function outputParameters=VidaCellSegmentationGrid(inputParameters)
%previously called MarchGrid1(EXPERIMENT) and MarchGrid3(EXPERIMENT)
%last modified 08/29/07 by Phil Tsai

%-----
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
cellSegFilesFolder = inputParameters.cellSegFilesFolder;
useTifStorageFlag = inputParameters.useTifStorageFlag;
cellThresh = inputParameters.cellThresh;
sz3D=inputParameters.sz3D;
overlapsz=inputParameters.overlapsz;
cellFileName = inputParameters.cellFileName;
cellMaskSize = inputParameters.cellMaskSize;
dispon = inputParameters.dispon;
%---
stackedCellSize=cellMaskSize;
%---
% overlap size dictates how much of each block has to overlap with its 3Dneighbor
if size(sz3D,2)==1,
   nx1blks=ceil(stackedCellSize(1)/sz3D); % number of blocks in x1 dim
   nx2blks=ceil(stackedCellSize(2)/sz3D); % number of blocks in x2 dim
   x1sz=fix(((nx1blks-1)*overlapsz+stackedCellSize(1))/nx1blks)+1;
   x2sz=fix(((nx2blks-1)*overlapsz+stackedCellSize(2))/nx2blks)+1;
   x1x2geomean=sqrt(x1sz*x2sz);
   nx3blks=ceil((stackedCellSize(3)-overlapsz)/(x1x2geomean-overlapsz)); %number of blocks in x3 diim
else%if size(sz3D,2)==1,
   nx1blks=ceil(stackedCellSize(1)/sz3D(1)); % number of blocks in x1 dim
   nx2blks=ceil(stackedCellSize(2)/sz3D(2)); % number of blocks in x2 dim
   nx3blks=ceil(stackedCellSize(3)/sz3D(3)); % number of blocks in x3 dim;
end%if size(sz3D,2)==1,
[cellGrid]=VidaGridUpBlock(stackedCellSize,overlapsz,nx1blks,nx2blks,nx3blks);


% load and write each block in cellGrid for tiff iSec
clear blockFileNames;
disp('SubBlocking Cell File');
if useTifStorageFlag == 0,
    load(cellFileName,'tiledStack');
end%if useTifStorageFlag == 0,
%-----
for iBlk=1:length(cellGrid) %---added by Phil 03/02/07
    blockFileNames{iBlk}=fullfile(cellSegFilesFolder,['cell-block-v2-',num2str(iBlk),'.mat']);
    %---
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(blockFileNames{iBlk},'file');
        fileExistsFlag = 1;
        fileProps = dir(blockFileNames{iBlk});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(blockFileNames{iBlk},'file');
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['skipping block ',num2str(iBlk),'...']); %---added by Phil 03/02/07
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['block ',num2str(iBlk),' of ',num2str(length(cellGrid)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
        % get indices for each block...
        blkii=cellGrid{iBlk};
        blockFileNames{iBlk}=fullfile(cellSegFilesFolder,['cell-block-v2-',num2str(iBlk),'.mat']);
        % subBlock=block from tiled tif
        if useTifStorageFlag == 1,
            subBlock=VidaTiffCycleRead(cellFileName,blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
        else%if useTifStorageFlag == 1,
            subBlock = tiledStack(blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
        end%if useTifStorageFlag == 1,
        subBlock(find(subBlock>cellThresh))=cellThresh;
        subBlock=single(subBlock);
        % vascblk=rescaleuint8(single(vascblk));
        % write each partially processed vasc block
        if dispon
            for i=1:size(subBlock,3)
                figure(1);
                colormap gray;
                subBlock(1,1,i)=0;
                subBlock(1,2,i)=cellThresh;
                imagesc(subBlock(:,:,i));drawnow;%pause(.05);
            end%for i=1:size(subBlock,3)
        end%if dispon
        %-----
        disp(['writing ',blockFileNames{iBlk},'...']);
        cellblk= subBlock;
        saveSize = (getfield(whos('cellblk'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(blockFileNames{iBlk},'cellblk',scs);
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for iBlk=1:length(cellGrid)

%-----
outputParameters = inputParameters;
outputParameters.stackedCellSize=stackedCellSize;
outputParameters.gridCellFileNames=blockFileNames;
outputParameters.cellGrid = cellGrid;
%-----
return


