function outExp = VidaCenterline(inExp)
%last modified 05/11/08 by Phil Tsai
%-----
fileRootName = inExp.globalParameters.fileRootName;
rootDataFolder = inExp.globalParameters.rootDataFolder;
lastRerunStartDateNum = inExp.globalParameters.lastRerunStartDateNum;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
vascEnhancedMaskFileName = inExp.globalParameters.vascEnhancedMaskFileName;
fullStackSize = inExp.globalParameters.fullStackSize;
blockGrid = inExp.globalParameters.blockGrid;
subVolumeOverlapSize = inExp.globalParameters.subVolumeOverlapSize;
vascBlockFileNameList = inExp.globalParameters.vascBlockFileNameList;
vascBlockRawMaskFileNameList = inExp.globalParameters.vascBlockRawMaskFileNameList;
vascBlockEnhancedMaskFileNameList = inExp.globalParameters.vascBlockEnhancedMaskFileNameList;
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
%-----
centerlineEnhancedByConnectivityParameters = inExp.centerlineEnhancedByConnectivityParameters;
%-----
centerlineFilesFolder = fullfile(processedDataFolder,'CenterlineFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(centerlineFilesFolder);
%-----


%-----

%Flag creation of optional tif files for stitched centerline mask
createCenterlineMaskTifFlag = 1;
if isfield(inExp,'createTifFlags'),
    if isfield(inExp.createTifFlags,'createCenterlineMaskTif')
        createCenterlineMaskTifFlag = inExp.createTifFlags.createCenterlineMaskTif;
    end
end

saveCenterlineMaskTiffFlag = createCenterlineMaskTifFlag;



%-----
centerlineEnhancedByConnectivityParameters.lastRerunStartDateNum = lastRerunStartDateNum;
centerlineEnhancedByConnectivityParameters.centerlineFilesFolder = centerlineFilesFolder;
centerlineEnhancedByConnectivityParameters.vascBlockRawMaskFileNameList = vascBlockRawMaskFileNameList;
centerlineEnhancedByConnectivityParameters.vascBlockFileNameList = vascBlockFileNameList;
centerlineEnhancedByConnectivityParameters.vascBlockRawMaskFileNameList = vascBlockRawMaskFileNameList;
centerlineEnhancedByConnectivityParameters.vascBlockEnhancedMaskFileNameList = vascBlockEnhancedMaskFileNameList;
centerlineEnhancedByConnectivityParameters.voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
    centerlineEnhancedByConnectivityParameters = VidaCenterlineEnhancedByConnectivity(centerlineEnhancedByConnectivityParameters);
vascBlockCenterlineMaskFileNameList = centerlineEnhancedByConnectivityParameters.vascBlockCenterlineMaskFileNameList;


%-----

centerlineRestitchParameters.fileRootName = fileRootName;
centerlineRestitchParameters.intermediateResultsFolder = intermediateResultsFolder;
centerlineRestitchParameters.processedDataFolder = processedDataFolder;
centerlineRestitchParameters.vascEnhancedMaskFileName = vascEnhancedMaskFileName;
centerlineRestitchParameters.fullStackSize = fullStackSize;
centerlineRestitchParameters.blockGrid = blockGrid;
centerlineRestitchParameters.subVolumeOverlapSize = subVolumeOverlapSize;
centerlineRestitchParameters.vascBlockCenterlineMaskFileNameList = vascBlockCenterlineMaskFileNameList;
centerlineRestitchParameters.saveFlag = saveCenterlineMaskTiffFlag;
    centerlineRestitchParameters = VidaCenterlineRestitch(centerlineRestitchParameters);
vascCenterlineMaskFileName = centerlineRestitchParameters.vascCenterlineMaskFileName;
%-----
outExp = inExp;
%---
outExp.centerlineEnhancedByConnectivityParameters = centerlineEnhancedByConnectivityParameters;
outExp.globalParameters.vascBlockCenterlineMaskFileNameList = vascBlockCenterlineMaskFileNameList;
outExp.globalParameters.vascCenterlineMaskFileName = vascCenterlineMaskFileName;
outExp.completionDates.centerlineCompletionDate = datestr(now);
%---

return



  
