function outputStructure = ClassicVidaSuite(varargin)
%if input variable is a string, assume it is the name of the .m setup
%function file to run. - the strings "current" and "default" default to
%using the setup function: SuperVidaParamatersCurrent.m
%if input variable is a structure, assume the call is from the GUI
%and the setup parameters are stored in a .mat file
outputStructure = [];
nin = nargin;
if nin == 0,
    commandVariable = 'current';
else%if nin==0
    commandVariable = varargin{1};
end%if nin==0
%---
% % % if isstruct(commandVariable),
% % %     calledFromGuiFlag = 1;
% % %     setupMatFileName = commandVariable.setupMatFileName; 
% % %     parameterSetupFunctionName = 'current';
% % % else%if isstruct(commandVariable)
% % %     calledFromGuiFlag = 0;
% % %     parameterSetupFunctionName = commandVariable;
% % % end%if-else isstruct(commandVariable)
% % % %---

parameterSetupFunctionName = commandVariable;

switch parameterSetupFunctionName
    case {'default','Default','DEFAULT','def','Def','DEF'};
        parameterSetupFunctionName = 'SuperVidaParametersCurrent.m';
    case {'current','CURRENT','Current'}
        parameterSetupFunctionName = 'SuperVidaParametersCurrent.m';
    otherwise
        parameterSetupFunctionName = parameterSetupFunctionName;
end%switch parameterSetupFunctionName
%-----------
%Automatically detect rootCodeFolder and add setupFunctions
rootCodeFolder = fileparts(which('ClassicVidaSuite'));
addpath(fullfile(rootCodeFolder,'SetupFunctionsFolder'))
%-----
    outputProject = VidaAutoDectectVidaProjectRootFolder([]);
vidaProjectRootName = outputProject.vidaProjectRootName;
vidaProjectRootFolder = outputProject.vidaProjectRootFolder;
%----------
%SetupParameters
defaultOverwriteFilesStateFlag = 0;
vidaProjectStyleFlag = 1;
reverseXBlockNumberingFlag = 1;%noteToSelf
reverseYBlockNumberingFlag = 0;%noteToSelf

useTifStorageFlag = 0; % use variable imageStack in Mat file
skipAutoUpgradeFlag = 0;
debugModeAvoidOverwriteFlag = 1; %set to 1 to avoid overwriting all files experiment file is deleted

deleteAfterCompletedFlags.deleteOffsetTif = 1;
deleteAfterCompletedFlags.deleteSubBlockFiles = 1;
deleteAfterCompletedFlags.deleteVascBlockChannelSubFiles = 1;
deleteAfterCompletedFlags.deleteNeunBlockChannelSubFiles = 1;
deleteAfterCompletedFlags.deleteCellSeg = 1;
deleteAfterCompletedFlags.deleteVascSegFiles = 0;
deleteAfterCompletedFlags.deleteCenterlineFiles = 0;
deleteAfterCompletedFlags.deleteVascRadiiFiles = 0;

createTifFlags.createRawMaskTif = 0;
createTifFlags.createEnhMaskTif = 0;
createTifFlags.createCenterlineMaskTif = 0;

%-----

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp([' ';' ';' ']);
disp(['VIDA Script Started at ',datestr(now)]);
disp([' ';' ';' ']);
%--------------------------------------------------------------------------


vidaProject.vidaProjectRootName = vidaProjectRootName;
vidaProject.vidaProjectRootFolder = vidaProjectRootFolder;
vidaProject.rootCodeFolder = rootCodeFolder;
%---
vidaProject.progressFlags.initialized = 1;
vidaProject.progressFlags.sortOriginalTifs = 0;
vidaProject.progressFlags.createUniformityFilter = 0;
vidaProject.progressFlags.processImageStacksCompleted = 0;
vidaProject.progressFlags.multiStackProcessingCompleted = 0;


%Initialize the VidaProject file with folder names and setup Parameters
%This step initializes the vidaProject structure, but does NOT save to disk
vidaProject.setupParameters.vidaProjectRootName = vidaProjectRootName;
vidaProject.setupParameters.vidaProjectRootFolder = vidaProjectRootFolder;
vidaProject.setupParameters.parameterSetupFunctionName = parameterSetupFunctionName;
vidaProject.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
vidaProject.setupParameters.useTifStorageFlag = useTifStorageFlag;
vidaProject.setupParameters.skipAutoUpgradeFlag = skipAutoUpgradeFlag;
vidaProject.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
    vidaProject = VidaSetupVidaProjectFile(vidaProject);
revisedCodeFolders = vidaProject.setupParameters.revisedCodeFolders;
vidaProjectFileName = vidaProject.vidaProjectFileName;

%-----
experimentTemplate = vidaProject;
experimentTemplate.deleteAfterCompletedFlags = deleteAfterCompletedFlags;
experimentTemplate.createTifFlags = createTifFlags;
%-----

% experimentTemplate.globalParameters.storePixelListInExperimentFlag = 1;%noteToSelf
%-----
vidaProject.experimentTemplate = experimentTemplate;


%Add all code Folder to Matlab path
codeFolders = experimentTemplate.codeFolders;
codeFolderList = fieldnames(experimentTemplate.codeFolders);
numCodeFolders = size(codeFolderList,1);
for codeFolderIter = 1:numCodeFolders,
    currentField = codeFolderList{codeFolderIter};
    currentCodePath = experimentTemplate.codeFolders.(currentField);
    addpath(currentCodePath)
end
    


%LOAD PARAMETERS
%this step further initializes the vidaProject, but does NOT save to disk
%first, check to see if parameterSetupFunctionName is a .m file or .mat file
continueFlag = 0;
if strcmpi(parameterSetupFunctionName(end-1:end),'.m');
    [junkPath,fileNameOnly] = fileparts(parameterSetupFunctionName);
    loadParamCommand = ['experimentTemplate = ',fileNameOnly,'(experimentTemplate);'];
    eval(loadParamCommand)
    disp(['LOADING PARAMETER SET: ',parameterSetupFunctionName]);
    continueFlag = 1;
end%if parameterSetupFunctionName(end-1:end) == '.m',
%---
if strcmpi(parameterSetupFunctionName(end-3:end),'.mat'),
    load(parameterSetupFunctionName,'experimentTemplate');
    continueFlag = 1;
end%if parameterSetupFunctionName(end-3:end) == '.mat',
%---
if continueFlag == 0,
    disp('NOT A VALID PARAMETER SETUP FILE');
    keyboard
end

experimentTemplate.globalParameters = experimentTemplate.basicParameters;
vidaProject.globalParameters = experimentTemplate.basicParameters;
vidaProject.experimentTemplate = experimentTemplate;

%Some specifc global-scale parameters may have been overwritten when the generic experiment Template
%was loaded.  Re-write these specific parameters to the experiment_Template
experimentTemplate.vidaProjectRootName = vidaProjectRootName;
experimentTemplate.vidaProjectRootFolder = vidaProjectRootFolder;
experimentTemplate.rootCodeFolder = rootCodeFolder;
experimentTemplate.setupParameters.vidaProjectRootName = vidaProjectRootName;
experimentTemplate.setupParameters.vidaProjectRootFolder = vidaProjectRootFolder;
experimentTemplate.setupParameters.parameterSetupFunctionName = parameterSetupFunctionName;
experimentTemplate.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
experimentTemplate.setupParameters.useTifStorageFlag = useTifStorageFlag;
experimentTemplate.setupParameters.skipAutoUpgradeFlag = skipAutoUpgradeFlag;
experimentTemplate.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
experimentTemplate.setupParameters.revisedCodeFolders = revisedCodeFolders;
experimentTemplate.vidaProjectFileName = vidaProjectFileName;
%---
experimentTemplate.deleteAfterCompletedFlags = deleteAfterCompletedFlags;
experimentTemplate.createTifFlags = createTifFlags;
experimentTemplate.codeFolders = codeFolders;
%-----
%-----



%AutoAdjust the rootfolder in any existing VidaProject file in case folder has moved
%this step saves the changes in the vidaProject file to disk
    vidaProject = VidaAutoAdjustVidaProjectRootFolder(vidaProject);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%DATE STAMP VIDAPROJECT FILE OR LOAD EXISTING VIDAPROJECT FILE
%This step overloads the iniatilzed vidaProject file if one exists on disk
vidaProject.setupParameters.debugModeAvoidOverwriteFlag = debugModeAvoidOverwriteFlag;
    vidaProject = VidaLoadVidaProjectFile(vidaProject);
vidaProject.codeFolders = revisedCodeFolders;
experimentTemplate = vidaProject.experimentTemplate;
experimentTemplate.codeFolders = revisedCodeFolders;
%-----
vidaProject.experimentTemplate = experimentTemplate;
%----------
%Copy the parameters relating to the full Project to the vidaProject structure
if ~isfield(vidaProject,'registrationParameters'),
    vidaProject.registrationParameters = experimentTemplate.registrationParameters;
end%if ~isfield(vidaProject,'registrationParameters'),
%---
if ~isfield(vidaProject,'strandifyParameters'),
    vidaProject.strandifyParameters = experimentTemplate.strandifyParameters;
end%if ~isfield(vidaProject,'strandifyParameters'),
%---
saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vidaProjectFileName,'vidaProject',scs);
preMatRoot = vidaProjectFileName(1:findstr(vidaProjectFileName,'.mat')-1);
save([preMatRoot,'Backup',datestr(now,'mmddyy-HHMM'),'.mat'],'vidaProject',scs);
%----------
%--------
%STAGE 0 : Determine number of image stacks - allocate each to a folder
%   SORT .TIF FILES INTO INDIVIDUAL FOLDERS IF NECESSARY
disp('Sorting Files');
if vidaProject.progressFlags.sortOriginalTifs == 0,
    vidaProject.globalParameters.reverseXBlockNumberingFlag = reverseXBlockNumberingFlag;
    vidaProject.globalParameters.reverseYBlockNumberingFlag = reverseYBlockNumberingFlag;
        vidaProject = VidaSortOriginalTifs(vidaProject);
    vidaProject.progressFlags.sortOriginalTifs = 1; 
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if vidaProject.progressFlags.sortOriginalTifs == 0,

%--------
%--------


%STAGE0b : Create uniformity filter for preprocessing
disp('Uniformity files');
if vidaProject.progressFlags.createUniformityFilter == 0,
        vidaProject = VidaCreateUniformityFilter(vidaProject);
    vidaProject.progressFlags.createUniformityFilter = 1;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if vidaProject.progressFlags.createUniformityFilter == 0,

%STAGE 1 : Run Classic Vida Suite on each image stack folder
disp('Running on individual image files');
numStacks = vidaProject.numImageStacks;
if vidaProject.progressFlags.processImageStacksCompleted == 0,
    imageStackFolderNameList = vidaProject.imageStackFolderNameList;
    for stackIter = 1:numStacks,
        if vidaProject.imageStackCompletedFlag(stackIter) == 1,
            disp(['Image Stack # ',num2str(stackIter),' previously completed.']);
        else%if vidaProject.imageStackCompletedFlag(stackIter) == 1,
            fprintf('\n\n\n\n\n');
            disp(['Start Processing Stack # ',num2str(stackIter),' of ',num2str(numStacks),' : ',datestr(now,'mm-dd-yy,HH:MM.SS')]);
            fprintf('\n\n');
            currentImageStackFolderName = imageStackFolderNameList{stackIter};
            vidaProject.setupParameters.currentImageStackFolderName = currentImageStackFolderName;

            
            
            %noteToSelf
                vidaProject = VidaProcessImageStack(vidaProject);
%                 vidaProject = VidaProcessImageStackQuick(vidaProject);
           %noteToSelf
                
                
                
                
            vidaProject.imageStackCompletedFlag(stackIter) = 1;
            vidaProject.imageStackCompletionDates{stackIter} = datestr(now,'mm-dd-yy,HH:MM.SS');
            saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            save(vidaProjectFileName,'vidaProject',scs);
            %--------
            disp([' ';' ';' ']);
            disp(['Completed Image Stack # ',num2str(stackIter),' of ',num2str(numStacks),' : ',datestr(now)]);
            disp([' ';' ';' ']);
            %--------
        end%if vidaProject.imageStackCompletedFlag(stackIter) == 1,
    end%for stackIter = 1:numStacks,
    vidaProject.progressFlags.processImageStacksCompleted = 1;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if vidaProject.progressFlags.processImageStacksCompleted == 0,

    
    
%STAGE 1b : Sort Stack Order if necessary
reverseXBlockNumberingFlag = 1;%noteToSelf
tempFolderNameList = vidaProject.imageStackFolderNameList;
rczMax = vidaProject.globalParameters.rczMax;
rczMin = vidaProject.globalParameters.rczMin;
zList = [rczMin(1):rczMax(1)];
rList = [rczMin(2):rczMax(2)];
cList = [rczMin(3):rczMax(3)];


%noteToSelf
%noteToSelf: UPDATE ALL THESE FILENAME VARIABLES
%noteToSelf

%STAGE 1c : Collect necessary filenames
disp('Collecting filenames');
if ~isfield(vidaProject.registrationParameters,'blockRegistration'),
    pathDelim = '\';if isunix; pathDelim = '/';end %make platform independent - Pablo
    for stackIter = 1:numStacks,
        charCount = fprintf(num2str(stackIter));
        tempMainFolderName = vidaProject.imageStackFolderNameList{stackIter};
        tempStackName = tempMainFolderName(findstr(tempMainFolderName,[pathDelim 'ImageStack-'])+12:end);
        tempProcessedDataFolderName = fullfile(tempMainFolderName,'ProcessedData');
        tempExperimentFileName = fullfile(tempProcessedDataFolderName,[tempStackName,'-Experiment.mat']);%make platform independent - Pablo
        load(tempExperimentFileName,'experiment');
        vidaProject.globalParameters.vascGrayscaleFileNameList{stackIter} = experiment.globalParameters.vascGrayscaleFileName;
        vidaProject.globalParameters.vascEnhancedGrayscaleFileNameList{stackIter} = experiment.globalParameters.vascEnhancedGrayscaleFileName;
        vidaProject.globalParameters.vascEnhancedMaskFileNameList{stackIter} = experiment.globalParameters.vascEnhancedMaskFileName;
        vidaProject.globalParameters.vascCenterlineMaskFileNameList{stackIter} = experiment.globalParameters.vascCenterlineMaskFileName;
        vidaProject.globalParameters.vascReconstructedMaskFileNameList{stackIter} = experiment.globalParameters.vascReconstructedMaskFileName;
        vidaProject.globalParameters.vascRadiusMapFileNameList{stackIter} = experiment.globalParameters.vascRadiusMapFileName;
        vidaProject.globalParameters.stackSizeList(stackIter,:) = experiment.globalParameters.fullStackSize;
        fprintf(repmat('\b',[1,charCount]));
    end%for stackIter = 1:numStacks,
end%if ~isfield(vidaProject.registrationParameters,'blockRegistration'),


%Create a subFolder for registered results
rootDataFolder = vidaProject.vidaProjectRootFolder;
registeredFilesFolder = fullfile(rootDataFolder,'RegisteredFiles');
vidaProject.globalParameters.registeredFilesFolder = registeredFilesFolder;
if ~exist(registeredFilesFolder,'dir'),
    mkdir(registeredFilesFolder);
end


%STAGE 2 : Register multiple stacks into single global coordinate sytem.
if ~isfield(vidaProject.progressFlags,'StackRegistrationCompleted'),
    vidaProject.progressFlags.calculateStackRegistration = 0;
end
disp('Calculating Block Registrations');
if ~isfield(vidaProject.registrationParameters,'blockRegistration'),
        vidaProject = VidaRegisterBlocks(vidaProject);
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if ~isfield(vidaProject.registrationParameters,'blockRegistration'),


%STAGE 3 : Choose a Multi-stack processing pathway, and run.
registeredPathway = 'StitchCenterlineStrandify';%noteToSelf
% registeredPathway = 'ConcatenateStrandify';%noteToSelf


switch registeredPathway,
    case{'StitchCenterlineStrandify','StitchCenterlineStrandify'}
        vidaProject = VidaRegisteredProcessStitchCenterlineStrandify(vidaProject);
    case{'ConcatenateStrandify'}
        vidaProject = VidaRegisteredProcessConcatenateStrandify(vidaProject);
end%switch multiStackPathway

saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vidaProjectFileName,'vidaProject',scs);

disp(['SuperVidaSuite Completed at ',datestr(now)]);
outputStructure.vidaProjectFileName = vidaProjectFileName;







