function strandSet = AugmentStrandsWithIslands(strandSet,islandlist)

%Copyright 2008 J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

nislands = size(islandlist,1);
laststrand = max(strandSet.strandData(:,1));
lastptr2coord = size(strandSet.strandData,1);

newstrands = (laststrand+(1:nislands)');
newptr2coords = (lastptr2coord+(1:nislands)');

% Note the islandlist - 1 compensates for the indexing difference (0 to 1)
islandstrands = [newstrands,max(1,islandlist-1),ones(nislands,1)];
strandSet.strandData = [strandSet.strandData;islandstrands];

strandSet.ctrPoint2StrandLUT = [strandSet.ctrPoint2StrandLUT;[newptr2coords,newstrands]];

for iISL = 1:numel(newstrands)
    strandSet.strandSetInfo(newstrands(iISL)).lineId = newstrands(iISL);
    strandSet.strandSetInfo(newstrands(iISL)).ptr2coord = newptr2coords(iISL);
    strandSet.ptr2endpoints(newstrands(iISL)+1) = strandSet.strandSetInfo(newstrands(iISL)).ptr2coord(end);
    if strandSet.strandSetInfo(newstrands(iISL)).ptr2coord(end) == 0
        keyboard
    end
end

strandSet = rmfield(strandSet,{'strandAdj','prt2bif','ptr2uncon'});
strandSet = amira2mat_buildStrandAdjacency(strandSet);
