function [cxyz,sparseIndexBlock] = BuildSparseIndexBlock(centerlinePts,maskSize)

% count the total number of points
nCpts = numel(centerlinePts);
cPtINDs = 1:nCpts;
% translate indices into 3D locations
[cx1,cx2,cx3] = ind2sub(maskSize,centerlinePts);
% package 3D coordinates in one variable
cxyz = [cx1,cx2,cx3];
% preallocate sparseIndexBlock
sparseIndexBlock = cell(1,maskSize(3));
for iSLICE = 1:maskSize(3)
    newslice = zeros(maskSize(1),maskSize(2));
    sliceSUBs = (cx3==iSLICE);
    sliceINDs = sub2ind([maskSize(1),maskSize(2)],cx1(sliceSUBs),cx2(sliceSUBs));
    newslice(sliceINDs) = cPtINDs(sliceSUBs);
    sparseIndexBlock{iSLICE} = sparse(newslice);
end
