function [Strands,Vertices] = BuildStrandVertexDatastructures(cxyz,CenterlineStrands,VertexStrandMemberships)

nStrands = numel(CenterlineStrands);

% Preallocate structure
Strands(nStrands).StartVertexIndex = CenterlineStrands{nStrands}(1);
Strands(nStrands).EndVertexIndex = CenterlineStrands{nStrands}(end);
% % Strands(nStrands).InteriorVertices = CenterlineStrands{nStrands}(2:end-1);
Strands(nStrands).StartToEndIndices = CenterlineStrands{nStrands}(1:end);
tmpStartNeighborStrands = [VertexStrandMemberships{Strands(nStrands).StartVertexIndex}];
Strands(nStrands).StartVertexNeighborStrands = setdiff(tmpStartNeighborStrands,nStrands);
tmpEndNeighborStrands = [VertexStrandMemberships{Strands(nStrands).EndVertexIndex}];
Strands(nStrands).EndVertexNeighborStrands = setdiff(tmpEndNeighborStrands,nStrands);

for iSTRAND = 1:nStrands
    % Populate all strand structures
    Strands(iSTRAND).StartVertexIndex = CenterlineStrands{iSTRAND}(1);
    Strands(iSTRAND).EndVertexIndex = CenterlineStrands{iSTRAND}(end);
% %     Strands(iSTRAND).InteriorVertices = CenterlineStrands{iSTRAND}(2:end-1);
    Strands(iSTRAND).StartToEndIndices = CenterlineStrands{iSTRAND}(1:end);
    tmpStartNeighborStrands = [VertexStrandMemberships{Strands(iSTRAND).StartVertexIndex}];
    Strands(iSTRAND).StartVertexNeighborStrands = setdiff(tmpStartNeighborStrands,iSTRAND);
    tmpEndNeighborStrands = [VertexStrandMemberships{Strands(iSTRAND).EndVertexIndex}];
    Strands(iSTRAND).EndVertexNeighborStrands = setdiff(tmpEndNeighborStrands,iSTRAND);
end
% Make Vertices structure compatible with strands
Vertices = UpdateVerticesByStrands(cxyz,Strands);
