function MakeConnectingStrandTif(thresholdConfidence);

if ~exist('thresholdConfidence'),
    thresholdConfidence = 0.0;
end%if ~exist(inputThresh),

mydir = dir('*-TRFinalResults.mat');
myFileName = mydir(1).name;
load(myFileName);
rootName = myFileName(1:findstr(myFileName,'-TRFinalResults')-1);

BridgingStrands = GapConnectionStruct.ThreshRelax.BridgingStrands;
BridgingConfidences = GapConnectionStruct.ThreshRelax.BridgingConfidences;

numStrands = size(BridgingStrands,2);
maskSize = GapConnectionStruct.maskSize;
myMask = false(maskSize);
for strandIter = 1:numStrands,
    currentStrand = BridgingStrands{strandIter};
    currentConfidence = BridgingConfidences(strandIter);
    if currentConfidence > thresholdConfidence,
        numPoints = size(currentStrand,1);
        for pointIter = 1:numPoints,
            myMask(currentStrand(pointIter,1),currentStrand(pointIter,2),currentStrand(pointIter,3))=1;
        end%for pointIter = 1:numPoints,
    end%if currentConfidence > thresholdConfidence,
end%for strandIter = 1:numStrands,

tifFileName = [rootName,'-BridgeStrandsMaskThresh',num2str(thresholdConfidence,'%0.02f'),'.tif'];
maketiff(myMask,tifFileName);


