function experiment = MakeVascularTifsForReconnection(experiment)

disp('check that all files are converted to .tifs')
%% MAKE VASCULAR TIFS
centerLineMatFileName = experiment.globalParameters.centerLineMaskFileName;
centerLineTifFileName = regexprep(centerLineMatFileName,'.mat','.tif');
load(centerLineMatFileName,'centerLineMask');
centerLineMask = 255*uint8(centerLineMask);
maketiff(centerLineMask,centerLineTifFileName);
clear centerLineMask
experiment.globalParameters.centerLineMaskTifFileName = centerLineTifFileName;
 
VascMaskMatFileName = experiment.globalParameters.vascMaskFileName;
VascMaskTifFileName = regexprep(VascMaskMatFileName,'.mat','.tif');
load(VascMaskMatFileName,'VascMask');
if ~exist('VaskMask')
    load(VascMaskMatFileName,'tiledStack');
    VascMask = 255*uint8(tiledStack);
    if ~exist('tiledStack')
        disp('could not get the vascular mask .mat file');
    else
        fprintf(1,'loaded tiledStack volume instead of VascMask volume from %s.\n', VascMaskMatFileName);
    end
    clear tiledStack
else
    VascMask = 255*uint8(VascMask);
end
maketiff(VascMask,VascMaskTifFileName);
clear VascMask
experiment.globalParameters.vascMaskTifFileName = VascMaskTifFileName;

VascMaskMatFileName = experiment.globalParameters.vascMaskReconstructedFileName;
VascMaskTifFileName = regexprep(VascMaskMatFileName,'.mat','.tif');
load(VascMaskMatFileName);
VascMask = 255*uint8(VascMask);
maketiff(VascMask,VascMaskTifFileName);
clear VascMask
experiment.globalParameters.vascMaskReconstructedTifFileName = VascMaskTifFileName;
 
load(experiment.vidaProjectFileName,'vidaProject','-mat');
%VascEnhancedMatFileName = experiment.vascSegParameters.vascEnhancedRestitchParameters.vascEnhancedFileName;
VascEnhancedMatFileName = vidaProject.registeredStackEnhancedDataFileName;
VascEnhancedTifFileName = regexprep(VascEnhancedMatFileName,'.mat','.tif');

load(VascEnhancedMatFileName,'EnhancedVasc');
if ~exist('EnhancedVasc')
    load(VascEnhancedMatFileName,'tiledStack');
    if ~exist('tiledStack')
        fprintf(1,'problems making enhanced .tif file from %s.\n', VascEnhancedMatFileName);
    else
        fprintf(1,'loaded tiledStack volume instead of EnhancedVasc volume from %s.\n', VascEnhancedMatFileName);
    end
    maketiff(tiledStack,VascEnhancedTifFileName);
    clear tiledStack
else
    maketiff(EnhancedVasc,VascEnhancedTifFileName);
    clear EnhancedVasc
end
experiment.globalParameters.vascEnhancedRestitchTifFileName = VascEnhancedTifFileName;
 
experiment.globalParameters.vascVectorizedRawFileName = regexprep(experiment.globalParameters.vascMaskFileName,'.mat','.mv3d');
experiment.globalParameters.vascVectorizedGapFilledFileName = regexprep(experiment.globalParameters.vascMaskFileName,'.mat','-GapFilled.mv3d');
experiment.globalParameters.vascBridgingStrands = regexprep(experiment.globalParameters.vascMaskFileName,'.mat','-BridgingStrands.mv3d');
