function [AMsnipped] = SnipIrreducible3JunctionClusters(AM)

AM0 = AM;
fprintf('Snipping irreducible 3-clusters of 3-junctions...\n');
degree3nodes = full(sum(AM)==3);
JCTclustercandidates = find(degree3nodes);
nJCT3pts = numel(JCTclustercandidates);
JCTvisited = zeros(1,size(AM,1));
nchar = 0;
for iJCT = 1:nJCT3pts
    if ~JCTvisited(JCTclustercandidates(iJCT))
        AdjNodeList = full(AM(JCTclustercandidates(iJCT),:))>0;
        AdjNodes = find(AdjNodeList);
        Adj3Degree = degree3nodes(AdjNodeList);
        if sum(Adj3Degree) == 2                         % if this degree 3 node touches 2 other degree 3 nodes, snip one connection
            irredi = [JCTclustercandidates(iJCT), AdjNodes(Adj3Degree)];
            AM(irredi(1),irredi(2)) = 0;
            AM(irredi(2),irredi(1)) = 0;
            JCTvisited(irredi) = true;                  % mark all of the irreducible set of 3 junctions in the cluster as visited
        else
            JCTvisited(JCTclustercandidates(iJCT)) = true; % mark the single junction as visited
        end
    end
    fprintf(repmat('\b',1,nchar))
    nchar = fprintf('%d / %d junction nodes examined...\n',iJCT,nJCT3pts);
end

AMsnipped = AM;
