
%% Extract ctps
centerlinePts = find(centerLineMask);
maskSize = size(centerLineMask);
clear CenterlineMask



%% REDUCE THE CENTERLINE MASK VIA REDUCTION OF JUNCTION CLUSTERS
centerlinePts = ReduceCenterlineMaskJunctions(centerlinePts,maskSize);

%% DO THE VECTORIZATION
[AM,cxyz] = GetCenterlinePointsAndAdjacency(centerlinePts,maskSize);
% [AM] = SnipIrreducible3JunctionClusters(AM); % This only simplifies junction clusters with 3 adjacent junctions
% irreducible by thinning
[AM,cxyz] = SimplifyJunctionClustersToSingleJunctions(AM,cxyz); % This replaces junction clusters with their cluster centroid
[CenterlineStrands,VertexStrandMemberships] = GetCenterlinesAndStrandStruct(AM);
[Strands,Vertices] = BuildStrandVertexDatastructures(cxyz,CenterlineStrands,VertexStrandMemberships);
for iSTRAND = 1:numel(Strands)
    Strands(iSTRAND).Active = true;
end


%% Generate vertex adjacency matrix

vertexIdx = find(Vertices.AllStrandEndPoints);
nv = numel(vertexIdx);
junction2vertexIdx_LUT = [[1:numel(vertexIdx)]' vertexIdx];
vertex2junctionIdx_LUT = zeros(numel(Vertices.JunctionPoints),1);
vertex2junctionIdx_LUT(vertexIdx) = [1:numel(vertexIdx)]';
vertexAdj = sparse(vertex2junctionIdx_LUT([Strands.StartVertexIndex]),...
    vertex2junctionIdx_LUT([Strands.EndVertexIndex]),1,nv,nv);
vertexAdj = max(vertexAdj,vertexAdj');
xyz = Vertices.AllVerts(vertexIdx,:);
gplot3(vertexAdj,xyz,'o-')

% spy(vertexAdj)

%% build graph sturcture and trim
G.Adj = vertexAdj;
G.x = xyz(:,1);
G.x = xyz(:,1)';
G.y = xyz(:,2)';
G.nv =numel(G.z);
G.type = ones(1,G.nv);
[D2 D] = trimNetwork(G);
D2b = removeVertexFromDataStructure(D2,find(sum(D2.Adj)==0));


%% Generate BioLayout
fname = 'pbCP400x400x400.txt';
[ii,jj,ww] = find(vertexAdj);
ne = numel(ii);

fid = fopen(fname,'w+');

for iE = 1 : ne
    fprintf(fid,'\nNode%d\tNode%d\t%3.2f',ii(iE),jj(iE),ww(iE));
end
   fprintf(fid,'\n')
   
   %adjust xyz coordinates to [0 1000]
   maxXYZ = max(max(xyz));
   xyzMod = xyz/maxXYZ *1000;
for iVTX = 1 : nv
    fprintf(fid,'\n//NODECOORD\tNode%d\t%3.1f\t%3.1f\t%3.1f',iVTX,...
        xyzMod(iVTX,1),xyzMod(iVTX,2),xyzMod(iVTX,3));
end
