%% Get a binary centerline mask
load('QF02-Stacked-FITC-mask-CenterLine.mat','-mat');

% zero edges (or add a layer of 0s to edges and adjust indexing later)
centerLineMask(:,:,1) = 0;
centerLineMask(:,:,end) = 0;
centerLineMask(:,1,:) = 0;
centerLineMask(:,end,:) = 0;
centerLineMask(1,:,:) = 0;
centerLineMask(end,:,:) = 0;

save('QF02-Stacked-FITC-mask-CenterLine-zeroedges.mat','centerLineMask','-mat');

% find nonzero centerline point indices
centerlinePts = find(centerLineMask);
maskSize = size(centerLineMask);
clear CenterlineMask

%% Get the Strands and Vertices mutually compatibly indexed datastructure
[Strands,Vertices,AMCenterlines] = VectorizeBinaryCenterlineMask(centerlinePts,maskSize);

%% Show connected strands about a centerline point to some depth of connectivity
figure(1);clf;hold on;
nStrandsDeep = 15;
randVertInds = randperm(size(Vertices.AllVerts,1));
startVert = randVertInds(1);
h = ShowStrandsNDeep(Strands,Vertices,startVert,nStrandsDeep);
