function thinbbL = ThinJunctionIsland(bbclm,bbL)

%bborig = bbclm;

%Load the connectivity look-up-table
% load('C:\Documents and Settings\kaufholdj\Desktop\VSDataRoot\CodeRoot\VidaSuite\CenterLineFunctionsFolder\ConnectivityLUT.mat','connectivityLUT');
load('ConnectivityLUT.mat','connectivityLUT');
powersOfTwo = pow2(26:-1:0);
bbli = find(bbL>0);              % only need to check connectivity of junctions
[w1List,w2List,w3List] = ind2sub(size(bbclm),bbli);

thinbbL = bbclm;
for ibbclm = 1:numel(bbli)
    %Trim pixels based on connectivity, arbitrary ordering
    w1 = w1List(ibbclm);
    w2 = w2List(ibbclm);
    w3 = w3List(ibbclm);
    subBlock = thinbbL(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1);
    subBlockLine = logical(subBlock(:)');
    if sum(subBlockLine) == 2,
        %Do not trim endpoints
        thinbbL(w1,w2,w3) = 1;
    else%if sum(subBlockLine) == 2,
        decNum = sum(powersOfTwo(subBlockLine));
        thinbbL(w1,w2,w3) = connectivityLUT(decNum);
    end%if sum(subBlockLine) == 2,
end%for pixelIter = 1:length(pixelList),

if 0
    % if sum(sum(sum(abs(bbL)))) >= 6   % to visualize >6-junction clusters
    % if sum(sum(sum(abs(bbL)))) == 3   % to visualize 3-junction clusters
    [AMorig,cxyzorig] = VectorizeSmallMask(bborig,'nosnip3');
    clm1List = cxyzorig(:,1);
    clm2List = cxyzorig(:,2);
    clm3List = cxyzorig(:,3);

    [AMthin,cxyzthin] = VectorizeSmallMask(thinbbL,'snip3');
    clm1Thin = cxyzthin(:,1);
    clm2Thin = cxyzthin(:,2);
    clm3Thin = cxyzthin(:,3);

    [AMjctreplaced,cxyzjctreplaced] = VectorizeSmallMask(thinbbL,'alljctreplace');
    clm1jcr = cxyzjctreplaced(:,1);
    clm2jcr = cxyzjctreplaced(:,2);
    clm3jcr = cxyzjctreplaced(:,3);

    disp('not an irreducible triple or smaller');
    figure(1);clf;
    % plot the centerline points
    plot3(clm2List,clm1List,clm3List,'ro');
    hold on;
    gplot3(AMorig,[clm2List,clm1List,clm3List],'r-');
    set(1,'position',[150   133   567   547]);
    p1 = patch(isosurface(thinbbL>0));
    set(p1,'facealpha',.2,'facecolor','r');
    p2 = patch(isosurface(bbL>0));
    set(p2,'facealpha',.2,'facecolor','b');
    axis equal;grid on;
    
    figure(2);clf;
    % plot the centerline points
    plot3(clm2Thin,clm1Thin,clm3Thin,'ro');
    hold on;
    gplot3(AMthin,[clm2Thin,clm1Thin,clm3Thin],'r-');
    set(2,'position',[725   133   567   547]);
    p1 = patch(isosurface(thinbbL>0));
    set(p1,'facealpha',.2,'facecolor','r');
    pause(.01);
    axis equal;grid on;
    %pause;
    
    figure(3);clf;
    % plot the centerline points
    plot3(clm2jcr,clm1jcr,clm3jcr,'ro');
    hold on;
    gplot3(AMjctreplaced,[clm2jcr,clm1jcr,clm3jcr],'r-');
    set(3,'position',[725   133   567   547]);
    p1 = patch(isosurface(thinbbL>0));
    set(p1,'facealpha',.2,'facecolor','r');
    pause(.01);
    axis equal;grid on;
    %pause;
    
    keyboard;
end

