function Vertices = UpdateVerticesByStrands(allverts,Strands)

CollectedEndpointVerts = [[Strands.StartVertexIndex],[Strands.EndVertexIndex]];

%% Create Vertex Structure
Vertices.AllVerts = allverts;

AllStrandEndPoints = zeros(size(allverts,1),1);
AllStrandEndPoints(CollectedEndpointVerts) = 1;
Vertices.AllStrandEndPoints = AllStrandEndPoints;

EOJVertLabs = histc(CollectedEndpointVerts,1:size(allverts,1));
JunctionPoints = zeros(size(allverts,1),1);
JunctionPoints(EOJVertLabs>=3) = 1;
Vertices.JunctionPoints = JunctionPoints;

FreeEndPoints = zeros(size(allverts,1),1);
FreeEndPoints(EOJVertLabs==1) = 1;
StartEndVerts = [[Strands.StartVertexIndex]',[Strands.EndVertexIndex]']; % if start and end vertex are the same, strand is an island
IslandEndPoints = (StartEndVerts(:,1)==StartEndVerts(:,2));
% label all islands as free endpoints
FreeEndPoints(StartEndVerts(IslandEndPoints)) = 1;
Vertices.FreeEndPoints = FreeEndPoints;

% % StrandIndices = cell(size(allverts,1),1);
StrandIndices = zeros(size(allverts,1),1);
for iSTRAND = 1:numel(Strands)

    for jINDS = Strands(iSTRAND).StartToEndIndices
        tempSI = StrandIndices(jINDS,:);
        tempSI = tempSI(tempSI~=0);
        tempSI = [tempSI,iSTRAND];
        tempSI = unique(tempSI);
        numSI = numel(tempSI);
        StrandIndices(jINDS,1:numSI) = tempSI;
    end
end

% % % % Force strandID list to be unique
% % % for iSTRAND = 1:size(allverts,1)
% % %     StrandIndices{iSTRAND} = unique(StrandIndices{iSTRAND});
% % % end

Vertices.StrandIndices = StrandIndices;
