function [Strands,Vertices,AM] = VectorizeBinaryCenterlineMask(centerlinePts,maskSize)

% centerlinePts are the indices to 1s in a volume of size maskSize
% 
% centerlinePts is a list of indices (NOT nx3 locations) of centerline
% points corresponding to locations of 1s in a binary-valued volume of
% vessel centerlines

%% REDUCE THE CENTERLINE MASK VIA REDUCTION OF JUNCTION CLUSTERS
centerlinePts = ReduceCenterlineMaskJunctions(centerlinePts,maskSize);

%% DO THE VECTORIZATION
[AM,cxyz] = GetCenterlinePointsAndAdjacency(centerlinePts,maskSize);
% [AM] = SnipIrreducible3JunctionClusters(AM); % This only simplifies junction clusters with 3 adjacent junctions irreducible by thinning
[AM,cxyz] = SimplifyJunctionClustersToSingleJunctions(AM,cxyz); % This replaces junction clusters with their cluster centroid

[CenterlineStrands,VertexStrandMemberships] = GetCenterlinesAndStrandStruct(AM);
[Strands,Vertices] = BuildStrandVertexDatastructures(cxyz,CenterlineStrands,VertexStrandMemberships);

for iSTRAND = 1:numel(Strands)
    Strands(iSTRAND).Active = true;
end
