function done = WriteMV3DFile(BridgingStrands,mv3dfname)

% Step 1: remove all empty strands
BridgingStrands = BridgingStrands(~(cellfun(@isempty,BridgingStrands)));

nStrands = numel(BridgingStrands);
[BSvc sz2] = cellfun(@size,BridgingStrands);
nPoints = sum(BSvc);

nIntersections = 0;

fid = fopen(mv3dfname,'wt+');

fprintf(fid,'# MicroVisu3D file\n');
fprintf(fid,'# Number of lines   %d\n',nStrands');
fprintf(fid,'# Number of points  %d\n',nPoints);
fprintf(fid,'# Number of inter.  %d\n',nIntersections);
fprintf(fid,'#\n');
fprintf(fid,'# No		x		y		z		d\n');
fprintf(fid,'#\n');

cptcounter = 0;
for iSTRAND = 1:nStrands
    for iCPT = 1:size(BridgingStrands{iSTRAND},1)
        fprintf(fid,'%d\t%.6f\t%.6f\t%.6f\t%.6f\n',iSTRAND-1,BridgingStrands{iSTRAND}(iCPT,2)-1,BridgingStrands{iSTRAND}(iCPT,1)-1,BridgingStrands{iSTRAND}(iCPT,3)-1,2);
        cptcounter = cptcounter + 1;
    end
    fprintf(fid,'\n');
end
fclose(fid);
done = 1;
