function outputStruct = CropVectorizedStructure(inputStruct,cropLimits)

cropSize(1) = cropLimits(2) - cropLimits(1) + 1;
cropSize(2) = cropLimits(4) - cropLimits(3) + 1;
cropSize(3) = cropLimits(6) - cropLimits(5) + 1;
maskSize = inputStruct.maskSize;
allVerts = inputStruct.Vertices.AllVerts;
numVerts = size(allVerts,1);
numStrands = size(inputStruct.Strands,2);
outputMask = false(cropSize);

flag1 = and(allVerts(:,1)>=cropLimits(1) , allVerts(:,1)<=cropLimits(2));
flag2 = and(allVerts(:,2)>=cropLimits(3) , allVerts(:,2)<=cropLimits(4));
flag3 = and(allVerts(:,3)>=cropLimits(5) , allVerts(:,3)<=cropLimits(6));
allFlag = and(and(flag1,flag2),flag3);
cs = cumsum(allFlag);

outputStruct.maskSize = cropSize;
outputStruct.Vertices.AllVerts = inputStruct.Vertices.AllVerts(allFlag,:);
outputStruct.Vertices.AllRadii = inputStruct.Vertices.AllRadii(allFlag);
outputStruct.Vertices.AllStrandEndPoints = inputStruct.Vertices.AllStrandEndPoints(allFlag);
outputStruct.Vertices.JunctionPoints = inputStruct.Vertices.JunctionPoints(allFlag);
outputStruct.Vertices.FreeEndPoints = inputStruct.Vertices.FreeEndPoints(allFlag);
outputStruct.Vertices.StrandIndices = inputStruct.Vertices.StrandIndices(allFlag);

tic
numChar = 0;
disp('Processing Strands');
for strandIter = 1:numStrands,
    if mod(strandIter,1000)==0,
        t1 = toc;
        remainingTime = t1*(numStrands-strandIter)/strandIter;
        fprintf(repmat('\b',[1,numChar]));
        pause(0.01);
        myMessage = ['Estimated Remaining Time: ',num2str(remainingTime),' seconds.\n'];
        numChar = fprintf(myMessage);
    end%if mod(strandIter,100)==0,
        
    currentStrand = inputStruct.Strands(strandIter);
    newStrand = [];
    subList = find(allFlag(currentStrand.StartToEndIndices));
    stei = currentStrand.StartToEndIndices(subList);
    if isempty(stei),
        newStrand.StartVertexIndex = [];
        newStrand.EndVertexIndex = [];
% %         newStrand.InteriorVertices = [];
        newStrand.StartToEndIndices = [];
    else%if isempty(stei),
        newSTEI = cs(stei)';
        newStrand.StartVertexIndex = newSTEI(1);
        newStrand.EndVertexIndex = newSTEI(end);
% %         newStrand.InteriorVertices = newSTEI(2:end-1);
        newStrand.StartToEndIndices = newSTEI;
    end%if-else isempty(stei),
    newStrand.StartVertexNeighborStrand = currentStrand.StartVertexNeighborStrands;
    newStrand.EndVertexNeighborStrands = currentStrand.EndVertexNeighborStrands;
    newStrand.Active = currentStrand.Active;
    outputStruct.Strands(strandIter) = newStrand;
end
    










