
% % cd('F:\Phil\AOH_Datasets\pbAU_Trials\fullRescaleTest')
% % load('F:\Phil\AOH_Datasets\pbAU_Trials\fullRescaleTest\pbAU-VidaProject.mat')

vsim = vidaProject.globalParameters.voxelSizeInMicrons;
vs = vidaProject.globalParameters.vectorizedStructure;
av = vs.Vertices.AllVerts;
ar = vs.Vertices.AllRadii;
numVerts = size(av,1);
sp = vidaProject.experimentTemplate.strandifyParameters;
crs = vidaProject.globalParameters.centerlineRadiusStructure;
maskSize = crs.maskSize;
numVox = prod(maskSize);

avPrime = av.*0;
arPrime = ar/2;
maskSizePrime = ceil(maskSize/2);

tracer = sparse(numVox,1);
numChar = 0;
for kk = 1:numVerts,
    cv = av(kk,:);
    cr = ar(kk);
    %make the upper quarter triagonal cube
    ci = sub2ind(maskSize,cv(1),cv(2),cv(3));
    qt(1,:) = cv + [1 0 0];
    qt(2,:) = cv + [0 1 0];
    qt(3,:) = cv + [0 0 1];
    qt(4,:) = cv + [1 1 0];
    qt(5,:) = cv + [1 0 1];
    qt(6,:) = cv + [0 1 1];
    qt(7,:) = cv + [0 1 1];
    qt(8,:) = cv + [1 1 1];
    qti = sub2ind(maskSize,qt(:,1),qt(:,2),qt(:,3));
    tracer(qti) = 1;
    %-----
    if tracer(ci) == 0,
        cvPrime = ceil(cv/2);
        avPrime(kk,:) = cvPrime;
        fprintf(repmat('\b',[1,numChar]));
        numChar = fprintf([num2str(kk),' of ',num2str(numVerts)]);
        %-----
        xx = zeros(27,3);    
        xx(1,:) = cv + [-1 -1 -1];    
        xx(2,:) = cv + [-1 -1 -0];    
        xx(3,:) = cv + [-1 -1 +1];    
        xx(4,:) = cv + [-1 -0 -1];    
        xx(5,:) = cv + [-1 -0 -0];    
        xx(6,:) = cv + [-1 -0 +1];    
        xx(7,:) = cv + [-1 +1 -1];    
        xx(8,:) = cv + [-1 +1 -0];    
        xx(9,:) = cv + [-1 +1 +1]; 
        %-----
        xx(10,:) = cv + [-0 -1 -1];   
        xx(11,:) = cv + [-0 -1 -0];    
        xx(12,:) = cv + [-0 -1 +1];    
        xx(13,:) = cv + [-0 -0 -1];    
        xx(14,:) = cv + [-0 -0 -0];    
        xx(15,:) = cv + [-0 -0 +1];    
        xx(16,:) = cv + [-0 +1 -1];    
        xx(17,:) = cv + [-0 +1 -0];    
        xx(18,:) = cv + [-0 +1 +1];    
        %-----
        xx(19,:) = cv + [+1 -1 -1];    
        xx(20,:) = cv + [+1 -1 -0];    
        xx(21,:) = cv + [+1 -1 +1];    
        xx(22,:) = cv + [+1 -0 -1];    
        xx(23,:) = cv + [+1 -0 -0];    
        xx(24,:) = cv + [+1 -0 +1];    
        xx(25,:) = cv + [+1 +1 -1];    
        xx(26,:) = cv + [+1 +1 -0];    
        xx(27,:) = cv + [+1 +1 +1];
        %-----
        xx = max(xx,repmat(1,size(xx)));
        xx = min(xx,repmat(maskSize,[27,1]));
        xxi = sub2ind(maskSize,xx(:,1),xx(:,2),xx(:,3));
        tracer(xxi) = 1;
    end%if tracer(ci) == 0,
end;

f = find(avPrime(:,1))~=0;



 crsPrime.pixelList = sub2ind(maskSizePrime,avPrimeU(:,1),avPrimeU(:,2),avPrimeU(:,3));
 crsPrime.maskSize = maskSizePrime;
 crsPrime.radiusList = arPrimeU;
 




strandifyParameters = sp;
minSegmentLength = strandifyParameters.minSegmentLength;
outputTifFilesFlag = strandifyParameters.outputTifFilesFlag;
centerlineRadiusStructure = crsPrime;
registeredVascGrayscaleFileName = '';
voxelSizeInMicrons = vsim;
%-----
strandifyParameters.centerlineRadiusStructure = centerlineRadiusStructure;
strandifyParameters.minSegmentLength = minSegmentLength;
strandifyParameters.registeredVascGrayscaleFileName = registeredVascGrayscaleFileName;
strandifyParameters.voxelSizeInMicrons = voxelSizeInMicrons;
%-----
strandifyParameters = VidaCenterlineToNodeSegList(strandifyParameters);
strandifyParameters = VidaCollapseNodeClusters(strandifyParameters);
strandifyParameters = VidaRemoveFalseStrands(strandifyParameters);
strandifyParameters = VidaRemoveFalseNodes(strandifyParameters);
strandifyParameters = VidaCleanUpNodeSegList(strandifyParameters);
strandifyParameters = VidaNodeSegListToVertexStrand(strandifyParameters);


% % % if outputTifFilesFlag == 1,
% % %     strandifyParameters = VidaGenerateStraightLineMasks2(strandifyParameters);%noteToSelf
% % % end%if outputTifFilesFlag == 1,
% % % 
% % % outExp = inExp;
% % % outExp.strandifyParameters = strandifyParameters;
% % % % outExp.globalParameters.vectorizedStructure = strandifyParameters.vectorizedStructure;
% % % 




