function outputMatrix = fastbwdist(inputMatrix);

[ySize,xSize,zSize] = size(inputMatrix);
matrixSize = [ySize,xSize,zSize];


inputMatrix = ~inputMatrix;
inputMatrix(:,:,1) = 0; inputMatrix(:,:,end) = 0;
inputMatrix(:,1,:) = 0; inputMatrix(:,end,:) = 0;
inputMatrix(1,:,:) = 0; inputMatrix(end,:,:) = 0;

    a = zeros(3,3,3);
    a(:,:,1) = 0; a(:,:,end) = 0;
    a(:,1,:) = 0; a(:,end,:) = 0;
    a(1,:,:) = 0; a(end,:,:) = 0;

forwardKernel = cat(3,cat(3,[5 4 5; 4 3 4 ; 5 4 5],[4 3 4; 3 0 0; 0 0 0]),[0 0 0; 0 0 0; 0 0 0]);
backwardKernel = cat(3,cat(3,[0 0 0; 0 0 0 ; 0 0 0],[0 0 0; 0 0 3; 4 3 4]),[5 4 5; 4 3 4; 5 4 5]);

forwardKernel = permute(forwardKernel,[2,1,3]);
backwardKernel = permute(backwardKernel,[2,1,3]);

forwardKernelOnes = forwardKernel>0;
forwardKernelOnes(14) = 1;
backwardKernelOnes = backwardKernel>0;
backwardKernelOnes(14) = 1;

outputMatrix = double(inputMatrix);
magicNumber = sum(matrixSize);

whereOnes = find(outputMatrix);
numPixels = length(whereOnes);
[cyList,cxList,czList] = ind2sub(matrixSize,whereOnes);
outputMatrix(find(outputMatrix)) = magicNumber;
for forwardIter = 1:numPixels,

    cy = cyList(forwardIter);
    cx = cxList(forwardIter);
    cz = czList(forwardIter);

    subMatrix = outputMatrix(cy-1:cy+1,cx-1:cx+1,cz-1:cz+1);           
    sumMatrix = forwardKernel + subMatrix;
    sumMatrix2 = sumMatrix(forwardKernelOnes);
    minVal = min(sumMatrix2,[],1);
    outputMatrix(whereOnes(forwardIter)) = minVal;
end
 
for backwardIter = numPixels:-1:1,   
    cy = cyList(backwardIter);
    cx = cxList(backwardIter);
    cz = czList(backwardIter);
    subMatrix = outputMatrix(cy-1:cy+1,cx-1:cx+1,cz-1:cz+1);           
    sumMatrix = backwardKernel + subMatrix;
    sumMatrix2 = sumMatrix(backwardKernelOnes);
    minVal = min(sumMatrix2,[],1);
    outputMatrix(whereOnes(backwardIter)) = minVal;
end
