function mygaussian = gaussian_2d(circle_size1,gaussian_size1,circle_size2,gaussian_size2);
%function mygaussian = gaussian_2d(circle_size1,gaussian_size1,circle_size2,gaussian_size2);
%   the gaussian size is the distance from the peak to the 1/e point(0.367)
%   for a gaussian_size = 10, you get a gaussian with:
%       FWHM = 16.6
%       Stdev = 7.07
if nargin <3,
        myhalf = floor(circle_size1/2);
        [x,y] = meshgrid(-myhalf:myhalf,-myhalf:myhalf);
        mycircle = sqrt(x.^2 + y.^2);
        mygaussian = exp(-1*mycircle.^2/gaussian_size1.^2);
else
        myhalf1 = floor(circle_size1/2);
        myhalf2 = floor(circle_size2/2);
        [x,y] = meshgrid(-myhalf1:myhalf1,-myhalf2:myhalf2);
        mycircle = sqrt((x/gaussian_size1).^2 + (y/gaussian_size2).^2);
        mygaussian = exp(-1*mycircle.^2);
end
return
        