function varargout = loadmovie(varargin);

%USE:
%MYPICS = LOADTIFF(INPUT_FILENAME,[OPTIONS]);
% Written by Phil Tsai 01/10/05

%EXTRACT INPUT PARAMETERS, IF THEY EXIST
nin = nargin;
nout = nargout;
myargin = varargin;
myargin{100} = '';
input_filename = myargin{1};
if nin >1,
    if isstruct(myargin{1}),
        myparameters = myargin{2};
    else%if isstruct(myargin{1})
%         myparameters.input_filename = myargin{1};
    end%if isstruct(myargin{1})
else%if nin>0
    myparameters = [];
end

% stop_frame = readparameters(myparameters,'stop_frame',0);


myinfo = imfinfo(input_filename);
numFrames = length(myinfo);
ySize = myinfo(1).Height;
xSize = myinfo(1).Width;
matrixSize = [ySize,xSize,numFrames];
ColorType = myinfo(1).ColorType;

if strcmp(ColorType,'truecolor');
    matrixSize(3) = matrixSize(3)*3;
    mypics = zeros(matrixSize,'uint16');
    RGB = 1;
else
    mypics = zeros(matrixSize,'uint16');
    RGB = 0;
end

% waitbar_on = 0;
% switch waitbar_yn
%     case {'yes','y','Y','Yes','YES'}
%         wb = waitbar(0,['Loading file ',filename,'...']);
%         waitbar_on = 1;
% end

frameCounter = 0;
for k = 1:numFrames
    temppic = imread(input_filename,k);
    frameCounter = frameCounter + 1;
    
    if RGB == 0,
        mypics(:,:,frameCounter) = temppic;
    else
        mypics(:,:,frameCounter*3-2 : (k+1)*3) = temppic;
    end

%     if waitbar_on == 1, waitbar((k-zStart)/(zStop+1-zStart),wb); end
end%for k = zStart:zStepSize:zStop,

% if waitbar_on ==1, close(wb); end


varargout{1} = mypics;
if nout >1,
    varargout{2} = myparameters;
end

return%function





function output_parameter = readparameters(paramstruct,parameter_name,default_value);
    if isfield(paramstruct,parameter_name),
        if ~isempty(paramstruct.(parameter_name))
            output_parameter = paramstruct.(parameter_name);
        else
            output_parameter = default_value;
        end
    else
        output_parameter = default_value;
    end
return
