function outputParameters = mpd2tiff(inputParameters);
%  Phil Tsai 11/15/07
%  Last Revision : 11/15/07


inputFileName = inputParameters.inputFileName;
%-----
f1 = figure(1);
set(f1,'Visible','Off');
fileRoot = inputFileName(1,1:length(inputFileName)-4);
mpfile = actxcontrol('MPfile.Data',[0,0,500,500],f1);
OpenFile = invoke(mpfile,'OpenMPFile',inputFileName);
%-----
%Read all the header information, but do nothing with it
% % % Header.Scan_Mode = invoke(mpfile,'ReadParameter','Scan Mode');
Header.Frame_Width = invoke(mpfile,'ReadParameter','Frame Width');
Header.Frame_Height = invoke(mpfile,'ReadParameter','Frame Height');
Header.Frame_Count = invoke(mpfile,'ReadParameter','Frame Count');
% % % Header.X_Position = invoke(mpfile,'ReadParameter','X Position');
% % % Header.Y_Position = invoke(mpfile,'ReadParameter','Y Position');
% % % Header.Z_Position = invoke(mpfile,'ReadParameter','Z Position');
% % % Header.Stack_Count = invoke(mpfile,'ReadParameter','Stack Count');
% % % Header.Z_Interval = invoke(mpfile,'ReadParameter','z- Interval');
% % % Header.Averaging_Count = invoke(mpfile,'ReadParameter','Averaging Count');
% % % Header.Repeat_Count = invoke(mpfile,'ReadParameter','Repeat Count');
% % % Header.Magnification = invoke(mpfile,'ReadParameter','Magnification');
% % % Header.Rotation = invoke(mpfile,'ReadParameter','Rotation');
% % % Header.X_Frame_Offset = invoke(mpfile,'ReadParameter','X Frame Offset');
% % % Header.Y_Frame_Offset = invoke(mpfile,'ReadParameter','Y Frame Offset');
% % % Header.Channel_Name1 = invoke(mpfile,'ReadParameter','Channel Name (1)');
% % % Header.Channel_Name2 = invoke(mpfile,'ReadParameter','Channel Name (2)');
% % % Header.Channel_Name3 = invoke(mpfile,'ReadParameter','Channel Name (3)');
% % % Header.Channel_Name4 = invoke(mpfile,'ReadParameter','Channel Name (4)');
Header.Enabled1 = invoke(mpfile,'ReadParameter','Enabled (1)');
Header.Enabled2 = invoke(mpfile,'ReadParameter','Enabled (2)');
Header.Enabled3 = invoke(mpfile,'ReadParameter','Enabled (3)');
Header.Enabled4 = invoke(mpfile,'ReadParameter','Enabled (4)');
% % % Header.Input_Range1 = invoke(mpfile,'ReadParameter','Input Range (1)');
% % % Header.Input_Range2 = invoke(mpfile,'ReadParameter','Input Range (2)');
% % % Header.Input_Range3 = invoke(mpfile,'ReadParameter','Input Range (3)');
% % % Header.Input_Range4 = invoke(mpfile,'ReadParameter','Input Range (4)');
% % % Header.Channel_Unit3 = invoke(mpfile,'ReadParameter','Channel Unit (3)');
% % % Header.Channel_Unit4 = invoke(mpfile,'ReadParameter','Channel Unit (4)');
% % % Header.Channel_Prefix3 = invoke(mpfile,'ReadParameter','Channel Prefix (3)');
% % % Header.Channel_Prefix4 = invoke(mpfile,'ReadParameter','Channel Prefix (4)');
% % % Header.Conversion_Factor3 = invoke(mpfile,'ReadParameter','Conversion Factor (3)');
% % % Header.Conversion_Factor4 = invoke(mpfile,'ReadParameter','Conversion Factor (4)');
% % % Header.Offset3 = invoke(mpfile,'ReadParameter','Offset (3)');
% % % Header.Offset4 = invoke(mpfile,'ReadParameter','Offset (4)');
% % % Header.Data_Point_Per_Frame3 = invoke(mpfile,'ReadParameter','Data Point Per Frame (3)');
% % % Header.Data_Point_Per_Frame4 = invoke(mpfile,'ReadParameter','Data Point Per Frame (4)');
% % % Header.Comments = invoke(mpfile,'ReadParameter','Comments');
%-----
numFrames = str2num(Header.Frame_Count);
xSize = str2num(Header.Frame_Width);
ySize = str2num(Header.Frame_Height);
channelFlag = [0 0 0 0];
if strcmp(Header.Enabled1,'True'), channelFlag(1) = 1; end
if strcmp(Header.Enabled2,'True'), channelFlag(2) = 1; end
if strcmp(Header.Enabled3,'True'), channelFlag(3) = 1; end
if strcmp(Header.Enabled4,'True'), channelFlag(4) = 1; end
%-----
for channelIter = 1:4,
    if channelFlag(channelIter) == 1,
        outputFileName = [fileRoot,'-Ch',num2str(channelIter),'.tif'];
        writeMode = 'overwrite';
        for frameIter = 1:numFrames
            tempFrame = mpfile.ReadFrameData(channelIter,frameIter);
            tempPic = transpose(reshape(tempFrame,xSize,ySize));
            imwrite(uint16(tempPic),outputFileName,'tiff','Compression','none','WriteMode',writeMode,'Resolution',1);
            writeMode = 'append';
        end %for frameIter
    end%if channelFlag(channelIter) == 1,
end%for channelIter = 1:4,
%----            

%close out files and close down figure windows
fclose all;
close all;


outputParameters = inputParameters;
outputParameters.outputFileName = outputFileName;



