
rootFolder = 'G:\AOH\pbCPA_1000x1000x600';
rootName = 'pbCPA';
firstZ = 16; 
lastZ = 25;
startC = 2;
stopC = 6;
startR = 3;
stopR = 7;
myThresh = 500;

modeCh1 = 91;
modeCh2 = 80;
modeCh3 = 99;


allMed = [];
placeCounter = 0;
for c = startC:stopC
    for r = startR:stopR
        for k = firstZ:lastZ
            placeCounter = placeCounter+1;
            za = k;
            zb = k+1;
            CRstr = ['-C',num2str(c,'%02d'),'-R',num2str(r,'%02d')];
 
            %for tif files
            fileName1 = [rootFolder,'\',rootName,'-Z',num2str(za,'%02d'),CRstr,'-Ch3.tif'];
            q1 = loadmovie(fileName1);
            m1 = q1 - modeCh3;
            med1 = squeeze(mean(mean(double(m1))));
            med1 = med1./med1(1);
            allMed(placeCounter,:) = med1;
            medianMed = median(allMed,1);
            
            figure(1);plot(med1,'r.');
            figure(2);plot(allMed');
            figure(3);plot(medianMed,'b-');
            pause(0.01)
            
        end%for k
       
    end%for r
end %for c

x = [1:length(medianMed)];
p = polyfit(x,medianMed,3);
fitRatio = polyval(p,x);
figure(7);plot(x,fitRatio,'r-');
hold on
plot(x,medianMed,'bo');




for zIter = firstZ:lastZ;
    fileTag = [rootName,'-Z',num2str(zIter,'%02d'),'*'];
    myDir = dir(fileTag);
    numFiles = size(myDir,1);
    disp(['Normalizing z ',num2str(zIter),' : ',datestr(now)]);
    for fileIter = 1:numFiles,
        fileName = myDir(fileIter).name;
        myMode = 0;
        if ~isempty(findstr(fileName,'-Ch1.tif')),myMode = modeCh1;end
        if ~isempty(findstr(fileName,'-Ch2.tif')),myMode = modeCh2;end
        if ~isempty(findstr(fileName,'-Ch3.tif')),myMode = modeCh3;end
        if myMode == 0,
            disp('Error');
            pause
        end
        mypics = double(loadmovie(fileName));
        for frameIter = 1:length(fitRatio);
            currentMultiplier = 1/fitRatio(frameIter);
            myFrame = double(mypics(:,:,frameIter));
            mypics(:,:,frameIter) = ((myFrame-myMode)*currentMultiplier) + myMode;
        end
        maketiff(uint16(mypics),fileName);
    end%for fileIter = 1:numFiles,
end%for zIter = firstz:lastZ-1;s
        
