
rootFolder = 'G:\AOH\pbCPA_1000x1000x600';
rootName = 'pbCPA';
firstZ = 16; 
lastZ = 29;
startC = 3;
stopC = 5;
startR = 3;
stopR = 5;
myThresh = 500;

modeCh1 = 91;
modeCh2 = 80;
modeCh3 = 99;



placeCounter = 0;
for c = startC:stopC
    for r = startR:stopR
        placeCounter = placeCounter+1;
        for k = firstZ:lastZ-1
            za = k;
            zb = k+1;
            CRstr = ['-C',num2str(c,'%02d'),'-R',num2str(r,'%02d')];
 
            %for tif files
            fileName1 = [rootFolder,'\',rootName,'-Z',num2str(za,'%02d'),CRstr,'-Ch3.tif'];
            fileName2 = [rootFolder,'\',rootName,'-Z',num2str(zb,'%02d'),CRstr,'-Ch3.tif'];
            q1 = loadmovie(fileName1);
            q2 = loadmovie(fileName2);
            f1 = double(q1(:,:,1:50));
            f2 = double(q2(:,:,1:50));
            
            m1 = f1 - mode(f1(:));
            m2 = f2 - mode(f2(:));
            
            mask1 = m1>myThresh;
            mask2 = m2>myThresh;
            v1 = m1(mask1);
            v2 = m2(mask2);
            med1(k) = median(v1(:));
            med2(k) = median(v2(:));
            myRatio(k) = med2(k)/med1(k);
            
            figure(1);plot(med1,'r.');
            figure(2);plot(med2,'g.');
            figure(3);plot(myRatio,'b.');
            
            
        end%for k
        
        allRatio(placeCounter,:) = myRatio;
        figure(4);plot(allRatio','k.');
        temp = median(allRatio,1);
        temp(1:firstZ-1) = 1;
        cumRatioTemp = cumprod(median(temp,1));
        figure(5);plot(cumRatioTemp,'m.');
    end%for r
end %for c

medianRatio = median(allRatio,1);
medianRatio(1:firstZ-1) = 1;
cumRatio = cumprod(medianRatio);


for zIter = firstZ:lastZ;
    currentRatio = cumRatio(zIter-1);
    currentMultiplier = 1/currentRatio;
    fileTag = [rootName,'-Z',num2str(zIter,'%02d'),'*'];
    myDir = dir(fileTag);
    numFiles = size(myDir,1);
    disp(['Normalizing z ',num2str(zIter),' : ',datestr(now)]);
    for fileIter = 1:numFiles,
        fileName = myDir(fileIter).name;
        myMode = 0;
        if ~isempty(findstr(fileName,'-Ch1.tif')),myMode = modeCh1;end
        if ~isempty(findstr(fileName,'-Ch2.tif')),myMode = modeCh2;end
        if ~isempty(findstr(fileName,'-Ch3.tif')),myMode = modeCh3;end
        if myMode == 0,
            disp('Error');
            pause
        end
        mypics = double(loadmovie(fileName));
        mypics = ((mypics-myMode)*currentMultiplier) + myMode;
        maketiff(uint16(mypics),fileName);
    end%for fileIter = 1:numFiles,
end%for zIter = firstz:lastZ-1;s
        
