function output_parameter = readparameters(paramstruct,parameter_name,default_value);
%
%Readparameters is a function used by other functions to extract
%  the passed parameters from a passed structure.
%USE:
%OUTPUT_PARAMETER = READPARAMETER(PARAMETER_STRUCT, PARAM_NAME, DEFAULT_VALUE)
%
% written by Phil Tsai 02-16-06
% last revision 02-16-06
%

if isfield(paramstruct,parameter_name),
    if ~isempty(paramstruct.(parameter_name))
        output_parameter = paramstruct.(parameter_name);
    else
        output_parameter = default_value;
    end
else
    output_parameter = default_value;
end
return
