function varargout = shiftaligntif(rawData,shiftEvenRowsBy)
%function outputFileName = shiftaligntif(inputFileName,shiftEvenRowsBy)
%written by Phil Tsai on 04/15/08
nin = nargin;
nout = nargout;
if nin == 2,
    bestShift = shiftEvenRowsBy;
else
    shiftList = [-2 -1 0 1 2];
    for shiftIter = 1:length(shiftList),
        currentShift = shiftList(shiftIter);
        oddRows = rawData(1:2:end,3:end-2,:);
        evenRows = rawData(2:2:end,3-currentShift:end-2-currentShift,:);
        minRows = min(size(oddRows,1),size(evenRows,1));
        oddRows = oddRows(1:minRows,:,:);
        evenRows = evenRows(1:minRows,:,:);
        corrValue(shiftIter) = sum(oddRows(:).*evenRows(:));
    end
    [maxVal,maxPos] = max(corrValue);
    bestShift = shiftList(maxPos);
end
if bestShift<0,
    rawData(2:2:end,1:end+bestShift,:) = rawData(2:2:end,1-bestShift:end,:);
else
    rawData(2:2:end,1+bestShift:end,:) = rawData(2:2:end,1:end-bestShift,:);
end

varargout{1} = rawData;
if nout == 2,
    varargout{2} = bestShift;
end
