function viewstackmax(varargin)
%function scanstack(mystack,durationSec,maxProjFrames,skipFrames)
%  set duration = 0 to keyboard step

nin = nargin;
mystack = varargin{1};
switch nin,
    case 1
        durationSec = 5;
        maxProj = 1;
        skipSize = 1;
    case 2
       durationSec = varargin{2};
       maxProj = 1;
       skipSize = 1;
    case 3
       durationSec = varargin{2};
       maxProj = varargin{3};
       skipSize = 1;
    case 4
       durationSec = varargin{2};
       maxProj = varargin{3}; 
       skipSize = varargin{4};
end

frameAdd = maxProj - 1;

zSize = size(mystack,3);
pauseSec = durationSec./zSize;

wb = waitbar(0,'Max Projecting');
if frameAdd>0,
    for frameIter = 1:skipSize:zSize-frameAdd,
        mystack(:,:,frameIter) = max(mystack(:,:,frameIter:frameIter+frameAdd),[],3);
        waitbar(frameIter/zSize,wb);
    end;
end
close(wb);

f102 = figure(102);
for frameIter = 1:skipSize:zSize-frameAdd,
    imagesc(mystack(:,:,frameIter));
    if frameAdd == 0,
        titleText = ['Frames ',num2str(frameIter),' of ', num2str(zSize)];
    else
        titleText = ['Frames ',num2str(frameIter),'-',num2str(frameIter+frameAdd),' of ', num2str(zSize)];
    end
    title(titleText);
    if pauseSec > 0,
        pause(pauseSec);
    else
        pause
    end
end
%close(f102);

return
