function outputParameters = EvaluateAgainstNeuronNeighbors(inputParameters)

compiledNeunResults=inputParameters.compiledNeunResults;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
neuronClassifyFilesFolder = inputParameters.neuronClassifyFilesFolder;
yxzNeuronNeighborhoodSize = inputParameters.yxzNeuronNeighborhoodSize;%40 40 40
maxNumIterationsNeuronSegregation = inputParameters.maxNumIterationsNeuronSegregation;%10
ratioXRangeParameters = inputParameters.ratioXRangeParameters;% [-2:.01:3];
bkgGaussianFitFilterSize = inputParameters.bkgGaussianFitFilterSize;%1-50;
convergenceNumChangedAllowed = inputParameters.convergenceNumChangedAllowed;%0
evalMetric = inputParameters.evalMetric;
neuronLabel = inputParameters.neuronLabel;
%------
% quantifiedNeunData =  columns : cy, cx, cz, cell_vol, cell_val, surround_val, cell_minus_surround


cellCoords = compiledNeunResults(1).cellCoords;
numCells = size(cellCoords,1);


% initialize Labels to be all Neurons to start
% keep coordinate copy separate
% preallocate ratios
ratioMetric=zeros(numCells,1);
diffMetric=zeros(numCells,1);


        misCounts = 0;
        for kCell=1:numCells
            % Get all the cells in a local volume
            Coords=cellCoords(kCell,1:3);
            currentMetric = evalMetric(kCell);
            
            % check yxz bounds on neighborhood
            neighbor1INDs=(cellCoords(:,1)>Coords(1)-yxzNeuronNeighborhoodSize(1))&(cellCoords(:,1)<Coords(1)+yxzNeuronNeighborhoodSize(1));
            neighbor2INDs=(cellCoords(:,2)>Coords(2)-yxzNeuronNeighborhoodSize(2))&(cellCoords(:,2)<Coords(2)+yxzNeuronNeighborhoodSize(2));
            neighbor3INDs=(cellCoords(:,3)>Coords(3)-yxzNeuronNeighborhoodSize(3))&(cellCoords(:,3)<Coords(3)+yxzNeuronNeighborhoodSize(3));
            allNeighborINDs=neighbor1INDs&neighbor2INDs&neighbor3INDs;
            % Get local features for this neighborhood
            neighborMetric=evalMetric(allNeighborINDs,:);
            neighborLabel=neuronLabel(allNeighborINDs,:);
            if sum(neighborLabel)>0,
                meanNeighborMetric = mean(neighborMetric(neighborLabel));
            else%if sum(neighborLabel)>0,
                misCounts = misCounts+1;
                meanNeighborMetric = mean(neighborMetric(:));
            end%if sum(neighborLabel)>0,
            ratioMetric(kCell) = currentMetric./meanNeighborMetric;
            diffMetric(kCell) = currentMetric - meanNeighborMetric;
            
        end%for kCell=1:numCells
        misCounts
        

        

    



outputParameters = inputParameters;
outputParameters.ratioMetric = ratioMetric;
outputParameters.diffMetric = diffMetric;

return

