function outExp = VidaConvertTifToMat(inExp)

%Input Parameters
rootDataFolder = inExp.globalParameters.rootDataFolder;
fileRootName = inExp.globalParameters.fileRootName;
processedDataFolder = inExp.globalParameters.processedDataFolder;
fileList = dir(fullfile(rootDataFolder,[fileRootName,'*.tif']));
numFiles = length(fileList);
if numFiles > 0,
    for fileIter = 1:numFiles,
        currentFileName = fileList(fileIter).name;
        fullTifFileName = fullfile(rootDataFolder,currentFileName);
        imageStack = loadmovie(fullTifFileName);
        matFileName = fullfile(processedDataFolder,[currentFileName(1:end-4),'-Stacked-FITC.mat']);
        saveSize = (getfield(whos('imageStack'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(matFileName,'imageStack',scs);
    end%for fileIter = 1:numFiles,

    %some of the code still expects three channel data, with vessels in slot2
    stackedFileNameList{1} = matFileName;
    stackedFileNameList{2} = matFileName;
    stackedFileNameList{3} = matFileName;
    fullStackSize = size(imageStack);
else%if numFiles > 0,
    stackedFileNameList{1} = 'temp-Stacked-FITC.mat';
    stackedFileNameList{2} = 'temp-Stacked-FITC.mat';
    stackedFileNameList{3} = 'temp-Stacked-FITC.mat';
end%if-else numFiles > 0


%-----
outExp = inExp;
outExp.globalParameters.stackedFileNameList = stackedFileNameList;
outExp.globalParameters.fullStackSize = fullStackSize;
outExp.completionDates.preProcessingCompletionDate = datestr(now);
return



