function [Blocks,AO,TotalMotion,E_it] = BlockDescentByRandomBlockLocalOffsetSearch(OffsetSearch,Blocks,Offsets,MarginalOffsetEnergies,num_it)

if ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),
    numAdjacentPairs = size(MarginalOffsetEnergies,2);
    for adjacentPairIter = 1:numAdjacentPairs,
        registrationDataFileNameList{adjacentPairIter} = MarginalOffsetEnergies.registrationDataFileName;
    end%for adjacentPairIter = 1:numAdjacentPairs,
else%if ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),
    registrationDataFileNameList = [];
end%if-else ~isfield(MarginalOffsetEnergies,'Offset3DEnergy'),



%% SHOW ALL BLOCK SEARCHES IN ADJACENT BLOCK CONTEXT
AO = cell(1,num_it);
TotalMotion = zeros(1,num_it);
E_it = zeros(1,num_it);
for iIT = 1:num_it
    all_rand_blocks = randperm(numel(Blocks));
    AllOffs = zeros(numel(all_rand_blocks),3);
    for iRB = 1:numel(all_rand_blocks)
        B_center = all_rand_blocks(iRB);                        % Get a random block
        % Get offset of minimum energy config in OffsetSearch from Blocks(B_center)
        [Offset_minE,Emin,Eoffsets] = LocalOffsetSearch(B_center,OffsetSearch,Blocks,Offsets,MarginalOffsetEnergies,registrationDataFileNameList);
        % Update center block's corner coordinates to be minimum energy
        Blocks(B_center).corner_coords = Blocks(B_center).corner_coords + Offset_minE;
        % Check if any blocks moved
        AllOffs(iRB,:) = Offset_minE;
    end
    TotalMotion(iIT) = sum(abs(AllOffs(:)));
    AO{iIT} = AllOffs;
    Blocks = TranslateBlock1To111(Blocks);
    [E,EiB] = ComputeTotalEnergy(Blocks,Offsets,MarginalOffsetEnergies);
    E_it(iIT) = E;
    %     if (~ShowAllMOESComputationZeroOffsets(Offsets,Blocks)) && (TotalMotion(iIT) == 0);
    %         disp('examine final config');
    %         %keyboard
    %     end
end
