function MarginalOffsetEnergies = Make3DOffsetEnergies(MarginalOffsetEnergies)

iMOES = 1;                                  % Assume the 1st offset energy surface is representative
MOES = MarginalOffsetEnergies(iMOES);
% get all joint offsets (x1s,x2s,x3s) in search extents
searchextents = max([size(MOES.MOES_x1x2,1),size(MOES.MOES_x1x3,1),size(MOES.MOES_x2x3,1);...
    size(MOES.MOES_x1x2,2),size(MOES.MOES_x1x3,2),size(MOES.MOES_x2x3,2);...
    size(MOES.MOES_x1x2,3),size(MOES.MOES_x1x3,3),size(MOES.MOES_x2x3,3)],[],2)';
allblksi = 1:prod(searchextents);
[x1s,x2s,x3s] = ind2sub(searchextents,allblksi);

for iMOES = 1:numel(MarginalOffsetEnergies)
    MOES = MarginalOffsetEnergies(iMOES);
    E_MOESi = zeros(searchextents);
    for iSEARCH = 1:numel(x1s)
%         E12 = (MOES.MOES_x1x2(x1s(iSEARCH),x2s(iSEARCH),1) - min(MOES.MOES_x1x2(:))) / max(MOES.MOES_x1x2(:));  % scale each energy to go from 0-1 (may be a bad idea)
%         E13 = (MOES.MOES_x1x3(x1s(iSEARCH),1,x3s(iSEARCH)) - min(MOES.MOES_x1x3(:))) / max(MOES.MOES_x1x3(:));
%         E23 = (MOES.MOES_x2x3(1,x2s(iSEARCH),x3s(iSEARCH)) - min(MOES.MOES_x2x3(:))) / max(MOES.MOES_x2x3(:));

        E12 = MOES.MOES_x1x2(x1s(iSEARCH),x2s(iSEARCH),1); 
        E13 = MOES.MOES_x1x3(x1s(iSEARCH),1,x3s(iSEARCH));
        E23 = MOES.MOES_x2x3(1,x2s(iSEARCH),x3s(iSEARCH));

        E_MOESi(x1s(iSEARCH),x2s(iSEARCH),x3s(iSEARCH)) = E12 + E13 + E23; % 3D energy is sum of 2D MOES after normalization
    end
    MarginalOffsetEnergies(iMOES).Offset3DEnergy = E_MOESi;
    MarginalOffsetEnergies(iMOES).ZeroOffsetLoc3D = max([MOES.offs_to_MOESloc_x1x2.MOESloc;MOES.offs_to_MOESloc_x1x3.MOESloc;MOES.offs_to_MOESloc_x2x3.MOESloc]);
end

for iMOES = 1:numel(MarginalOffsetEnergies)
    %MarginalOffsetEnergies(iMOES).Offset3DEnergy = flipdim(MarginalOffsetEnergies(iMOES).Offset3DEnergy,1);
    %MarginalOffsetEnergies(iMOES).Offset3DEnergy = flipdim(MarginalOffsetEnergies(iMOES).Offset3DEnergy,2);
    %MarginalOffsetEnergies(iMOES).Offset3DEnergy = flipdim(MarginalOffsetEnergies(iMOES).Offset3DEnergy,3);

    % With flipdim(block,3) data,
    % 
    % flipped dims 1 & 3 registers pair 3 correctly
    % none flipped registers pair 1 correctly (and maybe pair 2 is correct), pair 3 is wrong
    % flipped dims 2 & 3 misregisters pair 1, misregisters pair 2, misregisters pair 3 
    % flipped dim 1 only misregisters pair 1, misregisters pair 2, misregisters pair 3
    % flipped dim 2 only registers pair 1, misregisters pair 2, misregisters pair 3
    % flipped dims 1 & 2 misregisters pair 1, misregisters pair 2, misregisters pair 3
    % flipped dim 3 only (maybe pair 1 is correct), misregisters pair 2, misregisters pair 3
    % all flipped misregisters pair 1, misregisters pair 2, misregisters pair 3
    
    % Using the flipped versions of all 3D energies appeared to produce the
    % right answer for the Weber data.
    
    % Some vague JK MOES indexing observations on PB data:
    % 1. When all 3D MOES are flipped (with flipdim), dimensions 1 and 2
    % appear to jointly register, but dimension 3 seems to misregister. 
    % 2. When only the first 2 dimensions of the 3D MOES are flipped
    % (with flipdim), and the 3rd dimension is kept the same as the 2D
    % MOES indexing, dimensions 1 and 2 appear to jointly register,
    % but dimension 3 seems to still misregister. 
    
% % %     MarginalOffsetEnergies(iMOES).Offset3DEnergy = MarginalOffsetEnergies(iMOES).Offset3DEnergy - min(MarginalOffsetEnergies(iMOES).Offset3DEnergy(:));
end


%Check for correlation to "Empty" blocks:
for iMOES = 1:numel(MarginalOffsetEnergies),
    if MarginalOffsetEnergies(iMOES).emptyBlockCorrectionFlag == 1,
        threshold = MarginalOffsetEnergies(iMOES).emptyBlockThreshold;
        E = MarginalOffsetEnergies(iMOES).Offset3DEnergy;
        minE = min(E(:));
        p1 = E(1,:,:);
        p2 = E(:,1,:); 
        p3 = E(:,:,1);
        p4 = E(end,:,:); 
        p5 = E(:,end,:); 
        p6 = E(:,:,end);
        perimE = [p1(:);p2(:);p3(:);p4(:);p5(:);p6(:)];
        minPerimE = min(perimE(:));
        validMetric = minPerimE - minE;
        if validMetric < threshold,
            blockIDs = MarginalOffsetEnergies(iMOES).blocks;
            myMessage = ['Interface ',num2str(iMOES),' between blocks ',num2str(blockIDs),' appears Blank - defaulting'];
            disp(myMessage);
            ESize = size(E);
            midPoint = ceil(ESize/2);
            defaultE = zeros(ESize);
            defaultE(midPoint(1),midPoint(2),midPoint(3)) = 1;
            defaultE = (bwdist(defaultE).^2);
            normDefaultE = defaultE./max(defaultE(:));
            MarginalOffsetEnergies(iMOES).Offset3DEnergy = normDefaultE;
        end%if validMetric < threshold,
    end%if MarginalOffsetEnergies(iMOES).EmptyBlockCorrection == 1,
end%for iMOES = 1:numel(MarginalOffsetEnergies),
   



