function displayBlockPairInAmira(EstimatedRegistration,thisPair,displayType)
amAPI.host = 'localhost';
amAPI.port = 3000;
amAPI.send_cmd = 'C:\Tcl\Scripts';
amAPI.send_tcl = 'C:\Tcl\Scripts\send_tcl.tcl';
amAPI.tclsh = 'tclsh85';

% displayType = 'Enhanched';
% displayType = 'RawMask';
% displayType = 'VascReconstructedMask';

%bounding box parameters
showText = 1;
lineWidth = 3;
Bi_boundingBoxColor = [0.667 1 1];
Bj_boundingBoxColor = [.8 0.2 0.2];
Bi_isosurfColor = [0.3 0.27 0.8];
Bj_isosurfColor = [0.9 0.28 0.63];
isosurfPorts(1,:) = {'drawStyle' , 'setValue' , 4 };
isosurfPorts(2,:) = {'colormap' , 'setDefaultAlpha' , 0.2};
isosurfPorts(3,:) = {'doIt', 'snap',[0 1]}; %toggles auto-refresh

%remove previous objects
AmiraMatlabAPI_sendCmd(amAPI,'remove -all')
AmiraMatlabAPI_sendCmd(amAPI,'clear')

%change background
% % cmdStr = 'viewer setVertical 0;viewer 0 setBackgroundMode 0;viewer 0 setBackgroundColor 1 0.99 0.99';
% % AmiraMatlabAPI_sendCmd(amAPI,cmdStr)

dimIdx = [2 1 3];
Bi = thisPair(1);
Bj = thisPair(2);

[Bi_path2file,var2load] = getPtr2mask(EstimatedRegistration,Bi,displayType);
[Bj_path2file,var2load] = getPtr2mask(EstimatedRegistration,Bj,displayType);

[null,Bi_objName] = fileParts(Bi_path2file);
Bi_objName = ['Bi_' strrep(Bi_objName,'-','_')];
[null,Bj_objName] = fileParts(Bj_path2file);
Bj_objName = ['Bj_' strrep(Bj_objName,'-','_')];


Bi_size = EstimatedRegistration.Blocks(Bi).block_size;
% Bi_yxz = EstimatedRegistration.BlocksNominal(Bi).corner_coords;
Bi_yxz = EstimatedRegistration.Blocks(Bi).corner_coords;
Bi_boundingBox = reshape([Bi_yxz(dimIdx) ; Bi_yxz(dimIdx) + Bi_size(dimIdx)],1,6);
Bj_size = EstimatedRegistration.Blocks(Bj).block_size;
% Bj_yxz = EstimatedRegistration.BlocksNominal(Bj).corner_coords;
Bj_yxz = EstimatedRegistration.Blocks(Bj).corner_coords;
Bj_boundingBox = reshape([Bj_yxz(dimIdx) ; Bj_yxz(dimIdx) + Bj_size(dimIdx)],1,6);




%% load Bi file
AmiraMatlabAPI_loadMatFile(amAPI,Bi_path2file,var2load,Bi_objName,Bi_boundingBox)

%attache bounding box
AmiraMatlabAPI_displayBoundingBox(amAPI,Bi_objName,lineWidth,Bi_boundingBoxColor,showText)

%attach isosurface
isosurfPorts(end+1,:) = {'colormap' , 'setDefaultColor' , Bi_isosurfColor};
AmiraMatlabAPI_createIsoSurface(amAPI,Bi_objName,isosurfPorts);

%% load Bj file
AmiraMatlabAPI_loadMatFile(amAPI,Bj_path2file,var2load,Bj_objName,Bj_boundingBox)

%attache bounding box
AmiraMatlabAPI_displayBoundingBox(amAPI,Bj_objName,lineWidth,Bj_boundingBoxColor,showText)

%attach isosurface

isosurfPorts(end+1,:) = {'colormap' , 'setDefaultColor' , Bj_isosurfColor};
AmiraMatlabAPI_createIsoSurface(amAPI,Bj_objName,isosurfPorts);

%% add script object to toggle block configurations
ptr2script = 'C:/temp/ShiftBlockPos.scro'; %change here to suitable location 
AmiraMatlabAPI_BlockPosScriptObj(ptr2script,EstimatedRegistration,Bi,Bj,Bi_objName,Bj_objName)
AmiraMatlabAPI_sendCmd(amAPI,['load -scriptobj ' ptr2script]);

%-----------------------------------------------------------------------------------------------------------------------
function [fname var2load] = getPtr2mask(EstimatedRegistration,idx,displayType)
%build file name for specific mask to display
[path2file] = fileparts(EstimatedRegistration.Blocks(idx).block_data_fname);
str1 = findstr(path2file,'ImageStack-');
str2 = findstr(path2file,'ProcessedData');
baseName = path2file(str1 + 11 : str2 - 2);

switch displayType
    case 'Enhanched'
        fname = fullfile(path2file,[baseName '-VascEnhancedMask.mat']);
        var2load = 'vascEnhancedMask';
    case 'RawMask'
        fname = fullfile(path2file,[baseName '-VascRawMask.mat']);
        var2load = 'vascRawMask';
    case 'VascReconstructedMask'
        fname = fullfile(path2file,[baseName '-VascReconstructedMask.mat']);
        var2load = 'vascReconstructedMask';
    otherwise
        error('Mask type can be ''Enhanched'',  ''RawMask'' or ''VascReconstructedMask''.');
end

