%load vidaProject
%cd to registrationDataFolder


fileIDString = 'voMed4'
mydir = dir([fileIDString,'-RegData*.mat']);
numFiles = size(mydir,1);
for fileIter = 1:numFiles,
    currentFileName = [fileIDString,'-RegData',num2str(fileIter,'%06d'),'.mat'];
    load(currentFileName,'adjacentPairEnergy')
    EstimatedRegistration.MarginalOffsetEnergies(1,fileIter) = adjacentPairEnergy;
end%for fileIter = 1:numFile,
EstimatedRegistration.Offsets = vidaProject.registrationParameters.Offsets;
EstimatedRegistration.Blocks = vidaProject.registrationParameters.Blocks;
EstimatedRegistration.BlockConfig = vidaProject.registrationParameters.BlockConfig;



%Variable to load in mat files used for MOEs is set by data type being loaded
% displayType = 'Enhanched';
% displayType = 'RawMask';
displayType = 'VascReconstructedMask';

MOESsize = size(EstimatedRegistration.MarginalOffsetEnergies(1).MOES_x1x2);
nPairs = numel(EstimatedRegistration.Offsets);
%create single image with all MOES, concatenete along rows
nPairsPerRow = ceil(sqrt(nPairs));
nPairsPerCol = ceil(nPairs/nPairsPerRow);

%zoomed view window
figure('color','w','number','off','visible','off','units','norm','position',[0.42 0.68 0.22 0.2625]);
h2zoom = gca;
set(gca,'xLim',[1 MOESsize(2) * 3],...
    'ylim',[1 MOESsize(1)],'ydir','reverse')
axis off;colormap pink;

%create main window
figure('Color','w','number','off','units','norm','position',[0.002    0.2    0.4172    0.745])
setappdata(gcf,'h2zoom',h2zoom);
set(gca,'xLim',[1 nPairsPerCol  * MOESsize(2) * 3],...
    'ylim',[1 nPairsPerRow * MOESsize(1)],'ydir','reverse')
axis off;colormap pink;hold on


rrOffset = MOESsize(1);
ccOffset = MOESsize(2);
cc = 1;
rr = 1;
ptr = 1;

cmd = 'set(gcf,''name'',get(gcbo,''Tag''));CData = get(gcbo,''CData'');';
cmd = [cmd 'h2zoom = getappdata(gcf,''h2zoom'');set(get(h2zoom,''Children''),''CData'',CData);'];
cmd = [cmd 'set(get(h2zoom,''Parent''),''name'',get(gcbo,''Tag''));'];
cmd = [cmd 'thisPair = get(gcbo,''UserData'');'];
cmd = [cmd sprintf('displayBlockPairInAmira(EstimatedRegistration,thisPair,''%s'')',displayType)];

for iROW = 1 : nPairsPerRow
    for iCOL = 1 : nPairsPerCol
        thisPair = EstimatedRegistration.BlockConfig.all_block_pairs(ptr,:);
        tmp = EstimatedRegistration.Blocks(thisPair(1)).block_data_fname;
        [null,Bi]=fileparts(tmp);
        tmp = EstimatedRegistration.Blocks(thisPair(2)).block_data_fname;
        [null,Bj]=fileparts(tmp);
        pos = findstr(Bi,'-');
        BiZCR = Bi(pos(1)+1:pos(4)-1);
        BjZCR = Bj(pos(1)+1:pos(4)-1);
        tagStr = ['Pair ' num2str(ptr) ': ' BiZCR ' , '  BjZCR ' (' num2str(thisPair(1)) ' , ' num2str(thisPair(2)) ') '];  
        
        h = imagesc( EstimatedRegistration.MarginalOffsetEnergies(ptr).MOES_x1x2);
        set(h,'XData',[cc cc + ccOffset],'YData',[rr rr + rrOffset],'Tag',[tagStr ' Proj: x1x2 '],...
            'ButtonDownFcn',cmd,'UserData',thisPair);
        cc = cc + ccOffset;
        

        h = imagesc(squeeze(EstimatedRegistration.MarginalOffsetEnergies(ptr).MOES_x1x3));
        set(h,'XData',[cc cc + ccOffset],'YData',[rr rr + rrOffset],'Tag',[tagStr ' Proj: x1x3 '],...
            'ButtonDownFcn',cmd,'UserData',thisPair);
        cc = cc + ccOffset;
        

        h = imagesc(squeeze(EstimatedRegistration.MarginalOffsetEnergies(ptr).MOES_x2x3));
        set(h,'XData',[cc cc + ccOffset],'YData',[rr rr + rrOffset],'Tag',[tagStr ' Proj: x2x3 '],...
            'ButtonDownFcn',cmd,'UserData',thisPair);
        cc = cc + ccOffset;

        ptr = ptr + 1;


        if ptr > nPairs; break;end
    end
    rr= rr + rrOffset;
    cc = 1 ;
end

set(get(h2zoom,'parent'),'Visible','on');
h = imagesc( EstimatedRegistration.MarginalOffsetEnergies(1).MOES_x1x2);
