function outputProject = VidaDetermineParameters(inputProject)
    setupParameters = inputProject.setupParameters;
    nin = setupParameters.nin;
    inputArgs = setupParameters.inputArgs;
    defaultGuiStateFlag = setupParameters.defaultGuiStateFlag;
    %----------
    vidaProjectRootFolder = cd;
    vidaProjectRootName = 'Default';
    %-----
    %Determine input arguments.  If none, turn on Gui Flag
    otherArgCounter=0;
    for arginIter = 1:nin,
        currentArg = inputArgs{arginIter};
        switch currentArg,
            case {'nogui','NoGui','NOGUI','noGui','guiOff','GuiOff','GUIOFF'},
                useGuiFlag = 0;
            otherwise
                otherArgCounter=otherArgCounter+1;
                otherArgin{otherArgCounter} = currentArg;
        end%switch currentArg,
    end%for arginIter = 1:nin,
    %-----
    if defaultGuiStateFlag == 0,
        useGuiFlag = 0;
    end%if defaultGuiStateFlag...
    %-----
    if otherArgCounter>0,
        parameterSetupFunctionName = otherArgin{1};
    else%if otherArgCounter>0,
        parameterSetupFunctionName = 'SuperVidaParametersCurrent';
    end%if otherArgCounter>0,
    %---
    switch parameterSetupFunctionName
        case {'default','Default','DEFAULT','def','Def','DEF'};
            parameterSetupFunctionName = 'SuperVidaParametersCurrent';
        case {'current','CURRENT','Current'}
            parameterSetupFunctionName = 'SuperVidaParametersCurrent';
    end%switch parameterSetupFunctionName
    %-----
    if useGuiFlag == 0,
        %Automatically detect vidaProjectRootFolder
        inputProject = [];
            outputProject = VidaAutoDectectVidaProjectRootFolder(inputProject);
        vidaProjectRootName = outputProject.vidaProjectRootName;
        vidaProjectRootFolder = outputProject.vidaProjectRootFolder;
    end%if useGuiFlag == 1,
    %-----
    outputProject = inputProject;
    setupParameters.useGuiFlag = useGuiFlag;
    setupParameters.parameterSetupFunctionName = parameterSetupFunctionName;
    outputProject.vidaProjectRootName = vidaProjectRootName;
    outputProject.vidaProjectRootFolder = vidaProjectRootFolder;
    outputProject.setupParameters = setupParameters;    
    
end
