function outputParameters = VidaSetupExperimentFile(inputParameters)
    experimentRootDataFolder = inputParameters.experimentRootDataFolder;
    experimentRootName = inputParameters.experimentRootName;
    useGuiFlag = inputParameters.useGuiFlag;
    useTifStorageFlag = inputParameters.useTifStorageFlag;
    skipAutoUpgradeFlag = inputParameters.skipAutoUpgradeFlag;
    rootCodeFolder = inputParameters.rootCodeFolder;
    defaultOverwriteFilesStateFlag = inputParameters.defaultOverwriteFilesStateFlag;
    %----------
    experiment.setupParameters.useGuiFlag = useGuiFlag;
    experiment.setupParameters.useTifStorageFlag = useTifStorageFlag;
    experiment.setupParameters.skipAutoUpgradeFlag = skipAutoUpgradeFlag;
% % %     experiment.setupParameters.vascBlockChannelSubFlag = vascBlockChannelSubFlag;
% % %     experiment.setupParameters.neunBlockChannelSubFlag = neunBlockChannelSubFlag;
% % %     %---
% % %     experiment.skipStageParameters.skipPreProcessingFlag =
% skipPreProcessingFlag;
% % %     experiment.skipStageParameters.skipChannelSubFlag = skipChannelSubFlag;
% % %     experiment.skipStageParameters.skipTilingFlag = skipTilingFlag;
    %---
    experiment.codeFolders.rootCodeFolder = rootCodeFolder;
    experiment.codeFolders.generalFunctionsFolder = fullfile(rootCodeFolder,'GeneralFunctionsFolder');
    experiment.codeFolders.guiFunctionsFolder = fullfile(rootCodeFolder,'GuiFunctionsFolder');
    experiment.codeFolders.multiThreadFunctionsFolder = fullfile(rootCodeFolder,'MultiThreadFunctionsFolder');
    experiment.codeFolders.skipStageFunctionsFolder = fullfile(rootCodeFolder,'SkipStageFunctionsFolder');
    experiment.codeFolders.preProcessingFunctionsFolder = fullfile(rootCodeFolder,'PreProcessingFunctionsFolder');
    experiment.codeFolders.channelSubFunctionsFolder = fullfile(rootCodeFolder,'ChannelSubFunctionsFolder');
    experiment.codeFolders.tilingFunctionsFolder = fullfile(rootCodeFolder,'TilingFunctionsFolder');
    experiment.codeFolders.subBlockFunctionsFolder = fullfile(rootCodeFolder,'SubBlockFunctionsFolder');
    experiment.codeFolders.cellSegFunctionsFolder = fullfile(rootCodeFolder,'CellSegFunctionsFolder');
    experiment.codeFolders.vascBlockChannelSubFunctionsFolder = fullfile(rootCodeFolder,'VascBlockChannelSubFunctionsFolder');
    experiment.codeFolders.vascSegFunctionsFolder = fullfile(rootCodeFolder,'VascSegFunctionsFolder');
    experiment.codeFolders.cellCentroidFunctionsFolder = fullfile(rootCodeFolder,'CellCentroidFunctionsFolder');
    experiment.codeFolders.neunBlockChannelSubFunctionsFolder = fullfile(rootCodeFolder,'NeunBlockChannelSubFunctionsFolder');
    experiment.codeFolders.neunQuantifyFunctionsFolder = fullfile(rootCodeFolder,'NeunQuantifyFunctionsFolder');
    experiment.codeFolders.neuronClassifyFunctionsFolder = fullfile(rootCodeFolder,'NeuronClassifyFunctionsFolder');
    experiment.codeFolders.vascRadiiFunctionsFolder = fullfile(rootCodeFolder,'VascRadiiFunctionsFolder');
    experiment.codeFolders.centerLineFunctionsFolder = fullfile(rootCodeFolder,'CenterLineFunctionsFolder');
% % %     experiment.codeFolders.flattenCortexFunctionsFolder = fullfile(rootCodeFolder,'FlattenCortexFunctionsFolder');
% % %     experiment.codeFolders.sideProjectMasksFunctionsFolder = fullfile(rootCodeFolder,'SideProjectMasksFunctionsFolder');
% % %     experiment.codeFolders.analyzeMasksFunctionsFolder = fullfile(rootCodeFolder,'AnalyzeMasksFunctionsFolder');
    revisedCodeFolders = experiment.codeFolders; %temp storage of local code directory (in case prior experiment from different machine is used)
    %---
    experiment.progressFlags.initialized = 1;
    experiment.progressFlags.overwriteOldFiles = defaultOverwriteFilesStateFlag;
    experiment.progressFlags.preProcessingCompleted = 0;
    experiment.progressFlags.subBlockCompleted = 0;
    experiment.progressFlags.cellSegCompleted = 0;
    experiment.progressFlags.vascBlockChannelSubCompleted = 0;
    experiment.progressFlags.vascSegCompleted = 0;
    experiment.progressFlags.centerLineCompleted = 0;
    experiment.progressFlags.cellCentroidCompleted = 0;
    experiment.progressFlags.neunBlockChannelSubCompleted = 0;
    experiment.progressFlags.neunQuantifyCompleted = 0;
    experiment.progressFlags.neuronClassifyCompleted = 0;
    experiment.progressFlags.vascRadiiCompleted = 0;
    %---
    vidaProjectFileName = fullfile(experimentRootDataFolder,[experimentRootName,'-VidaProject.mat']);
    %-----
    outputParameters = inputParameters;
    outputParameters.experiment = experiment;
    outputParameters.revisedCodeFolders = revisedCodeFolders;
    outputParameters.vidaProjectFileName = vidaProjectFileName;
    
end
