function outputParameters = VidaVascOnlyRenameFiles(inputParameters)
vidaProject = inputParameters;

tifFileList = dir('*.tif');
%-----
%Check to see if there is a -Zxx-Cxx-Rxx-ChX.tif file
numTifFiles = length(tifFileList);
nameScore = zeros(1,numTifFiles);
for fileIter = 1:numTifFiles,
    currentFile = tifFileList(fileIter).name;
    goodNameFlag = 1;
    if isempty(findstr(currentFile,'-Z')), goodNameFlag=0; end
    if isempty(findstr(currentFile,'-C')), goodNameFlag=0; end
    if isempty(findstr(currentFile,'-R')), goodNameFlag=0; end
    if isempty(findstr(currentFile,'-Ch1')), goodNameFlag=0; end
    nameScore(fileIter) = goodNameFlag;
end    

if max(nameScore)==0,
    %We need to change the name to fit VidaSuite
    if numTifFiles == 1,
        %only one file; simply name it '-Z01-C01-R01-Ch1.tif';
        originalName = tifFileList(fileIter).name;
        dashPos = [];
        dashPos = [dashPos,findstr(originalName,'-Z')];
        dashPos = [dashPos,findstr(originalName,'-R')];
        dashPos = [dashPos,findstr(originalName,'-C')];
        dashPos = [dashPos,findstr(originalName,'-Ch')];
        dashPos = [dashPos,findstr(originalName,'.tif')];
        firstDashPos = min(dashPos);
        nameRoot = originalName(1:firstDashPos-1);
        newName = [nameRoot,'-Z01-C01-R01-Ch1.tif'];
        mypics = loadmovie(originalName);
        maketiff(mypics,newName);
    else%if numTifFiles == 1,
        disp('more than one misnamed tif file!');
        disp('either put single file in the folder, or rename files to -Zxx-Rxx-Cxx-Ch1.tif');
        keyboard
    end%if-else numTifFiles == 1,
else%if max(goodNameScore)==0,  
    goodNameFilePointer = find(nameScore==1);
    originalName = tifFileList(goodNameFilePointer(1)).name;
    dashPos = findstr(originalName,'-Z');
    firstDashPos = min(dashPos);
    nameRoot = originalName(1:firstDashPos-1);
end%if max(goodNameScore)==0,


outputParameters = inputParameters;
outputParameters.vidaProjectRootName = nameRoot;
    