function outExp = VidaSkipPreProcessing(inExp)

%Input Parameters
rootDataFolder = inExp.globalParameters.rootDataFolder;
originalDataFolder = inExp.globalParameters.originalDataFolder;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
filePrefix = inExp.preProcessingParameters.filePrefix;
%-----
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(originalDataFolder);
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(processedDataFolder);
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(intermediateResultsFolder);
%-----
disp('You have opted to skip PreProcessing');
%Move the files into the processedDataFolder
processedFiles = dir(fullfile(rootDataFolder,'*.tif'));
numProcessedFiles = size(processedFiles,1);
for fileIter = 1:numProcessedFiles,
    disp(['Moving original file ',num2str(fileIter),' of ',num2str(numProcessedFiles),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
    currentFileName = processedFiles(fileIter).name;
    fullProcessedFileName = fullfile(rootDataFolder,currentFileName);
    fullFinalFileName = fullfile(processedDataFolder,processedFiles(fileIter).name);
    for channelIter = 1:size(filePrefix,2);
        currentChSuffix = ['-Ch',num2str(channelIter),'.tif'];
        if findstr(currentChSuffix,currentFileName),
            suffixPos = findstr(currentChSuffix,currentFileName);
            convertedFileName = [filePrefix{channelIter},'-',currentFileName(1:suffixPos-1),'.tif'];
            fullFinalFileName = fullfile(processedDataFolder,convertedFileName);
        end%if findstr(currentChSuffix,currentFileName),
    end%for channelIter = 1:size(filePrefix,2);
    dosCommand = ['move "',fullProcessedFileName,'" "',fullFinalFileName,'"'];
    dos(dosCommand); 
    % % % movefile(fullProcessedFileName,fullFinalFileName)
end%for fileIter = 1:numOriginalFiles,
%-----
outExp = inExp;
nullCompletionDate = '01-Jan-1900 00:00:00';
outExp.completionDates.preProcessingCompletionDate = nullCompletionDate;
outExp.progressFlags.preProcessingCompleted = 1;
%-----
return


