function outExp = VidaSkipTiling(inExp)

rootDataFolder = inExp.globalParameters.rootDataFolder;
processedDataFolder = inExp.globalParameters.processedDataFolder;
fileRootName = inExp.globalParameters.fileRootName;
%---
outputFileRoots = inExp.tilingParameters.outputFileRoots;
%---
tilingFilesFolder = fullfile(processedDataFolder,'TilingFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(processedDataFolder,'TilingFiles');
%-----
extType = '.mat';
%-----
numChannels = size(outputFileRoots,2);
for channelIter = 1:numChannels,
    outputFileName = [fileRootName,'-Stacked-',outputFileRoots{channelIter},extType];
    stackedVolumeFileNames{channelIter} = fullfile(processedDataFolder,outputFileName);
    %If file is in rootDataFolder, then move it to the processedDataFolder
    if exist(fullfile(rootDataFolder,outputFileName)),
        disp(['Moving ',outputFileName,' to processedDataFolder']);
        dosCommand = ['move "',fullfile(rootDataFolder,outputFileName),'" "',stackedVolumeFileNames{channelIter},'"'];
        dos(dosCommand); 
    end%if exist(fullFile(rootDataFolder,outputFileName)),
end%for channelIter = 1:numChannels,
%-----
if isfield(inExp.globalParameters,'cellMaskSize')
    stackedVolumeSize = inExp.globalParameters.cellMaskSize;
else %if ~isfield...
    disp(['Evaluating Stacked Volume Size : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
    try%1
        load(stackedVolumeFileNames{1},'imageStack');
    catch%1
        try%2
            load(stackedVolumeFileNames{2},'imageStack');
        catch%2
            try%3
                load(stackedVolumeFileNames{2},'imageStack');
            catch%3
                error('Could Not mat file containing image stack.  Try setting skipPreprocessingFlag = 0');
            end%try-catch3
        end%try-catch2
    end%try-catch1
    stackedVolumeSize = size(imageStack);
end %if ~isfield...
%-----
%DEFINE CHANNEL NAMES
stackedFileNames = stackedVolumeFileNames;
[tempPath,tempFileName,tempExt,tempVer] = fileparts(stackedFileNames{1});
channels.cellChannelString = tempFileName(findstr(tempFileName,'-')+1:end);
[tempPath,tempFileName,tempExt,tempVer] = fileparts(stackedFileNames{2});
channels.vascChannelString = tempFileName(findstr(tempFileName,'-')+1:end);
channels.neunChannelString = '';
if numChannels >2,
    [tempPath,tempFileName,tempExt,tempVer] = fileparts(stackedFileNames{3});
    channels.neunChannelString = tempFileName(findstr(tempFileName,'-')+1:end);
end
%-----
outExp = inExp;
outExp.tilingParameters.channelNames = outputFileRoots;
outExp.tilingParameters.relativeOffsetTextFile = 'skipped';
outExp.tilingParameters.tilingFilesFolder = tilingFilesFolder;
%---
outExp.globalParameters.numChannels = numChannels;
outExp.globalParameters.stackedFileNames = stackedVolumeFileNames;
outExp.globalParameters.cellMaskSize = stackedVolumeSize;
outExp.globalParameters.vascMaskSize = stackedVolumeSize;
outExp.globalParameters.channels = channels;
outExp.completionDates.tilingCompletionDate = datestr(now);
outExp.progressFlags.tilingCompleted = 1;
return


