

strandCurrentList = analysisResults.strandCurrentList;
strands = globalDataStruct.strands;
strandsConnectedByNode = analysisResults.strandsConnectedByNode;
nodesConnectedByStrand = analysisResults.nodesConnectedByStrand;
freeNodeList = analysisResults.freeNodeList;
strandConductanceList = analysisResults.strandConductanceList;
maskSize = globalDataStruct.maskSize;
voltageVector = analysisResults.voltageVector;
cpMatrix = globalDataStruct.cpMatrix;
ar = globalDataStruct.ar;


numStrands = numel(strands);
for strandIter = 1:numStrands,
    stei = strands(strandIter).StartToEndIndices;
    strandLengthList(strandIter) = numel(stei);
    subRadiusList = ar(stei);
    strandRadiusList(strandIter) = median(subRadiusList);
end

minCurrent = median(strandCurrentList)/100;
modStrandCurrentList = max(strandCurrentList,minCurrent);
transitTimeList = double(strandLengthList)./modStrandCurrentList';




% % % 
% % % 
% % % %FAKE
% % % %FAKE
% % % %FAKE
% % % %FAKE
% % % transitTimeList = modStrandCurrentList' ./ double(strandLengthList);
% % % %FAKE
% % % %FAKE
% % % %FAKE
% % % %FAKE





%Start from a high voltage node
%Find the strands connected, give those strands a total transit time (ttt) of 0
%These strands act at seed strands
%For each seed strand:
%   Find other node attached
%   If the voltage of the other node is lower, current flows
%       Find the other strands attached to the lower node
%       These strands get a ttt = ttt(seedStrand) + seedStrand's singleTransitTime
%       Mark these strands as next round seeds
%
%Next round: find those strands marked as seeds.
%   Repeat; if a strand already has a ttt attached, take the min value.

%When all paths have gone to completion (no lower voltage nodes available)
%   Check to see what segments have not yet gotten a ttt.  Start with the
%   strand with the highest attached voltage node, and repeat the whole
%   procedure.



%Find the highest voltage node
[mymax,highestVoltageNodeID] = max(voltageVector);
ttt = zeros(size(strandConductanceList))+inf;
seedStrandFlagList = zeros(size(strandConductanceList));
seedStrandList = strandsConnectedByNode{freeNodeList(highestVoltageNodeID)};
seedStrandAnchorFreeNodeList = repmat(highestVoltageNodeID,size(seedStrandList));
    %recall that the sCBN lists all nodes, but the voltageVector
    %only contains the free nodes (not clamped to ground or voltage)
    %the freeNodeList converts between the two.
ttt(seedStrandList) = 0;
moreTrackingFlag = 1;
while moreTrackingFlag == 1,
    keepGoing = 1;
    while keepGoing==1,
        numSeedStrands = numel(seedStrandList);
        nextRoundSeedStrandList = zeros(1,numSeedStrands*5);
        nextRoundSeedStrandAnchorFreeNodeList = zeros(1,numSeedStrands*5);
        myVoltageList = zeros(1,numSeedStrands*5);
        counter = 0;
        for seedIter = 1:numSeedStrands,
            thisSeedStrandID = seedStrandList(seedIter);
            thisSeedStrandAnchorFreeNodeID = seedStrandAnchorFreeNodeList(seedIter);
            baseTTT = ttt(thisSeedStrandID);
            thisStrandTransitTime = transitTimeList(thisSeedStrandID);
            %find other node attached 
            bothNodes = nodesConnectedByStrand(thisSeedStrandID,:);
            freeNodes = find(ismember(freeNodeList,bothNodes));
            otherFreeNodeID = freeNodes(~ismember(freeNodes,thisSeedStrandAnchorFreeNodeID));
            %determine the voltages
            thisVoltage = voltageVector(thisSeedStrandAnchorFreeNodeID);
            otherVoltage = voltageVector(otherFreeNodeID);
            %if the otherVoltage is lower, then propagate
            if otherVoltage<thisVoltage,
                %find the strands attached to the otherFreeNode
                nextSetStrands = strandsConnectedByNode{freeNodeList(otherFreeNodeID)};
                %if the ttt of the next strand is already lower, no need to
                %propagate if you only want to find the Minimum transit time
                storedTTT = ttt(nextSetStrands);
                tempTTT = baseTTT+thisStrandTransitTime;
                greaterStoredTTTFlag = storedTTT > tempTTT;

                nextSetStrands = nextSetStrands(greaterStoredTTTFlag);

                ttt(nextSetStrands) = tempTTT;
                numNextStrands = numel(nextSetStrands);
                nextSetAnchorFreeNodeID = repmat(otherFreeNodeID,[1,numNextStrands]);
                nextRoundSeedStrandList(counter+1:counter+numNextStrands) = nextSetStrands;
                nextRoundSeedStrandAnchorFreeNodeList(counter+1:counter+numNextStrands) = nextSetAnchorFreeNodeID;
                myVoltageList(counter+1:counter+numNextStrands) = repmat(otherVoltage,[1,numNextStrands]);
                counter = counter + numNextStrands;
            end%if otherVoltage<thisVoltage,
        end%for seedIter = 1:numSeedStrands,
        nextRoundSeedStrandList = nextRoundSeedStrandList(1:counter);
        nextRoundSeedStrandAnchorFreeNodeList = nextRoundSeedStrandAnchorFreeNodeList(1:counter);
        myVoltageList = myVoltageList(1:counter);
        disp([numel(nextRoundSeedStrandList),median(myVoltageList)*1]);
        if numel(nextRoundSeedStrandList) == 0,
            keepGoing = 0;
        end
        seedStrandList = nextRoundSeedStrandList;
        seedStrandAnchorFreeNodeList = nextRoundSeedStrandAnchorFreeNodeList;
    end%while keepGoing == 1,

    moreTrackingFlag = 0;
    if max(ttt)==inf,
        disp('New Starting Point');
        moreTrackingFlag = 1;
        %Now Find the highest voltage node that has note yet been processed
        untrackedStrandList = find(ttt==inf);
        untrackedNodeList = nodesConnectedByStrand(untrackedStrandList,:);
        untrackedFreeNodeList = find(ismember(freeNodeList,untrackedNodeList));
        untrackedVoltageList = voltageVector(untrackedFreeNodeList);
        [maxUntrackedVoltage,maxPos] = max(untrackedVoltageList);
        highestVoltageFreeNodeID = untrackedFreeNodeList(maxPos(1));
        highestVoltageNodeID = freeNodeList(highestVoltageFreeNodeID);
        seedStrandList = strandsConnectedByNode{highestVoltageNodeID};
        seedStrandAnchorFreeNodeList = repmat(highestVoltageFreeNodeID,size(seedStrandList));
        ttt(seedStrandList)=0;
    end%if max(ttt)==inf,

end%while moreTrackingFlag == 1,



%the ttt's (total transit times) are associated with strands.
%to make a map, normalize ttt's, map each strands.StartToEndIndices with
%its ttt value

% % % tttMod = ttt;
% % % tttMod(ttt==inf) = max(ttt(ttt<inf))*1.1;
% % % tttMax = max(tttMod)
% % % tttMin = min(tttMod);
% % % tttRange = tttMax-tttMin
% % % tttMod = 200*(tttMod-tttMin)/tttRange;
% % % tttMod = 230-tttMod;

tttMod = ttt;
tttMod(ttt==0)=min(ttt(ttt>0));
tttMod = log(tttMod);
tttMax = max(tttMod)
tttMin = min(tttMod);
tttRange = tttMax-tttMin
tttMod = 200*(tttMod-tttMin)/tttRange;
tttMod = 230-tttMod;



myMask = zeros(maskSize,'uint8');
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    iv = thisStrand.StartToEndIndices;
    cp1 = cpMatrix(iv,1);
    cp2 = cpMatrix(iv,2);
    cp3 = cpMatrix(iv,3);
    for cpIter = 1:numel(cp1),
        myMask(cp1(cpIter),cp2(cpIter),cp3(cpIter)) = tttMod(thisStrandID);
    end%for cpIter = 1:numel(c1),
end%for strandIter = 1:numStrands,
maketiff(myMask,'TransitTimeMask.tif');








meanVal = mean(tttMod(tttMod>0));
tttRed = tttMod;
redStretch = max(tttRed)/(meanVal+25);
tttRed = max(0,tttRed-meanVal+25);
tttRed = tttRed*redStretch;
%---
myMask = zeros(maskSize,'uint8');
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    iv = thisStrand.StartToEndIndices;
    cp1 = cpMatrix(iv,1);
    cp2 = cpMatrix(iv,2);
    cp3 = cpMatrix(iv,3);
    for cpIter = 1:numel(cp1),
        myMask(cp1(cpIter),cp2(cpIter),cp3(cpIter)) = tttRed(thisStrandID);
    end%for cpIter = 1:numel(c1),
end%for strandIter = 1:numStrands,
MakeHalfSizeMasks
maketiff(halfMask,'TransitTimeMaskRedHalf.tif');



tttBlue = max(tttMod) - tttMod;
meanVal = mean(tttBlue);
blueStretch = max(tttBlue)/(meanVal+25);
tttBlue = max(0,tttBlue-meanVal+25);
tttBlue = tttBlue*blueStretch;
%---
myMask = zeros(maskSize,'uint8');
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    iv = thisStrand.StartToEndIndices;
    cp1 = cpMatrix(iv,1);
    cp2 = cpMatrix(iv,2);
    cp3 = cpMatrix(iv,3);
    for cpIter = 1:numel(cp1),
        myMask(cp1(cpIter),cp2(cpIter),cp3(cpIter)) = tttBlue(thisStrandID);
    end%for cpIter = 1:numel(c1),
end%for strandIter = 1:numStrands,
MakeHalfSizeMasks
maketiff(halfMask,'TransitTimeMaskBlueHalf.tif');






