
%This code crops away vessel segments near the edges.

%Load a globalDataStruct
%
%Note:  no connectivity changes can have occured since the latest restrandify round
%Changes to labels are okay.
%
%Labels: 100=Unlabeled; 200=Temp ; 300=Surface ; 400=Plunging ; 500=Micro ;
%         10=Unlabeled ; 20=Temp ; 30=Supply ; 40=Draining ;  50=Connecting ;
%Therefore: SurfaceArtery=330; SurfaceVein = 340;
%
%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label


manualLimitsY = [90 1080];
manualLimitsX = [50 1040];
manualLimitsZ = [1 1100];



maskSize = globalDataStruct.maskSize;
cpMatrix = globalDataStruct.cpMatrix;
ar = globalDataStruct.ar;

q1 = cpMatrix(:,1)>=manualLimitsY(1);
q2 = cpMatrix(:,2)>=manualLimitsX(1);
q3 = cpMatrix(:,3)>=manualLimitsZ(1);
q4 = cpMatrix(:,1)<=manualLimitsY(2);
q5 = cpMatrix(:,2)<=manualLimitsX(2);
q6 = cpMatrix(:,3)<=manualLimitsZ(2);

qq = and(and(and(and(and(q1,q2),q3),q4),q5),q6);
cpMatrix = cpMatrix(qq,:);
ar = ar(qq,:);


        
        
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.ar = ar;
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE',dateString,'-Cropped','-StrandEdit-',fileName,ext]);
save(saveFileName,'globalDataStruct');


    