
if ~exist('variableCleanupFlag','var'), 
    variableCleanupFlag = 0;
end
%---



voltageVector = analysisResults.voltageVector;
nodesConnectedByStrand = analysisResults.nodesConnectedByStrand;
strandConductanceList = analysisResults.strandConductanceList;
nodeCPID = analysisResults.nodeCPID;
groundStrandList = analysisResults.groundStrandList;
voltageStrandList = analysisResults.voltageStrandList;
freeNodeList = analysisResults.freeNodeList;
groundNodeList = analysisResults.groundNodeList;
voltageNodeList = analysisResults.voltageNodeList;
%---
maskSize = globalDataStruct.maskSize;
cpMatrix = globalDataStruct.cpMatrix;
strands = globalDataStruct.strands;
myMask = zeros(maskSize,'uint8');
cpCurrentList = zeros(size(cpMatrix,1),1);
normCPCurrentList = zeros(size(cpMatrix,1),1);
strandCurrentList = zeros(numel(strands),1);
normStrandCurrentList = zeros(numel(strands),1);
voltageDifferenceList = zeros(numel(strands),1);



%Generate a current map from 55 to 255
%(the 55 offset allows a margin around zero to set opacity maps for bkg to 0)
lowI = 50;
highI = 200;
maxVoltageDifference = Ev-Eg;



numStrands = numel(strands);
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    strandCompletedFlag = 0;
    voltage1 = -999;
    voltage2 = -999;
    stei = strands(thisStrandID).StartToEndIndices;
    if ismember(thisStrandID,voltageStrandList),
        strandCurrentList(thisStrandID) = inf;
        normStrandCurrentList(thisStrandID) = -255;
        cpCurrentList(stei) = inf;
        normCPCurrentList(stei) = -255; 
        strandCompletedFlag = 1;
    end%if ismember(thisStrandID,voltageStrandList)
    %---
    if ismember(thisStrandID,groundStrandList),
        strandCurrentList(thisStrandID) = inf;
        normStrandCurrentList(thisStrandID) = -255;
        cpCurrentList(stei) = inf;
        normCPCurrentList(stei) = -255; 
        strandCompletedFlag = 1;
    end%if ismember(thisStrandID,voltageStrandList)
    %---
    if strandCompletedFlag == 0,
        node1 = nodesConnectedByStrand(thisStrandID,1);
        node2 = nodesConnectedByStrand(thisStrandID,2);
        node1CP = nodeCPID(node1);
        node2CP = nodeCPID(node2);
        if node1CP ~= stei(1),
            stei = fliplr(stei);
        end%if node1CP ~= stei(1),
        %---
        if ismember(node1,voltageNodeList), voltage1 = Ev; end
        if ismember(node2,voltageNodeList), voltage2 = Ev; end
        if ismember(node1,groundNodeList), voltage1 = Eg; end
        if ismember(node2,groundNodeList), voltage2 = Eg; end
        %---
        if ismember(node1,freeNodeList),
            freeNode1ID = find(freeNodeList==node1);
            voltage1 = voltageVector(freeNode1ID);
        end%if ismember(node1,freeNodeList),
        %---
        if ismember(node2,freeNodeList),
            freeNode2ID = find(freeNodeList==node2);
            voltage2 = voltageVector(freeNode2ID);
        end%if ismember(node2,freeNodeList),
        %---
        voltageDifference = abs(voltage1-voltage2);
        thisConductance = strandConductanceList(thisStrandID);
        thisCurrent = voltageDifference.*thisConductance;
        
        voltageDifferenceList(thisStrandID) = voltageDifference;
        thisCurrent = (1-exp(-voltageDifference/0.1)).*thisConductance;
        
        
        cpCurrentList(stei) = thisCurrent;
        normCPCurrentList(stei) = thisCurrent;
        strandCurrentList(thisStrandID) = thisCurrent;
        strandCompletedFlag = 1;
    end%if strandCompletedFlag == 0,
end%for strandIter = 1:numStrands,

posNormCurrentFlag = normCPCurrentList>0;
posNormCurrentList = (double(normCPCurrentList(posNormCurrentFlag)));
maxCurrent = max(posNormCurrentList);
minCurrent = min(posNormCurrentList);
currentRange = maxCurrent-minCurrent;
posNormCurrentList = ((posNormCurrentList-minCurrent)./currentRange)*(highI-lowI) + lowI;
normCPCurrentList = double(normCPCurrentList)*-1;
normCPCurrentList(posNormCurrentFlag) = posNormCurrentList;

% % for strandIter = 1:numStrands,
% %     thisStrandID = strandIter;
% %     thisStrand = strands(thisStrandID);
% %     stei = thisStrand.StartToEndIndices;
% %     normStrandCurrentList(thisStrandID) = median(normCPCurrentList(stei));
% %     for pointIter = 1:numel(stei),
% %         cp = cpMatrix(stei(pointIter),1:3);
% %         thisNormCurrent = normCPCurrentList(stei(pointIter));
% %         myMask(cp(1),cp(2),cp(3)) = thisNormCurrent;
% %     end%for pointIter = 1:numel(stei),
% % end%for strandIter = 1:numStrands


logStrandCurrentList = log(max(1,strandCurrentList));
sortList = sort(logStrandCurrentList);
numList = numel(sortList);
topVal = sortList(ceil(numList*0.98));
bottomVal = sortList(ceil(numList*0.02));
rangeVal = topVal-bottomVal;
normStrandCurrentList = uint8(255*(logStrandCurrentList-bottomVal)./rangeVal);
%-----
logCPCurrentList = log(max(1,cpCurrentList));
normCPCurrentList = uint8(255*(logCPCurrentList-bottomVal)./rangeVal);

for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    for pointIter = 1:numel(stei),
        cp = cpMatrix(stei(pointIter),1:3);
        thisNormCurrent = normCPCurrentList(stei(pointIter));
        myMask(cp(1),cp(2),cp(3)) = thisNormCurrent;
    end%for pointIter = 1:numel(stei),
end%for strandIter = 1:numStrands





analysisResults.cpCurrentList = cpCurrentList;
analysisResults.normCPCurrentList = normCPCurrentList;
analysisResults.strandCurrentList = strandCurrentList;
analysisResults.normStrandCurrentList = normStrandCurrentList;


if variableCleanupFlag == 1,
    clear cp cpMatrix cpCurrentList cpVoltageList currentRange thisStrandID 
    clear freeNode1ID freeNode2ID freeNodeList
    clear highI k lowI maxCurrent maxVoltageDifference minCurrent myFrame newFrame 
    clear node1 node1CP node2 node2CP nodeCPID nodesConnectedByStrand
    clear normCPCurrentList normCurrentList normPosCurrentList numStrands normStrandCurrentList pointIter
    clear posCurrentFlag posCurrentList posNormCurrentFlag posNormCurrentList
    clear stei strandCompletedFlag strandConductanceList strandIter strands
    clear thisConductance thisCurrent thisNormCurrent thisStrand voltageDifference voltage1
    clear voltage2 voltageList voltageNodeList voltageRange voltageVector voltageStrandList
    clear zeroCurrentFlag
end%if variableCleanupFlag == 1


% %  