function outputParameters = VidaMaskToList(inputParameters)

maskFileName = inputParameters.maskFileName;

variableStructure = load(maskFileName);
variableFields = fieldnames(variableStructure);
binaryMask = getfield(variableStructure,variableFields{1});

%-----
%First perform a modified FIND.  This z-by-z method avoids memory problems
%and is 2x as slow as a simple find.
maskSize = size(binaryMask);
numOnVoxels = sum(binaryMask(:));
onVoxelList = zeros(numOnVoxels,1);
onVoxelCounter = 0;
for zIter = 1:maskSize(3);
    zFind = find(binaryMask(:,:,zIter))+((maskSize(1)*maskSize(2))*(zIter-1));
    zFindSize = size(zFind,1);
    if zFindSize>0,
        onVoxelIndexList(onVoxelCounter+1:onVoxelCounter+zFindSize,1) = zFind;
    end%if zFindSize>0
    onVoxelCounter = onVoxelCounter + zFindSize;
end%for zIter = 1:maskSize(3);

outputParameters = inputParameters;
outputParameters.maskSize = maskSize;
outputParameters.onVoxelIndexList = onVoxelIndexList;



