function outputParameters=VidaSegmentationGrid(inputParameters)
%previously called MarchGrid1(EXPERIMENT) and MarchGrid3(EXPERIMENT)
%last modified 08/29/07 by Phil Tsai

%-----
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
subBlockFilesFolder = inputParameters.subBlockFilesFolder;
maskSize = inputParameters.maskSize;
sz3D=inputParameters.sz3D;
overlapsz=inputParameters.overlapsz;
stackedFileName = inputParameters.stackedFileName;
blockVariableName = inputParameters.blockVariableName;
dispon = inputParameters.dispon;
%---
% overlap size dictates how much of each block has to overlap with its 3Dneighbor
if size(sz3D,2)==1,
   nx1blks=ceil(maskSize(1)/sz3D); % number of blocks in x1 dim
   nx2blks=ceil(maskSize(2)/sz3D); % number of blocks in x2 dim
   x1sz=fix(((nx1blks-1)*overlapsz+maskSize(1))/nx1blks)+1;
   x2sz=fix(((nx2blks-1)*overlapsz+maskSize(2))/nx2blks)+1;
   x1x2geomean=sqrt(x1sz*x2sz);
   nx3blks=ceil((maskSize(3)-overlapsz)/(x1x2geomean-overlapsz)); %number of blocks in x3 diim
else%if size(sz3D,2)==1,
   nx1blks=ceil(maskSize(1)/sz3D(1)); % number of blocks in x1 dim
   nx2blks=ceil(maskSize(2)/sz3D(2)); % number of blocks in x2 dim
   nx3blks=ceil(maskSize(3)/sz3D(3)); % number of blocks in x3 dim;
end%if size(sz3D,2)==1,
[blockGrid]=VidaGridUpBlock(maskSize,overlapsz,nx1blks,nx2blks,nx3blks);


% load and write each block in blockGrid for tiff iSec
clear blockFileNames;
blockStruct = load(stackedFileName,'imageStack');
blockFieldNames = fieldnames(blockStruct);
imageStack = blockStruct.(blockFieldNames{1});
%-----
channelSubFactor = zeros(1,length(blockGrid));
disp(['Writing ',blockVariableName,'s to folder ',subBlockFilesFolder]);
for iBlk=1:length(blockGrid) %---added by Phil 03/02/07
    blockFileNames{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
    %-----
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(blockFileNames{iBlk},'file'),
        fileExistsFlag = 1;
        fileProps = dir(blockFileNames{iBlk});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(blockFileNames{iBlk},'file'),
    %---

    
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['skipping block ',num2str(iBlk),' - previously completed...']); %---added by Phil 03/02/07
        blockFileNames{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['block ',num2str(iBlk),' of ',num2str(length(blockGrid)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
        % get indices for each block...
        blkii=blockGrid{iBlk};
        blockFileNames{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
        % subBlock=block from image tif
        subBlock = imageStack(blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
        % vascblk=rescaleuint8(single(vascblk));
        % write each partially processed vasc block
        if dispon
            for i=1:size(subBlock,3)
                figure(1);
                colormap gray;
                subBlock(1,1,i)=0;
                subBlock(1,2,i)=vascThresh;
                imagesc(subBlock(:,:,i));drawnow;%pause(.05);
            end%for i=1:size(subBlock,3)
        end%if dispon
%         disp(['writing ',blockFileNames{iBlk},'...']);
        commandString = [blockVariableName,' = single(subBlock);'];
        eval(commandString);
        saveSize = (getfield(whos('blockVariableName'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        commandString = ['save(blockFileNames{iBlk},''',blockVariableName,''',scs);'];
        eval(commandString);
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for iBlk=1:length(blockGrid)

%-----
outputParameters = inputParameters;
outputParameters.blockFileNames=blockFileNames;
outputParameters.blockGrid = blockGrid;
%-----
return


