function outExp = VidaSubBlockReg(inExp)
%last modified 05/08/08 by Phil Tsai

%-----
fileRootName = inExp.globalParameters.fileRootName;
rootDataFolder = inExp.globalParameters.rootDataFolder;
lastRerunStartDateNum = inExp.globalParameters.lastRerunStartDateNum;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
numChannels = 1;
stackedFileNames = inExp.globalParameters.stackedFileNames;
blockVariableNames = {'enhMask','vascBlock'};
cellMaskSize = inExp.globalParameters.cellMaskSize;
%-----
subVolumeSize3D = inExp.subBlockParameters.subVolumeSize3D;              
subVolumeOverlapSize = inExp.subBlockParameters.subVolumeOverlapSize;    
%-----
%-----
subBlockFilesFolder = fullfile(processedDataFolder,'subBlockFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(subBlockFilesFolder);
%-----
displayFlag = 0;
%-----
%DEFINE CHANNEL NAMES
[tempPath,tempFileName,tempExt,tempVer] = fileparts(stackedFileNames{1});
dashPos = findstr(tempFileName,'-');
lastDash = dashPos(end);
% channels.regChannelString = tempFileName(lastDash+1:end);


%-----
% Extract subblocks from .tifs, order, and store pointers to .mat files for vasc data
disp(['Starting Reg Grid Subblocking : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
gridParameters.lastRerunStartDateNum = lastRerunStartDateNum;
gridParameters.subBlockFilesFolder = subBlockFilesFolder;
gridParameters.stackedFileName = stackedFileNames{1};
gridParameters.blockVariableName = blockVariableNames{1};
gridParameters.maskSize = cellMaskSize;
gridParameters.sz3D=subVolumeSize3D;
gridParameters.overlapsz = subVolumeOverlapSize;
gridParameters.dispon = displayFlag;
%-----
    gridParameters = VidaSegmentationGrid(gridParameters);      
%-----
vascEnhMaskBlockGrid = gridParameters.blockGrid;
vascEnhMaskBlockFileNames = gridParameters.blockFileNames;
%---------
gridParameters.stackedFileName = stackedFileNames{2};
gridParameters.blockVariableName = blockVariableNames{2};
gridParameters.maskSize = cellMaskSize;
gridParameters.sz3D=subVolumeSize3D;
gridParameters.overlapsz = subVolumeOverlapSize;
gridParameters.dispon = displayFlag;
%-----
    gridParameters = VidaSegmentationGrid(gridParameters);      
%-----
vascRawDataBlockGrid = gridParameters.blockGrid;
vascRawDataBlockFileNames = gridParameters.blockFileNames;
%---------

outExp = inExp;
% outExp.globalParameters.channels = channels;
%---
outExp.globalParameters.blockGrid = vascEnhMaskBlockGrid;
outExp.globalParameters.subVolumeOverlapSize = subVolumeOverlapSize;
outExp.globalParameters.vascEnhancedMaskFileNames = vascEnhMaskBlockFileNames;
outExp.globalParameters.vascRawMaskFileNames = vascEnhMaskBlockFileNames;
outExp.globalParameters.vascBlockFileNames = vascRawDataBlockFileNames;
outExp.vascSegParameters.vascRodFilterParameters.vascEnhancedFileNames = vascEnhMaskBlockFileNames;
outExp.completionDates.subBlockCompletionDate = datestr(now);
%---
%---
return


