function outputParameters=VidaVascGaussianFilteredRatioSeg(inputParameters)
%-----      
fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
%---
smallFilterSizeList = inputParameters.smallFilterSizeList;
ratioDenominatorEpsilon = inputParameters.ratioDenominatorEpsilon;
filterSizeDifference = inputParameters.filterSizeDifference;
ratioThreshold = inputParameters.ratioThreshold;
%-----
minVolForSmallVolRemoval = inputParameters.minVolForSmallVolRemoval;
postCleanUpCloseDiameter = inputParameters.postCleanUpCloseDiameter;
%---
displayFlag = inputParameters.displayFlag;
saveFlag = inputParameters.saveFlag;


% blockOverlapSize = 40
% halfOverlapSize = floor(blockOverlapSize/2);


smallFilterSizeList = [5,11,21,31];% [5,11,21,31,41,151];
filterSizeDifference = 2;
ratioDenominatorEpsilon = 10;
ratioThreshold = 1.1;
lowThreshold = 0.99;
bigVesselIntensityFraction = 0.20;
numCleanupCycles = 10;
minVolForCleanup = 11;
postCleanUpCloseDiameter = 5;


%---
enhancedVolumeFileNames=inputParameters.vascEnhancedFileNames;
%-----
for i=1:length(enhancedVolumeFileNames)
  [pathName,fileName,ext] = fileparts(enhancedVolumeFileNames{i});
  enhancedMaskFileNames{i} = fullfile(vascSegFilesFolder,[fileName,'-enhMask.mat']);
  rawMaskFileNames{i} = fullfile(vascSegFilesFolder,[fileName,'-rawMask.mat']);
  enhMaskBinarizeDetailsFileNames{i} = fullfile(vascSegFilesFolder,[fileName,'-enhBinDetails.mat']);
end
%-----
numBlocks = length(enhancedMaskFileNames);
vethresh = cell(1,numBlocks);
enhancedFraction = cell(1,numBlocks);
filterKernel = ones(3,3,3)./27;
%-----
for blockIter=1:numBlocks,
    disp(['Vasc Filtered Ratio Seg of Enhanced subvolume ',num2str(blockIter),' of ',num2str(length(enhancedVolumeFileNames)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
    %-----
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(enhancedMaskFileNames{blockIter},'file'),
        fileExistsFlag = 1;
        fileProps = dir(enhancedMaskFileNames{blockIter});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(vasctempmaskfnames{blockIter},'file'),
    %---
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp('...Skipping-Previously calculated');
        load(enhMaskBinarizeDetailsFileNames{blockIter},'vethresh','enhancedFraction');
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        load(enhancedVolumeFileNames{blockIter},'vascvolenhanced','-mat');
        %-----
% % %         numFilters = length(smallFilterSizeList);
% % %         middleSumImage = vascvolenhanced.*0;
% % %         smallFilteredVolume = vascvolenhanced;
% % %         largeFilteredVolume = vascvolenhanced;
% % %         smallFilterRepCounter = 0;
% % %         largeFilterRepCounter = 0;
% % %         for filterIter = 1:numFilters,
% % %             smallFilterReps = smallFilterSizeList(filterIter) - smallFilterRepCounter;
% % %             largeFilterReps = round(smallFilterSizeList(filterIter)*filterSizeDifference) - largeFilterRepCounter;
% % %             for roundIter = 1:smallFilterReps,
% % %                 smallFilteredVolume = imfilter(smallFilteredVolume,filterKernel,'replicate');
% % %                 smallFilterRepCounter = smallFilterRepCounter + 1;
% % %             end
% % %             for roundIter = 1:largeFilterReps,
% % %                 largeFilteredVolume = imfilter(largeFilteredVolume,filterKernel,'replicate');
% % %                 largeFilterRepCounter = largeFilterRepCounter + 1;
% % %             end
% % %             ratioImage = (smallFilteredVolume./(max(largeFilteredVolume,ratioDenominatorEpsilon)));
% % % 
% % %             middleSumImage = middleSumImage+ratioImage;
% % %         end%for filterIter = 1:numFilters,
% % %   
% % %         middleSumImage = middleSumImage./numFilters;
% % %         %-----
% % % 
% % %         enhMask = middleSumImage>ratioThreshold;


        %-----
        vascvolenhanced = vascvolenhanced - min(vascvolenhanced(:));
        numFilters = length(smallFilterSizeList);
        smallFilteredVolume = vascvolenhanced;
        maxImage = vascvolenhanced.*0;
        lowMask = vascvolenhanced.*0;
        largeFilteredVolume = vascvolenhanced;
        smallFilterRepCounter = 0;
        largeFilterRepCounter = 0;
        for filterIter = 1:numFilters,
            smallFilterReps = smallFilterSizeList(filterIter) - smallFilterRepCounter;
            largeFilterReps = round(smallFilterSizeList(filterIter)*filterSizeDifference) - largeFilterRepCounter;
            for roundIter = 1:smallFilterReps,
                smallFilteredVolume = imfilter(smallFilteredVolume,filterKernel,'replicate');
                smallFilterRepCounter = smallFilterRepCounter + 1;
            end
            for roundIter = 1:largeFilterReps,
                largeFilteredVolume = imfilter(largeFilteredVolume,filterKernel,'replicate');
                largeFilterRepCounter = largeFilterRepCounter + 1;
            end
            ratioImage = (smallFilteredVolume./(max(largeFilteredVolume,ratioDenominatorEpsilon)));
            lowMask = or(lowMask,ratioImage<lowThreshold);
            maxImage = max(maxImage,ratioImage.*~lowMask);
        end%for filterIter = 1:numFilters,
        %-----
        smallVesselMask = maxImage>ratioThreshold;
        bigVesselMask = vascvolenhanced > (max(vascvolenhanced(:)) * bigVesselIntensityFraction);
%         enhMask = or(smallVesselMask,bigVesselMask);
%         maketiff(enhMask,'enhMask.tif');
enhMask = smallVesselMask;

        maketiff(smallVesselMask,'smallVesselMask.tif');
        maketiff(bigVesselMask,'bigVesselMask.tif');
        




        
        vethresh{blockIter} = ratioThreshold;
        enhancedFraction{blockIter} = sum(enhMask(:))./numel(enhMask);
        %----------
        %----------
        %Eliminate contiguous 6-connected regions of size  [minVolForSmallVolRemoval] or less
        L=bwlabeln(enhMask,6);
        stmp=regionprops(L,'Area');
        LUT=[0,[stmp.Area]>=minVolForSmallVolRemoval];
        L=LUT(L+1);
        enhMask = L>0;
        %-----
        %Run multiple iterations of a convexify-ing routine.
        %   Remove pixels "hairs" that have fewer than [minVol] of 26-connected neighbors.
        %   but also add any pixels that are more than [minVol] of 26-connected neighbors.
        % 

     
keepGoing = 1;        
minVolForCleanup = 13

sumValHistory = zeros(1,1000)-1;
counter = 0;

while keepGoing
%         for cleanIter = 1:numCleanupCycles,
            counter = counter+1;
            oldMask = enhMask;
            filtMask = imfilter(double(enhMask),ones(3,3,3),'replicate');
            enhMask = filtMask>=minVolForCleanup;
            oldSum = sum(oldMask(:));
            currentSum = sum(enhMask(:));
            keepGoing = oldSum~=currentSum;
            sumValHistory(counter) = currentSum;
            if length(find(sumValHistory==currentSum)) > 10, keepGoing = 0 ; end
end
%         end%for cleanIter = 1:numCleanupCycles,
        %-----
        %Close the Mask
        enhMask = imclose(enhMask,circle3d(postCleanUpCloseDiameter));

  
        
        saveSize = (getfield(whos('vethresh'),'bytes')>0.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(enhMaskBinarizeDetailsFileNames{blockIter},'vethresh','enhancedFraction',scs);
        saveSize = (getfield(whos('enhMask'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(enhancedMaskFileNames{blockIter},'enhMask',scs);

        rawMask = enhMask;
        saveSize = (getfield(whos('rawMask'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(rawMaskFileNames{blockIter},'rawMask',scs');
        
        
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for blockIter=1:length(vascBlockFileNames)


outputParameters = inputParameters;

outputParameters.smallFilterSizeList = smallFilterSizeList;
outputParameters.filterSizeDifference = filterSizeDifference;
outputParameters.ratioDenominatorEpsilon = ratioDenominatorEpsilon;
outputParameters.ratioThreshold = ratioThreshold;
outputParameters.lowThreshold = lowThreshold;
outputParameters.bigVesselIntensityFraction = bigVesselIntensityFraction;
outputParameters.numCleanupCycles = numCleanupCycles;
outputParameters.postCleanUpCloseDiameter = postCleanUpCloseDiameter;
outputParameters.minVolForCleanup = minVolForCleanup;


outputParameters.vascEnhancedThresh = vethresh;
outputParameters.enhancedFraction = enhancedFraction;
outputParameters.enhancedMaskFileNames = enhancedMaskFileNames;
outputParameters.rawMaskFileNames = rawMaskFileNames;

