function outputParameters=VidaVascSegmentationGrid(inputParameters)
%previously called MarchGrid1(EXPERIMENT) and MarchGrid3(EXPERIMENT)
%last modified 08/29/07 by Phil Tsai

%-----
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
vascMaskSize = inputParameters.vascMaskSize;
useTifStorageFlag = inputParameters.useTifStorageFlag;
vascThresh = inputParameters.vascThresh;
sz3D=inputParameters.sz3D;
overlapsz=inputParameters.overlapsz;
vascFileName = inputParameters.vascFileName;
dispon = inputParameters.dispon;
%---
stackedVascSize=vascMaskSize;
cellBlockFileNames = inputParameters.cellBlockFileNames;
cellBlockMaskFileNames = inputParameters.cellBlockMaskFileNames;
channelSubtractVesselUsingCellMaskFlag = inputParameters.channelSubtractVesselUsingCellMaskFlag;
shiftAlignFlag = inputParameters.shiftAlignFlag;
channelSubFactorList = inputParameters.channelSubFactorList;
channelSubFitPolynomialDegree = inputParameters.channelSubFitPolynomialDegree;
channelSubMaskSubSample = inputParameters.channelSubMaskSubSample;
channelSubNonMaskSubSample = inputParameters.channelSubNonMaskSubSample;
            

%---
% overlap size dictates how much of each block has to overlap with its 3Dneighbor
if size(sz3D,2)==1,
   nx1blks=ceil(stackedVascSize(1)/sz3D); % number of blocks in x1 dim
   nx2blks=ceil(stackedVascSize(2)/sz3D); % number of blocks in x2 dim
   x1sz=fix(((nx1blks-1)*overlapsz+stackedVascSize(1))/nx1blks)+1;
   x2sz=fix(((nx2blks-1)*overlapsz+stackedVascSize(2))/nx2blks)+1;
   x1x2geomean=sqrt(x1sz*x2sz);
   nx3blks=ceil((stackedVascSize(3)-overlapsz)/(x1x2geomean-overlapsz)); %number of blocks in x3 diim
else%if size(sz3D,2)==1,
   nx1blks=ceil(stackedVascSize(1)/sz3D(1)); % number of blocks in x1 dim
   nx2blks=ceil(stackedVascSize(2)/sz3D(2)); % number of blocks in x2 dim
   nx3blks=ceil(stackedVascSize(3)/sz3D(3)); % number of blocks in x3 dim;
end%if size(sz3D,2)==1,
[vascGrid]=VidaGridUpBlock(stackedVascSize,overlapsz,nx1blks,nx2blks,nx3blks);


% load and write each block in vascGrid for tiff iSec
clear blockFileNames;
if useTifStorageFlag == 0,
    load(vascFileName,'tiledStack');
end%if useTifStorageFlag == 0,
channelSubFactor = zeros(1,length(vascGrid));
for iBlk=1:length(vascGrid) %---added by Phil 03/02/07
    blockFileNames{iBlk}=fullfile(vascSegFilesFolder,['vasc-block-v2-',num2str(iBlk),'.mat']);
    %-----
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(blockFileNames{iBlk},'file'),
        fileExistsFlag = 1;
        fileProps = dir(blockFileNames{iBlk});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(blockFileNames{iBlk},'file'),
    %---
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['skipping block ',num2str(iBlk),' - previously completed...']); %---added by Phil 03/02/07
        blockFileNames{iBlk}=fullfile(vascSegFilesFolder,['vasc-block-v2-',num2str(iBlk),'.mat']);
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        disp(['block ',num2str(iBlk),' of ',num2str(length(vascGrid)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
        % get indices for each block...
        blkii=vascGrid{iBlk};
        blockFileNames{iBlk}=fullfile(vascSegFilesFolder,['vasc-block-v2-',num2str(iBlk),'.mat']);
        % subBlock=block from tiled tif
        if useTifStorageFlag == 1,
            subBlock=VidaTiffCycleRead(vascFileName,blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
        else%if useTifStorageFlag == 1,
            subBlock = tiledStack(blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
        end%if useTifStorageFlag == 1,
        

        %If Desired, Perform Channel Subtraction of the Cell signal from
        %the vessel data using the previously computed cell masks.
        channelSubFactor(iBlk) = 0;
        if channelSubtractVesselUsingCellMaskFlag == 1,
            disp(['Channel Subtracting Block using Cell Mask: ',datestr(now,'mm/dd/yy HH:MM:SS')])
            channelSubParameters.cellBlockFileName = cellBlockFileNames{iBlk};
            channelSubParameters.cellBlockMaskFileName = cellBlockMaskFileNames{iBlk};
            channelSubParameters.channelSubFactorList = channelSubFactorList;
            channelSubParameters.channelSubFitPolynomialDegree = channelSubFitPolynomialDegree;
            channelSubParameters.channelSubMaskSubSample =channelSubMaskSubSample;
            channelSubParameters.channelSubNonMaskSubSample = channelSubNonMaskSubSample;
            [subBlock,channelSubParameters] = VidaChannelSubVesselOnCellMask(subBlock,channelSubParameters);
            channelSubFactor(iBlk) = channelSubParameters.subtractionFactor;
        end
        
        subBlock=single(subBlock);
        % vascblk=rescaleuint8(single(vascblk));
        % write each partially processed vasc block
        if dispon
            for i=1:size(subBlock,3)
                figure(1);
                colormap gray;
                subBlock(1,1,i)=0;
                subBlock(1,2,i)=vascThresh;
                imagesc(subBlock(:,:,i));drawnow;%pause(.05);
            end%for i=1:size(subBlock,3)
        end%if dispon
        disp(['writing ',blockFileNames{iBlk},'...']);
        vascblk= subBlock;
        saveSize = (getfield(whos('vascblk'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(blockFileNames{iBlk},'vascblk',scs);
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for iBlk=1:length(vascGrid)

%-----
outputParameters = inputParameters;
outputParameters.stackedVascSize=stackedVascSize;
outputParameters.gridVascFileNames=blockFileNames;
outputParameters.vascGrid = vascGrid;
outputParameters.channelSubFactor = channelSubFactor;
%-----
return


