function outProject = VidaRegisteredProcessStitchCenterlineStrandify(inProject)

vidaProject = inProject;
vidaProjectFileName = vidaProject.vidaProjectFileName;
vidaProjectRootName = vidaProject.vidaProjectRootName;
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
globalParameters = vidaProject.globalParameters;
registrationParameters = vidaProject.registrationParameters;
strandifyParameters = vidaProject.strandifyParameters;
registeredFilesFolder = globalParameters.registeredFilesFolder;
voxelSizeInMicrons = globalParameters.voxelSizeInMicrons;
%-----
registrationParameters.vidaProjectRootFolder = vidaProjectRootFolder;
registrationParameters.voxelSizeInMicrons = voxelSizeInMicrons;

%-----
%Create a subFolder for stitched volumes
stitchedFilesFolder = fullfile(registeredFilesFolder,'StitchedFilesFolder');
globalParameters.stitchedFilesFolder = stitchedFilesFolder;
vidaProject.globalParameters = globalParameters;
if ~exist(stitchedFilesFolder,'dir'),
    mkdir(stitchedFilesFolder);
end
    

%STAGE 1 : Stitch processed image stacks in global coordinate system
%-----
disp('Stitching Registered Vasc Grayscale');
if isfield(globalParameters,'registeredVascGrayscaleFileName') && exist(globalParameters.registeredVascGrayscaleFileName,'file')
    disp('registeredVascGrayscaleFileName previously stitched.  Skipping.');
else%isfield(vidaProject,'registeredMultStackVascGrayscaleFileName') &&...
    registeredVariableName = 'registeredVascGrayscale';
    stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
    registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascGrayscaleFileNameList;
    registrationParameters.registeredVariableName = registeredVariableName;
    registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
        registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
    globalParameters.registeredVascGrayscaleFileName = registrationParameters.stackedMatFileName;
    vidaProject.globalParameters = globalParameters;
    vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if ~isfield(vidaProject,'registeredMultStackVascGrayscaleFileName') && ...
%-----
disp('Stitching Registered Vasc Enhanced Grayscale');
if isfield(globalParameters,'registeredVascEnhancedGrayscaleFileName') && exist(globalParameters.registeredVascEnhancedGrayscaleFileName,'file')
    disp('RegisteredVascEnhancedGrayscaleFileName previously stitched.  Skipping.');
else%isfield(vidaProject,'registeredVascEnhancedGrayscaleFileName') &&...
    registeredVariableName = 'registeredVascEnhancedGrayscale';
    stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
    registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascEnhancedGrayscaleFileNameList;
    registrationParameters.registeredVariableName = registeredVariableName;
    registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
        registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
    globalParameters.registeredVascEnhancedGrayscaleFileName = registrationParameters.stackedMatFileName;
    vidaProject.globalParameters = globalParameters;
    vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if ~isfield(vidaProject,'registeredVascEnhancedGrayscaleFileName') &&...    
%-----
disp('Stitching Registered Vasc Enhanced Masks');
if isfield(globalParameters,'registeredVascEnhancedMaskFileName') && exist(globalParameters.registeredVascEnhancedMaskFileName,'file')
    disp('RegisteredVascEnhancedMaskFileName previously stitched.  Skipping.');
else%isfield(vidaProject,'registeredVascEnhancedMaskFileName') &&...
    registeredVariableName = 'registeredVascEnhancedMask';
    stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
    registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascEnhancedMaskFileNameList;
    registrationParameters.registeredVariableName = registeredVariableName;
    registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
        registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
    globalParameters.registeredVascEnhancedMaskFileName = registrationParameters.stackedMatFileName;
    vidaProject.globalParameters = globalParameters;
    vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if ~isfield(vidaProject,'registeredVascEnhancedMaskFileName') &&...    
%-----
disp('Stitching Registered Vasc Radius Maps');
if isfield(globalParameters,'registeredVascRadiusMapFileName') && exist(globalParameters.registeredVascRadiusMapFileName,'file')
    disp('RegisteredVascReconstructedMaskFileName previously stitched.  Skipping.');
else%if isfield(globalParameters,'registeredVascRadiusMapFileName') &&..
    registeredVariableName = 'registeredVascRadiusMap';
    stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
    registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascRadiusMapFileNameList;
    registrationParameters.registeredVariableName = registeredVariableName;
    registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
        registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
    globalParameters.registeredVascRadiusMapFileName = registrationParameters.stackedMatFileName;
    vidaProject.globalParameters = globalParameters;
    vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        vidaProject = VidaReconstructVascFromRadii(vidaProject);
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if isfield(globalParameters,'registeredVascRadiusMapFileName') &&.. 
%-----


vidaProject = VidaReconstructVascFromRadii(vidaProject);




%STAGE 2 : Rerun Centerline and Reconstruction Steps on Montaged Datasets

fprintf('\n\n\n\n\n');
disp(['Start Processing of Registered Mask : ',datestr(now,'mm-dd-yy,HH:MM.SS')]);
fprintf('\n\n');
currentImageStackFolderName = vidaProject.imageStackFolderNameList{end};
%-----
registeredExperiment = vidaProject.experimentTemplate;
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
vidaProjectRootName = vidaProject.vidaProjectRootName;
rootCodeFolder = registeredExperiment.codeFolders.rootCodeFolder;
registeredVascReconstructedMaskFileName = vidaProject.globalParameters.registeredVascReconstructedMaskFileName;
registeredVascGrayscaleFileName = vidaProject.globalParameters.registeredVascGrayscaleFileName;
registeredStackSize = vidaProject.globalParameters.registeredStackSize;
%-----
%Set up internal folder and file names
fileRootName = [vidaProjectRootName,'-Reg'];
rootDataFolder = registeredFilesFolder;
originalDataFolder = rootDataFolder;
processedDataFolder = rootDataFolder;
intermediateResultsFolder = rootDataFolder;
registeredExperiment.globalParameters.fileRootName = fileRootName;
registeredExperiment.globalParameters.rootDataFolder = rootDataFolder;
registeredExperiment.globalParameters.originalDataFolder = originalDataFolder;
registeredExperiment.globalParameters.processedDataFolder = processedDataFolder;
registeredExperiment.globalParameters.intermediateResultsFolder = intermediateResultsFolder;


registeredExperimentFileName = fullfile(registeredExperiment.globalParameters.processedDataFolder,[fileRootName,'-Experiment.mat']);
%-----
registeredExperiment.globalParameters.vidaProjectRootFolder = vidaProjectRootFolder;
registeredExperiment.globalParameters.vidaProjectRootName = vidaProjectRootName;
registeredExperiment.globalParameters.fileRootName = fileRootName;
registeredExperiment.globalParameters.registeredExperimentFileName = registeredExperimentFileName;
registeredExperiment.globalParameters.rootDataFolder = rootDataFolder;
registeredExperiment.globalParameters.originalDataFolder = originalDataFolder;
registeredExperiment.globalParameters.processedDataFolder = processedDataFolder;
registeredExperiment.globalParameters.intermediateResultsFolder = intermediateResultsFolder;
registeredExperiment.globalParameters.fullStackSize = registeredStackSize;
% % % registeredExperiment.centerlineEnhancedByConnectivityParameters.preCloseDiameter = 7;%noteToSelf
% % % registeredExperiment.subBlockParameters.subVolumeSize3D = 200;%noteToSelf

registeredExperiment.globalParameters.registeredVascGrayscaleFileName = registeredVascGrayscaleFileName;
registeredExperiment.globalParameters.registeredVascReconstructedMaskFileName = registeredVascReconstructedMaskFileName;
registeredExperiment.globalParameters.vascEnhancedMaskFileName = registeredVascReconstructedMaskFileName;
registeredExperiment.globalParameters.channels.vascChannelString = 'FITC';
%----------
registeredExperiment.globalParameters.lastRerunStartDateNum = now()-5000;
registeredExperiment.globalParameters.stackedFileNameList = {registeredVascReconstructedMaskFileName,registeredVascGrayscaleFileName};
%--------------------------------------------------------------------------
%If already exists, load previously created registeredExperiment file
if exist(registeredExperimentFileName,'file'),
    load(registeredExperimentFileName,'registeredExperiment');
else%if exist(registeredExperimentFileName,'file'),
    registeredExperiment.completionDates.initializedDate = datestr(now);
    registeredExperiment.progressFlags.initalized = 1; 
end%if-else exists(registeredExperimentFileName,'file'),
%-----
%Save Experiment file and a backup
saveSize = (getfield(whos('registeredExperiment'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(registeredExperimentFileName,'registeredExperiment',scs);
preMatRoot = registeredExperimentFileName(1:findstr(registeredExperimentFileName,'.mat')-1);
saveSize = (getfield(whos('registeredExperiment'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save([preMatRoot,'Backup',datestr(now,'mmddyy-HHMM'),'.mat'],'registeredExperiment',scs);
%----------
%SET UP STAGES FOR RUNNING
stageParameters.regVascSubBlock.currentStageString = 'RegisteredSubBlock';
stageParameters.regVascSubBlock.dataStructureVariableName = 'registeredExperiment';
stageParameters.regVascSubBlock.dataStructureFileName = registeredExperimentFileName;
stageParameters.regVascSubBlock.mainFunctionCallString = 'VidaSubBlockReg';
%-----
stageParameters.regVascCenterline.currentStageString = 'RegisteredVascCenterline';
stageParameters.regVascCenterline.dataStructureVariableName = 'registeredExperiment';
stageParameters.regVascCenterline.dataStructureFileName = registeredExperimentFileName;
stageParameters.regVascCenterline.mainFunctionCallString = 'VidaCenterline';
%-----
stageParameters.regVascRadii.currentStageString = 'RegisteredVascRadii';
stageParameters.regVascRadii.dataStructureVariableName = 'registeredExperiment';
stageParameters.regVascRadii.dataStructureFileName = registeredExperimentFileName;
stageParameters.regVascRadii.mainFunctionCallString = 'VidaVascRadii';
%-----
stageParameters.regStrandify.currentStageString = 'RegisteredVascStrandify';
stageParameters.regStrandify.dataStructureVariableName = 'registeredExperiment';
stageParameters.regStrandify.dataStructureFileName = registeredExperimentFileName;
stageParameters.regStrandify.mainFunctionCallString = 'VidaStrandify';
%-----
stageParameters.regCellCentroidMerge.currentStageString = 'registeredCellCentroidMerge';
stageParameters.regCellCentroidMerge.dataStructureVariableName = 'registeredExperiment';
stageParameters.regCellCentroidMerge.dataStructureFileName = registeredExperimentFileName;
stageParameters.regCellCentroidMerge.mainFunctionCallString = 'VidaMultiStackMergeCellCentroids';
%-----



%RUN UNCOMPLETED STAGES
disp(['RootDataFolder = ',rootDataFolder]);
disp(['FileRootName = ',fileRootName]);
[registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regVascSubBlock);
[registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regVascCenterline);
[registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regVascRadii);
vascRadiusMapFileName = registeredExperiment.globalParameters.vascRadiusMapFileName;
%-----
registeredCellCentroidAndLabelList = [];
if isfield(registeredExperiment.globalParameters,'cellCentroidAndLabelList')
        [registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regCellCentroidMerge);%noteToSelf
    registeredCellCentroidAndLabelList = registeredExperiment.globalParameters.cellCentroidAndLabelList;%noteToSelf
end%if isfield...
%-----
load(vascRadiusMapFileName,'vascRadiusMap');
centerlineRadiusStructure = vascRadiusMap;
%-----
registeredExperiment.strandifyParameters = strandifyParameters;
registeredExperiment.globalParameters.centerlineRadiusStructure = centerlineRadiusStructure;
    [registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regStrandify);
centerlineRadiusStructure = registeredExperiment.globalParameters.centerlineRadiusStructure;
vectorizedStructure = registeredExperiment.globalParameters.vectorizedStructure;



disp([' ';' ';' ']);
disp(['Completed Processing of Registered Mask : ',datestr(now)]);
disp([' ';' ';' ']);
%----

vidaProject.registeredExperiment = registeredExperiment;
saveSize = (getfield(whos('registeredExperiment'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(registeredExperimentFileName,'registeredExperiment',scs);
vidaProject.globalParameters.centerlineRadiusStructure = centerlineRadiusStructure;
vidaProject.globalParameters.vectorizedStructure = vectorizedStructure;

outProject = vidaProject;
