
trace250 = loadmovie('trace250.tif');
trace270 = loadmovie('trace270.tif');
trace290 = loadmovie('trace290.tif');
trace310 = loadmovie('trace310.tif');
trace330 = loadmovie('trace330.tif');

trace250 = imerode(trace250(1:545,1:551),ones(3,3));
trace270 = imerode(trace270(1:545,1:551),ones(3,3));
trace290 = imerode(trace290(1:545,1:551),ones(3,3));
trace310 = imerode(trace310(1:545,1:551),ones(3,3));
trace330 = imerode(trace330(1:545,1:551),ones(3,3));


halfMaskSize = [545 551 832];
halfMask = false(halfMaskSize);

for k = 241:260
    halfMask(:,:,k) = trace250;
end
%-----
for k = 261:280
    halfMask(:,:,k) = trace270;
end
%-----
for k = 281:300
    halfMask(:,:,k) = trace290;
end
%-----
for k = 301:320
    halfMask(:,:,k) = trace310;
end
%-----
for k = 321:340
    halfMask(:,:,k) = trace330;
end
%-----
halfMask(:,:,1) = 0;
halfMask(:,:,end) = 0;
halfMask(:,1,:) = 0;
halfMask(:,end,:) = 0;
halfMask(1,:,:) = 0;
halfMask(end,:,:) = 0;

tic
L = bwlabeln(halfMask>0);
toc

numBarrels = max(L(:));
for k = 1:numBarrels,
    thisBarrel = L==k;
    topFrame = double(thisBarrel(:,:,1));
    bottomFrame = double(thisBarrel(:,:,1));
    topFrame(:) = inf;
    bottomFrame(:) = 0;
    tempTopFrame = topFrame;
    tempBottomFrame = bottomFrame;
    for z = 200:400,
        thisFrame = thisBarrel(:,:,z);
        tempTopFrame(:)=inf;
        tempBottomFrame(:) = 0;
        tempTopFrame(thisFrame>0) = z;
        tempBottomFrame(thisFrame>0) = z;
        topFrame = min(topFrame,tempTopFrame);
        bottomFrame = max(bottomFrame,tempBottomFrame);
    end
end

numBarrels = max(L(:));
for k = 1:numBarrels,
    thisBarrel = L==k;
    topPlane = inf;
    bottomPlane = 0;
    for z = 200:400,
        thisFrame = thisBarrel(:,:,z);
        if max(thisFrame(:))>0,
            topPlane = min(topPlane,z);
            bottomPlane = max(bottomPlane,z);
        end
    end
    topFrame = thisBarrel(:,:,topPlane);
    bottomFrame = thisBarrel(:,:,bottomPlane);
    topFrame = topFrame - imerode(topFrame,ones(3,3,3));
    bottomFrame = bottomFrame - imerode(bottomFrame,ones(3,3,3));
    [topy,topx] = ind2sub(size(topFrame),find(topFrame>0));
    [boty,botx] = ind2sub(size(bottomFrame),find(bottomFrame>0));
    barrels(k).top = [topy,topx,repmat(topPlane,[numel(topy),1])]*2;
    barrels(k).bottom = [boty,botx,repmat(bottomPlane,[numel(boty),1])]*2;

end

testMask = false(size(halfMask));
for k = 1:numBarrels,
    top = barrels(k).top;
    bot = barrels(k).bottom;
    topList = sub2ind(size(testMask),top(:,1)/2,top(:,2)/2,top(:,3)/2);
    botList = sub2ind(size(testMask),bot(:,1)/2,bot(:,2)/2,bot(:,3)/2);
    testMask(topList) = 1;
    testMask(botList) = 1;
end

    
    





