%Calculate Cell Density against barrel locations
%Preload vidaProject and barrel hand-trace file
%Assumes Z-axis is the depth into brain.  If data is taken at a different
%orintation, then the data must be permuted so that [axis1, axis2, axis3]
%represents [horizontalDim1, horizontalDim2, depthIntoBrain]



cellCentroidAndLabelList = vectorProject.cellCentroidAndLabelList;
maskSize = vectorProject.maskSize;
allVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
allRadii = vectorProject.vectorizedStructure.Vertices.AllRadii;
%%
userTraced = [];
for barrelIter = 1:numel(barrels)
    userTraced{barrelIter} = barrels(barrelIter).userTraced;
end

% clear barrels

%%
numBarrels = numel(userTraced);
for barrelIter = 1:numBarrels,
    barrelPoints = userTraced{barrelIter}.top;
    diffFlag = sum(abs(diff(barrelPoints)),2)>0;
    barrelPoints = barrelPoints(diffFlag,:);
    barrelPoints(end+1,:) = barrelPoints(1,:);
    barrelCoordList = [];
    for pointIter = 1:size(barrelPoints,1)-1;
        startCoord = barrelPoints(pointIter,:);
        stopCoord = barrelPoints(pointIter+1,:);
        coordDiff = stopCoord-startCoord;
        longestSep = max(abs(coordDiff));
        numInterpPoints = ceil(longestSep)+1;
        cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
        cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
        cc3 = linspace(startCoord(3),stopCoord(3),numInterpPoints);
        lineCoords = round([cc1',cc2',cc3']);
        barrelCoordList = [barrelCoordList;lineCoords];
    end%for pointIter...
    figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
end%for barrelIter...
        
%---

for barrelIter = 1:numBarrels,
    barrelPoints = userTraced{barrelIter}.bottom;
    diffFlag = sum(abs(diff(barrelPoints)),2)>0;
    barrelPoints = barrelPoints(diffFlag,:);
    barrelPoints(end+1,:) = barrelPoints(1,:);
    barrelCoordList = [];
    for pointIter = 1:size(barrelPoints,1)-1;
        startCoord = barrelPoints(pointIter,:);
        stopCoord = barrelPoints(pointIter+1,:);
        coordDiff = stopCoord-startCoord;
        longestSep = max(abs(coordDiff));
        numInterpPoints = ceil(longestSep)+1;
        cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
        cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
        cc3 = linspace(startCoord(3),stopCoord(3),numInterpPoints);
        lineCoords = round([cc1',cc2',cc3']);
        barrelCoordList = [barrelCoordList;lineCoords];
    end%for pointIter...
    figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'b.');hold on
end%for barrelIter...
           

%%
myFrame = zeros(maskSize(1),maskSize(2));
barrels = [];
numBarrels = numel(userTraced);
for barrelIter = 1:numBarrels,
    barrelPoints = userTraced{barrelIter}.top;
    diffFlag = sum(abs(diff(barrelPoints)),2)>0;
    barrelPoints = barrelPoints(diffFlag,:);
    barrelPoints(end+1,:) = barrelPoints(1,:);
    barrelCoordList = zeros(100000,3);
    barrelZ1 = round(min(barrelPoints(:,3)));
    barrelBottom = userTraced{barrelIter}.bottom;
    barrelZ2 = round(max(barrelBottom(:,3)));
    counter = 0;
    for pointIter = 1:size(barrelPoints,1)-1;
        startCoord = barrelPoints(pointIter,:);
        stopCoord = barrelPoints(pointIter+1,:);
        coordDiff = stopCoord-startCoord;
        longestSep = max(abs(coordDiff));
        numInterpPoints = ceil(longestSep)+1;
        cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
        cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
        numCC = numel(cc1);
        for zIter = barrelZ1:barrelZ2,
            cc3 = zeros(size(cc2))+zIter;
            lineCoords = round([cc1',cc2',cc3']);
            barrelCoordList(counter+1:counter+numCC,:) = lineCoords;
            counter = counter+numCC;
        end%for zIter... 
    end%for pointIter...
    barrelCoordList = barrelCoordList(1:counter,:);
    barrels{barrelIter} = barrelCoordList;
    figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
    pixelList = sub2ind([maskSize(1),maskSize(2)],barrelCoordList(:,1),barrelCoordList(:,2));
    myFrame(pixelList)=1;
end%for barrelIter...
hold off
figure(2);imagesc(myFrame)
fillFrame = imfill(myFrame,'holes');
figure(3);imagesc(fillFrame)


vectorProject.barrels = barrels;



%%

maskSize = co.maskSize;
myFrame = zeros(maskSize(1),maskSize(2));
numBarrels = numel(barrels)
for barrelIter = 1:numBarrels,
   
    barrelCoordList = barrels{barrelIter}
    figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
    pixelList = sub2ind([maskSize(1),maskSize(2)],barrelCoordList(:,1),barrelCoordList(:,2));
    myFrame(pixelList)=1;
end%for barrelIter...
hold off
figure(2);imagesc(myFrame)
fillFrame = imfill(myFrame,'holes');
figure(3);imagesc(fillFrame)




