function outExp = VidaCellCentroid(inExp)
%last modified 08/27/07 by Phil Tsai

%-----
fileRootName = inExp.globalParameters.fileRootName;
lastRerunStartDateNum = inExp.globalParameters.lastRerunStartDateNum;
rootDataFolder = inExp.globalParameters.rootDataFolder;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
cellMaskFileName = inExp.globalParameters.cellMaskFileName;
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
%-----
cellCentroidSubBlockSizeYInMicrons = inExp.cellCentroidParameters.cellCentroidSubBlockSizeYInMicrons;
cellCentroidSubBlockBufferSizeYInMicrons = inExp.cellCentroidParameters.cellCentroidSubBlockBufferSizeYInMicrons;
cellCentroidMergeDistanceInMicrons = inExp.cellCentroidParameters.cellCentroidMergeDistanceInMicrons;  
%-----
cellCentroidSubBlockSizeY = round(cellCentroidSubBlockSizeYInMicrons ./ voxelSizeInMicrons);
cellCentroidSubBlockBufferSizeY = round(cellCentroidSubBlockBufferSizeYInMicrons ./ voxelSizeInMicrons);
cellCentroidMergeDistance = round(cellCentroidMergeDistanceInMicrons ./ voxelSizeInMicrons);

%-----
cellCentroidFilesFolder = fullfile(processedDataFolder,'CellCentroidFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(cellCentroidFilesFolder);








% Compute cell centroids from binary mask--disambiguates via distance transform
% and display and write an .avi after computing the cell centroid
% locations.
disp(['Finding First Pass Cell Centroids : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
firstPassCentroidParameters.lastRerunStartDateNum = lastRerunStartDateNum;
firstPassCentroidParameters.intermediateResultsFolder = intermediateResultsFolder;
firstPassCentroidParameters.cellCentroidFilesFolder = cellCentroidFilesFolder;
firstPassCentroidParameters.cellMaskFileName = cellMaskFileName;
firstPassCentroidParameters.cellCentroidSubBlockSizeY=cellCentroidSubBlockSizeY;
firstPassCentroidParameters.cellCentroidSubBlockBufferSizeY=cellCentroidSubBlockBufferSizeY;
    firstPassCentroidParameters = VidaGetCentroidsFromMask(firstPassCentroidParameters);    
cellCentroidList = firstPassCentroidParameters.cellCentroidList;
%-----
    
%Merge close cell centroids in such a way as to remove the fewest centroids
disp(['Merging too-close cell centroids : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
%---
mergeCellCentroidParameters.lastRerunStartDateNum = lastRerunStartDateNum;
mergeCellCentroidParameters.fileRootName = fileRootName;
mergeCellCentroidParameters.intermediateResultsFolder = intermediateResultsFolder;
mergeCellCentroidParameters.cellCentroidFilesFolder = cellCentroidFilesFolder;
mergeCellCentroidParameters.cellCentroidMergeDistance = cellCentroidMergeDistance;
mergeCellCentroidParameters.cellCentroidList = cellCentroidList;
    mergeCellCentroidParameters = VidaMergeCellCentroids(mergeCellCentroidParameters);
mergedCellCentroidList = mergeCellCentroidParameters.mergedCellCentroidList;
%----------

outExp = inExp;
outExp.globalParameters.cellCentroidList = mergedCellCentroidList;
outExp.cellCentroidParameters.firstPassCentroidParameters = firstPassCentroidParameters;
outExp.cellCentroidParameters.mergeCellCentroidParameters = mergeCellCentroidParameters;
%---
outExp.completionDates.cellCentroidCompletionDate = datestr(now,'mm/dd/yy HH:MM:SS');
%----------






