function mergedcclist = CellTestMergeCellCentroids_core(cclist,mergedist)

CAG=sparse(size(cclist,1),size(cclist,1)); %CAG stands for Cell Adjacency Graph


%go cell by cell.  locate those cells that are less than mergedist from the
%current cell.  Fill the sparse adjacency matrix with the distance only at
%those entries where cell separation <= mergedist

mergedist2 = mergedist^2;
ccLength = size(cclist,1);
for iCENT=1:size(cclist,1)
    offs=[cclist-repmat(cclist(iCENT,:),ccLength,1)];
    dtmp2=sum(offs.^2,2);
    ncentsi=dtmp2<=mergedist2;
    CAG(iCENT,ncentsi)=dtmp2(ncentsi);
end

% Find all connected subgraphs with distances<mergedist
[connsub]=decomposeRAGlabels(CAG);
%connsub is a list of all the clusters of centroids (<=mergedist from another
%   centroid in that same cluster),each entry in connsub is a 1xn list of the
%   n centroids associated with that cluster.  Isolated centroids are their
%   own cluster
%clabels is a m x 1 list of all the centroids, giving the cluster# for each
%   centroid


% Where the cell array, connsub, contains at least 2 centroid indices, that
% set of centroids must be separated.

centroidsplitlist=find(cellfun('length',connsub)>=2);
centroidreplacements=[];


for iCSPLIT=1:length(centroidsplitlist)
    csubgi=connsub{iCSPLIT};
    if length(csubgi)==2
        % if only 2 members of subgraph, pick mid-point as centroid
        % location estimate
        centroidsubgraph=cclist(csubgi,:);
        centrep=round(mean(centroidsubgraph,1));
    else%if length(csubgi)==2
        if length(csubgi)<=7,
            centroidsubgraph=cclist(csubgi,:);
            centrep=DisconnectSubgraph(centroidsubgraph,mergedist);
        else%if length(csubgi)<=7,
            %the process takes too long; use this shortcut:local
            %elimination by rank order until full disconnection
            disp(['Cluster of ',num2str(length(csubgi)),' found!!!!!!!!!!']);
            centroidsubgraph=cclist(csubgi,:);
            centrep = QuickDisconnectSubgraph(centroidsubgraph,mergedist);
        end%if-else length(csubgi)<=7,
    end%if-else length(csubgi)==2
    centroidreplacements=cat(1,centroidreplacements,centrep);
end%for iCSPLIT=1:length(centroidsplitlist)

mergedcclist=cclist;
removecentroidsi=unique([connsub{centroidsplitlist}]);
mergedcclist(removecentroidsi,:)=[];
mergedcclist=[mergedcclist;centroidreplacements];