function [cellson,histanalysis,resultsStruct]=VidaBinarizeSmoothCell2(smoothCell,numSigma,minvol,maxvol,displayFlag,resultsStruct)



%histogram the filtered bkg-subtracted image block and find the mode
[minSmoothCell,minPosSmoothCell]=min(smoothCell(:));
[maxSmoothCell,maxPosSmoothCell]=max(smoothCell(:));
histSmoothCellXRange=linspace(minSmoothCell(1),maxSmoothCell(1),100);
histSmoothCell=histc(smoothCell(:),histSmoothCellXRange);
[maxHistSmoothCell,maxHistPosSmoothCell]=max(histSmoothCell);
smoothCellHistMode=histSmoothCellXRange(maxHistPosSmoothCell); %this is the mode of the image histogram

%find the regional maxima of the 6-connected regions in 3D and their values
regionalMaxResults=imregionalmax(smoothCell,6);
regionalMaxVals=sort(smoothCell(find(regionalMaxResults(:))));
minRegionalMax = min(regionalMaxVals(:));
maxRegionalMax = max(regionalMaxVals(:));
histRegionalMaxXRange = linspace(minRegionalMax(1),maxRegionalMax(1),200);
histRegionalMax = histc(regionalMaxVals,histRegionalMaxXRange);
[maxHistRegionalMax,maxHistPosRegionalMax]=max(histRegionalMax);
regionalMaxHistMode=histRegionalMaxXRange(maxHistPosRegionalMax); %this is the mode of the regionalMax histogram


%take the standard deviation of the portion of the regional max histogram
%that is to the left of the mode
smoothCellSigma=sqrt(var(smoothCell(find(smoothCell(:)<smoothCellHistMode))));
regionalMaxSigma=sqrt(var(regionalMaxVals(find(regionalMaxVals(:)<regionalMaxHistMode))));
%take the standard deviation of the portion of the histogram to the left of the point
%    that is one bkg-std above the mode (i.e., the "background" portion of
%    the histogram
smoothCellSigma=sqrt(var(smoothCell(find(smoothCell(:)<(smoothCellHistMode+smoothCellSigma)))));
regionalMaxSigma=sqrt(var(regionalMaxVals(find(regionalMaxVals(:)<(regionalMaxHistMode+regionalMaxSigma)))));

if displayFlag == 1,
    figure(2);clf;
    plot(histRegionalMaxXRange,histRegionalMax,'b-');
    hold on;
    plot([regionalMaxHistMode regionalMaxHistMode],[0 max(histRegionalMax)],'k-');
    plot([regionalMaxHistMode+numSigma*regionalMaxSigma regionalMaxHistMode+numSigma*regionalMaxSigma],[0 max(histRegionalMax)],'k-');
    plot([regionalMaxHistMode regionalMaxHistMode+numSigma*regionalMaxSigma],[max(histRegionalMax) max(histRegionalMax)]/2,'k-');
    hold off
    %---
    figure(3);clf;
    plot(histSmoothCellXRange,histSmoothCell,'r-');
    hold on;
    plot([smoothCellHistMode smoothCellHistMode],[0 max(histSmoothCell)],'k-');
    plot([smoothCellHistMode+numSigma*smoothCellSigma smoothCellHistMode+numSigma*smoothCellSigma],[0 max(histSmoothCell)],'k-');
    plot([smoothCellHistMode smoothCellHistMode+numSigma*smoothCellSigma],[max(histSmoothCell) max(histSmoothCell)]/2,'k-');
    hold off
end%if displayFlag == 1,


regionalMaxThresh = regionalMaxHistMode+numSigma*regionalMaxSigma;
smoothCellThresh = smoothCellHistMode+numSigma*smoothCellSigma;

histanalysis.histSmoothCellXRange = histSmoothCellXRange;
histanalysis.histRegionalMaxXRange = histRegionalMaxXRange;
histanalysis.histSmoothCell = histSmoothCell';
histanalysis.histRegionalMax=histRegionalMax';
histanalysis.smoothCellHistMode=smoothCellHistMode;     %mode of filtered-bkg-sub-image
histanalysis.regionalMaxHistMode=regionalMaxHistMode;     %mode of filtered-bkg-sub-image
histanalysis.regionalMaxSigma=regionalMaxSigma;     %stdev of "background" portion of histogram
histanalysis.regionalMaxThresh=regionalMaxThresh; %threshold value = mode + (numSigma * bkg_stdev)
%                                                where numSigma is a parameters selected by the user

%make a mask of only those regions above the threshold
onmask=smoothCell>regionalMaxThresh;

%find the volume of each 6-connected region and toss regions that are too
%small or too large (based on user-parameters)
L=bwlabeln(onmask,6);
s=regionprops(L,'Area');
keepi=find(([s.Area]>minvol)&([s.Area]<maxvol));
cellson=VidaKeepLabels(L,keepi);



if displayFlag == 1,
    figure(1);colormap gray;
    set(1,'position',[239,657,1079,420]);
    for i=1:size(smoothCell,3)
        clf;
        subplot(1,2,1);
        imagesc(smoothCell(:,:,i));hold on;
        contour(cellson(:,:,i),1,'g','linewidth',2);drawnow;
        subplot(1,2,2);
        imagesc(smoothCell(:,:,i));
        drawnow;
        pause(.01);
    end
end

if displayFlag == 1,
    outlineFileName = fullfile(dispon.intermediateResultsFolder,'CellSampleOutlines.tif'); 
    f1 = figure(1);colormap gray;
    set(f1,'position',[239,657,1079,420]);
    middleFrame=floor(size(smoothCell,3)/2);
    clf;
    subplot(1,2,1);
    imagesc(smoothCell(:,:,middleFrame));hold on;
    contour(cellson(:,:,middleFrame),1,'g','linewidth',2);drawnow;
    subplot(1,2,2);
    imagesc(smoothCell(:,:,middleFrame));
    drawnow;
    pause(.01);
    movieFrame = getframe(f1);
    resultsStruct.outlineSampleFrame = frame2im(movieFrame);
end




cellson=logical(cellson);
