function outputParameters=VidaBinaryCellRestitch(inputParameters)
%previously called EXPERIMENT=BinaryCellRestitch(EXPERIMENT)

fileRootName = inputParameters.fileRootName;
processedDataFolder = inputParameters.processedDataFolder;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
cellFileName = inputParameters.cellFileName;
cellBlockMaskFileNameList = inputParameters.cellBlockMaskFileNameList;
fullStackSize = inputParameters.fullStackSize;
blockGrid = inputParameters.blockGrid;
overlapsz = inputParameters.overlapsz;
numVoxelsMarginBlank = inputParameters.numVoxelsMarginBlank;
%-----
[pname,bname,ext]=fileparts(cellFileName);
cellMaskFileName=fullfile(pname,[fileRootName,'-CellMask.mat']);
%-----
[tempPath,tempName] = fileparts(cellFileName);
disp(['Restitching mask for ',tempName]);


%% Try to keep the biggest cell mask possible in memory
cellMask=false(fullStackSize);

for blockIter=1:length(blockGrid)
    blockIterlims=blockGrid{blockIter};
    load(cellBlockMaskFileNameList{blockIter},'cellBlockMask','-mat');
    if isstruct(cellBlockMask),
        tempPixelList = cellBlockMask.pixelList;
        tempMaskSize = cellBlockMask.maskSize;
        cellBlockMask = false(tempMaskSize);
        cellBlockMask(tempPixelList) = 1;
        clear tempPixelList tempMaskSize
    end
    blkmargin=numVoxelsMarginBlank;    

    x1r=[blockIterlims.x1min+blkmargin:blockIterlims.x1max-blkmargin];
    x2r=[blockIterlims.x2min+blkmargin:blockIterlims.x2max-blkmargin];
    x3r=[blockIterlims.x3min+blkmargin:blockIterlims.x3max-blkmargin];
    cellBlockMask=cellBlockMask(1+blkmargin:end-blkmargin,1+blkmargin:end-blkmargin,1+blkmargin:end-blkmargin);

    % % % % % % In case the CellMask was truncated in the 1st dimension for MEMORY
    % % % % % % issues, truncate the part of the block bigger than the
    % CellMask.
    % % % % % insidemaski=find(x1r<fullStackSize(1));
    % % % % % x1r=x1r(insidemaski);
    % % % % % cellBlockMask=cellBlockMask(1:length(x1r),:,:);

    cellMask(x1r,x2r,x3r)=max(cellMask(x1r,x2r,x3r),cellBlockMask);
end

disp(['Writing mask to ',cellMaskFileName]);
pixelList = find(cellMask);
maskSize = size(cellMask);
cellMask = [];
cellMask.pixelList = pixelList;
cellMask.maskSize = maskSize;
saveSize = (getfield(whos('cellMask'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(cellMaskFileName,'cellMask',scs);
%---
outputParameters = inputParameters;
outputParameters.cellMaskFileName = cellMaskFileName; 




