function B=VidaKeepLabels(L,keepi)

% This function uses a LUT to replace all values in L that are in the set
% keepi with 1 to produce the binary image/volume, B, same size as L
% (i.e. sets everything in index list keepi to 1)

% % This is the slow way to validate
% Bval=zeros(size(L));
% for i=1:length(keepi)
%   Bval(find(L==keepi(i)))=1;
% end

% This is the vectorized way to use (Bval and B are equivalent)
L=single(L)+1;
keepi=keepi+1;
LUT=zeros(1,max(L(:)));
LUT(keepi)=1;
B=reshape(LUT(L(:)),size(L));
