
function [foundList1,foundList2] = LocateConnectingStrands(vectorizedStructure,label1List,label2List);
%function [foundList1,foundList2] = LocateConnectingStrands(vectorizedStructure,label1List,label2List);
%   supply vectorizedStructure with fields:
%       maskSize
%       Vertices
%       Strands
%Returns foundList1 : the strands IDs of type labelList1 that connect to typelabelList2.
%   and foundList2: the strands IDs of type labelList2 that connect to typelabelList1.

maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
AllLabels = double(Vertices.AllLabels);
StrandIndices = Vertices.StrandIndices;
foundList1 = [];
foundList2 = [];

if iscell(StrandIndices),
    disp('StrandIndices is in wrong format');
    keyboard
end%if iscell(StrandIndices),

numPoints = numel(AllLabels);
label1PointList = find(ismember(AllLabels,label1List));
label1StrandList = unique([StrandIndices(label1PointList,1)]);
numStrands = numel(label1StrandList);
for strandIter = 1:numStrands,
    thisStrandID = label1StrandList(strandIter);
    thisStrand = Strands(thisStrandID);
    thisMedLabel = mode(AllLabels(thisStrand.InteriorVertices));
    if ismember(thisMedLabel,label1List),
        neighborStrandList = [thisStrand.StartVertexNeighborStrands,thisStrand.EndVertexNeighborStrands];
        neighborStrandList = unique(neighborStrandList(neighborStrandList~=thisStrandID));
        for neighborIter = 1:numel(neighborStrandList),
            thisNeighborID = neighborStrandList(neighborIter);
            thisNeighborStrand = Strands(thisNeighborID);
            neighborMedLabel = mode(AllLabels(thisNeighborStrand.InteriorVertices));
            if ismember(neighborMedLabel,label2List),
                foundList1 = [foundList1,thisStrandID];
                foundList2 = [foundList2,thisNeighborID];
            end%if ismember(neighborMedLabel,label2List),
        end%for neighborIter...
    end%if ismember(...
end%for strandIter...

foundList1 = unique(foundList1);
foundList2 = unique(foundList2);






