function vidaProject = restorePathToCurrentFolder(vidaProject)
%
%update global parameter file name lists - this corrects for files being pointed to a
%network drive path as a result of running Vida across the network
%
%Pablo 30/Dec/2010


%% find file name lists
globalParameters = vidaProject.globalParameters;
nblocks = vidaProject.numImageStacks;
allfields = fieldnames(vidaProject.globalParameters);
findFileNameListFun = @(x) findstr(x,'GrayscaleFileNameList');
grayscaleFileNameListIdx = find(cellfun(@numel,(cellfun(findFileNameListFun,allfields,'UniformOutput',false))));
findFileNameListFun = @(x) findstr(x,'MaskFileNameList');
maskFileNameListIdx = find(cellfun(@numel,(cellfun(findFileNameListFun,allfields,'UniformOutput',false))));
fields2processIdx = union(grayscaleFileNameListIdx,maskFileNameListIdx);

%% apply correction to file location
for iFIELD = 1 : numel(fields2processIdx)
    newLocation = [vidaProject.vidaProjectRootFolder filesep];
    replaceFun = sprintf('replaceFun = @(x) strrep(x,x(1:findstr(x,''\\ImageStack'')),''%s'')',newLocation);
    eval(replaceFun);
    globalParameters.(allfields{fields2processIdx(iFIELD)}) = ...
        cellfun(replaceFun,globalParameters.(allfields{fields2processIdx(iFIELD)}),'UniformOutput',false);
%    cellfun(@disp,globalParameters.(allfields{fields2processIdx(iFIELD)}));
end

vidaProject.globalParameters = globalParameters;