function outputParameters = GetBlockOffsets(inputParameters)
%---
vidaProjectRootFolder = inputParameters.vidaProjectRootFolder; %//PB - 29-Nov-2011
nominalBlockStepSizeRC = inputParameters.nominalBlockStepSizeRC;
nominalBlockStepSizeZ = inputParameters.nominalBlockStepSizeZ;
variableZBlockStepSizeFlag = inputParameters.variableZBlockStepSizeFlag;
nblks1 = inputParameters.nblks1;
nblks2 = inputParameters.nblks2;
nblks3 = inputParameters.nblks3;
adjacentBlockPairList = inputParameters.adjacentBlockPairList;
%---
variableZBlockStepSizeFileName = fullfile(vidaProjectRootFolder,'variableZBlockStepSize.mat');
%---
%if varibleZBlockStepSizeFlag is set to 1, load the file containing the list of offsets
if variableZBlockStepSizeFlag == 1,
    if exist(variableZBlockStepSizeFileName) == 2,
        loadedStruct = load(variableZBlockStepSizeFileName,'variableZBlockStepSize');
        if ~isfield(loadedStruct,'variableZBlockStepSize')
            nominalBlockStepSizeZ = loadedStruct.variableZBlockStepSize;
            disp('Utilizing previously loaded variableZBlockStepSize array');
        else%if ~isfield(loadedStruct,'variableZBlockStepSize')
            loadedVariableNames = fieldnames(loadedStruct);
            nominalBlockStepSizeZ = loadedStruct.(loadedVariableNames{1});
            disp('Utilizing variableZBlockStepSize array from file');
        end%if-else ~isfield(loadedStruct,'variableZBlockStepSize')
    else%if exist(variableZBlockStepSizeFileName) == 2,
        disp('Warning!  variableZBlockStepSizeFlag set, but the file containing the list of Z-step sizes was not found.')
        disp('Store the list as a vector, in the file: ');
        disp(variableZBlockStepSizeFileName);
        disp('Preferable in a matlab variable named: ''variableZBlockStepSize''. ');
        disp('Defaulting to single z offset : (nominal value)');
    end%if-else exist(variableZBlockStepSizeFileName) == 2,
end%if variableZBlockStepSizeFlag == 1,



if size(nominalBlockStepSizeZ,1)>size(nominalBlockStepSizeZ,2),
    nominalBlockStepSizeZ = nominalBlockStepSizeZ';
end%if size(nominalBlockStepSizeZ,1)>size(nominalBlockStepSizeZ,2)


% Compute corner coordinates of all block locations - or use stage positions (not implemented yet)
cornercoords1 = 0 : nominalBlockStepSizeRC :  nominalBlockStepSizeRC * (nblks1 - 1);
cornercoords2 = 0 : nominalBlockStepSizeRC :  nominalBlockStepSizeRC * (nblks2 - 1);
if numel(nominalBlockStepSizeZ) == 1
    cornercoords3 = 0 : nominalBlockStepSizeZ :  nominalBlockStepSizeZ * (nblks3 - 1);
    Z = repmat(cornercoords3,nblks1 * nblks2,1);
else%if numel(nominalBlockStepSizeZ) == 1
    cornercoords3 = cumsum(nominalBlockStepSizeZ);
    cornercoords3 = [0 , cornercoords3(1:nblks3-1)];
    Z = repmat(cornercoords3,nblks1 * nblks2,1);
end%if-else numel(nominalBlockStepSizeZ) == 1

%cornercoords1,2 and 3 are lenght numblock 
[R C] = meshgrid(cornercoords1,cornercoords2);
R = R';C = C';
R = repmat(R(:),nblks3,1);
C = repmat(C(:),nblks3,1);

Z = Z(:);

blockCornerCoordList = [R C Z];
adjacentBlockPairOffsetList = blockCornerCoordList(adjacentBlockPairList(:,1),:) - blockCornerCoordList(adjacentBlockPairList(:,2),:);



outputParameters = inputParameters;
outputParameters.adjacentBlockPairOffsetList = adjacentBlockPairOffsetList;
outputParameters.blockCornerCoordList = blockCornerCoordList;

