function vidaProject = restorePathToCurrentFolder(vidaProject)
%
%update global parameter file name lists - this corrects for files being pointed to a
%network drive path as a result of running Vida across the network
%
%Pablo 30/Dec/2010


%% find file name lists
globalParameters = vidaProject.globalParameters;
nblocks = vidaProject.numImageStacks;
allfields = fieldnames(vidaProject.globalParameters);
findFileNameListFun = @(x) findstr(x,'GrayscaleFileNameList');
grayscaleFileNameListIdx = find(cellfun(@numel,(cellfun(findFileNameListFun,allfields,'UniformOutput',false))));
findFileNameListFun = @(x) findstr(x,'MaskFileNameList');
maskFileNameListIdx = find(cellfun(@numel,(cellfun(findFileNameListFun,allfields,'UniformOutput',false))));
fields2processIdx = union(grayscaleFileNameListIdx,maskFileNameListIdx);

%% apply correction to file location
for iFIELD = 1 : numel(fields2processIdx)
    newLocation = [vidaProject.vidaProjectRootFolder];
    replaceFun = sprintf('replaceFun = @(x) strrep(x,x(1:findstr(x,''ImageStack'')-2),''%s'')',newLocation);
    eval(replaceFun);
    tmp = cellfun(replaceFun,globalParameters.(allfields{fields2processIdx(iFIELD)}),'UniformOutput',false);

    %now replace ensure all filesep are platform matched
    if isunix
        delimOK = '/';
        delimBAD = '\';
    else
        delimOK = '\';
        delimBAD = '/';
    end

    replaceFun = sprintf('replaceFun = @(x) strrep(x,''%s'',''%s'')',delimBAD,delimOK);
    eval(replaceFun);
    tmp = cellfun(replaceFun,tmp,'UniformOutput',false);


    globalParameters.(allfields{fields2processIdx(iFIELD)}) = tmp;

%     cellfun(@disp,globalParameters.(allfields{fields2processIdx(iFIELD)}));
end

vidaProject.globalParameters = globalParameters;