% % % path2vidaProcessingDir = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH';
% % % rootName = 'CX06_pbEH';
% % % % ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat';
% % % ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-v7-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat.mat';


path2vidaProcessingDir = 'F:\Phil\ForFromPeople\Joyce\CX06-Retest';
rootName = 'CX06_pbEH';
ptr2latestSEfile = 'F:\Phil\ForFromPeople\Joyce\CX06-Retest\SE2-v7-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat';


%load the pre-threshold relaxation vectorizedStructure
load(fullfile(path2vidaProcessingDir,sprintf('%s-PreAddTRBridgesVectorProject.mat',rootName)))




%Reconvert all properties to double from single/uint16

vs = vectorProject.vectorizedStructure;
vertices = vs.Vertices;
vertices.AllVerts = double(vertices.AllVerts);
vertices.AllRadii = double(vertices.AllRadii);
vertices.AllLabels = double(vertices.AllLabels);
vertices.AllConfidences = double(vertices.AllConfidences);
vs.Vertices = vertices;
vectorProject.vectorizedStructure = vs;


%% add bridging strands and revectorize (the final result of TR is appended to the vectorProject
%update vectorizedStructrue on VectorProject
%STAGE 12 : Add TR Bridges
tic
disp(['Adding TR Bridges and Re-vectorizing: ',datestr(now)]);
    vectorProject = VidaAddTRBridges(vectorProject);
vectorProject.progressFlags.addTRBridgesCompleted = 1;
saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
vectorProjectFileName = fullfile(path2vidaProcessingDir,[rootName,'-PostAddTRBridgesVectorProject.mat']);
save(vectorProjectFileName,'vectorProject',scs);


save savePoint01



%% load latest SE file and transfer labels and manual corrections
load(ptr2latestSEfile)

%Now transfer over all edits performed in StrandEditor
%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label

cpMatrix = double(globalDataStruct.cpMatrix);
cpRadii = double(globalDataStruct.allRadii);
cpVerts = double(globalDataStruct.allVerts);
cpLabels = double(globalDataStruct.allLabels);

origVP = globalDataStruct.origVectorProject;
maskSize = origVP.maskSize;
numOrigPoints = numel(origVP.vectorizedStructure.Vertices.AllRadii);
inactiveFlag = cpMatrix(:,6) == 0;
activeFlag = cpMatrix(:,6) == 1;
%label 111 = original, label 162 = bridging strand
labelChangedFlag = and(cpMatrix(:,7)~=111 , cpMatrix(:,7)~=162);
labelChangedList = find(labelChangedFlag);
removedFlag = inactiveFlag;
removedFlag(numOrigPoints+1:end) = 0;%removed = on original list, but inactive
gapConnectFlag = (cpMatrix(:,7)==162); %ignore gap connection removals
jpFlag = (cpMatrix(:,5)==1); %do not remove junction points;
removedFlag = and(removedFlag,~gapConnectFlag);
removedFlag = and(removedFlag,~jpFlag);
removedList = find(removedFlag);
addedFlag = activeFlag;
addedFlag(1:numOrigPoints)= 0;%added = active but not in original list
addedList = find(addedFlag);

%%
%Go through all removal points, look for corresponding point in new vectroization, and
%remove if found.

allVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
allLabels = vectorProject.vectorizedStructure.Vertices.AllLabels;
allRadii = vectorProject.vectorizedStructure.Vertices.AllRadii;
allConfidences = vectorProject.vectorizedStructure.Vertices.AllConfidences;
numAllVerts = size(allVerts,1);
numRemovalPoints = sum(removedFlag);
dummyVerts = zeros(size(allVerts));

searchWindow = 10;
removeFailedList = zeros(numRemovalPoints,1);
removeFromAllVertsList = [];
removeFailCounter = 0;

for pointIter = 1:numRemovalPoints,
    goFlag = 1;
    while goFlag == 1,
        searchWindow=searchWindow*10;
        thisRemovalPoint = removedList(pointIter);
        thisRemovalVerts = cpMatrix(thisRemovalPoint,1:3);
        z1 = max(thisRemovalPoint-searchWindow,1);
        z2 = min(thisRemovalPoint+searchWindow,numAllVerts);
        subAllVerts = allVerts(z1:z2,1:3);
        dummyVertsSmall = allVerts(z1:z2,:)*0;
        dummyVertsSmall(:,1) = thisRemovalVerts(1);
        dummyVertsSmall(:,2) = thisRemovalVerts(2);
        dummyVertsSmall(:,3) = thisRemovalVerts(3);
        matchCoords = (dummyVertsSmall-subAllVerts)==0;
        perfectMatchID = find(sum(matchCoords,2) == 3);
        trueMatchID = perfectMatchID + z1 - 1;
        if ~isempty(trueMatchID),
            goFlag = 0;
        end%if ~isempty(trueMatchID),
        %--
        if z2-z1 == numAllVerts-1,
            goFlag = 0;
            removeFailCounter = removeFailCounter+1;
            removeFailedList(removeFailCounter) = [thisRemovalPoint];
            disp('numFailed:')
            disp(removeFailCounter)
            disp([pointIter,numRemovalPoints]);
        end%if if z2-z1 == numAllVerts,
        removeFromAllVertsList = [removeFromAllVertsList;trueMatchID];
    end%while goFlag == 1
    searchWindow = 10;
end%for pointIter
removeFailedList = removeFailedList(1:removeFailCounter);

save savePoint02
%%
%Now, transfer all the points that were added:

numAddedPoints = numel(addedList);
extraVerts = cpMatrix(addedList,1:3);
extraRadii = cpRadii(addedList);
extraLabels = cpMatrix(addedList,7);


%%
%Now find all those points whos label has changed
%try to find their matching points
%Transfer their new label and radii

numLabelChanged = numel(labelChangedList);

searchWindow = 10;
labelFailedList = [];

for pointIter = 1:numLabelChanged,
    goFlag = 1;
    while goFlag == 1,
        searchWindow=searchWindow*10;
        thisLabelChangedPoint = labelChangedList(pointIter);
        thisLabelChangedVerts = cpMatrix(thisLabelChangedPoint,1:3);
        z1 = max(thisLabelChangedPoint-searchWindow,1);
        z2 = min(thisLabelChangedPoint+searchWindow,numAllVerts);
        subAllVerts = allVerts(z1:z2,1:3);
        dummyVertsSmall = allVerts(z1:z2,:)*0;
        dummyVertsSmall(:,1) = thisLabelChangedVerts(1);
        dummyVertsSmall(:,2) = thisLabelChangedVerts(2);
        dummyVertsSmall(:,3) = thisLabelChangedVerts(3);
        matchCoords = (dummyVertsSmall-subAllVerts)==0;
        perfectMatchID = find(sum(matchCoords,2) == 3);
        trueMatchID = perfectMatchID + z1 - 1;
        if ~isempty(trueMatchID),
            goFlag = 0;
            allLabels(trueMatchID) = cpMatrix(thisLabelChangedPoint,7);
            allRadii(trueMatchID) = cpRadii(thisLabelChangedPoint);
        end%if ~isempty(trueMatchID),
        %--
        if z2-z1 == numAllVerts-1,
            goFlag = 0;
            labelFailedList = [labelFailedList;thisLabelChangedPoint];
            disp('numFailed:')
            disp(numel(labelFailedList))
            disp([pointIter,numLabelChanged]);
        end%if if z2-z1 == numAllVerts,
    end%while goFlag == 1
    searchWindow = 10;
end%for pointIter

save savePoint03
%%
%Finish cropping and adding to the AllVerts List, etc


finalKeepFlag = true(size(allRadii));
finalKeepFlag(removeFromAllVertsList) = 0;
adjVerts = allVerts(finalKeepFlag,:);
adjLabels = allLabels(finalKeepFlag);
adjRadii = allRadii(finalKeepFlag);
adjConfidences = allConfidences(finalKeepFlag);

tempNumVerts = numel(adjRadii);
adjVerts(tempNumVerts+1:tempNumVerts+numAddedPoints,:) = extraVerts;
adjLabels(tempNumVerts+1:tempNumVerts+numAddedPoints) = extraLabels;
adjRadii(tempNumVerts+1:tempNumVerts+numAddedPoints) = extraRadii;
adjConfidences(tempNumVerts+1:tempNumVerts+numAddedPoints) = 1;

vertices.AllVerts = adjVerts;
vertices.AllLabels = adjLabels;
vertices.AllRadii = adjRadii;
vertices.AllConfidences = adjConfidences;
vectorProject.vectorizedStructure.Vertices = vertices;





%%

adjPixelList = sub2ind(maskSize,double(adjVerts(:,1)),double(adjVerts(:,2)),double(adjVerts(:,3)));
adjRadiusList = vertices.AllRadii;
adjLabelList = vertices.AllLabels;
adjConfidenceList = vertices.AllConfidences;



%Restrandify one last time
%--
centerlineRadiusStructure.pixelList = adjPixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = adjRadiusList;
centerlineRadiusStructure.labelList = adjLabelList;
centerlineRadiusStructure.confidenceList = adjConfidenceList;
% % centerlineRadiusStructure.medianConfidenceList = medianConfidenceList;
% % centerlineRadiusStructure.noteList = noteList;
%-----
strandifyParameters = vectorProject.strandifyParameters;
strandifyParameters.voxelSizeInMicrons = vectorProject.voxelSizeInMicrons;
registeredVascGrayscaleFileOnlyName = vectorProject.volumeFileNames.permutedVascGrayscale;
strandifyExp.registeredVascGrayscaleFileName = [vectorProject.vectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
strandifyExp.strandifyParameters = strandifyParameters;
strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;

    strandifyExp = RestrandifyAndTransferLabels2(strandifyExp);
vectorizedStructure = strandifyExp.vectorizedStructure;
vectorProject.vectorizedStructure = vectorizedStructure;

toc
save adjustedVectorProject vectorProject
