% % % path2vidaProcessingDir = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH';
% % % rootName = 'CX06_pbEH';
% % % % ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat';
% % % ptr2latestSEfile = '/home/pblinder/Desktop/FLATTEN_CORTEX/CX06_pbEH/VectorProjectFolder/SE2-v7-2012_07_06-14_21_23-Mod-StrandEdit2-CX06_pbEH.mat.mat';


path2vidaProcessingDir = 'F:\Phil\ForFromPeople\Joyce\CX08\VectorProjectFolder';
rootName = 'CX08_pbEI';
ptr2latestSEfile = 'F:\Phil\ForFromPeople\Joyce\CX08\VectorProjectFolder\SE2-2012_06_21-18_38_33-Mod-StrandEdit2-CX08_pbEI.mat';


%load the pre-threshold relaxation vectorizedStructure
cd(path2vidaProcessingDir)
load(fullfile(path2vidaProcessingDir,sprintf('%s-PreAddTRBridgesVectorProject.mat',rootName)))




%Reconvert all properties to double from single/uint16

vs = vectorProject.vectorizedStructure;
vertices = vs.Vertices;
vertices.AllVerts = double(vertices.AllVerts);
vertices.AllRadii = double(vertices.AllRadii);
vertices.AllLabels = double(vertices.AllLabels);
vertices.AllConfidences = double(vertices.AllConfidences);
vs.Vertices = vertices;
vectorProject.vectorizedStructure = vs;


%% add bridging strands and revectorize (the final result of TR is appended to the vectorProject
%update vectorizedStructrue on VectorProject
%STAGE 12 : Add TR Bridges
tic
disp(['Adding TR Bridges and Re-vectorizing: ',datestr(now)]);
    vectorProject = VidaAddTRBridges(vectorProject);
vectorProject.progressFlags.addTRBridgesCompleted = 1;
saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
vectorProjectFileName = fullfile(path2vidaProcessingDir,[rootName,'-PostAddTRBridgesVectorProject.mat']);
save(vectorProjectFileName,'vectorProject',scs);


% load latest SE file and transfer labels and manual corrections
load(ptr2latestSEfile)
globalDataStruct.origVectorProject = [];
save savePoint01


%%
tic
%Make a list of the original vectorProject verts (minus bridges)
preAddTRVertices = vs.Vertices;
preAddTRVerts = vs.Vertices.AllVerts;
postAddTRVertices = vectorProject.vectorizedStructure.Vertices;
postAddTRVerts = vectorProject.vectorizedStructure.Vertices.AllVerts;
postAddTRStrandIndices = vectorProject.vectorizedStructure.Vertices.StrandIndices;
postAddTRStrands = vectorProject.vectorizedStructure.Strands;


%Grab a list of all active vertices from the SE file (minus bridges)
cpMatrix = double(globalDataStruct.cpMatrix);
cpRadii = double(globalDataStruct.allRadii);
cpLabel = double(globalDataStruct.allLabels);


activeFlagList = (cpMatrix(:,6) == 1);
nonBridgeFlagList = (cpMatrix(:,7)~=162);
andFlagList = and(activeFlagList,nonBridgeFlagList);
SEVerts = cpMatrix(andFlagList,1:3);
SELabels = cpMatrix(andFlagList,7);
SERadii = cpRadii(andFlagList);


%First, find all the SEVerts that are not in the vectorProject (presumably manual adds)
maskSize = vectorProject.maskSize;
SEPixelList = sub2ind(maskSize,SEVerts(:,1),SEVerts(:,2),SEVerts(:,3));
VPPixelList = sub2ind(maskSize,preAddTRVerts(:,1),preAddTRVerts(:,2),preAddTRVerts(:,3));
addedFlag = ~ismember(SEPixelList,VPPixelList);
addedPixelList = SEPixelList(addedFlag);
[cc1,cc2,cc3] = ind2sub(maskSize,addedPixelList);
addedVerts = [cc1,cc2,cc3];
addedLabels = SELabels(addedFlag);
addedRadii = SERadii(addedFlag);


%Next, find all the VPVerts that are not in SEVerts (mix of manual & error removals)
removedFlag = ~ismember(VPPixelList,SEPixelList);
removedPixelList = VPPixelList(removedFlag);
[cc1,cc2,cc3] = ind2sub(maskSize,removedPixelList);
removedVerts = [cc1,cc2,cc3];
removedRadii = preAddTRVertices.AllRadii(removedFlag);


%Start with the "postTRBridges" vectorProject, and add/transfer labels to that
allVerts = postAddTRVertices.AllVerts;
allLabels = postAddTRVertices.AllLabels;
allRadii = postAddTRVertices.AllRadii;
allConfidences = postAddTRVertices.AllConfidences;


%Add the added vertices with labels and radii
modAddedLabels = addedLabels;
surfacePlungingLabelFlag = ismember(addedLabels,[300:499]);
modAddedLabels(~surfacePlungingLabelFlag) = 552; %label 552 = added nonSurface/Plunging
adjVerts = [allVerts;addedVerts];
adjLabelList = [allLabels;modAddedLabels];
adjRadiusList = [allRadii;addedRadii];
adjConfidenceList = [allConfidences;zeros(size(addedRadii))];


%Transfer all non-111 SELabels and Radii to the VP
non111LabelFlagList = ~ismember(SELabels,[111]);
non111LabelPixelList = SEPixelList(non111LabelFlagList);
non111LabelLabels = SELabels(non111LabelFlagList);
non111LabelRadii = SERadii(non111LabelFlagList);
adjPixelList = sub2ind(maskSize,adjVerts(:,1),adjVerts(:,2),adjVerts(:,3));
[foundInVPFlagList,foundLoc] = ismember(non111LabelPixelList,adjPixelList);

for foundIter = 1:numel(foundInVPFlagList),
    if foundInVPFlagList(foundIter)==1,
        thisPointer = foundLoc(foundIter);
        thisLabel = non111LabelLabels(foundIter);
        thisRadius = non111LabelRadii(foundIter);
        adjLabelList(thisPointer) = thisLabel;
        adjRadiusList(thisPointer) = thisRadius;
    end%if foundInVPFlagList...
%     disp([foundIter]);pause(0.001);
end%for foundIter...



%Label removed points with label 772;
numRemoved = numel(removedPixelList);
[foundInVPFlagList,foundLoc] = ismember(removedPixelList,adjPixelList);
for removeIter = 1:numRemoved,
    if foundInVPFlagList(removeIter)==1,
        thisPointer = foundLoc(removeIter);
        adjLabelList(thisPointer) = 772; %label 772 = removedPoint
        
    end%if foundInVPFlagList...
end%for removeIter...




%%

%Restrandify again
%--
centerlineRadiusStructure.pixelList = adjPixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = adjRadiusList;
centerlineRadiusStructure.labelList = adjLabelList;
centerlineRadiusStructure.confidenceList = adjConfidenceList;
% % centerlineRadiusStructure.medianConfidenceList = medianConfidenceList;
% % centerlineRadiusStructure.noteList = noteList;
%-----
strandifyParameters = vectorProject.strandifyParameters;
strandifyParameters.voxelSizeInMicrons = vectorProject.voxelSizeInMicrons;
% registeredVascGrayscaleFileOnlyName = vectorProject.volumeFileNames.permutedVascGrayscale;
% strandifyExp.registeredVascGrayscaleFileName = [vectorProject.vectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
% strandifyExp.strandifyParameters = strandifyParameters;
% strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;

    vectorizedStructure = JustStrandifyCenterlineRadiusStructure2(centerlineRadiusStructure,strandifyParameters);
vectorProject.vectorizedStructure = vectorizedStructure;

toc
save stage2VectorProject vectorProject

save savePoint02


%%
tic

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allLabels = vertices.AllLabels;
allRadii = vertices.AllRadii;
allConfidences = vertices.AllConfidences;
strandIndices = full(vertices.StrandIndices);



delPoints = find(allLabels == 772);
delStrands = unique(strandIndices(delPoints,1));

medianDelRadiusList = [];
medianDelLabelList = [];
delFractionList = [];
delLengthList = [];
delNumPointsList = [];
longestDelSegmentList = [];

for delIter = 1:numel(delStrands),
    thisStrandID = delStrands(delIter);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    delLabels = allLabels(stei);
    thisMedianRadius = median(allRadii(stei));
    thisMedianLabel = median(delLabels(delLabels~=772));
    numDelPointsOnStrand = sum(delLabels == 772);
    delFraction = numDelPointsOnStrand./numel(stei);
    medianDelRadiusList(delIter) = thisMedianRadius;
    medianDelLabelList(delIter) = thisMedianLabel;
    delFractionList(delIter) = delFraction;
    delLengthList(delIter) = numel(stei);
    delNumPointsList(delIter) = numDelPointsOnStrand;
    delSegmentLength = diff(find([0;delLabels;0]~=772));
    if isempty(delSegmentLength)
        longestDelSegmentList(delIter) = numel(stei);
    else
        longestDelSegmentList(delIter) = max(delSegmentLength-1);
    end%if isempty(delSegmentLength)
    
end%for delIter = 1:numel(delStrands),

keepAllStrandList = delStrands(or(delFractionList<0.2,longestDelSegmentList==1));
dropStrandList = delStrands(~ismember(delStrands,keepAllStrandList));



allDropVertices = [];
for strandIter = 1:numel(dropStrandList),
    thisStrandID = dropStrandList(strandIter);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    interiorVertices = stei(2:end-1);
    interiorLabels = allLabels(interiorVertices);
    dropVertices = interiorVertices(interiorLabels==772);
    allDropVertices = [allDropVertices,dropVertices];
end%for strandIter = 1:numel(dropStrandList);

allDropVerts = allVerts(allDropVertices,:);
allDropPixelList = sub2ind(maskSize,allDropVerts(:,1),allDropVerts(:,2),allDropVerts(:,3));
allPixelList = sub2ind(maskSize,allVerts(:,1),allVerts(:,2),allVerts(:,3));

keepFlag = ~ismember(allPixelList,allDropPixelList);


adjPixelList = allPixelList(keepFlag);
adjRadiusList = allRadii(keepFlag);
adjLabelList = allLabels(keepFlag);
adjConfidenceList = allConfidences(keepFlag);


%Restrandify one last time
%--
centerlineRadiusStructure.pixelList = adjPixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = adjRadiusList;
centerlineRadiusStructure.labelList = adjLabelList;
centerlineRadiusStructure.confidenceList = adjConfidenceList;
% % centerlineRadiusStructure.medianConfidenceList = medianConfidenceList;
% % centerlineRadiusStructure.noteList = noteList;
%-----
strandifyParameters = vectorProject.strandifyParameters;
strandifyParameters.voxelSizeInMicrons = vectorProject.voxelSizeInMicrons;
% registeredVascGrayscaleFileOnlyName = vectorProject.volumeFileNames.permutedVascGrayscale;
% strandifyExp.registeredVascGrayscaleFileName = [vectorProject.vectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
% strandifyExp.strandifyParameters = strandifyParameters;
% strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;

    vectorizedStructure = JustStrandifyCenterlineRadiusStructure2(centerlineRadiusStructure,strandifyParameters);
vectorProject.vectorizedStructure = vectorizedStructure;

toc
save adjustedVectorProject vectorProject

save savePoint03


