function FV_GetStrandInfo

strandData = get(gco,'UserData');
strandID = strandData.strandID;
medianLabel = strandData.MedianLabel;
strandRadius = strandData.strandRadius;
medianVoltage = strandData.MedianVoltage;
voltageDrop = strandData.VoltageDrop;
strandLength = numel(strandData.StartToEndIndices);
current = strandData.strandCurrent;

% % myColor = get(gco,'MarkerEdgeColor');
% % set(gco,'MarkerEdgeColor',double(myColor)*0.75);


mytext = ['StrandID: ',num2str(strandID),' ,  '];
mytext = [mytext, 'label: ',num2str(medianLabel),' ,  '];
mytext = [mytext, 'length: ',num2str(strandLength),' ,  '];
mytext = [mytext, 'R: ',num2str(strandRadius,'%0.3f'),' ,  '];
mytext = [mytext, 'Vmed: ',num2str(medianVoltage,'%0.3f'),' ,  '];
mytext = [mytext, 'dV: ',num2str(voltageDrop,'%0.3f'),' ,  '];
mytext = [mytext, 'I: ',num2str(current,'%0.3e')];

title(mytext);
set(gcf,'Name',mytext);


return