%Clean up labels

%keep only the surface labels - convert all others to 112
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allLabels = vertices.AllLabels;

surfaceLabelNumberList = [300:399];
surfacePointList = ismember(allLabels,surfaceLabelNumberList);
allLabels(~surfacePointList) = 112;

numStrands = numel(strands);
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    %-----
    if ismember(thisStrandID,vectorizedStructure.allPlungingVenuleList),
        allLabels(stei(2:end-1)) = 442; %plunging draining
    end%if ismember(thisStrandID,allPlungingVenuleList),
    %-----
    if ismember(thisStrandID,vectorizedStructure.allPlungingArterioleList),
        allLabels(stei(2:end-1)) = 432; %plunging draining
    end%if ismember(thisStrandID,allPlungingVenuleList),
    %-----
    if ismember(thisStrandID,vectorizedStructure.plungingVenuleTipList),
        allLabels(stei(2:end-1)) = 342; %plunging draining
    end%if ismember(thisStrandID,allPlungingVenuleList),
    %-----
    if ismember(thisStrandID,vectorizedStructure.plungingArterioleTipList),
        allLabels(stei(2:end-1)) = 332; %plunging draining
    end%if ismember(thisStrandID,allPlungingVenuleList),
    %-----
    medianLabel = median(allLabels(stei));
    thisStrand.MedianLabel = medianLabel;
    strands(thisStrandID) = thisStrand;
end

vectorizedStructure.Strands = strands;
vertices.AllLabels = allLabels;
vectorizedStructure.Vertices = vertices;
vectorProject.vectorizedStructure = vectorizedStructure;

disp('Saving -Flow-VectorProject');
pause(0.01);
vectorProjectFileName = [vectorProject.vectorProjectRootName,'-CleanLabels-VectorProject.mat'];
save(vectorProjectFileName,'vectorProject');
    
