
clotStrandID = gds.selectedStrandData.strandID;
clotStrand = gds.Strands(clotStrandID);

clotStrandCoords = median(gds.Vertices.AllVerts(clotStrand.InteriorVertices,:),1);

numStrands = numel(gds.Strands);
allSep = zeros(numStrands,1);
allCurrentRatio = zeros(numStrands,1);
for strandIter = 1:numStrands,
    thisStrand = gds.Strands(strandIter);
    thisCoords = median(gds.Vertices.AllVerts(thisStrand.InteriorVertices,:),1);
    thisSep = sqrt(sum((clotStrandCoords(1:2) - thisCoords(1:2)).^2));
    
    if thisCoords(3)>400, thisSep = 1000; end
    
    thisCurrentRatio = abs(gds.clotAnalysisParameters.strandCurrentList(strandIter)) / ...
        abs(gds.circuitAnalysisParameters.strandCurrentList(strandIter));
    
    thisVoltageRatio = abs(memgds(5).Strands(strandIter).VoltageDrop) / ...
        abs(memgds(1).Strands(strandIter).VoltageDrop);
    
    
    
    allSep(strandIter) = thisSep;
    allCurrentRatio(strandIter) = thisCurrentRatio;

    
    allCurrentRatio(strandIter) = thisVoltageRatio;

    
end

ff = find(gds.circuitAnalysisParameters.strandRadiusList<4);
allCurrentRatio = allCurrentRatio(ff);
allSep = allSep(ff);

ff = find(allCurrentRatio<5);
allCurrentRatio = allCurrentRatio(ff);
allSep = allSep(ff);

numCap = numel(allSep);

% % allCurrentRatio = min(allCurrentRatio,3);

figure(98); plot(allSep,allCurrentRatio,'g.');
sortData = sortrows([allSep,allCurrentRatio],1);

filtRatio = zeros(size(allCurrentRatio));
filtSize = 100;
for kk = 1:numCap
    filtSizeTemp = min(filtSize,kk-1);
    filtSizeTemp = min(filtSizeTemp,numCap-kk);
    cropData = sortData(kk-filtSizeTemp:kk+0,2);
    filtRatio(kk) = mean(cropData);
end
hold on
figure(98);plot(sortData(:,1),filtRatio,'r-');
hold off
