function varargout = FlowVisualizer(varargin)
% FLOWVISUALIZER M-file for FlowVisualizer.fig
%      FLOWVISUALIZER, by itself, creates a new FLOWVISUALIZER or raises the existing
%      singleton*.
%
%      H = FLOWVISUALIZER returns the handle to a new FLOWVISUALIZER or the handle to
%      the existing singleton*.
%
%      FLOWVISUALIZER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FLOWVISUALIZER.M with the given input arguments.
%
%      FLOWVISUALIZER('Property','Value',...) creates a new FLOWVISUALIZER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FlowVisualizer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FlowVisualizer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FlowVisualizer

% Last Modified by GUIDE v2.5 22-Feb-2011 11:12:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FlowVisualizer_OpeningFcn, ...
                   'gui_OutputFcn',  @FlowVisualizer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FlowVisualizer is made visible.
function FlowVisualizer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FlowVisualizer (see VARARGIN)

% Choose default command line output for FlowVisualizer
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%-----------------------------
%-----------------------------
%------- MY CODE -------------
%-----------------------------
%-----------------------------

global gds;%gds = globalDataStructure;
gds.handles = handles;
% LoadVectorProject;
uiwait(handles.figure1,1);
InitializeFVParameters;
CalculateDownstreamPaths
CalculateUpstreamPaths
GenerateBasicView;


% UIWAIT makes FlowVisualizer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


function LoadVectorProject
global gds
[fileName,pathName] = uigetfile({'*.mat'},'Select a vectorProject, StrandEdit2 .mat file');
cd(pathName)
loadFileName = [fileName];
load(loadFileName);
if exist('vectorProject','var'),
    gds.maskSize = vectorProject.maskSize;
    gds.Strands = vectorProject.vectorizedStructure.Strands;
    gds.Vertices = vectorProject.vectorizedStructure.Vertices;
    InitializeFVParameters;
    clear vectorProject
end%if exist('vectorProject','var');
%---
if ~isfield(gds.Strands,'YXZLimits'),
    for strandIter = 1:numel(gds.Strands),
        cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
        yxzLim(:,1) = min(cc,[],1)';
        yxzLim(:,2) = max(cc,[],1)';
        gds.Strands(strandIter).YXZLimits = yxzLim;
        gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).MedianVoltage = mode(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
                min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    end%for strandIter = 1:numel(gds.Strands),
end%if ~isfield(gds.Strands,'YXZLimits'),
%---


return




function InitializeFVParameters
global gds
gds.viewCenter = [500 500 100];
gds.viewRange = [100 100 100];
gds.smallMarkerSize = 1;
gds.largeMarkerSize = 5;
%---
gds.showDownstreamFlowFlag = 0;
gds.showUpstreamFlowFlag = 0;
gds.downstreamBranches = 1;
gds.upstreamBranches = 1;
%---
gds.showRadiiFlag = 0;
gds.hideGrayFlag = 0;
%---
gds.largeMarkerThresholdRadius = 3;
gds.baseStrandIDList = [1 2 3];
%---

gds.baseStrandIDList = [1054 2208 96 2043 849 24 ...
                     3204 54 1921 2096 1569 244 1010 961 ...
                     946 778 1684 1694 2424 1213 3468 5330 1811 ...
                     2370 3730 ...
                     193 ...
                     1187 ...
                     4587 239]; 
                 
gds.baseStrandIDList = [244 3204 54 1921 2096 1569 2424 1213 3468 5330 1811] ;                 
gds.baseStrandIDList = [244] ;                 

InitializeBaseStrands
GetViewLimits
figure(11);hold off
PlotOutlineBox(gds.viewLimits);

return


function GetViewLimits
global gds
viewLimits = zeros(3,2);
viewLimits(1,1) = max(1, gds.viewCenter(1) - gds.viewRange(1));
viewLimits(2,1) = max(1, gds.viewCenter(2) - gds.viewRange(2));
viewLimits(3,1) = max(1, gds.viewCenter(3) - gds.viewRange(3));
viewLimits(1,2) = min(gds.maskSize(1), gds.viewCenter(1) + gds.viewRange(1));
viewLimits(2,2) = min(gds.maskSize(2), gds.viewCenter(2) + gds.viewRange(2));
viewLimits(3,2) = min(gds.maskSize(3), gds.viewCenter(3) + gds.viewRange(3));
gds.viewLimits = viewLimits;
return


function InitializeBaseStrands
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
numBaseStrands = numel(baseStrandIDList);
baseStrandCell = [];
for baseStrandIter = 1:numBaseStrands,
    baseStrandID = baseStrandIDList(baseStrandIter);
    baseStrandCell{baseStrandIter} = num2str(baseStrandID);
end%for baseStrandIter = 1:numBaseStrands,
set(handles.baseStrandListbox,'String',baseStrandCell);
gds.baseStrandCell = baseStrandCell;
return



function GenerateBasicView
global gds
handles = gds.handles;
maskSize = gds.maskSize;
AllVerts = gds.Vertices.AllVerts;
viewLimits = gds.viewLimits;
baseStrandIDList = gds.baseStrandIDList;
largeMarkerThresholdRadius = gds.largeMarkerThresholdRadius;
largeMarkerSize = gds.largeMarkerSize;
smallMarkerSize = gds.smallMarkerSize;
showDownstreamFlowFlag = gds.showDownstreamFlowFlag;
showUpstreamFlowFlag = gds.showUpstreamFlowFlag;
downstreamBranchList = gds.downstreamBranchList;
downstreamBranches = gds.downstreamBranches;
upstreamBranchList = gds.upstreamBranchList;
upstreamBranches = gds.upstreamBranches;
showRadiiFlag = gds.showRadiiFlag;
hideGrayFlag = gds.hideGrayFlag;
%-----
gds.Strands;
numStrands = numel(gds.Strands);
myGray = [0.7 0.7 0.7];

set(handles.processingText,'Visible','on');pause(0.1)
f11 = figure(11);hold off
cameratoolbar
mycamva = camva; mycampos = campos; mycamup = camup; mycamtarget = camtarget;
vl = viewLimits;
axis equal
PlotOutlineBox(viewLimits);

for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = gds.Strands(thisStrandID);
    thisYXZ = thisStrand.YXZLimits;
    allOutsideFlag = 0;
    if thisYXZ(1,2) < vl(1,1), allOutsideFlag = 1; end
    if thisYXZ(1,1) > vl(1,2), allOutsideFlag = 1; end
    if thisYXZ(2,2) < vl(2,1), allOutsideFlag = 1; end
    if thisYXZ(2,1) > vl(2,2), allOutsideFlag = 1; end
    if thisYXZ(3,2) < vl(3,1), allOutsideFlag = 1; end
    if thisYXZ(3,1) > vl(3,2), allOutsideFlag = 1; end
    if allOutsideFlag == 0,
        visibleFlag = 0;
        medianRadius = thisStrand.MedianRadius;
        if hideGrayFlag == 0, visibleFlag = 1; end
        if ismember(thisStrandID,baseStrandIDList), visibleFlag = 1; end;
        if showDownstreamFlowFlag == 1 && downstreamBranchList(thisStrandID)<=downstreamBranches, visibleFlag = 1; end
        if showUpstreamFlowFlag == 1 && upstreamBranchList(thisStrandID)<=upstreamBranches, visibleFlag = 1; end
        if ~(smallMarkerSize == 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
            iv = thisStrand.InteriorVertices;
            ev = [thisStrand.StartVertexIndex,thisStrand.EndVertexIndex];
            medianLabel = thisStrand.MedianLabel;
            medianVoltage = thisStrand.MedianVoltage;
            voltageDrop = thisStrand.VoltageDrop;
            thisCurrent = thisStrand.strandCurrent;
            cc = AllVerts(iv,:);
            f1 = and(cc(:,1)>=vl(1,1) , cc(:,1)<=vl(1,2));
            f2 = and(cc(:,2)>=vl(2,1) , cc(:,2)<=vl(2,2));
            f3 = and(cc(:,3)>=vl(3,1) , cc(:,3)<=vl(3,2));
            ff = and(and(f1,f2),f3);
            subcc = cc(ff,:);
            if ~isempty(subcc),
                p1 = plot3(subcc(:,1),subcc(:,2),-1*subcc(:,3),'k.');
                strandData.strandID = thisStrandID;
                strandData.medianRadius = medianRadius;
                strandData.medianVoltage = medianVoltage;
                strandData.voltageDrop = voltageDrop;
                strandData.current = thisCurrent;
                strandData.medianLabel = medianLabel;
                set(p1,'MarkerSize',largeMarkerSize);
                set(p1,'MarkerEdgeColor',myGray);
                set(p1,'UserData',strandData);
                %---
                myString1 = ['get(gco,''UserData'')'];
                set(p1,'ButtonDownFcn','FV_GetStrandInfo');
                %---
                if medianRadius <= largeMarkerThresholdRadius,
                    set(p1,'Marker','.','MarkerSize',smallMarkerSize+0.1);
                end%if medianRadius < largeMarkerThresholdRadius,
                %---
                if ismember(thisStrandID,baseStrandIDList),
                    set(p1,'MarkerEdgeColor','green');
                end%if ismember(thisStrandID,baseStrandIDList)
                %---
                if showDownstreamFlowFlag == 1,
                    if downstreamBranchList(thisStrandID)<=downstreamBranches,
                        set(p1,'MarkerEdgeColor','blue');
                    end%if downstreamBranchList(thisStrandID)<=downstreamBranches,
                end%if showDownstreamFlowFlag == 1,
                %---
                if showUpstreamFlowFlag == 1,
                    if upstreamBranchList(thisStrandID)<=upstreamBranches,
                        set(p1,'MarkerEdgeColor','red');
                    end%if upstreamBranchList(thisStrandID)<=upstreamBranches,
                end%if showUpstreamFlowFlag == 1,
                %---
                if showRadiiFlag == 1,
                    if medianRadius<0, keyboard, end
                    set(p1,'Markersize',(medianRadius+0.1).*largeMarkerSize);
                end
                %---
                if sum(get(p1,'MarkerEdgeColor')==myGray) == 3 && hideGrayFlag == 1,
                    set(p1,'Visible','off');
                end
            end%if ~isempty(subcc),
        end% if ~(smallMarkerSize > 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
        %---
    end%if allOutsideFlag == 0,
end%for strandIter = 1:numStrands,
camva(mycamva);
campos(mycampos);
camup(mycamup);
camtarget(mycamtarget);

% if showDownstreamFlowFlag == 1, GenerateDownstreamView; end
% if showUpstreamFlowFlag == 1, GenerateUpstreamView; end
set(handles.processingText,'Visible','off');
return




function PlotOutlineBox(viewLimits)
vl = viewLimits;
plot3([vl(1,1),vl(1,2)],[vl(2,1),vl(2,1)],-1*[vl(3,1),vl(3,1)],'r-');hold on
plot3([vl(1,1),vl(1,1)],[vl(2,1),vl(2,2)],-1*[vl(3,1),vl(3,1)],'g-');
plot3([vl(1,1),vl(1,1)],[vl(2,1),vl(2,1)],-1*[vl(3,1),vl(3,2)],'b-');  
xlabel('Axis 1');
ylabel('Axis 2');
zlabel('Axis 3');
axis equal
return    
%     
%     
% function GenerateDownstreamView 
% global gds
% maskSize = gds.maskSize;
% AllVerts = gds.Vertices.AllVerts;
% viewLimits = gds.viewLimits;
% baseStrandIDList = gds.baseStrandIDList;
% largeMarkerThresholdRadius = gds.largeMarkerThresholdRadius;
% largeMarkerSize = gds.largeMarkerSize;
% smallMarkerSize = gds.smallMarkerSize;
% %-----
% gds.Strands;
% numStrands = numel(gds.Strands);
% 













% --- Outputs from this function are returned to the command line.
function varargout = FlowVisualizer_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in enterBaseStrandButton.
function enterBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to enterBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in loadBaseStrandSetButton.
function loadBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in addSelectedStrandButton.
function addSelectedStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to addSelectedStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in clearBaseStrandSetButton.
function clearBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to clearBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in saveBaseStrandSetButton.
function saveBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --- Executes on button press in addBaseStrandButton.
function addBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to addBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
baseStrandIDList = gds.baseStrandIDList;
numStrands = numel(gds.Strands);
newBaseStrandID = round(str2num(get(handles.baseStrandEdit,'String')));
if newBaseStrandID >0 && newBaseStrandID < numStrands,
    baseStrandIDList = [baseStrandIDList,newBaseStrandID];
end%if newBaseStrandID >0 && newBaseStrandID < numStrands,
gds.baseStrandIDList = baseStrandIDList;
InitializeBaseStrands
CalculateDownstreamPaths
CalculateUpstreamPaths
GenerateBasicView;


% --- Executes on button press in removeBaseStrandButton.
function removeBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
baseStrandIDList = gds.baseStrandIDList;
selectedBaseStrandPos = get(handles.baseStrandListbox,'Value');
if numel(baseStrandIDList)>1,
    baseStrandIDList = baseStrandIDList([1:selectedBaseStrandPos-1,selectedBaseStrandPos+1:end]);
end%if numel(baseStrandIDList)>1,
gds.baseStrandIDList = baseStrandIDList;
InitializeBaseStrands
CalculateDownstreamPaths
CalculateUpstreamPaths
GenerateBasicView;


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in showDownstreamFlowButton.
function showDownstreamFlowButton_Callback(hObject, eventdata, handles)
% hObject    handle to showDownstreamFlowButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showDownstreamFlowButton
global gds
gds.showDownstreamFlowFlag = get(hObject,'Value');
GenerateBasicView


% --- Executes on button press in showUpstreamFlowButton.
function showUpstreamFlowButton_Callback(hObject, eventdata, handles)
% hObject    handle to showUpstreamFlowButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showUpstreamFlowButton
global gds
gds.showUpstreamFlowFlag = get(hObject,'Value');
GenerateBasicView


% --- Executes on selection change in downstreamBranchesMenu.
function downstreamBranchesMenu_Callback(hObject, eventdata, handles)
% hObject    handle to downstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns downstreamBranchesMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from downstreamBranchesMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString);
gds.downstreamBranches = menuVal;
GenerateBasicView

% --- Executes during object creation, after setting all properties.
function downstreamBranchesMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to downstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in upstreamBranchesMenu.
function upstreamBranchesMenu_Callback(hObject, eventdata, handles)
% hObject    handle to upstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns upstreamBranchesMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from upstreamBranchesMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString);
gds.upstreamBranches = menuVal;
GenerateBasicView

% --- Executes during object creation, after setting all properties.
function upstreamBranchesMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to upstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in Axis1RangeMenu.
function Axis1RangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to Axis1RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns Axis1RangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Axis1RangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(1) = menuVal;
GetViewLimits
GenerateBasicView




% --- Executes during object creation, after setting all properties.
function Axis1RangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Axis1RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in AxisTwoRangeMenu.
function AxisTwoRangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to AxisTwoRangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns AxisTwoRangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from AxisTwoRangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(2) = menuVal;
GetViewLimits
GenerateBasicView



% --- Executes during object creation, after setting all properties.
function AxisTwoRangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AxisTwoRangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in Axis3RangeMenu.
function Axis3RangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to Axis3RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns Axis3RangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Axis3RangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(3) = menuVal;
GetViewLimits
GenerateBasicView





% --- Executes during object creation, after setting all properties.
function Axis3RangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Axis3RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter1Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter1Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter1Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(1) = editVal;
GetViewLimits
GenerateBasicView


% --- Executes during object creation, after setting all properties.
function viewRangeCenter1Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter2Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter2Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter2Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(2) = editVal;
GetViewLimits
GenerateBasicView


% --- Executes during object creation, after setting all properties.
function viewRangeCenter2Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter3Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter3Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter3Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(3) = editVal;
GetViewLimits
GenerateBasicView


% --- Executes during object creation, after setting all properties.
function viewRangeCenter3Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in smallMarkerSizeMenu.
function smallMarkerSizeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to smallMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns smallMarkerSizeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from smallMarkerSizeMenu
global gds
smallMarkerSizeList = get(hObject,'String');
smallMarkerSizeChoice = get(hObject,'Value');
smallMarkerSize = str2num(smallMarkerSizeList{smallMarkerSizeChoice});
gds.smallMarkerSize = smallMarkerSize;
GenerateBasicView

% --- Executes during object creation, after setting all properties.
function smallMarkerSizeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to smallMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in largeMarkerSizeMenu.
function largeMarkerSizeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to largeMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns largeMarkerSizeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from largeMarkerSizeMenu
global gds
largeMarkerSizeList = get(hObject,'String');
largeMarkerSizeChoice = get(hObject,'Value');
largeMarkerSize = str2num(largeMarkerSizeList{largeMarkerSizeChoice});
gds.largeMarkerSize = largeMarkerSize;
GenerateBasicView

% --- Executes during object creation, after setting all properties.
function largeMarkerSizeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to largeMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function thresholdRadiusEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdRadiusEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdRadiusEdit as a double
global gds
newRadius = str2num(get(hObject,'String'));
newRadius = max(0,min(999,newRadius));
gds.largeMarkerThresholdRadius = newRadius;
GenerateBasicView


% --- Executes during object creation, after setting all properties.
function thresholdRadiusEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in showRadiiButton.
function showRadiiButton_Callback(hObject, eventdata, handles)
% hObject    handle to showRadiiButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
gds.showRadiiFlag = get(hObject,'Value');
if gds.showRadiiFlag == 1,
    set(handles.largeMarkerSizeText,'String','Radius Multiplier');
else
    set(handles.largeMarkerSizeText,'String','Large Marker Size');
end    
GenerateBasicView



% --- Executes on button press in hideGrayButton.
function hideGrayButton_Callback(hObject, eventdata, handles)
% hObject    handle to hideGrayButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
gds.hideGrayFlag = get(hObject,'Value');
GenerateBasicView



















function CalculateDownstreamPaths
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
downstreamPathList = [];
numStrands = numel(gds.Strands);
downstreamBranchList = zeros(numStrands,1) + Inf;


stopVoltage = 50.1;%Hardcode;
minimumFluxFraction = 1/3000;%Hardcode

set(handles.processingText,'Visible','on');pause(0.1);
numBaseStrands = numel(baseStrandIDList);
proceedFlag = 1;
if numBaseStrands > 5,
    myQuery = questdlg('Calculate Downstream Paths for ALL base strands?','This may take awhile','Proceed','Abort','Proceed');
    if strmatch(myQuery,'Abort'), proceedFlag = 0; end
    pause(0.1);
end%if numBaseStrands > 10,
if proceedFlag == 1,
    for baseStrandIter = 1:numBaseStrands;
        baseStrandID = baseStrandIDList(baseStrandIter);
        baseStrand = gds.Strands(baseStrandID);
        bsiv = baseStrand.InteriorVertices;
        baseStrandCoordList = gds.Vertices.AllVerts(bsiv,:);
        strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
        nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        pathActiveFlagList = false(1,100000);
        pathActiveFlagList(1) = 1;
        numActivePath = sum(pathActiveFlagList);
        strandPathList = {};
        nodePathList = {};
        fractionPathList = {};
        strandPathList{1} = baseStrandID;
        nodePathList{1} = [highNode lowNode];
        fractionPathList{1} = 1;
        strandFlowList = zeros(numStrands,1);
        strandFlowList(baseStrandID) = 1;
        strandVoltageList = zeros(numStrands,1);
        strandVoltageList(1) = mean([highVoltage,lowVoltage]);
        pathCounter = 1;
        keepGoingFlag = 1;


        while (keepGoingFlag == 1),
            myCount = 0;
            for pathIter = find(pathActiveFlagList == 1);
                currentPathID = pathIter;
                currentStrandPath = strandPathList{pathIter};
                currentNodePath = nodePathList{pathIter};
                currentFractionPath = fractionPathList{pathIter};
                currentStrandID = currentStrandPath(end);
                currentStrand = gds.Strands(currentStrandID);
                %-----
                strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
                nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
                [highVoltage,highVoltagePos] = max(nodeVoltages);
                [lowVoltage,lowVoltagePos] = min(nodeVoltages);
                highNode = strandNodes(highVoltagePos);
                lowNode = strandNodes(strandNodes~=highNode);
                lowAttachedStrands = gds.Vertices.StrandIndices(lowNode,:);
                lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
                lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
                numDaughterPaths = numel(lowAttachedStrands);
                strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
                stopTracingFlag = 0;
                if numDaughterPaths == 0, stopTracingFlag = 1; end
                if lowVoltage < stopVoltage, stopTracingFlag = 1; end
                if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
                if stopTracingFlag == 1,
                    pathActiveFlagList(currentPathID) = 0;
                else%if stopTracingFlag == 1,
                    motherCurrent = abs(currentStrand.strandCurrent);
                    validDaughterCounter = 0;
                    validDaughterStrandList = [];
                    validDaughterCurrentList = zeros(1,numDaughterPaths);
                    validDaughterPathIndexList = [];
                    for daughterIter = 1:numDaughterPaths,
                        %Check to see if the daughter strand leads to a lower voltage
                        candidateDaughterID = lowAttachedStrands(daughterIter);
                        candidateDaughterStrand = gds.Strands(candidateDaughterID);
                        candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                        candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                        candidateDaughterOtherVoltage = gds.Vertices.AllVoltages(candidateDaughterOtherNode);
                        if candidateDaughterOtherVoltage < lowVoltage,
                            %if so, add the strand to a path
                            myCount = myCount + 1;
                            validDaughterCounter = validDaughterCounter + 1;
                            validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                            validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                            if validDaughterCounter == 1,
                                %if this is the first valid daughter, add to current path
                                strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                                validDaughterPathIndexList(1) = currentPathID;
                            else%if validDaughterCounter == 1,
                                %if not the first daughter, duplicate path up to this point, and
                                %make new path
                                pathCounter = pathCounter + 1;
                                strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                                fractionPathList{pathCounter} = currentFractionPath;
                                pathActiveFlagList(pathCounter) = 1;  
                                validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                            end%if-else validDaughterCounter == 1,
                        end%if candidateDaughterOtherVoltage < lowVoltage,
                    end%for daughterIter = 1:numDaughterPaths,
                    clear daughterIter
                    %-----
                    daughterSumCurrent = sum(validDaughterCurrentList);
                    fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                    for validDaughterIter = 1:validDaughterCounter;
                        validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                        validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                        fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                        strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    end%for validDaughterIter = 1:validDaughterCounter;
                end%if-else stopTracingFlag == 1,
            end%for pathIter = find(pathActiveFlagList == 1);
            if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
            if myCount == 0, keepGoingFlag = 0;end
        end%while (keepGoingFlag == 1),
        downstreamPathList{baseStrandIter} = strandPathList;
    end%for baseStrandIter = 1:numBaseStrands;

    for baseStrandIter = 1:numBaseStrands;
        thisPathSet = downstreamPathList{baseStrandIter};
        for pathIter = 1:numel(thisPathSet),
            thisPath = thisPathSet{pathIter};
            thisPath = thisPath(2:end);
            posList = [1:numel(thisPath)]';
            downstreamBranchList(thisPath) = min(downstreamBranchList(thisPath),posList);
        end%for pathIter = 1:numel(thisPathSet);
    end%for baseStrandIter = ...
end%if proceedFlag == 1;
     
gds.downstreamPathList = downstreamPathList;
gds.downstreamBranchList = downstreamBranchList;
set(handles.processingText,'Visible','off');




function CalculateUpstreamPaths
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
upstreamPathList = [];
numStrands = numel(gds.Strands);
upstreamBranchList = zeros(numStrands,1) + Inf;


stopVoltage = 99.9;%Hardcode;
minimumFluxFraction = 1/3000;%Hardcode

set(handles.processingText,'Visible','on');pause(0.1);
numBaseStrands = numel(baseStrandIDList);
proceedFlag = 1;
if numBaseStrands > 5,
    myQuery = questdlg('Calculate Upstream Paths for ALL base strands?','This may take awhile','Proceed','Abort','Proceed');
    if strmatch(myQuery,'Abort'), proceedFlag = 0; end
    pause(0.1);
end%if numBaseStrands > 10,
if proceedFlag == 1,
    for baseStrandIter = 1:numBaseStrands;
        baseStrandID = baseStrandIDList(baseStrandIter);
        baseStrand = gds.Strands(baseStrandID);
        bsiv = baseStrand.InteriorVertices;
        baseStrandCoordList = gds.Vertices.AllVerts(bsiv,:);
        strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
        nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        pathActiveFlagList = false(1,100000);
        pathActiveFlagList(1) = 1;
        numActivePath = sum(pathActiveFlagList);
        strandPathList = {};
        nodePathList = {};
        fractionPathList = {};
        strandPathList{1} = baseStrandID;
        nodePathList{1} = [highNode lowNode];
        fractionPathList{1} = 1;
        strandFlowList = zeros(numStrands,1);
        strandFlowList(baseStrandID) = 1;
        strandVoltageList = zeros(numStrands,1);
        strandVoltageList(1) = mean([highVoltage,lowVoltage]);
        pathCounter = 1;
        keepGoingFlag = 1;


        while (keepGoingFlag == 1),
            myCount = 0;
            for pathIter = find(pathActiveFlagList == 1);
                currentPathID = pathIter;
                currentStrandPath = strandPathList{pathIter};
                currentNodePath = nodePathList{pathIter};
                currentFractionPath = fractionPathList{pathIter};
                currentStrandID = currentStrandPath(end);
                currentStrand = gds.Strands(currentStrandID);
                %-----
                strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
                nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
                [highVoltage,highVoltagePos] = max(nodeVoltages);
                [lowVoltage,lowVoltagePos] = min(nodeVoltages);
                highNode = strandNodes(highVoltagePos);
                lowNode = strandNodes(strandNodes~=highNode);
                highAttachedStrands = gds.Vertices.StrandIndices(highNode,:);
                highAttachedStrands = highAttachedStrands(highAttachedStrands~=0);
                highAttachedStrands = highAttachedStrands(highAttachedStrands~=currentStrandID);
                numDaughterPaths = numel(highAttachedStrands);
                strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
                stopTracingFlag = 0;
                if numDaughterPaths == 0, stopTracingFlag = 1; end
                if highVoltage > stopVoltage, stopTracingFlag = 1; end
                if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
                if stopTracingFlag == 1,
                    pathActiveFlagList(currentPathID) = 0;
                else%if stopTracingFlag == 1,
                    motherCurrent = abs(currentStrand.strandCurrent);
                    validDaughterCounter = 0;
                    validDaughterStrandList = [];
                    validDaughterCurrentList = zeros(1,numDaughterPaths);
                    validDaughterPathIndexList = [];
                    for daughterIter = 1:numDaughterPaths,
                        %Check to see if the daughter strand leads to a lower voltage
                        candidateDaughterID = highAttachedStrands(daughterIter);
                        candidateDaughterStrand = gds.Strands(candidateDaughterID);
                        candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                        candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=highNode);
                        candidateDaughterOtherVoltage = gds.Vertices.AllVoltages(candidateDaughterOtherNode);
                        if candidateDaughterOtherVoltage > highVoltage,
                            %if so, add the strand to a path
                            myCount = myCount + 1;
                            validDaughterCounter = validDaughterCounter + 1;
                            validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                            validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                            if validDaughterCounter == 1,
                                %if this is the first valid daughter, add to current path
                                strandPathList{currentPathID} = [currentStrandPath, highAttachedStrands(daughterIter)];
                                nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                                validDaughterPathIndexList(1) = currentPathID;
                            else%if validDaughterCounter == 1,
                                %if not the first daughter, duplicate path up to this point, and
                                %make new path
                                pathCounter = pathCounter + 1;
                                strandPathList{pathCounter} = [currentStrandPath, highAttachedStrands(daughterIter)];
                                nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                                fractionPathList{pathCounter} = currentFractionPath;
                                pathActiveFlagList(pathCounter) = 1;  
                                validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                            end%if-else validDaughterCounter == 1,
                        end%if candidateDaughterOtherVoltage > highVoltage,
                    end%for daughterIter = 1:numDaughterPaths,
                    clear daughterIter
                    %-----
                    daughterSumCurrent = sum(validDaughterCurrentList);
                    fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                    for validDaughterIter = 1:validDaughterCounter;
                        validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                        validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                        fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                        strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    end%for validDaughterIter = 1:validDaughterCounter;
                end%if-else stopTracingFlag == 1,
            end%for pathIter = find(pathActiveFlagList == 1);
            if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
            if myCount == 0, keepGoingFlag = 0;end
        end%while (keepGoingFlag == 1),
        upstreamPathList{baseStrandIter} = strandPathList;
    end%for baseStrandIter = 1:numBaseStrands;

    for baseStrandIter = 1:numBaseStrands;
        thisPathSet = upstreamPathList{baseStrandIter};
        for pathIter = 1:numel(thisPathSet),
            thisPath = thisPathSet{pathIter};
            thisPath = thisPath(2:end);
            posList = [1:numel(thisPath)]';
            upstreamBranchList(thisPath) = min(upstreamBranchList(thisPath),posList);
        end%for pathIter = 1:numel(thisPathSet);
    end%for baseStrandIter = ...
end%if proceedFlag == 1;
     
gds.upstreamPathList = upstreamPathList;
gds.upstreamBranchList = upstreamBranchList;
set(handles.processingText,'Visible','off');



 


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
% menuVal = str2num(menuString);
% gds.viewRange(3) = menuVal;
% GetViewLimits
% GenerateBasicView

% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu9.
function popupmenu9_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu9 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu9


% --- Executes during object creation, after setting all properties.
function popupmenu9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in baseStrandListbox.
function baseStrandListbox_Callback(hObject, eventdata, handles)
% hObject    handle to baseStrandListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns baseStrandListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from baseStrandListbox
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};

% --- Executes during object creation, after setting all properties.
function baseStrandListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to baseStrandListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.



