function varargout = FVClotModule(varargin)
% FVCLOTMODULE M-file for FVClotModule.fig
%      FVCLOTMODULE, by itself, creates a new FVCLOTMODULE or raises the existing
%      singleton*.
%
%      H = FVCLOTMODULE returns the handle to a new FVCLOTMODULE or the handle to
%      the existing singleton*.
%
%      FVCLOTMODULE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FVCLOTMODULE.M with the given input arguments.
%
%      FVCLOTMODULE('Property','Value',...) creates a new FVCLOTMODULE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FVClotModule_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FVClotModule_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FVClotModule

% Last Modified by GUIDE v2.5 09-Mar-2011 12:06:57

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FVClotModule_OpeningFcn, ...
                   'gui_OutputFcn',  @FVClotModule_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FVClotModule is made visible.
function FVClotModule_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FVClotModule (see VARARGIN)

% Choose default command line output for FVClotModule
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


%-----------------------------
%-----------------------------
%------- MY CODE -------------
%-----------------------------
%-----------------------------

global gds;%gds = globalDataStructure;
% UIWAIT makes FVClotModule wait for user response (see UIRESUME)
% uiwait(handles.figure1);





% --- Outputs from this function are returned to the command line.
function varargout = FVClotModule_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in clotThisStrandButton.
function clotThisStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to clotThisStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
selectedStrandID = gds.selectedStrandData.strandID;
clotAnalysisParameters = gds.clotAnalysisParameters;
if clotAnalysisParameters.clotStrandID(1) == 0,
    clotAnalysisParameters.clotStrandID = selectedStrandID;
else%if clotAnalysisParameters.clotStrandID(1) == 0,
    clotAnalysisParameters.clotStrandID = [clotAnalysisParameters.clotStrandID,selectedStrandID];
end%if clotAnalysisParameters.clotStrandID(1) == 0,
    %----------
disp('Calculating Perturbed flow');
clotProject = [];
clotProject.circuitAnalysisParameters = clotAnalysisParameters;
clotProject.vectorizedStructure.maskSize = gds.maskSize;
clotProject.vectorizedStructure.Vertices = gds.Vertices;
clotProject.vectorizedStructure.Strands = gds.Strands;
    
    clotProject = CalculateFlowWithClot(clotProject);
    
gds.Vertices = clotProject.vectorizedStructure.Vertices;
gds.Strands = clotProject.vectorizedStructure.Strands;
gds.clotAnalysisParameters = clotProject.circuitAnalysisParameters;
%---
for strandIter = 1:numel(gds.Strands),
    cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
    yxzLim(:,1) = min(cc,[],1)';
    yxzLim(:,2) = max(cc,[],1)';
    gds.Strands(strandIter).YXZLimits = yxzLim;
    gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianVoltage = median(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
            min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
end%for strandIter = 1:numel(gds.Strands),
disp('DONE');






% --- Executes on button press in restoreThisStrandButton.
function restoreThisStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to restoreThisStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
selectedStrandID = gds.selectedStrandData.strandID;
clotAnalysisParameters = gds.clotAnalysisParameters;
clotStrandID = clotAnalysisParameters.clotStrandID;


clotStrandID = clotStrandID(~ismember(clotStrandID,selectedStrandID));
if isempty(clotStrandID), 
    clotStrandID = [0];
end

clotAnalysisParameters.strandConductanceList(selectedStrandID) = gds.clotAnalysisParameters.originalConductanceList(selectedStrandID);
clotAnalysisParameters.clotStrandID = clotStrandID;
%----------
disp('Calculating Perturbed flow');
clotProject = [];
clotProject.circuitAnalysisParameters = clotAnalysisParameters;
clotProject.vectorizedStructure.maskSize = gds.maskSize;
clotProject.vectorizedStructure.Vertices = gds.Vertices;
clotProject.vectorizedStructure.Strands = gds.Strands;

    clotProject = CalculateFlowWithClot(clotProject);
    
gds.Vertices = clotProject.vectorizedStructure.Vertices;
gds.Strands = clotProject.vectorizedStructure.Strands;
gds.clotAnalysisParameters = clotProject.circuitAnalysisParameters;
%---
for strandIter = 1:numel(gds.Strands),
    cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
    yxzLim(:,1) = min(cc,[],1)';
    yxzLim(:,2) = max(cc,[],1)';
    gds.Strands(strandIter).YXZLimits = yxzLim;
    gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).MedianVoltage = mode(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
            min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
end%for strandIter = 1:numel(gds.Strands),
disp('DONE');



% --- Executes on button press in stallViewButton.
function stallViewButton_Callback(hObject, eventdata, handles)
% hObject    handle to stallViewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in currentViewButton.
function currentViewButton_Callback(hObject, eventdata, handles)
% hObject    handle to currentViewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


