function varargout = FVTraceDownModule(varargin)
% FVTRACEDOWNMODULE M-file for FVTraceDownModule.fig
%      FVTRACEDOWNMODULE, by itself, creates a new FVTRACEDOWNMODULE or raises the existing
%      singleton*.
%
%      H = FVTRACEDOWNMODULE returns the handle to a new FVTRACEDOWNMODULE or the handle to
%      the existing singleton*.
%
%      FVTRACEDOWNMODULE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FVTRACEDOWNMODULE.M with the given input arguments.
%
%      FVTRACEDOWNMODULE('Property','Value',...) creates a new FVTRACEDOWNMODULE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FVTraceDownModule_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FVTraceDownModule_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FVTraceDownModule

% Last Modified by GUIDE v2.5 09-Mar-2011 11:20:49

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FVTraceDownModule_OpeningFcn, ...
                   'gui_OutputFcn',  @FVTraceDownModule_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FVTraceDownModule is made visible.
function FVTraceDownModule_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FVTraceDownModule (see VARARGIN)

% Choose default command line output for FVTraceDownModule
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FVTraceDownModule wait for user response (see UIRESUME)
% uiwait(handles.figure1);
global gds

baseStrandIDList = gds.baseStrandIDList;






% --- Outputs from this function are returned to the command line.
function varargout = FVTraceDownModule_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in traceDownButton.
function traceDownButton_Callback(hObject, eventdata, handles)
% hObject    handle to traceDownButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
startStrandList = gds.baseStrandIDList;
cutoffRadius = str2num(get(handles.cutoffRadiusEdit,'String'));
cutoffVoltage = str2num(get(handles.cutoffVoltageEdit,'String'));


Strands = gds.Strands;
StrandIndices = gds.Vertices.StrandIndices;
AllVoltages = gds.Vertices.AllVoltages;
AllVerts = gds.Vertices.AllVerts;
AllRadii = gds.Vertices.AllRadii;
maskSize = gds.maskSize;
numStrands = numel(Strands);

numChanged = 999;
belowCutoffStrandList = [];
cycleCounter = 0;
while numChanged > 0,
    cycleCounter = cycleCounter+1;
    newStartStrandList = [];
    numChanged = 0;
    numStartStrands = numel(startStrandList);
    for startStrandIter = 1:numStartStrands;
        startStrandID = startStrandList(startStrandIter);
        startStrand = Strands(startStrandID);
        ssiv = startStrand.InteriorVertices;
        startStrandCoordList = AllVerts(ssiv,:);
        strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);
        %Look at the low node, and find neighbors
        if lowVoltagePos == 1,
            neighborStrands = startStrand.StartVertexNeighborStrands;
        else%if lowVoltagePos == 1,
            neighborStrands = startStrand.EndVertexNeighborStrands;
        end%if-else lowVoltagePos == 1,
        neighborStrands = neighborStrands(neighborStrands~=startStrandID);
        daughterConductance(1) = Strands(neighborStrands(1)).strandConductance;
        daughterConductance(2) = Strands(neighborStrands(2)).strandConductance;
        conductanceRatio = min(daughterConductance)./max(daughterConductance);
        maxZ = max(startStrandCoordList(:,3));
        
        for neighborIter = 1:numel(neighborStrands);
            thisNeighborID = neighborStrands(neighborIter);
            thisNeighborStrand = Strands(thisNeighborID);
            thisRadius = median(AllRadii(thisNeighborStrand.InteriorVertices));
            thisVoltage = median(AllVoltages(thisNeighborStrand.InteriorVertices));
            neighborNodes = [thisNeighborStrand.StartVertexIndex,thisNeighborStrand.EndVertexIndex];
            neighborNodeVoltages = AllVoltages(neighborNodes);
            sharedNodeVoltagePos = find(ismember(neighborNodeVoltages,nodeVoltages));
            sharedNodeVoltage = neighborNodeVoltages(sharedNodeVoltagePos(1));
            otherNodeVoltage = neighborNodeVoltages(neighborNodeVoltages~=sharedNodeVoltage);
            %---
            failTestFlag = 0;
            if otherNodeVoltage>=sharedNodeVoltage, failTestFlag = 1; end %daughter must be receiving flow from mother strand
            if thisRadius <= cutoffRadius, failTestFlag = 1; end %daughter must be above cutoff radius
            if thisVoltage <= cutoffVoltage, failTestFlag = 1; end %daughter must be above cutoff voltage
            if ismember(thisNeighborID,startStrandList), failTestFlag = 1; end %daughter must not be existing start strand
            
            if failTestFlag == 1,
                belowCutoffStrandList = [belowCutoffStrandList,thisNeighborID];
            else%if failTestFlag == 1,
                newStartStrandList = [newStartStrandList,thisNeighborID];
            end%if failTestFlag == 1,
        end%for neighborIter = 1:numel(neighborStrands);
    end%for startStrandIter = 1:numStartStrands;
startStrandList = unique(newStartStrandList);
% numChanged = numel(startStrandList)-numStartStrands;
numChanged = numel(startStrandList);
end

cutoffStrandList = belowCutoffStrandList;
baseStrandIDList = cutoffStrandList;

defaultFileName = ['TraceDownBaseStrandIDList_r',num2str(cutoffRadius),'_v',num2str(cutoffVoltage)];
defaultFileName = [regexprep(defaultFileName,'\.','p'),'.mat'];
[fileName,pathName] = uiputfile({'*.mat'},'Save traceDownBaseStrandIDList as...',defaultFileName);
cd(pathName)
saveFileName = [fileName];
save(saveFileName,'baseStrandIDList');







function cutoffRadiusEdit_Callback(hObject, eventdata, handles)
% hObject    handle to cutoffRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cutoffRadiusEdit as text
%        str2double(get(hObject,'String')) returns contents of cutoffRadiusEdit as a double


% --- Executes during object creation, after setting all properties.
function cutoffRadiusEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cutoffRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cutoffVoltageEdit_Callback(hObject, eventdata, handles)
% hObject    handle to cutoffVoltageEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cutoffVoltageEdit as text
%        str2double(get(hObject,'String')) returns contents of cutoffVoltageEdit as a double


% --- Executes during object creation, after setting all properties.
function cutoffVoltageEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cutoffVoltageEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


