function varargout = FlowVisualizer(varargin)
% FLOWVISUALIZER M-file for FlowVisualizer.fig
%      FLOWVISUALIZER, by itself, creates a new FLOWVISUALIZER or raises the existing
%      singleton*.
%
%      H = FLOWVISUALIZER returns the handle to a new FLOWVISUALIZER or the handle to
%      the existing singleton*.
%
%      FLOWVISUALIZER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FLOWVISUALIZER.M with the given input arguments.
%
%      FLOWVISUALIZER('Property','Value',...) creates a new FLOWVISUALIZER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FlowVisualizer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FlowVisualizer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FlowVisualizer

% Last Modified by GUIDE v2.5 09-Aug-2011 16:35:26

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FlowVisualizer_OpeningFcn, ...
                   'gui_OutputFcn',  @FlowVisualizer_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FlowVisualizer is made visible.
function FlowVisualizer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FlowVisualizer (see VARARGIN)

% Choose default command line output for FlowVisualizer
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%-----------------------------
%-----------------------------
%------- MY CODE -------------
%-----------------------------
%-----------------------------

global gds;%gds = globalDataStructure;
global memgds;
% % % memgds = struct([]);
gds.handles = handles;
LoadVectorProject;
% set(0,'DefaultFigureRenderer','opengl');
uiwait(handles.figure1,1);
if gds.autoRefreshFlag, GenerateBasicView; end;


% UIWAIT makes FlowVisualizer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


function LoadVectorProject
global gds
global memgds
currentHandles = gds.handles;
%---
[fileName,pathName] = uigetfile({'*.mat'},'Select a vectorProject, flowProject or FV file');
if pathName~=0,
    cd(pathName)
    loadFileName = [fileName];
    set(currentHandles.processingText,'Visible','on');pause(0.1)
    load(loadFileName);
    set(currentHandles.processingText,'Visible','off')
end%if pathName~=0


if exist('flowProject','var'),
    vectorProject = flowProject;
    clear flowProject;
end;
if exist('vectorProject','var'),
    gds.maskSize = vectorProject.maskSize;
    gds.Strands = vectorProject.vectorizedStructure.Strands;
    gds.Vertices = vectorProject.vectorizedStructure.Vertices;
    gds.cellCentroidAndLabelList = vectorProject.cellCentroidAndLabelList;
    gds.circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
    gds.clotAnalysisParameters = gds.circuitAnalysisParameters;
    %---
    if isfield(vectorProject,'plungingArterioleTopStrandList'),
        gds.baseStrandIDList = vectorProject.plungingArterioleTopStrandList;
    end%if isfield(vectorProject,'plungingArterioleTopStrandList'),
end%if exist('vectorProject','var');


%---
gds.handles = currentHandles;
%---
if ~isfield(gds.Strands,'YXZLimits'),
    for strandIter = 1:numel(gds.Strands),
        cc = gds.Vertices.AllVerts(gds.Strands(strandIter).StartToEndIndices,:);
        yxzLim(:,1) = min(cc,[],1)';
        yxzLim(:,2) = max(cc,[],1)';
        gds.Strands(strandIter).YXZLimits = yxzLim;
        gds.Strands(strandIter).MedianRadius = median(gds.Vertices.AllRadii(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).MedianLabel = mode(gds.Vertices.AllLabels(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).MedianVoltage = median(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
        gds.Strands(strandIter).VoltageDrop = max(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:)) - ...
                min(gds.Vertices.AllVoltages(gds.Strands(strandIter).InteriorVertices,:));
    end%for strandIter = 1:numel(gds.Strands),
end%if ~isfield(gds.Strands,'YXZLimits'),
%---
if exist('vectorProject','var'),
    InitializeFVParameters;
    PopulateFields;
    CalculateDownstreamPaths
    CalculateUpstreamPaths
    clear vectorProject
else%if exist('vectorProject','var'),
    PopulateFields;
end%if exist('vectorProject','var'),
return


function SaveFVFile
global gds
global memgds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
saveFileName = ['FVFile_',datestr(now,'yyyy_mm_dd-HHMMSS'),'.mat'];
[fileName,pathName] = uiputfile(saveFileName,'Save FV as...');
cd(pathName)
saveFileName = [fileName];
set(handles.processingText,'Visible','on');pause(0.1)
save(saveFileName,'gds','memgds');
set(handles.processingText,'Visible','off');pause(0.1)






function InitializeFVParameters
global gds
gds.viewCenter = [500 500 100];
gds.viewRange = [100 100 100];
gds.smallMarkerSize = 1;
gds.largeMarkerSize = 5;
%---
gds.showDownstreamFlowFlag = 0;
gds.showUpstreamFlowFlag = 0;
gds.showSingleBaseFlag = 0;
gds.limitToClosestFlag = 0;
gds.downstreamBranches = 1;
gds.upstreamBranches = 1;
gds.maxBranchSearch = 2;
gds.thresholdRatio = 0.5;
gds.thresholdCurrent = median(abs(gds.circuitAnalysisParameters.strandCurrentList));
gds.thresholdTransitTime = 1;
%---
gds.centerOnClickFlag = 0;
gds.showRadiiFlag = 0;
gds.hideGrayFlag = 0;
gds.showBarrelsFlag = 0;
gds.autoRefreshFlag = 1;
gds.showNeuronsFlag = 0;
gds.showNonNeuronsFlag = 0;
gds.showGrayCentersFlag = 0;
gds.lowCurrentViewFlag = 0;
gds.currentRatioViewFlag = 0;
gds.longTransitTimeViewFlag = 0;
gds.dataMemSetFlag = 0;
gds.visibleLabelList = [];
%---
gds.largeMarkerThresholdRadius = 3;
if ~isfield(gds,'baseStrandIDList'),
    gds.baseStrandIDList = [1 2 3];
end%if ~isfield(gds,'baseStrandIDList'),
gds.currentSelectedBaseStrandIndex = 1;
%---
               

InitializeBaseStrands
GetViewLimits
figure(11);hold off
PlotOutlineBox(gds.viewLimits);

return


function GetViewLimits
global gds
viewLimits = zeros(3,2);
viewLimits(1,1) = max(1, gds.viewCenter(1) - gds.viewRange(1));
viewLimits(2,1) = max(1, gds.viewCenter(2) - gds.viewRange(2));
viewLimits(3,1) = max(1, gds.viewCenter(3) - gds.viewRange(3));
viewLimits(1,2) = min(gds.maskSize(1), gds.viewCenter(1) + gds.viewRange(1));
viewLimits(2,2) = min(gds.maskSize(2), gds.viewCenter(2) + gds.viewRange(2));
viewLimits(3,2) = min(gds.maskSize(3), gds.viewCenter(3) + gds.viewRange(3));


%HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE
%HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE
% viewLimits(3,2) = min(viewLimits(3,2),1400);
%HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE
%HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE HARDCODE



gds.viewLimits = viewLimits;
return


function PopulateFields
global gds
rangeList = [10 20 30 40 50 75 100 150 200 300 400 500 1000 1500 2000 5000];
branchRangeList = [1 2 3 4 5 6 7 8 9 10 12 14 16 18 20 25 30 40 50 100 1000];
largeMarkerRangeList = [1 2 3 4 5 6 7 8 9 10 12 14 16 18 20 25 30 40 50 100 200];
smallMarkerRangeList = [0 1 2 3 4 5 6 7 8 9 10 12 14 16 18 20 25 30 40 50 100 200];
InitializeBaseStrands
handles = gds.handles;
set(handles.centerOnClickButton,'Value',gds.centerOnClickFlag);
set(handles.showUpstreamFlowButton,'Value',gds.showUpstreamFlowFlag);
set(handles.showDownstreamFlowButton,'Value',gds.showDownstreamFlowFlag);
set(handles.downstreamBranchesMenu,'Value',find(branchRangeList == gds.downstreamBranches));
set(handles.upstreamBranchesMenu,'Value',find(branchRangeList == gds.upstreamBranches));
set(handles.smallMarkerSizeMenu,'Value',find(smallMarkerRangeList == gds.smallMarkerSize));
set(handles.largeMarkerSizeMenu,'Value',find(largeMarkerRangeList == gds.largeMarkerSize));
set(handles.Axis1RangeMenu,'Value',find(rangeList == gds.viewRange(1)));
set(handles.AxisTwoRangeMenu,'Value',find(rangeList == gds.viewRange(2)));
set(handles.Axis3RangeMenu,'Value',find(rangeList == gds.viewRange(3)));
set(handles.viewRangeCenter1Edit,'String',num2str(gds.viewCenter(1)));
set(handles.viewRangeCenter2Edit,'String',num2str(gds.viewCenter(2)));
set(handles.viewRangeCenter3Edit,'String',num2str(gds.viewCenter(3)));
set(handles.showRadiiButton,'Value',gds.showRadiiFlag);
set(handles.hideGrayButton,'Value',gds.hideGrayFlag);
set(handles.maxBranchSearchEdit,'String',num2str(gds.maxBranchSearch));
set(handles.showSingleBaseButton,'Value',gds.showSingleBaseFlag);
set(handles.limitToClosestButton,'Value',gds.limitToClosestFlag);
set(handles.baseStrandListbox,'Value',gds.currentSelectedBaseStrandIndex);
set(handles.showGrayCentersButton,'Value',gds.showGrayCentersFlag);
set(handles.showNeuronsButton,'Value',gds.showNeuronsFlag);
set(handles.showNonNeuronsButton,'Value',gds.showNonNeuronsFlag);
set(handles.autoRefreshButton,'Value',gds.autoRefreshFlag);
set(handles.thresholdRatioEdit,'String',num2str(gds.thresholdRatio));
set(handles.thresholdCurrentEdit,'String',num2str(gds.thresholdCurrent,'%0.1e'));







function InitializeBaseStrands
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
numBaseStrands = numel(baseStrandIDList);
baseStrandCell = [];
for baseStrandIter = 1:numBaseStrands,
    baseStrandID = baseStrandIDList(baseStrandIter);
    baseStrandCell{baseStrandIter} = num2str(baseStrandID);
end%for baseStrandIter = 1:numBaseStrands,
set(handles.baseStrandListbox,'String',baseStrandCell);
gds.baseStrandCell = baseStrandCell;
return



function GenerateBasicView
global gds
global memgds

convergenceViewFlag = 0; %HARDCODE
if isfield(gds.Strands(1),'convergenceValue'),convergenceViewFlag = 1; end%%HARDCODE
if ~isfield(gds,'visibleLabelList'), gds.visibleLabelList = [];end%%HARDCODE

% % bloodOx = gds.StrandBloodOx;

GetViewLimits
handles = gds.handles;
maskSize = gds.maskSize;
AllVerts = gds.Vertices.AllVerts;
viewLimits = gds.viewLimits;
baseStrandIDList = gds.baseStrandIDList;
largeMarkerThresholdRadius = gds.largeMarkerThresholdRadius;
largeMarkerSize = gds.largeMarkerSize;
smallMarkerSize = gds.smallMarkerSize;
showDownstreamFlowFlag = gds.showDownstreamFlowFlag;
showUpstreamFlowFlag = gds.showUpstreamFlowFlag;
limitToClosestFlag = gds.limitToClosestFlag;
downstreamBranchList = gds.downstreamBranchList;
downstreamBranches = gds.downstreamBranches;
upstreamBranchList = gds.upstreamBranchList;
upstreamBranches = gds.upstreamBranches;
showRadiiFlag = gds.showRadiiFlag;
hideGrayFlag = gds.hideGrayFlag;
showBarrelsFlag = gds.showBarrelsFlag;
showSingleBaseFlag = gds.showSingleBaseFlag;
showNeuronsFlag = gds.showNeuronsFlag;
showNonNeuronsFlag = gds.showNonNeuronsFlag;
showGrayCentersFlag = gds.showGrayCentersFlag;
currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
currentRatioList = abs(gds.clotAnalysisParameters.strandCurrentList ./gds.circuitAnalysisParameters.strandCurrentList);
strandCurrentList = gds.clotAnalysisParameters.strandCurrentList;
lowCurrentViewFlag = gds.lowCurrentViewFlag;
currentRatioViewFlag = gds.currentRatioViewFlag;
longTransitTimeViewFlag = gds.longTransitTimeViewFlag;
thresholdRatio = gds.thresholdRatio;
thresholdCurrent = gds.thresholdCurrent;
thresholdTransitTime = gds.thresholdTransitTime;
clotStrandID = gds.clotAnalysisParameters.clotStrandID;
%-----
gds.Strands;
numStrands = numel(gds.Strands);
myGray = [0.7 0.7 0.7];
myOrange = [1 0.66 0.0];

set(handles.processingText,'Visible','on');pause(0.1)
f11 = figure(11);hold off
gds.viewWindowHandle = f11;
h = datacursormode(f11);
set(h,'UpdateFcn',@FV_GiveStrandInfo,'DisplayStyle','window')
mycamva = camva; mycampos = campos; mycamup = camup; mycamtarget = camtarget;
PlotOutlineBox(viewLimits);
cameratoolbar
vl = viewLimits;
if or(mycamtarget(1)<vl(1,1) , mycamtarget(1)>vl(1,2)),
    if or(mycamtarget(2)<vl(2,1) , mycamtarget(2)>vl(2,2)),
        if or(mycamtarget(3)<vl(3,1) , mycamtarget(3)>vl(3,2)),
            mycamtarget = mean(viewLimits,2);
        end%if or..
    end%if or..
end%if or..

    
axis equal

blueColorList = [linspace(0,myGray(1),ceil(downstreamBranches))' , ...
    linspace(0,myGray(2),ceil(downstreamBranches))' , ...
    linspace(1,1,ceil(downstreamBranches))'];
redColorList = [linspace(1,1,ceil(upstreamBranches*1))' , ...
    linspace(0,myGray(2),ceil(upstreamBranches*1))' , ...
    linspace(0,myGray(3),ceil(upstreamBranches*1))'];

[minBranch,closestBaseIndexList] = min(downstreamBranchList,[],2);

if showSingleBaseFlag == 1,
    downstreamBranchList(:,1:gds.currentSelectedBaseStrandIndex-1)= inf;
    downstreamBranchList(:,gds.currentSelectedBaseStrandIndex+1:end)= inf;
    upstreamBranchList(:,1:gds.currentSelectedBaseStrandIndex-1)= inf;
    upstreamBranchList(:,gds.currentSelectedBaseStrandIndex+1:end)= inf;
% % %     baseStrandIDList = baseStrandIDList(gds.currentSelectedBaseStrandIndex);
end

ccl = gds.cellCentroidAndLabelList;
f1 = and(ccl(:,1) > vl(1,1) , ccl(:,1) < vl(1,2));
f2 = and(ccl(:,2) > vl(2,1) , ccl(:,2) < vl(2,2));
f3 = and(ccl(:,3) > vl(3,1) , ccl(:,3) < vl(3,2));
ff = and(and(f1,f2),f3);
ccl = ccl(ff,:);

%----
if showNeuronsFlag == 1,
    neurons = ccl(ccl(:,4)==1,1:3);
    pn = plot3(neurons(:,1),neurons(:,2),-1*neurons(:,3),'go');
    set(pn,'MarkerSize',20/mycamva);
    set(pn,'MarkerFaceColor','green');
end%if showNeuronsFlag == 1,
%-----
if showNonNeuronsFlag == 1,
    nonNeurons = ccl(ccl(:,4)==0,1:3);
    pnn = plot3(nonNeurons(:,1),nonNeurons(:,2),-1*nonNeurons(:,3),'co');
    set(pnn,'MarkerSize',20/mycamva)
    set(pnn,'MarkerFaceColor','cyan');
end%if showNonNeuronsFlag == 1,
%-----

if showGrayCentersFlag == 1,
    av = AllVerts;
    f1 = and(av(:,1) > vl(1,1) , av(:,1) < vl(1,2));
    f2 = and(av(:,2) > vl(2,1) , av(:,2) < vl(2,2));
    f3 = and(av(:,3) > vl(3,1) , av(:,3) < vl(3,2));
    ff = and(and(f1,f2),f3);
    av = av(ff,:);
    pc = plot3(av(:,1),av(:,2),-1*av(:,3),'ko');
    set(pc,'MarkerEdgeColor',myGray);
    set(pc,'MarkerSize',1);
end%if showAllGrayCenterlinesFlag == 1,

if isfield(gds.Strands,'meanTransitTime');
    meanTransitTimeList = [gds.Strands(:).meanTransitTime];
    medianTransitTime = median(meanTransitTimeList(~isnan(meanTransitTimeList)));
end%if isfield(gds.Strands,'meanTransitTime');

for strandIter = 1:numStrands,
    thisStrandID = strandIter;

%     baseTransitTime = memgds(1).Strands(thisStrandID).meanTransitTime;
    
    thisStrand = gds.Strands(thisStrandID);
% %     thisBloodOx = bloodOx(thisStrandID);
    thisStrandCurrent = strandCurrentList(thisStrandID);
    thisStrandCurrentRatio = currentRatioList(thisStrandID);
    thisYXZ = thisStrand.YXZLimits;
    thisDown = min(downstreamBranchList(thisStrandID,:));
    thisUp = min(upstreamBranchList(thisStrandID,:));
    thisClosestBase = gds.baseStrandIDList(closestBaseIndexList(thisStrandID));
    allOutsideFlag = 0;
    if thisYXZ(1,2) < vl(1,1), allOutsideFlag = 1; end
    if thisYXZ(1,1) > vl(1,2), allOutsideFlag = 1; end
    if thisYXZ(2,2) < vl(2,1), allOutsideFlag = 1; end
    if thisYXZ(2,1) > vl(2,2), allOutsideFlag = 1; end
    if thisYXZ(3,2) < vl(3,1), allOutsideFlag = 1; end
    if thisYXZ(3,1) > vl(3,2), allOutsideFlag = 1; end
    if allOutsideFlag == 0,
        specialViewFlag = 0;
        medianRadius = thisStrand.MedianRadius;
        medianLabel = thisStrand.MedianLabel;
        
        try
            meanBloodOx = thisStrand.meanBloodOx;
        catch
            meanBloodOx = 0;
        end
        
        if lowCurrentViewFlag == 1, specialViewFlag = 1; end
        if currentRatioViewFlag == 1, specialViewFlag = 1; end
        if specialViewFlag == 0,
            visibleFlag = 0;
            if hideGrayFlag == 0, visibleFlag = 1; end
            if ismember(thisStrandID,baseStrandIDList), visibleFlag = 1; end;
            if showDownstreamFlowFlag == 1 && thisDown<=downstreamBranches, visibleFlag = 1; end
            if showUpstreamFlowFlag == 1 && thisUp<=upstreamBranches, visibleFlag = 1; end
            if ismember(medianLabel,gds.visibleLabelList),visibleFlag = 1;end

            
            if ~(smallMarkerSize == 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
                iv = thisStrand.InteriorVertices;
                ev = [thisStrand.StartVertexIndex,thisStrand.EndVertexIndex];
                strandLength = numel(iv);
                medianLabel = thisStrand.MedianLabel;
                medianVoltage = thisStrand.MedianVoltage;
                voltageDrop = thisStrand.VoltageDrop;
                thisCurrent = thisStrand.strandCurrent;
                cc = AllVerts(iv,:);
                f1 = and(cc(:,1)>=vl(1,1) , cc(:,1)<=vl(1,2));
                f2 = and(cc(:,2)>=vl(2,1) , cc(:,2)<=vl(2,2));
                f3 = and(cc(:,3)>=vl(3,1) , cc(:,3)<=vl(3,2));
                ff = and(and(f1,f2),f3);
                subcc = cc(ff,:);
                if ~isempty(subcc),
                    p1 = plot3(subcc(:,1),subcc(:,2),-1*subcc(:,3),'ko');
                    strandData.strandID = thisStrandID;
                    strandData.medianRadius = medianRadius;
                    strandData.medianVoltage = medianVoltage;
                    strandData.voltageDrop = voltageDrop;
                    strandData.current = thisCurrent;
                    strandData.medianLabel = medianLabel;
                    strandData.strandLength = strandLength;
                    strandData.closestBase = thisClosestBase;
                    strandData.meanBloodOx = meanBloodOx;
                    %---
                    markerStr = 'Marker';
                    markerSizeStr = 'MarkerSize';
                    markerColorStr = 'MarkerEdgeColor';
    %                 markerStr = 'LineStyle';
    %                 markerSizeStr = 'LineWidth';
    %                 markerColorStr = 'Color';
                    %---
                    set(p1,markerSizeStr,largeMarkerSize);
   
                    set(p1,markerColorStr,myGray);
                    

                    set(p1,'UserData',strandData);
                    %---
                    myString1 = ['get(gco,''UserData'')'];
                    set(p1,'ButtonDownFcn','FV_GetStrandInfo');
                    %---

                    if medianRadius <= largeMarkerThresholdRadius,
                        set(p1,markerStr,'o',markerSizeStr,smallMarkerSize+0.1);
                    end%if medianRadius < largeMarkerThresholdRadius,
                    %---
                    
                    %---
                    if ~isempty(gds.visibleLabelList),
                        if ismember(medianLabel,gds.visibleLabelList)
                            set(p1,markerColorStr,myOrange);
                        end%if ~ismember(thisLabel,gds.visibleLabelList)
                    end%if ~isempty(gds.visibleLabelList),
                    %---
                    
                    
                    
                    
                    
                    %-----
                     if showDownstreamFlowFlag == 1,
                        if thisDown<=downstreamBranches,
                            if or(limitToClosestFlag == 0 , thisClosestBase == baseStrandIDList(gds.currentSelectedBaseStrandIndex)),
                                set(p1,markerColorStr,blueColorList(thisDown,:));
        set(p1,'MarkerFaceColor',blueColorList(thisDown,:));                        
                            end%if or(...;
                        end%if downstreamBranchList(thisStrandID)<=downstreamBranches,
                    end%if showDownstreamFlowFlag == 1,
                    %---
                    if showUpstreamFlowFlag == 1,
                        if thisUp<=upstreamBranches,
                            set(p1,markerColorStr,redColorList(thisUp,:));
        set(p1,'MarkerFaceColor',redColorList(thisUp,:));                    
                        end%if upstreamBranchList(thisStrandID)<=upstreamBranches,
                    end%if showUpstreamFlowFlag == 1,
                    %---
                   if ismember(thisStrandID,baseStrandIDList),
                        set(p1,markerColorStr,'green');
        set(p1,'MarkerFaceColor','green');                 
                    end%if ismember(thisStrandID,baseStrandIDList)
                    %---
                    if showRadiiFlag == 1,
                        medianRadius = min(999,max(1,medianRadius));
                        set(p1,markerSizeStr,(medianRadius+0.1).*largeMarkerSize);
                    end
                    %-----
                    
                    %---
                    if ~isempty(gds.visibleLabelList),
                        if ismember(medianLabel,gds.visibleLabelList)
                            set(p1,markerColorStr,myOrange);
                        end%if ~ismember(thisLabel,gds.visibleLabelList)
                    end%if ~isempty(gds.visibleLabelList),
                    %---
                    
                    
                    
         
                    
                    
                    %-----
                    if sum(get(p1,markerColorStr)==myGray) == 3 && hideGrayFlag == 1,
                        set(p1,'Visible','off');
                    end
                    %---
                    if ismember(thisStrandID,clotStrandID),
                        set(p1,markerColorStr,'black');
                        set(p1,'MarkerFaceColor','black');                  
                    end%if ismember(thisStrandID,clotStrandID),
                    %---
                    %---
                    if longTransitTimeViewFlag == 1,
%                         if thisStrand.meanTransitTime/medianTransitTime >thresholdTransitTime,%4e-4=median, 8.8e-4=veins
%                         if thisStrand.meanTransitTime - baseTransitTime > thresholdTransitTime
                        if thisStrand.meanTransitTime > thresholdTransitTime
                            set(p1,markerColorStr,'magenta');
                        end%if thisStrand.meanTransitTime/mediantTransitTime >thresholdTransitTime,
                    end%if longTransitTimeViewFlag == 1,
                    %---
                    if convergenceViewFlag == 1,
                        if isinf(thisStrand.convergenceValue),
                            set(p1,markerColorStr,'magenta');
                            set(p1,'markerFaceColor','magenta');
                        else%if isinf(thisStrand.convergenceValue),
                            if thisStrand.convergenceValue >0,
                                set(p1,markerColorStr,'blue');
                                set(p1,'markerFaceColor','blue');
                            else%if thisStrand.convergenceValue>0,
                                set(p1,markerColorStr,'cyan');
                                set(p1,'markerFaceColor','cyan');
                            end%if-else thisStrand.convergenceValue>0,
                        end%if-else isinf(thisStrand.convergenceValue),
                    end%if convergenceViewFlag == 1,
                    %---
                    %---
% % %                     if thisBloodOx > 0.95,
% % %                         set(p1,markerStr,'s');
% % %                         set(p1,markerColorStr,'r');
% % %                     end
% % %                     
% % %                     if thisBloodOx < 0.3,
% % %                         set(p1,markerStr,'x');
% % %                         set(p1,markerColorStr,'b');
% % %                     end
% % %                     

% %                 if ismember(medianLabel,[340:349]),
% %                     set(p1,markerColorStr,'c');
% %                 end%if ismember



                end%if ~isempty(subcc),
            end% if ~(smallMarkerSize > 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
        end%if specialViewFlag == 0
        

        
        %---
        if specialViewFlag == 1,
            visibleFlag = 0;
            if hideGrayFlag == 0, visibleFlag = 1; end
            if ismember(thisStrandID,clotStrandID), visibleFlag = 1; end
            if currentRatioViewFlag == 1 && (thisStrandCurrentRatio<thresholdRatio || thisStrandCurrent>(2-thresholdRatio)), visibleFlag = 1; end
            if lowCurrentViewFlag == 1 && abs(thisStrandCurrent)<thresholdCurrent, visibleFlag = 1; end
            if ~(smallMarkerSize == 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
                iv = thisStrand.InteriorVertices;
                ev = [thisStrand.StartVertexIndex,thisStrand.EndVertexIndex];
                strandLength = numel(iv);
                medianLabel = thisStrand.MedianLabel;
                medianVoltage = thisStrand.MedianVoltage;
                voltageDrop = thisStrand.VoltageDrop;
                thisCurrent = thisStrand.strandCurrent;
                cc = AllVerts(iv,:);
                f1 = and(cc(:,1)>=vl(1,1) , cc(:,1)<=vl(1,2));
                f2 = and(cc(:,2)>=vl(2,1) , cc(:,2)<=vl(2,2));
                f3 = and(cc(:,3)>=vl(3,1) , cc(:,3)<=vl(3,2));
                ff = and(and(f1,f2),f3);
                subcc = cc(ff,:);
                if ~isempty(subcc),
                    p1 = plot3(subcc(:,1),subcc(:,2),-1*subcc(:,3),'ko');
                    strandData.strandID = thisStrandID;
                    strandData.medianRadius = medianRadius;
                    strandData.medianVoltage = medianVoltage;
                    strandData.voltageDrop = voltageDrop;
                    strandData.current = thisCurrent;
                    strandData.medianLabel = medianLabel;
                    strandData.strandLength = strandLength;
                    strandData.closestBase = thisClosestBase;
                    %---
                    markerStr = 'Marker';
                    markerSizeStr = 'MarkerSize';
                    markerColorStr = 'MarkerEdgeColor';
                    %---
                    set(p1,markerSizeStr,largeMarkerSize);
                    set(p1,markerColorStr,myGray);
                    set(p1,'UserData',strandData);
                    %---
                    myString1 = ['get(gco,''UserData'')'];
                    set(p1,'ButtonDownFcn','FV_GetStrandInfo');
                    %---
                    if currentRatioViewFlag == 1,
                        if thisStrandCurrentRatio < thresholdRatio,
                            set(p1,markerColorStr,'blue');
                        end%if thisStrandCurrentRatio < thresholdRatio,
                        %---
                        if thisStrandCurrentRatio > (2-thresholdRatio),
                            set(p1,markerColorStr,'red');
                        end%if thisStrandCurrentRatio > (2-thresholdRatio),
                    end%if currentRatioViewFlag == 1,
                    %---
                    if lowCurrentViewFlag == 1,
                        if abs(thisStrandCurrent) < thresholdCurrent,
                            set(p1,markerColorStr,'cyan');
                        end%if thisStrandCurrent < thresholdCurrent,
                    end%if lowCurrentViewFlag == 1,
                    %---
                    if ismember(thisStrandID,clotStrandID),
                        set(p1,markerColorStr,'black');
                    end%if ismember(thisStrandID,clotStrandID),
                    %---
                    if medianRadius <= largeMarkerThresholdRadius,
                        set(p1,markerStr,'o',markerSizeStr,smallMarkerSize+0.1);
                    end%if medianRadius < largeMarkerThresholdRadius,
                    %---
                    if showRadiiFlag == 1,
                        medianRadius = min(999,max(0,medianRadius));
                        set(p1,markerSizeStr,(medianRadius+0.1).*largeMarkerSize);
                    end
                    %---
                    if sum(get(p1,markerColorStr)==myGray) == 3 && hideGrayFlag == 1,
                        set(p1,'Visible','off');
                    end

                    
                    
                end%if ~isempty(subcc),
            end% if ~(smallMarkerSize > 0 && medianRadius <= largeMarkerThresholdRadius) && visibleFlag == 1,
        end%if specialViewFlag == 1
        
            

            
    end%if allOutsideFlag == 0,
end%for strandIter = 1:numStrands,



if showBarrelsFlag == 1,
    GenerateBarrelView;
end




camva(mycamva);
campos(mycampos);
camup(mycamup);
camtarget(mycamtarget);


% if showDownstreamFlowFlag == 1, GenerateDownstreamView; end
% if showUpstreamFlowFlag == 1, GenerateUpstreamView; end
set(handles.processingText,'Visible','off');
set(handles.viewRangeCenter1Edit,'String',num2str(gds.viewCenter(1)));
set(handles.viewRangeCenter2Edit,'String',num2str(gds.viewCenter(2)));
set(handles.viewRangeCenter3Edit,'String',num2str(gds.viewCenter(3)));
return




function PlotOutlineBox(viewLimits)
vl = viewLimits;
plot3([vl(1,1),vl(1,2)],[vl(2,1),vl(2,1)],-1*[vl(3,1),vl(3,1)],'r-');hold on
plot3([vl(1,1),vl(1,1)],[vl(2,1),vl(2,2)],-1*[vl(3,1),vl(3,1)],'g-');
plot3([vl(1,1),vl(1,1)],[vl(2,1),vl(2,1)],-1*[vl(3,1),vl(3,2)],'b-');  
% % xlabel('Axis 1');
% % ylabel('Axis 2');
% % zlabel('Axis 3');
axis equal
return    



function GenerateBarrelView
global gds
barrels = gds.barrels;

set(gds.handles.processingText,'Visible','on');pause(0.1)
f11 = figure(11);
vl = gds.viewLimits;

numBarrels = numel(barrels);
for barrelIter = 1:numBarrels,
    thisBarrel = barrels{barrelIter};
    f1 = and(thisBarrel(:,1)>vl(1,1) , thisBarrel(:,1) <vl(1,2));
    f2 = and(thisBarrel(:,2)>vl(2,1) , thisBarrel(:,2) <vl(2,2));
    f3 = and(thisBarrel(:,3)>vl(3,1) , thisBarrel(:,3) <vl(3,2));
    ff = and(and(f1,f2),f3);
    thisBarrel = thisBarrel(ff,:);
    p1 = plot3(thisBarrel(:,1),thisBarrel(:,2),-1*thisBarrel(:,3),'k.');
    set(p1,'MarkerSize',1);
end
   

set(gds.handles.processingText,'Visible','off');









% --- Outputs from this function are returned to the command line.
function varargout = FlowVisualizer_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in enterBaseStrandButton.
function enterBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to enterBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in loadBaseStrandSetButton.
function loadBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
[fileName,pathName] = uigetfile({'*.mat'},'Select a baseStrandIDList file to load');
cd(pathName)
loadFileName = [fileName];
load(loadFileName);
if exist('baseStrandIDList','var'),
    gds.baseStrandIDList = sort(baseStrandIDList);  
    InitializeBaseStrands
    CalculateDownstreamPaths
    CalculateUpstreamPaths
    gds.currentSelectedBaseStrandIndex = 1;
    if gds.autoRefreshFlag, GenerateBasicView; end;
end%if exist('baseStrandIDList','var');




% --- Executes on button press in addSelectedStrandButton.
function addSelectedStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to addSelectedStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in clearBaseStrandSetButton.
function clearBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to clearBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
gds.baseStrandIDList = [1];
InitializeBaseStrands
CalculateDownstreamPaths
CalculateUpstreamPaths
if gds.autoRefreshFlag, GenerateBasicView; end;

% --- Executes on button press in saveBaseStrandSetButton.
function saveBaseStrandSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveBaseStrandSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
baseStrandIDList = gds.baseStrandIDList;
[fileName,pathName] = uiputfile({'*.mat'},'Save baseStrandIDList as...');
cd(pathName)
saveFileName = [fileName];
save(saveFileName,'baseStrandIDList');


% --- Executes on button press in addBaseStrandButton.
function addBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to addBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
baseStrandIDList = gds.baseStrandIDList;
numStrands = numel(gds.Strands);
newBaseStrandID = round(str2num(get(handles.baseStrandEdit,'String')));
if newBaseStrandID >0 && newBaseStrandID < numStrands,
    baseStrandIDList = [baseStrandIDList,newBaseStrandID];
end%if newBaseStrandID >0 && newBaseStrandID < numStrands,
gds.baseStrandIDList = baseStrandIDList;
gds.currentSelectedBaseStrandIndex = numel(baseStrandIDList);
set(gds.handles.baseStrandListbox,'Value',numel(baseStrandIDList));
InitializeBaseStrands;
% % CalculateDownstreamPaths
% % CalculateUpstreamPaths
% % if gds.autoRefreshFlag, GenerateBasicView; end;



% --- Executes on button press in removeBaseStrandButton.
function removeBaseStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeBaseStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
baseStrandIDList = gds.baseStrandIDList;
selectedBaseStrandPos = get(handles.baseStrandListbox,'Value');
if numel(baseStrandIDList)>1,
    baseStrandIDList = baseStrandIDList([1:selectedBaseStrandPos-1,selectedBaseStrandPos+1:end]);
end%if numel(baseStrandIDList)>1,
gds.baseStrandIDList = baseStrandIDList;
gds.currentSelectedBaseStrandIndex = 1;
set(gds.handles.baseStrandListbox,'Value',1);
InitializeBaseStrands
% % CalculateDownstreamPaths
% % CalculateUpstreamPaths
% % if gds.autoRefreshFlag, GenerateBasicView; end;




% --- Executes on button press in showDownstreamFlowButton.
function showDownstreamFlowButton_Callback(hObject, eventdata, handles)
% hObject    handle to showDownstreamFlowButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showDownstreamFlowButton
global gds
gds.showDownstreamFlowFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in showUpstreamFlowButton.
function showUpstreamFlowButton_Callback(hObject, eventdata, handles)
% hObject    handle to showUpstreamFlowButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showUpstreamFlowButton
global gds
gds.showUpstreamFlowFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on selection change in downstreamBranchesMenu.
function downstreamBranchesMenu_Callback(hObject, eventdata, handles)
% hObject    handle to downstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns downstreamBranchesMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from downstreamBranchesMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString);
gds.downstreamBranches = menuVal;
if gds.autoRefreshFlag, GenerateBasicView; end

% --- Executes during object creation, after setting all properties.
function downstreamBranchesMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to downstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in upstreamBranchesMenu.
function upstreamBranchesMenu_Callback(hObject, eventdata, handles)
% hObject    handle to upstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns upstreamBranchesMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from upstreamBranchesMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString);
gds.upstreamBranches = menuVal;
if gds.autoRefreshFlag, GenerateBasicView; end

% --- Executes during object creation, after setting all properties.
function upstreamBranchesMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to upstreamBranchesMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in Axis1RangeMenu.
function Axis1RangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to Axis1RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns Axis1RangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Axis1RangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(1) = menuVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end




% --- Executes during object creation, after setting all properties.
function Axis1RangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Axis1RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in AxisTwoRangeMenu.
function AxisTwoRangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to AxisTwoRangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns AxisTwoRangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from AxisTwoRangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(2) = menuVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes during object creation, after setting all properties.
function AxisTwoRangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AxisTwoRangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in Axis3RangeMenu.
function Axis3RangeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to Axis3RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns Axis3RangeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Axis3RangeMenu
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
menuVal = str2num(menuString(4:end));
gds.viewRange(3) = menuVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end





% --- Executes during object creation, after setting all properties.
function Axis3RangeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Axis3RangeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter1Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter1Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter1Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(1) = editVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes during object creation, after setting all properties.
function viewRangeCenter1Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter2Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter2Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter2Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(2) = editVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes during object creation, after setting all properties.
function viewRangeCenter2Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function viewRangeCenter3Edit_Callback(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of viewRangeCenter3Edit as text
%        str2double(get(hObject,'String')) returns contents of viewRangeCenter3Edit as a double
global gds
editVal = str2num(get(hObject,'String'));
gds.viewCenter(3) = editVal;
GetViewLimits
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes during object creation, after setting all properties.
function viewRangeCenter3Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to viewRangeCenter3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in smallMarkerSizeMenu.
function smallMarkerSizeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to smallMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns smallMarkerSizeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from smallMarkerSizeMenu
global gds
smallMarkerSizeList = get(hObject,'String');
smallMarkerSizeChoice = get(hObject,'Value');
smallMarkerSize = str2num(smallMarkerSizeList{smallMarkerSizeChoice});
gds.smallMarkerSize = smallMarkerSize;
if gds.autoRefreshFlag, GenerateBasicView; end

% --- Executes during object creation, after setting all properties.
function smallMarkerSizeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to smallMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in largeMarkerSizeMenu.
function largeMarkerSizeMenu_Callback(hObject, eventdata, handles)
% hObject    handle to largeMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns largeMarkerSizeMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from largeMarkerSizeMenu
global gds
largeMarkerSizeList = get(hObject,'String');
largeMarkerSizeChoice = get(hObject,'Value');
largeMarkerSize = str2num(largeMarkerSizeList{largeMarkerSizeChoice});
gds.largeMarkerSize = largeMarkerSize;
if gds.autoRefreshFlag, GenerateBasicView; end

% --- Executes during object creation, after setting all properties.
function largeMarkerSizeMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to largeMarkerSizeMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function thresholdRadiusEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdRadiusEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdRadiusEdit as a double
global gds
newRadius = str2num(get(hObject,'String'));
newRadius = max(0,min(999,newRadius));
gds.largeMarkerThresholdRadius = newRadius;
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes during object creation, after setting all properties.
function thresholdRadiusEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdRadiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in showRadiiButton.
function showRadiiButton_Callback(hObject, eventdata, handles)
% hObject    handle to showRadiiButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
gds.showRadiiFlag = get(hObject,'Value');
if gds.showRadiiFlag == 1,
    set(handles.largeMarkerSizeText,'String','Radius Multiplier');
else
    set(handles.largeMarkerSizeText,'String','Large Marker Size');
end    
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes on button press in hideGrayButton.
function hideGrayButton_Callback(hObject, eventdata, handles)
% hObject    handle to hideGrayButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
gds.hideGrayFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end



















function CalculateDownstreamPaths
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
maxBranchSearch = gds.maxBranchSearch;
downstreamPathList = [];
numStrands = numel(gds.Strands);
downstreamBranchList = zeros(numStrands,numel(baseStrandIDList)) + Inf;


stopVoltage = 50.1;%Hardcode;
minimumFluxFraction = 1/30000;%Hardcode


minimumFluxFraction = 1/(2^18);%Hardcode


set(handles.processingText,'Visible','on');pause(0.1);
numBaseStrands = numel(baseStrandIDList);
proceedFlag = 1;
if numBaseStrands > 5,
    myQuery = questdlg('Calculate Downstream Paths for ALL base strands?','This may take awhile','Proceed','Abort','Proceed');
    if strmatch(myQuery,'Abort'), proceedFlag = 0; end
    pause(0.1);
end%if numBaseStrands > 10,
if proceedFlag == 1,
    for baseStrandIter = 1:numBaseStrands;
        baseStrandID = baseStrandIDList(baseStrandIter);
        baseStrand = gds.Strands(baseStrandID);
        bsiv = baseStrand.InteriorVertices;
        baseStrandCoordList = gds.Vertices.AllVerts(bsiv,:);
        strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
        nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        pathActiveFlagList = false(1,100000);
        pathActiveFlagList(1) = 1;
        numActivePath = sum(pathActiveFlagList);
        strandPathList = {};
        nodePathList = {};
        fractionPathList = {};
        strandPathList{1} = baseStrandID;
        nodePathList{1} = [highNode lowNode];
        fractionPathList{1} = 1;
        strandFlowList = zeros(numStrands,1);
        strandFlowList(baseStrandID) = 1;
        strandVoltageList = zeros(numStrands,1);
        strandVoltageList(1) = mean([highVoltage,lowVoltage]);
        pathCounter = 1;
        keepGoingFlag = 1;
        branchCounter = 0;

        while (keepGoingFlag == 1),
            myCount = 0;
            branchCounter = branchCounter+1;
            for pathIter = find(pathActiveFlagList == 1);
                currentPathID = pathIter;
                currentStrandPath = strandPathList{pathIter};
                currentNodePath = nodePathList{pathIter};
                currentFractionPath = fractionPathList{pathIter};
                currentStrandID = currentStrandPath(end);
                currentStrand = gds.Strands(currentStrandID);
                %-----
                strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
                nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
                [highVoltage,highVoltagePos] = max(nodeVoltages);
                [lowVoltage,lowVoltagePos] = min(nodeVoltages);
                highNode = strandNodes(highVoltagePos);
                lowNode = strandNodes(strandNodes~=highNode);
                lowAttachedStrands = gds.Vertices.StrandIndices(lowNode,:);
                lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
                lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
                numDaughterPaths = numel(lowAttachedStrands);
                strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
                stopTracingFlag = 0;
                if numDaughterPaths == 0, stopTracingFlag = 1; end
                if lowVoltage < stopVoltage, stopTracingFlag = 1; end
                if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
                if stopTracingFlag == 1,
                    pathActiveFlagList(currentPathID) = 0;
                else%if stopTracingFlag == 1,
                    motherCurrent = abs(currentStrand.strandCurrent);
                    validDaughterCounter = 0;
                    validDaughterStrandList = [];
                    validDaughterCurrentList = zeros(1,numDaughterPaths);
                    validDaughterPathIndexList = [];
                    for daughterIter = 1:numDaughterPaths,
                        %Check to see if the daughter strand leads to a lower voltage
                        candidateDaughterID = lowAttachedStrands(daughterIter);
                        candidateDaughterStrand = gds.Strands(candidateDaughterID);
                        candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                        candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                        candidateDaughterOtherVoltage = gds.Vertices.AllVoltages(candidateDaughterOtherNode);
                        if candidateDaughterOtherVoltage < lowVoltage,
                            %if so, add the strand to a path
                            myCount = myCount + 1;
                            validDaughterCounter = validDaughterCounter + 1;
                            validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                            validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                            if validDaughterCounter == 1,
                                %if this is the first valid daughter, add to current path
                                strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                                validDaughterPathIndexList(1) = currentPathID;
                            else%if validDaughterCounter == 1,
                                %if not the first daughter, duplicate path up to this point, and
                                %make new path
                                pathCounter = pathCounter + 1;
                                strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                                fractionPathList{pathCounter} = currentFractionPath;
                                pathActiveFlagList(pathCounter) = 1;  
                                validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                            end%if-else validDaughterCounter == 1,
                        end%if candidateDaughterOtherVoltage < lowVoltage,
                    end%for daughterIter = 1:numDaughterPaths,
                    clear daughterIter
                    %-----
                    daughterSumCurrent = sum(validDaughterCurrentList);
                    fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                    for validDaughterIter = 1:validDaughterCounter;
                        validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                        validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                        fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                        strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    end%for validDaughterIter = 1:validDaughterCounter;
                end%if-else stopTracingFlag == 1,
            end%for pathIter = find(pathActiveFlagList == 1);
            if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
            if myCount == 0, keepGoingFlag = 0;end
            if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
        end%while (keepGoingFlag == 1),
        downstreamPathList{baseStrandIter} = strandPathList;
    end%for baseStrandIter = 1:numBaseStrands;

    for baseStrandIter = 1:numBaseStrands;
        thisPathSet = downstreamPathList{baseStrandIter};
        for pathIter = 1:numel(thisPathSet),
            thisPath = thisPathSet{pathIter};
            thisPath = thisPath(2:end);
            posList = [1:numel(thisPath)]';
            downstreamBranchList(thisPath,baseStrandIter) = min(downstreamBranchList(thisPath,baseStrandIter),posList);
        end%for pathIter = 1:numel(thisPathSet);
    end%for baseStrandIter = ...
end%if proceedFlag == 1;
     
% gds.downstreamPathList = downstreamPathList;
gds.downstreamBranchList = downstreamBranchList;
set(handles.processingText,'Visible','off');




function CalculateUpstreamPaths
global gds
handles = gds.handles;
baseStrandIDList = gds.baseStrandIDList;
maxBranchSearch = gds.maxBranchSearch;
upstreamPathList = [];
numStrands = numel(gds.Strands);
upstreamBranchList = zeros(numStrands,numel(baseStrandIDList)) + Inf;


stopVoltage = 100;%Hardcode;
minimumFluxFraction = 1/3000;%Hardcode
minimumFluxFraction = 1/(2^18);%Hardcode

set(handles.processingText,'Visible','on');pause(0.1);
numBaseStrands = numel(baseStrandIDList);
proceedFlag = 1;
if numBaseStrands > 5,
    myQuery = questdlg('Calculate Upstream Paths for ALL base strands?','This may take awhile','Proceed','Abort','Proceed');
    if strmatch(myQuery,'Abort'), proceedFlag = 0; end
    pause(0.1);
end%if numBaseStrands > 10,
if proceedFlag == 1,
    for baseStrandIter = 1:numBaseStrands;
        baseStrandID = baseStrandIDList(baseStrandIter);
        baseStrand = gds.Strands(baseStrandID);
        bsiv = baseStrand.InteriorVertices;
        baseStrandCoordList = gds.Vertices.AllVerts(bsiv,:);
        strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
        nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        pathActiveFlagList = false(1,100000);
        pathActiveFlagList(1) = 1;
        numActivePath = sum(pathActiveFlagList);
        strandPathList = {};
        nodePathList = {};
        fractionPathList = {};
        strandPathList{1} = baseStrandID;
        nodePathList{1} = [highNode lowNode];
        fractionPathList{1} = 1;
        strandFlowList = zeros(numStrands,1);
        strandFlowList(baseStrandID) = 1;
        strandVoltageList = zeros(numStrands,1);
        strandVoltageList(1) = mean([highVoltage,lowVoltage]);
        pathCounter = 1;
        keepGoingFlag = 1;
        branchCounter = 0;


        while (keepGoingFlag == 1),
            myCount = 0;
            branchCounter = branchCounter + 1;
            for pathIter = find(pathActiveFlagList == 1);
                currentPathID = pathIter;
                currentStrandPath = strandPathList{pathIter};
                currentNodePath = nodePathList{pathIter};
                currentFractionPath = fractionPathList{pathIter};
                currentStrandID = currentStrandPath(end);
                currentStrand = gds.Strands(currentStrandID);
                %-----
                strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
                nodeVoltages = gds.Vertices.AllVoltages(strandNodes);
                [highVoltage,highVoltagePos] = max(nodeVoltages);
                [lowVoltage,lowVoltagePos] = min(nodeVoltages);
                highNode = strandNodes(highVoltagePos);
                lowNode = strandNodes(strandNodes~=highNode);
                highAttachedStrands = gds.Vertices.StrandIndices(highNode,:);
                highAttachedStrands = highAttachedStrands(highAttachedStrands~=0);
                highAttachedStrands = highAttachedStrands(highAttachedStrands~=currentStrandID);
                numDaughterPaths = numel(highAttachedStrands);
                strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
                stopTracingFlag = 0;
                if numDaughterPaths == 0, stopTracingFlag = 1; end
                if highVoltage > stopVoltage, stopTracingFlag = 1; end
                if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
                if stopTracingFlag == 1,
                    pathActiveFlagList(currentPathID) = 0;
                else%if stopTracingFlag == 1,
                    motherCurrent = abs(currentStrand.strandCurrent);
                    validDaughterCounter = 0;
                    validDaughterStrandList = [];
                    validDaughterCurrentList = zeros(1,numDaughterPaths);
                    validDaughterPathIndexList = [];
                    for daughterIter = 1:numDaughterPaths,
                        %Check to see if the daughter strand leads to a lower voltage
                        candidateDaughterID = highAttachedStrands(daughterIter);
                        candidateDaughterStrand = gds.Strands(candidateDaughterID);
                        candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                        candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=highNode);
                        candidateDaughterOtherVoltage = gds.Vertices.AllVoltages(candidateDaughterOtherNode);
                        if candidateDaughterOtherVoltage > highVoltage,
                            %if so, add the strand to a path
                            myCount = myCount + 1;
                            validDaughterCounter = validDaughterCounter + 1;
                            validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                            validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                            if validDaughterCounter == 1,
                                %if this is the first valid daughter, add to current path
                                strandPathList{currentPathID} = [currentStrandPath, highAttachedStrands(daughterIter)];
                                nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                                validDaughterPathIndexList(1) = currentPathID;
                            else%if validDaughterCounter == 1,
                                %if not the first daughter, duplicate path up to this point, and
                                %make new path
                                pathCounter = pathCounter + 1;
                                strandPathList{pathCounter} = [currentStrandPath, highAttachedStrands(daughterIter)];
                                nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                                fractionPathList{pathCounter} = currentFractionPath;
                                pathActiveFlagList(pathCounter) = 1;  
                                validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                            end%if-else validDaughterCounter == 1,
                        end%if candidateDaughterOtherVoltage > highVoltage,
                    end%for daughterIter = 1:numDaughterPaths,
                    clear daughterIter
                    %-----
                    daughterSumCurrent = sum(validDaughterCurrentList);
                    fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                    for validDaughterIter = 1:validDaughterCounter;
                        validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                        validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                        fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                        strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    end%for validDaughterIter = 1:validDaughterCounter;
                end%if-else stopTracingFlag == 1,
            end%for pathIter = find(pathActiveFlagList == 1);
            if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
            if myCount == 0, keepGoingFlag = 0;end
            if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
        end%while (keepGoingFlag == 1),
        upstreamPathList{baseStrandIter} = strandPathList;
    end%for baseStrandIter = 1:numBaseStrands;

    for baseStrandIter = 1:numBaseStrands;
        thisPathSet = upstreamPathList{baseStrandIter};
        for pathIter = 1:numel(thisPathSet),
            thisPath = thisPathSet{pathIter};
            thisPath = thisPath(2:end);
            posList = [1:numel(thisPath)]';
            upstreamBranchList(thisPath,baseStrandIter) = min(upstreamBranchList(thisPath,baseStrandIter),posList);
        end%for pathIter = 1:numel(thisPathSet);
    end%for baseStrandIter = ...
end%if proceedFlag == 1;
     
% gds.upstreamPathList = upstreamPathList;
gds.upstreamBranchList = upstreamBranchList;
set(handles.processingText,'Visible','off');



 

% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end






% --- Executes on selection change in popupmenu9.
function popupmenu9_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu9 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu9


% --- Executes during object creation, after setting all properties.
function popupmenu9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in baseStrandListbox.
function baseStrandListbox_Callback(hObject, eventdata, handles)
% hObject    handle to baseStrandListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns baseStrandListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from baseStrandListbox
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
global gds
menuList = get(hObject,'String');
menuChoice = get(hObject,'Value');
menuString = menuList{menuChoice};
gds.currentSelectedBaseStrandIndex = menuChoice;
if gds.showSingleBaseFlag == 1, GenerateBasicView; end



% --- Executes during object creation, after setting all properties.
function baseStrandListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to baseStrandListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.



function maxBranchSearchEdit_Callback(hObject, eventdata, handles)
% hObject    handle to maxBranchSearchEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxBranchSearchEdit as text
%        str2double(get(hObject,'String')) returns contents of maxBranchSearchEdit as a double
global gds
gds.maxBranchSearch = str2num(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function maxBranchSearchEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxBranchSearchEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in recalculateButton.
function recalculateButton_Callback(hObject, eventdata, handles)
% hObject    handle to recalculateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
InitializeBaseStrands
CalculateDownstreamPaths
CalculateUpstreamPaths
if gds.autoRefreshFlag, GenerateBasicView; end;





% --- Executes on button press in refreshButton.
function refreshButton_Callback(hObject, eventdata, handles)
% hObject    handle to refreshButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
GenerateBasicView;



% --- Executes on button press in centerOnClickButton.
function centerOnClickButton_Callback(hObject, eventdata, handles)
% hObject    handle to centerOnClickButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of centerOnClickButton
global gds
gds.centerOnClickFlag = get(hObject,'Value');


% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



% --- Executes on button press in loadButton.
function loadButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
LoadVectorProject

% --- Executes on button press in saveButton.
function saveButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
SaveFVFile


% --- Executes on button press in showSingleBaseButton.
function showSingleBaseButton_Callback(hObject, eventdata, handles)
% hObject    handle to showSingleBaseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showSingleBaseButton
global gds
gds.showSingleBaseFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in loadBarrelsButton.
function loadBarrelsButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadBarrelsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
%---
[fileName,pathName] = uigetfile({'*.mat'},'Select a barrels .mat file');
if pathName~=0,
    cd(pathName)
    loadFileName = [fileName];
    set(gds.handles.processingText,'Visible','on');pause(0.1)
    load(loadFileName);
    set(gds.handles.processingText,'Visible','off')
end%if pathName~=0
if exist('barrels','var'),
    gds.barrels = barrels;
end%if exist('barrels','var'),


% --- Executes on button press in showBarrelsButton.
function showBarrelsButton_Callback(hObject, eventdata, handles)
% hObject    handle to showBarrelsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showBarrelsButton
global gds
gds.showBarrelsFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in markLimitsButton.
function markLimitsButton_Callback(hObject, eventdata, handles)
% hObject    handle to markLimitsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of markLimitsButton
global gds
gds.markedCenter = gds.viewCenter;
gds.markedRange = gds.viewRange;

% --- Executes on button press in revertLimitsButton.
function revertLimitsButton_Callback(hObject, eventdata, handles)
% hObject    handle to revertLimitsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of revertLimitsButton
global gds
handles = gds.handles;
if isfield(gds,'markedCenter'),
    gds.viewCenter = gds.markedCenter;
    gds.viewRange = gds.markedRange;
end%if isfield...
PopulateFields
if gds.autoRefreshFlag, GenerateBasicView; end;


% --- Executes on button press in limitToClosestButton.
function limitToClosestButton_Callback(hObject, eventdata, handles)
% hObject    handle to limitToClosestButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of limitToClosestButton
global gds
gds.limitToClosestFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in switchToClosestButton.
function switchToClosestButton_Callback(hObject, eventdata, handles)
% hObject    handle to switchToClosestButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of switchToClosestButton
global gds
if isfield(gds,'selectedStrandData'),
    closestBase = gds.selectedStrandData.closestBase;
    strandID = gds.selectedStrandData.strandID;
    if ismember(strandID,gds.baseStrandIDList),
        gds.currentSelectedBaseStrandIndex = find(gds.baseStrandIDList == strandID);
    else%if ismember(strandID,gds.baseStrandIDList),
        gds.currentSelectedBaseStrandIndex = find(gds.baseStrandIDList == closestBase);
    end%if ismember(strandID,gds.baseStrandIDList),
    PopulateFields;
    if gds.autoRefreshFlag, GenerateBasicView; end;
end%if isfield(gds,'selectedStrandData'),
    
    
    


% --- Executes on button press in snapshotButton.
function snapshotButton_Callback(hObject, eventdata, handles)
% hObject    handle to snapshotButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
if ~isfield(gds,'snapshotCounter');
    gds.snapshotCounter = 0;
end
gds.snapshotCounter = gds.snapshotCounter + 1;
saveas(gds.viewWindowHandle,['FV_snapshot',num2str(gds.snapshotCounter,'%05d'),'_',datestr(now,'mmddyy-HHMMSS')]);


% --- Executes on button press in movieMakerButton.
function movieMakerButton_Callback(hObject, eventdata, handles)
% hObject    handle to movieMakerButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds
FVMovieMaker;

% --- Executes on button press in autoRefreshButton.
function autoRefreshButton_Callback(hObject, eventdata, handles)
% hObject    handle to autoRefreshButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of autoRefreshButton
global gds
gds.autoRefreshFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in showNeuronsButton.
function showNeuronsButton_Callback(hObject, eventdata, handles)
% hObject    handle to showNeuronsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showNeuronsButton
global gds
gds.showNeuronsFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes on button press in showNonNeuronsButton.
function showNonNeuronsButton_Callback(hObject, eventdata, handles)
% hObject    handle to showNonNeuronsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showNonNeuronsButton
global gds
gds.showNonNeuronsFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes on button press in showGrayCentersButton.
function showGrayCentersButton_Callback(hObject, eventdata, handles)
% hObject    handle to showGrayCentersButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showGrayCentersButton
global gds
gds.showGrayCentersFlag = get(hObject,'Value');
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in lowCurrentViewerButton.
function lowCurrentViewerButton_Callback(hObject, eventdata, handles)
% hObject    handle to lowCurrentViewerButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lowCurrentViewerButton
global gds;
newState = get(hObject,'Value');
gds.lowCurrentViewFlag = newState;
if newState == 1,
    gds.currentRatioViewFlag = 0;
    gds.longTransitTimeViewFlag = 0;
    set(handles.lowCurrentRatioViewButton,'Value',0);
    set(handles.longTransitTimeViewerButton,'Value',0);
end%if newState == 1,
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes on button press in lowCurrentRatioViewButton.
function lowCurrentRatioViewButton_Callback(hObject, eventdata, handles)
% hObject    handle to lowCurrentRatioViewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of lowCurrentRatioViewButton
global gds;
newState = get(hObject,'Value');
gds.currentRatioViewFlag = newState;
if newState == 1,
    gds.lowCurrentViewFlag = 0;
    gds.longTransitTimeViewFlag = 0;
    set(handles.lowCurrentViewerButton,'Value',0);
    set(handles.longTransitTimeViewerButton,'Value',0);
end%if newState == 1,
if gds.autoRefreshFlag, GenerateBasicView; end


function thresholdCurrentEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdCurrentEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdCurrentEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdCurrentEdit as a double
global gds
newValue = str2num(get(hObject,'String'));
if isempty(newValue), 
    newValue = median(abs(gds.circuitAnalysisParameters.strandCurrentList)); 
    set(hObject,'String',num2str(newValue,'%0.1e'));
end;%if isempty(newValue),
gds.thresholdCurrent = newValue;
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes during object creation, after setting all properties.
function thresholdCurrentEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdCurrentEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function thresholdRatioEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdRatioEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdRatioEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdRatioEdit as a double
global gds
newValue = str2num(get(hObject,'String'));
if isempty(newValue),
    newValue = 0.5;
    set(hObject,'String',num2str(newValue));
end;
gds.thresholdRatio = newValue;
if gds.autoRefreshFlag, GenerateBasicView; end



% --- Executes during object creation, after setting all properties.
function thresholdRatioEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdRatioEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in clotModuleButton.
function clotModuleButton_Callback(hObject, eventdata, handles)
% hObject    handle to clotModuleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
FVClotModule

% --- Executes on button press in calcTransitTimeButton.
function calcTransitTimeButton_Callback(hObject, eventdata, handles)
% hObject    handle to calcTransitTimeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

FVTransitTime


% --- Executes on button press in longTransitTimeViewerButton.
function longTransitTimeViewerButton_Callback(hObject, eventdata, handles)
% hObject    handle to longTransitTimeViewerButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of longTransitTimeViewerButton
global gds
global gds;
newState = get(hObject,'Value');
gds.longTransitTimeViewFlag = newState;
if newState == 1,
    gds.lowCurrentViewFlag = 0;
    gds.currentRatioViewFlag = 0;
    set(handles.lowCurrentViewerButton,'Value',0);
    set(handles.lowCurrentRatioViewButton,'Value',0);
end%if newState == 1,
if gds.autoRefreshFlag, GenerateBasicView; end


% --- Executes during object creation, after setting all properties.
function longTransitTimeViewerButton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to longTransitTimeViewerButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in dataMem1Button.
function dataMem1Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem1Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memStruct = [];
    memgds(1).Strands = gds.Strands;
    memgds(1).AllVoltages = gds.Vertices.AllVoltages;
    memgds(1).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(1).baseStrandIDList = gds.baseStrandIDList;
    memgds(1).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(1).baseStrandCell = gds.baseStrandCell;
    memgds(1).downstreamBranchList = gds.downstreamBranchList;
    memgds(1).upstreamBranchList = gds.upstreamBranchList;
    memgds(1).selectedStrandData = gds.selectedStrandData;
    disp('Mem1 Stored');
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(1);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem1 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);

% --- Executes on button press in dataMem2Button.
function dataMem2Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem2Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memgds(2).Strands = gds.Strands;
    memgds(2).AllVoltages = gds.Vertices.AllVoltages;
    memgds(2).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(2).baseStrandIDList = gds.baseStrandIDList;
    memgds(2).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(2).baseStrandCell = gds.baseStrandCell;
    memgds(2).downstreamBranchList = gds.downstreamBranchList;
    memgds(2).upstreamBranchList = gds.upstreamBranchList;
    memgds(2).selectedStrandData = gds.selectedStrandData;
    disp('Mem2 Stored');
    
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(2);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem2 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);


% --- Executes on button press in dataMem3Button.
function dataMem3Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem3Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memgds(3).Strands = gds.Strands;
    memgds(3).AllVoltages = gds.Vertices.AllVoltages;
    memgds(3).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(3).baseStrandIDList = gds.baseStrandIDList;
    memgds(3).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(3).baseStrandCell = gds.baseStrandCell;
    memgds(3).downstreamBranchList = gds.downstreamBranchList;
    memgds(3).upstreamBranchList = gds.upstreamBranchList;
    memgds(3).selectedStrandData = gds.selectedStrandData;
    disp('Mem3 Stored');
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(3);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem3 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);


% --- Executes on button press in dataMem4Button.
function dataMem4Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem4Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memStruct = [];
    memgds(4).Strands = gds.Strands;
    memgds(4).AllVoltages = gds.Vertices.AllVoltages;
    memgds(4).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(4).baseStrandIDList = gds.baseStrandIDList;
    memgds(4).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(4).baseStrandCell = gds.baseStrandCell;
    memgds(4).downstreamBranchList = gds.downstreamBranchList;
    memgds(4).upstreamBranchList = gds.upstreamBranchList;
    memgds(4).selectedStrandData = gds.selectedStrandData;
    disp('Mem4 Stored');
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(4);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem4 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);


% --- Executes on button press in dataMem5Button.
function dataMem5Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem5Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memgds(5).Strands = gds.Strands;
    memgds(5).AllVoltages = gds.Vertices.AllVoltages;
    memgds(5).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(5).baseStrandIDList = gds.baseStrandIDList;
    memgds(5).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(5).baseStrandCell = gds.baseStrandCell;
    memgds(5).downstreamBranchList = gds.downstreamBranchList;
    memgds(5).upstreamBranchList = gds.upstreamBranchList;
    memgds(5).selectedStrandData = gds.selectedStrandData;
    disp('Mem5 Stored');
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(5);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem5 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);


% --- Executes on button press in dataMem6Button.
function dataMem6Button_Callback(hObject, eventdata, handles)
% hObject    handle to dataMem6Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gds;
global memgds;
if gds.dataMemSetFlag == 1,
    memgds(6).Strands = gds.Strands;
    memgds(6).AllVoltages = gds.Vertices.AllVoltages;
    memgds(6).clotAnalysisParameters = gds.clotAnalysisParameters;
    memgds(6).baseStrandIDList = gds.baseStrandIDList;
    memgds(6).currentSelectedBaseStrandIndex = gds.currentSelectedBaseStrandIndex;
    memgds(6).baseStrandCell = gds.baseStrandCell;
    memgds(6).downstreamBranchList = gds.downstreamBranchList;
    memgds(6).upstreamBranchList = gds.upstreamBranchList;
    memgds(6).selectedStrandData = gds.selectedStrandData;
    disp('Mem6 Stored');
else%if gds.dataMemSetFlag == 1,
    memStruct = memgds(6);
    gds.Strands = memStruct.Strands;
    gds.Vertices.AllVoltages = memStruct.AllVoltages;
    gds.clotAnalysisParameters = memStruct.clotAnalysisParameters;
    gds.baseStrandIDList = memStruct.baseStrandIDList;
    gds.currentSelectedBaseStrandIndex = memStruct.currentSelectedBaseStrandIndex;
    gds.baseStrandCell = memStruct.baseStrandCell;
    gds.downstreamBranchList = memStruct.downstreamBranchList;
    gds.upstreamBranchList = memStruct.upstreamBranchList;
    gds.selectedStrandData = memStruct.selectedStrandData;
    disp('Mem6 Retrieved');
    GenerateBasicView
end%if-else gds.dataMemSetFlag == 1,
gds.dataMemSetFlag = 0;
set(handles.dataMemSetButton,'Value',0);


% --- Executes on button press in dataMemSetButton.
function dataMemSetButton_Callback(hObject, eventdata, handles)
% hObject    handle to dataMemSetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of dataMemSetButton
global gds
gds.dataMemSetFlag = get(hObject,'Value');
if gds.dataMemSetFlag == 1,
    disp('Set on');
else
    disp('Set off');
end



function thresholdTransitTimeEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdTransitTimeEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdTransitTimeEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdTransitTimeEdit as a double
global gds
newValue = str2num(get(hObject,'String'));
if isempty(newValue),
    newValue = 1;
    set(hObject,'String',num2str(newValue));
end;
gds.thresholdTransitTime = newValue;
if gds.autoRefreshFlag, GenerateBasicView; end

% --- Executes during object creation, after setting all properties.
function thresholdTransitTimeEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdTransitTimeEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function visibleLabelListEdit_Callback(hObject, eventdata, handles)
% hObject    handle to visibleLabelListEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of visibleLabelListEdit as text
%        str2double(get(hObject,'String')) returns contents of visibleLabelListEdit as a double
global gds
testString = get(hObject,'String');
if ~iscell(testString), testString = {testString};end
testNum = str2num(testString{1});

if ~isempty(testNum),
    gds.visibleLabelList = testNum;
else
    gds.visibleLabelList = [];
    set(hObject,'String','');
end



% --- Executes during object creation, after setting all properties.
function visibleLabelListEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to visibleLabelListEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


