selectedStrandID = gds.selectedStrandData.strandID;
selectedStrand = gds.Strands(selectedStrandID);

thresholdCurrentForStall = gds.thresholdCurrentForStall

startAttachedStrands = [gds.Vertices.StrandIndices(selectedStrand.StartVertexIndex,:)];
startAttachedStrands = startAttachedStrands(startAttachedStrands~=0);
startAttachedStrands = startAttachedStrands(startAttachedStrands~=selectedStrandID);
endAttachedStrands = [gds.Vertices.StrandIndices(selectedStrand.EndVertexIndex,:)];
endAttachedStrands = endAttachedStrands(endAttachedStrands~=0);
endAttachedStrands = endAttachedStrands(endAttachedStrands~=selectedStrandID);
startMedianRadius = median(gds.Vertices.AllRadii(startAttachedStrands));
endMedianRadius = median(gds.Vertices.AllRadii(endAttachedStrands));

startMedianVoltage = median([memgds(6).Strands(startAttachedStrands).MedianVoltage]);
endMedianVoltage = median([memgds(6).Strands(endAttachedStrands).MedianVoltage]);



% % % if startMedianRadius > endMedianRadius,
% % %     nextRoundStrands = endAttachedStrands;
% % %     trackedStrands = [selectedStrandID,endAttachedStrands];
% % % else%if startMedianRadius > endMedianRadius,
% % %     nextRoundStrands = startAttachedStrands;
% % %     trackedStrands = [selectedStrandID,startAttachedStrands];
% % % end%if-else startMedianRadius > endMedianRadius,

if startMedianVoltage > endMedianVoltage,
    nextRoundStrands = endAttachedStrands;
    trackedStrands = [selectedStrandID,endAttachedStrands];
else%if startMedianVoltage > endMedianVoltage,
    nextRoundStrands = startAttachedStrands;
    trackedStrands = [selectedStrandID,startAttachedStrands];
end%if-else startMedianVoltage > endMedianVoltage,



currentRatioCell = {};
branchIter = 1;
clotCurrent = gds.clotAnalysisParameters.strandCurrentList(selectedStrandID);


% % % origCurrent = gds.circuitAnalysisParameters.strandCurrentList(selectedStrandID);
origCurrent = memgds(6).clotAnalysisParameters.strandCurrentList(selectedStrandID);




currentRatio = 0;
currentRatioCell{1} = currentRatio;

if ~exist('runningMedianRatioList','var'),
    for kk = 1:15
        runningMedianRatioList{kk} = [];
        runningSelectedStrandList = [];
    end
end%if ~exit('runningMedianRatioList','var'),

for branchIter = 2:15,
    seedStrands = nextRoundStrands;
    
    nextRoundStrands = [];
    currentRatioList = [];
    for strandIter = 1:numel(seedStrands),
        thisStrandID = seedStrands(strandIter);
        thisStrand = gds.Strands(thisStrandID);
        if ~ismember(thisStrandID,gds.clotAnalysisParameters.clotStrandID),
            clotCurrent = gds.clotAnalysisParameters.strandCurrentList(thisStrandID);
    %         origCurrent = gds.circuitAnalysisParameters.strandCurrentList(thisStrandID);
    origCurrent = memgds(6).clotAnalysisParameters.strandCurrentList(thisStrandID);

    
    if abs(clotCurrent) < thresholdCurrentForStall, clotCurrent = 0; end
            
            currentRatio = (clotCurrent - origCurrent) * sign(origCurrent);
            
            if origCurrent < 30*thresholdCurrentForStall,
             currentRatioList = [currentRatioList,currentRatio];
            end
% %             currentRatioList = [currentRatioList,currentRatio];
    % %         currentRatioList = [currentRatioList,voltageRatio];


            allAttachedStrands = [gds.Vertices.StrandIndices(thisStrand.StartVertexIndex,:),gds.Vertices.StrandIndices(thisStrand.EndVertexIndex,:)];
            nextStrands = allAttachedStrands(~ismember(allAttachedStrands,trackedStrands));
            nextStrands = nextStrands(nextStrands~=0);
            trackedStrands = [trackedStrands,nextStrands];
            nextRoundStrands = [nextRoundStrands,nextStrands];
        end
    end%for strandIter = 1:numel(seedStrands),
    currentRatioCell{branchIter} = currentRatioList;
end %for branchIter = 2:5,       
  
medianRatioList = [];
for kk = 1:numel(currentRatioCell);
    q = currentRatioCell{kk}; 
    q = q(~isnan(q));
    medianRatioList(kk) = mean(q);
    runningMedianRatioList{kk} = [runningMedianRatioList{kk},mean(q)];
end

howFarDown = min(gds.downstreamBranchList(selectedStrandID,:))

figure(1);plot(medianRatioList,'r.');
runningSelectedStrandList = [runningSelectedStrandList,selectedStrandID];

figure(2);plot(0,0);hold on
for kk = 1:numel(currentRatioCell);
    q = currentRatioCell{kk};
    q = q(~isnan(q));
    for jj = 1:numel(q);
        plot(kk,(q(jj)),'b.');
    end%forjj
end
    
    
   
figure(3);plot(0,0);hold on
for kk = 1:numel(runningMedianRatioList);
    q = runningMedianRatioList{kk};
    q = q(~isnan(q));
    for jj = 1:numel(q);
        plot(kk,(q(jj)),'bo');
    end%forjj
end 
    
pause(2)

 
        
        
        