function thresholdRelaxationParameters = AugmentStrandsWithIslandsPrime2(thresholdRelaxationParameters)

islandlist = thresholdRelaxationParameters.IslandCenterPoints;
Strands = thresholdRelaxationParameters.Strands;
Vertices = thresholdRelaxationParameters.Vertices;
% % AllNotes = Vertices.AllNotes;
StrandIndices = Vertices.StrandIndices;

%Copyright 2008 J.Kaufhold
%Revised 2011 P.Tsai

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.



numStrands = numel(Strands);
numVertices = size(Vertices.AllVerts,1);
nislands = size(islandlist,1);
laststrand = numStrands;
lastptr2coord = numVertices;
newstrands = (laststrand+(1:nislands)');
newptr2coords = (lastptr2coord+(1:nislands)');


% % % % Note the islandlist - 1 compensates for the indexing difference (0 to 1)
% % % islandstrands = [newstrands,max(1,islandlist-1),ones(nislands,1)];
% % % strandSet.strandData = [strandSet.strandData;islandstrands];
% % % strandSet.ctrPoint2StrandLUT = [strandSet.ctrPoint2StrandLUT;[newptr2coords,newstrands]];



q0 = single(zeros(nislands,1));
q1 = int16(ones(nislands,1));
q00 = false(nislands,1);
Vertices.AllVerts = [Vertices.AllVerts;int16(islandlist)];
Vertices.AllRadii = [Vertices.AllRadii;q0];
Vertices.AllLabels = [Vertices.AllLabels;q1];
Vertices.AllConfidences = [Vertices.AllConfidences;q0];
Vertices.AllStrandEndPoints = [Vertices.AllStrandEndPoints;q00];
Vertices.JunctionPoints = [Vertices.JunctionPoints;q00];
Vertices.FreeEndPoints = [Vertices.FreeEndPoints;q00];
%-----
%Create the new strand for every island point
%These strands have no neighbors
vertCounter = numVertices;
for strandIter = numStrands+1 : numStrands+nislands,
    vertCounter = vertCounter + 1;
    Strands(strandIter).StartVertexIndex = vertCounter;
    Strands(strandIter).EndVertexIndex = vertCounter;
% %     Strands(strandIter).InteriorVertices = [vertCounter];
    Strands(strandIter).StartToEndIndices = [vertCounter];
    Strands(strandIter).StartVertexNeighborStrands = [];
    Strands(strandIter).EndVertexNeighborStrands = [];
    Strands(strandIter).Active = 1;
end%for strandIter = numStrands+1 : numStrands+nislands,
%-----
strandCounter = numStrands;
for vertIter = numVertices+1:numVertices+nislands,
    strandCounter = strandCounter + 1;
% %     AllNotes{vertIter} = 'island';
    StrandIndices(vertIter,1) =  strandCounter+1;
end%for vertIter = numOldVerts+1:numOldVerts+numNewVerts,
% % Vertices.AllNotes = AllNotes;
Vertices.StrandIndices = StrandIndices;

 thresholdRelaxationParameters.Strands = Strands;
 thresholdRelaxationParameters.Vertices = Vertices;
 
 
 
 
 
 
 
 
