function outputStructure = VidaTRAugmentBlockEdges2(inputStructure,edgeAugmentationGridStepSize)

    maskSize = inputStructure.maskSize;
    Vertices = inputStructure.Vertices;
    Strands = inputStructure.Strands;
% %     AllNotes = Vertices.AllNotes;
    StrandIndices = Vertices.StrandIndices;
    
    if size(StrandIndices,1)<size(StrandIndices,2),
        StrandIndices = StrandIndices';
    end%if size(StrandIndices,1)<size(StrandIndices,2),

    tempBlock = false(maskSize);
    tempBlock(2,1:edgeAugmentationGridStepSize:end,1:edgeAugmentationGridStepSize:end) = 1; tempBlock(end-1,1:edgeAugmentationGridStepSize:end,1:edgeAugmentationGridStepSize:end) = 1;
    tempBlock(1:edgeAugmentationGridStepSize:end,2,1:edgeAugmentationGridStepSize:end) = 1; tempBlock(1:edgeAugmentationGridStepSize:end,end-1,1:edgeAugmentationGridStepSize:end) = 1;
    tempBlock(1:edgeAugmentationGridStepSize:end,1:edgeAugmentationGridStepSize:end,2) = 1; tempBlock(1:edgeAugmentationGridStepSize:end,1:edgeAugmentationGridStepSize:end,end-1) = 1;
    [qy,qx,qz] = ind2sub(size(tempBlock),find(tempBlock));
    edgePoints = [qy,qx,qz];
    numOldVerts = size(Vertices.AllVerts,1);
    numNewVerts = size(qy,1);
    numStrands = size(Strands,2);
    q0 = single(qy*0);
    q1 = single(qy*0+1);
    q00 = false(size(q0));
    Vertices.AllVerts = [Vertices.AllVerts;int16(edgePoints)];
    Vertices.AllRadii = [Vertices.AllRadii;q1];
    Vertices.AllLabels = [Vertices.AllLabels;q1*111];
    Vertices.AllConfidences = [Vertices.AllConfidences;q0];
    
% % %     for vertIter = numOldVerts+1:numOldVerts+numNewVerts,
% % %         AllNotes{vertIter} = [];
% % %         StrandIndices{vertIter} =  numStrands+1;
% % %     end%for vertIter = numOldVerts+1:numOldVerts+numNewVerts,
% % %     Vertices.AllNotes = AllNotes;
    Vertices.StrandIndices = StrandIndices;
    Vertices.AllStrandEndPoints = [Vertices.AllStrandEndPoints;q00];
    Vertices.JunctionPoints = [Vertices.JunctionPoints;q00];
    Vertices.FreeEndPoints = [Vertices.FreeEndPoints;q00];

    
    %Create the psuedo strand that contains all the augmented edge points
    %This strand has no neighbors
    Strands(numStrands+1).StartVertexIndex = numOldVerts+1;
    Strands(numStrands+1).EndVertexIndex = numOldVerts+numNewVerts;
% %     Strands(numStrands+1).InteriorVertices = [numOldVerts+2:numOldVerts+numNewVerts-1];
    Strands(numStrands+1).StartToEndIndices = [numOldVerts+1:numOldVerts+numNewVerts];
    Strands(numStrands+1).StartVertexNeighborStrands = [];
    Strands(numStrands+1).EndVertexNeighborStrands = [];
    Strands(numStrands+1).Active = 1;

    
    outputStructure.maskSize = maskSize;
    outputStructure.Vertices = Vertices;
    outputStructure.Strands = Strands;