function done = WriteMV3DFile(Strands,Vertices,mv3dfname)

%nStrands = numel(Strands);
nStrands = sum([Strands.Active]);
nAllVerts = size(Vertices.AllVerts,1);

CollectedEndpointVerts = [[Strands.StartVertexIndex],[Strands.EndVertexIndex]];
EOJVertLabs = histc(CollectedEndpointVerts,1:size(Vertices.AllVerts,1));
nIntersections = sum(EOJVertLabs>0);

nPoints = nAllVerts;
%nPoints = (endline - startline - nStrands) - (2 * nIntersections)

fid = fopen(mv3dfname,'wt+');

fprintf(fid,'# MicroVisu3D file\n');
fprintf(fid,'# Number of lines   %d\n',nStrands');
fprintf(fid,'# Number of points  %d\n',nPoints);
fprintf(fid,'# Number of inter.  %d\n',nIntersections);
fprintf(fid,'#\n');
fprintf(fid,'# No		x		y		z		d\n');
fprintf(fid,'#\n');

cptcounter = 0;
strandcounter = 0;
for iSTRAND = 1:numel(Strands)
    if Strands(iSTRAND).Active
        sINDs = Strands(iSTRAND).StartToEndIndices;
        
        for iCPT = 1:numel(sINDs)
            %             fprintf(fid,'%d\t%.6f\t%.6f\t%.6f\t%.6f\n',iSTRAND-1,(Vertices.AllVerts(sINDs(iCPT),2))-1,(Vertices.AllVerts(sINDs(iCPT),1))-1,(Vertices.AllVerts(sINDs(iCPT),3))-1,2);
            fprintf(fid,'%d\t%.6f\t%.6f\t%.6f\t%.6f\n',strandcounter,(Vertices.AllVerts(sINDs(iCPT),2))-1,(Vertices.AllVerts(sINDs(iCPT),1))-1,(Vertices.AllVerts(sINDs(iCPT),3))-1,Vertices.AllRadii(sINDs(iCPT)));
            cptcounter = cptcounter + 1;
        end
        fprintf(fid,'\n');
        strandcounter = strandcounter + 1;
    end
end
fclose(fid);
done = 1;
