function [blockranges]=gridupblock(vsize,overlapsz,n1,n2)

%Copyright 2008 J.Kaufhold

% This file is part of ThresholdRelaxationAlgorithmV0.1
% 
%     ThresholdRelaxationAlgorithmV0.1 is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     ThresholdRelaxationAlgorithmV0.1 is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with ThresholdRelaxationAlgorithmV0.1.  If not, see <http://www.gnu.org/licenses/>.

% Divide each 2D slice in x1x2 plan in 1/(nxiblks)ths to get a blksize estimate
x1sz=fix(((n1-1)*overlapsz+vsize(1))/n1)+1;
x2sz=fix(((n2-1)*overlapsz+vsize(2))/n2)+1;
x1x2geomean=sqrt(x1sz*x2sz);
n3=ceil((vsize(3)-overlapsz)/(x1x2geomean-overlapsz));
raw1=linspace(1,vsize(1),n1+1);
raw2=linspace(1,vsize(2),n2+1);
raw3=linspace(1,vsize(3),n3+1);

shft=overlapsz/2;
rstacked1=[[raw1(1:end-1)];raw1(2:end)];
rstacked1(1,2:end)=rstacked1(1,2:end)-shft;
rstacked1(2,1:end-1)=rstacked1(2,1:end-1)+shft;

rstacked2=[[raw2(1:end-1)];raw2(2:end)];
rstacked2(1,2:end)=rstacked2(1,2:end)-shft;
rstacked2(2,1:end-1)=rstacked2(2,1:end-1)+shft;

rstacked3=[[raw3(1:end-1)];raw3(2:end)];
rstacked3(1,2:end)=rstacked3(1,2:end)-shft;
rstacked3(2,1:end-1)=rstacked3(2,1:end-1)+shft;

st1=round(rstacked1);
st2=round(rstacked2);
st3=round(rstacked3);

bcount=1;
for k=1:size(st3,2)
  for j=1:size(st2,2)
    for i=1:size(st1,2)
      blockgrid.x1min=st1(1,i);
      blockgrid.x1max=st1(2,i);
      blockgrid.x2min=st2(1,j);
      blockgrid.x2max=st2(2,j);
      blockgrid.x3min=st3(1,k);
      blockgrid.x3max=st3(2,k);
      blockranges{bcount}=blockgrid;
      bcount=bcount+1;
    end
  end
end
disp('show block ranges');
