function vectorProject = ConvertToNonCellStorage(vectorProject)
disp('Converting To NonCell Storage...');
StrandIndices = vectorProject.vectorizedStructure.Vertices.StrandIndices;
AllNotes = vectorProject.vectorizedStructure.Vertices.AllNotes;
numPoints = numel(StrandIndices);
nonCellStrandIndices = zeros(numPoints,26);
notePointers = zeros(numPoints,1);
noteList = {};
noteCounter = 0;
tic
for pointIter = 1:numPoints,
    currentStrandIndices = StrandIndices{pointIter};
    numIndices = numel(currentStrandIndices);
    nonCellStrandIndices(pointIter,1:numIndices) = currentStrandIndices;
    %---
    currentNote = AllNotes{pointIter};
    if ~isempty(currentNote) && strcmp(currentNote,'')==0,
        duplicateNoteFlag = 0;
        for noteIter = 1:noteCounter;
            oldNote = noteList{noteIter};
            if strcmp(oldNote,currentNote)==1,
                notePointers(pointIter) = noteIter;
                duplicateNoteFlag = 1;
                break%out of for noteIter loop
            end%if strcmp(oldNote,currentNote)==1,
        end%for noteIter...
        if duplicateNoteFlag == 0,
            noteCounter = noteCounter+1;
            noteList{noteCounter} = currentNote;
            notePointers(pointIter) = noteCounter;
        end%if duplicateNoteFlag == 0,
    end%if ~isempty(currentNote) && strcmp(currentNote,'')==1,
end%for pointIter = 1:numPoints,
toc
vectorProject.vectorizedStructure.Vertices.StrandIndices = nonCellStrandIndices;
vectorProject.vectorizedStructure.Vertices.AllNotes = {};
vectorProject.vectorizedStructure.Vertices.NotePointers = notePointers;
vectorProject.vectorizedStructure.Vertices.NoteList = noteList;
