function D=DistMatrix(X)

%DISTMATRIX Pairwise euclidean distance between observations.
%   D = DISTMATRIX(X) returns a vector D containing the Euclidean distances
%   between each pair of observations in the N-by-P data matrix X.  Rows of
%   X correspond to observations, columns correspond to variables.  D is a
%   2D matrix with the euclidean distance from the point in row i of X to the
%   point in row j of X as elements.

D=zeros(size(X,1),size(X,1));
for i=1:size(X,1)
  dtmp=sqrt(sum((X-repmat(X(i,:),size(X,1),1)).^2,2));
  D(:,i)=dtmp;
end
