function [clust,clabels]=decomposeRAGlabels(AG)

% AG is an adjacency graph that's nonzero for connected vertices

%I think that this code finds all the clusters of cell centroids
%that are all within mergedist of at least one other centroid in
%the cluster - Phil
R=AG+AG';
clustind=1;
clust={};
while sum(sum(R))>0
  tmpinds=[];           
  [ii,jj]=find(R);  %find all nonzero entries (cells with nearby neighbors)
  rootinds=[ii(1)]; %take Cell A
  branchinds=find([R(ii(1),:)]);    %list of all cells {B} connected to A
  tmpinds=[tmpinds,[rootinds,branchinds(:)']];  %list of {C} = [A, {B}]
  R(ii(1),:)=0;     %clear row A in adjacency matrix
  while ~isempty(branchinds)
    [ii,jj]=find(R(branchinds,:));  %find all cells {D} connected to {B}
    R(branchinds,:)=0;  %clear rows {B} in adjacency matrix
    branchinds=unique(jj(:)); %compress to unique set of {D}, reset: {B} = {D}
    tmpinds=unique([tmpinds,[branchinds(:)']]); %concatenate {C} = [{C} , {B}]
  end
  clust{clustind}=tmpinds;
  clustind=clustind+1;
end

%Consider isolated cells as their own cluster and compile
%a list of all clusters in the variable: clust.  Each entry of
%clust is a 1xn list of the n centroid indices associated
%with that cluster
clast=length(clust);
isolatedcleanpts=find(sum(AG+AG')==0);
for i=1:length(isolatedcleanpts)
  clust{clast+i}=isolatedcleanpts(i);
end

%Create a m x1 array (clabels) where m = # of centroids
%each entry in clabels is the cluster# associated with
%that centroid
clabels=zeros(size(AG,1),1);
for i=1:length(clust)
  clabels(clust{i})=i;
end

