function mygaussian = gaussian(circle_size1,gaussian_size1,circle_size2,gaussian_size2,circle_size3,gaussian_size3);
%function mygaussian = gaussian(circle_size1,gaussian_size1,circle_size2,gaussian_size2,circle_size3,gaussian_size3);
%   the gaussian size is the distance from the peak to the 1/e point(0.367)
%   for a gaussian_size = 10, you get a gaussian with:
%       FWHM = 16.6
%       Stdev = 7.07
if nargin<3,
        myhalf = floor(circle_size1/2);
        [x,y,z] = meshgrid(-myhalf:myhalf,-myhalf:myhalf,-myhalf:myhalf);
        mycircle = sqrt(x.^2 + y.^2 +z.^2);
        mygaussian = exp(-1*mycircle.^2/gaussian_size1.^2);
else
        myhalf1 = floor(circle_size1/2);
        myhalf2 = floor(circle_size2/2);
        myhalf3 = floor(circle_size3/2);
        [x,y,z] = meshgrid(-myhalf1:myhalf1,-myhalf2:myhalf2,-myhalf3:myhalf3);
        mycircle = sqrt((x/gaussian_size1).^2 + (y/gaussian_size2).^2 + (z/gaussian_size3).^2);
        mygaussian = exp(-1*mycircle.^2);
end


return
        