function outputStructure = replacefields(inputStructure,searchString,replaceString,verboseFlag)
%outputStructure = replacefields(inputStructure,searchString,replaceString,verboseFlag)
%   written by Philbert S. Tsai on 02/15/08
%Traces through entire structure tree for character strings and replaces
%   all 'searchString' with 'replaceString'

if exist('verboseFlag'),
    switch(verboseFlag),
        case {'on','yes','verbose','1'}
            verboseFlag = 1;
        otherwise
            verboseFlag = 0;
    end%switch(verboseFlag)
else%if exist('verboseFlag'),
    verboseFlag = 0;
end%if exist('verboseFlag'),

currentDepth = 1;
stringAtDepth{currentDepth} = 'inputStructure';
currentField(currentDepth) = 1;
currentStructure = inputStructure;
myFieldNames = fieldnames(currentStructure);
numFields(currentDepth) = size(myFieldNames,1);
fieldsAtDepth(currentDepth) = numFields(currentDepth);

while currentDepth > 0,
    if currentField(currentDepth)<=numFields(currentDepth),
        currentObject{currentDepth} = currentStructure.(myFieldNames{currentField(currentDepth)});
        myClass = class(currentObject{currentDepth});
        switch(myClass)
            case {'char'}
                %make replacement
                currentDepthString = stringAtDepth{currentDepth};
                arraySize = max(size(eval(currentDepthString)));
                for k = 1:arraySize,
                    if arraySize>1,
                        fieldString = [stringAtDepth{currentDepth},'(',num2str(k),').',myFieldNames{currentField(currentDepth)}];
                    else%if arraySize>1,
                        fieldString = [stringAtDepth{currentDepth},'.',myFieldNames{currentField(currentDepth)}];
                        currentString = currentObject{currentDepth};
                        newString = strrep(currentString,searchString,replaceString);
                        eval([fieldString,' = ''',newString, ''';']);
                        if verboseFlag == 1,
                            disp([fieldString,' = ''',newString, ''';']);
                        end%if verboseFlag == 1,
                    end%if-else arraySize>1,
                end%for k = 1:arraySize,
            case {'cell'}
                %make replacement
                numCellElements = numel(currentObject{currentDepth});
                for cellIter = 1:numCellElements,
                    currentCell = currentObject{currentDepth}{cellIter};
                    currentClass = class(currentCell);
                    if strcmpi(currentClass,'char'),
                        fieldString = [stringAtDepth{currentDepth},'.',myFieldNames{currentField(currentDepth)}];
                        currentString = currentObject{currentDepth}{cellIter};
                        foundString = findstr(currentString,searchString);
                        if ~isempty(foundString),
                            newString = strrep(currentString,searchString,replaceString);
                            eval([fieldString,'{',num2str(cellIter),'} = ''',newString, ''';']);
                        end%~isempty(foundString),
                        if verboseFlag == 1,
                            disp([fieldString,'{',num2str(cellIter),'} = ''',newString, ''';']);
                        end%if verboseFlag == 1,
                    end%if strcmpi(currentClass,'char'),
                end%for cellIter = 1:numCellElements,
            case {'struct'}
                stringAtDepth{currentDepth+1} = [stringAtDepth{currentDepth},'.',myFieldNames{currentField(currentDepth)}];
                currentStructure = currentObject{currentDepth};
                currentDepth = currentDepth + 1;
                currentField(currentDepth) = 0;
                %currentObject{currentDepth} = currentObject{currentDepth-1}.(myFieldNames{currentField});
                %myFieldNames = fieldnames(currentObject{currentDepth});
                myFieldNames = fieldnames(currentStructure);
                numFields(currentDepth) = size(myFieldNames,1);
                fieldsAtDepth(currentDepth) = numFields(currentDepth);
        end%switch(myClass)
        currentField(currentDepth) = currentField(currentDepth) + 1;
    end%if currentField(currentDepth)<=numFields(currentDepth),
    if currentField(currentDepth) > numFields(currentDepth),
        currentDepth = currentDepth - 2;
        if currentDepth < 0 , break, end;
        if currentDepth == 0 ,
            currentStructure = inputStructure;
        else%if currentDepth == 0 ,
            currentStructure = currentObject{currentDepth};        
        end%if currentDepth == 0 ,
        currentDepth = currentDepth + 1;
        currentField(currentDepth) = currentField(currentDepth)+1;
        myFieldNames = fieldnames(currentStructure);
    end%if currentField(currentDepth) > numFields(currentDepth),
end%while currentDepth > 0,


outputStructure = inputStructure;
