myDir = dir('*-VidaProject.mat');
vidaProjectFileName = myDir(1).name;
load(vidaProjectFileName);
%-----
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
vidaProjectRootName = vidaProject.vidaProjectRootName;
registrationParameters = vidaProject.registrationParameters;
%-----

currentFolder = cd;
vidaProject.vidaProjectRootFolder = currentFolder;
vidaProjectRootFolder = cd;




if ~isfield(registrationParameters,'permuteSequenceStringNum'),
    registrationParameters.permuteSequenceStringNum = 123;
end
sequenceString = num2str(registrationParameters.permuteSequenceStringNum);
permuteSequence = [];
permuteSequence(1) = str2num(sequenceString(1));
permuteSequence(2) = str2num(sequenceString(2));
permuteSequence(3) = str2num(sequenceString(3))
vidaProject.registrationParameters.permuteSequence = permuteSequence;%Hardcode
vidaProject.registrationParameters.generatePermutedTifFlagList = [0 0 0 0 0 0 0 0];%Hardcode


if isfield(vidaProject,'thresholdRelaxationParameters');
    thresholdRelaxationParameters = vidaProject.thresholdRelaxationParameters;
else
    %-----
    thresholdRelaxationParameters.minConfidence = 1;%Hardcode
    thresholdRelaxationParameters.PreprocessNNConnections = 1;%Hardcode
    thresholdRelaxationParameters.maxGapDist_um = 10;%Hardcode
    thresholdRelaxationParameters.boundBoxMinDist = 10;%Hardcode
    thresholdRelaxationParameters.minvvol = 5;%Hardcode
    thresholdRelaxationParameters.morphfiltsz = 3;%Hardcode
    %---
    thresholdRelaxationParameters.augmentTRBlockEdgesFlag = 0; %Hardcode
    thresholdRelaxationParameters.edgeAugmentationGridStepSize = 20;%Hardcode
    thresholdRelaxationParameters.ignoreEdgeY1 = 15;
    thresholdRelaxationParameters.ignoreEdgeY2 = 15;
    thresholdRelaxationParameters.ignoreEdgeX1 = 15;
    thresholdRelaxationParameters.ignoreEdgeX2 = 15;
    thresholdRelaxationParameters.ignoreEdgeZ1 = 15;
    thresholdRelaxationParameters.ignoreEdgeZ2 = 15;
    thresholdRelaxationParameters.BBmargin1 = 50;
    thresholdRelaxationParameters.BBmargin2 = 0;
    thresholdRelaxationParameters.BBmargin3 = 0;
    thresholdRelaxationParameters.BBmargin4 = 0;
    thresholdRelaxationParameters.thresholdGapConfidence = 1;%Hardcode
    thresholdRelaxationParameters.hopislands = 1;%Hardcode
    disp('ThresholdRelaxation Parameters not found: Hardcoding :');
    thresholdRelaxationParameters
    vidaProject.thresholdRelaxationParameters = thresholdRelaxationParameters;
end 
%-----
ignoreEdgeY1 = thresholdRelaxationParameters.ignoreEdgeY1;
ignoreEdgeY2 = thresholdRelaxationParameters.ignoreEdgeY2;
ignoreEdgeX1 = thresholdRelaxationParameters.ignoreEdgeX1;
ignoreEdgeX2 = thresholdRelaxationParameters.ignoreEdgeX2;
ignoreEdgeZ1 = thresholdRelaxationParameters.ignoreEdgeZ1;
ignoreEdgeZ2 = thresholdRelaxationParameters.ignoreEdgeZ2;
%-----
edgeBoundaryInVoxels = [ignoreEdgeY1, ignoreEdgeY2;...
                        ignoreEdgeX1, ignoreEdgeX2;...
                        ignoreEdgeZ1, ignoreEdgeZ2];
BBmargin = [thresholdRelaxationParameters.BBmargin1,...
    thresholdRelaxationParameters.BBmargin2,...
    thresholdRelaxationParameters.BBmargin3,...
    thresholdRelaxationParameters.BBmargin4];
BBmargin = BBmargin(BBmargin~=0);
vidaProject.thresholdRelaxationParameters.BBmargin = BBmargin;
vidaProject.thresholdRelaxationParameters.edgeBoundaryInVoxels = edgeBoundaryInVoxels;
%-----




fileNameOnlyList{1} =  [vidaProjectRootName,'-registeredVascGrayscale.mat'];
fileNameOnlyList{2}  = [vidaProjectRootName,'-registeredCellGrayscale.mat'];
fileNameOnlyList{3}  = [vidaProjectRootName,'-registeredNeunGrayscale.mat'];
fileNameOnlyList{4}  = [vidaProjectRootName,'-registeredVascEnhancedGrayscale.mat'];
fileNameOnlyList{5}  = [vidaProjectRootName,'-registeredVascRawMask.mat'];
fileNameOnlyList{6}  = [vidaProjectRootName,'-registeredVascEnhancedMask.mat'];
fileNameOnlyList{7}  = [vidaProjectRootName,'-registeredVascRadiusMap.mat'];
fileNameOnlyList{8}  = [vidaProjectRootName,'-registeredVascReconstructedMask.mat'];

for k = 1:8,
    fileNameList{k} = fullfile(currentFolder,fileNameOnlyList{k});
end%for k=1:8
%---
for k = 1:8,
    if ~exist(fileNameList{k},'file'),
        fileNameList{k} = fullfile(currentFolder,fullfile('RegisteredFiles',fileNameOnlyList{k}));
    end%if ~exist ...
end%for k=1:8
%---
for k = 1:8,
    if ~exist(fileNameList{k},'file'),
        fileNameList{k} = fullfile(currentFolder,fullfile('RegisteredFiles',fullfile('StitchedFilesFolder',fileNameOnlyList{k})));
    end%if ~exist ...
end%for k=1:8


vidaProject.globalParameters.registeredVascGrayscaleFileName = fileNameList{1};
variableNameList{1} = 'registeredVascGrayscale';
vidaProject.globalParameters.registeredCellGrayscaleFileName = fileNameList{2};
variableNameList{2} = 'registeredCellGrayscale';
vidaProject.globalParameters.registeredNeunGrayscaleFileName = fileNameList{3};
variableNameList{3} = 'registeredNeunGrayscale';
vidaProject.globalParameters.registeredVascEnhancedGrayscaleFileName = fileNameList{4};
variableNameList{4} = 'registeredVascEnhancedGrayscale';
vidaProject.globalParameters.registeredVascRawMaskFileName = fileNameList{5};
variableNameList{5} = 'registeredVascRawMask';
vidaProject.globalParameters.registeredVascEnhancedMaskFileName = fileNameList{6};
variableNameList{6} = 'registeredVascEnhancedMask';
vidaProject.globalParameters.registeredVascRadiusMapFileName = fileNameList{7};
variableNameList{7} = 'vascRadiusMap';
vidaProject.globalParameters.registeredVascReconstructedMaskFileName = fileNameList{8};
variableNameList{8} = 'vascReconstructedMask';


%STAGE 10 : Permute Data Axes if necessary to Normalize Datasets

vectorProjectFolder = fullfile(vidaProjectRootFolder,'vectorProjectFolder');
vectorProjectRootName = vidaProjectRootName;
vectorProjectFileName = fullfile(vectorProjectFolder,[vectorProjectRootName,'-VectorProject.mat']);
if exist(vectorProjectFileName,'file'),
    load(vectorProjectFileName,'vectorProject');
else%if exist(vectorProjectFileName,'file'),
        vectorProject = VidaRegisteredPermuteParentSL(vidaProject);
    vectorProjectFolder = vectorProject.vectorProjectFolder;
    vectorProjectRootName = vectorProject.vectorProjectRootName;
    saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vectorProjectFileName,'vectorProject',scs);
end%if-else exist(vectorProjectFileName,'file'),


%STAGE 11 : Threshold Relaxation

if vectorProject.progressFlags.thresholdRelaxationCompleted > 0,
    fprintf('\nThreshold Relaxation previously completed\n\n');
else%if vectorProject.multiThreadProgress.thresholdRelaxingFlag >0,
    disp(['Running Threshold Relaxation: ',datestr(now)]);
        vectorProject = VidaThresholdRelaxation3(vectorProject);
    vectorProject.progressFlags.thresholdRelaxationCompleted = 1;
    saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vectorProjectFileName,'vectorProject',scs);
    backupFileName = regexprep(vectorProjectFileName,'VectorProject','PreAddTRBridgesVectorProject');
    save(backupFileName,'vectorProject',scs);
end%if vectorProject.multiThreadProgress.thresholdRelaxingFlag >0,




%STAGE 12 : Add TR Bridges
if isfield(vectorProject.progressFlags,'addTRBridgesCompleted') && vectorProject.progressFlags.addTRBridgesCompleted > 0,
    fprintf('\nAdding TR Bridges previously completed\n\n');
else%if vectorProject.multiThreadProgress.addTRBridgesCompleted >0,
    disp(['Adding TR Bridges and Re-vectorizing: ',datestr(now)]);
        vectorProject = VidaAddTRBridges(vectorProject);
    vectorProject.progressFlags.addTRBridgesCompleted = 1;
    saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vectorProjectFileName,'vectorProject',scs);
end%if vectorProject.multiThreadProgress.addTRBridgesCompleted >0,







