%load a barrel outline.matfile and a -flow-VectorProject file

vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);

%%
allBarrelCoords = [];


numBarrels = numel(barrels);
allVerts = vertices.AllVerts;
allVerts = [allVerts,[1:numVerts]'];
for barrelIter = 1:numBarrels;
    allBarrelCoords = [allBarrelCoords;barrels{barrelIter}];
end

minZ = min(allBarrelCoords(:,3));
maxZ = max(allBarrelCoords(:,3));

globalOffset = (minZ-1)*maskSize(1)*maskSize(2);
subMask = zeros(maskSize(1),maskSize(2),maxZ-minZ+1,'uint16');
numDots = prod(size(subMask));

%%
allValueList = zeros(1,numDots)-999;
vertValueList = zeros(1,numVerts)-999;
barrelVolumeList = [];
for barrelIter = 1:numBarrels;
    disp(barrelIter);
    barrelCoords = barrels{barrelIter};
    minZ = min(barrelCoords(:,3));
    maxZ = max(barrelCoords(:,3));
    myFrame = false(maskSize(1),maskSize(2));
    myFrame(sub2ind(size(myFrame),barrelCoords(:,1),barrelCoords(:,2))) = 1;
    myFrame = imclose(myFrame,circle2d(7)>0);
    myFrame = imfill(myFrame,'holes');
    insideInd = find(myFrame>0);
    insideIndList = [];
    for zIter = minZ:maxZ,
        indexOffset = (zIter-1)*maskSize(1)*maskSize(2);
        insideIndList = [insideIndList;insideInd+indexOffset];
    end%for zIter;
    %---
    dilateSize = 100;
    dilateFrame = imdilate(myFrame,circle2d(dilateSize));
    outsideFrame = (dilateFrame-myFrame) >0;
    outsideInd = find(outsideFrame>0);
    outsideIndList = [];
    for zIter = minZ:maxZ,
        indexOffset = (zIter-1)*maskSize(1)*maskSize(2);
        outsideIndList = [outsideIndList;outsideInd+indexOffset];
    end%for zIter;
    %---
    subVerts = allVerts(allVerts(:,3)>=minZ,:);
    subVerts = subVerts(subVerts(:,3)<=maxZ,:);
    subInd = sub2ind(maskSize,subVerts(:,1),subVerts(:,2),subVerts(:,3));
    %---
    outsideIndices = subVerts(find(ismember(subInd,outsideIndList)),4);
    vertValueList(outsideIndices) = max(vertValueList(outsideIndices),-9);
    allValueList(outsideIndList-globalOffset) = max(allValueList(outsideIndList-globalOffset),-9);
    %---
    insideIndices = subVerts(find(ismember(subInd,insideIndList)),4);
    vertValueList(insideIndices) = max(vertValueList(insideIndices),barrelIter);
    allValueList(insideIndList-globalOffset) = max(allValueList(insideIndList-globalOffset),barrelIter);
    barrelVolumeList(barrelIter) = numel(insideIndList);
end%for barrelIter...
outsideVolume = numel(find(allValueList==-9));

save Results-BarrelInsideOutsideVerts vertValueList barrelVolumeList outsideVolume
%%

    activeVerts = find(and(vertValueList<0,vertValueList==-9));
    
%     [w1,w2,w3] = ind2sub(maskSize,outsideIndList);
    
    activeCoords1 = allVerts(activeVerts,1:3);
%     activeCoords1 = subVerts(:,1:3);
%     activeCoords1 = [w1,w2,w3];
    
    figure(1);p1 = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'b.');hold on
    set(p1,'MarkerSize',1,'Color',thisColor);hold on
   







