
%Automatically load a VectorProject file
myDir = dir('*-VectorProject.mat');
vectorProjectFileName = myDir(1).name;
load(vectorProjectFileName);
dateString = [datestr(now,'mmddyy_HHMMSS'),'-PreImportSE.mat'];
backupFileName = regexprep(vectorProjectFileName,'-VectorProject.mat',['-BackupVectorProject-',dateString]);
save(backupFileName,'vectorProject');
%-----
%Select an (old-style) SE file to import from
[manualFileName,manualPath] = uigetfile({['*',currentFileName];'*.mat'},['Locate : ',currentFileName]);
load(fullfile(manualPath,manualFileName),'globalDataStruct');
%-----



%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label



%Label Structure
%100's Labels : Topology   : 100=Unlabeled, 200=Temporary, 300=Surface, 400=Plunging, 500=Connecting
%10's Labels  : Physiology :  10=Unlabeled,  20=Temporary,  30=Supply ,  40=Draining,  50=Microvessel
%1's Labels   : WhenAdded  :   1=Original ,   2=TR Added ,   3=Manual



maskSize = globalDataStruct.maskSize;
cpMatrix = globalDataStruct.cpMatrix;
strands = globalDataStruct.strands;
ar = globalDataStruct.ar;
si = globalDataStruct.si;
oldLabels = cpMatrix(:,7);
newLabels = (10*floor(oldLabels/10))+1;
fep = globalDataStruct.fep;
jp = globalDataStruct.jp;
%---
indList = sub2ind(maskSize,cpMatrix(:,1),cpMatrix(:,2),cpMatrix(:,3));
jpIndList = sub2ind(maskSize,jp(:,1),jp(:,2),jp(:,3));
fepIndList = sub2ind(maskSize,fep(:,1),fep(:,2),fep(:,3));
junctionPoints = ismember(indList,jpIndList);
freeEndPoints = ismember(indList,fepIndList);
allStrandEndPoints = or(junctionPoints,freeEndPoints);





tempVertices = [];
tempVertices.AllVerts = cpMatrix(:,1:3);
tempVertices.AllRadii = ar;
tempVertices.AllStrandEndPoints = allStrandEndPoints;
tempVertices.JunctionPoints = junctionPoints;
tempVertices.FreeEndPoints = freeEndPoints;
tempVertices.StrandIndices = si;
tempVertices.AllLabels = newLabels;
tempVertices.AllConfidences = zeros(size(ar))+Inf;
% % stempVertices.AllNotes = cell(size(ar));
%----
vectorProject.vectorizedStructure.Vertices = tempVertices;
vectorProject.vectorizedStructure.Strands = strands;

saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vectorProjectFileName,'vectorProject',scs);









