
scriptVersion = 'CalculateGMatrixEigenValues.m';

vectorProject = allProject.au;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('auEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.av;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('avEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.co;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('coEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('dbEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.avPlus0p5;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('auPlus0p5Eigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.coPlus0p4;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

clear eigenVectors eigenValueMatrix eingValues
L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('coPlus0p4Eigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
%%
vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
plungingStrandList = [unperturbedProject.vectorizedStructure.allPlungingArterioleList,unperturbedProject.vectorizedStructure.allPlungingVenuleList]
unperturbedProject.vectorizedStructure.effectiveStrandRadiusList(plungingStrandList) = 0.001;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);


clear eigenVectors eigenValueMatrix eingValues
L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('dbMinusPlungingEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)


%%
vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
strandLabelList = [strands(:).MedianLabel];
surfaceStrandList = ismember(strandLabelList,[300:399]);
plungingStrandList = [unperturbedProject.vectorizedStructure.allPlungingArterioleList,unperturbedProject.vectorizedStructure.allPlungingVenuleList];
unperturbedProject.vectorizedStructure.effectiveStrandRadiusList(surfaceStrandList) = 0.001;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);


clear eigenVectors eigenValueMatrix eingValues
L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('dbMinusSurfaceEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.co;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
strandLabelList = [strands(:).MedianLabel];
surfaceStrandList = ismember(strandLabelList,[300:399]);
plungingStrandList = [unperturbedProject.vectorizedStructure.allPlungingArterioleList,unperturbedProject.vectorizedStructure.allPlungingVenuleList];
unperturbedProject.vectorizedStructure.effectiveStrandRadiusList(surfaceStrandList) = 0.001;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

clear eigenVectors eigenValueMatrix eingValues
L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('coMinusSurfaceEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)
%%
vectorProject = allProject.au;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
strandLabelList = [strands(:).MedianLabel];
surfaceStrandList = ismember(strandLabelList,[300:399]);
plungingStrandList = [unperturbedProject.vectorizedStructure.allPlungingArterioleList,unperturbedProject.vectorizedStructure.allPlungingVenuleList];
unperturbedProject.vectorizedStructure.effectiveStrandRadiusList(surfaceStrandList) = 0.001;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);


L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('auMinusSurfaceEigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)


%%
vectorProject = perturbedProject;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save('auRemoveFraction0.33Eigen.mat','eigenVectors','eigenValues','-V7.3');
datestr(now)


%%
% % %%
% % tic
% % RMatrix = zeros(size(eigenVectors));
% % toc
% % mSize = size(RMatrix,1);
% % indexList = [1:mSize];
% % for alphaIter = 1:mSize;
% %     disp(alphaIter);
% %     for betaIter = 1:mSize;
% %         disp(betaIter);
% %         tic
% %         runSum = 0;
% %         for iIter = 2:mSize;
% %             eVectorAlpha = eigenVectors(alphaIter,iIter);
% %             eVectorBeta = eigenVectors(betaIter,iIter);
% %             eVal = eigenValues(iIter);
% %             runSum = runSum + (((eVectorAlpha-eVectorBeta)^2)/eVal);
% %         end%for iIter;
% %         RMatrix(alphaIter,betaIter) = runSum;
% %         toc
% %     end%for betaIter
% % end%for alphaIter;
% % 
