% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);

strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;

strandID = 2299;
vertex1ID = strands(strandID).StartVertexIndex;
vertex2ID = strands(strandID).EndVertexIndex;
strandResistance = 1/strands(strandID).strandConductance

floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
floatingNode2ID = find(floatingNodeIndexList==vertex2ID);



figure(1);plot(eigenVectors(:,1),'r.');
figure(2);plot(log(eigenValues),'g.');


runSum = 0;
mSize = size(eigenVectors,1);
for iIter = 2:mSize;
    eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
    eVectorBeta = eigenVectors(floatingNode2ID,iIter);
    eVal = eigenValues(iIter);
    cutoff = 1e-5;
    if eVal > cutoff,
        runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
%         pause
    end
end%for iIter;
effReistance = runSum
ratio = effReistance/strandResistance% should be less than 1

