function varargout = FastRestrandifyVectorProject(varargin);

if nargin>0,
    vectorProject = varargin{1};
else
    [fileName,pathName] = uigetfile('*-VectorProject.mat','Select a vectorProject file');
    cd(pathName)
    load(fileName,'vectorProject');
end
%---
    
vectorProjectRootName = vectorProject.vectorProjectRootName;
vectorProjectRootName = [vectorProjectRootName,'-'Restrandified];
vectorProject.vectorProjectRootName = vectorProjectRootName;
vectorProjectFileName = [vectorProjectRootName,'-VectorProject.mat'];
vectorizedStructure = vectorProject.vectorizedStructure;
Strands = vectorizedStructure.Strands;
Vertices = vectorizedStructure.Vertices;


%Remove a strand

    
%Find the largest connected subgraph
subgraphLabels = ParseSubgraphs(vectorizedStructure);
numSubgraphs = max(subgraphLabels);
h = hist(subgraphLabels,[1:numSubgraphs]);
[majorSubgraphSize,majorSubgraphLabel] = max(h);
majorSubgraphStrandList = find(subgraphLabels == majorSubgraphLabel);

%Inactivate all strands not on the largest subgraph
for strandIter = majorSubgraphStrandList
   Strands(strandIter).Active = 0;
   
   
   
   
if nargout>0,
    varargout{1} = vectorProject;
end


    
