function vectorProject = FastVectorProject(varargin)

saveFlag = 0;
vectorProject = varargin{1};
if nargin > 1,
    for kk = 2:nargin,
        thisArg = varargin{kk};
        switch lower(thisArg),
            case {'save'}
                saveFlag = 1;
            case {'nosave'}
                saveFlag = 0;
        end%switch lower(thisArg)
    end%for kk = 2:nargin,
end%if nargin>1


StrandIndices = vectorProject.vectorizedStructure.Vertices.StrandIndices;
if iscell(StrandIndices),
    numPoints = numel(StrandIndices);
    strandIndicesMatrix =(zeros(numPoints,26));
    for pointIter = 1:numPoints,
        currentStrandIndices = StrandIndices{pointIter};
        numIndices = numel(currentStrandIndices);
        strandIndicesMatrix(pointIter,1:numIndices) = currentStrandIndices;
    end%for pointIter = 1:numPoints,
%     strandIndicesMatrix = sparse(strandIndicesMatrix);
    vectorProject.vectorizedStructure.Vertices.StrandIndices = strandIndicesMatrix;
end%if iscell(StrandIndices),

AllNotes = vectorProject.vectorizedStructure.Vertices.AllNotes;
if ~isempty(AllNotes),
    numPoints = numel(AllNotes);
    NotePointers = zeros(numPoints,1);
    noteCounter = 0;
    NoteList = [];
    for pointIter = 1:numPoints,
        currentNote = AllNotes{pointIter};
        if ~isempty(currentNote),
            noteCounter = noteCounter + 1;
            NoteList{noteCounter,1} = currentNote;
        end%if ~isempty(currentNote),
    end%for pointIter = 1:numPoints,
    vectorProject.vectorizedStructure.Vertices.AllNotes = {};
    vectorProject.vectorizedStructure.Vertices.NotePointers = NotePointers;
    vectorProject.vectorizedStructure.Vertices.NoteList = NoteList;
end%if ~isempty(AllNotes),

if saveFlag == 1,
    fileName = fullfile(vectorProject.vectorProjectFolder,[vectorProject.vectorProjectRootName,'-VectorProject-fast.mat']);
    save(fileName,'vectorProject');
end



















