%Load a vectorProject file



%Start at a voltage or ground strand
%Walk, keeping track of all previous direction change options
%Stop if:  (a) you hit another ground/voltage strand
%       (b) you hit a "completed" strand
%       (c) you hit a stand on the current path
%
%(a) : mark all points on path as complete - but do not transfer to master list
%       back up one step - remove traveled path - take untraveled path or back up more
%(b) : same procedure as (a)
%(c) : do not mark points on path as complete - otherwise same as (a) & (b)
%
%When all options are exhausted - transfer completed strands list to master list

fixedALabelList = [330 630];%Hardcode : labels to be considerred voltages voltages
fixedBLabelList = [340 640];%Hardcode : labels to be considered ground
startStrandID = 101;
    


maskSize = globalDataStruct.maskSize;
strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
si = globalDataStruct.si;
ar = globalDataStruct.ar;
numStrands = size(strands,2);

cpMatrix2 = cpMatrix;
cpMatrix2(:,7) = 110;
touchedStrandFlagList = zeros(numStrands,1);
% % % for strandIter = 1:numStrands,
% % %     currentStrandID = strandIter;
% % %     currentStrand = strands(currentStrandID);
% % %     iv = currentStrand.InteriorVertices;
% % %     majorityLabel = median(cpMatrix(iv,7));
% % %     if ismember(majorityLabel,[voltageStrandLabelList,groundStrandLabelList]),
% % %         cpMatrix2(iv,7) = 130;
% % %         touchedStrandFlagList(currentStrandID) = 1;
% % %     end
% % % end
stei = strands(startStrandID).StartToEndIndices;
cpMatrix2(stei,7) = 130;
touchedStrandFlagList(startStrandID) = 1;




keepGoingFlag = 1;
while keepGoingFlag,
    changedCounter = 0;
    numTouchedStrands = sum(touchedStrandFlagList);
    touchedStrandList = find(touchedStrandFlagList==1);    
    for strandIter = 1:numTouchedStrands,
        currentStrandID = touchedStrandList(strandIter);
        currentStrand = strands(currentStrandID);
        iv = currentStrand.InteriorVertices;
        stei = currentStrand.StartToEndIndices;
        svns = currentStrand.StartVertexNeighborStrands;
        evns = currentStrand.EndVertexNeighborStrands;
        neighborStrandList = unique([svns,evns]);
        neighborStrandList = neighborStrandList(neighborStrandList~=currentStrandID);
        numNeighborStrands = numel(neighborStrandList);
        for neighborIter = 1:numNeighborStrands,
            currentNeighbor = neighborStrandList(neighborIter);
            niv = strands(currentNeighbor).InteriorVertices;
            nstei = strands(currentNeighbor).StartToEndIndices;
            neighborMajorityLabel = median(cpMatrix2(niv,7));
            if neighborMajorityLabel == 110,
                changedCounter = changedCounter + 1;
                cpMatrix2(nstei,7) = 130;
                touchedStrandFlagList(currentNeighbor) = 1;
            end
        end
    end
    disp(changedCounter);
    if changedCounter == 0, keepGoingFlag = 0;end
end


f1 = find(cpMatrix2(:,7)==110);
cpMatrix(f1,6) = 0;


globalDataStruct.cpMatrix = cpMatrix;            
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE',dateString,'-SingleNeighborhood','-StrandEdit-',fileName,ext]);
save(saveFileName,'globalDataStruct');



if variableCleanupFlag == 1,
    clear ar changedCounter cpMatrix cpMatrix2 currentNeighbor currentStrand currentStrandID
    clear dateString evns ext f1 fileName fileRootName iv keepGoingFlag neighborIter
    clear neighborMajorityLabel neighborStrandList niv nstei numNeighborStrands numStrands
    clear numTouchedStrands pathName saveFileName si stei strandIter strands svns
    clear touchedStrandFlagList touchedStrandList
end%if variableCleanupFlag == 1




