% function FlowFromStrand(vectorProject,startStrandID);


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;

        highV = find(AllVoltages>90);
        AllLabels = Vertices.AllLabels;
        highVLabels = AllLabels(highV);
        sub1 = ismember(highVLabels,[430:439]);
        highV2 = highV(sub1);
        potentialList = unique(StrandIndices(highV2));


for startIter = 5:length(potentialList);
    
    
startStrandID = potentialList(startIter)
stopVoltage = 50.5;
minimumFluxFraction = 1/3000;
divFactor = 3;
maxVoltage = 100;



numStrands = numel(Strands);
startStrand = Strands(startStrandID);
strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
nodeVoltages = AllVoltages(strandNodes);
[highVoltage,highVoltagePos] = max(nodeVoltages);
[lowVoltage,lowVoltagePos] = min(nodeVoltages);
highNode = strandNodes(highVoltagePos);
lowNode = strandNodes(strandNodes~=highNode);

pathActiveFlagList = false(1,100000);
pathActiveFlagList(1) = 1;
numActivePath = sum(pathActiveFlagList);
strandPathList = {};
nodePathList = {};
fractionPathList = {};
strandPathList{1} = startStrandID;
nodePathList{1} = [highNode lowNode];
fractionPathList{1} = 1;
strandFlowList = zeros(numStrands,1);
strandFlowList(startStrandID) = 1;
strandVoltageList = zeros(numStrands,1);
strandVoltageList(1) = mean([highVoltage,lowVoltage]);
pathCounter = 1;
keepGoingFlag = 1;


while (keepGoingFlag == 1),
    myCount = 0;
%     keyboard
    for pathIter = find(pathActiveFlagList == 1);
        currentPathID = pathIter;
        currentStrandPath = strandPathList{pathIter};
        currentNodePath = nodePathList{pathIter};
        currentFractionPath = fractionPathList{pathIter};
        currentStrandID = currentStrandPath(end);
        currentStrand = Strands(currentStrandID);
        %-----
        strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);
        lowAttachedStrands = StrandIndices(lowNode,:);
        lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
        lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
        numDaughterPaths = numel(lowAttachedStrands);
        strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
        stopTracingFlag = 0;
        if numDaughterPaths == 0, stopTracingFlag = 1; end
        if lowVoltage < stopVoltage, stopTracingFlag = 1; end
        if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
        if stopTracingFlag == 1,
            pathActiveFlagList(currentPathID) = 0;
        else%if stopTracingFlag == 1,
            motherCurrent = abs(currentStrand.strandCurrent);
            validDaughterCounter = 0;
            validDaughterStrandList = [];
            validDaughterCurrentList = zeros(1,numDaughterPaths);
            validDaughterPathIndexList = [];
            for daughterIter = 1:numDaughterPaths,
                %Check to see if the daughter strand leads to a lower voltage
                candidateDaughterID = lowAttachedStrands(daughterIter);
                candidateDaughterStrand = Strands(candidateDaughterID);
                candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                candidateDaughterOtherVoltage = AllVoltages(candidateDaughterOtherNode);
                if candidateDaughterOtherVoltage < lowVoltage,
                    %if so, add the strand to a path
                    myCount = myCount + 1;
                    validDaughterCounter = validDaughterCounter + 1;
                    validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                    validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                    if validDaughterCounter == 1,
                        %if this is the first valid daughter, add to current path
                        strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                        nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                        validDaughterPathIndexList(1) = currentPathID;
                    else%if validDaughterCounter == 1,
                        %if not the first daughter, duplicate path up to this point, and
                        %make new path
                        pathCounter = pathCounter + 1;
                        strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                        nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                        fractionPathList{pathCounter} = currentFractionPath;
                        pathActiveFlagList(pathCounter) = 1;  
                        validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                    end%if-else validDaughterCounter == 1,
                end%if candidateDaughterOtherVoltage < lowVoltage,
            end%for daughterIter = 1:numDaughterPaths,
            clear daughterIter
            %-----
            daughterSumCurrent = sum(validDaughterCurrentList);
            fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
            for validDaughterIter = 1:validDaughterCounter;
                validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
            end%for validDaughterIter = 1:validDaughterCounter;
        end%if-else stopTracingFlag == 1,
    end%for pathIter = find(pathActiveFlagList == 1);
    if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
    if myCount == 0, keepGoingFlag = 0;end
    disp([myCount]);
    
end%while (keepGoingFlag == 1),

% clear candidate* current* high* low* keep* valid* *Iter


% % clear qq;for k = 1:numel(fractionPathList);q = fractionPathList{k};q = q(q~=0);qq(k) = q(end);end
% % sum(qq)

% % numPaths = numel(strandPathList);
% % for pathIter = 1:numPaths,
% %     thisStrandPath = strandPathList{pathIter};
% %     thisNodePath = nodePathList{pathIter};
% %     pathCurrentList = abs([Strands(thisStrandPath).strandCurrent]);
% %     pathVoltageList = AllVoltages(thisNodePath);
% %     figure(1);semilogy(pathCurrentList,'b-')
% %     figure(2);plot(pathVoltageList,'r-');
% %     pause(0.1);
% % end

% % % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % % divMaskSize = size(myMask);
% % % numPaths = numel(strandPathList);
% % % for pathIter = 1:numPaths,
% % %     thisStrandPath = strandPathList{pathIter};
% % %     pathIndexList = abs([Strands(thisStrandPath).InteriorVertices]);
% % %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % %     myMask(maskIndexList) = myMask(maskIndexList)+1;
% % % end
% % %     
% % % maketiff(myMask,'testMask.tif');


% % % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % % divMaskSize = size(myMask);
% % % numPaths = numel(strandPathList);
% % % for pathIter = 1:numPaths,
% % %     thisStrandPath = strandPathList{pathIter};
% % %     thisFractionPath = fractionPathList{pathIter};
% % %     numSegments = numel(thisStrandPath);
% % %     for segmentIter = 1:numSegments;
% % %         pathIndexList = Strands(thisStrandPath(segmentIter)).InteriorVertices;
% % %         pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % %         maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % %         myMask(maskIndexList) = max(myMask(maskIndexList),thisFractionPath(segmentIter)*255);
% % %     end%for segmentIter = 1:numSegments;
% % % end%for pathIter = 1:numPaths,
% % % 
% % % 




% % %Generate a flow distribution mask
% % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % voltageMask = zeros(ceil(maskSize/divFactor),'uint8');
% % divMaskSize = size(myMask);
% % activeStrandList = find(strandFlowList>0);
% % numActiveStrands = numel(activeStrandList);
% % for strandIter = 1:numActiveStrands 
% %     thisStrandID = activeStrandList(strandIter);
% %     thisStrand = Strands(thisStrandID);
% %     pathIndexList = thisStrand.InteriorVertices;
% %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% %     myMask(maskIndexList) = ceil(strandFlowList(thisStrandID)*255);
% %     voltageMask(maskIndexList) = 255*strandVoltageList(thisStrandID)./maxVoltage;
% % end%for pathIter = 1:numPaths,
% % maketiff(myMask,['FlowMask_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);
% % maketiff(voltageMask,['VoltageMask_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);




%Generate a plot
myR = zeros(256,1);
myG = zeros(256,1);
myB = zeros(256,1);
myR(257-200:256) = linspace(1,255,200);
myG(0+1:0+64) = linspace(1,255,64);
myG(64+1:64+32) = linspace(255,1,32);
myB(1:64) = linspace(255,1,64);
myColorMap = [myR,myG,myB]./256;
%-----
figure(1);plot(myR,'r-');
hold on
figure(1);plot(myG,'g-');
figure(1);plot(myB,'b-');
hold off
%-----
divMaskSize = size(myMask);
activeStrandList = find(strandFlowList>0);
numActiveStrands = numel(activeStrandList);
ff = figure(10);
cameratoolbar
for strandIter = 1:numActiveStrands 
    thisStrandID = activeStrandList(strandIter);
    thisStrand = Strands(thisStrandID);
    pathIndexList = thisStrand.InteriorVertices;
    pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
    maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
    p3 = plot3(pathCoordList(:,1),pathCoordList(:,2),-1*pathCoordList(:,3),'ro');hold on
    thisStrandFlow = ceil(strandFlowList(thisStrandID)*255);
    thisStrandVoltage = ceil(255*(strandVoltageList(thisStrandID)-49)./51);
    set(p3,'MarkerSize',thisStrandFlow/20);
    set(p3,'Color',myColorMap(thisStrandVoltage,:))
end%for pathIter = 1:numPaths,
xlabel('Axis 1');
ylabel('Axis 2');
zlabel('Axis 3');
plot3(0,0,0,'b.');
plot3(500,500,-500,'b.');
hold off
saveas(ff,['Figure_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);


pause
end






