function GenerateCircuitCurrentMask3(flowProject)

vectorizedStructure = flowProject.vectorizedStructure;
flowProjectRootName = flowProject.flowProjectRootName;
vectorProjectFolder = flowProject.vectorProjectFolder;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
strandCurrentList = abs([Strands.strandCurrent]);
outputMaskSizeDivisor = flowProject.circuitAnalysisParameters.outputMaskSizeDivisor;

logFlag = 1;%Hardcode

if logFlag == 1,
    strandCurrentList = log(strandCurrentList+1);
end%if logFlag == 1,

minCurrent = median(strandCurrentList)-3*std(strandCurrentList);
maxCurrent = median(strandCurrentList)+3*std(strandCurrentList);



strandCurrentList = min(maxCurrent,max(minCurrent,strandCurrentList));
currentRange = maxCurrent-minCurrent;
minOutputValue = 56;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normCurrents = (((strandCurrentList-minCurrent)/currentRange)*outputRange)+minOutputValue;


%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numStrands = numel(strandCurrentList);
for strandIter = 1:numStrands,
    thisStrand = Strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    numPoints = numel(stei);
    thisCurrent = normCurrents(strandIter);
    for pointIter = 1:numPoints,
        coords = ceil(AllVerts(stei(pointIter),:)/outputMaskSizeDivisor);
        myMask(coords(1),coords(2),coords(3)) = thisCurrent;
    end%for pointIter = 1:numPoints,
end%for strandIter = 1:numStrands,



saveFileName = [flowProjectRootName,'-CurrentMaskDiv',num2str(outputMaskSizeDivisor),'.tif'];
savePathFileName = fullfile(fullfile(vectorProjectFolder,flowProject.associatedFlowProjectFolder),saveFileName);

if ~exist(fullfile(flowProject.vectorProjectFolder,flowProject.associatedFlowProjectFolder)),
    mkdir(flowProject.vectorProjectFolder,flowProject.associatedFlowProjectFolder)
end%if ~exist...
maketiff(myMask,savePathFileName);


    
    

