% % function GenerateCircuitCurrentSizeMask(vectorProject)


vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
strandCurrentList = abs([Strands.strandCurrent]);


outputMaskSizeDivisor = 3;%Hardcode
logFlag = 0;%Hardcode

if logFlag == 1,
    strandCurrentList = log10(strandCurrentList+1);
end%if logFlag == 1,
hist(strandCurrentList,1000);

maxCurrent = max(strandCurrentList);
minCurrent = min(strandCurrentList);

maxCurrent = 1e8;%Hardcode
minCurrent = 1e7;%Hardcode


strandCurrentList = min(maxCurrent,max(minCurrent,strandCurrentList));
currentRange = maxCurrent-minCurrent;
minOutputValue = 1;
maxOutputValue = 5;
outputRange = maxOutputValue - minOutputValue;
normCurrents = (((strandCurrentList-minCurrent)/currentRange)*outputRange)+minOutputValue;
hist(normCurrents,100);

%-----
myMask = false(ceil(maskSize/outputMaskSizeDivisor));
numStrands = numel(strandCurrentList);
for currentIter = minOutputValue : maxOutputValue
    disp(currentIter);
    tempMask = false(ceil(maskSize/outputMaskSizeDivisor));
    for strandIter = 1:numStrands,
        thisStrand = Strands(strandIter);
        stei = thisStrand.StartToEndIndices;
        numPoints = numel(stei);
        thisCurrent = normCurrents(strandIter);
        if thisCurrent>=currentIter && thisCurrent<=currentIter+1;
            for pointIter = 1:numPoints,
                coords = ceil(AllVerts(stei(pointIter),:)/outputMaskSizeDivisor);
                tempMask(coords(1),coords(2),coords(3)) = 1;
            end%for pointIter = 1:numPoints,
        end%if thisCurrent>=....
    end%for strandIter = 1:numStrands
    tempMask = imdilate(tempMask,circle3d(currentIter));
    myMask = max(myMask,tempMask);
end%for currentIter = minOutputValue : maxOutputValue


maketiff(myMask,[vectorProjectRootName,'-QCurrentSizeMaskDiv',num2str(outputMaskSizeDivisor),'.tif']);

    


