function vectorProject = GenerateCircuitVoltageMask2(vectorProject)

vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
AllVoltages = Vertices.AllVoltages;
outputMaskSizeDivisor = vectorProject.circuitAnalysisParameters.outputMaskSizeDivisor;



normVoltages = AllVoltages;
maxVoltage = max(AllVoltages);
minVoltage = min(AllVoltages);
voltageRange = maxVoltage-minVoltage;
minOutputValue = 56;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normVoltages = (((AllVoltages-minVoltage)/voltageRange)*outputRange)+minOutputValue;


%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numVertices = numel(AllVoltages);
for vertexIter = 1:numVertices,
    coords = ceil(AllVerts(vertexIter,:)/outputMaskSizeDivisor);
    thisVoltage = normVoltages(vertexIter);
    myMask(coords(1),coords(2),coords(3)) = thisVoltage;
end

maketiff(myMask,[vectorProjectRootName,'-VoltageMaskDiv',num2str(outputMaskSizeDivisor),'.tif']);

    

