function GenerateCircuitVoltageMask3(flowProject)

vectorizedStructure = flowProject.vectorizedStructure;
flowProjectRootName = flowProject.flowProjectRootName;
vectorProjectFolder = flowProject.vectorProjectFolder;
associatedFlowProjectFolder = flowProject.associatedFlowProjectFolder;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
AllVoltages = Vertices.AllVoltages;
outputMaskSizeDivisor = flowProject.circuitAnalysisParameters.outputMaskSizeDivisor;


normVoltages = AllVoltages;
maxVoltage = max(AllVoltages);
minVoltage = min(AllVoltages);
voltageRange = maxVoltage-minVoltage;
minOutputValue = 56;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normVoltages = (((AllVoltages-minVoltage)/voltageRange)*outputRange)+minOutputValue;


%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numVertices = numel(AllVoltages);
for vertexIter = 1:numVertices,
    coords = ceil(AllVerts(vertexIter,:)/outputMaskSizeDivisor);
    thisVoltage = normVoltages(vertexIter);
    myMask(coords(1),coords(2),coords(3)) = thisVoltage;
end

saveFileName = [flowProjectRootName,'-VoltageMaskDiv',num2str(outputMaskSizeDivisor),'.tif'];
savePathFileName = fullfile(fullfile(vectorProjectFolder,associatedFlowProjectFolder),saveFileName);

if ~exist(fullfile(flowProject.vectorProjectFolder,flowProject.associatedFlowProjectFolder)),
    mkdir(flowProject.vectorProjectFolder,flowProject.associatedFlowProjectFolder)
end%if ~exist...
maketiff(myMask,savePathFileName);


    

