function vectorProject = GenerateCurrentStoppageMaskRGB(vectorProject)

vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
strandCurrentList = abs([Strands.strandCurrent]);


strandCurrentList = abs(vectorProject.circuitAnalysisParameters.strandCurrentHistoryList(:,5));
max(strandCurrentList)

outputMaskSizeDivisor = 3;%Hardcode
logFlag = 1;%Hardcode

if logFlag == 1,
    strandCurrentList = log(strandCurrentList+1);
end%if logFlag == 1,

% % minCurrent = median(strandCurrentList)-3*std(strandCurrentList);
% % maxCurrent = median(strandCurrentList)+3*std(strandCurrentList);
% % 
minCurrent = min(strandCurrentList);
maxCurrent = max(strandCurrentList);

strandCurrentList = min(maxCurrent,max(minCurrent,strandCurrentList));
currentRange = maxCurrent-minCurrent;
minOutputValue = 1;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normCurrents = (((strandCurrentList-minCurrent)/currentRange)*outputRange)+minOutputValue;

%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numStrands = numel(strandCurrentList);
for strandIter = 1:numStrands,
    thisStrand = Strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    numPoints = numel(stei);
    thisCurrent = normCurrents(strandIter);
    for pointIter = 1:numPoints,
        coords = ceil(AllVerts(stei(pointIter),:)/outputMaskSizeDivisor);
        myMask(coords(1),coords(2),coords(3)) = thisCurrent;
    end%for pointIter = 1:numPoints,
end%for strandIter = 1:numStrands,

mask1 = permute(myMask,[3,2,1]);

%----------------------------
%----------------------------
%----------------------------
%----------------------------
%----------------------------


vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
strandCurrentList = abs([Strands.strandCurrent]);


strandCurrentList = abs(vectorProject.circuitAnalysisParameters.strandCurrentHistoryList(:,4));
max(strandCurrentList)

outputMaskSizeDivisor = 3;%Hardcode
logFlag = 1;%Hardcode

if logFlag == 1,
    strandCurrentList = log(strandCurrentList+1);
end%if logFlag == 1,

% % minCurrent = median(strandCurrentList)-3*std(strandCurrentList);
% % maxCurrent = median(strandCurrentList)+3*std(strandCurrentList);
% % 
minCurrent = min(strandCurrentList);
maxCurrent = max(strandCurrentList);

strandCurrentList = min(maxCurrent,max(minCurrent,strandCurrentList));
currentRange = maxCurrent-minCurrent;
minOutputValue = 1;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normCurrents = (((strandCurrentList-minCurrent)/currentRange)*outputRange)+minOutputValue;

%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numStrands = numel(strandCurrentList);
for strandIter = 1:numStrands,
    thisStrand = Strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    numPoints = numel(stei);
    thisCurrent = normCurrents(strandIter);
    for pointIter = 1:numPoints,
        coords = ceil(AllVerts(stei(pointIter),:)/outputMaskSizeDivisor);
        myMask(coords(1),coords(2),coords(3)) = thisCurrent;
    end%for pointIter = 1:numPoints,
end%for strandIter = 1:numStrands,

mask2 = permute(myMask,[3,2,1]);;


%----------------------------
%----------------------------
%----------------------------
%----------------------------
%----------------------------


vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
maskSize = vectorizedStructure.maskSize;
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
strandCurrentList = abs([Strands.strandCurrent]);


strandCurrentList = abs(vectorProject.circuitAnalysisParameters.strandCurrentHistoryList(:,4));
max(strandCurrentList)

outputMaskSizeDivisor = 3;%Hardcode
logFlag = 1;%Hardcode

if logFlag == 1,
    strandCurrentList = log(strandCurrentList+1);
end%if logFlag == 1,

% % minCurrent = median(strandCurrentList)-3*std(strandCurrentList);
% % maxCurrent = median(strandCurrentList)+3*std(strandCurrentList);
% % 
minCurrent = min(strandCurrentList);
maxCurrent = max(strandCurrentList);

strandCurrentList = min(maxCurrent,max(minCurrent,strandCurrentList));
currentRange = maxCurrent-minCurrent;
minOutputValue = 100;
maxOutputValue = 255;
outputRange = maxOutputValue - minOutputValue;
normCurrents = (((strandCurrentList-minCurrent)/currentRange)*outputRange)+minOutputValue;

%-----
myMask = zeros(ceil(maskSize/outputMaskSizeDivisor),'uint8');
numStrands = numel(strandCurrentList);
for strandIter = 1:numStrands,
    thisStrand = Strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    numPoints = numel(stei);
    thisCurrent = normCurrents(strandIter);
    for pointIter = 1:numPoints,
        coords = ceil(AllVerts(stei(pointIter),:)/outputMaskSizeDivisor);
        myMask(coords(1),coords(2),coords(3)) = thisCurrent;
    end%for pointIter = 1:numPoints,
end%for strandIter = 1:numStrands,

mask3 = permute(myMask,[3,2,1]);

%----------------------
%----------------------
%----------------------
%----------------------

fileName = 'CurrentStopMaskRGBDiv3.tif';
currentFrame = zeros(size(mask1,1),size(mask1,2),3,'uint8');
currentFrame(:,:,1) = squeeze(mask1(:,:,1));
currentFrame(:,:,2) = squeeze(mask2(:,:,1));
currentFrame(:,:,3) = squeeze(mask3(:,:,1));
imwrite(uint8(currentFrame),fileName,'tiff','Compression','none');

for frameIter = 2:size(mask1,3);
    currentFrame(:,:,1) = squeeze(mask1(:,:,frameIter));
    currentFrame(:,:,2) = squeeze(mask2(:,:,frameIter));
    currentFrame(:,:,3) = squeeze(mask3(:,:,frameIter));
    imwrite(uint8(currentFrame),fileName,'tiff','WriteMode','append','Compression','none');
end

clear mask1 mask2 mask3 myMask
    

