function output_filename = maketiff8(varargin);
%this function writes a 3-D image stack as a multi-frame .tif file
%use : maketiff(myvariable, output_filename)
%   this returns the output_filename
%   if output_filname is excluded, a uiputfile gui opens to select a
%   filename
%
%Written by Philbert S. Tsai on 08/03/05
%Last Updated : 08/16/05


nin = nargin;
filename = ' ';
transpose_yn=0;
input_matrix = varargin{1};
if nin>1,
    qualifier1 = varargin{2};
    switch qualifier1,
        case 'transpose', transpose_yn = 1;
        case 'notranspose', transpose_yn = 0;
        otherwise filename = varargin{2};
    end
end

if filename == ' ';
    [filename,pathname,filterindex] = uiputfile('*.tif', 'Save as multiframe tif');
    filename = [pathname,filename];
end

if nin>2,
    qualifier1 = varargin{3};
    if qualifer1 == 'transpose', transpose_yn = 1; end
    if qualifer1 == 'notranspose', transpose_yn = 0; end
end


mysize = size(input_matrix);
x_size = mysize(1);
y_size = mysize(2);
temp = size(mysize);
if temp(2) > 2,
    z_size = mysize(3);
else
    z_size = 1;
end

current_frame = squeeze(input_matrix(:,:,1,:));
if transpose_yn == 1; current_frame = transpose(current_frame);end
imwrite(uint8(current_frame),filename,'tiff','Compression','none');

if z_size >1,
    wb = waitbar(0,'Writing multiframe tiff...');
    for k = 2:z_size,
        current_frame = squeeze(input_matrix(:,:,k,:));
        if transpose_yn == 1; current_frame = transpose(current_frame);end
        imwrite(uint8(current_frame),filename,'tiff','WriteMode','append','Compression','none');
        waitbar(k/z_size,wb)    
    end
    close(wb);
end

output_filename = filename;

return





