
logFlag = 0;
hematocrit = 0.45;
radiusPower = 4;

D = [0:0.5:15];
alpha = 4./(1+exp(-0.593*(D-6.74)));    
viscosity = 1 + ((exp(hematocrit*alpha)-1) .* (110*exp(-1.424*D) + 3 - 3.45*exp(-0.035*D)) ./ (exp(0.45*alpha)-1));
strandLength = 100;
q = D.^radiusPower ./ (viscosity.*strandLength);

if logFlag,
    alpha = log(alpha);
    viscosity = log(viscosity);
    q = log(q);
end%if logFlag

figure(1);plot(D,alpha,'r-');hold on;xlabel('Diameter');ylabel('alpha');
figure(2);plot(D,viscosity,'g-');hold on;xlabel('Diameter');ylabel('viscosity');
figure(3);semilogy(D,1./q,'b-');hold on;xlabel('Diameter');ylabel('resistance');





D = [0:0.5:15];
% Dprime = max(D+2,0.5);
Dprime = D;
hematocrit = 0.3

alpha = 4./(1+exp(-0.593*(Dprime-6.74)));    
viscosity = 1 + ((exp(hematocrit*alpha)-1) .* (110.0*exp(-1.424*Dprime) + 3 - 3.45*exp(-0.035*Dprime)) ./ (exp(0.45*alpha)-1));
strandLength = 100;
q = Dprime.^radiusPower ./ (viscosity.*strandLength);

if logFlag,
    alpha = log(alpha);
    viscosity = log(viscosity);
    q = log(q);
end%if logFlag


figure(1);plot(D,alpha,'r.');hold off
figure(2);plot(D,viscosity,'g.');hold off
figure(3);semilogy(D,1./q,'b.');hold off




