startFromScratchFlag = 0;

if startFromScratchFlag == 1,
    cd('F:\Phil\ForFromPeople\Joyce\CX06-Retest2')
    load('F:\Phil\ForFromPeople\Joyce\CX06-Retest2\SE2-2012_09_14-12_16_58-Mod-StrandEdit2-CX06_pbEH-LargestSubgraph-Flow.mat')
    load('F:\Phil\ForFromPeople\Joyce\CX06-Retest2\CX06_barrels.mat')
    oldBarrels = barrels;

    maskSize = globalDataStruct.maskSize;
    frameSize = maskSize(1:2);
    cpMatrix = globalDataStruct.cpMatrix;
    strands = globalDataStruct.strands;
    strandRadiusList = [strands(:).MedianRadius];
    strandIndices = globalDataStruct.strandIndices;

    userTraced = [];
    for barrelIter = 1:numel(oldBarrels)
        userTraced{barrelIter} = oldBarrels(barrelIter).userTraced;
    end


    numBarrels = numel(userTraced);
    for barrelIter = 1:numBarrels,
        barrelPoints = userTraced{barrelIter}.top;
        diffFlag = sum(abs(diff(barrelPoints)),2)>0;
        barrelPoints = barrelPoints(diffFlag,:);
        barrelPoints(end+1,:) = barrelPoints(1,:);
        barrelCoordList = [];
        for pointIter = 1:size(barrelPoints,1)-1;
            startCoord = barrelPoints(pointIter,:);
            stopCoord = barrelPoints(pointIter+1,:);
            coordDiff = stopCoord-startCoord;
            longestSep = max(abs(coordDiff));
            numInterpPoints = ceil(longestSep)+1;
            cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
            cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
            cc3 = linspace(startCoord(3),stopCoord(3),numInterpPoints);
            lineCoords = round([cc1',cc2',cc3']);
            barrelCoordList = [barrelCoordList;lineCoords];
        end%for pointIter...
        figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
    end%for barrelIter...

    %---

    myFrame = zeros(maskSize(1),maskSize(2));
    barrels = [];
    barrelZMin = inf;
    barrelZMax = 0;

    numBarrels = numel(userTraced);
    for barrelIter = 1:numBarrels,
        barrelPoints = userTraced{barrelIter}.top;
        diffFlag = sum(abs(diff(barrelPoints)),2)>0;
        barrelPoints = barrelPoints(diffFlag,:);
        barrelPoints(end+1,:) = barrelPoints(1,:);
        barrelCoordList = zeros(100000,3);
        barrelZ1 = round(min(barrelPoints(:,3)));
        barrelBottom = userTraced{barrelIter}.bottom;
        barrelZ2 = round(max(barrelBottom(:,3)));
        counter = 0;
        for pointIter = 1:size(barrelPoints,1)-1;
            startCoord = barrelPoints(pointIter,:);
            stopCoord = barrelPoints(pointIter+1,:);
            coordDiff = stopCoord-startCoord;
            longestSep = max(abs(coordDiff));
            numInterpPoints = ceil(longestSep)+1;
            cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
            cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
            numCC = numel(cc1);
            for zIter = barrelZ1:barrelZ2,
                cc3 = zeros(size(cc2))+zIter;
                lineCoords = round([cc1',cc2',cc3']);
                barrelCoordList(counter+1:counter+numCC,:) = lineCoords;
                counter = counter+numCC;
            end%for zIter... 
        end%for pointIter...
        barrelCoordList = barrelCoordList(1:counter,:);
        barrels{barrelIter} = barrelCoordList;
        barrelZMin = min(barrelZMin, min(barrelCoordList(:,3)));
        barrelZMax = max(barrelZMax, max(barrelCoordList(:,3)));
        figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
        pixelList = sub2ind([maskSize(1),maskSize(2)],barrelCoordList(:,1),barrelCoordList(:,2));
        myFrame(pixelList)=1;
    end%for barrelIter...
    hold off
    figure(2);imagesc(myFrame)
    fillFrame = imfill(myFrame,'holes');
    figure(3);imagesc(fillFrame)
    layer4FrameBarrel = myFrame;

    fillFrame = imfill(layer4FrameBarrel,'holes');
    openFrame = imopen(fillFrame,ones(3,3));
    barrelInteriorFrame = imerode(openFrame,ones(3,3));
    barrelEdgeFrame = openFrame-barrelInteriorFrame;


    %Make a mask to trim regions that are far away from any barrel boundary
    dilationSize = 11;
    numIter = 12;
    dilatedFrame = barrelInteriorFrame;
    for kk = 1:numIter,
        dilatedFrame = imdilate(dilatedFrame,circle2d(dilationSize));
    end
    dilatedFrame = imfill(dilatedFrame,'holes');
    figure(1);imagesc(barrelInteriorFrame);
    figure(2);imagesc(dilatedFrame);
    erodedFrame = dilatedFrame;
    erodedFrame(1,:) = 0;
    erodedFrame(end,:) = 0;
    erodedFrame(:,1) = 0;
    erodedFrame(:,end) = 0;

    numIter = 9;
    for kk = 1:numIter,
        erodedFrame = imerode(erodedFrame,circle2d(dilationSize));
    end
    figure(3);imagesc(erodedFrame);

    clear numIter dilationSize


end%if startFromScratchFlag == 1


%%
%Evaluate the plunging vessels
strandIndexList = strandIndices(:,1);
radiusList = globalDataStruct.allRadii;
for kk = 1:numel(strandIndexList),
    radiusList(kk) = strandRadiusList(strandIndexList(kk));
end

z1 = barrelZMin;
z2 = barrelZMax;

midZ = round((z1+z2)/2);

z1 = midZ-1;
z2 = midZ+1;



%%%%%%%
%%%%%%%

z1 = 200; z2 = 205;

%%%%%%%
%%%%%%%

saPoints = find(ismember(cpMatrix(:,7),[330:331,333:339]));
svPoints = find(ismember(cpMatrix(:,7),[340:341,343:349]));
paPoints = find(ismember(cpMatrix(:,7),[660:669,432]));
pvPoints = find(ismember(cpMatrix(:,7),[770:779,442]));

saCoords = [cpMatrix(saPoints,1:3),radiusList(saPoints)];
svCoords = [cpMatrix(svPoints,1:3),radiusList(svPoints)];
paCoords = [cpMatrix(paPoints,1:3),radiusList(paPoints)];
pvCoords = [cpMatrix(pvPoints,1:3),radiusList(pvPoints)];

layer4FrameArtery = zeros(frameSize);
layer4FrameVein = zeros(frameSize);

minRadius = 0;
layer4paCoords = paCoords(and(and(paCoords(:,3)>z1,paCoords(:,3)<z2),paCoords(:,4)>=minRadius),:);
layer4pvCoords = pvCoords(and(and(pvCoords(:,3)>z1,pvCoords(:,3)<z2),pvCoords(:,4)>=minRadius),:);

layer4FrameArtery(sub2ind(frameSize,layer4paCoords(:,1),layer4paCoords(:,2))) = 1;
layer4FrameVein(sub2ind(frameSize,layer4pvCoords(:,1),layer4pvCoords(:,2))) = 1;


    myFilter = double(circle2d(7));
    layer4FiltFrameBarrel = imfilter(layer4FrameBarrel,myFilter);
    layer4FiltFrameArtery = imfilter(layer4FrameArtery,myFilter);
    layer4FiltFrameVein = imfilter(layer4FrameVein,myFilter);


rFrame = ones(frameSize);
gFrame = ones(frameSize);
bFrame = ones(frameSize);
rFrame(layer4FiltFrameBarrel>0) = 0;
bFrame(layer4FiltFrameBarrel>0) = 0;
gFrame(layer4FiltFrameArtery>0) = 0;
bFrame(layer4FiltFrameArtery>0) = 0;
rFrame(layer4FiltFrameVein>0) = 0;
gFrame(layer4FiltFrameVein>0) = 0;

layer4RGB = zeros([frameSize,3]);
layer4RGB(:,:,1) = rFrame;
layer4RGB(:,:,2) = gFrame;
layer4RGB(:,:,3) = bFrame;

 figure(4);imagesc(layer4RGB)
%% 
%Pick a center point for each plunging vessel.
L = bwlabel(layer4FrameArtery>0);
centroidList = regionprops(L,'Centroid');
aCoordList = [];
for kk = 1:numel(centroidList)
    aCoordList(kk,:) = round(centroidList(kk).Centroid);
end

L = bwlabel(layer4FrameVein>0);
centroidList = regionprops(L,'Centroid');
vCoordList = [];
for kk = 1:numel(centroidList)
    vCoordList(kk,:) = round(centroidList(kk).Centroid);
end
    
%REMEMBER, regionprops Centroid list give XY not YX
arterioleFrame = zeros(frameSize);
for kk = 1:size(aCoordList,1);
    arterioleFrame(aCoordList(kk,2),aCoordList(kk,1)) = 1;
end
venuleFrame = zeros(frameSize);
for kk = 1:size(vCoordList,1);
    venuleFrame(vCoordList(kk,2),vCoordList(kk,1)) = 1;
end



%%
rFrame = ones(frameSize);
gFrame = ones(frameSize);
bFrame = ones(frameSize);
bf = imfilter(barrelEdgeFrame,double(circle2d(7)));
af = imfilter(arterioleFrame,double(circle2d(7)));
vf = imfilter(venuleFrame,double(circle2d(7)));


rFrame(bf>0) = 0;
bFrame(bf>0) = 0;
gFrame(af>0) = 0;
bFrame(af>0) = 0;
rFrame(vf>0) = 0;
gFrame(vf>0) = 0;

layer4RGB = zeros([frameSize,3]);
layer4RGB(:,:,1) = rFrame;
layer4RGB(:,:,2) = gFrame;
layer4RGB(:,:,3) = bFrame;

figure(4);imagesc(layer4RGB)


%%
%For each arteriole, calculate the distance distribution to all points,
%   to all venules and to all other arterioles

subAFrame = arterioleFrame.*dilatedFrame;
numA = numel(find(subAFrame>0))
[acc1,acc2] = ind2sub(frameSize,find(subAFrame>0));
subACoords = [acc1,acc2];
%---
subVFrame = venuleFrame.*dilatedFrame;
numV = numel(find(subVFrame>0))
[vcc1,vcc2] = ind2sub(frameSize,find(subVFrame>0));
subVCoords = [vcc1,vcc2];

%---
hStepSize = 10;
maxSep = 3000;
hx = [0:hStepSize:maxSep]';
hAllNormRunning = zeros(size(hx));
hAVNormRunning = zeros(size(hx));

for aIter = 1:numA;
    singleAFrame = zeros(frameSize);
    thisACoord = subACoords(aIter,:);
    singleAFrame(thisACoord(1),thisACoord(2)) = 1;
    bwFrame = (bwdist(singleAFrame).*dilatedFrame);
    avDistList = sqrt(sum((repmat(thisACoord,[numV,1]) - subVCoords).^2,2));
    
    
    hAV = histc(avDistList,hx);
    hAll = histc(bwFrame(dilatedFrame>0),hx);
    
    hAllNorm = hAll./sum(hAll);
    hAVNorm = hAV./sum(hAV);
    
    figure(1); plot(hx,hAllNorm,'k-');hold on
    figure(1); plot(hx,hAVNorm,'r-');hold off
    pause(0.1);
    
    hAllNormRunning = hAllNormRunning + hAllNorm;
    hAVNormRunning = hAVNormRunning + hAVNorm;
end%for aIter = 1:numA,

    
figure(2); plot(hx,hAllNormRunning,'k-');hold on
figure(2); plot(hx,hAVNormRunning,'g-');hold off

%---
hStepSize = 25;
maxSep = 3000;
hx = [0:hStepSize:maxSep]';
hAllNormRunning = zeros(size(hx));
hAANormRunning = zeros(size(hx));

for aIter = 1:numA;
    singleAFrame = zeros(frameSize);
    thisACoord = subACoords(aIter,:);
    singleAFrame(thisACoord(1),thisACoord(2)) = 1;
    bwFrame = (bwdist(singleAFrame).*dilatedFrame);
    aaDistList = sqrt(sum((repmat(thisACoord,[numA,1]) - subACoords).^2,2));
    aaDistList = aaDistList(aaDistList~=0);
    
    hAA = histc(aaDistList,hx);
    hAll = histc(bwFrame(dilatedFrame>0),hx);
    
    hAllNorm = hAll./sum(hAll);
    hAANorm = hAA./sum(hAA);
    
    figure(1); plot(hx,hAllNorm,'k-');hold on
    figure(1); plot(hx,hAANorm,'r-');hold off
    pause(0.1);
    
    hAllNormRunning = hAllNormRunning + hAllNorm;
    hAANormRunning = hAANormRunning + hAANorm;
end%for aIter = 1:numA,

    
figure(3); plot(hx,hAllNormRunning,'k-');hold on
figure(3); plot(hx,hAANormRunning,'r-');hold off

%----

%---
hStepSize = 25;
maxSep = 3000;
hx = [0:hStepSize:maxSep]';
hAllNormRunning = zeros(size(hx));
hVVNormRunning = zeros(size(hx));

for aIter = 1:numV;
    singleVFrame = zeros(frameSize);
    thisVCoord = subVCoords(aIter,:);
    singleVFrame(thisVCoord(1),thisVCoord(2)) = 1;
    bwFrame = (bwdist(singleVFrame).*dilatedFrame);
    vvDistList = sqrt(sum((repmat(thisVCoord,[numV,1]) - subVCoords).^2,2));
    vvDistList = vvDistList(vvDistList~=0);
    
    hVV = histc(vvDistList,hx);
    hAll = histc(bwFrame(dilatedFrame>0),hx);
    
    hAllNorm = hAll./sum(hAll);
    hVVNorm = hVV./sum(hVV);
    
    figure(1); plot(hx,hAllNorm,'k-');hold on
    figure(1); plot(hx,hVVNorm,'r-');hold off
    pause(0.1);
    
    hAllNormRunning = hAllNormRunning + hAllNorm;
    hVVNormRunning = hVVNormRunning + hVVNorm;
end%for aIter = 1:numA,

    
figure(4); plot(hx,hAllNormRunning,'k-');hold on
figure(4); plot(hx,hVVNormRunning,'b-');hold off







%%
% % croppedAFrame = arterioleFrame .* dilatedFrame;
% % croppedVFrame = venuleFrame .* dilatedFrame;
% % allValues = fullResultFrame(dilatedFrame>0);
% % aValues = fullResultFrame(croppedAFrame>0);
% % vValues = fullResultFrame(croppedVFrame>0);
% % 
% % stepSize = 0.1
% % hx = [-1:stepSize:1];
% % h1 = histc(allValues,hx);
% % h1 = h1./sum(h1);
% % figure(91);plot(hx,h1,'k-');hold on
% % 
% % hA = histc(aValues,hx);
% % hA = hA./sum(hA);
% % figure(91);plot(hx,hA,'r-');hold on
% % 
% % hV = histc(vValues,hx);
% % hV = hV./sum(hV);
% % figure(91);plot(hx,hV,'b-');hold on
% % 
% % 
% % hBoth = histc([aValues;vValues],hx);
% % hBoth = hBoth./sum(hBoth);
% % figure(91);plot(hx,hBoth,'g-');hold off
% % 
% % figure(101);plot(hx,hA./h1,'r--');hold on
% % figure(101);plot(hx,hV./h1,'b--');hold off
% % figure(102);plot(hx,hBoth./h1,'g--');
% % 
% % csBoth = cumsum(hBoth./h1);
% % figure(103);plot(hx,csBoth'./[1:numel(csBoth)],'m-');


