
% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject004.mat')



vectorProject = allProject.av;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;

%Set the plunging vessel diameters to <0.1 um
plungingStrandList = [vectorProject.vectorizedStructure.allPlungingArterioleList,vectorProject.vectorizedStructure.allPlungingVenuleList];
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
effectiveStrandRadiusList(plungingStrandList) = effectiveStrandRadiusList(plungingStrandList) ./100;
% effectiveStrandRadiusList(plungingStrandList) = 0;


perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = effectiveStrandRadiusList;
perturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);



fileName = [shortName,'MinusPlunging-VectorProject.mat'];
save(fileName,'perturbedProject');


clear L eigenValues eigenVectors
disp(['Starting Eigenvalue calculation: ',datestr(now)]);pause(0.1);
L = full(perturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

fileName2 = [shortName,'MinusPlungingEigen.mat'];
save(fileName2,'eigenVectors','eigenValues','-V7.3');
datestr(now)

clear L eigenValueMatrix
