
% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject003b.mat')



vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;


midMask = (maskSize/2);
y1 = midMask(1)-1100/2;
y2 = midMask(1)+1100/2;
x1 = midMask(2)-1100/2;
x2 = midMask(2)+1100/2;
z2 = 1500;

f1 = allVerts(:,1)<y1;
f2 = allVerts(:,1)>y2;
f3 = allVerts(:,2)<x1;
f4 = allVerts(:,2)>x2;
f5 = allVerts(:,3)>z2;
ff = find(or(or(or(or(f1,f2),f3),f4),f5));
si = strandIndices(ff,1);
usi = unique(si);
adjustedStrandRadiusList(usi) = adjustedStrandRadiusList(usi)./10000;


%Set the plunging vessel diameters to <0.1 um
plungingStrandList = [vectorProject.vectorizedStructure.allPlungingArterioleList,vectorProject.vectorizedStructure.allPlungingVenuleList];
adjustedStrandRadiusList = vectorizedStructure.adjustedStrandRadiusList;
adjustedStrandRadiusList(plungingStrandList) = adjustedStrandRadiusList(plungingStrandList) ./10000;
% adjustedStrandRadiusList(plungingStrandList) = 0;


perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = adjustedStrandRadiusList;
perturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);

%%

fileName = [shortName,'MinusPlunging-VectorProject.mat'];
save(fileName,'perturbedProject');



clear L eigenValues eigenVectors
disp(['Starting Eigenvalue calculation: ',datestr(now)]);pause(0.1);
L = full(perturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

fileName2 = [shortName,'AdjRadiiMinusPlungingEigenDiv10000CROPPED_DOWN.mat'];
save(fileName2,'eigenVectors','eigenValues','-V7.3');
datestr(now)

clear L eigenValueMatrix
