
% cd('F:\Phil\AOH_VectorProjects')
% load('F:\Phil\AOH_VectorProjects\allProject004.mat')
for setIter = 1:4
    
    switch setIter
        case 1
            vectorProject = allProject.au;
        case 2
            vectorProject = allProject.av;
        case 3
            vectorProject = allProject.co;
        case 4
            vectorProject = allProject.db;
    end%switch setIter
            

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;

%Set the surface vessel diameters to <0.1 um
strandLabelList = [strands(:).MedianLabel];
surfaceStrandList = find(ismember(strandLabelList,[300:399]));
adjustedStrandRadiusList = vectorizedStructure.adjustedStrandRadiusList;
adjustedStrandRadiusList(surfaceStrandList) = adjustedStrandRadiusList(surfaceStrandList) ./10000;


perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = adjustedStrandRadiusList;
perturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);



% % fileName = [shortName,'MinusSurface-VectorProject.mat'];
% % save(fileName,'perturbedProject');


clear L eigenValues eigenVectors
disp(['Starting Eigenvalue calculation: ',datestr(now)]);pause(0.1);
L = full(perturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

fileName2 = [shortName,'MinusSurfaceEigenAdjRadii.mat'];
save(fileName2,'eigenVectors','eigenValues','-V7.3');
datestr(now)


clear L eigenValueMatrix

end%for setIter...