
% cd('F:\Phil\AOH_VectorProjects')
% load('F:\Phil\AOH_VectorProjects\allProject004.mat')
for setIter = 4:-1:1,
    
    switch setIter
        case 1
            vectorProject = allProject.au;
        case 2
            vectorProject = allProject.av;
        case 3
            vectorProject = allProject.co;
        case 4
            vectorProject = allProject.db;
    end%switch setIter
            

% vectorProject = allProject.au;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;



%Set the surface vessel diameters to <0.1 um
strandLabelList = [strands(:).MedianLabel];
surfaceStrandList = find(ismember(strandLabelList,[300:399]));
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
effectiveStrandRadiusList(surfaceStrandList) = effectiveStrandRadiusList(surfaceStrandList) ./10000;
% effectiveStrandRadiusList(plungingStrandList) = 0;


perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = effectiveStrandRadiusList;
perturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);



% % fileName = [shortName,'MinusPlunging-VectorProject.mat'];
% % save(fileName,'perturbedProject');


lowConductanceThresh = 1;
bcm = perturbedProject.basicConductanceMatrix;
numRows = size(bcm,1);


%Set all conductance values = 1 (except for surface/)
for rowIter = 1:numRows,
    thisLine = bcm(rowIter,:);
    thisLine(rowIter) = 0;
    lowCondEntries = find(and(abs(thisLine)>0,abs(thisLine)<lowConductanceThresh));
%     disp([rowIter,numel(lowCondEntries)]);
    thisLine(thisLine~=0) = 1;%set all connections to resistance = 1
    thisLine(lowCondEntries) = 1e-9; %set plunging/surface connections to high resistance
    thisLine(rowIter) = -1*sum(thisLine);
%     figure(1);plot(thisLine);
    bcm(rowIter,:) = thisLine;
end

% for kk = 1:1000,figure(1);q = full(bcm(kk,:));q = q(q~=0);plot(q,'ro');pause;end


perturbedProject.basicConductanceMatrix = bcm;




clear L eigenValues eigenVectors
disp(['Starting Eigenvalue calculation: ',datestr(now)]);pause(0.1);
L = full(perturbedProject.basicConductanceMatrix);
clear perturbedProject;
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;


fileName2 = [shortName,'MinusSurfaceEqualResistanceEigen.mat'];
save(fileName2,'eigenVectors','eigenValues','-V7.3');
datestr(now)


clear L eigenValueMatrix

end%for setIter...

