% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);


vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;


cutName = shortName(3:end);
cutName = shortName;
eigenSetFileName = ['F:\Phil\AOH_VectorProjects\',lower(cutName),'AdjRadiiMinusPlungingEigen.mat']

if exist('eigenValues','var') && numel(eigenValues) == numel(floatingNodeIndexList),
    disp('EigenValues already loaded');
else
    disp('Loading EigenValues and EigenVectors');pause(0.1);
    load(eigenSetFileName);
end

numStrands = numel(strands);
numFloatingNodes = numel(floatingNodeIndexList);
maxResistance = 2e-7


normalizeStrandLengthFlag = 0;

%%

figure(1);hold off
figure(2);hold off
% % figure(7);hold off
% % figure(8);hold off

%Plot network resistance from a node as you track outward
midZ = 500;%400
plusMinusZ = 100;%5
skipVal = 1;%33

allSlope = [];
allUsedStrandList = [];
actualStrandList = [];
allPathDistList = [];
allXYDistList = [];
allResList = [];
% % for midZ = 105:10:1400; disp(midZ);

    
y1 = 450;y2 = maskSize(1)-y1;
x1 = 450;x2 = maskSize(2)-x1;

strandZList = vectorizedStructure.strandMidYXZList(:,3);
strandYList = vectorizedStructure.strandMidYXZList(:,1);
strandXList = vectorizedStructure.strandMidYXZList(:,2);

zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
yFlagList = and(strandYList>=y1,strandYList<=y2);
xFlagList = and(strandXList>=x1,strandXList<=x2);

thisZStrandList = find(and(and(zFlagList,yFlagList),xFlagList));

numStart = numel(thisZStrandList);


for startNum = 1:skipVal:numStart,

    startingStrand = thisZStrandList(startNum);
    attachedStrandList1 = [strands([vectorizedStructure.allPlungingArterioleList,vectorizedStructure.allPlungingVenuleList]).StartVertexNeighborStrands];
    attachedStrandList2 = [strands([vectorizedStructure.allPlungingArterioleList,vectorizedStructure.allPlungingVenuleList]).EndVertexNeighborStrands];
    usedStrandList = unique([attachedStrandList1,attachedStrandList2,startingStrand]);


    vertex1ID = strands(startingStrand).StartVertexIndex;
    vertex2ID = strands(startingStrand).EndVertexIndex;
    nextNeighborList = strands(startingStrand).EndVertexNeighborStrands;
    nextNeighborList = nextNeighborList(nextNeighborList~=startingStrand);
    nextNeighborID = nextNeighborList(1);
    sep = vertices.AllVerts(vertex1ID,:) - vertices.AllVerts(vertex2ID,:);
    sepDist = sqrt(sum(sep.^2));


    % for aIter = 1:1,
    % for aIter = 1:numArterioleTips,
    %     myColor = myColorMap(mod(aIter*7,64)+1,:);
    thisStrandID = startingStrand;  
    resList = [];
    xyDistList = [];
    pathDistList = 0;
        for vIter = 1:30,
            floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
            floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
            runSum = 0;
            mSize = size(eigenVectors,1);
            for iIter = 2:mSize;
                eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
                eVectorBeta = eigenVectors(floatingNode2ID,iIter);
                eVal = eigenValues(iIter);
                cutoff = -1;
                if eVal > cutoff,
                    runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
                end
            end%for iIter;
            effectiveResistance = runSum;
            if isempty(effectiveResistance),effectiveResistance = inf;end

%             effectiveResistance = min(effectiveResistance,4e-7);
            resList(vIter) = effectiveResistance;
            xyDistList(vIter) = sepDist;
            
            thisPathLength = vectorizedStructure.strandLengthList(thisStrandID);
            if normalizeStrandLengthFlag == 1,
                thisPathLength = 1;
            end%if normalizeStrandLengthFlag == 1,
            pathDistList(vIter) = pathDistList(end) + thisPathLength;

            %----
            %Find next node
            previousStrandID = thisStrandID;
            thisStrandID = nextNeighborID;
            usedStrandList = [usedStrandList,thisStrandID];
            if ismember(previousStrandID,strands(thisStrandID).EndVertexNeighborStrands),
                vertex2ID = strands(thisStrandID).StartVertexIndex;
                nextNeighborList = strands(thisStrandID).StartVertexNeighborStrands;
            else%if ismember(previousStrandID,
                vertex2ID = strands(thisStrandID).EndVertexIndex;
                nextNeighborList = strands(thisStrandID).EndVertexNeighborStrands;
            end%if ismember(previousStrandID,

            nextNeighborList = nextNeighborList(~ismember(nextNeighborList,usedStrandList));
            if isempty(nextNeighborList),break;end
            nextNeighborID = nextNeighborList(1);
            sep = vertices.AllVerts(vertex1ID,:) - vertices.AllVerts(vertex2ID,:);
            sepDist = sqrt(sum(sep.^2));

            actualStrandList = [actualStrandList,thisStrandID];
        end%for vIter...

    resList = min(resList,maxResistance);    
    
    figure(1);plot(xyDistList,(resList),'r.');hold on
    xlabel('radial distance [um]'),ylabel('network resistance');
    figure(2);plot(pathDistList,(resList),'g.');hold on
    xlabel('pathlength distance [um]'),ylabel('network resistance');
    if normalizeStrandLengthFlag == 1, xlabel('numStrands');end
    allUsedStrandList = unique([allUsedStrandList,usedStrandList]);
    allPathDistList = [allPathDistList,pathDistList];
    allXYDistList = [allXYDistList,xyDistList];
    allResList = [allResList,resList];
    
    
    
end%for startNum



%%


%Calc running median
sortData = sortrows([allPathDistList',allResList'],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medPathDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medPathDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(12);plot(allPathDistList,allResList,'g.');hold on
% figure(12);plot(medPathDistList,medResList,'k-');
% figure(12);plot([0,30],[modeStrandResistance, modeStrandResistance],'b-');hold off
xlabel('path distance along microvessel network');
if normalizeStrandLengthFlag == 1, xlabel('numStrands');end
ylabel('effective network resistance');
set(gca,'YLim',[0,2e-7],'XLim',[0,30]);
f1 = find(medPathDistList>=15);
m1 = median(medResList(f1));
figure(12);plot([0,30],[m1,m1],'b-');
myTitle = [shortName,' - blue line @ ',num2str(m1)];
title(myTitle)
for kk = 1:30,
    f1 = find(allPathDistList == kk);
    m2 = median(allResList(f1));
    figure(12);plot(kk,m2,'ko');
end%for kk
figure(12);hold off
%---
sortData = sortrows([allXYDistList',allResList'],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medXYDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medXYDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(11);plot(allXYDistList,allResList,'r.');hold on
figure(11);plot(medXYDistList,medResList,'k-');
set(gca,'YLim',[0,2e-7],'XLim',[0,700]);
xlabel('radial distance');
ylabel('effective network resistance');
f1 = find(allXYDistList>=350);
m3 = median(allResList(f1));
figure(11);plot([0,700],[m3,m3],'b-');
myTitle = [shortName,' - blue line @ ',num2str(m3)];
title(myTitle)
figure(11);hold off



saveFileName = [shortName,'-AdjRadiiPointToPointResultSource'];
save(saveFileName,'allPathDistList','allXYDistList','allResList','actualStrandList','skip*','x*','y*','*Z');


sss = [strands(actualStrandList).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'g-');hold on
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---
figure(998);plot(log10([m1,m1]),[0,max(h)./sum(h)],'b-');
%---
sss = [strands(:).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'r-');hold off
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---
