% % 
% % cd('F:\Phil\VectorProjects')
% % load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')


pause
pause
pause




%Convert the vectorizedStructure to a segments and nodes structure for the dijkstra algorithm
vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
firstDash = findstr(vectorProjectRootName,'-');
shortName = vectorProjectRootName(1:firstDash(1)-1);

strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allJP = vertices.JunctionPoints;
strandIndices = vertices.StrandIndices;
strandIndices = full(strandIndices);
strandLabelList = [strands(:).MedianLabel];

avDataStruct = [];
aaDataStruct = [];
vvDataStruct = [];

nodes = allVerts(allJP,:);
nodes = [(1:size(nodes,1))',nodes];
nodeList = find(allJP);

segments = [];
for nodeIter = 1:numel(nodeList)
    thisNodeID = nodeIter;
    thisNodeIndex = nodeList(nodeIter);
    attachedStrands = strandIndices(thisNodeIndex,:);
    attachedStrands = attachedStrands(attachedStrands~=0);
    startIndex = [strands(attachedStrands).StartVertexIndex];
    endIndex = [strands(attachedStrands).EndVertexIndex];
    bothIndex = [startIndex,endIndex];
    attachedNodeIndexList = bothIndex(bothIndex~=thisNodeIndex);
    attachedNodeIDList = find(ismember(nodeList,attachedNodeIndexList));
    newSegmentList = [repmat(thisNodeID,size(attachedNodeIDList)),attachedNodeIDList];
    orderFlag = newSegmentList(:,1)<newSegmentList(:,2);
    subSegmentList = newSegmentList(orderFlag,:);
    segments = [segments;subSegmentList];
end%for nodeIter

fullSegments = [(1:size(segments,1))',segments];

%%
%Remove the plunging strands and the surface strands from the segment list
removePlungingArteriolesFlag = 0;
removePlungingVenulesFlag = 1;
removeSurfaceVesselsFlag = 1;

allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;

s1 = fullSegments(:,2);
s2 = fullSegments(:,3);

removeList = [];
if removePlungingArteriolesFlag == 1,
    for aIter = 1:numel(allPlungingArterioleList),
        thisStrandID = allPlungingArterioleList(aIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for aIter
end%if removePlungingArterioleFlag == 1,
    
if removePlungingVenulesFlag == 1,
    for vIter = 1:numel(allPlungingVenuleList),
        thisStrandID = allPlungingVenuleList(vIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for vIter
end%if removePlungingVenulesFlag == 1,

if removeSurfaceVesselsFlag == 1,
    surfaceStrandList = find(ismember(strandLabelList,[300:399]));
    for sIter = 1:numel(surfaceStrandList);
        thisStrandID = surfaceStrandList(sIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for sIter
end%if removeSurfaceVesselsFlag == 1,


keepInd = ~ismember(fullSegments(:,1),removeList);        
segments = fullSegments(keepInd,2:3);
segments = [(1:size(segments,1))',segments];
    


%%

allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;

allArterioleStrandList = [allPlungingArteriolePathList{:}];
allVenuleStrandList = [allPlungingVenulePathList{:}];

allArterioleVertexList = unique([strands(allArterioleStrandList).StartVertexIndex,strands(allArterioleStrandList).EndVertexIndex]);
allArterioleNodeList = find(ismember(nodeList,allArterioleVertexList));
allVenuleVertexList = unique([strands(allVenuleStrandList).StartVertexIndex,strands(allVenuleStrandList).EndVertexIndex]);
allVenuleNodeList = find(ismember(nodeList,allVenuleVertexList));


numArterioles = numel(allPlungingArteriolePathList);
numVenules = numel(allPlungingVenulePathList);

numArterioleNodes = numel(allArterioleNodeList);
numVenuleNodes = numel(allVenuleNodeList);

%Generate a list of all nodes on each plunging venule
plungingVenuleNodeList = [];
for pvIter = 1:numVenules,
    thisVenuleStrandList = allPlungingVenulePathList{pvIter};
    thisVenuleVertexList = unique([strands(thisVenuleStrandList).StartVertexIndex,strands(thisVenuleStrandList).EndVertexIndex]);
    thisVenuleNodeList = find(ismember(nodeList,thisVenuleVertexList));
    plungingVenuleNodeList{pvIter} = thisVenuleNodeList;
end

%Generate a reverse lookup table of nodes to plunging venules
vNodeToPlungingLUT = [];
for vNodeIter = 1:numVenuleNodes,
    thisVNode = allVenuleNodeList(vNodeIter);
    for pvIter = 1:numVenules,
        thisPVList = plungingVenuleNodeList{pvIter};
        if ismember(thisVNode,thisPVList),
            vNodeToPlungingLUT(vNodeIter) = pvIter;
            break%break out of pvIter loop
        end%if ismember
    end%for pvIter
end%for vNodeIter


% % aterioleIter = 1;
% % venuleIter = 1;
% %     thisArterioleStrandList = allPlungingArteriolePathList{aterioleIter};
% %     thisArterioleVertexList = unique([strands(thisArterioleStrandList).StartVertexIndex,strands(thisArterioleStrandList).EndVertexIndex]);
% %     thisArterioleNodeList = find(ismember(nodeList,thisArterioleVertexList));
% %     otherArterioleStrandList = allArterioleStrandList(~ismember(allArterioleStrandList,thisArterioleStrandList));
% %     otherArterioleVertexList = unique([strands(otherArterioleStrandList).StartVertexIndex,strands(otherArterioleStrandList).EndVertexIndex]);
% %     otherArterioleNodeList = find(ismember(nodeList,otherArterioleVertexList));
% %    
% %     
% %     
% %     thisVenuleStrandList = allPlungingVenulePathList{venuleIter};
% %     thisVenuleVertexList = unique([strands(thisVenuleStrandList).StartVertexIndex,strands(thisVenuleStrandList).EndVertexIndex]);
% %     thisVenuleNodeList = find(ismember(nodeList,thisVenuleVertexList));
% %     otherVenuleStrandList = allVenuleStrandList(~ismember(allVenuleStrandList,thisVenuleStrandList));
% %     otherVenuleVertexList = unique([strands(otherVenuleStrandList).StartVertexIndex,strands(otherVenuleStrandList).EndVertexIndex]);
% %     otherVenuleNodeList = find(ismember(nodeList,otherVenuleVertexList));
% %    
% %     
    

%%

%find all shortest arteriole to venule paths
filePath = ['F:\Phil\VectorProjects\avShortestPath\',shortName];

alreadyRun = 0;
if isempty(avDataStruct),
    %load saved files if exist
    loadedCounter = 0;
    for aNodeIter = 1:numArterioleNodes,
        fileName = fullfile(filePath,['aNode',num2str(aNodeIter,'%04d'),'.mat']);
        if exist(fileName,'file'),
            loadedCounter = loadedCounter + 1;
            load(fileName,'thisANodeData');
            avDataStruct{aNodeIter} = thisANodeData;
        else%if exist(fileName)
            break%break out of for aNodeIter loop
        end%if exist(fileName)
        alreadyRun = loadedCounter;
    end%for aNodeIter
else%if ismepty(avDataStruct)
    alreadyRun = numel(avDataStruct);
end%if ismepty(avDataStruct)


maxSep = 200;

avShortestPathList = [];
for aNodeIter = alreadyRun+1 : numArterioleNodes,
    tic
    fileName = fullfile(filePath,['aNode',num2str(aNodeIter,'%04d'),'.mat']);
    thisANodeData = [];
    thisArterioleNode = allArterioleNodeList(aNodeIter)
    aNodeCoord = nodes(thisArterioleNode,2:4);
    shortestPathList = [];
    maxPath = 25;
    for vNodeIter = 1:numVenuleNodes,
        thisVenuleNode = allVenuleNodeList(vNodeIter);
        vNodeCoord = nodes(thisVenuleNode,2:4);
        sep = sqrt(sum(((aNodeCoord(1:2)-vNodeCoord(1:2)).^2),2));
        thisANodeData(vNodeIter).aNode = thisArterioleNode;
        thisANodeData(vNodeIter).aNodeCoord = aNodeCoord;
        thisANodeData(vNodeIter).vNode = thisVenuleNode;
        thisANodeData(vNodeIter).vNodeCoord = vNodeCoord;
        thisANodeData(vNodeIter).xySep = sep;
        thisANodeData(vNodeIter).shortestDist = [998];
        thisANodeData(vNodeIter).strandPath = [];
        if sep < maxSep,
%             [dist,shortestPath] = dijkstra(nodes,segments,thisArterioleNode,thisVenuleNode);
            [dist,shortestPath] = dijkstra_phil(nodes,segments,thisArterioleNode,thisVenuleNode,maxPath);
            if ~isinf(dist),
                shortestPathLength = numel(shortestPath);
                shortestPathList = [shortestPathList,shortestPathLength];
                maxPath = 3*min([shortestPathList,maxPath/3]);
                if dist<900,
                    numNodesInPath = numel(shortestPath);
                    strandPath = [];
                    for segmentIter = 1:numNodesInPath-1,
                        nodeA = shortestPath(segmentIter);
                        nodeB = shortestPath(segmentIter+1);
                        vertexA = nodeList(nodeA);
                        vertexB = nodeList(nodeB);
                        strandSetA = strandIndices(vertexA,:);
                        strandSetA = strandSetA(strandSetA~=0);
                        strandSetB = strandIndices(vertexB,:);
                        strandSetB = strandSetB(strandSetB~=0);
                        doubletFlag = ismember(strandSetA,strandSetB);
                        doubletStrand = strandSetA(doubletFlag);
                        thisPathStrand = doubletStrand(1);
                        strandPath(segmentIter) = thisPathStrand;
                    end%for segmentIter
                    %---
                    thisANodeData(vNodeIter).shortestDist = dist;
                    thisANodeData(vNodeIter).strandPath = strandPath;
                end%if dist<900
            end%if ~isinf(dist)
        end%if sep<maxSep
        
    end%for vNodeIter
    avShortestPathList = [avShortestPathList,min(shortestPathList)]
    avDataStruct{aNodeIter} = thisANodeData;
    save(fileName,'thisANodeData');
    toc
    pause(0.01);
end%for aNodeIter



%find all shortest venule to venule paths



filePath = ['F:\Phil\VectorProjects\vvShortestPath\',shortName];

alreadyRun = 0;
if isempty(vvDataStruct),
    %load saved files if exist
    loadedCounter = 0;
    for vNodeIter = 1:numVenuleNodes,
        fileName = fullfile(filePath,['vNode',num2str(vNodeIter,'%04d'),'.mat']);
        if exist(fileName,'file'),
            loadedCounter = loadedCounter + 1;
            load(fileName,'thisVNodeData');
            vvDataStruct{vNodeIter} = thisVNodeData;
        else%if exist(fileName)
%             break%break out of for aNodeIter loop
        end%if exist(fileName)
        alreadyRun = loadedCounter;
    end%for vNodeIter
else%if ismepty(vvDataStruct)
    alreadyRun = numel(vvDataStruct);
end%if ismepty(vvDataStruct)


maxSep = 200;
vvShortestPathList = [];
for svNodeIter = alreadyRun+1 : numVenuleNodes,
    tic
    fileName = fullfile(filePath,['vNode',num2str(svNodeIter,'%04d'),'.mat']);
    thisVNodeData = [];
    thisStartVenuleNode = allVenuleNodeList(svNodeIter)
    svNodeCoord = nodes(thisStartVenuleNode,2:4);
    shortestPathList = [];
    maxPath = 25;
if mod(svNodeIter,1) == 0,
    
    for evNodeIter = 1:numVenuleNodes,
        thisEndVenuleNode = allVenuleNodeList(evNodeIter);
        evNodeCoord = nodes(thisEndVenuleNode,2:4);
        sep = sqrt(sum(((svNodeCoord(1:2)-evNodeCoord(1:2)).^2),2));
        thisVNodeData(evNodeIter).svNode = thisStartVenuleNode;
        thisVNodeData(evNodeIter).svNodeCoord = svNodeCoord;
        thisVNodeData(evNodeIter).evNode = thisEndVenuleNode;
        thisVNodeData(evNodeIter).evNodeCoord = evNodeCoord;
        thisVNodeData(evNodeIter).xySep = sep;
        thisVNodeData(evNodeIter).shortestDist = [998];
        thisVNodeData(evNodeIter).strandPath = [];
        %ignore if on same plunging strand
        if vNodeToPlungingLUT(svNodeIter) == vNodeToPlungingLUT(evNodeIter),
            sep = 99999; %force skip
            thisVNodeData(evNodeIter).shortestDistance = [997];
        end%if vNodeToPlungingLUT(svNodeIter) == vNodeToPlungingLUT(evNodeIter),
        %---
        if sep < maxSep,
            [dist,shortestPath] = dijkstra_phil(nodes,segments,thisStartVenuleNode,thisEndVenuleNode,maxPath);
            if ~isinf(dist),
                shortestPathLength = numel(shortestPath);
                shortestPathList = [shortestPathList,shortestPathLength];
                maxPath = 3*min([shortestPathList,maxPath/3]);
                if dist<900,
                    numNodesInPath = numel(shortestPath);
                    strandPath = [];
                    for segmentIter = 1:numNodesInPath-1,
                        nodeA = shortestPath(segmentIter);
                        nodeB = shortestPath(segmentIter+1);
                        vertexA = nodeList(nodeA);
                        vertexB = nodeList(nodeB);
                        strandSetA = strandIndices(vertexA,:);
                        strandSetA = strandSetA(strandSetA~=0);
                        strandSetB = strandIndices(vertexB,:);
                        strandSetB = strandSetB(strandSetB~=0);
                        doubletFlag = ismember(strandSetA,strandSetB);
                        doubletStrand = strandSetA(doubletFlag);
                        thisPathStrand = doubletStrand(1);
                        strandPath(segmentIter) = thisPathStrand;
                    end%for segmentIter
                    %---
                    thisVNodeData(evNodeIter).shortestDist = dist;
                    thisVNodeData(evNodeIter).strandPath = strandPath;
                end%if dist<900
            end%if ~isinf(dist)
        end%if sep<maxSep
        
    end%for vNodeIter
    vvShortestPathList = [vvShortestPathList,min(shortestPathList)]
    vvDataStruct{svNodeIter} = thisVNodeData;
    save(fileName,'thisVNodeData');
    toc
    pause(0.01);


end% if mod(..)



end%for vNodeIter













        
%%

strandLengthList = vectorizedStructure.strandLengthList;
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
zList = [];
minRadiusList = [];
for aNodeIter = 1:numel(avDataStruct);
    subDataStruct = avDataStruct{aNodeIter};
    if ~isempty(subDataStruct),
        for vNodeIter = 1:numVenuleNodes,
            thisData = subDataStruct(vNodeIter);
            strandPath = thisData.strandPath;
            if ~isempty(strandPath),
                pathRadii = effectiveStrandRadiusList(strandPath);
                pathRadii = strandLengthList(strandPath);
                vz = thisData.vNodeCoord(3);

                minRadius = min(pathRadii);
                minRadius = numel(pathRadii);
                minRadius = sum(pathRadii);
                
                minRadiusList = [minRadiusList,minRadius];
                zList = [zList,vz];
            end%if ~isempty(strandPath)
        end%for vNodeIter
        median(minRadiusList)
    end%if ~isempty(subDataStruct);
end%for aNodeIter
    
figure(1);plot(zList,minRadiusList,'r.');

%%

effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;

zList = [];
minRadiusList = [];
for svNodeIter = 1:numel(vvDataStruct);
    subDataStruct = vvDataStruct{svNodeIter};
    if ~isempty(subDataStruct),
        for evNodeIter = 1:numVenuleNodes,
            thisData = subDataStruct(evNodeIter);
            strandPath = thisData.strandPath;
            if ~isempty(strandPath),
                pathRadii = effectiveStrandRadiusList(strandPath);
                pathRadii = strandLengthList(strandPath);
                svz = thisData.svNodeCoord(3);

                minRadius = min(pathRadii);
                minRadius = numel(pathRadii);
                minRadius = sum(pathRadii);
                
                minRadiusList = [minRadiusList,minRadius];
                zList = [zList,svz];
            end%if ~isempty(strandPath)
        end%for evNodeIter
%     median(minRadiusList)
    end%if ~isempty(subDataStruct)
end%for svNodeIter
    
    
figure(1);plot(zList,minRadiusList,'b.');


    