% % load('F:\Phil\VectorProjects\allProject03c_withVelocity.mat');


vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;

velocityListUMs = vectorizedStructure.velocityListMMs'*1000;



%%
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
flowProject.baseStrandIDList = vectorProject.vectorizedStructure.plungingArterioleTipList;
flowProject.maxBranchSearch = 6;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode

tic
flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
toc
disp('Downstream Calculation Completed');



%%
%Calculate the minimum time of flight from an plungingArterioleTip;
%velocity = strandCurrent(Flux) / meanStrandXSectionalArea
%timeOfFlight = strandLength / velocity 

numStrands = numel(flowProject.Strands);
meanYXZList = vectorizedStructure.strandMidYXZList;
timeMultiplier = 1;

tofList = zeros(numStrands,1)+inf;    
baseStrandIDList = flowProject.baseStrandIDList;
numBases = numel(baseStrandIDList);
for baseIter = 1:numBases,
    thisBaseStrandID = baseStrandIDList(baseIter);
    thisBaseStrand = flowProject.Strands(baseIter);
    dsbl = flowProject.downstreamBranchList(:,baseIter);
    thisPathList = flowProject.downstreamPathList{baseIter};
    numPaths = numel(thisPathList);
    for pathIter = 1:numPaths,
        thisPath = thisPathList{pathIter};
%         currentList = abs(velocityListMMs);
        lengthList = vectorProject.vectorizedStructure.strandLengthList(thisPath);
        radiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList(thisPath);
        velocityList = velocityListUMs(thisPath);
        timeList = timeMultiplier.*lengthList./velocityList;
        cumTimeList = cumsum(timeList);
        tempTOFList = tofList+inf;
        tempTOFList(thisPath) = cumTimeList;
        tofList = min(tofList,tempTOFList);
    end
    figure(1);plot(min(tofList,10),'r.');
    pause(0.1)
end%for baseIter = 1:numBases,
disp('Time of Flight Calculation Completed');

    
%%
%Calculate the minimum time of flight from an plungingArterioleTip;
%velocity = strandCurrent(Flux) / meanStrandXSectionalArea
%timeOfFlight = strandLength / velocity 

numStrands = numel(flowProject.Strands);
meanYXZList = vectorizedStructure.strandMidYXZList;
timeMultiplier = 1;
labelList = [vectorizedStructure.Strands.MedianLabel];
roundTripTimeList = zeros(numStrands,1)+inf;    
maxZReachedList = zeros(numStrands,1)+inf;   
minMaxYXReachedList = zeros(numStrands,4)+inf;

baseStrandIDList = flowProject.baseStrandIDList;
numBases = numel(baseStrandIDList);
pathCounter = 0;
for baseIter = 1:numBases,
    thisBaseStrandID = baseStrandIDList(baseIter);
    thisBaseStrand = flowProject.Strands(baseIter);
    dsbl = flowProject.downstreamBranchList(:,baseIter);
    thisPathList = flowProject.downstreamPathList{baseIter};
    numPaths = numel(thisPathList);
    for pathIter = 1:numPaths,
        thisPath = thisPathList{pathIter};
        pathLabelList  = labelList(thisPath);
        isSurfaceVeinFlag = ismember(pathLabelList,[340:349]);
        surfaceVeinIndex = find(isSurfaceVeinFlag);
        if isempty(surfaceVeinIndex),
            lastVesselToCount = numel(thisPath);
        else%if isempty(surfaceVeinIndex),
            lastVesselToCount = surfaceVeinIndex(1)-1;
        end%if isempty(surfaceVeinIndex),
        thisPath = thisPath(1:lastVesselToCount);
        zList = meanYXZList(thisPath,3);
        yList = meanYXZList(thisPath,1);
        xList = meanYXZList(thisPath,2);
        maxZ = max(zList);
        lengthList = vectorProject.vectorizedStructure.strandLengthList(thisPath);
        radiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList(thisPath);
        velocityList = velocityListUMs(thisPath);
        timeList = timeMultiplier.*lengthList./velocityList;
        cumTimeList = cumsum(timeList);
        roundTripTime = cumTimeList(end);
        pathCounter = pathCounter + 1;
        roundTripTimeList(pathCounter) = roundTripTime;
        maxZReachedList(pathCounter) = maxZ;
        minMaxYXReachedList(pathCounter,:) = [min(yList),max(yList),min(xList),max(xList)];
    end
    figure(1);plot(maxZReachedList(1:pathCounter),min(30,roundTripTimeList(1:pathCounter)),'r.');
    pause(0.1)
end%for baseIter = 1:numBases,
maxZReachedList = maxZReachedList(1:pathCounter);
roundTripTimeList = roundTripTimeList(1:pathCounter);
minMaxYXReachedList = minMaxYXReachedList(1:pathCounter,:);

disp('Time of Flight Calculation Completed');

%%    
bufferSize = 300;
yMin = bufferSize;
xMin = bufferSize;
maskSize = vectorProject.maskSize;
yMax = maskSize(1)-bufferSize;
xMax = maskSize(2)-bufferSize;
flag1 = and(minMaxYXReachedList(:,1)>yMin , minMaxYXReachedList(:,2)<yMax);
flag2 = and(minMaxYXReachedList(:,3)>xMin , minMaxYXReachedList(:,4)<xMax);
flag3 = and(flag1,flag2);
subMaxZReachedList = maxZReachedList(flag3);
subRoundTripTimeList = roundTripTimeList(flag3);
figure(11);plot(subMaxZReachedList,min(30,subRoundTripTimeList),'r.');



%%
f1 = figure(1);
set(f1,'DoubleBuffer','on');
clf
flightTimeStep = 0.01;

activeStrands = find(tofList<inf);
activeIndices = [flowProject.Strands(activeStrands).StartToEndIndices];
av = flowProject.Vertices.AllVerts;
activeCoords = [flowProject.Vertices.AllVerts(activeIndices,:)];
zRange = [0:10:1200];
finalHist = hist(activeCoords(:,3),zRange);


for flightTime = 0:flightTimeStep:10
    activeStrands = find(tofList<flightTime);
    activeIndices = [flowProject.Strands(activeStrands).StartToEndIndices];
    av = flowProject.Vertices.AllVerts;
    activeCoords = [flowProject.Vertices.AllVerts(activeIndices,:)];
    inactiveStrands = find(tofList>flightTime);
    inactiveIndices = [flowProject.Strands(inactiveStrands).StartToEndIndices];
    iav = flowProject.Vertices.AllVerts;
    iactiveCoords = [flowProject.Vertices.AllVerts(inactiveIndices,:)];
% %     figure(1);p1 = plot3(av(:,1),av(:,2),-1*av(:,3),'y.');hold on
% %     set(p1,'MarkerSize',1);
    figure(1);p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'r.');
    title(num2str(flightTime));
    set(p1,'MarkerSize',1);
    hold off

    figure(2);p2 = plot3(iactiveCoords(:,1),iactiveCoords(:,2),-1*iactiveCoords(:,3),'g.');
    title(num2str(flightTime));
    set(p2,'MarkerSize',1);
    hold off
    
    zHist = hist(activeCoords(:,3),zRange);
    figure(3);plot(zRange,zHist./finalHist,'r-');

    pause
end









