%%

dataSet = 'AU';

rerunFlags.meanBloodOx = 1;
rerunFlags.barrelBoundary = 0;
rerunFlags.barrelVersusBloodOx = 0;

disp(['Starting dataset ',dataSet,'...']);pause(0.1);

switch(dataSet),
    case{'AU','au'};
        vectorProjectFolder = 'F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder';
        vectorProjectFileName = 'pbAU-PutativesAdded-LargestSubgraph-Flow-WithAnalysis-VectorProject.mat';
        barrelOutlineFileName = 'barrelOutlines.mat';
        dataSetName = 'au';
    case{'AV','av'};
        vectorProjectFolder = 'F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder';
        vectorProjectFileName = 'pbAV-660sRemoved-LargestSubgraph-Flow-WithAnalysis-VectorProject.mat';
        barrelOutlineFileName = 'barrelOutlines.mat';
        dataSetName = 'av';
   case{'CO','co'};
        vectorProjectFolder = 'F:\Phil\AOH_VectorProjects\pbCO\VectorProjectFolder';
        vectorProjectFileName = 'pbCO-LargestSubgraph-Flow-WithAnalysis-VectorProject.mat';
        barrelOutlineFileName = 'barrelOutlines.mat';
        dataSetName = 'co';
   case{'DB','db'};
        vectorProjectFolder = 'F:\Phil\AOH_VectorProjects\pbDB\VectorProjectFolder';
        vectorProjectFileName = 'pbDB-LargestSubgraph-Flow-WithAnalysis-VectorProject.mat';
        barrelOutlineFileName = 'barrelOutlines.mat';
        dataSetName = 'db';
end%switch-case

cd(vectorProjectFolder);
if exist('allProject','var') && isfield(allProject,dataSetName),
    vectorProject = allProject.(dataSetName);
    barrels = vectorProject.barrelBoundaryParameters.barrels;
else%if exist('allProject'....
    try
        load(vectorProjectFileName,'vectorProject');
        disp(['Dataset ',dataSet,' -withAnalysis vectorProject loaded']);
    catch%try-
        charPos = findstr(vectorProjectFileName,'-WithAnalysis');
        baseFileName = [vectorProjectFileName(1:charPos-1),'-VectorProject.mat'];
        load(baseFileName,'vectorProject');    
        disp(['Dataset ',dataSet,' Flow-vectorProject (orig) loaded']);
    end%try-catch
    load(barrelOutlineFileName,'barrels');
end%if exist('allProject'....

%---
vectorizedStructure = vectorProject.vectorizedStructure;
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
if isempty(findstr(vectorProject.vectorProjectRootName,'-WithAnalysis')),
    vectorProject.vectorProjectRootName = [vectorProject.vectorProjectRootName,'-WithAnalysis'];
end%if isempty(findstr..
vectorProjectFileName = [vectorProject.vectorProjectRootName,'-VectorProject.mat'];


%%
%CalculateMeanBloodOx and normalized blood ox (between mean of plunging arteriole strands and mean of plunging venule strands)

vectorProject.bloodOxParameters.maxBranchSearch = 30;
vectorProject.bloodOxParameters.stopVoltage = 50.1;
vectorProject.bloodOxParameters.minimumFluxFraction = 1/300000;
vectorProject.bloodOxParameters.maxBranchSearch = 30;
vectorProject.bloodOxParameters.decayAlpha = 10;
if or(~isfield(vectorProject.bloodOxParameters,'lastRunDate'),rerunFlags.meanBloodOx == 1),
    disp('Calculating Mean Blood Ox...');
        vectorProject = CalculateMeanBloodOxForAllVesselsFunction(vectorProject);
    save(vectorProjectFileName,'vectorProject');
else
    disp('...MeanBloodOx previously calculated');
end%if or(~isfield..


%%
%Calculate a barrel value (inside/outside/edge) region mask from barrelOutlines.mat
vectorProject.barrelBoundaryParameters.barrels = barrels;
vectorProject.barrelBoundaryParameters.divRatio = 3;
vectorProject.barrelBoundaryParameters.closeCircleDiameter = 7;
vectorProject.barrelBoundaryParameters.erodeCircleDiameter = 50;
vectorProject.barrelBoundaryParameters.dilateCircleDiameter = 250;
vectorProject.barrelBoundaryParameters.extendBarrelZRange = 5;
vectorProject.barrelBoundaryParameters.extendBarrelZAcrossFullFieldFlag = 1;
if or(~isfield(vectorProject.barrelBoundaryParameters,'lastRunDate'),rerunFlags.barrelBoundary == 1),
    disp('Calculating Barrel Boundary Values');
        vectorProject = AssignBarrelBoundariesFunction(vectorProject);
    save(vectorProjectFileName,'vectorProject');  
else
    disp('...BarrelBoundaryValues previously calculated');
end%if or(~isfield ...

%%
%%
%Calculate distribution of normalizedVesselBloodOx versus barrel region
vectorProject.barrelVersusBloodOxParameters.bufferZone = 200;
vectorProject.barrelVersusBloodOxParameters.bloodOxCutoffList = [1:-0.05:0.0];
if or(~isfield(vectorProject.barrelVersusBloodOxParameters,'lastRunDate'),rerunFlags.barrelVersusBloodOx == 1),
    disp('Calculating BarrelVersusBloodOx Stats...');
        vectorProject = CalculateBarrelVersusBloodOxFunction(vectorProject);
        
%         vectorProject = CalculateBarrelVersusPathStats(vectorProject);

    save(vectorProjectFileName,'vectorProject');
else
    disp('...BarrelVersusBloodOx previously calculated');
end%if or(~isfield...




%%

switch(dataSet),
    case{'AU'};
        allProject.au = vectorProject;
    case{'AV'};
        allProject.av = vectorProject;
    case{'CO'};
        allProject.co = vectorProject;
   case{'DB'};
        allProject.db = vectorProject;
end%switch-case

%%
allProject = AllSetsPlotBarrelVersusBloodOxFunction(allProject);





