%Load an FV file

edgeBuffer = 200;
allNeurons = [];
area = [];
for setIter = 1:4,
    switch setIter
        case 1
            vectorProject = allProject.db;
            zOffset = 30;flipFlag = 1;
        case 2
            vectorProject = allProject.co;
            zOffset = 80;flipFlag = 0;
        case 3
            vectorProject = allProject.av;
            zOffset = 20;flipFlag = 0;
        case 4
            vectorProject = allProject.au;
            zOffset = 40;flipFlag = 0;
    end%switch setIter
    ccl = vectorProject.cellCentroidAndLabelList;
    maskSize = vectorProject.maskSize;
    neuronList = ccl(ccl(:,4)==1,1:3);
neuronList = ccl(:,1:3);    
    if flipFlag == 1,
        neuronList = fliplr(neuronList);
    end
    y1 = edgeBuffer;
    y2 = maskSize(1)-edgeBuffer;
    x1 = edgeBuffer;
    x2 = maskSize(2)-edgeBuffer;
    f1 = and(neuronList(:,1)>y1,neuronList(:,1)<y2);
    f2 = and(neuronList(:,2)>x1,neuronList(:,2)<x2);
    ff = and(f1,f2);
    neuronListSub = neuronList(ff,:);
    neuronListSub(:,3) = neuronListSub(:,3)-zOffset;
    allNeurons = [allNeurons;neuronListSub];
    area(setIter) = (maskSize(1)-edgeBuffer*2) * (maskSize(2)-edgeBuffer*2);
end

totalAreaSquareMicrons = sum(area);
zPlaneTotalVolumeCubicMicrons = totalAreaSquareMicrons * 1;
zPlaneTotalVolumeCubicMM = zPlaneTotalVolumeCubicMicrons/1e9;
allZ = allNeurons(:,3);

zStep = 10;
zRange = [0:zStep:2000];
h = hist(allZ,zRange);
volumeDivisor = zPlaneTotalVolumeCubicMM*zStep;
figure(1);plot(zRange,h./volumeDivisor);



   
    
