%%
%Histological data taken from 090529_002 at frames:
% 81, 161, 231, 313,394, 490
%Diameter measured at 33% of peak intensity value in ImageJ

cd('F:\Phil\ForFromPeople\2009 - AwakeStacksFromPat\052909')
load('F:\Phil\ForFromPeople\2009 - AwakeStacksFromPat\052909\awakeHist.mat')
z1Toz5 = [z1,z2,z3,z4,z5];
x = [0:0.5:15];
hAwake = hist(z1Toz5,x)./numel(z1Toz5);
figure(1);bar(x,hAwake);

currentSet = 'XX'

%%
dz = 400;
dx = 500;
dy = 500;
threshD = 7; %thresh Diameter for xcorr of histograms
threshD2 = 11; %thresh Diameter for median of D versus z-depth
zStep = 10; %step in z for median of D verus z-depth


%%
%Load dataset DB
if ~strcmp(currentSet,'DB'),
    load('F:\Phil\AOH_VectorProjects\pbDB\VectorProjectFolder\pbDB-LargestSubgraph-Flow-VectorProject.mat')
    currentSet = 'DB';
end
gds = vectorProject.vectorizedStructure;

allStrandRadii = gds.effectiveStrandRadiusList;
allStrandDiameter = allStrandRadii*2;
hAll = hist(allStrandDiameter,x)./numel(allStrandDiameter);
figure(2);bAwake = bar(x,hAwake);hold on
figure(2);bAll = bar(x,hAll);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bAll,'BarWidth',0.4);
title('All Vessels of set DB (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
z1 = min(gds.strandMidYXZList(:,3));
z2 = z1+dz;
midY = gds.maskSize(1)/2;
midX = gds.maskSize(2)/2;
y1 = round(midY - (dy/2));
y2 = round(midY + (dy/2));
x1 = round(midX - (dx/2));
x2 = round(midX + (dx/2));
fz = gds.strandMidYXZList(:,3)<z2;
fy = and(gds.strandMidYXZList(:,1)>y1 , gds.strandMidYXZList(:,1)<y2); 
fx = and(gds.strandMidYXZList(:,2)>x1 , gds.strandMidYXZList(:,2)<x2); 
ff = and(and(fz,fy),fx);
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter,x)./numel(subStrandDiameter);
figure(12);bAwake = bar(x,hAwake);hold on
figure(12);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title('Central & Upper Vessels of set DB (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);

%--
addDiameterList = [-1:0.1:2];
xCorrList = [];
for addIter = 1:numel(addDiameterList);
    addDiameter = addDiameterList(addIter);
    hTest = hist(subStrandDiameter+addDiameter,x)./numel(subStrandDiameter);
    figure(99);bAwake = bar(x,hAwake);hold on
    figure(99);bTest = bar(x,hTest);hold off
    set(bAwake,'FaceColor',[0.5,0.5,0.5]);
    set(bTest,'BarWidth',0.4);
    xCorrTemp = corrcoef(hTest(x<threshD),hAwake(x<threshD));
    xCorrList(addIter) = xCorrTemp(1,2);
end
[maxCorr,maxPos] = max(xCorrList);
bestAddDiameter = addDiameterList(maxPos(1));
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter+bestAddDiameter,x)./numel(subStrandDiameter);
figure(22);bAwake = bar(x,hAwake);hold on
figure(22);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title(['Central & Upper Vessels of set DB (black) versus awake (gray) : add Diameter = ',num2str(bestAddDiameter,'%0.1f')]);
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
%Calculate median diameter versus depth
zList = [0:zStep:1400]+z1;
medianDiameter = [];
medianLength = [];
numMicroStrands = [];
for zIter = 1:numel(zList)-1;
    zA = zList(zIter);
    zB = zList(zIter+1);
    fz = and(gds.strandMidYXZList(:,3)>zA , gds.strandMidYXZList(:,3)<=zB); 
    ff = and(and(fx,fy),fz);
    subStrandDiameter = allStrandDiameter(ff);
    subStrandLength = gds.strandLengthList(ff);
    medianDiameter(zIter) = median(subStrandDiameter(subStrandDiameter<threshD2));
    medianLength(zIter) = median(subStrandLength(subStrandDiameter<threshD2));
    numMicroStrands(zIter) = sum(subStrandDiameter<threshD2);
end
figure(33);plot(zList(1:end-1),medianDiameter,'r.');
title(['Central Vessels of set ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Diameter [micrometers]');




allData.DB.allStrandDiameter = allStrandDiameter;
allData.DB.subStrandDiameter = subStrandDiameter;
allData.DB.bestAddDiameter = bestAddDiameter;
allData.DB.medianDiameter = medianDiameter;
allData.DB.medianLength = medianLength;
allData.DB.numMicroStrands = numMicroStrands;




%%
%Load dataset AU
if ~strcmp(currentSet,'AU'),
    load('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\pbAU-PutativesAdded-LargestSubgraph-Flow-VectorProject.mat')
    currentSet = 'AU';
end
gds = vectorProject.vectorizedStructure;

allStrandRadii = gds.effectiveStrandRadiusList;
allStrandDiameter = allStrandRadii*2;
hAll = hist(allStrandDiameter,x)./numel(allStrandDiameter);
figure(3);bAwake = bar(x,hAwake);hold on
figure(3);bAll = bar(x,hAll);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bAll,'BarWidth',0.4);
title('All Vessels of set AU (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
z1 = min(gds.strandMidYXZList(:,3));
z2 = z1+dz;
midY = gds.maskSize(1)/2;
midX = gds.maskSize(2)/2;
y1 = round(midY - (dy/2));
y2 = round(midY + (dy/2));
x1 = round(midX - (dx/2));
x2 = round(midX + (dx/2));
fz = gds.strandMidYXZList(:,3)<z2;
fy = and(gds.strandMidYXZList(:,1)>y1 , gds.strandMidYXZList(:,1)<y2); 
fx = and(gds.strandMidYXZList(:,2)>x1 , gds.strandMidYXZList(:,2)<x2); 
ff = and(and(fz,fy),fx);
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter,x)./numel(subStrandDiameter);
figure(13);bAwake = bar(x,hAwake);hold on
figure(13);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title('Central & Upper Vessels of set AU (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%--
addDiameterList = [-1:0.1:2];
xCorrList = [];
for addIter = 1:numel(addDiameterList);
    addDiameter = addDiameterList(addIter);
    hTest = hist(subStrandDiameter+addDiameter,x)./numel(subStrandDiameter);
    figure(99);bAwake = bar(x,hAwake);hold on
    figure(99);bTest = bar(x,hTest);hold off
    set(bAwake,'FaceColor',[0.5,0.5,0.5]);
    set(bTest,'BarWidth',0.4);
    xCorrTemp = corrcoef(hTest(x<threshD),hAwake(x<threshD));
    xCorrList(addIter) = xCorrTemp(1,2);
end
[maxCorr,maxPos] = max(xCorrList);
bestAddDiameter = addDiameterList(maxPos(1));
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter+bestAddDiameter,x)./numel(subStrandDiameter);
figure(23);bAwake = bar(x,hAwake);hold on
figure(23);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title(['Central & Upper Vessels of set AU (black) versus awake (gray) : add Diameter = ',num2str(bestAddDiameter,'%0.1f')]);
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
%Calculate median diameter versus depth
zList = [0:zStep:1400]+z1;
medianDiameter = [];
medianLength = [];
numMicroStrands = [];
for zIter = 1:numel(zList)-1;
    zA = zList(zIter);
    zB = zList(zIter+1);
    fz = and(gds.strandMidYXZList(:,3)>zA , gds.strandMidYXZList(:,3)<=zB); 
    ff = and(and(fx,fy),fz);
    subStrandDiameter = allStrandDiameter(ff);
    subStrandLength = gds.strandLengthList(ff);
    medianDiameter(zIter) = median(subStrandDiameter(subStrandDiameter<threshD2));
    medianLength(zIter) = median(subStrandLength(subStrandDiameter<threshD2));
    numMicroStrands(zIter) = sum(subStrandDiameter<threshD2);
end
figure(33);plot(zList(1:end-1),medianDiameter,'r.');
title(['Central Vessels of set ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Diameter [micrometers]');

allData.AU.allStrandDiameter = allStrandDiameter;
allData.AU.subStrandDiameter = subStrandDiameter;
allData.AU.bestAddDiameter = bestAddDiameter;
allData.AU.medianDiameter = medianDiameter;
allData.AU.medianLength = medianLength;
allData.AU.numMicroStrands = numMicroStrands;


%%
%Load dataset CO
if ~strcmp(currentSet,'CO'),
    load('F:\Phil\AOH_VectorProjects\pbCO\VectorProjectFolder\pbCO-LargestSubgraph-Flow-VectorProject.mat')
    currentSet = 'CO';
end
gds = vectorProject.vectorizedStructure;

allStrandRadii = gds.effectiveStrandRadiusList;
allStrandDiameter = allStrandRadii*2;
hAll = hist(allStrandDiameter,x)./numel(allStrandDiameter);
figure(4);bAwake = bar(x,hAwake);hold on
figure(4);bAll = bar(x,hAll);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bAll,'BarWidth',0.4);
title('All Vessels of set CO (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
z1 = min(gds.strandMidYXZList(:,3));
z2 = z1+dz;
midY = gds.maskSize(1)/2;
midX = gds.maskSize(2)/2;
y1 = round(midY - (dy/2));
y2 = round(midY + (dy/2));
x1 = round(midX - (dx/2));
x2 = round(midX + (dx/2));
fz = gds.strandMidYXZList(:,3)<z2;
fy = and(gds.strandMidYXZList(:,1)>y1 , gds.strandMidYXZList(:,1)<y2); 
fx = and(gds.strandMidYXZList(:,2)>x1 , gds.strandMidYXZList(:,2)<x2); 
ff = and(and(fz,fy),fx);
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter,x)./numel(subStrandDiameter);
figure(14);bAwake = bar(x,hAwake);hold on
figure(14);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title('Central & Upper Vessels of set CO (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%--
addDiameterList = [-1:0.1:2];
xCorrList = [];
for addIter = 1:numel(addDiameterList);
    addDiameter = addDiameterList(addIter);
    hTest = hist(subStrandDiameter+addDiameter,x)./numel(subStrandDiameter);
    figure(99);bAwake = bar(x,hAwake);hold on
    figure(99);bTest = bar(x,hTest);hold off
    set(bAwake,'FaceColor',[0.5,0.5,0.5]);
    set(bTest,'BarWidth',0.4);
    xCorrTemp = corrcoef(hTest(x<threshD),hAwake(x<threshD));
    xCorrList(addIter) = xCorrTemp(1,2);
end
[maxCorr,maxPos] = max(xCorrList);
bestAddDiameter = addDiameterList(maxPos(1));
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter+bestAddDiameter,x)./numel(subStrandDiameter);
figure(24);bAwake = bar(x,hAwake);hold on
figure(24);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title(['Central & Upper Vessels of set CO (black) versus awake (gray) : add Diameter = ',num2str(bestAddDiameter)]);
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
%Calculate median diameter versus depth
zList = [0:zStep:1400]+z1;
medianDiameter = [];
medianLength = [];
numMicroStrands = [];
for zIter = 1:numel(zList)-1;
    zA = zList(zIter);
    zB = zList(zIter+1);
    fz = and(gds.strandMidYXZList(:,3)>zA , gds.strandMidYXZList(:,3)<=zB); 
    ff = and(and(fx,fy),fz);
    subStrandDiameter = allStrandDiameter(ff);
    subStrandLength = gds.strandLengthList(ff);
    medianDiameter(zIter) = median(subStrandDiameter(subStrandDiameter<threshD2));
    medianLength(zIter) = median(subStrandLength(subStrandDiameter<threshD2));
    numMicroStrands(zIter) = sum(subStrandDiameter<threshD2);
end
figure(33);plot(zList(1:end-1),medianDiameter,'r.');
title(['Central Vessels of set ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Diameter [micrometers]');


allData.CO.allStrandDiameter = allStrandDiameter;
allData.CO.subStrandDiameter = subStrandDiameter;
allData.CO.bestAddDiameter = bestAddDiameter;
allData.CO.medianDiameter = medianDiameter;
allData.CO.medianLength = medianLength;
allData.CO.numMicroStrands = numMicroStrands;
%%
%Load dataset AV
if ~strcmp(currentSet,'AV'),
    load('F:\Phil\AOH_VectorProjects\pbAV\VectorProjectFolder\pbAV-660sRemoved-LargestSubgraph-Flow-VectorProject.mat')
    currentSet = 'AV';
end
gds = vectorProject.vectorizedStructure;

allStrandRadii = gds.effectiveStrandRadiusList;
allStrandDiameter = allStrandRadii*2;
hAll = hist(allStrandDiameter,x)./numel(allStrandDiameter);
figure(5);bAwake = bar(x,hAwake);hold on
figure(5);bAll = bar(x,hAll);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bAll,'BarWidth',0.4);
title('All Vessels of set AV (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
z1 = min(gds.strandMidYXZList(:,3));
z2 = z1+dz;
midY = gds.maskSize(1)/2;
midX = gds.maskSize(2)/2;
y1 = round(midY - (dy/2));
y2 = round(midY + (dy/2));
x1 = round(midX - (dx/2));
x2 = round(midX + (dx/2));
fz = gds.strandMidYXZList(:,3)<z2;
fy = and(gds.strandMidYXZList(:,1)>y1 , gds.strandMidYXZList(:,1)<y2); 
fx = and(gds.strandMidYXZList(:,2)>x1 , gds.strandMidYXZList(:,2)<x2); 
ff = and(and(fz,fy),fx);
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter,x)./numel(subStrandDiameter);
figure(15);bAwake = bar(x,hAwake);hold on
figure(15);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title('Central & Upper Vessels of set AV (black) versus awake (gray)');
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%--
addDiameterList = [-1:0.1:2];
xCorrList = [];
for addIter = 1:numel(addDiameterList);
    addDiameter = addDiameterList(addIter);
    hTest = hist(subStrandDiameter+addDiameter,x)./numel(subStrandDiameter);
    figure(99);bAwake = bar(x,hAwake);hold on
    figure(99);bTest = bar(x,hTest);hold off
%     title(['Central & Upper Vessels of set AV (black) versus awake (gray) : add Diameter = ',num2str(addDiameter)]);
    set(bAwake,'FaceColor',[0.5,0.5,0.5]);
    set(bTest,'BarWidth',0.4);
    xCorrTemp = corrcoef(hTest(x<threshD),hAwake(x<threshD));
    xCorrList(addIter) = xCorrTemp(1,2);
end
[maxCorr,maxPos] = max(xCorrList);
bestAddDiameter = addDiameterList(maxPos(1));
subStrandDiameter = allStrandDiameter(ff);
hSub= hist(subStrandDiameter+bestAddDiameter,x)./numel(subStrandDiameter);
figure(25);bAwake = bar(x,hAwake);hold on
figure(25);bSub = bar(x,hSub);hold off
set(bAwake,'FaceColor',[0.5,0.5,0.5]);
set(bSub,'BarWidth',0.4);
title(['Central & Upper Vessels of set AV (black) versus awake (gray) : add Diameter = ',num2str(bestAddDiameter)]);
xlabel('Diameter : mean of 50-90% along strand');
ylabel('Probability');
set(gca,'XLim',[0,16]);
%---
%Calculate median diameter versus depth
zList = [0:zStep:1400]+z1;
medianDiameter = [];
medianLength = [];
numMicroStrands = [];
for zIter = 1:numel(zList)-1;
    zA = zList(zIter);
    zB = zList(zIter+1);
    fz = and(gds.strandMidYXZList(:,3)>zA , gds.strandMidYXZList(:,3)<=zB); 
    ff = and(and(fx,fy),fz);
    subStrandDiameter = allStrandDiameter(ff);
    subStrandLength = gds.strandLengthList(ff);
    medianDiameter(zIter) = median(subStrandDiameter(subStrandDiameter<threshD2));
    medianLength(zIter) = median(subStrandLength(subStrandDiameter<threshD2));
    numMicroStrands(zIter) = sum(subStrandDiameter<threshD2);
end
figure(33);plot(zList(1:end-1),medianDiameter,'r.');
title(['Central Vessels of set ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Diameter [micrometers]');



allData.AV.allStrandDiameter = allStrandDiameter;
allData.AV.subStrandDiameter = subStrandDiameter;
allData.AV.bestAddDiameter = bestAddDiameter;
allData.AV.medianDiameter = medianDiameter;
allData.AV.medianLength = medianLength;
allData.AV.numMicroStrands = numMicroStrands;



%%


figure(101);
plot(zList(1:end-1),allData.DB.medianLength,'r-');hold on
plot(zList(1:end-1),allData.AU.medianLength,'g-');hold on
plot(zList(1:end-1),allData.CO.medianLength,'b-');hold on
plot(zList(1:end-1),allData.AV.medianLength,'c-');hold off
title(['RGBC = DB,AU,CO,AV ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Strand Length [micrometers]');


figure(102);
plot(zList(1:end-1),allData.DB.medianDiameter,'r-');hold on
plot(zList(1:end-1),allData.AU.medianDiameter,'g-');hold on
plot(zList(1:end-1),allData.CO.medianDiameter,'b-');hold on
plot(zList(1:end-1),allData.AV.medianDiameter,'c-');hold off
title(['RGBC = DB,AU,CO,AV ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Median Strand Diameter [micrometers]');
    

figure(103);
plot(zList(1:end-1),allData.DB.numMicroStrands,'r-');hold on
plot(zList(1:end-1),allData.AU.numMicroStrands,'g-');hold on
plot(zList(1:end-1),allData.CO.numMicroStrands,'b-');hold on
plot(zList(1:end-1),allData.AV.numMicroStrands,'c-');hold off
title(['RGBC = DB,AU,CO,AV ',currentSet]);
xlabel('Z-Depth [micrometers]');
ylabel('Number of microstrands');
    

allML = (allData.DB.medianLength + ...
        allData.AU.medianLength + ...
        allData.CO.medianLength + ...
        allData.AV.medianLength) ./4;
figure(111);plot(zList(1:end-1),allML,'g.');
title(['4 Datasets']);
xlabel('Z-Depth [micrometers]');
ylabel('Median Strand Length [micrometers]');



allMD = (allData.DB.medianDiameter + ...
        allData.AU.medianDiameter + ...
        allData.CO.medianDiameter + ...
        allData.AV.medianDiameter) ./4;
figure(112);plot(zList(1:end-1),allMD,'g.');
title(['4 Datasets']);
xlabel('Z-Depth [micrometers]');
ylabel('Median Strand Diameter [micrometers]');



allNM = (allData.DB.numMicroStrands + ...
        allData.AU.numMicroStrands + ...
        allData.CO.numMicroStrands + ...
        allData.AV.numMicroStrands) ./4;
figure(113);plot(zList(1:end-1),allNM,'g.');
title(['4 Datasets']);
xlabel('Z-Depth [micrometers]');
ylabel('Number of microstrands');

allVV = allNM .* allMD .* allMD;
figure(99);plot(zList(1:end-1),allVV,'c.');

