%load a vectorProject

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;

vertices.AllVerts = double(vertices.AllVerts);
vertices.AllRadii = double(vertices.AllRadii);
vertices.AllLabels = double(vertices.AllLabels);
vertices.AllConfidences = double(vertices.AllConfidences);




allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
plungingVenuleTipList = vectorizedStructure.plungingVenuleTipList;

for kk = 1:numel(allPlungingArterioleList);
    thisLabel = 432;
    thisStrandID = allPlungingArterioleList(kk);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    thisStrand.MedianLabel = thisLabel;
    vertices.AllLabels(stei) = thisLabel;
end

for kk = 1:numel(allPlungingVenuleList);
    thisLabel = 442;
    thisStrandID = allPlungingVenuleList(kk);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    thisStrand.MedianLabel = thisLabel;
    vertices.AllLabels(stei) = thisLabel;
end

for kk = 1:numel(plungingArterioleTipList);
    thisLabel = 431;
    thisStrandID = plungingArterioleTipList(kk);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    thisStrand.MedianLabel = thisLabel;
    vertices.AllLabels(stei) = thisLabel;
end

for kk = 1:numel(plungingVenuleTipList);
    thisLabel = 441;
    thisStrandID = plungingVenuleTipList(kk);
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    thisStrand.MedianLabel = thisLabel;
    vertices.AllLabels(stei) = thisLabel;
end

vectorizedStructure.Vertices = vertices;
vectorizedStructure.Strands = strands;
vectorProject.vectorizedStructure = vectorizedStructure;



