function allProject = AllSetsPlotBarrelVersusBloodOxFunction(allProject)
%%
numProjects = 0;
%---
if isfield(allProject,'au')
    numProjects = numProjects + 1;
    projectList{numProjects}='au';
end
%---
if isfield(allProject,'av')
    numProjects = numProjects + 1;
    projectList{numProjects}='av';
end
%---
if isfield(allProject,'co')
    numProjects = numProjects + 1;
    projectList{numProjects}='co';
end
%---
if isfield(allProject,'db')
    numProjects = numProjects + 1;
    projectList{numProjects}='db';
end

edgeMatrix = [];
outMatrix = [];
inMatrix = [];
allMatrix = [];
inNumMatrix = [];
edgeNumMatrix = [];
outNumMatrix = [];
allNumMatrix = [];


for projIter = 1:numProjects,
    thisProjectTag = projectList{projIter};
    thisProject = allProject.(thisProjectTag);
    %---
    bvb = thisProject.barrelVersusBloodOxStruct;
    xRange = bvb.xRange;
    inMatrix(projIter,:) = bvb.selectedInsideDensity;%vertices inside / subvolume inside
    edgeMatrix(projIter,:) = bvb.selectedEdgeDensity;%vertices in edge region / subvolume in edge region.
    outMatrix(projIter,:) = bvb.selectedOutsideDensity;%vertices outside / subvolume outside
    allMatrix(projIter,:) = bvb.selectedAllDensity;%sum of in+edge+out densities
    
    inNumMatrix(projIter,:) = bvb.numVertsInside;%
    edgeNumMatrix(projIter,:) = bvb.numVertsEdge;%
    outNumMatrix(projIter,:) = bvb.numVertsOutside;%
    allNumMatrix(projIter,:) = bvb.numVertsInside+bvb.numVertsEdge+bvb.numVertsOutside;%sum of in+edge+out number
end

insideMean = mean(inMatrix,1);
edgeMean = mean(edgeMatrix,1);
outsideMean = mean(outMatrix,1);
allMean = mean(allMatrix,1);

% % insideMean = mean(inMatrix.*inNumMatrix,1)./sum(inNumMatrix,1);
% % edgeMean = mean(edgeMatrix.*edgeNumMatrix,1)./sum(edgeNumMatrix,1);
% % outsideMean = mean(outMatrix.*outNumMatrix,1)./sum(outNumMatrix,1);
% % allMean = insideMean+edgeMean+outsideMean;
% % 


filtSize = 1% 1= no filtering
insideMean = imfilter(insideMean,ones(1,filtSize));
edgeMean = imfilter(edgeMean,ones(1,filtSize));
outsideMean = imfilter(outsideMean,ones(1,filtSize));
allMean = imfilter(allMean,ones(1,filtSize));


figure(1004);plot(xRange,insideMean./allMean,'m-');hold on
figure(1004);plot(xRange,edgeMean./allMean,'y-');hold on
figure(1004);plot(xRange,outsideMean./allMean,'c-');hold on
figure(1004);plot(xRange,insideMean./outsideMean,'k-');hold off
xlabel('NormalizedBloodOx [1(0)= mean of plunging arteries(veins)');
ylabel('Fraction of vessel in each region');
title(['Average all sets  - pink/yellow/cyan = inside/edge/outside']);






