%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%
cd('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\FlowProject000001_Files')
load('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\BarrelMaskDiv3.mat','myMask')
load('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\FlowProject000001_Files\FVFile_2011_06_13-134115.mat')



%%
%Generate a 3D barrel mask and barrel outline mask from the barrelOutlines file
% over the spanning Z
maskSize = gds.maskSize;
thirdMask = myMask;
thirdZ = size(thirdMask,3);
minZ = 9999; maxZ = -9999;
for thirdZIter = 1:thirdZ,
    thisFrame = thirdMask(:,:,thirdZIter);
    if sum(thisFrame(:))>0,
        minZ = min(minZ,thirdZIter*3);
        maxZ = max(maxZ,thirdZIter*3);
    end%if sum(thisFrame(:))>0, 
end

subBlock = zeros(maskSize(1),maskSize(2),maxZ-minZ+1,'uint8');
for zIter = 1:size(subBlock,3);
    thirdFrame = thirdMask(:,:,round((minZ+zIter)/3));
    thisFrame = imresize(thirdFrame,[maskSize(1),maskSize(2)]);
    subBlock(:,:,zIter) = thisFrame;
end


z1 = 1;
z2 = z1 - minZ + maxZ;


barrelEdgeMask = subBlock.*0;
barrelInteriorMask = subBlock.*0;

for zIter = z1:3:z2-3,
    thisFrame = subBlock(:,:,zIter);
    dilatedFrame = imdilate(thisFrame>0,ones(3,3));
%     filledFrame = imfill(dilatedFrame,'holes');
    edgeFrame = (dilatedFrame>0) - (thisFrame>0);
    
    barrelEdgeMask(:,:,zIter) = edgeFrame;
    barrelEdgeMask(:,:,zIter+1) = edgeFrame;
    barrelEdgeMask(:,:,zIter+2) = edgeFrame;   
    barrelInteriorMask(:,:,zIter) = dilatedFrame;
    barrelInteriorMask(:,:,zIter+1) = dilatedFrame;
    barrelInteriorMask(:,:,zIter+2) = dilatedFrame;   
end



%%
%Make a 3D mask of the arterioles over the spanning Z

minRadius = 1.5
arterioleMask = barrelEdgeMask.*0;
allPlungingArterioleList = gds.allPlungingArterioleList;
numArterioles = numel(allPlungingArterioleList);
aRadiusList = [];
for aIter = 1:numArterioles,
    thisStrandID = allPlungingArterioleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    aRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if aRadiusList(aIter) > minRadius,
        arterioleMask(thisInd) = 1;
    end%if aRadiusList(aIter) > minRadius,
end


%%
%Make a 3D mask of the venules over the spanning Z
venuleMask = barrelEdgeMask.*0;
allPlungingVenuleList = gds.allPlungingVenuleList;
numVenules = numel(allPlungingVenuleList);
vRadiusList = [];
for aIter = 1:numVenules,
    thisStrandID = allPlungingVenuleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    vRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if vRadiusList(aIter) > minRadius,
        venuleMask(thisInd) = 1;
    end%if vRadiusList(aIter) > minRadius,
end




%%
barrelInteriorFrame = max(barrelInteriorMask,[],3)>0;
barrelEdgeFrame = max(barrelEdgeMask,[],3);
arterioleFrame = max(arterioleMask,[],3);
venuleFrame = max(venuleMask,[],3);


%%
figure(1);imagesc(barrelEdgeFrame);
figure(2);imagesc(arterioleFrame);
figure(3);imagesc(venuleFrame);
RGB = zeros([size(barrelEdgeFrame),3]);
RGB(:,:,1) = arterioleFrame;
RGB(:,:,2) = barrelEdgeFrame;
RGB(:,:,3) = venuleFrame;
figure(4); imagesc(RGB);

%%
barrelInteriorFrame;

dilationSize = 11;
numIter = 12;
dilatedFrame = barrelInteriorFrame;
for kk = 1:numIter,
    dilatedFrame = imdilate(dilatedFrame,circle2d(dilationSize));
end
dilatedFrame = imfill(dilatedFrame,'holes');
figure(1);imagesc(barrelInteriorFrame);
figure(2);imagesc(dilatedFrame);
erodedFrame = dilatedFrame;
erodedFrame(1,:) = 0;
erodedFrame(end,:) = 0;
erodedFrame(:,1) = 0;
erodedFrame(:,end) = 0;

numIter = 9
for kk = 1:numIter,
    erodedFrame = imerode(erodedFrame,circle2d(dilationSize));
end
figure(3);imagesc(erodedFrame);

%%
%Calculate a normalized distance map inside and outside of the barrels


testFrame = barrelInteriorFrame;



figure(11);imagesc(testFrame);
fullResultFrame = ones(size(testFrame));
bwFrame = bwdist(testFrame);
figure(22);imagesc(bwFrame);
L = watershed(bwFrame);
L(1:end,1) = 0;
L(1:end,end) = 0;
L(1,1:end) = 0;
L(end,1:end) = 0;

figure(13);imagesc(L);
figure(14);imagesc(L==0);
bwl = bwlabel(testFrame);

numObjects = max(bwl(:));
for objIter = 1:numObjects,
    thisObject = bwl==objIter;
    figure(2);imagesc(thisObject);
    thisEdge = thisObject - imerode(thisObject,ones(3,3));
    figure(3);imagesc(thisEdge);
    props = regionprops(bwl,'Centroid','PixelList');
    yc = round(props(objIter).Centroid(2));
    xc = round(props(objIter).Centroid(1));
    allPixelList = props(objIter).PixelList;
    allX = allPixelList(:,1);
    allY = allPixelList(:,2);
    [fullX,fullY] = meshgrid(1-xc:size(thisObject,2)-xc,1-yc:size(thisObject,1)-yc);
    fullR = sqrt(fullX.^2 + fullY.^2);
    allR = fullR(sub2ind(size(thisObject),allY,allX));
    figure(4);imagesc(fullR);
    bwle = bwlabel(thisEdge);
    propsE = regionprops(bwle,'PixelList','PixelIdxList');
    edgePixelList = propsE(1).PixelList;
    edgePixelIDList = propsE(1).PixelIdxList;
    edgeXList = edgePixelList(:,1);
    edgeYList = edgePixelList(:,2);
    dx = edgeXList-xc;
    dy = edgeYList-yc;
    edgeRList = sqrt(dx.^2+dy.^2);
    numPixels = numel(allX);
    numEdge = numel(edgeXList);
    sortedEdgePixelList = flipud(sortrows([edgeYList,edgeXList,edgeRList],3));

    tic
    q = zeros(kk,1);
    maxEdgeFrame = zeros(size(thisObject));
    maxEdgeFrame(sub2ind(size(thisObject),edgeYList,edgeXList)) = edgeRList;
    for kk = 1:numEdge,
        ey = round(sortedEdgePixelList(kk,1));
        ex = round(sortedEdgePixelList(kk,2));
        er = sortedEdgePixelList(kk,3);
        dy = ey -yc;
        dx = ex -xc;
        if abs(dy)>abs(dx),
            pyList = [yc:sign(dy):ey];
            pxList = round(linspace(xc,ex,numel(pyList)));
        else
            pxList = [xc:sign(dx):ex]; 
            pyList = round(linspace(yc,ey,numel(pxList)));
        end
        maxEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = er;
    end%for kk = 1:numPixels
    figure(5);imagesc(maxEdgeFrame);
    toc

    effRadius = fullR.*thisObject./maxEdgeFrame;
    figure(6);imagesc(effRadius);
    numErrors = numel(find(maxEdgeFrame(thisObject)==0))



    wsVal = unique(L(thisObject));
    thisWS = L==wsVal;

thisWS = thisWS .* dilatedFrame;

    thisWSEdge = thisWS - imerode(thisWS,ones(3,3));

    figure(3);imagesc(thisWSEdge);

    bwWSe = bwlabel(thisWSEdge);
    propsWSE = regionprops(bwWSe,'PixelList','PixelIdxList');
    wsEdgePixelList = propsWSE(1).PixelList;
    wsEdgePixelIDList = propsWSE(1).PixelIdxList;
    wsEdgeXList = wsEdgePixelList(:,1);
    wsEdgeYList = wsEdgePixelList(:,2);
    dx = wsEdgeXList-xc;
    dy = wsEdgeYList-yc;
    wsEdgeRList = sqrt(dx.^2+dy.^2);
    numWSEdge = numel(wsEdgeXList);
    sortedWSEdgePixelList = flipud(sortrows([wsEdgeYList,wsEdgeXList,wsEdgeRList],3));

    tic
    q = zeros(kk,1);
    maxWSEdgeFrame = zeros(size(thisObject));
    maxWSEdgeFrame(sub2ind(size(thisObject),wsEdgeYList,wsEdgeXList)) = wsEdgeRList;
    for kk = 1:numWSEdge,
        ey = round(sortedWSEdgePixelList(kk,1));
        ex = round(sortedWSEdgePixelList(kk,2));
        er = sortedWSEdgePixelList(kk,3);
        dy = ey -yc;
        dx = ex -xc;
        if abs(dy)>abs(dx),
            pyList = [yc:sign(dy):ey];
            pxList = round(linspace(xc,ex,numel(pyList)));
        else
            pxList = [xc:sign(dx):ex]; 
            pyList = round(linspace(yc,ey,numel(pxList)));
        end
        %Now, find the point where this vector crosses the barrelEdge
        idList = sub2ind(size(thisObject),pyList,pxList);
        crossFlagList = ismember(idList,edgePixelIDList);
        if sum(crossFlagList)>0,
            crossPoint = find(crossFlagList);
            pyList = pyList(crossPoint(1):end);
            pxList = pxList(crossPoint(1):end);
            normRList = linspace(0,1,numel(pyList));
            maxWSEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = normRList;
        else
            disp('No Cross');
            keyboard
        end

    end%for kk = 1:numPixels
    figure(5);imagesc(maxWSEdgeFrame);
    fullResultFrame(thisWS>0) = maxWSEdgeFrame(thisWS>0);
    fullResultFrame(thisObject) = effRadius(thisObject)-1;
    figure(9);imagesc(fullResultFrame);
end%for objIter...
toc




%%
%Consider the closest barrel to each vessel point.
%only evaluate if that barrel exists within that plane

testFrame = barrelInteriorFrame;
bwl = bwlabeln(testFrame);
bwFrame = bwdist(testFrame);
L = watershed(bwFrame);
L(1:end,1) = 0;
L(1:end,end) = 0;
L(1,1:end) = 0;
L(end,1:end) = 0;



numBarrels = max(L(:));
fullBWL = uint8(bwlabeln(barrelInteriorMask));
LvalList = [];
top = [];
bot = [];
for barrelIter = 1:numBarrels,
    allBarrelIdx = find(fullBWL == barrelIter);
    [yList,xList,zList] = ind2sub(size(fullBWL),allBarrelIdx);
    frameIdx = sub2ind(size(L),yList,xList);
    Lval = mode(L(frameIdx));
    LvalList(barrelIter) = Lval;
    top(Lval) = min(zList)+minZ;
    bot(Lval) = max(zList)+minZ;
end






arterioleMask2 = arterioleMask;
venuleMask2 = venuleMask;
erodedFrame2 = uint8(erodedFrame);
for kk = 1:size(arterioleMask,3),
    arterioleMask2(:,:,kk) = arterioleMask(:,:,kk) .* erodedFrame2;
    venuleMask2(:,:,kk) = venuleMask(:,:,kk) .* erodedFrame2;
end%for kk


bwA = [];bwV = [];
angleAList = [];
angleVList = [];
aBarrelList = [];
vBarrelList = [];

for barrelIter = 1:numBarrels,
    thisLval = LvalList(barrelIter);
    thisTop = top(thisLval);
    thisBot = bot(thisLval);
    thisMask = uint8(L==thisLval);
    thisBarrel = uint8(testFrame).*thisMask;
    thisProp = regionprops(bwlabeln(thisBarrel),'Orientation','Centroid');
    thisOrientation = thisProp.Orientation;
    thisCentroid = thisProp.Centroid;
% % %     barrelPixelList = find(L==thisLval);
% % %     barrelMap = zeros(size(L))-999;
% % %     barrelMap(barrelPixelList) = fullResultFrame(barrelPixelList);
    for zIter = thisTop:thisBot,
        croppedAPlane = (arterioleMask2(:,:,zIter-minZ));
        barrelAPlane = thisMask.*croppedAPlane;
        temp_bwA = fullResultFrame(find(barrelAPlane));
        if ~isempty(temp_bwA),
            [yList,xList] = ind2sub(size(barrelAPlane),find(barrelAPlane));
            yList = yList-thisCentroid(2);
            xList = xList-thisCentroid(1);
            tempAngleList = atan2(yList,xList)*180/pi - thisOrientation;
            angleAList = [angleAList,tempAngleList'];
            aBarrelList = [aBarrelList,repmat(barrelIter,size(tempAngleList'))];
        end
        bwA = [bwA,temp_bwA'];
         %---
        croppedVPlane = venuleMask2(:,:,zIter-minZ);
        barrelVPlane = thisMask.*croppedVPlane;
        temp_bwV = fullResultFrame(find(barrelVPlane));
        if ~isempty(temp_bwV),
            [yList,xList] = ind2sub(size(barrelAPlane),find(barrelVPlane));
            yList = yList-thisCentroid(2);
            xList = xList-thisCentroid(1);
            tempAngleList = atan2(yList,xList)*180/pi - thisOrientation;
            angleVList = [angleVList,tempAngleList'];
            vBarrelList = [vBarrelList,repmat(barrelIter,size(tempAngleList'))];
        end
        bwV = [bwV,temp_bwV'];
    end%for zIter
    disp(barrelIter);
end%for barrelIter

    
x = [-1:0.1:1];
h1x = zeros(1,numel(x));
hAx = h1x;
hVx = h1x;
bwFrame = fullResultFrame;


h1 = hist(bwFrame(:),x);
h1(1) = 0;h1(end) = 0;
h1x = h1x+h1./sum(h1);
figure(91);plot(x,h1x,'k-');hold on
hA = hist(bwA(:),x);
hA(1) = 0;hA(end) = 0;
hAx = hAx+hA./sum(hA);
% figure(99);plot(x,hA./sum(hA),'r-');
figure(91);plot(x,hAx,'r-');hold on

hV = hist(bwV(:),x);
hV(1) = 0;hV(end) = 0;
hVx = hVx+hV./sum(hV);
% figure(99);plot(x,hV./sum(hV),'b-');
figure(91);plot(x,hVx,'b-');hold on
hold off


figure(101);plot(x,hAx./h1x,'r--');hold on
figure(101);plot(x,hVx./h1x,'b--');hold off

%%
%Choose a demonstration barrel
myChoice = 6;
demoLval = myChoice;
demoMask = uint8(L==demoLval);
demoBarrel = uint8(testFrame).*demoMask;
demoResult = fullResultFrame.*(L==demoLval);
demoProp = regionprops(bwlabeln(demoBarrel),'Orientation','Centroid');
demoOrientation = demoProp.Orientation;
demoCentroid = demoProp.Centroid;
demoY = round(demoCentroid(2));
demoX = round(demoCentroid(1));


%Plot the arterioles against this demonstration barrel
mybwList = bwA;
myAngleList = angleAList;
myBarrelList = aBarrelList;
numPoints = numel(mybwList);
demoFrame = zeros(size(demoMask));
figure(1);imagesc(demoBarrel);
for pointIter = 1:numPoints,
    thisResultVal = mybwList(pointIter);
    thisOrientation = myAngleList(pointIter)+demoOrientation;
    thisFinalY = demoY + sin(thisOrientation*pi/180)*200;
    thisFinalX = demoX + cos(thisOrientation*pi/180)*200;
    yList = round(linspace(demoY,thisFinalY,200));
    xList = round(linspace(demoX,thisFinalX,200));
    indList = sub2ind(size(thisMask),yList,xList);
    resultList = abs(demoResult(indList)-thisResultVal);
    [minVal,minPos] = min(resultList);
    thisYPos = yList(minPos(1));
    thisXPos = xList(minPos(1));
    realUnitsRadius = sqrt((thisYPos-demoY).^2 + (thisXPos-demoX).^2);
    indList = sub2ind(size(demoMask),thisYPos,thisXPos);
% % % %     if pointIter >1,
% % % %         if myBarrelList(pointIter-1) == myBarrelList(pointIter),
% % % % % % %             previousOrientation = myAngleList(pointIter+1)+demoOrientation;
% % % % % % %             nextYPos = demoY + sin(nextOrientation*pi/180)*realUnitsRadius;
% % % % % % %             nextXPos = demoX + cos(nextOrientation*pi/180)*realUnitsRadius;
% % % % % % %             disp([thisYPos,nextYPos]);
% % % % % % %             yList = round(linspace(thisYPos,nextYPos,200));
% % % % % % %             xList = round(linspace(thisXPos,nextXPos,200));
% % % % % % %             indList = sub2ind(size(thisMask),yList,xList);
% % % %             yList = round(linspace(lastYPos,thisYPos,200));
% % % %             xList = round(linspace(lastXPos,thisXPos,200));
% % % %             indList = sub2ind(size(thisMask),yList,xList);
% % % %         else
% % % %             disp('skipping');
% % % % %             pause
% % % %         end%if myBarrelList(pointIter+1) == myBarrelList(pointIter),
% % % %     end% if pointIter>1
    lastYPos = thisYPos;
    lastXPos = thisXPos;
    demoFrame(indList) = demoFrame(indList)+ 1;%   demoFrame(thisYPos,thisXPos) + 1;
    see(log(demoFrame(demoY-200:demoY+200,demoX-200:demoX+200)+1));
end
aFrame = demoFrame;
test = uint8(demoFrame)*5+uint8(demoBarrel+demoMask);see(log(double(test+1)));
%%

%Plot the venules against this demonstration barrel
mybwList = bwV;
myAngleList = angleVList;
myBarrelList = vBarrelList;
numPoints = numel(mybwList);
demoFrame = zeros(size(demoMask));
figure(1);imagesc(demoBarrel);
for pointIter = 1:numPoints,
    thisResultVal = mybwList(pointIter);
    thisOrientation = myAngleList(pointIter)+demoOrientation;
    thisFinalY = demoY + sin(thisOrientation*pi/180)*200;
    thisFinalX = demoX + cos(thisOrientation*pi/180)*200;
    yList = round(linspace(demoY,thisFinalY,200));
    xList = round(linspace(demoX,thisFinalX,200));
    indList = sub2ind(size(thisMask),yList,xList);
    resultList = abs(demoResult(indList)-thisResultVal);
    [minVal,minPos] = min(resultList);
    thisYPos = yList(minPos(1));
    thisXPos = xList(minPos(1));
    realUnitsRadius = sqrt((thisYPos-demoY).^2 + (thisXPos-demoX).^2);
    indList = sub2ind(size(demoMask),thisYPos,thisXPos);
% % % %     if pointIter >99991,
% % % %         if myBarrelList(pointIter-1) == myBarrelList(pointIter),
% % % %             yList = round(linspace(lastYPos,thisYPos,200));
% % % %             xList = round(linspace(lastXPos,thisXPos,200));
% % % %             indList = sub2ind(size(thisMask),yList,xList);
% % % %         else
% % % %             disp('skipping');
% % % %             pause
% % % %         end%if myBarrelList(pointIter+1) == myBarrelList(pointIter),
% % % %     end% if pointIter>1
    demoFrame(indList) = demoFrame(indList) + 1;%   demoFrame(thisYPos,thisXPos) + 1;
    see(log(demoFrame(demoY-200:demoY+200,demoX-200:demoX+200))+1);
    lastYPos = thisYPos;
    lastXPos = thisXPos;
end
vFrame = demoFrame;
test = uint8(demoFrame)*5+uint8(demoBarrel+demoMask);see(log(double(test+1)));
test = uint8(aFrame+vFrame)*5+uint8(demoBarrel+demoMask);see(log(double(test+1)),98);

mycircle = double(circle2d(51));
filtFrame = imfilter(double(aFrame+vFrame),mycircle); %./sum(mycircle(:));
test = filtFrame*5+(double(demoBarrel+demoMask)*max(filtFrame(:))/10);see((double(test)),97);
see(log(filtFrame+1),96);



bwAAU = bwA; angleAListAU = angleAList;
bwVAU = bwV; angleVListAU = angleVList;




