%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%

cd('F:\Phil\AOH_VectorProjects\pbCO\VectorProjectFolder\FlowProject_00001')
load('F:\Phil\AOH_VectorProjects\pbCO\VectorProjectFolder\FlowProject_00001\FVFile_2011_06_13-142123.mat')
load('F:\Phil\AOH_VectorProjects\pbCO\VectorProjectFolder\barrelStruct.mat')

%%




%%
maskSize = gds.maskSize;

numBarrels = numel(barrels);
minZ = inf;
maxZ = 0;
for barrelIter = 1:numBarrels,
    thisBarrel = barrels(barrelIter);
    thisBarrelTop = thisBarrel.top(1,3);
    thisBarrelBottom = thisBarrel.bottom(1,3);
    minZ = min(minZ,thisBarrelTop-1);
    maxZ = max(maxZ,thisBarrelBottom+1);    
end

z1 = 1;
z2 = z1 - minZ + maxZ;
subBlock = zeros(maskSize(1),maskSize(2),z2-z1+1,'uint8');

for barrelIter = 1:numBarrels,
    thisBarrel = barrels(barrelIter);
    thisBarrelTop = thisBarrel.top(1,3);
    thisBarrelBottom = thisBarrel.bottom(1,3);
    for zIter = 1: thisBarrelBottom-thisBarrelTop+1;
        thisInd = sub2ind(size(subBlock),thisBarrel.top(:,1),thisBarrel.top(:,2),thisBarrel.top(:,3)-minZ+zIter);
        subBlock(thisInd) = 1;
    end
end


barrelEdgeMask = subBlock.*0;
barrelInteriorMask = subBlock.*0;

for zIter = z1:3:z2-3,
    thisFrame = subBlock(:,:,zIter);
    closedFrame = imclose(thisFrame>0,ones(5,5));
    filledFrame = imfill(closedFrame,'holes');
    
% % %     
% % %     filledFrame = imdilate(filledFrame,circle2d(11));
% % %     closedFrame = imdilate(filledFrame,ones(3,3));
% % %     closedFrame = closedFrame-filledFrame;
% % %     
% % %     
    
    barrelEdgeMask(:,:,zIter) = closedFrame;
    barrelEdgeMask(:,:,zIter+1) = closedFrame;
    barrelEdgeMask(:,:,zIter+2) = closedFrame;   
    barrelInteriorMask(:,:,zIter) = filledFrame;
    barrelInteriorMask(:,:,zIter+1) = filledFrame;
    barrelInteriorMask(:,:,zIter+2) = filledFrame;   
end

%%
minRadius = 2
arterioleMask = barrelEdgeMask.*0;
allPlungingArterioleList = gds.allPlungingArterioleList;
numArterioles = numel(allPlungingArterioleList);
aRadiusList = [];
for aIter = 1:numArterioles,
    thisStrandID = allPlungingArterioleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    aRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if aRadiusList(aIter) > minRadius,
        arterioleMask(thisInd) = 1;
    end%if aRadiusList(aIter) > minRadius,
end


%%
venuleMask = barrelEdgeMask.*0;
allPlungingVenuleList = gds.allPlungingVenuleList;
numVenules = numel(allPlungingVenuleList);
vRadiusList = [];
for aIter = 1:numVenules,
    thisStrandID = allPlungingVenuleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    vRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if vRadiusList(aIter) > minRadius,
        venuleMask(thisInd) = 1;
    end%if vRadiusList(aIter) > minRadius,
end



%%
barrelInteriorFrame = max(barrelInteriorMask,[],3)>0;
barrelEdgeFrame = max(barrelEdgeMask,[],3);
arterioleFrame = max(arterioleMask,[],3);
venuleFrame = max(venuleMask,[],3);


%%
figure(1);imagesc(barrelEdgeFrame);
figure(2);imagesc(arterioleFrame);
figure(3);imagesc(venuleFrame);
RGB = zeros([size(barrelEdgeFrame),3]);
RGB(:,:,1) = arterioleFrame;
RGB(:,:,2) = barrelEdgeFrame;
RGB(:,:,3) = venuleFrame;
figure(4); imagesc(RGB);

for x = 400:maskSize(2)
    y = 1500-x;
    RGB(y:end,x,:) = 1;
end
RGB(:,1:200,:) = 1;
RGB(:,1200:end,:) = 1;
RGB(1000:end,:,:) = 1;
RGB(1:250,:,:) = 1;
figure(5);imagesc(RGB);

%%


barrelInteriorFrame;

dilationSize = 11;
numIter = 12;
dilatedFrame = barrelInteriorFrame;
for kk = 1:numIter,
    dilatedFrame = imdilate(dilatedFrame,circle2d(dilationSize));
end
dilatedFrame = imfill(dilatedFrame,'holes');
figure(1);imagesc(barrelInteriorFrame);
figure(2);imagesc(dilatedFrame);
erodedFrame = dilatedFrame;
erodedFrame(1,:) = 0;
erodedFrame(end,:) = 0;
erodedFrame(:,1) = 0;
erodedFrame(:,end) = 0;

numIter = 9
for kk = 1:numIter,
    erodedFrame = imerode(erodedFrame,circle2d(dilationSize));
end
figure(3);imagesc(erodedFrame);




%%
x = [-1:0.03:1];
h1x = zeros(1,numel(x));
hAx = h1x;
hVx = h1x;


% % for x = 400:maskSize(2)
% %     y = 1500-x;
% %     arterioleFrame(y:end,x) = 0;
% %     venuleFrame(y:end,x) = 0;
% % end
% % arterioleFrame(:,1:200) = 0;
% % arterioleFrame(:,1200:end) = 0;
% % arterioleFrame(1000:end,:) = 0;
% % arterioleFrame(1:250,:) = 0;
% % venuleFrame(:,1:200) = 0;
% % venuleFrame(:,1200:end) = 0;
% % venuleFrame(1000:end,:) = 0;
% % venuleFrame(1:250,:) = 0;




% % % cc1 = -170;
% % % cc2 = 590;
% % % arterioleFrame2 = circshift(arterioleFrame,[cc1,cc2]);
% % % venuleFrame2 = circshift(venuleFrame,[cc1,cc2]);
% % % arterioleFrame2 = fliplr(arterioleFrame2);
% % % venuleFrame2 = fliplr(venuleFrame2);



for q = 0:0

bwFrame = bwdist(barrelEdgeFrame);
bwFrame = bwFrame.*(double(barrelInteriorFrame*2-1));
bwFrame(~erodedFrame) = -999;


bwFrame = fullResultFrame;


% % % for x = 400:maskSize(2)
% % %     y = 1500-x;
% % %     bwFrame(y:end,x) = -999;
% % % end
% % % bwFrame(:,1:200) = -999;
% % % bwFrame(:,1200:end) = -999;
% % % bwFrame(1000:end,:) = -999;
% % % bwFrame(1:250,:) = -999;


bwFrame = circshift(bwFrame,[q,q]);



h1 = histc(bwFrame(:),x)';
h1(1) = 0;h1(end) = 0;
h1x = h1x+h1./sum(h1);
% figure(99);plot(x,h1./sum(h1),'k-');hold on
figure(93);plot(x,h1x,'k-');hold on

% % bwA = bwFrame(find(arterioleFrame));
% % bwV = bwFrame(find(venuleFrame));

bwA = [];bwV = [];
for kk = z1:z2,
% %     temp_bwA = bwFrame(find(arterioleMask(:,:,kk)));
% %     temp_bwV = bwFrame(find(venuleMask(:,:,kk)));

    temp_bwA = bwFrame(find(double(arterioleMask(:,:,kk)).*erodedFrame));
    temp_bwV = bwFrame(find(double(venuleMask(:,:,kk)).*erodedFrame));
    
    bwA = [bwA,temp_bwA'];
    bwV = [bwV,temp_bwV'];
end%for kk
    

hA = histc(bwA(:),x)';
hA(1) = 0;hA(end) = 0;
hAx = hAx+hA./sum(hA);
% figure(99);plot(x,hA./sum(hA),'r-');
figure(93);plot(x,hAx,'r-');hold on

hV = histc(bwV(:),x)';
hV(1) = 0;hV(end) = 0;
hVx = hVx+hV./sum(hV);
% figure(99);plot(x,hV./sum(hV),'b-');
figure(93);plot(x,hVx,'b-');hold on
hold off

% pause
end

b1 = (h1x(21:40));
b2 = (h1x(41:60));
b3 = (h1x(81:100));
v1 = (hVx(21:40));
v2 = (hVx(41:60));
v3 = (hVx(81:100));
a1 = (hAx(21:40));
a2 = (hAx(41:60));
a3 = (hAx(81:100));
% b1 = sum(h1x(21:50));
% b2 = sum(h1x(51:70));
% b3 = sum(h1x(71:100));
% v1 = sum(hVx(21:50));
% v2 = sum(hVx(51:70));
% v3 = sum(hVx(71:100));
% a1 = sum(hAx(21:50));
% a2 = sum(hAx(51:70));
% a3 = sum(hAx(71:100));




