%%
'yuck'
'yuck'

pause
pause
pause
pause
pause
%%
% % 
cd('F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files')
load('F:\Phil\AOH_VectorProjects\pbDB\BarrelOutlines.mat')
load('F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files\FVFile_2011_06_13-162141.mat')


%%

maskSize = gds.maskSize;

numBarrels = numel(barrels);
minZ = inf;
maxZ = 0;
for barrelIter = 1:numBarrels,
    thisBarrel = barrels{barrelIter};
    minZ = min(minZ,min(thisBarrel(:,3))-1);
    maxZ = max(maxZ,max(thisBarrel(:,3))+1);    
end

z1 = 1;
z2 = z1 - minZ + maxZ;
subBlock = zeros(maskSize(1),maskSize(2),z2-z1+1,'uint8');

for barrelIter = 1:numBarrels,
    thisBarrel = barrels{barrelIter};
    thisInd = sub2ind(size(subBlock),thisBarrel(:,1),thisBarrel(:,2),thisBarrel(:,3)-minZ);
    subBlock(thisInd) = 1;
    minZ = min(minZ,min(thisBarrel(:,3))-1);
    maxZ = max(maxZ,max(thisBarrel(:,3))+1);    
end


barrelEdgeMask = subBlock.*0;
barrelInteriorMask = subBlock.*0;

for zIter = z1:3:z2-3,
    thisFrame = subBlock(:,:,zIter);
    closedFrame = imclose(thisFrame>0,ones(5,5));
    filledFrame = imfill(closedFrame,'holes');
    barrelEdgeMask(:,:,zIter) = closedFrame;
    barrelEdgeMask(:,:,zIter+1) = closedFrame;
    barrelEdgeMask(:,:,zIter+2) = closedFrame;   
    barrelInteriorMask(:,:,zIter) = filledFrame;
    barrelInteriorMask(:,:,zIter+1) = filledFrame;
    barrelInteriorMask(:,:,zIter+2) = filledFrame;   
end




%%
minRadius = 3.5
arterioleMask = barrelEdgeMask.*0;
allPlungingArterioleList = gds.allPlungingArterioleList;
numArterioles = numel(allPlungingArterioleList);
aRadiusList = [];
for aIter = 1:numArterioles,
    thisStrandID = allPlungingArterioleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    aRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if aRadiusList(aIter) > minRadius,
        arterioleMask(thisInd) = 1;
    end%if aRadiusList(aIter) > minRadius,
end


%%
venuleMask = barrelEdgeMask.*0;
allPlungingVenuleList = gds.allPlungingVenuleList;
numVenules = numel(allPlungingVenuleList);
vRadiusList = [];
for aIter = 1:numVenules,
    thisStrandID = allPlungingVenuleList(aIter);
    thisStrand = gds.Strands(thisStrandID);
    vRadiusList(aIter) = thisStrand.MedianRadius;
    allVerts = gds.Vertices.AllVerts(thisStrand.StartToEndIndices,:);
    subVerts = allVerts(and(allVerts(:,3)>minZ,allVerts(:,3)<maxZ),:);
    thisInd = sub2ind(size(subBlock),subVerts(:,1),subVerts(:,2),subVerts(:,3)-minZ);
    if vRadiusList(aIter) > minRadius,
        venuleMask(thisInd) = 1;
    end%if vRadiusList(aIter) > minRadius,
end




%%
barrelInteriorFrame = max(barrelInteriorMask,[],3)>0;
barrelEdgeFrame = max(barrelEdgeMask,[],3);
arterioleFrame = max(arterioleMask,[],3);
venuleFrame = max(venuleMask,[],3);


%%
figure(1);imagesc(barrelEdgeFrame);
figure(2);imagesc(arterioleFrame);
figure(3);imagesc(venuleFrame);
RGB = zeros([size(barrelEdgeFrame),3]);
RGB(:,:,1) = arterioleFrame;
RGB(:,:,2) = barrelEdgeFrame;
RGB(:,:,3) = venuleFrame;
figure(4); imagesc(RGB);

%%

barrelInteriorFrame;

dilationSize = 11;
numIter = 12;
dilatedFrame = barrelInteriorFrame;
for kk = 1:numIter,
    dilatedFrame = imdilate(dilatedFrame,circle2d(dilationSize));
end
dilatedFrame = imfill(dilatedFrame,'holes');
figure(1);imagesc(barrelInteriorFrame);
figure(2);imagesc(dilatedFrame);
erodedFrame = dilatedFrame;
erodedFrame(1,:) = 0;
erodedFrame(end,:) = 0;
erodedFrame(:,1) = 0;
erodedFrame(:,end) = 0;

numIter = 9
for kk = 1:numIter,
    erodedFrame = imerode(erodedFrame,circle2d(dilationSize));
end
figure(3);imagesc(erodedFrame);

%%
testFrame = barrelInteriorFrame;

figure(11);imagesc(testFrame);
fullResultFrame = ones(size(testFrame));
bwFrame = bwdist(testFrame);
figure(22);imagesc(bwFrame);
L = watershed(bwFrame);
L(1:end,1) = 0;
L(1:end,end) = 0;
L(1,1:end) = 0;
L(end,1:end) = 0;

figure(13);imagesc(L);
figure(14);imagesc(L==0);
bwl = bwlabel(testFrame);

numObjects = max(bwl(:));
for objIter = 1:numObjects,
    thisObject = bwl==objIter;
    figure(2);imagesc(thisObject);
    thisEdge = thisObject - imerode(thisObject,ones(3,3));
    figure(3);imagesc(thisEdge);
    props = regionprops(bwl,'Centroid','PixelList');
    yc = round(props(objIter).Centroid(2));
    xc = round(props(objIter).Centroid(1));
    allPixelList = props(objIter).PixelList;
    allX = allPixelList(:,1);
    allY = allPixelList(:,2);
    [fullX,fullY] = meshgrid(1-xc:size(thisObject,2)-xc,1-yc:size(thisObject,1)-yc);
    fullR = sqrt(fullX.^2 + fullY.^2);
    allR = fullR(sub2ind(size(thisObject),allY,allX));
    figure(4);imagesc(fullR);
    bwle = bwlabel(thisEdge);
    propsE = regionprops(bwle,'PixelList','PixelIdxList');
    edgePixelList = propsE(1).PixelList;
    edgePixelIDList = propsE(1).PixelIdxList;
    edgeXList = edgePixelList(:,1);
    edgeYList = edgePixelList(:,2);
    dx = edgeXList-xc;
    dy = edgeYList-yc;
    edgeRList = sqrt(dx.^2+dy.^2);
    numPixels = numel(allX);
    numEdge = numel(edgeXList);
    sortedEdgePixelList = flipud(sortrows([edgeYList,edgeXList,edgeRList],3));

    tic
    q = zeros(kk,1);
    maxEdgeFrame = zeros(size(thisObject));
    maxEdgeFrame(sub2ind(size(thisObject),edgeYList,edgeXList)) = edgeRList;
    for kk = 1:numEdge,
        ey = round(sortedEdgePixelList(kk,1));
        ex = round(sortedEdgePixelList(kk,2));
        er = sortedEdgePixelList(kk,3);
        dy = ey -yc;
        dx = ex -xc;
        if abs(dy)>abs(dx),
            pyList = [yc:sign(dy):ey];
            pxList = round(linspace(xc,ex,numel(pyList)));
        else
            pxList = [xc:sign(dx):ex]; 
            pyList = round(linspace(yc,ey,numel(pxList)));
        end
        maxEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = er;
    end%for kk = 1:numPixels
    figure(5);imagesc(maxEdgeFrame);
    toc

    effRadius = fullR.*thisObject./maxEdgeFrame;
    figure(6);imagesc(effRadius);
    numErrors = numel(find(maxEdgeFrame(thisObject)==0))



    wsVal = unique(L(thisObject));
    thisWS = L==wsVal;

thisWS = thisWS .* dilatedFrame;

    thisWSEdge = thisWS - imerode(thisWS,ones(3,3));

    figure(3);imagesc(thisWSEdge);

    bwWSe = bwlabel(thisWSEdge);
    propsWSE = regionprops(bwWSe,'PixelList','PixelIdxList');
    wsEdgePixelList = propsWSE(1).PixelList;
    wsEdgePixelIDList = propsWSE(1).PixelIdxList;
    wsEdgeXList = wsEdgePixelList(:,1);
    wsEdgeYList = wsEdgePixelList(:,2);
    dx = wsEdgeXList-xc;
    dy = wsEdgeYList-yc;
    wsEdgeRList = sqrt(dx.^2+dy.^2);
    numWSEdge = numel(wsEdgeXList);
    sortedWSEdgePixelList = flipud(sortrows([wsEdgeYList,wsEdgeXList,wsEdgeRList],3));

    tic
    q = zeros(kk,1);
    maxWSEdgeFrame = zeros(size(thisObject));
    maxWSEdgeFrame(sub2ind(size(thisObject),wsEdgeYList,wsEdgeXList)) = wsEdgeRList;
    for kk = 1:numWSEdge,
        ey = round(sortedWSEdgePixelList(kk,1));
        ex = round(sortedWSEdgePixelList(kk,2));
        er = sortedWSEdgePixelList(kk,3);
        dy = ey -yc;
        dx = ex -xc;
        if abs(dy)>abs(dx),
            pyList = [yc:sign(dy):ey];
            pxList = round(linspace(xc,ex,numel(pyList)));
        else
            pxList = [xc:sign(dx):ex]; 
            pyList = round(linspace(yc,ey,numel(pxList)));
        end
        %Now, find the point where this vector crosses the barrelEdge
        idList = sub2ind(size(thisObject),pyList,pxList);
        crossFlagList = ismember(idList,edgePixelIDList);
        if sum(crossFlagList)>0,
            crossPoint = find(crossFlagList);
            pyList = pyList(crossPoint(1):end);
            pxList = pxList(crossPoint(1):end);
            normRList = linspace(0,1,numel(pyList));
            maxWSEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = normRList;
        else
            disp('No Cross');
            keyboard
        end

    end%for kk = 1:numPixels
    figure(5);imagesc(maxWSEdgeFrame);
    fullResultFrame(thisWS>0) = maxWSEdgeFrame(thisWS>0);
    fullResultFrame(thisObject) = effRadius(thisObject)-1;
    figure(9);imagesc(fullResultFrame);
end%for objIter...
toc




%%
x = [-1:0.03:1];
h1x = zeros(1,numel(x));
hAx = h1x;
hVx = h1x;

for q = -0,

% % % bwFrame = bwdist(barrelEdgeFrame);
% % % bwFrame = bwFrame.*(double(barrelInteriorFrame*2-1));
% % % bwFrame = circshift(bwFrame,[0,q]);
% % % bwFrame(~erodedFrame) = -999;
bwFrame = fullResultFrame;


h1 = hist(bwFrame(:),x);
h1(1) = 0;h1(end) = 0;
h1x = h1x+h1./sum(h1);
% figure(99);plot(x,h1./sum(h1),'k-');hold on
figure(91);plot(x,h1x,'k-');hold on

% % bwA = bwFrame(find(arterioleFrame));
% % bwV = bwFrame(find(venuleFrame));

bwA = [];bwV = [];
for kk = z1:z2,
% %     temp_bwA = bwFrame(find(arterioleMask(:,:,kk)));
% %     temp_bwV = bwFrame(find(venuleMask(:,:,kk)));

    temp_bwA = bwFrame(find(double(arterioleMask(:,:,kk)).*erodedFrame));
    temp_bwV = bwFrame(find(double(venuleMask(:,:,kk)).*erodedFrame));
    
    bwA = [bwA,temp_bwA'];
    bwV = [bwV,temp_bwV'];
end%for kk
    

hA = hist(bwA(:),x);
hA(1) = 0;hA(end) = 0;
hAx = hAx+hA./sum(hA);
% figure(99);plot(x,hA./sum(hA),'r-');
figure(91);plot(x,hAx,'r-');hold on

hV = hist(bwV(:),x);
hV(1) = 0;hV(end) = 0;
hVx = hVx+hV./sum(hV);
% figure(99);plot(x,hV./sum(hV),'b-');
figure(91);plot(x,hVx,'b-');hold on
hold off

% pause
end

figure(101);plot(x,hAx./h1x,'r--');hold on
figure(101);plot(x,hVx./h1x,'b--');hold off






