%Load a barrelOutlines.mat file and a -flow-VectorProject.mat file

vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);
allVerts = vertices.AllVerts;

%%

numBarrels = numel(barrels)
allBarrelCoords = [];
for barrelIter = 1:numBarrels;
    allBarrelCoords = [allBarrelCoords;barrels{barrelIter}];
end

globalMinZ = min(allBarrelCoords(:,3));
globalMaxZ = max(allBarrelCoords(:,3));
globalZRange = globalMaxZ-globalMinZ+1;


% % %                 globalMinZ = min(allBarrelCoords(:,3))-20;

% % %                 globalMaxZ = max(allBarrelCoords(:,3))-20;
% % %                 globalZRange = globalMaxZ-globalMinZ+1;

%%
divRatio = 3;
closeCircleDiameter = 7;
erodeCircleDiameter = 30;
dilateCircleDiameter = 200;

subMaskSize = ceil(maskSize/divRatio);
subMaskSize(3) = ceil(globalZRange/divRatio);
%%
allVertsExpanded = [allVerts,[1:numVerts]'];
cutVerts = allVertsExpanded(allVerts(:,3)>=globalMinZ,1:4);
cutVerts = cutVerts(cutVerts(:,3)<=globalMaxZ,1:4);
cutVertIndList = sub2ind(maskSize,cutVerts(:,1),cutVerts(:,2),cutVerts(:,3));
subVerts = cutVerts;
subVerts(:,3) = cutVerts(:,3) - globalMinZ + 1;
subVerts(:,1:3) = ceil(subVerts(:,1:3)/3);
subVertIndList = sub2ind(subMaskSize,subVerts(:,1),subVerts(:,2),subVerts(:,3));
%---

%%
vertBarrelValueList = zeros(numVerts,1,'int8');

subMask = zeros(subMaskSize,'int8')-128;
barrelIter = 1;
for barrelIter = 1:numBarrels;
    tic
    disp(barrelIter);
    thisBarrelCoords = barrels{barrelIter};
    minZ = min(thisBarrelCoords(:,3));
    maxZ = max(thisBarrelCoords(:,3));
    
    
    
    minZ = globalMinZ;disp('Extending each barrel across all Z of barrel field');
    maxZ = globalMaxZ;
    
    
    
    
    indOffset = (minZ-1)*maskSize(1)*maskSize(2);
    frameCoords = thisBarrelCoords(find(thisBarrelCoords(:,3) == min(thisBarrelCoords(:,3))),1:2);
    thisFrame = false(maskSize(1),maskSize(2));
    frameIndList = sub2ind(size(thisFrame),frameCoords(:,1),frameCoords(:,2));
    thisFrame(frameIndList) = 1;
    closeFrame = imclose(thisFrame,circle2d(closeCircleDiameter));
    fillFrame = imfill(closeFrame,'holes');
    erodeFrame = imerode(fillFrame,circle2d(erodeCircleDiameter));
    dilateFrame = imdilate(fillFrame,circle2d(erodeCircleDiameter));
    outsideFrame = imdilate(fillFrame,circle2d(dilateCircleDiameter));
    outsideFrame = (outsideFrame-dilateFrame)>0;
    edgeFrame = (dilateFrame-erodeFrame)>0;
    insideFrame = erodeFrame;
    valueFrame = int8(zeros(maskSize(1),maskSize(2)))-128;
    valueFrame(insideFrame>0) = barrelIter;
    valueFrame(edgeFrame>0) = -1*barrelIter;
    valueFrame(outsideFrame>0) = -127;
    subValueFrame = imresize(valueFrame,[subMaskSize(1),subMaskSize(2)],'nearest');
    insideFrameIndList = find(insideFrame);
    edgeFrameIndList = find(edgeFrame);
    outsideFrameIndList = find(outsideFrame);
    zStart = minZ-globalMinZ+1;
    zStop = maxZ-globalMinZ+1;
    insideIndList = [];
    edgeIndList = [];
    outsideIndList = [];
    for zIter = minZ:maxZ,
        cutZ = zIter-globalMinZ+1;
        subZ = ceil(cutZ/divRatio);
%         indOffset = (zIter-1)*maskSize(1)*maskSize(2);
%         insideIndList = [insideIndList; insideFrameIndList+indOffset];
%         edgeIndList = [edgeIndList; edgeFrameIndList+indOffset];
        %---
        subMask(:,:,subZ) = max(subMask(:,:,subZ),subValueFrame);
        %---
    end%for zIter = ...
    toc
end%for barrelIter = ...
%---
for zIter = 1:subMaskSize(3),
    origFrame = subMask(:,:,zIter);
    thisFrame = origFrame~=-128;
    fillFrame = imfill(thisFrame,'holes');
    addFrame = (fillFrame-thisFrame)>0;
    joinedFrame = origFrame;
    joinedFrame(find(addFrame)) = -127;
    subMask(:,:,zIter) = joinedFrame;
end%for zIter;
vertBarrelValueList(subVerts(:,4)) = subMask(subVertIndList);
   

save Results-BarrelBoundaryValues.mat subMask cutVerts subVerts vertBarrelValueList *VertIndList divRatio *CircleDiameter;

viewstack(and(subMask>-126,subMask<0));
viewstack(subMask==-127);


%%
vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);
allVerts = vertices.AllVerts;
subMaskSize = size(subMask);
%%
bufferZone = 000;
y1 = bufferZone+1; x1 = bufferZone+1;
y2 = maskSize(1)-bufferZone;
x2 = maskSize(2)-bufferZone;
subBufferZone = ceil(bufferZone./divRatio);
y1sub = subBufferZone+1; x1sub = subBufferZone+1;
y2sub = subMaskSize(1)-subBufferZone;
x2sub = subMaskSize(2)-subBufferZone;


croppedSubMask = subMask;
croppedSubMask(1:y1sub,:,:) = -128;
croppedSubMask(y2sub:end,:,:) = -128;
croppedSubMask(:,1:x1sub,:) = -128;
croppedSubMask(:,x2sub:end,:) = -128;
f1 = or(allVerts(:,1)<y1,allVerts(:,1)>y2);
f2 = or(allVerts(:,2)<x1,allVerts(:,2)>x2);
fAll = or(f1,f2);
croppedVertBarrelValueList = vertBarrelValueList;
croppedVertBarrelValueList(fAll) = -128;


numOutsideVoxels = sum(croppedSubMask(:)==-127);
numEdgeVoxels = sum(and(croppedSubMask(:)>-101,croppedSubMask(:)<0));
numInsideVoxels = sum(croppedSubMask(:)>0);
numNonCountVoxels = sum(croppedSubMask(:)==-128);


outsideVertIndexList = find(croppedVertBarrelValueList==-127);
edgeVertIndexList = find(and(croppedVertBarrelValueList>-126,croppedVertBarrelValueList<0));
insideVertIndexList = find(croppedVertBarrelValueList>0);

outsideVertDensity = numel(outsideVertIndexList)./numOutsideVoxels;
edgeVertDensity = numel(edgeVertIndexList)./numEdgeVoxels;
insideVertDensity = numel(insideVertIndexList)./numInsideVoxels;
disp('All Vessels:');
disp([1, edgeVertDensity./insideVertDensity,outsideVertDensity./insideVertDensity]);
%---
%%
ov = allVerts(outsideVertIndexList,:);
iv = allVerts(insideVertIndexList,:);
ev = allVerts(edgeVertIndexList,:);

figure(11);pov = plot3(ov(:,1),ov(:,2),-1*ov(:,3),'c.');hold on
figure(11);piv = plot3(iv(:,1),iv(:,2),-1*iv(:,3),'k.');hold on
figure(11);pev = plot3(ev(:,1),ev(:,2),-1*ev(:,3),'m.');hold off



%%
strandCurrentList = abs([strands(:).strandCurrent]);
strandConductanceList = abs([strands(:).strandConductance]);
medianCurrent = median(strandCurrentList);
sortCurrent = sort(strandCurrentList);

lowCurrent = sortCurrent(ceil(numel(sortCurrent)*0.1));

lowCurrentStrandList = find(strandCurrentList<lowCurrent); disp('Low Current:');


        lowCurrentStrandList = allClusterStrandList;disp('Substitituing cluster strands for low current strands')



lowCurrentVertList = [strands(lowCurrentStrandList).StartToEndIndices];
lowBVL = croppedVertBarrelValueList(lowCurrentVertList);



lowOutsideIndexList = find(lowBVL==-127);
lowEdgeIndexList = find(and(lowBVL>-126,lowBVL<0));
lowInsideIndexList = find(lowBVL>0);

lowOutsideDensity = numel(lowOutsideIndexList)./numOutsideVoxels;
lowEdgeDensity = numel(lowEdgeIndexList)./numEdgeVoxels;
lowInsideDensity = numel(lowInsideIndexList)./numInsideVoxels;

disp([1, lowEdgeDensity./lowInsideDensity,lowOutsideDensity./lowInsideDensity]);

lv = allVerts(lowCurrentVertList,:);
figure(2);plv = plot3(lv(:,1),lv(:,2),-1*lv(:,3),'b.');hold off



%%
highCurrent = sortCurrent(ceil(numel(sortCurrent)*0.90));
highCurrentStrandList = find(strandCurrentList>highCurrent); disp('HighCurrent');

highCurrentVertList = [strands(highCurrentStrandList).StartToEndIndices];
highBVL = croppedVertBarrelValueList(highCurrentVertList);


highOutsideIndexList = find(highBVL==-127);
highEdgeIndexList = find(and(highBVL>-126,highBVL<0));
highInsideIndexList = find(highBVL>0);


highOutsideDensity = numel(highOutsideIndexList)./numOutsideVoxels;
highEdgeDensity = numel(highEdgeIndexList)./numEdgeVoxels;
highInsideDensity = numel(highInsideIndexList)./numInsideVoxels;

disp([1, highEdgeDensity./highInsideDensity,highOutsideDensity./highInsideDensity]);

hv = allVerts(highCurrentVertList,:);
figure(3);plv = plot3(hv(:,1),hv(:,2),-1*hv(:,3),'r.');hold off

%%

hav = allVerts(union(union(outsideVertIndexList,insideVertIndexList),edgeVertIndexList),:);
hov = allVerts(intersect(outsideVertIndexList,highCurrentVertList),:);
hiv = allVerts(intersect(insideVertIndexList,highCurrentVertList),:);
hev = allVerts(intersect(edgeVertIndexList,highCurrentVertList),:);

figure(4);phav = plot3(hav(:,1),hav(:,2),-1*hav(:,3),'k.');hold on
figure(4);phov = plot3(hov(:,1),hov(:,2),-1*hov(:,3),'b.');hold on
figure(4);phiv = plot3(hiv(:,1),hiv(:,2),-1*hiv(:,3),'r.');hold on
figure(4);phev = plot3(hev(:,1),hev(:,2),-1*hev(:,3),'g.');hold off


%%
% allPlungingVenuleList = vectorProject.vectorizedStructure.allPlungingVenuleList;
allPlungingVenuleList = vectorProject.vectorizedStructure.allPlungingArterioleList;

plungingVenuleVertList = [strands(allPlungingVenuleList).StartToEndIndices];
pvBVL = croppedVertBarrelValueList(plungingVenuleVertList);


pvOutsideIndexList = find(pvBVL==-127);
pvEdgeIndexList = find(and(pvBVL>-126,pvBVL<0));
pvInsideIndexList = find(pvBVL>0);


pvOutsideDensity = numel(pvOutsideIndexList)./numOutsideVoxels;
pvEdgeDensity = numel(pvEdgeIndexList)./numEdgeVoxels;
pvInsideDensity = numel(pvInsideIndexList)./numInsideVoxels;

disp([1, pvEdgeDensity./pvInsideDensity,pvOutsideDensity./pvInsideDensity]);

pv = allVerts(plungingVenuleVertList,:);
figure(4);ppv = plot3(pv(:,1),pv(:,2),-1*pv(:,3),'b.');hold off

hav = allVerts(union(union(outsideVertIndexList,insideVertIndexList),edgeVertIndexList),:);
pvov = allVerts(intersect(outsideVertIndexList,plungingVenuleVertList),:);
pviv = allVerts(intersect(insideVertIndexList,plungingVenuleVertList),:);
pvev = allVerts(intersect(edgeVertIndexList,plungingVenuleVertList),:);

figure(4);phav = plot3(hav(:,1),hav(:,2),-1*hav(:,3),'k.');hold on
figure(4);phov = plot3(pvov(:,1),pvov(:,2),-1*pvov(:,3),'b.');hold on
figure(4);phiv = plot3(pviv(:,1),pviv(:,2),-1*pviv(:,3),'r.');hold on
figure(4);phev = plot3(pvev(:,1),pvev(:,2),-1*pvev(:,3),'g.');hold off



