function myPath = BackTrackFromStrand(gds,startStrandID);

keepGoingFlag = 1;

thisStrandID = startStrandID;
myPath = [];

while keepGoingFlag == 1,
    thisStrand = gds.Strands(thisStrandID);
    myPath = [myPath,thisStrandID];
    startVoltage = gds.Vertices.AllVoltages(thisStrand.StartVertexIndex);
    endVoltage = gds.Vertices.AllVoltages(thisStrand.EndVertexIndex);
    if startVoltage < endVoltage,
        upperVoltage = endVoltage;
        upperNeighbors = thisStrand.EndVertexNeighborStrands;
    else
        upperVoltage = startVoltage;
        upperNeighbors = thisStrand.StartVertexNeighborStrands;
    end
    upperNeighbors = upperNeighbors(upperNeighbors~=thisStrandID);
    
    %Consider only upstream neighbors that flow INTO the node
    neighborVoltages = [gds.Strands(upperNeighbors).MedianVoltage];
    validNeighborFlags = [neighborVoltages > upperVoltage];
    upperNeighbors = upperNeighbors(validNeighborFlags);
    
    %Pick the neighbor with the largest current
    neighborCurrents = abs([gds.Strands(upperNeighbors).strandCurrent]);
    [maxC,maxCurrentPointer] = max(neighborCurrents);
    if isempty(maxCurrentPointer),
        myPath = [myPath,inf];
        keepGoingFlag = 0;
    else%if isempty(maxCurrentPointer),
        highCurrentNeighbor = upperNeighbors(maxCurrentPointer(1));
        thisStrandID = highCurrentNeighbor;
    end%if isempty(maxCurrentPointer),
    
    if ismember(thisStrandID,gds.baseStrandIDList),
        myPath = [myPath,thisStrandID];
        keepGoingFlag = 0;
    end%if ismember...
end%while keepGoingFlag == 1






