%Take each tip, trace along for 300 um staying as high as possible

for baseIter = 1:29;
    baseStrandID = gds.baseStrandIDList(baseIter);
    zList = [];
    lengthList = [];
    bloodOxList = [];
    thisStrandID = baseStrandID;
        
    for kk = 1:9,
        thisStrand = gds.Strands(thisStrandID);
        neighborStrands = [thisStrand.StartVertexNeighborStrands,thisStrand.EndVertexNeighborStrands];
        neighborStrands = unique(neighborStrands(neighborStrands~=thisStrandID));
        numNeighbors = numel(neighborStrands);
        neighborV = [gds.Strands(neighborStrands).MedianVoltage];
        neighborStrands = neighborStrands(neighborV < thisStrand.MedianVoltage);
        neighborZ = meanYXZList(neighborStrands,3)';
        neighborR  = strandRadiusList(neighborStrands)';
        
        [minZ, minPos] = min(neighborZ);
% [minR, minPos] = min(neighborR);
        
        
        if isempty(minPos),break;end
        nextStrandID = neighborStrands(minPos);
        nextStrand = gds.Strands(nextStrandID);

        zList = [zList,minZ];
        lengthList = [lengthList,numel(nextStrand.StartToEndIndices)];
        bloodOxList = [bloodOxList,nextStrand.meanBloodOx];
        thisStrandID = nextStrandID;
    end
 
     travelLength = sum(lengthList) - ((lengthList(1) + lengthList(end))/2);     
     percentDropPerMicron(baseIter) =    (1-(bloodOxList(end)/bloodOxList(1))) * (100/travelLength);  
     travelLengthList(baseIter) = travelLength;
     allZList{baseIter} = zList;
     maxZList(baseIter) = max(zList);
     allBloodOxList{baseIter} = bloodOxList;
     bo1(baseIter) = bloodOxList(1);
     bo2(baseIter) = bloodOxList(2);
     bo3(baseIter) = bloodOxList(3);
     bo4(baseIter) = bloodOxList(4);
     bo5(baseIter) = bloodOxList(5);
     
     
end


ff = find(maxZList<300);
pcd = percentDropPerMicron(ff);
pcd = pcd(pcd~=-Inf);
pcd = pcd(~isnan(pcd));
mean(pcd)




