% function vectorProject = CalculateBloodOxDropVersusDistanceToArterioleFunction(vectorProject)
%%
vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
dashPos = findstr(vectorProjectRootName,'-');
vectorProjectShortName = vectorProjectRootName(1:dashPos-1);
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
strandIndices = vertices.StrandIndices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);
allVerts = vertices.AllVerts;
barrelValueSubMask = vectorProject.barrelValueSubMask;
subMaskSize = size(barrelValueSubMask);
divRatio = vectorProject.barrelBoundaryParameters.divRatio;
vertBarrelValueList = vectorProject.vertBarrelValueList;
vertNormMeanBloodOxList = vectorProject.vectorizedStructure.vertNormMeanBloodOxList;
vertMeanBloodOxList = vectorProject.vectorizedStructure.vertMeanBloodOxList;
strandMidYXZList = vectorizedStructure.strandMidYXZList;
strandMeanBloodOxList = vectorizedStructure.strandMeanBloodOxList;

barrelVersusBloodOxParameters = vectorProject.barrelVersusBloodOxParameters;
bufferZone = barrelVersusBloodOxParameters.bufferZone;
bloodOxCutoffList = barrelVersusBloodOxParameters.bloodOxCutoffList;



allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
% allPlungingArterioleList = vectorizedStructure.allPlungingVenuleList;




allPlungingArterioleZList = strandMidYXZList(allPlungingArterioleList,3);

z1 = 200;
z2 = 300;

f1 = find(and(allPlungingArterioleZList>z1,allPlungingArterioleZList<z2));
baseStrandList = allPlungingArterioleList(f1);
subStrandList = find(and(strandMidYXZList(:,3)>z1,strandMidYXZList(:,3)<z2));
subVertList = find(and(allVerts(:,3)>z1,allVerts(:,3)<z2));



allDistList = [];
allOxList = [];

allBaseStrandY = strandMidYXZList(baseStrandList,1);
allBaseStrandX = strandMidYXZList(baseStrandList,2);



for kk = 1:numel(baseStrandList);

    thisBaseStrandID = baseStrandList(kk);
    thisBaseStrandY = strandMidYXZList(thisBaseStrandID,1);
    thisBaseStrandX = strandMidYXZList(thisBaseStrandID,2);

    baseSep =  sqrt((allBaseStrandY-thisBaseStrandY).^2 + (allBaseStrandX-thisBaseStrandX).^2);
    sortBaseSep = sort(baseSep,'ascend');
    closestBaseSep = sortBaseSep(2);
    
    if closestBaseSep>100,


    subStrandY = strandMidYXZList(subStrandList,1);
    subStrandX = strandMidYXZList(subStrandList,2);
    subStrandBloodOxList = strandMeanBloodOxList(subStrandList);
    subVertY = allVerts(subVertList,1);
    subVertX = allVerts(subVertList,2);
    subVertDistList = sqrt((subVertY-thisBaseStrandY).^2 + (subVertX-thisBaseStrandX).^2);
    subVertOxList = strandMeanBloodOxList(strandIndices(subVertList));
    
    subStrandDistList = sqrt((subStrandY-thisBaseStrandY).^2 + (subStrandX-thisBaseStrandX).^2);
    allDistList = [allDistList;subStrandDistList];
    allOxList = [allOxList;subStrandBloodOxList];

    
    
    figure(1);p1 = plot(subStrandDistList,subStrandBloodOxList,'r.');
    figure(2);p2 = plot(allDistList,allOxList,'g.');set(gca,'XLim',[0 200]);
    disp([thisBaseStrandY,thisBaseStrandX]);
    figure(3);p3 = plot(subVertDistList,subVertOxList,'b.');
    
    pause(0.01);  pause
    
    end %if closestBaseSep,
    
end%for kk

filtSize = 20;
allData = [allDistList,allOxList];
sortList = sortrows(allData,1);
filtList = imfilter(sortList,ones(filtSize,1),'symmetric')./filtSize;
figure(3);p3 = plot(filtList(:,1),filtList(:,2),'g-');set(gca,'XLim',[0 200]);



