vp = allProject.db;
vs = vp.vectorizedStructure;
strands = vs.Strands;
vertices = vs.Vertices;
strandIndices = vs.Vertices.StrandIndices;
maskSize = vp.maskSize;


vertBarrelValueList = vp.vertBarrelValueList;


barrelIter = 15;
barrelVertList = find(vertBarrelValueList == barrelIter);
barrelStrandList = unique(strandIndices(barrelVertList,1));

flowProject = vs;
flowProject.baseStrandIDList = barrelStrandList;
flowProject.maxBranchSearch = 8;
flowProject.stopVoltage = 50.1;
flowProject.minimumFluxFraction = 1/3000;

tic
disp('Calculating DownstreamFlow');
flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
toc

downstreamPathList = flowProject.downstreamPathList ;
downstreamBranchList = flowProject.downstreamBranchList ;
%%
%Visualize the barrel strands, and their downstream flow strands
barrelVertCoords = vertices.AllVerts(barrelVertList,:);
downstreamStrandList = find(min(downstreamBranchList,[],2)<Inf);

cc1 = [];cc2 = [];cc3 = [];
for strandIter = 1:numel(downstreamStrandList)
    thisStrand = strands(downstreamStrandList(strandIter));
    stei = thisStrand.StartToEndIndices;
    strandVertCoordList = vertices.AllVerts(stei,:);
    cc1 = [cc1;strandVertCoordList(:,1)];
    cc2 = [cc2;strandVertCoordList(:,2)];
    cc3 = [cc3;strandVertCoordList(:,3)];
end%for strandIter

bvc1 = barrelVertCoords(:,1);
bvc2 = barrelVertCoords(:,2);
bvc3 = barrelVertCoords(:,3);

figure(1);plot3(cc1,cc2,-1*cc3,'b.');hold on
figure(1);plot3(bvc1,bvc2,-1*bvc3,'r.');hold off
set(gca,'XLim',[0,1000],'YLim',[0,1000],'ZLim',[-1000,0]);


%%

%%


% % %%
% % %Visualize the barrel strands, and their downstream flow strands
% % topView = zeros(maskSize(1),maskSize(2));
% % barrelVertCoords = vertices.AllVerts(barrelVertList,:);
% % 
% % 
% % downstreamStrandList = find(min(downstreamBranchList,[],2)<Inf);
% % for strandIter = 1:numel(downstreamStrandList)
% %     thisStrand = strands(downstreamStrandList(strandIter));
% %     stei = thisStrand.StartToEndIndices;
% %     strandVertCoordList = vertices.AllVerts(stei,:);
% %     for vertIter = 1:numel(stei);
% %         topView(strandVertCoordList(vertIter,1),strandVertCoordList(vertIter,2)) = 1;
% %     end%for vertIter
% % end%for strandIter
% % 
% % for vertIter = 1:numel(barrelVertList);
% %     topView(barrelVertCoords(vertIter,1),barrelVertCoords(vertIter,2)) = 2;
% % end%for vertIter
% % 
% % 
% % 
% % 
% % figure(1);imagesc(topView)
% %     


