% % % 'ooooh'
% % % pause
% % % pause
% % % pause
% % % pause

gds = vectorProject.vectorizedStructure;

startStrandList = gds.plungingArterioleTipList;                 
minimumFluxFraction = 1/3e4;
stopVoltage = 49;
divFactor = 3;
%-----
displayFlag = 0;
overlayDisplayFlag = 0;
pauseFlag = 0;

StrandIndices = gds.Vertices.StrandIndices;
AllVoltages = gds.Vertices.AllVoltages;
AllVerts = gds.Vertices.AllVerts;
maskSize = gds.maskSize;
numStrands = numel(gds.Strands);




% % % cutoffRadius = 2.95;
% % % cutoffVoltage = 51;
% % % % dyeSourceStrandList = TraceToCutoffRadius(vectorProject,startStrandList,cutoffRadius,cutoffVoltage);
% % % % % fileTag = '_cutoff_2p95_60_fromBasic'



fileTag = '_bareBonesSet';
dyeSourceStrandList = startStrandList;
% % whos dyeSourceStrandList

numStartStrands = numel(dyeSourceStrandList);
%sourceFlowFractionStorageList stores each strand's fraction of [flux from each startStrand]
sourceFlowFractionStorageList = zeros(numStartStrands,numel(gds.Strands));
%totalFlowFractionStorageList stores each strand's fraction of [total flux within Strand]
totalFlowFractionStorageList = zeros(numStartStrands,numel(gds.Strands));

% % % pathColorStorageList = zeros(size(AllVerts));
% % % maxFlowFractionStorageList = zeros(size(gds.Strands));
% % % associatedStartStorageList = zeros(size(gds.Strands));
% % % %-----               
% % % myColorSpace = GenerateColorSpace(numStartStrands);

allMajorRouteStrandList = [];
for startStrandIter = 1:numStartStrands;
    majorRouteStrandList = [];
    startStrandID = dyeSourceStrandList(startStrandIter);
    disp([startStrandIter, startStrandID]);
    startStrand = gds.Strands(startStrandID);
    
    %Determine voltage flow direction of start strand
    ssiv = startStrand.InteriorVertices;
    startStrandCoordList = AllVerts(ssiv,:);
    startStrandCurrent = abs(startStrand.strandCurrent);
    strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
    nodeVoltages = AllVoltages(strandNodes);
    [highVoltage,highVoltagePos] = max(nodeVoltages);
    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
    highNode = strandNodes(highVoltagePos);
    lowNode = strandNodes(strandNodes~=highNode);
    startLowVoltage = lowVoltage;
        
    if showPathFlag == 1,
        figure(77); hold off
        upLinear = linspace(0,1,256)';
        downLinear = 1-upLinear;
        upQuadratic = upLinear.^2;
        downQuadratic = downLinear.^2;
        myRedBlueColorMap = [upQuadratic,upLinear.*0,downQuadratic];
        
       
        displayedSegmentsList = startStrandID;
        p1 = plot3(startStrandCoordList(:,1),startStrandCoordList(:,2),-1*startStrandCoordList(:,3),'go');
        hold on
        plot3(0,0,0,'w.');
        plot3(1200,1300,-1400,'w.');
        axis equal
        
    end%if showPathFlag == 1,



    
    
    
    pathActiveFlagList = false(1,100000);
    pathActiveFlagList(1) = 1;
    numActivePath = sum(pathActiveFlagList);
    strandPathList = {};
    nodePathList = {};
    fractionPathList = {};
    strandPathList{1} = startStrandID;
    nodePathList{1} = [highNode lowNode];
    fractionPathList{1} = 1;
    strandFlowFractionList = zeros(numStrands,1);
    strandFlowFractionList(startStrandID) = 1;
    strandVoltageList = zeros(numStrands,1);
    strandVoltageList(1) = mean([highVoltage,lowVoltage]);
    pathCounter = 1;
    keepGoingFlag = 1;
    while (keepGoingFlag == 1),
        myCount = 0;
        for pathIter = find(pathActiveFlagList == 1);
            currentPathID = pathIter;
            currentStrandPath = strandPathList{pathIter};
            currentNodePath = nodePathList{pathIter};
            currentFractionPath = fractionPathList{pathIter};
            currentStrandID = currentStrandPath(end);
            currentStrand = gds.Strands(currentStrandID);
            %-----
            strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
            nodeVoltages = AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);
            lowAttachedStrands = StrandIndices(lowNode,:);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
            numDaughterPaths = numel(lowAttachedStrands);
            strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
            stopTracingFlag = 0;
            if numDaughterPaths == 0, stopTracingFlag = 1;; end
            if lowVoltage < stopVoltage, stopTracingFlag = 1; ; end
            if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1;;end
            if stopTracingFlag == 1,
                pathActiveFlagList(currentPathID) = 0;
            else%if stopTracingFlag == 1,
                motherCurrent = abs(currentStrand.strandCurrent);
                validDaughterCounter = 0;
                validDaughterStrandList = [];
                validDaughterCurrentList = zeros(1,numDaughterPaths);
                validDaughterPathIndexList = [];
                for daughterIter = 1:numDaughterPaths,
                    %Check to see if the daughter strand leads to a lower voltage
                    candidateDaughterID = lowAttachedStrands(daughterIter);
                    candidateDaughterStrand = gds.Strands(candidateDaughterID);
                    candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                    candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                    candidateDaughterOtherVoltage = AllVoltages(candidateDaughterOtherNode);
                    if candidateDaughterOtherVoltage < lowVoltage,
                        %if so, add the strand to a path
                        myCount = myCount + 1;
                        validDaughterCounter = validDaughterCounter + 1;
                        validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                        validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                        if validDaughterCounter == 1,
                            %if this is the first valid daughter, add to current path
                            strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                            validDaughterPathIndexList(1) = currentPathID;
                        else%if validDaughterCounter == 1,
                            %if not the first daughter, duplicate path up to this point,
                            %and
                            %make new path
                            pathCounter = pathCounter + 1;
                            strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                            fractionPathList{pathCounter} = currentFractionPath;
                            pathActiveFlagList(pathCounter) = 1;  
                            validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                        end%if-else validDaughterCounter == 1,
  
                        
                    end%if candidateDaughterOtherVoltage < lowVoltage,
                end%for daughterIter = 1:numDaughterPaths,
                clear daughterIter
                %-----
                daughterSumCurrent = sum(validDaughterCurrentList);
                fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                for validDaughterIter = 1:validDaughterCounter;
                    validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                    validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                    fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                    strandFlowFractionList(validDaughterSegmentID) = strandFlowFractionList(validDaughterSegmentID) + validDaughterFraction;
                
                                      
                    
                    
                    
                    
                    if showPathFlag==1,
                        if ~ismember(validDaughterSegmentID,displayedSegmentsList),
                            figure(77);
                            daughterStrand = gds.Strands(validDaughterSegmentID);
                            daughterCurrent = abs(daughterStrand.strandCurrent);
                            daughterPoints = daughterStrand.StartToEndIndices;
                            daughterCoordList = gds.Vertices.AllVerts(daughterPoints,:);
                            p1 = plot3(daughterCoordList(:,1),daughterCoordList(:,2),-1*daughterCoordList(:,3),'b.');
                            daughterVoltage = daughterStrand.MedianVoltage;
                            voltageColor = ceil(254*(daughterVoltage-50)/(startLowVoltage-50))+1;
                            voltageColor = min(voltageColor,254);
                            set(p1,'Color',myRedBlueColorMap(voltageColor,:));
                            set(p1,'MarkerSize',1);
                            
                            majorRouteFlag = abs(validDaughterFraction.*startStrandCurrent) > 0.5 * daughterCurrent;
                            if majorRouteFlag == 1;
                                set(p1,'Marker','o');
                                set(p1,'MarkerSize',6);
                            end%if majorRouteFlag ==1,
                            majorRouteStrandList = [majorRouteStrandList,validDaughterSegmentID];
                            hold on
                            % %                             pause
                            displayedSegmentsList = [displayedSegmentsList,validDaughterSegmentID];
                        end%if ~ismember(validDaughterSegmentID,displayedSegmentsList),
                    end
                
                    
                    
                    
                    
                
                end%for validDaughterIter = 1:validDaughterCounter;
            end%if-else stopTracingFlag == 1,
        end%for pathIter = find(pathActiveFlagList == 1);
        if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
        if myCount == 0, keepGoingFlag = 0;end
    end%while (keepGoingFlag == 1),
    %-----
    %-----
    
% %     disp('Paused');
% %     pause
    
    %Generate an flow map 
    activeStrandList = find(strandFlowFractionList>0);
    numActiveStrands = numel(activeStrandList);
    counter = 0;
    for strandIter = 1:numActiveStrands 
        thisStrandID = activeStrandList(strandIter);
        thisStrand = gds.Strands(thisStrandID);
        thisStrandFlowFraction = (strandFlowFractionList(thisStrandID));
        thisStrandCurrent = abs(thisStrand.strandCurrent);
        thisStrandFlow = startStrandCurrent * thisStrandFlowFraction;
        if thisStrandFlow > 1.01*thisStrandCurrent,
            counter = counter + 1;
        end
        thisStrandFractionFromThisSource = thisStrandFlow./(max(thisStrandFlow,thisStrandCurrent));
% if isnan(thisStrandFractionFromThisSource), keyboard,end;
        sourceFlowFractionStorageList(startStrandIter,thisStrandID) = thisStrandFlowFraction;
        totalFlowFractionStorageList(startStrandIter,thisStrandID) = thisStrandFractionFromThisSource;
    end%for strandIter = 1:numActiveStrands 
%     disp(numel(find(associatedStartStorageList>0)))
disp([0,0,counter]);
allMajorRouteStrandList{startStrandIter} = majorRouteStrandList;
end%for startStrandIter = 1:...

%%

for startStrandIter = 1:numStartStrands,
    qqq = sourceFlowFractionStorageList(startStrandIter,:);
    www = totalFlowFractionStorageList(startStrandIter,:);
    
    medianZ = median(gds.strandMidYXZList(find(www>0.01),3));
    maxZ = max(gds.strandMidYXZList(find(www>0.01),3));
    disp([startStrandIter,medianZ,maxZ])
    
    figure(1);plot(qqq(qqq>0.01),'r.');
    figure(2);plot(www(www>0.01),'b.');
    
    %Find strands that are >90% of total flow fraction
    topFlowStrandsIDList = find(www>0.9);
    nonNeglibleFlowStrandsIDList = find(www>0.1);
    midYList = gds.strandMidYXZList(topFlowStrandsIDList,1);
    midXList = gds.strandMidYXZList(topFlowStrandsIDList,2);
    midZList = gds.strandMidYXZList(topFlowStrandsIDList,3);
    cpYXZ = [median(midYList),median(midXList),median(midZList)];
    numElements = numel(nonNeglibleFlowStrandsIDList);
    distanceList = [];
    thisFlowList = [];
    for strandIter = 1:numElements;
        thisStrandID = nonNeglibleFlowStrandsIDList(strandIter);
        thisStrand = gds.Strands(thisStrandID);
        thisMidYXZ = gds.strandMidYXZList(thisStrandID,:);
        offset = thisMidYXZ-cpYXZ;
        YXDistance = sqrt(offset(1).^2 + offset(2).^2);
        distanceList(strandIter) = YXDistance;
        thisFlowList(strandIter) = www(nonNeglibleFlowStrandsIDList(strandIter));
    end
    
    figure(3);plot(distanceList,thisFlowList,'r.');       
    sideBySideList = [distanceList',thisFlowList'];
    sortSideBySide = sortrows(sideBySideList,1);
    sortedDistanceList = sortSideBySide(:,1);
    sortedFlowList = sortSideBySide(:,2);
    filtSize = min(30,max(2,ceil(numel(sortedFlowList/10))));
    myFilter = gaussian1d(filtSize,filtSize/2);
    myFilter = myFilter'./sum(myFilter);
    filtFlowList = imfilter(sortedFlowList,myFilter,'replicate');
filtFlowList = filtFlowList-min(filtFlowList);    
filtFlowList = filtFlowList./max(filtFlowList);
    myColor = [maxZ/1200, 0, 0 ];
    figure(4);plot(sortedDistanceList,filtFlowList,'g-','Color',myColor); hold on
    pause
end%for startStrandIter = 1:numStartStrands,


%%
%-------------------

%Calculate the spread from the central z at every z plane
for startStrandIter = 1:numStartStrands,
    qqq = sourceFlowFractionStorageList(startStrandIter,:);
    www = totalFlowFractionStorageList(startStrandIter,:);
    nonNeglibleFlowStrandsIDList = find(www>0.001);
    majorityFlowStrandsIDList = find(www>0.5);
    allPointIndexList = [gds.Strands(nonNeglibleFlowStrandsIDList).StartToEndIndices];
    majorityPointIndexList = [gds.Strands(majorityFlowStrandsIDList).StartToEndIndices];
    allCoords = gds.Vertices.AllVerts(allPointIndexList,:);
    majorityCoords = gds.Vertices.AllVerts(majorityPointIndexList,:);
    medianZ = median(allCoords(:,3));
    minZ = min(allCoords(:,3));
    maxZ = max(allCoords(:,3));
    allZAllMeanCoords = mean(allCoords,1);
    allZMajorityMeanCoords = mean(majorityCoords,1);
    
    disp([startStrandIter,medianZ,maxZ])
    figure(1);plot(qqq(qqq>0.01),'r.');
    figure(2);plot(www(www>0.01),'b.');
    zList = [minZ:maxZ];
    allMeanXYDistanceList = [];
    allMeanYCoordList = [];
    allMeanXCoordList = [];
    majorityMeanXYDistanceList = [];
    majorityMeanYCoordList = [];
    majorityMeanXCoordList = [];
    for zIter = 1:numel(zList);
        thisZ = zList(zIter);
        subCoords = allCoords(find(allCoords(:,3)==thisZ),:);
        meanCoords = mean(subCoords,1);
% % meanCoords = allZAllMeanCoords;
        relativeCoords = subCoords - repmat(meanCoords,[size(subCoords,1),1]);
        xyDistanceList = sqrt(sum(relativeCoords.^2,2));
        meanXYDistance = mean(xyDistanceList);
meanXYDistance = max(xyDistanceList);
        allMeanXYDistanceList(zIter) = meanXYDistance;
        allMeanYCoordList(zIter) = meanCoords(1);
        allMeanXCoordList(zIter) = meanCoords(2);
        %---
        subCoords = majorityCoords(find(majorityCoords(:,3)==thisZ),:);
        if ~isempty(subCoords),
            meanCoords = mean(subCoords,1);
% % meanCoords = allZMajorityMeanCoords;
            relativeCoords = subCoords - repmat(meanCoords,[size(subCoords,1),1]);
            xyDistanceList = sqrt(sum(relativeCoords.^2,2));
            meanXYDistance = mean(xyDistanceList);
meanXYDistance = max(xyDistanceList);
        else%if ~isempty(subCoords),
            meanCoords = [0, 0 ,0];
            meanXYDistance = 0;
        end%if-else  ~isempty(subCoords),
        majorityMeanXYDistanceList(zIter) = meanXYDistance;
        majorityMeanYCoordList(zIter) = meanCoords(1);
        majorityMeanXCoordList(zIter) = meanCoords(2);
    end%for zIter = 1:numel(zList);
    figure(5);plot(zList,allMeanYCoordList,'r.');hold on 
    figure(5);plot(zList,allMeanXCoordList,'g.');hold off
    figure(6);plot(zList,allMeanXYDistanceList,'k.');hold on
    figure(6);plot(zList,majorityMeanXYDistanceList,'m.');hold off
    pause
end%for startStrandIter = 1:numStartStrands,

%%
%Calculate distance of each strand to any XY edge
maskSize = gds.maskSize;
for strandIter = 1:numStrands,
    midPoint = gds.strandMidYXZList(strandIter,:);
    yMin = min(midPoint(1),maskSize(1)-midPoint(1));
    xMin = min(midPoint(2),maskSize(2)-midPoint(2));
    distMin = min(xMin,yMin);
    gds.strandDistanceToEdgeList(strandIter) = distMin;
end


%%
%Look at each venule tip: calculate the distribution of flow from the 
%various plunging arteriole tips (look at the contribution mode structure)

%Consider the pluningVenuleTipStrands:
thresholdDistance = 000; %Exclude from average if venule is closer than this distance from a xy edge ;
plungingVenuleTipList = gds.plungingVenuleTipList;
numVenuleTips = numel(plungingVenuleTipList);
sortAve = zeros(numStartStrands,1);
counter = 0;
for tipIter = 1:numVenuleTips,
    thisTipID = plungingVenuleTipList(tipIter);
    flowFraction = totalFlowFractionStorageList(:,thisTipID);
    distanceToEdge = gds.strandDistanceToEdgeList(thisTipID);
    thisTipStrand = gds.Strands(thisTipID);
%     disp(max(flowFraction));
    missingFraction = 1-sum(flowFraction);
    sortFraction = sort(flowFraction,'descend');
    figure(1);bar(sortFraction);
    title(['DistanceToEdge: ',num2str(distanceToEdge),' Missing Fraction : ',num2str(missingFraction)]);
    if distanceToEdge > thresholdDistance && max(sortFraction)<1,
        sortAve = sortAve+sortFraction;
        figure(2);bar(sortAve);
        counter = counter + 1;
        disp(counter);
    end
    pause
    
end

normAve = sortAve./sum(sortAve);
figure(3);bar(normAve)   
%%
%Calculate the max depth of each plunging arteriole and venule tip
plungingVenuleTipList = gds.plungingVenuleTipList;
plungingArterioleTipList = gds.plungingArterioleTipList;
numVenuleTips = numel(plungingVenuleTipList);
numArterioleTips = numel(plungingArterioleTipList);
for tipIter = 1:numVenuleTips,
    thisTipPath = gds.allPlungingVenulePathList{tipIter};
    zList = gds.strandMidYXZList(thisTipPath,3);
    plungingVenuleTipMaxZList(tipIter) = max(zList);
end
%---
for tipIter = 1:numArterioleTips,
    thisTipPath = gds.allPlungingArteriolePathList{tipIter};
    zList = gds.strandMidYXZList(thisTipPath,3);
    plungingArterioleTipMaxZList(tipIter) = max(zList);
end

%%

%Look at each venule tip: calculate the distribution of flow from the 
%various plunging arteriole tips (look at the contribution mode structure)
%and plot the xy distribution arrow graph

%Consider the pluningVenuleTipStrands:
thresholdDistance = 000; %Exclude from average if venule is closer than this distance from a xy edge ;
plungingVenuleTipList = gds.plungingVenuleTipList;
plungingArterioleTipList = gds.plungingArterioleTipList;
strandMidYXZList = gds.strandMidYXZList;
numVenuleTips = numel(plungingVenuleTipList);
sortAve = zeros(numStartStrands,1);
counter = 0;
for tipIter = 1:numVenuleTips,
    thisTipID = plungingVenuleTipList(tipIter);
    flowFraction = totalFlowFractionStorageList(:,thisTipID);
    distanceToEdge = gds.strandDistanceToEdgeList(thisTipID);
    thisTipStrand = gds.Strands(thisTipID);
    venuleCoords = strandMidYXZList(thisTipID,:);
    venuleCoords(3) = plungingVenuleTipMaxZList(tipIter);
%     disp(max(flowFraction));
    missingFraction = 1-sum(flowFraction);
    sortFraction = sort(flowFraction,'descend');
    figure(1);bar(sortFraction);
    title(['DistanceToEdge: ',num2str(distanceToEdge),' Missing Fraction : ',num2str(missingFraction)]);
    if distanceToEdge > thresholdDistance && max(sortFraction)<1,
        sortAve = sortAve+sortFraction;
        figure(2);bar(sortAve);
        counter = counter + 1;
        disp(counter);
    end
    figure(3);plot3(venuleCoords(1),venuleCoords(2),-1*venuleCoords(3),'bo');hold on
    for arterioleIter = 1:numel(flowFraction);
        thisFraction = flowFraction(arterioleIter);
        arterioleStrandID = plungingArterioleTipList(arterioleIter);
        arterioleCoords = strandMidYXZList(arterioleStrandID,:);
        arterioleCoords(3) = plungingArterioleTipMaxZList(arterioleIter);
        if tipIter == 1,
            figure(3);plot3(arterioleCoords(1),arterioleCoords(2),-1*arterioleCoords(3),'go');hold on
        end
        plotCoords = [arterioleCoords(1:3);venuleCoords(1:3)];
        colorVal = 1- (thisFraction./max(flowFraction));
        lineColor = [1 colorVal colorVal];
        if (1-colorVal) > 0.66,
            figure(3)
            p1 = plot3(plotCoords(:,1),plotCoords(:,2),-1*plotCoords(:,3),'r-');hold on
            set(p1,'Color',lineColor);
        end
    end
        
        
    
        
    
end

normAve = sortAve./sum(sortAve);
figure(4);bar(normAve)   



%%



%Analyze all major route strands at various depths

blankFrame = zeros(gds.maskSize(1),gds.maskSize(2));
zList = [100:100:1000];
for zIter = 1:numel(zList);
    zFrame = blankFrame;
    zMin = zList(zIter)-50;
    zMax = zList(zIter)+ 50;
    
    for routeIter = 1:numel(allMajorRouteStrandList),
        thisRouteList = allMajorRouteStrandList{routeIter};
        allRouteIndices = [gds.Strands(thisRouteList).StartToEndIndices];
        allRouteCoords = gds.Vertices.AllVerts(allRouteIndices,:);
        subRouteCoords = allRouteCoords(find(and(allRouteCoords(:,3)>=zMin , allRouteCoords(:,3)<zMax)), :);
        if ~isempty(subRouteCoords),
            myFrame = blankFrame;
            subRouteInd = sub2ind(size(myFrame),subRouteCoords(:,1),subRouteCoords(:,2));
            myFrame(subRouteInd) = 1;
            mycircle = circle2d(100);
            closeFrame = imclose(myFrame>0,mycircle);
            figure(4);imagesc(closeFrame);
            smallCircle = circle2d(50);
            openFrame = imopen(closeFrame>0,smallCircle);
            if max(openFrame(:))>0,
                figure(5);imagesc(openFrame);
                L = bwlabel(openFrame);

                myProps = regionprops(L,'ConvexImage','BoundingBox','Area');
                areaList = [myProps(:).Area];
                [maxArea,maxPos] = max(areaList);
                myProps = myProps(maxPos);
                
                
                L = (L==maxPos);

                convexFrame = blankFrame;
                bb = ceil(myProps.BoundingBox);
                convexFrame(bb(2):bb(2)+bb(4)-1,bb(1):bb(1)+bb(3)-1) = myProps.ConvexImage;
                
% % convexFrame = imfill(L,'holes');
                
                zFrame = zFrame + convexFrame*numel(subRouteInd)/1000;
                figure(1);imagesc(myFrame);
                figure(2);imagesc(convexFrame);
                figure(zIter+10);logpic(zFrame);
                pause(0.1);
            end%if max(openFrame(:))>0,
        end%if ~isempty(subRouteCoords)
          
        
        
        
    end%for routeIter = ...
end%for zIter = ...
    
    
    
    
    


