%Load an FV File that has already been run through ...


Strands = gds.Strands;
Vertices = gds.Vertices;
zList = [];
deltaZ = [];

numStrands = numel(Strands);
for strandIter = 1:numStrands,
    thisStrand = Strands(strandIter);
    zList(strandIter) = mean(thisStrand.YXZLimits(3,:));
    startZ = Vertices.AllVerts(thisStrand.StartVertexIndex,3);
    endZ = Vertices.AllVerts(thisStrand.EndVertexIndex,3);
    startY = Vertices.AllVerts(thisStrand.StartVertexIndex,1);
    endY = Vertices.AllVerts(thisStrand.EndVertexIndex,1);
    startX = Vertices.AllVerts(thisStrand.StartVertexIndex,2);
    endX = Vertices.AllVerts(thisStrand.EndVertexIndex,2);
    dx = endX-startX;
    dy = endY-startY;
    dr = sqrt(dx*dx+dy*dy);
    if startZ < endZ,
        deepZ = endZ;
        shallowZ = startZ;
        deepV = Vertices.AllVoltages(thisStrand.EndVertexIndex);
        shallowV = Vertices.AllVoltages(thisStrand.StartVertexIndex); 
    else
        deepZ = startZ;
        shallowZ = endZ;
        deepV = Vertices.AllVoltages(thisStrand.StartVertexIndex);
        shallowV = Vertices.AllVoltages(thisStrand.EndVertexIndex); 
    end%if startZ<endZ
    if shallowV > deepV %flow is downward
        dz = deepZ-shallowZ; %downward is positive dz
    else%if shallowV... %flow is upward
        dz = shallowZ-deepZ; %upward is negative dz;
    end
    deltaZ(strandIter) = dz;
    dL = max(abs(dz),max(dr,sqrt(dr*dr+dz*dz)));
    if dL == 0,
        zFraction(strandIter) = zFraction(strandIter-1);
    else%if dL == 0,
        zFraction(strandIter) = abs(dz)/dL;
    end%if dL == 0,
end %for strandIter


%Sort the data
allData = [zList',deltaZ',zFraction'];
sortData = sortrows(allData,1);

filterSize = 500;
sortData = imfilter(sortData,ones(filterSize,1),'symmetric')./filterSize;

sortDeltaZ = sortData(:,2);
sortZ = sortData(:,1);
sortZFraction = sortData(:,3);

figure(101);plot(sortZ,sortDeltaZ,'r.');
figure(102);plot(sortZ,sortZFraction,'b.');
    

