
rand('seed',77);

%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];



%%%Stage 2: Find the offshoots of plunging arterioles
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
startList = vectorProject.vectorizedStructure.allPlungingArterioleList;
flowProject.baseStrandIDList = startList;
flowProject.maxBranchSearch = 20;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
disp('Calculating downstream paths...');
tic
fullFlowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
toc

downstreamBranchList = fullFlowProject.downstreamBranchList;
lowestBranchOrderFromFullPlungingArterioleList = min(downstreamBranchList,[],2);

strands = vectorProject.vectorizedStructure.Strands;
numStrands = numel(strands);
for strandIter = 1:numStrands,
    strand(strandIter).lowestBranchOrderFromFullPlungingArteriole = lowestBranchOrderFromFullPlungingArterioleList(strandIter);
end
vectorProject.vectorizedStructure.Strands = strands;

