%Load an FV File that has already been run through TrackDownFromPlungingArterioleTips.m
%   and TrackDownFromPlungingVenuleTips.m

%Calculate the shortest distance from a arteriole to a venule as a function of z (depth)
%this is purely topological, and does not account for direction of flow

aList = gds.allPlungingArterioleList;
vList = gds.allPlungingVenuleList;
numA = numel(aList);
Strands = gds.Strands;
Vertices = gds.Vertices;
strandLengthList = gds.strandLengthList;
pathLengthList = [];
zList = [];

shortestPathLengthList = [];
medianPathLengthList = [];

for aIter = 1:numA;
% aIter = 79;
    pathList = [];
    forbiddenStrandList = aList;
    thisStrandID = aList(aIter);
    thisStrand = Strands(thisStrandID);
    startZ = Vertices.AllVerts(thisStrand.StartVertexIndex,3);
    endZ = Vertices.AllVerts(thisStrand.EndVertexIndex,3);
    if startZ < endZ,
        lowZ = endZ;
        lowV = Vertices.AllVoltages(thisStrand.EndVertexIndex);
        lowNeighbors = thisStrand.EndVertexNeighborStrands;
    else
        lowZ = startZ;
        lowV = Vertices.AllVoltages(thisStrand.StartVertexIndex);
        lowNeighbors = thisStrand.StartVertexNeighborStrands;        
    end%if startZ<endZ
    neighborList = lowNeighbors(~ismember(lowNeighbors,forbiddenStrandList));
    forbiddenStrandList = [forbiddenStrandList,neighborList];
    numNeighbors = numel(neighborList);
    for neighborIter = 1:numNeighbors,
        pathList{1,neighborIter} = neighborList(neighborIter);
    end
   
    %---
    
    if numNeighbors >0 ,

        stopFlag = 0;
        for depthIter = 2:15;
            pathCounter = 0;
            numPath = sum(~cellfun(@isempty,pathList(depthIter-1,:)));
            for pathIter = 1:numPath,
                thisPath = pathList{depthIter-1,pathIter};
                lastStrand = Strands(thisPath(end));
                svns = lastStrand.StartVertexNeighborStrands;
                evns = lastStrand.EndVertexNeighborStrands;
                tempNeighborList = [svns,evns];
                validNeighborList = tempNeighborList(~ismember(tempNeighborList,forbiddenStrandList));
                numValNeigh = numel(validNeighborList);
                for neighborIter = 1:numel(validNeighborList);
                    thisNeighborID = validNeighborList(neighborIter);
                    if ismember(thisNeighborID,vList);
                        %hit a target
                        pathList{depthIter-1,pathIter} = [thisPath,thisNeighborID,-999];
% % %                         foundPath = [thisPath,thisNeighborID];stopFlag = 1;break;
                    else%if ismember(thisNeighbor,vList);
                        pathCounter = pathCounter + 1;
                        pathList{depthIter,pathCounter} = [thisPath,thisNeighborID];
                        forbiddenStrandList = [forbiddenStrandList,thisNeighborID];
                    end%if ismember(thisNeighbor,vList);
                end%for neighborIter...
                if stopFlag == 1, break;end
            end%for pathIter...
            if size(pathList,1)<depthIter
                stopFlag = 1;
                foundPath = [1 1 1];
            end%if size(pathList,1)<depthIter

            if stopFlag == 1, break;end
        end%for depthIter
    else%if numNeighbors>0,
        foundPath = [1 1 1];
    end%if numNeighbors>0

    %Calculate the shortest path found (using break commands to exit loops)
      
    
    allConnectedPathLengthList = [];
    for pathListIter = 1:numel(pathList),
        if ismember(-999,pathList{pathListIter})
            foundPath = pathList{pathListIter};
            thisPathLength =  sum(strandLengthList(foundPath(1:end-1)));
            allConnectedPathLengthList = [allConnectedPathLengthList , thisPathLength];
        end%if ismember...
    end%for pathListIter = 

    
    if isempty(allConnectedPathLengthList), allConnectedPathLengthList = [0 0 0];end
        
    shortestPathLengthList(aIter) = min(allConnectedPathLengthList);
    medianPathLengthList(aIter) = median(allConnectedPathLengthList);
    zList(aIter) = lowZ;
    
end%for aIter
    

figure(1);plot(zList,shortestPathLengthList,'r.');
    
    
    