% % 
% % cd('F:\Phil\VectorProjects')
% % load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')


pause
pause
pause




%Convert the vectorizedStructure to a segments and nodes structure for the dijkstra algorithm
vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
firstDash = findstr(vectorProjectRootName,'-');
shortName = vectorProjectRootName(1:firstDash(1)-1);

strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allJP = vertices.JunctionPoints;
strandIndices = vertices.StrandIndices;
strandIndices = full(strandIndices);
strandLabelList = [strands(:).MedianLabel];

avDataStruct = [];
aaDataStruct = [];
vvDataStruct = [];

nodes = allVerts(allJP,:);
nodes = [(1:size(nodes,1))',nodes];
nodeList = find(allJP);

segments = [];
for nodeIter = 1:numel(nodeList)
    thisNodeID = nodeIter;
    thisNodeIndex = nodeList(nodeIter);
    attachedStrands = strandIndices(thisNodeIndex,:);
    attachedStrands = attachedStrands(attachedStrands~=0);
    startIndex = [strands(attachedStrands).StartVertexIndex];
    endIndex = [strands(attachedStrands).EndVertexIndex];
    bothIndex = [startIndex,endIndex];
    attachedNodeIndexList = bothIndex(bothIndex~=thisNodeIndex);
    attachedNodeIDList = find(ismember(nodeList,attachedNodeIndexList));
    newSegmentList = [repmat(thisNodeID,size(attachedNodeIDList)),attachedNodeIDList];
    orderFlag = newSegmentList(:,1)<newSegmentList(:,2);
    subSegmentList = newSegmentList(orderFlag,:);
    segments = [segments;subSegmentList];
end%for nodeIter

fullSegments = [(1:size(segments,1))',segments];

%%
%Remove the plunging strands and the surface strands from the segment list
removePlungingArteriolesFlag = 0;
removePlungingVenulesFlag = 1;
removeSurfaceVesselsFlag = 1;

allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;

s1 = fullSegments(:,2);
s2 = fullSegments(:,3);

removeList = [];
if removePlungingArteriolesFlag == 1,
    for aIter = 1:numel(allPlungingArterioleList),
        thisStrandID = allPlungingArterioleList(aIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for aIter
end%if removePlungingArterioleFlag == 1,
    
if removePlungingVenulesFlag == 1,
    for vIter = 1:numel(allPlungingVenuleList),
        thisStrandID = allPlungingVenuleList(vIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for vIter
end%if removePlungingVenulesFlag == 1,

if removeSurfaceVesselsFlag == 1,
    surfaceStrandList = find(ismember(strandLabelList,[300:399]));
    for sIter = 1:numel(surfaceStrandList);
        thisStrandID = surfaceStrandList(sIter);
        thisStrand = strands(thisStrandID);
        startVertex = thisStrand.StartVertexIndex;
        endVertex = thisStrand.EndVertexIndex;
        f1 = find(nodeList==startVertex);
        f2 = find(nodeList==endVertex);
        if and(~isempty(f1),~isempty(f2)),
            ff1 = min(f1,f2);
            ff2 = max(f1,f2);
            fs = find(and(s1==ff1,s2==ff2));
            removeList = [removeList,fs];
        end%if...
    end%for sIter
end%if removeSurfaceVesselsFlag == 1,


keepInd = ~ismember(fullSegments(:,1),removeList);        
segments = fullSegments(keepInd,2:3);
segments = [(1:size(segments,1))',segments];
    


%%

allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;

allArterioleStrandList = [allPlungingArteriolePathList{:}];
allVenuleStrandList = [allPlungingVenulePathList{:}];

allArterioleVertexList = unique([strands(allArterioleStrandList).StartVertexIndex,strands(allArterioleStrandList).EndVertexIndex]);
allArterioleNodeList = find(ismember(nodeList,allArterioleVertexList));
allVenuleVertexList = unique([strands(allVenuleStrandList).StartVertexIndex,strands(allVenuleStrandList).EndVertexIndex]);
allVenuleNodeList = find(ismember(nodeList,allVenuleVertexList));


numArterioles = numel(allPlungingArteriolePathList);
numVenules = numel(allPlungingVenulePathList);

numArterioleNodes = numel(allArterioleNodeList);
numVenuleNodes = numel(allVenuleNodeList);

%Generate a list of all nodes on each plunging arteriole
plungingArterioleNodeList = [];
for paIter = 1:numArterioles,
    thisArterioleStrandList = allPlungingArteriolePathList{paIter};
    thisArterioleVertexList = unique([strands(thisArterioleStrandList).StartVertexIndex,strands(thisArterioleStrandList).EndVertexIndex]);
    thisArterioleNodeList = find(ismember(nodeList,thisArterioleVertexList));
    plungingArterioleNodeList{paIter} = thisArterioleNodeList;
end

%Generate a reverse lookup table of nodes to plunging arterioles
aNodeToPlungingLUT = [];
for aNodeIter = 1:numArterioleNodes,
    thisANode = allArterioleNodeList(aNodeIter);
    for paIter = 1:numArterioles,
        thisPAList = plungingArterioleNodeList{paIter};
        if ismember(thisANode,thisPAList),
            aNodeToPlungingLUT(aNodeIter) = paIter;
            break%break out of paIter loop
        end%if ismember
    end%for paIter
end%for aNodeIter



%Generate a list of all nodes on each plunging venule
plungingVenuleNodeList = [];
for pvIter = 1:numVenules,
    thisVenuleStrandList = allPlungingVenulePathList{pvIter};
    thisVenuleVertexList = unique([strands(thisVenuleStrandList).StartVertexIndex,strands(thisVenuleStrandList).EndVertexIndex]);
    thisVenuleNodeList = find(ismember(nodeList,thisVenuleVertexList));
    plungingVenuleNodeList{pvIter} = thisVenuleNodeList;
end

%Generate a reverse lookup table of nodes to plunging venules
vNodeToPlungingLUT = [];
for vNodeIter = 1:numVenuleNodes,
    thisVNode = allVenuleNodeList(vNodeIter);
    for pvIter = 1:numVenules,
        thisPVList = plungingVenuleNodeList{pvIter};
        if ismember(thisVNode,thisPVList),
            vNodeToPlungingLUT(vNodeIter) = pvIter;
            break%break out of pvIter loop
        end%if ismember
    end%for pvIter
end%for vNodeIter


%%
%Pick an arteriole.
%Find all the outlets of that arteriole
%Find the shortest path to all venule inlet from any of these outlet
%Figure out which venule(including all its inlets) is the shortest path from the arteriole
%Figure out which venule is second closest
%Follow the shortest path, reevaluate the distance to the second closest from each
%intermediate step
%Plot that distance as a function of distance along the original shortest path
%Expect monotonic increase for Model 1
%Excpect bowl shape for Model 2


%Pick an arteriole
avDataStruct = [];
maxSep = 250;


for arterioleIter = 1:44;
    disp(['arteriole ',num2str(arterioleIter),' of ', num2str(numArterioles)]);
                
    
    
    keepGoingFlag = 1;
    while keepGoingFlag == 1;

        %Find all the outlets of that arteriole
        nodesOnThisArteriole = allArterioleNodeList(find(aNodeToPlungingLUT == arterioleIter));
        numNodesOnThisArteriole = numel(nodesOnThisArteriole);

        
        
        
if numNodesOnThisArteriole>5,
    disp('Cropping nodes!!!');
  nodesOnThisArteriole = nodesOnThisArteriole(1:5);
  numNodesOnThisArteriole = numel(nodesOnThisArteriole);
end
        



        if numNodesOnThisArteriole>0,

            %Find the shortest path to all venule inlets from any of these arteriole outlets
            avShortestPathList = [];
            avShortestDistList = [];
            for aNodeIter = 1 : numNodesOnThisArteriole,
                disp(['aNode ',num2str(aNodeIter),' of ', num2str(numNodesOnThisArteriole)]);
                
                tic
                thisANodeData = [];
                thisArterioleNode = nodesOnThisArteriole(aNodeIter)
                aNodeCoord = nodes(thisArterioleNode,2:4);
                shortestPathList = [];
                shortestDistList = [];
                maxPath = 25;
                for vNodeIter = 1:numVenuleNodes,
                    thisVenuleNode = allVenuleNodeList(vNodeIter);
                    vNodeCoord = nodes(thisVenuleNode,2:4);
                    sep = sqrt(sum(((aNodeCoord(1:2)-vNodeCoord(1:2)).^2),2));
                    thisANodeData(vNodeIter).aNode = thisArterioleNode;
                    thisANodeData(vNodeIter).aNodeCoord = aNodeCoord;
                    thisANodeData(vNodeIter).vNode = thisVenuleNode;
                    thisANodeData(vNodeIter).vNodeCoord = vNodeCoord;
                    thisANodeData(vNodeIter).xySep = sep;
                    thisANodeData(vNodeIter).shortestDist = [998];
                    thisANodeData(vNodeIter).strandPath = [];
                    if sep < maxSep,
            %             [dist,shortestPath] = dijkstra(nodes,segments,thisArterioleNode,thisVenuleNode);
                        [dist,shortestPath] = dijkstra_phil(nodes,segments,thisArterioleNode,thisVenuleNode,maxPath);
                        if ~isinf(dist),
                            shortestPathLength = numel(shortestPath);
                            shortestPathList = [shortestPathList,shortestPathLength];
                            shortestDistList = [shortestDistList,dist];
                            maxPath = 2*min([shortestPathList,maxPath/2]);
                            if dist<900,
                                numNodesInPath = numel(shortestPath);
                                strandPath = [];
                                for segmentIter = 1:numNodesInPath-1,
                                    nodeA = shortestPath(segmentIter);
                                    nodeB = shortestPath(segmentIter+1);
                                    vertexA = nodeList(nodeA);
                                    vertexB = nodeList(nodeB);
                                    strandSetA = strandIndices(vertexA,:);
                                    strandSetA = strandSetA(strandSetA~=0);
                                    strandSetB = strandIndices(vertexB,:);
                                    strandSetB = strandSetB(strandSetB~=0);
                                    doubletFlag = ismember(strandSetA,strandSetB);
                                    doubletStrand = strandSetA(doubletFlag);
                                    thisPathStrand = doubletStrand(1);
                                    strandPath(segmentIter) = thisPathStrand;
                                end%for segmentIter
                                %---
                                thisANodeData(vNodeIter).shortestDist = dist;
                                thisANodeData(vNodeIter).strandPath = strandPath;
                                thisANodeData(vNodeIter).nodePath = shortestPath;
                            end%if dist<900
                        end%if ~isinf(dist)
                    end%if sep<maxSep

                end%for vNodeIter
                [minVal,minPos] = min(shortestDistList);
                shortestPathHere = shortestPathList(minPos(1))
                avShortestPathList = [avShortestPathList,min(shortestPathList)]
                avShortestDistList = [avShortestDistList,min(shortestDistList)]
                avDataStruct{aNodeIter} = thisANodeData;
                toc
                pause(0.01);
            end%for aNodeIter....






            %%%%%
            %Figure out which venule(including all its inlets) is the shortest path from the arteriole
            %%%%%

            %Find the nearest Venule for each outlet
            allANodeMinDistList = [];
            allANodeMinPosList = [];
            allANodeNearestVNodeList = [];

            for aNodeIter = 1:numNodesOnThisArteriole,
                thisANodeData = avDataStruct{aNodeIter};
                distList = [thisANodeData(:).shortestDist];
                vNodeList = [thisANodeData(:).vNode];
                [minVal,minPos] = min(distList);
                allANodeMinDistList(aNodeIter) = minVal;
                allANodeMinPosList(aNodeIter) = minPos(1);
                allANodeNearestVNodeList(aNodeIter) = vNodeList(minPos(1));
            end%for aNodeIter...


            %Find the overall nearest venule across all outlets
            [minVal,minPos] = min(allANodeMinDistList);
            nearestNode = allANodeNearestVNodeList(minPos(1));
            nearestVNodeID = find(allVenuleNodeList == nearestNode);
            pathPos = allANodeMinPosList(minPos(1));
            nearestVenuleID = vNodeToPlungingLUT(nearestVNodeID);
            nearestPairANode = nodesOnThisArteriole(minPos(1));
            nearestAVDataStruct = avDataStruct{minPos(1)};
            nearestPath = nearestAVDataStruct(pathPos).nodePath;

            if numel(nearestPath)<2, 
                disp('BREAK - nearestPath<2');
                keepGoingFlag = 0; 
                break; %break out of while loop
            end
            
            %Find all the inlets of that venule
            nodesOnNearestVenule = allVenuleNodeList(find(vNodeToPlungingLUT == nearestVenuleID));
            numNodesOnNearestVenule = numel(nodesOnNearestVenule);


            %%%%%
            %Figure out which venule is second closest
            %%%%%

            allANodeNextMinDistList = [];
            allANodeNextMinPosList = [];
            allANodeNextNearestVNodeList = [];

            for aNodeIter = 1:numNodesOnThisArteriole,
                thisANodeData = avDataStruct{aNodeIter};
                distList = [thisANodeData(:).shortestDist];
                vNodeList = [thisANodeData(:).vNode];
                excludeFlag = ismember(vNodeList,nodesOnNearestVenule);
                includeFlag = ~excludeFlag;
                includeIndList = find(includeFlag);
                subDistList = distList(includeFlag);
                subvNodeList = vNodeList(includeFlag);
                [minVal,minPos] = min(subDistList);
                allANodeNextMinDistList(aNodeIter) = minVal;
                allANodeNextMinPosList(aNodeIter) = includeIndList(minPos(1));
                allANodeNextNearestVNodeList(aNodeIter) = subvNodeList(minPos(1));
            end%for aNodeIter...

            %Find the overall second nearest venule across all outlets
            [minVal,minPos] = min(allANodeNextMinDistList);
            nextNearestNode = allANodeNextNearestVNodeList(minPos(1));
            nextNearestVNodeID = find(allVenuleNodeList == nextNearestNode);
            nextPathPos = allANodeNextMinPosList(minPos(1));
            nextNearestVenuleID = vNodeToPlungingLUT(nextNearestVNodeID);
            nextNearestPairANode = nodesOnThisArteriole(minPos(1));
            nextNearestAVDataStruct = avDataStruct{minPos(1)};
            nextNearestPath = nextNearestAVDataStruct(nextPathPos).nodePath;

            
            if numel(nextNearestPath)<2, 
                disp('BREAK - nextNearestPath<2');
                keepGoingFlag = 0; 
                break; %break out of while loop
            end
            
            %Find all the inlets of that venule
            nodesOnNextNearestVenule = allVenuleNodeList(find(vNodeToPlungingLUT == nextNearestVenuleID));
            numNodesOnNextNearestVenule = numel(nodesOnNextNearestVenule);



            %%%%%
            %Figure out which venule is third closest
            %%%%%

            allANodeThirdMinDistList = [];
            allANodeThirdMinPosList = [];
            allANodeThirdNearestVNodeList = [];

            for aNodeIter = 1:numNodesOnThisArteriole,
                thisANodeData = avDataStruct{aNodeIter};
                distList = [thisANodeData(:).shortestDist];
                vNodeList = [thisANodeData(:).vNode];
                excludeFlag = ismember(vNodeList,[nodesOnNearestVenule;nodesOnNextNearestVenule]);
                includeFlag = ~excludeFlag;
                includeIndList = find(includeFlag);
                subDistList = distList(includeFlag);
                subvNodeList = vNodeList(includeFlag);
                [minVal,minPos] = min(subDistList);
                allANodeThirdMinDistList(aNodeIter) = minVal;
                allANodeThirdMinPosList(aNodeIter) = includeIndList(minPos(1));
                allANodeThirdNearestVNodeList(aNodeIter) = subvNodeList(minPos(1));
            end%for aNodeIter...

            %Find the overall second nearest venule across all outlets
            [minVal,minPos] = min(allANodeThirdMinDistList);
            
            if minVal>888,
                disp('BREAK - noThirdNearest');
                keepGoingFlag =0;
                break%break out of while loop
            end%%if minVal>888,
            
            thirdNearestNode = allANodeThirdNearestVNodeList(minPos(1));
            thirdNearestVNodeID = find(allVenuleNodeList == thirdNearestNode);
            thirdPathPos = allANodeThirdMinPosList(minPos(1));
            thirdNearestVenuleID = vNodeToPlungingLUT(thirdNearestVNodeID);
            thirdNearestPairANode = nodesOnThisArteriole(minPos(1));
            thirdNearestAVDataStruct = avDataStruct{minPos(1)};
            thirdNearestPath = thirdNearestAVDataStruct(thirdPathPos).nodePath;
            
            if numel(thirdNearestPath)<2, 
                disp('BREAK - thirdNearestPath<2');
                keepGoingFlag = 0; 
                break; %break out of while loop
            end
            
            %Find all the inlets of that venule
            nodesOnThirdNearestVenule = allVenuleNodeList(find(vNodeToPlungingLUT == thirdNearestVenuleID));
            numNodesOnThirdNearestVenule = numel(nodesOnThirdNearestVenule);




            %%%%%
            %Figure out which venule is fourth closest
            %%%%%

            allANodeFourthMinDistList = [];
            allANodeFourthMinPosList = [];
            allANodeFourthNearestVNodeList = [];

            for aNodeIter = 1:numNodesOnThisArteriole,
                thisANodeData = avDataStruct{aNodeIter};
                distList = [thisANodeData(:).shortestDist];
                vNodeList = [thisANodeData(:).vNode];
                excludeFlag = ismember(vNodeList,[nodesOnNearestVenule;nodesOnNextNearestVenule;nodesOnThirdNearestVenule]);
                includeFlag = ~excludeFlag;
                includeIndList = find(includeFlag);
                subDistList = distList(includeFlag);
                subvNodeList = vNodeList(includeFlag);
                [minVal,minPos] = min(subDistList);
                allANodeFourthMinDistList(aNodeIter) = minVal;
                allANodeFourthMinPosList(aNodeIter) = includeIndList(minPos(1));
                allANodeFourthNearestVNodeList(aNodeIter) = subvNodeList(minPos(1));
            end%for aNodeIter...

            %Find the overall second nearest venule across all outlets
            [minVal,minPos] = min(allANodeFourthMinDistList);
            
            if minVal>888,
                disp('BREAK - noFourthNearest');
                keepGoingFlag =0;
                break%break out of while loop
            end%%if minVal>888,
            
            fourthNearestNode = allANodeFourthNearestVNodeList(minPos(1));
            fourthNearestVNodeID = find(allVenuleNodeList == fourthNearestNode);
            fourthPathPos = allANodeFourthMinPosList(minPos(1));
            fourthNearestVenuleID = vNodeToPlungingLUT(fourthNearestVNodeID);
            fourthNearestPairANode = nodesOnThisArteriole(minPos(1));
            fourthNearestAVDataStruct = avDataStruct{minPos(1)};
            fourthNearestPath = fourthNearestAVDataStruct(fourthPathPos).nodePath;
            
            if numel(fourthNearestPath)<2, 
                disp('BREAK - fourthNearestPath<2');
                keepGoingFlag = 0; 
                break; %break out of while loop
            end

            %Find all the inlets of that venule
            nodesOnFourthNearestVenule = allVenuleNodeList(find(vNodeToPlungingLUT == fourthNearestVenuleID));
            numNodesOnFourthNearestVenule = numel(nodesOnFourthNearestVenule);











            %%%%%
            %Follow the shortest path, reevaluate the distance to the second closest from each
            %intermediate step
            %%%%%

            numPathSteps = numel(nearestPath);
            alongNextDist = [];
            alongNextPath = [];
            alongThirdDist = [];
            alongThirdPath = [];
            alongFourthDist = [];
            alongFourthPath = [];
            for pathIter = 1:numPathSteps,
                startNode = nearestPath(pathIter);
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nextNearestNode,50);
                alongNextDist(pathIter) = dist;
                alongNextPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,thirdNearestNode,50);
                alongThirdDist(pathIter) = dist;
                alongThirdPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,fourthNearestNode,50);
                alongFourthDist(pathIter) = dist;
                alongFourthPath{pathIter} = shortestPath;

            end%for pathIter...

            %%%%%
            %Plot that distance as a function of distance along the original shortest path
            %%%%%
            figure(12); plot(alongNextDist,'r-');
            figure(13); plot(alongThirdDist,'g-');
            figure(14); plot(alongFourthDist,'b-');

            p12{arterioleIter} = alongNextDist;
            p13{arterioleIter} = alongThirdDist;
            p14{arterioleIter} = alongFourthDist;



            %%%%%
            %Follow the second nearest path
            %%%%%


            numPathSteps = numel(nextNearestPath);
            alongADist = [];
            alongAPath = [];
            alongBDist = [];
            alongBPath = [];
            alongCDist = [];
            alongCPath = [];
            for pathIter = 1:numPathSteps,
                startNode = nextNearestPath(pathIter);
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nearestNode,50);
                alongADist(pathIter) = dist;
                alongAPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,thirdNearestNode,50);
                alongBDist(pathIter) = dist;
                alongBPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,fourthNearestNode,50);
                alongCDist(pathIter) = dist;
                alongCPath{pathIter} = shortestPath;

            end%for pathIter...
            figure(21);plot(alongADist,'k-');
            figure(23);plot(alongBDist,'k-');
            figure(24);plot(alongCDist,'k-');

            p21{arterioleIter} = alongADist;
            p23{arterioleIter} = alongBDist;
            p24{arterioleIter} = alongCDist;



             %%%%%
            %Follow the third nearest path
            %%%%%


            numPathSteps = numel(thirdNearestPath);
            alongADist = [];
            alongAPath = [];
            alongBDist = [];
            alongBPath = [];
            alongCDist = [];
            alongCPath = [];
            for pathIter = 1:numPathSteps,
                startNode = thirdNearestPath(pathIter);
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nearestNode,50);
                alongADist(pathIter) = dist;
                alongAPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nextNearestNode,50);
                alongBDist(pathIter) = dist;
                alongBPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,fourthNearestNode,50);
                alongCDist(pathIter) = dist;
                alongCPath{pathIter} = shortestPath;

            end%for pathIter...
            figure(31);plot(alongADist,'k-');
            figure(32);plot(alongBDist,'k-');
            figure(34);plot(alongCDist,'k-');

            p31{arterioleIter} = alongADist;
            p32{arterioleIter} = alongBDist;
            p34{arterioleIter} = alongCDist;




                %%%%%
            %Follow the fourth nearest path
            %%%%%


            numPathSteps = numel(fourthNearestPath);
            alongADist = [];
            alongAPath = [];
            alongBDist = [];
            alongBPath = [];
            alongCDist = [];
            alongCPath = [];
            for pathIter = 1:numPathSteps,
                startNode = fourthNearestPath(pathIter);
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nearestNode,50);
                alongADist(pathIter) = dist;
                alongAPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,nextNearestNode,50);
                alongBDist(pathIter) = dist;
                alongBPath{pathIter} = shortestPath;
                %---
                [dist,shortestPath] = dijkstra_phil(nodes,segments,startNode,thirdNearestNode,50);
                alongCDist(pathIter) = dist;
                alongCPath{pathIter} = shortestPath;

            end%for pathIter...
            figure(41);plot(alongADist,'k-');
            figure(42);plot(alongBDist,'k-');
            figure(43);plot(alongCDist,'k-');

            p41{arterioleIter} = alongADist;
            p42{arterioleIter} = alongBDist;
            p43{arterioleIter} = alongCDist;



            %%%%%
            %Expect monotonic increase for Model 1
            %%%%%

            %%%%%
            %Excpect bowl shape for Model 2
            %%%%%


            counter = 0;
            figure(99);hold off;
            for aIter = 1:numel(p43),
                q43 = p43{aIter};
                if ~isempty(q43),
                    counter = counter+1;
                    tempVar = [];
                    tempVar{1} = p12{aIter};
                    tempVar{2} = p13{aIter};
                    tempVar{3} = p14{aIter};
                    tempVar{4} = p21{aIter};
                    tempVar{5} = p23{aIter};
                    tempVar{6} = p24{aIter};
                    tempVar{7} = p31{aIter};
                    tempVar{8} = p32{aIter};
                    tempVar{9} = p34{aIter};
                    tempVar{10} = p41{aIter};
                    tempVar{11} = p42{aIter};
                    tempVar{12} = p43{aIter};


                    for kk = 1:12,
                        tempLine = tempVar{kk};
                        numSteps = numel(tempLine);
                        normLine = tempLine./tempLine(1);
                        stepPos = linspace(0,1,numSteps);
                        figure(99);plot(stepPos,normLine,'k-');hold on
                    end
                end%if ~ismepty...
            end%for aIter...

        end%if numNodeOnThisArteriole>0
        
        keepGoingFlag = 0;
        
    end%while keepGoingFlag==1,
            
end%for arterioleIter...        
    
    
    
    
   