%Calculate Stream Convergence (are branches diverging or converging)

%Load an FV file



numStrands = numel(vectorProject.vectorizedStructure.Strands);
convergenceValueList = zeros(1,numStrands);
nodeValueList = zeros(size(vectorProject.vectorizedStructure.Vertices.AllVoltages))-999;


for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = vectorProject.vectorizedStructure.Strands(thisStrandID);
    startVoltage = vectorProject.vectorizedStructure.Vertices.AllVoltages(thisStrand.StartVertexIndex);
    endVoltage = vectorProject.vectorizedStructure.Vertices.AllVoltages(thisStrand.EndVertexIndex);
    if startVoltage > endVoltage,
        lowerVoltage = endVoltage;
        lowerNeighbors = thisStrand.EndVertexNeighborStrands;
        nodeID = thisStrand.EndVertexIndex;
    else
        lowerVoltage = startVoltage;
        lowerNeighbors = thisStrand.StartVertexNeighborStrands;
        nodeID = thisStrand.StartVertexIndex;
    end

    lowerNeighbors = lowerNeighbors(lowerNeighbors~=thisStrandID);

    if numel(lowerNeighbors>0),
        neighborVoltages = [vectorProject.vectorizedStructure.Strands(lowerNeighbors).MedianVoltage];
        numHigherNeighbors = sum(neighborVoltages>lowerVoltage);
        numLowerNeighbors = sum(neighborVoltages<lowerVoltage);
        numInputs = numHigherNeighbors+1;
        numOutputs = numLowerNeighbors;
        nodeValueList(nodeID) = numOutputs-numInputs;
    end
    %---
    dbl = vectorProject.vectorizedStructure.downstreamBranchList(thisStrandID,:);
    branchNumber = min(min(dbl),999);
    branchNumberList(thisStrandID) = branchNumber;
end%for strandIter;
delta = nodeValueList(nodeValueList~=-999);%positive = more outputs than inputs(divergent)
zList = vectorProject.vectorizedStructure.Vertices.AllVerts(nodeValueList~=-999);
myData = [zList,delta];
sortData = sortrows(myData,1);
filtSize = 2000;
filtData = imfilter(sortData,ones(filtSize,1),'replicate')./filtSize;
sortZ = filtData(:,1);
sortCD = filtData(:,2);
figure(1);plot(sortZ,sortCD,'r.');






yLim1 = 400;
yLim2 = 600;
xLim1 = 400;
xLim2 = 600;
zLim1 = 0;
zLim2 = 600;


fY = and(meanYXZ(:,1)>yLim1,meanYXZ(:,1)<yLim2);
fX = and(meanYXZ(:,1)>zLim1,meanYXZ(:,1)<xLim2);
fZ = and(meanYXZ(:,1)>zLim1,meanYXZ(:,1)<zLim2);
fYXZ = and(and(fY,fX),fZ);
subBranchNumberList = branchNumberList(fYXZ);
subConvergenceValueList = convergenceValueList(fYXZ);
subStrands = [vectorProject.vectorizedStructure.Strands(fYXZ)];
maxBranchVal = max(branchNumberList(branchNumberList<999));





for branchIter = 1:maxBranchVal,
    ff1 = find(subBranchNumberList==branchIter);
    meanConvergenceList(branchIter) = mean(subConvergenceValueList(ff1));
    meanVoltageList(branchIter) = mean([subStrands(ff1).MedianVoltage]);
end

figure(1);plot(meanConvergenceList,'b-');
figure(2);plot(meanVoltageList,'r-');
figure(3);plot(subBranchNumberList+rand(size(subBranchNumberList))-0.5,[subStrands.MedianVoltage],'r.');
figure(4);plot(subBranchNumberList+rand(size(subBranchNumberList))-0.5,subConvergenceValueList+rand(size(subBranchNumberList))-0.5,'b.');

    



