%Open a FV file in FlowVisualizer,
%use "global gds" to access the gds,
%Set gds.baseStrandIDList = gds.allPlungingArterioleList
%Recalculate the flow, and then run code below

%%
global gds
gds.baseStrandIDList = gds.allPlungingArterioleList;
RecaculateDownStreamAndUpstreamPaths
q = gds.downstreamBranchList;
q2 = (q==1);
q3 = max(q2,[],2);
q4 = find(q3);
f4 = ismember(q4,gds.baseStrandIDList);
f5 = q4(~f4);
myZ = gds.strandMidYXZList(f5,3);
figure(96);plot(myZ,'r.')
zRange = [0:100:2000];
hz = hist(myZ,zRange);
figure(97);bar(zRange,hz);
xlabel('Depth from surface [um]');
ylabel('Number of plunging arteriole outlets');
cumsumhz = cumsum(hz);
figure(197);plot(zRange,cumsumhz./max(cumsumhz));


%%

%%%use "global gds" to access the gds,
%Set gds.baseStrandIDList = gds.allPlungingArterioleList
%Recalculate the flow, and then run code below


%%
global gds
gds.baseStrandIDList = gds.allPlungingVenuleList;
RecaculateDownStreamAndUpstreamPaths
q = gds.upstreamBranchList;
q2 = (q==1);
q3 = max(q2,[],2);
q4 = find(q3);
f4 = ismember(q4,gds.baseStrandIDList);
f5 = q4(~f4);
myZ = gds.strandMidYXZList(f5,3);
figure(98);plot(myZ,'r.')
zRange = [0:100:2000];
hz = hist(myZ,zRange);
figure(99);bar(zRange,hz);
xlabel('Depth from surface [um]');
ylabel('Number of plunging venule inlets');
cumsumhz = cumsum(hz);
figure(199);plot(zRange,cumsumhz./max(cumsumhz));


