vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorProject.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allRadii = vertices.AllRadii;
strandIndices = full(vertices.StrandIndices);

bufferSize = 100;
largeBufferEdge = maskSize-[bufferSize,bufferSize,bufferSize];

insideFlag1 = sum(allVerts > repmat([ bufferSize, bufferSize, bufferSize],[size(allVerts,1),1]),2)==3;
insideFlag2 = sum(allVerts < repmat([largeBufferEdge],[size(allVerts,1),1]),2)==3;
insideFlag = and(insideFlag1,insideFlag2);

siSub = strandIndices(insideFlag,:);

si4 = find(siSub(:,4) ~=0);
si3 = find(siSub(:,3) ~=0);
si2 = find(siSub(:,2) ~=0);

maxConnectedRadiusList = [];
maxConnectedLabelList = [];
for si4Iter = 1:numel(si4);
    thisSI = si4(si4Iter);
    connectedStrands = siSub(thisSI,:);
    connectedStrands = connectedStrands(connectedStrands~=0);
    csLabel = [strands(connectedStrands).MedianLabel];
    csRadii = [strands(connectedStrands).MedianRadius];
    maxConnectedRadiusList(si4Iter) = max(csRadii);
    maxConnectedLabelList(si4Iter) = max(csLabel);
end



figure(1);plot(maxConnectedLabelList,'r.');

%%
y1 = 600;
y2 = 700;

insideFlag = and(allVerts(:,1)>y1,allVerts(:,1)<y2);
siSub = strandIndices(insideFlag,:);
si4 = find(siSub(:,4) ~=0);
si3 = find(siSub(:,3) ~=0);
si2 = find(siSub(:,2) ~=0);
subVerts = allVerts(insideFlag,:);
si4Verts = subVerts(si4,:);
paVerts = subVerts(ismember([strands(siSub(:,1)).MedianLabel],[430:439]),:);
pvVerts = subVerts(ismember([strands(siSub(:,1)).MedianLabel],[440:449]),:);

maxConnectedRadiusList = [];
maxConnectedLabelList = [];
for si4Iter = 1:numel(si4);
    thisSI = si4(si4Iter);
    connectedStrands = siSub(thisSI,:);
    connectedStrands = connectedStrands(connectedStrands~=0);
    csLabel = [strands(connectedStrands).MedianLabel];
    csRadii = [strands(connectedStrands).MedianRadius];
    maxConnectedRadiusList(si4Iter) = max(csRadii);
    maxConnectedLabelList(si4Iter) = max(csLabel);
end




figure(2);plot3(subVerts(:,1),subVerts(:,2),-subVerts(:,3),'k.');hold on
figure(2);plot3(paVerts(:,1),paVerts(:,2),-paVerts(:,3),'r.');hold on
figure(2);plot3(pvVerts(:,1),pvVerts(:,2),-pvVerts(:,3),'b.');hold on
figure(2);plot3(si4Verts(:,1),si4Verts(:,2),-si4Verts(:,3),'go');
hold off
axis equal

q = si4Verts;
q(:,1) = si4Verts(:,2);
q(:,2) = si4Verts(:,1);
disp([q,maxConnectedRadiusList'*1000]);


