vectorizedStructure = vectorProject.vectorizedStructure;
vertices = vectorizedStructure.Vertices;
strands = vectorizedStructure.Strands;
allVerts = vertices.AllVerts;
numStrands = numel(strands);
allLabels = vertices.AllLabels;

medianLabelList = zeros(numStrands,1);
for strandIter = 1:numStrands;
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    labelList = allLabels(stei);
    medianLabelList(strandIter) = median(labelList);
end

surfaceArteryList = find(ismember(medianLabelList,[330:339]));
surfaceVeinList = find(ismember(medianLabelList,[340:349]));

badConnectPointList = [];
for arteryIter = 1:numel(surfaceArteryList);
    thisArteryID = surfaceArteryList(arteryIter);
    thisArtery = strands(thisArteryID);
    endVertexNeighbors = thisArtery.EndVertexNeighborStrands;
    endVertexNeighborLabels = medianLabelList(endVertexNeighbors);
    startVertexNeighbors = thisArtery.StartVertexNeighborStrands;
    startVertexNeighborLabels = medianLabelList(startVertexNeighbors);
    badConnect = find(ismember(endVertexNeighborLabels,[340:349]));
    if ~isempty(badConnect),
        badConnectPointList = [badConnectPointList;thisArtery.EndVertexIndex];
    end%if ~isempty(badConnect);
    badConnect = find(ismember(startVertexNeighborLabels,[340:349]));
    if ~isempty(badConnect),
        badConnectPointList = [badConnectPointList;thisArtery.StartVertexIndex];
    end%if ~isempty(badConnect);
end

badCoords = allVerts(unique(badConnectPointList),:)

    






