% % % % % %This script takes all the plunging artery tops and clots them one-by-one
% % % % % %and compares the flow downstream to the non-clot flow.
% % % % % %In this version, the main line of the plunging arteriole is identified
% % % % % %and branch counting starts OFF of that line.
% % % % % 
% % % % % %Instructions:
% % % % % %Load allProject
% % % % % 
% % % % % vectorProject = allProject.db;
% % % % % strands = vectorProject.vectorizedStructure.Strands;
% % % % % vertices = vectorProject.vectorizedStructure.Vertices;
% % % % % maskSize = vectorProject.vectorizedStructure.maskSize;
% % % % % flowAnalysisParameters = [];
% % % % % cleanupFlag = 1;
% % % % % 
% % % % % 
% % % % % 
% % % % % 
% % % % % 
% % % % % %%Stage 2: Run the unperturbed flow analysis:
% % % % % unperturbedProject = vectorProject;
% % % % % unperturbedProject.circuitAnalysisParameters.minRadius = 0;
% % % % % unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);
% % % % % disp('UnPerturbed Flow Calculation completed');
% % % % % 
% % % % % 
% % % % % 
%%
%%Stage 3: Select a vessel segment to occlude
tipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
allPlungingArteriolePathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;
numTips = numel(tipList);

% % % % % selectedTips = [1796,1918,5296,354,1591,1218];
% % % % % selectedTips = [3429 2909 1475 955];%shallower
% % % % % selectedTips = [855 5859];%mid-deep?
% % % % selectedTips = [1263 2056];%deeper
% % % % selectedTips = 1123;
% % % ff = find(ismember(tipList,selectedTips));
% % % tipList = tipList(ff);
% % % allPlungingArteriolePathList = allPlungingArteriolePathList(ff);
% % % numTips = numel(tipList);

%%
%Set limits on analysis field of view
y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

% y1 = 300; y2 = maskSize(1)-y1;
% x1 = 300; x2 = maskSize(2)-x1;
z1 = 0; z2 = 500;


analyzeDownstreamBranchesOnlyFlag = 1;
considerOnlyBranchesInFOVFlag = 1;
ignoreLowStartingCurrentStrandsFlag = 0;
thresholdCurrentForStall = 0;
maxBranch = 15;



allTipMedianCurrentRatioList = [];
allRatioList =[]; allRatioList{maxBranch} = [];
allPreCurrentList =[]; allPreCurrentList{maxBranch} = [];
allPostCurrentList =[]; allPostCurrentList{maxBranch} = [];

f1 = figure(1); set(f1,'DoubleBuffer','on');clf
f2 = figure(2); set(f2,'DoubleBuffer','on');clf

tipCounter = 0;
allTipMedianCurrentRatioList = [];
allRatioList =[]; allRatioList{maxBranch} = [];
allPreCurrentList =[]; allPreCurrentList{maxBranch} = [];
allPostCurrentList =[]; allPostCurrentList{maxBranch} = [];
crossingPointList = [];
medianOffShootZList = [];
for tipIter = 1:numTips,

    disp(['TIP ITER ',num2str(tipIter)]);
    occlusionStrandID = tipList(tipIter)
    origRadius = vectorProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID);
    pathList = allPlungingArteriolePathList{tipIter};
    pathCoords = vectorProject.vectorizedStructure.strandMidYXZList(pathList,:)
    maxPathCoords = max(pathCoords,[],1);
    minPathCoords = min(pathCoords,[],1);
    insideFlag = 1;
    
    if minPathCoords(1)<y1, insideFlag = 0;end
    if minPathCoords(2)<x1, insideFlag = 0;end
    if maxPathCoords(1)>y2, insideFlag = 0;end
    if maxPathCoords(2)>x2, insideFlag = 0;end
    
    %Consider branches off the clotted plunging arteriole line
    flowProject.maskSize = unperturbedProject.vectorizedStructure.maskSize;
    flowProject.Strands = unperturbedProject.vectorizedStructure.Strands;
    flowProject.Vertices = unperturbedProject.vectorizedStructure.Vertices;
    flowProject.baseStrandIDList = pathList;
    flowProject.maxBranchSearch = 2;
    flowProject.stopVoltage = 50.1;%Hardcode;
    flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
    disp('Finding arteriole outlets paths...');
    flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
    arterioleOffshootList = find(min(flowProject.downstreamBranchList,[],2)==1);
    numArterioleOffshoots = numel(arterioleOffshootList);
    downstreamBranchList = flowProject.downstreamBranchList;
    arterioleOffshootList = arterioleOffshootList(~ismember(arterioleOffshootList,vectorProject.vectorizedStructure.allPlungingArterioleList));
    offshootZ = vectorProject.vectorizedStructure.strandMidYXZList(arterioleOffshootList,3);
    medianOffshootZ = median(offshootZ);
    arterioleOffshootList = arterioleOffshootList(and(offshootZ>z1,offshootZ<z2))
    if isempty(arterioleOffshootList), insideFlag = 0; end
        if insideFlag == 1,
            perturbedProject = vectorProject;
            perturbedProject.circuitAnalysisParameters.minRadius = 0;
            perturbedProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID) = 0;
                perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
            disp('Perturbed Flow Calculation completed');
            origCurrentList = [unperturbedProject.vectorizedStructure.Strands(:).strandCurrent];
            perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
% % %         perturbedCurrentList(abs(perturbedCurrentList)<thresholdCurrentForStall) = 0;
            lowCurrentStrandList = find(origCurrentList < thresholdCurrentForStall);
            currentRatioList = abs(perturbedCurrentList./origCurrentList);


            switch analyzeDownstreamBranchesOnlyFlag,
                case 1 %analyze only downstream branches
                    flowProject.baseStrandIDList = arterioleOffshootList;
                    flowProject.maxBranchSearch = maxBranch;
                    flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
                    downstreamBranchList = flowProject.downstreamBranchList;
                    offshootRatio = currentRatioList(arterioleOffshootList);
                    allRatioList{1} = offshootRatio;
                    allPreCurrentList{1} = origCurrentList(arterioleOffshootList);
                    allPostCurrentList{1} = perturbedCurrentList(arterioleOffshootList);
                    
                    branchClassList = [1:maxBranch];
                    medianCurrentRatioList = [];
                    medianCurrentRatioList(1) = median(offshootRatio);
                    for branchIter = 2:maxBranch,
                        findBranch = find(sum(downstreamBranchList==(branchIter-1),2)>0);
                        findBranch = findBranch(~ismember(findBranch,pathList));
                        if considerOnlyBranchesInFOVFlag == 1,
                            branchCoordList = vectorProject.vectorizedStructure.strandMidYXZList(findBranch,:);
                            branchListZ = branchCoordList(:,3);
                            f1 = and(branchCoordList(:,1)>y1,branchCoordList(:,1)<y2);
                            f2 = and(branchCoordList(:,2)>x1,branchCoordList(:,2)<x2);
                            f3 = and(branchCoordList(:,3)>z1,branchCoordList(:,3)<z2);
                            ff = and(and(f1,f2),f3);
                            findBranch = findBranch(ff);
                        end%if considerOnly...
                        crl = currentRatioList(findBranch);
                        if ignoreLowStartingCurrentStrandsFlag == 1,
                            crl = crl(~ismember(crl,lowCurrentStrandList));
                        end%if ignoreLow...
                        allRatioList{branchIter} = [allRatioList{branchIter},crl];
                        allPreCurrentList{branchIter} = [allPreCurrentList{branchIter},origCurrentList(findBranch)];
                        allPostCurrentList{branchIter} = [allPostCurrentList{branchIter},perturbedCurrentList(findBranch)];

                        figure(1);p1 = plot(repmat(branchIter,size(crl)),crl,'bo');hold on
                        figure(2);p2 = plot(repmat(branchIter,size(crl)),crl,'bo');hold on
                        figure(3);p2 = plot(repmat(branchIter,size(branchListZ)),branchListZ,'go');
                        medianCurrentRatioList(branchIter) = median(crl);
                    end%for branchIter;
                    figure(1);plot(branchClassList,medianCurrentRatioList,'r-');
                    set(gca,'YLim',[0,2]);
                    figure(2);plot(branchClassList,medianCurrentRatioList,'r-');hold off
                    set(gca,'YLim',[0,2]);
                    
                case 0 %analyze all branches regardless of flow direction
                    flowProject.baseStrandIDList = arterioleOffshootList;
                    flowProject.maxBranchSearch = maxBranch;
                    flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
                    downstreamBranchList = flowProject.downstreamBranchList;
                    offshootRatio = currentRatioList(arterioleOffshootList);
                    allRatioList{1} = offshootRatio;
                    allPreCurrentList{1} = origCurrentList(arterioleOffshootList);
                    allPostCurrentList{1} = perturbedCurrentList(arterioleOffshootList);
                    
                    alreadyUsedList = [pathList,arterioleOffshootList'];
                    nextStrandList = [strands(arterioleOffshootList).StartVertexNeighborStrands,strands(arterioleOffshootList).EndVertexNeighborStrands];
                    nextStrandList = nextStrandList(~ismember(nextStrandList,alreadyUsedList));
                    branchClassList = [1:maxBranch];
                    medianCurrentRatioList = [];
                    medianCurrentRatioList(1) = median(offshootRatio);
                    for branchIter = 2:maxBranch,
                        findBranch = nextStrandList;
                        alreadyUsedList = [alreadyUsedList,findBranch];
                        if considerOnlyBranchesInFOVFlag == 1,
                            branchCoordList = vectorProject.vectorizedStructure.strandMidYXZList(findBranch,:);
                            branchListZ = branchCoordList(:,3);
                            f1 = and(branchCoordList(:,1)>y1,branchCoordList(:,1)<y2);
                            f2 = and(branchCoordList(:,2)>x1,branchCoordList(:,2)<x2);
                            f3 = and(branchCoordList(:,3)>z1,branchCoordList(:,3)<z2);
                            ff = and(and(f1,f2),f3);
                            findBranch = findBranch(ff);
                        end%if considerOnly...
                        crl = currentRatioList(findBranch);
                        if ignoreLowStartingCurrentStrandsFlag == 1,
                            crl = crl(~ismember(crl,lowCurrentStrandList));
                        end%if ignoreLow...
                        allRatioList{branchIter} = [allRatioList{branchIter},crl];
                        allPreCurrentList{branchIter} = [allPreCurrentList{branchIter},origCurrentList(findBranch)];
                        allPostCurrentList{branchIter} = [allPostCurrentList{branchIter},perturbedCurrentList(findBranch)];

                        figure(1);p1 = plot(repmat(branchIter,size(crl)),crl,'bo');hold on
                        figure(2);p2 = plot(repmat(branchIter,size(crl)),crl,'bo');hold on
                        figure(3);p2 = plot(repmat(branchIter,size(branchListZ)),branchListZ,'go');hold on
                        nonNanCRL = crl(~isnan(crl));
                        medianCurrentRatioList(branchIter) = median(nonNanCRL);
                        %---
                        nextStrandList = [strands(nextStrandList).StartVertexNeighborStrands,strands(nextStrandList).EndVertexNeighborStrands];
                        nextStrandList = nextStrandList(~ismember(nextStrandList,alreadyUsedList));
                    
                        
                    end%for branchIter;
                    figure(1);plot(branchClassList,medianCurrentRatioList,'r-');
                    set(gca,'YLim',[0,2]);
                    figure(2);plot(branchClassList,medianCurrentRatioList,'r-');hold off
                    set(gca,'YLim',[0,2]);
                    
            end%switch-case
            tipCounter = tipCounter +1;
            allTipMedianCurrentRatioList(tipCounter,:) = medianCurrentRatioList;
            
            
            above75 = find(medianCurrentRatioList>0.75);
            if ~isempty(above75),
                if above75(1)>1,
                    q2 = above75(1);
                    q1 = above75(1)-1;
                    q3 = q1+((0.75-medianCurrentRatioList(q1))/(medianCurrentRatioList(q2)-medianCurrentRatioList(q1)));
                    crossingPointList(tipCounter) =  q3;
                else%if above75(1)>1
                    crossingPointList(tipCounter) = 1;
                end%if above75(1)>1
            else%if isempty(above75),
                crossingPointList(tipCounter) = maxBranch
            end%if isempty
            medianOffShootZList(tipCounter) = medianOffshootZ;
            
            figure(9);plot(medianOffShootZList,crossingPointList,'ro');
            
            pause(0.1);


    
    
    

    

     
                    
        
        


        %---

        
        
        
        %Here, branchClass1 is actually 1 and 2 branches downstream, then 2 = 3, etc.
  

    end%if insideFlag == 1,
end%for tipIter..

for kk = 1:maxBranch,
    q = allTipMedianCurrentRatioList(:,kk);
    q2 = q(~isnan(q));
    q2m = median(q2);
    q(isnan(q)) = q2m;
    allTipMedianCurrentRatioList(:,kk) = q;
end
medianOfMedianCurrentRatioList = median(allTipMedianCurrentRatioList,1);
figure(2);plot(branchClassList,medianOfMedianCurrentRatioList);

fullMedianList = [];
for branchIter = 1:maxBranch,
    q = allRatioList{branchIter};
    q2 = q(~isnan(q));
    q2m = median(q2);
    q(isnan(q)) = q2m;
    fullMedianList(branchIter) = median(q);
end%branchIter
figure(3);plot(branchClassList,fullMedianList,'g-');

    
    
