
%Instructions:
%Load an -flow Project file.
% wacko


alpha = 0.2;
myChoice = 16;


strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
strandLengthList = vectorProject.vectorizedStructure.strandLengthList;
baseStrandIDList = vectorProject.vectorizedStructure.plungingArterioleTipList;
effectiveStrandRadiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList;



numBaseStrands = numel(baseStrandIDList);
numStrands = numel(strands);
numVertices = numel(vertices.AllRadii);
tofStruct = []; %timeOfFlight dataStruct
tofStruct(numStrands).currentList = [];
tofStruct(numStrands).startTimeList = [];


maxBranchSearch = 30;%Hardcode
stopVoltage = 50.1;%Hardcode;
minimumFluxFraction = 1/300000;%Hardcode

downstreamPathList = [];
downstreamBranchList = zeros(numStrands,numel(baseStrandIDList)) + Inf;
transitTimeList = zeros(numStrands,1);

for baseStrandIter = 1:numBaseStrands;
    endTimeList = zeros(numStrands,1);
    baseStrandID = baseStrandIDList(baseStrandIter);
    baseStrand = strands(baseStrandID);
    bsiv = baseStrand.InteriorVertices;
    baseStrandCoordList = vertices.AllVerts(bsiv,:);
    strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
    nodeVoltages = vertices.AllVoltages(strandNodes);
    [highVoltage,highVoltagePos] = max(nodeVoltages);
    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
    highNode = strandNodes(highVoltagePos);
    lowNode = strandNodes(strandNodes~=highNode);

    pathActiveFlagList = false(1,100000);
    pathActiveFlagList(1) = 1;
    numActivePath = sum(pathActiveFlagList);
    strandPathList = {};
    nodePathList = {};
    fractionPathList = {};
    strandPathList{1} = baseStrandID;
    nodePathList{1} = [highNode lowNode];
    fractionPathList{1} = 1;
    strandFlowList = zeros(numStrands,1);
    strandFlowList(baseStrandID) = 1;
    strandVoltageList = zeros(numStrands,1);
    strandVoltageList(1) = mean([highVoltage,lowVoltage]);
    pathCounter = 1;
    keepGoingFlag = 1;
    branchCounter = 0;
    %---
    baseStrandCurrent = abs(baseStrand.strandCurrent);
    strandRadius = effectiveStrandRadiusList(baseStrandID);
    tofStruct(baseStrandID).currentList = baseStrandCurrent;
    tofStruct(baseStrandID).startTimeList = 0;
    strandLength = strandLengthList(baseStrandID);
    timeOfFlight = strandLength*(strandRadius.^2/baseStrandCurrent);
% % timeOfFlight = strandLength/baseStrandCurrent;


    transitTimeList(baseStrandID) = timeOfFlight;
    endTimeList(baseStrandID) = timeOfFlight;

    while (keepGoingFlag == 1),
        myCount = 0;
        branchCounter = branchCounter+1;
        for pathIter = find(pathActiveFlagList == 1);
            currentPathID = pathIter;
            currentStrandPath = strandPathList{pathIter};
            currentNodePath = nodePathList{pathIter};
            currentFractionPath = fractionPathList{pathIter};
            currentStrandID = currentStrandPath(end);
            currentStrand = strands(currentStrandID);
            %-----
            strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
            nodeVoltages = vertices.AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);
            lowAttachedStrands = vertices.StrandIndices(lowNode,:);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
            numDaughterPaths = numel(lowAttachedStrands);
            strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
            stopTracingFlag = 0;
            if numDaughterPaths == 0, stopTracingFlag = 1; end
            if lowVoltage < stopVoltage, stopTracingFlag = 1; end
            if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
            if stopTracingFlag == 1,
                pathActiveFlagList(currentPathID) = 0;
            else%if stopTracingFlag == 1,
                motherCurrent = abs(currentStrand.strandCurrent);
                validDaughterCounter = 0;
                validDaughterStrandList = [];
                validDaughterCurrentList = zeros(1,numDaughterPaths);
                validDaughterPathIndexList = [];
                for daughterIter = 1:numDaughterPaths,
                    %Check to see if the daughter strand leads to a lower voltage
                    candidateDaughterID = lowAttachedStrands(daughterIter);
                    candidateDaughterStrand = strands(candidateDaughterID);
                    candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                    candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                    candidateDaughterOtherVoltage = vertices.AllVoltages(candidateDaughterOtherNode);
                    if candidateDaughterOtherVoltage < lowVoltage,
                        %if so, add the strand to a path
                        myCount = myCount + 1;
                        validDaughterCounter = validDaughterCounter + 1;
                        validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                        validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                        if validDaughterCounter == 1,
                            %if this is the first valid daughter, add to current path
                            strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                            validDaughterPathIndexList(1) = currentPathID;
                        else%if validDaughterCounter == 1,
                            %if not the first daughter, duplicate path up to this point, and
                            %make new path
                            pathCounter = pathCounter + 1;
                            strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                            fractionPathList{pathCounter} = currentFractionPath;
                            pathActiveFlagList(pathCounter) = 1;  
                            validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                        end%if-else validDaughterCounter == 1,
                    end%if candidateDaughterOtherVoltage < lowVoltage,
                end%for daughterIter = 1:numDaughterPaths,
                clear daughterIter
                %-----
                daughterSumCurrent = sum(validDaughterCurrentList);
                fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                for validDaughterIter = 1:validDaughterCounter;
                    validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                    validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                    fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                    strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    
                    
                    strandRadius = effectiveStrandRadiusList(validDaughterSegmentID);
                    currentList = [tofStruct(validDaughterSegmentID).currentList, baseStrandCurrent .* validDaughterFraction];
                    tofStruct(validDaughterSegmentID).currentList = currentList;
                    thisDaughterCurrent = abs(strands(validDaughterSegmentID).strandCurrent);
                    thisMotherEndTime = endTimeList(currentStrandID);
                    strandLength = strandLengthList(validDaughterSegmentID);
                    timeOfFlight = strandLength*(strandRadius.^2)/thisDaughterCurrent;
% timeOfFlight = strandLength/thisDaughterCurrent;
                    
                    velocityMultiplier = 1e-6;
                    assumedDensity = 1e-2; %rbc per um3 (assuming 1x7x7 cell, and 50% hematocrit)
                    %strand velocity in um/sec (expect ~500 - 1000um/s for small vessels)
                    strandVelocity = velocityMultiplier * thisDaughterCurrent./((pi*strandRadius^2)*assumedDensity);
                    timeOfFlight = strandLength./strandVelocity;
                    strandVelocityList(validDaughterSegmentID) = strandVelocity;

                                        
                    thisDaughterEndTime = thisMotherEndTime + timeOfFlight;
                    transitTimeList(validDaughterSegmentID) = timeOfFlight;
                    startTimeList = [tofStruct(validDaughterSegmentID).startTimeList, thisMotherEndTime];
                    tofStruct(validDaughterSegmentID).startTimeList = startTimeList;
                    endTimeList(validDaughterSegmentID) = thisDaughterEndTime;
                    

                    
                end%for validDaughterIter = 1:validDaughterCounter;
            end%if-else stopTracingFlag == 1,
        end%for pathIter = find(pathActiveFlagList == 1);
        if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
        if myCount == 0, keepGoingFlag = 0;end
        if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
    end%while (keepGoingFlag == 1),
    downstreamPathList{baseStrandIter} = strandPathList;
    disp(baseStrandIter)
end%for baseStrandIter = 1:numBaseStrands;

for baseStrandIter = 1:numBaseStrands;
    thisPathSet = downstreamPathList{baseStrandIter};
    for pathIter = 1:numel(thisPathSet),
        thisPath = thisPathSet{pathIter};
        thisPath = thisPath(2:end);
        posList = [1:numel(thisPath)]';
        downstreamBranchList(thisPath,baseStrandIter) = min(downstreamBranchList(thisPath,baseStrandIter),posList);
    end%for pathIter = 1:numel(thisPathSet);
end%for baseStrandIter = ...

figure(41);plot(strandVelocityList,'g.');
xlabel('Strand ID #');ylabel('estimated RBC velocity [um/s]');


%%


meanBloodOx = zeros(1,numStrands);
for kk = 1:numStrands,
    startTimeList = tofStruct(kk).startTimeList;
    currentList = tofStruct(kk).currentList;
% %     if isempty(startTimeList),startTimeList = 0;end
% %     q(kk) = min(startTimeList);
    fractionCurrent(kk) = abs(sum(currentList)./strands(kk).strandCurrent);
    bloodOx = exp(-alpha*startTimeList);
    normCurrentList = currentList./sum(currentList);
    meanBloodOx(kk) = sum(bloodOx.*normCurrentList);
    strands(kk).meanBloodOx = meanBloodOx(kk);
    meanYXZList(kk,1) = mean(strands(kk).YXZLimits(1,:));
    meanYXZList(kk,2) = mean(strands(kk).YXZLimits(2,:));
    meanYXZList(kk,3) = mean(strands(kk).YXZLimits(3,:));    
    meanVoltage = strands(kk).MedianVoltage;
    meanZ(kk) = meanYXZList(kk,3);
end

vectorProject.vectorizedStructure.Strands = strands;

meanVoltage = [strands.MedianVoltage];
figure(1);plot(meanVoltage,meanBloodOx,'r.');
xlabel('mean Voltage');ylabel('meanBloodOx');
figure(2);plot(meanZ,meanBloodOx,'r.');
xlabel('mean Z depth');ylabel('meanBloodOx');

unperturbedProject = vectorProject;
unperturbedCurrent = abs([unperturbedProject.vectorizedStructure.Strands(:).strandCurrent]);
unperturbedBloodOx = meanBloodOx;


%%
%%Stage 3: Select a vessel segment to occlude
tipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
numTips = numel(tipList);


occlusionStrandID = tipList(myChoice)
origRadius = vectorProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID)

%Stage 4: Calculate the perturbed flow surface vessel endpoints are held at fixed
%           voltages (100 and 50) using effect Strand Radii & true lengths

perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID) = 0;


perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
disp('Perturbed Flow Calculation completed');



vectorProject = perturbedProject;

%%
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
strandLengthList = vectorProject.vectorizedStructure.strandLengthList;
baseStrandIDList = vectorProject.vectorizedStructure.plungingArterioleTipList;
effectiveStrandRadiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList;



numBaseStrands = numel(baseStrandIDList);
numStrands = numel(strands);
numVertices = numel(vertices.AllRadii);
tofStruct = []; %timeOfFlight dataStruct
tofStruct(numStrands).currentList = [];
tofStruct(numStrands).startTimeList = [];


maxBranchSearch = 30;%Hardcode
stopVoltage = 50.1;%Hardcode;
minimumFluxFraction = 1/300000;%Hardcode

downstreamPathList = [];
downstreamBranchList = zeros(numStrands,numel(baseStrandIDList)) + Inf;
transitTimeList = zeros(numStrands,1);

for baseStrandIter = 1:numBaseStrands;
    endTimeList = zeros(numStrands,1);
    baseStrandID = baseStrandIDList(baseStrandIter);
    baseStrand = strands(baseStrandID);
    bsiv = baseStrand.InteriorVertices;
    baseStrandCoordList = vertices.AllVerts(bsiv,:);
    strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
    nodeVoltages = vertices.AllVoltages(strandNodes);
    [highVoltage,highVoltagePos] = max(nodeVoltages);
    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
    highNode = strandNodes(highVoltagePos);
    lowNode = strandNodes(strandNodes~=highNode);

    pathActiveFlagList = false(1,100000);
    pathActiveFlagList(1) = 1;
    numActivePath = sum(pathActiveFlagList);
    strandPathList = {};
    nodePathList = {};
    fractionPathList = {};
    strandPathList{1} = baseStrandID;
    nodePathList{1} = [highNode lowNode];
    fractionPathList{1} = 1;
    strandFlowList = zeros(numStrands,1);
    strandFlowList(baseStrandID) = 1;
    strandVoltageList = zeros(numStrands,1);
    strandVoltageList(1) = mean([highVoltage,lowVoltage]);
    pathCounter = 1;
    keepGoingFlag = 1;
    branchCounter = 0;
    %---
    baseStrandCurrent = abs(baseStrand.strandCurrent);
    strandRadius = effectiveStrandRadiusList(baseStrandID);
    tofStruct(baseStrandID).currentList = baseStrandCurrent;
    tofStruct(baseStrandID).startTimeList = 0;
    strandLength = strandLengthList(baseStrandID);
    timeOfFlight = strandLength*(strandRadius.^2/baseStrandCurrent);
% % timeOfFlight = strandLength/baseStrandCurrent;


    transitTimeList(baseStrandID) = timeOfFlight;
    endTimeList(baseStrandID) = timeOfFlight;

    while (keepGoingFlag == 1),
        myCount = 0;
        branchCounter = branchCounter+1;
        for pathIter = find(pathActiveFlagList == 1);
            currentPathID = pathIter;
            currentStrandPath = strandPathList{pathIter};
            currentNodePath = nodePathList{pathIter};
            currentFractionPath = fractionPathList{pathIter};
            currentStrandID = currentStrandPath(end);
            currentStrand = strands(currentStrandID);
            %-----
            strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
            nodeVoltages = vertices.AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);
            lowAttachedStrands = vertices.StrandIndices(lowNode,:);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
            numDaughterPaths = numel(lowAttachedStrands);
            strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
            stopTracingFlag = 0;
            if numDaughterPaths == 0, stopTracingFlag = 1; end
            if lowVoltage < stopVoltage, stopTracingFlag = 1; end
            if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
            if stopTracingFlag == 1,
                pathActiveFlagList(currentPathID) = 0;
            else%if stopTracingFlag == 1,
                motherCurrent = abs(currentStrand.strandCurrent);
                validDaughterCounter = 0;
                validDaughterStrandList = [];
                validDaughterCurrentList = zeros(1,numDaughterPaths);
                validDaughterPathIndexList = [];
                for daughterIter = 1:numDaughterPaths,
                    %Check to see if the daughter strand leads to a lower voltage
                    candidateDaughterID = lowAttachedStrands(daughterIter);
                    candidateDaughterStrand = strands(candidateDaughterID);
                    candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                    candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                    candidateDaughterOtherVoltage = vertices.AllVoltages(candidateDaughterOtherNode);
                    if candidateDaughterOtherVoltage < lowVoltage,
                        %if so, add the strand to a path
                        myCount = myCount + 1;
                        validDaughterCounter = validDaughterCounter + 1;
                        validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                        validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                        if validDaughterCounter == 1,
                            %if this is the first valid daughter, add to current path
                            strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                            validDaughterPathIndexList(1) = currentPathID;
                        else%if validDaughterCounter == 1,
                            %if not the first daughter, duplicate path up to this point, and
                            %make new path
                            pathCounter = pathCounter + 1;
                            strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                            fractionPathList{pathCounter} = currentFractionPath;
                            pathActiveFlagList(pathCounter) = 1;  
                            validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                        end%if-else validDaughterCounter == 1,
                    end%if candidateDaughterOtherVoltage < lowVoltage,
                end%for daughterIter = 1:numDaughterPaths,
                clear daughterIter
                %-----
                daughterSumCurrent = sum(validDaughterCurrentList);
                fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                for validDaughterIter = 1:validDaughterCounter;
                    validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                    validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                    fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                    strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    
                    
                    strandRadius = effectiveStrandRadiusList(validDaughterSegmentID);
                    currentList = [tofStruct(validDaughterSegmentID).currentList, baseStrandCurrent .* validDaughterFraction];
                    tofStruct(validDaughterSegmentID).currentList = currentList;
                    thisDaughterCurrent = abs(strands(validDaughterSegmentID).strandCurrent);
                    thisMotherEndTime = endTimeList(currentStrandID);
                    strandLength = strandLengthList(validDaughterSegmentID);
                    timeOfFlight = strandLength*(strandRadius.^2)/thisDaughterCurrent;
% timeOfFlight = strandLength/thisDaughterCurrent;
                    
                    velocityMultiplier = 1e-6;
                    assumedDensity = 1e-2; %rbc per um3 (assuming 1x7x7 cell, and 50% hematocrit)
                    %strand velocity in um/sec (expect ~500 - 1000um/s for small vessels)
                    strandVelocity = velocityMultiplier * thisDaughterCurrent./((pi*strandRadius^2)*assumedDensity);
                    timeOfFlight = strandLength./strandVelocity;
                    strandVelocityList(validDaughterSegmentID) = strandVelocity;

                                        
                    thisDaughterEndTime = thisMotherEndTime + timeOfFlight;
                    transitTimeList(validDaughterSegmentID) = timeOfFlight;
                    startTimeList = [tofStruct(validDaughterSegmentID).startTimeList, thisMotherEndTime];
                    tofStruct(validDaughterSegmentID).startTimeList = startTimeList;
                    endTimeList(validDaughterSegmentID) = thisDaughterEndTime;
                    

                    
                end%for validDaughterIter = 1:validDaughterCounter;
            end%if-else stopTracingFlag == 1,
        end%for pathIter = find(pathActiveFlagList == 1);
        if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
        if myCount == 0, keepGoingFlag = 0;end
        if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
    end%while (keepGoingFlag == 1),
    downstreamPathList{baseStrandIter} = strandPathList;
    disp(baseStrandIter)
end%for baseStrandIter = 1:numBaseStrands;

for baseStrandIter = 1:numBaseStrands;
    thisPathSet = downstreamPathList{baseStrandIter};
    for pathIter = 1:numel(thisPathSet),
        thisPath = thisPathSet{pathIter};
        thisPath = thisPath(2:end);
        posList = [1:numel(thisPath)]';
        downstreamBranchList(thisPath,baseStrandIter) = min(downstreamBranchList(thisPath,baseStrandIter),posList);
    end%for pathIter = 1:numel(thisPathSet);
end%for baseStrandIter = ...

figure(41);plot(strandVelocityList,'g.');
xlabel('Strand ID #');ylabel('estimated RBC velocity [um/s]');


%%


meanBloodOx = zeros(1,numStrands);
for kk = 1:numStrands,
    startTimeList = tofStruct(kk).startTimeList;
    currentList = tofStruct(kk).currentList;
% %     if isempty(startTimeList),startTimeList = 0;end
% %     q(kk) = min(startTimeList);
    fractionCurrent(kk) = abs(sum(currentList)./strands(kk).strandCurrent);
    bloodOx = exp(-alpha*startTimeList);
    normCurrentList = currentList./sum(currentList);
    meanBloodOx(kk) = sum(bloodOx.*normCurrentList);
    strands(kk).meanBloodOx = meanBloodOx(kk);
    meanYXZList(kk,1) = mean(strands(kk).YXZLimits(1,:));
    meanYXZList(kk,2) = mean(strands(kk).YXZLimits(2,:));
    meanYXZList(kk,3) = mean(strands(kk).YXZLimits(3,:));    
    meanVoltage = strands(kk).MedianVoltage;
    meanZ(kk) = meanYXZList(kk,3);
end

vectorProject.vectorizedStructure.Strands = strands;

meanVoltage = [strands.MedianVoltage];
figure(1);plot(meanVoltage,meanBloodOx,'r.');
xlabel('mean Voltage');ylabel('meanBloodOx');
figure(2);plot(meanZ,meanBloodOx,'r.');
xlabel('mean Z depth');ylabel('meanBloodOx');

perturbedProject = vectorProject;
perturbedCurrent = abs([perturbedProject.vectorizedStructure.Strands(:).strandCurrent]);
perturbedBloodOx = meanBloodOx;

vectorProject = unperturbedProject;
%%
figure(61);plot(unperturbedBloodOx,perturbedBloodOx,'r.');
xlabel('Unperturbed Est. Blood ox');
ylabel('Single Arteriole Occlusion Est. Blood ox');
figure(62);plot(unperturbedCurrent,perturbedCurrent,'g.');
xlabel('Unperturbed Strand Flux');
ylabel('Single Arteriole Occlusion Strand Flux');





