

strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
numTips = length(stallMatrix);
stallRatioList = myParameters.stallRatioList;
stopCountingNumStalls = myParameters.stopCountingNumStalls;
numStallRatio = length(stallRatioList);


arterioleTipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
venuleTipList = vectorProject.vectorizedStructure.plungingVenuleTipList;

arterioleCurrentList = abs([strands(arterioleTipList).strandCurrent]);
venuleCurrentList = abs([strands(venuleTipList).strandCurrent]);

figure(1);plot(arterioleCurrentList,'r.');hold on
figure(1);plot(venuleCurrentList,'b.');hold off


load('IterateDamageFromSingleOcclusionResults.mat')
volumePerStrand = prod(maskSize)/numel(strands);
arterioleCystDiameter = [];
numTips = numel(stallMatrix);
for tipIter = 1:numTips,
    for stallRatioIter = 1:numStallRatio,
        stallCurves = stallMatrix{tipIter};
        if ~isempty(stallCurves),
            thisCurve = stallCurves(stallRatioIter,:);
            maxStalls = max(thisCurve);
            cystVol = maxStalls * volumePerStrand;
            arterioleCystDiameter(tipIter,stallRatioIter) = 2*(cystVol*(0.75/pi))^0.333;
        end%if ~isempty
    end%for stallRatioIter
end%for tipIter

load('IterateDamageFromSingleOcclusionVenuleResults.mat')
volumePerStrand = prod(maskSize)/numel(strands);
venuleCystDiameter = [];
numTips = numel(stallMatrix);
for tipIter = 1:numTips,
    for stallRatioIter = 1:numStallRatio,
        stallCurves = stallMatrix{tipIter};
        thisCurve = stallCurves(stallRatioIter,:);
        maxStalls = max(thisCurve);
        cystVol = maxStalls * volumePerStrand;
        venuleCystDiameter(tipIter,stallRatioIter) = 2*(cystVol*(0.75/pi))^0.333;
    end
end



aCyst = arterioleCystDiameter(:,4)';
vCyst = venuleCystDiameter(:,4)';

figure(2);plot(arterioleCurrentList,aCyst,'r.');hold on
figure(2);plot(venuleCurrentList,vCyst,'b.');hold off


     
     





                