
% cd('F:\Phil\VectorProjects')
% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')
% 

pause
pause
pause

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allJP = vertices.JunctionPoints;
strandIndices = vertices.StrandIndices;
strandIndices = full(strandIndices);
strandLabelList = [strands(:).MedianLabel];

% % 
% % allLabels = vertices.AllLabels;
% % strandIndices = vertices.StrandIndices;
% % 
% % allPlungingPointFlag = ismember(allLabels,[400:499]);
% % allStrandLabelList = [strands(:).MedianLabel];
% % allPlungingStrandList = find(ismember(allStrandLabelList,[400:499]));
% % allLabels(allPlungingPointFlag) = 115;
% 

nodes = allVerts(allJP,:);
nodes = [(1:size(nodes,1))',nodes];
nodeList = find(allJP);

segments = [];
for nodeIter = 1:numel(nodeList)
    thisNodeID = nodeIter;
    thisNodeIndex = nodeList(nodeIter);
    attachedStrands = strandIndices(thisNodeIndex,:);
    attachedStrands = attachedStrands(attachedStrands~=0);
    startIndex = [strands(attachedStrands).StartVertexIndex];
    endIndex = [strands(attachedStrands).EndVertexIndex];
    bothIndex = [startIndex,endIndex];
    attachedNodeIndexList = bothIndex(bothIndex~=thisNodeIndex);
    attachedNodeIDList = find(ismember(nodeList,attachedNodeIndexList));
    newSegmentList = [repmat(thisNodeID,size(attachedNodeIDList)),attachedNodeIDList];
    orderFlag = newSegmentList(:,1)<newSegmentList(:,2);
    subSegmentList = newSegmentList(orderFlag,:);
    segments = [segments;subSegmentList];
end%for nodeIter

fullSegments = [(1:size(segments,1))',segments];

%%
%Remove the plunging segments and the surface segments
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;

s1 = fullSegments(:,2);
s2 = fullSegments(:,3);

removeList = [];
% % for aIter = 1:numel(allPlungingArterioleList),
% %     thisStrandID = allPlungingArterioleList(aIter);
% %     thisStrand = strands(thisStrandID);
% %     startVertex = thisStrand.StartVertexIndex;
% %     endVertex = thisStrand.EndVertexIndex;
% %     f1 = find(nodeList==startVertex);
% %     f2 = find(nodeList==endVertex);
% %     if and(~isempty(f1),~isempty(f2)),
% %         ff1 = min(f1,f2);
% %         ff2 = max(f1,f2);
% %         fs = find(and(s1==ff1,s2==ff2));
% %         removeList = [removeList,fs];
% %     end%if...
% % end%for aIter

for vIter = 1:numel(allPlungingVenuleList),
    thisStrandID = allPlungingVenuleList(vIter);
    thisStrand = strands(thisStrandID);
    startVertex = thisStrand.StartVertexIndex;
    endVertex = thisStrand.EndVertexIndex;
    f1 = find(nodeList==startVertex);
    f2 = find(nodeList==endVertex);
    if and(~isempty(f1),~isempty(f2)),
        ff1 = min(f1,f2);
        ff2 = max(f1,f2);
        fs = find(and(s1==ff1,s2==ff2));
        removeList = [removeList,fs];
    end%if...
end%for vIter

surfaceStrandList = find(ismember(strandLabelList,[300:399]));
for sIter = 1:numel(surfaceStrandList);
    thisStrandID = surfaceStrandList(sIter);
    thisStrand = strands(thisStrandID);
    startVertex = thisStrand.StartVertexIndex;
    endVertex = thisStrand.EndVertexIndex;
    f1 = find(nodeList==startVertex);
    f2 = find(nodeList==endVertex);
    if and(~isempty(f1),~isempty(f2)),
        ff1 = min(f1,f2);
        ff2 = max(f1,f2);
        fs = find(and(s1==ff1,s2==ff2));
        removeList = [removeList,fs];
    end%if...
end%for sIter


keepInd = ~ismember(fullSegments(:,1),removeList);        
segments = fullSegments(keepInd,2:3);
segments = [(1:size(segments,1))',segments];
    


%%

allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;

allArterioleStrandList = [allPlungingArteriolePathList{:}];
allVenuleStrandList = [allPlungingVenulePathList{:}];

allArterioleVertexList = unique([strands(allArterioleStrandList).StartVertexIndex,strands(allArterioleStrandList).EndVertexIndex]);
allArterioleNodeList = find(ismember(nodeList,allArterioleVertexList));
allVenuleVertexList = unique([strands(allVenuleStrandList).StartVertexIndex,strands(allVenuleStrandList).EndVertexIndex]);
allVenuleNodeList = find(ismember(nodeList,allVenuleVertexList));


numArterioles = numel(allPlungingArteriolePathList);
numVenules = numel(allPlungingVenulePathList);

numArterioleNodes = numel(allArterioleNodeList);
numVenuleNodes = numel(allVenuleNodeList);



aterioleIter = 1;
venuleIter = 1;
    thisArterioleStrandList = allPlungingArteriolePathList{aterioleIter};
    thisArterioleVertexList = unique([strands(thisArterioleStrandList).StartVertexIndex,strands(thisArterioleStrandList).EndVertexIndex]);
    thisArterioleNodeList = find(ismember(nodeList,thisArterioleVertexList));
    otherArterioleStrandList = allArterioleStrandList(~ismember(allArterioleStrandList,thisArterioleStrandList));
    otherArterioleVertexList = unique([strands(otherArterioleStrandList).StartVertexIndex,strands(otherArterioleStrandList).EndVertexIndex]);
    otherArterioleNodeList = find(ismember(nodeList,otherArterioleVertexList));
   
    
    
    thisVenuleStrandList = allPlungingVenulePathList{aterioleIter};
    thisVenuleVertexList = unique([strands(thisVenuleStrandList).StartVertexIndex,strands(thisVenuleStrandList).EndVertexIndex]);
    thisVenuleNodeList = find(ismember(nodeList,thisVenuleVertexList));
    otherVenuleStrandList = allVenuleStrandList(~ismember(allVenuleStrandList,thisVenuleStrandList));
    otherVenuleVertexList = unique([strands(otherVenuleStrandList).StartVertexIndex,strands(otherVenuleStrandList).EndVertexIndex]);
    otherVenuleNodeList = find(ismember(nodeList,otherVenuleVertexList));
   
    
    

%%


%find all shortest arteriole to venule paths
maxSep = 200;

avShortestPathList = [];
for aNodeIter = 1:numArterioleNodes,
    thisArterioleNode = allArterioleNodeList(aNodeIter)
    aNodeCoord = nodes(thisArterioleNode,2:3);
    shortestPathList = [];
    maxPath = 50;
    for vNodeIter = 1:numVenuleNodes,
        thisVenuleNode = allVenuleNodeList(vNodeIter);
        vNodeCoord = nodes(thisVenuleNode,2:3);
        sep = sqrt(sum(((aNodeCoord-vNodeCoord).^2),2));
        if sep < maxSep,

%             [dist,shortestPath] = dijkstra(nodes,segments,thisArterioleNode,thisVenuleNode);
            [dist,shortestPath] = dijkstra_phil(nodes,segments,thisArterioleNode,thisVenuleNode,maxPath);

            if ~isinf(dist),
                shortestPathLength = numel(shortestPath);
                shortestPathList = [shortestPathList,shortestPathLength];
                maxPath = 3*min(shortestPathList);
            else%if ~isinf(dist)
                disp('inf');
            end%if ~isinf(dist)
        end%if sep<maxSep
        
    end%for vNodeIter
    avShortestPathList = [avShortestPathList,min(shortestPathList)]
end%for aNodeIter

        
%%

%find all shortest venule to venule paths
vvShortestPathList = [];
for startVenuleIter = 50:numVenules
    thisVenuleStrandList = allPlungingVenulePathList{startVenuleIter};
    thisVenuleVertexList = unique([strands(thisVenuleStrandList).StartVertexIndex,strands(thisVenuleStrandList).EndVertexIndex]);
    thisVenuleNodeList = find(ismember(nodeList,thisVenuleVertexList));
    otherVenuleStrandList = allVenuleStrandList(~ismember(allVenuleStrandList,thisVenuleStrandList));
    otherVenuleVertexList = unique([strands(otherVenuleStrandList).StartVertexIndex,strands(otherVenuleStrandList).EndVertexIndex]);
    otherVenuleNodeList = find(ismember(nodeList,otherVenuleVertexList));
   
    numStartNodes = numel(thisVenuleNodeList);
    numOtherVenuleNodes = numel(otherVenuleNodeList);
    
    for startNodeIter = 1:numStartNodes,
        startVenuleNode = thisVenuleNodeList(startNodeIter)
        startNodeCoord = nodes(startVenuleNode,2:3);
        shortestPathList = [];
        maxPath = 20;
        for vNodeIter = 1:numOtherVenuleNodes,
            thisVenuleNode = otherVenuleNodeList(vNodeIter);
            vNodeCoord = nodes(thisVenuleNode,2:3);
            sep = sqrt(sum(((startNodeCoord-vNodeCoord).^2),2));
            if sep < maxSep,

    %             [dist,shortestPath] = dijkstra(nodes,segments,thisArterioleNode,thisVenuleNode);
                [dist,shortestPath] = dijkstra_phil(nodes,segments,thisArterioleNode,thisVenuleNode,maxPath);

                if ~isinf(dist),
                    shortestPathLength = numel(shortestPath);
                    shortestPathList = [shortestPathList,shortestPathLength];
                    maxPath = 3*min([shortestPathList,maxPath/3]);
                else%if ~isinf(dist)
                    disp('inf');
                end%if ~isinf(dist)
            end%if sep<maxSep

        end%for vNodeIter
        vvShortestPathList = [vvShortestPathList,min(shortestPathList)]
    end%for startNodeIter
end%for startVenuleIter 

        




    
    