% function DilationSpreadVisualizer_ver01a(vectorProject,startStrandID);


% load('F:\Phil\AOH_Datasets\pbAU_Trials\pbAU_Flow02b\pbAU-UnperturbedFlow-PutativesAdded_LargestSubgraph_VectorProject-fast.mat')
% load('F:\Phil\AOH_Datasets\pbAU_Trials\pbAU_Flow02b\baseStrandIDList_shortSet_cutoff_2p95_60_fromBareBones_AU.mat')


minRadiusForDilation = 2.1; %0 = all vessels capable of dilating
minVoltageForDilation = 60; %don't allow veins to dilate
vesselDilationFraction = 1.1; %radiusDilation

% startStrandIndex = 80;
% startStrandIndex = 83;
% startStrandIndex = 20;
startStrandIndex = 55;

startStrandID = baseStrandIDList(startStrandIndex);

minimumFluxFraction = 1/3000;
stopVoltage = 50.5;
divFactor = 3;
%-----
displayFlag = 0;
overlayDisplayFlag = 0;
pauseFlag = 0;
normalizeToStartStrandCurrentFlag = 1; %multiply the flow by the startStrand current

dilationFrontDieOffFactor = 0.998
dilationStepSize = 50;


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
AllRadii = Vertices.AllRadii;
maskSize = vectorProject.maskSize;
numStrands = numel(Strands);
numPoints = numel(AllVoltages);

baselineCurrentList = [Strands.strandCurrent];

populateNeighborListFlag = 1;
if exist('neighborList','var') && exist('populatingListCompletedFlag','var') && populatingListCompletedFlag == 1,
    populateNeighborListFlag = 0;
end

%Maintain a list of points and their neighbors
if populateNeighborListFlag == 1,
    tic
    populatingListCompleted = 0;
    neighborList = zeros(numPoints,10);%to be truly robust, this should be as high as 26 columns
    for strandIter = 1:numStrands,
        thisStrandID = strandIter;
        thisStrand = Strands(thisStrandID);
        stei = thisStrand.StartToEndIndices;
        for pointIter = 2:numel(stei)-1;
            neighborList(stei(pointIter),1:2) = [stei(pointIter-1),stei(pointIter+1)];
        end
        svi = thisStrand.StartVertexIndex;
        svns = thisStrand.StartVertexNeighborStrands;
        svns = svns(svns~=thisStrandID);
        evi = thisStrand.EndVertexIndex;
        evns = thisStrand.EndVertexNeighborStrands;
        evns = evns(evns~=thisStrandID);
        %---
        if ~isempty(svns),
            tempNeighborList = stei(2);
            for neighborIter = 1:numel(svns),
                nstei = Strands(svns(neighborIter)).StartToEndIndices;
                if svi == nstei(1),
                    tempNeighborList = [tempNeighborList,nstei(2)];
                else%if svi == nstei(1),
                    tempNeighborList = [tempNeighborList,nstei(end-1)];
                    if svi~=nstei(end), disp('ERROR'),keyboard,end;
                end%if-else svi == nstei(1),
            end%for neighborIter = 1:numel(evns),
            neighborList(svi,1:numel(tempNeighborList)) = tempNeighborList;
        end%if ~isempty(evns),
        %---
        if ~isempty(evns),
            tempNeighborList = stei(pointIter-1);
            for neighborIter = 1:numel(evns),
                nstei = Strands(evns(neighborIter)).StartToEndIndices;
                if evi == nstei(1),
                    tempNeighborList = [tempNeighborList,nstei(2)];
                else%if evi == nstei(1),
                    tempNeighborList = [tempNeighborList,nstei(end-1)];
                    if evi~=nstei(end), disp('ERROR'),keyboard,end;
                end%if-else evi == nstei(1),
            end%for neighborIter = 1:numel(evns),
            neighborList(evi,1:numel(tempNeighborList)) = tempNeighborList;
        end%if ~isempty(evns),
    end%for strandIter = 1:numStrands,
    populatingListCompletedFlag = 1;
    toc
end%%if populateNeighborListFlag == 1,

%Create a flag list to keep track of which point have already dilated
alreadyDilatedFlagList = false(numPoints,1);
dilationFrontFlagList = false(numPoints,1);

%First dilation is the entire start strand
pointsToDilate = Strands(startStrandID).StartToEndIndices;
dilationFrontFlagList(pointsToDilate(1)) = 1;
dilationFrontFlagList(pointsToDilate(end)) = 1;
subRadiiList = AllRadii(pointsToDilate);
subVoltageList = AllVoltages(pointsToDilate);
subAlreadyDilatedFlagList = alreadyDilatedFlagList(pointsToDilate);
flag1 = subRadiiList > minRadiusForDilation;
flag2 = subVoltageList > minVoltageForDilation;
meetsCriteriaFlagList = and(and(flag1,flag2),~subAlreadyDilatedFlagList);
multiplierList = ones(size(subRadiiList));
multiplierList(meetsCriteriaFlagList) = vesselDilationFraction;
AllRadii(pointsToDilate) = subRadiiList .* multiplierList;
alreadyDilatedFlagList(pointsToDilate) = 1;
changedVectorProject = vectorProject;
changedVectorProject.vectorizedStructure.Vertices.AllRadii = AllRadii;
    changedVectorProject = CalculateUnperturbedFlow001(changedVectorProject);

newCurrentList = [changedVectorProject.vectorizedStructure.Strands.strandCurrent];
diffCurrentList = newCurrentList - baselineCurrentList;
ratioCurrentList = newCurrentList ./ baselineCurrentList;
figure(1);plot(diffCurrentList,'r.');

thresholdCurrentRatioToPlot = 0.1;
saturatingCurrentRatio = 0.5;

redColorMap = zeros(255,3);
redColorMap(:,1) = 1;
redColorMap(:,2) = linspace(1,0,255);
redColorMap(:,3) = linspace(1,0,255);
blueColorMap = zeros(255,3);
blueColorMap(:,1) = linspace(1,0,255);
blueColorMap(:,2) = linspace(1,0,255);
blueColorMap(:,3) = 1;


%Generate Plot
strandsToPlotList = find( abs(ratioCurrentList-1) > thresholdCurrentRatioToPlot );
numStrandsToPlot = numel(strandsToPlotList),
startStrandPoints = AllVerts(Strands(startStrandID).InteriorVertices,:);
hold off
figure(201);
pp1 = plot3(startStrandPoints(:,1),startStrandPoints(:,2),-1*startStrandPoints(:,3),'kx');
hold on
for strandIter = 1:numStrandsToPlot,
    thisStrandID = strandsToPlotList(strandIter);
    thisStrand = Strands(thisStrandID);
    iv = thisStrand.InteriorVertices;
    medRadius = median(AllRadii(iv));
    medRadius = max(medRadius,1);
    thisRatio = ratioCurrentList(thisStrandID);
    if thisRatio > 1,
        tempRatio = ceil(((thisRatio - 1)./saturatingCurrentRatio) * 255);
        tempRatio = min(tempRatio,255);
        myColor = redColorMap(tempRatio,:);
    else%if thisRatio > 1,
        tempRatio = ceil(((1 - thisRatio)./saturatingCurrentRatio) * 255);
        tempRatio = min(tempRatio,255);
        myColor = blueColorMap(tempRatio,:);
    end%if thisRatio > 1,
    myPoints = AllVerts(iv,:);
    ppp = plot3(myPoints(:,1),myPoints(:,2),-1*myPoints(:,3),'ro');
    set(ppp,'MarkerEdgeColor',myColor);
    set(ppp,'MarkerSize',medRadius);
end
axis equal
hold off    
    
    
pause
counter = 0;
while 1==1;
counter = counter+1;

%Propagate the dilation
for dilationIter = 1:dilationStepSize,
    vesselDilationFraction = ((vesselDilationFraction-1) * dilationFrontDieOffFactor)+1;
    dilationFrontPointList = find(dilationFrontFlagList);
    newDilationFrontFlagList = false(numPoints,1);
    for frontPointIter = 1:numel(dilationFrontPointList);
        thisFrontPoint = dilationFrontPointList(frontPointIter);
        neighborPointList = neighborList(thisFrontPoint,:);
        neighborPointList = neighborPointList(neighborPointList~=0);
        readyForDilationFlag = ~(alreadyDilatedFlagList(neighborPointList));
        AllRadii(neighborPointList(readyForDilationFlag)) = AllRadii(neighborPointList(readyForDilationFlag)) .* vesselDilationFraction;
        newDilationFrontFlagList(neighborPointList(readyForDilationFlag)) = 1;
        alreadyDilatedFlagList(neighborPointList(readyForDilationFlag)) = 1;
    end%for frontPointIter = 1:numel(dilationFrontPointList);
    dilationFrontFlagList = newDilationFrontFlagList;
end%for dilationIter = 1:dilationStepSize,
vesselDilationFraction

changedVectorProject = vectorProject;
changedVectorProject.vectorizedStructure.Vertices.AllRadii = AllRadii;
    changedVectorProject = CalculateUnperturbedFlow001(changedVectorProject);

newCurrentList = [changedVectorProject.vectorizedStructure.Strands.strandCurrent];
diffCurrentList = newCurrentList - baselineCurrentList;
ratioCurrentList = newCurrentList ./ baselineCurrentList;

%Generate Plot
strandsToPlotList = find( abs(ratioCurrentList-1) > thresholdCurrentRatioToPlot );
numStrandsToPlot = numel(strandsToPlotList),
startStrandPoints = AllVerts(Strands(startStrandID).InteriorVertices,:);
hold off
figure(201+counter);
pp1 = plot3(startStrandPoints(:,1),startStrandPoints(:,2),-1*startStrandPoints(:,3),'kx');
hold on
for strandIter = 1:numStrandsToPlot,
    thisStrandID = strandsToPlotList(strandIter);
    thisStrand = Strands(thisStrandID);
    iv = thisStrand.InteriorVertices;
    medRadius = median(AllRadii(iv));
    medRadius = max(medRadius,1);
    thisRatio = ratioCurrentList(thisStrandID);
    if thisRatio > 1,
        tempRatio = ceil(((thisRatio - 1)./saturatingCurrentRatio) * 255);
        tempRatio = min(tempRatio,255);
        myColor = redColorMap(tempRatio,:);
    else%if thisRatio > 1,
        tempRatio = ceil(((1 - thisRatio)./saturatingCurrentRatio) * 255);
        tempRatio = min(tempRatio,255);
        myColor = blueColorMap(tempRatio,:);
    end%if thisRatio > 1,
    myPoints = AllVerts(iv,:);
    ppp = plot3(myPoints(:,1),myPoints(:,2),-1*myPoints(:,3),'ro');
    set(ppp,'MarkerEdgeColor',myColor);
    set(ppp,'MarkerSize',medRadius);
end
axis equal
hold off    

pause(5)

end%while 1==1
