


scriptVersion = 'DisplayPenetratingVesselsScript1x.m'


vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
allVerts = vertices.AllVerts;

strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;

strandLabelList = [strands(:).MedianLabel];
surfList = find(and(strandLabelList>=300,strandLabelList<=399)); 
zSurf = strandMidYXZList(surfList,3);
medianZSurf = median(zSurf);
minZSurf = min(zSurf);

strandMidYXZList(:,3) = max(strandMidYXZList(:,3)-minZSurf,0);
allPlungingVenuleList = vectorProject.vectorizedStructure.allPlungingVenuleList;
allPlungingVenulePathList = vectorProject.vectorizedStructure.allPlungingVenulePathList;
allPlungingArterioleList = vectorProject.vectorizedStructure.allPlungingArterioleList;
allPlungingArteriolePathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;

flowAnalysisParameters = [];
cleanupFlag = 1;



        allPlungingArteriolePathList = allPlungingArteriolePathList([8:14]);%,19,24,26:29]);%,31,32,34,41]);%db



myCounter = 0;
numPlungingArterioles = numel(allPlungingArteriolePathList);
figure(1);clf
for plungingIter = 1:numPlungingArterioles,
    disp(plungingIter)
    thisPath = allPlungingArteriolePathList{plungingIter};
    if numel(thisPath)>1,
        myCounter = myCounter+1;
        thisVertList = [strands(thisPath).StartToEndIndices];
        thisCoordList = allVerts(thisVertList,:);
        cc1 = thisCoordList;
        outletStrandList = [strands(thisPath(2:end)).StartVertexNeighborStrands,strands(thisPath(2:end)).EndVertexNeighborStrands];
        outletStrandList = outletStrandList(~ismember(outletStrandList,thisPath));
        outletVertList = [strands(outletStrandList).StartToEndIndices];
        outletCoordList = allVerts(outletVertList,:);
        cc2 = outletCoordList;
        minZ = min(cc1(:,3));
        minY = min(cc1(:,1));
        cc1(:,3) = cc1(:,3)-minZ;
        cc2(:,3) = cc2(:,3)-minZ;
        cc1(:,1) = cc1(:,1)-minY+myCounter*300;
        cc2(:,1) = cc2(:,1)-minY+myCounter*300;
       
        figure(1);plot(cc1(:,1),-1*cc1(:,3),'r.');hold on
        figure(1);plot(cc2(:,1),-1*cc2(:,3),'g.');hold on
        axis equal
        pause
    end%if numel(thisPath)>1
end%for plungingIter..

        

%%


allPlungingVenulePathList = allPlungingVenulePathList([2,3,9,12,24,32]);


myCounter = 0;
numPlungingVenules = numel(allPlungingVenulePathList);
figure(2);clf
for plungingIter = 1:numPlungingVenules,
    disp(plungingIter)
    thisPath = allPlungingVenulePathList{plungingIter};
    if numel(thisPath)>1,
        myCounter = myCounter+1;
        thisVertList = [strands(thisPath).StartToEndIndices];
        thisCoordList = allVerts(thisVertList,:);
        cc1 = thisCoordList;
        outletStrandList = [strands(thisPath(2:end)).StartVertexNeighborStrands,strands(thisPath(2:end)).EndVertexNeighborStrands];
        outletStrandList = outletStrandList(~ismember(outletStrandList,thisPath));
        outletVertList = [strands(outletStrandList).StartToEndIndices];
        outletCoordList = allVerts(outletVertList,:);
        cc2 = outletCoordList;
        minZ = min(cc1(:,3));
        minY = min(cc1(:,1));
        cc1(:,3) = cc1(:,3)-minZ;
        cc2(:,3) = cc2(:,3)-minZ;
        cc1(:,1) = cc1(:,1)-minY+myCounter*300;
        cc2(:,1) = cc2(:,1)-minY+myCounter*300;
       
        figure(2);plot(cc1(:,1),-1*cc1(:,3),'b.');hold on
        figure(2);plot(cc2(:,1),-1*cc2(:,3),'g.');hold on
        axis equal
        pause
    end%if numel(thisPath)>1
end%for plungingIter..


%%
