
%Stage 1: Load a -flow-vectorProject
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;


%%
% % % offset = 200;
% % % 
% % % ry = ceil(rand(10000,1)*(maskSize(1)-2*offset))+offset;
% % % rx = ceil(rand(10000,1)*(maskSize(2)-2*offset))+offset;
% % % rz = ceil(rand(10000,1)*(maskSize(3)-4*offset))+(2*offset);
% % % 
% % % 
% % % for kk = 1:10000,
% % %     
% % % searchSize = 30;
% % % av = vertices.AllVerts;
% % % avAug = [av,[1:size(av,1)]'];
% % % 
% % % av = avAug;
% % % av(:,1) = abs(av(:,1)-ry(kk));
% % % av = av(av(:,1)<searchSize,:);
% % % 
% % % av(:,2) = abs(av(:,2)-rx(kk));
% % % av = av(av(:,2)<searchSize,:);
% % % 
% % % av(:,3) = abs(av(:,3)-rz(kk));
% % % av = av(av(:,3)<searchSize,:);
% % % 
% % % distList = sqrt(av(:,1).^2 + av(:,2).^2 + av(:,3).^2);
% % % [minDist,minPos] = min(distList);
% % % 
% % % if ~isempty(minDist)
% % %     closestPoint = av(minPos,4);
% % %     closestStrand = vertices.StrandIndices(closestPoint);
% % %     strandVoltage = strands(closestStrand).MedianVoltage;
% % %     figure(1);plot(strandVoltage,minDist,'b.');hold on
% % %     pause(0.01);
% % % end% if ~isempty
% % % 
% % % end%for kk


%%
sviList = [strands(:).StartVertexIndex];
eviList = [strands(:).EndVertexIndex];
sviCoords = vertices.AllVerts(sviList,:);
eviCoords = vertices.AllVerts(eviList,:);
startToEndSepList = sqrt(sum((eviCoords-sviCoords).^2,2));


%%
%Try again, but looking at strand centers
startCount = 2;
numCount = 17; %consider the (numCount) closest strands
strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;
numStrands = size(strandMidYXZList,1);
strandVoltageList = [strands(:).MedianVoltage]';
strandLengthList = vectorProject.vectorizedStructure.strandLengthList;
strandRadiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList;
strandTortuosityList = strandLengthList./startToEndSepList;

meanDistList = zeros(numStrands,1);
for strandIter = 1:numStrands;
    strandSepList = strandMidYXZList - repmat(strandMidYXZList(strandIter,:),[numStrands,1]);
    strandDistList = sqrt(sum(strandSepList.^2,2));
    sortDistList = sort(strandDistList);
    meanDistList(strandIter,1) = mean(sortDistList(startCount:startCount+numCount-1));
end
disp('Completed mean separation distance calculation');


%%
y1 = 0;x1 = 0;z1 = 0; y2 = inf;x2 = inf;z2 = inf;

offset = 200;
y1 = offset; y2 = maskSize(1) - offset;
x1 = offset; x2 = maskSize(2) - offset;
z1 = 300; z2 = 900;
sm = strandMidYXZList;
ff = and(and(and(sm(:,1)>y1,sm(:,1)<y2),and(sm(:,2)>x1,sm(:,2)<x2)),and(sm(:,3)>z1,sm(:,3)<z2));
% % ff = and(ff,strandRadiusList<2);
ff = find(ff);

subVoltageList = strandVoltageList(ff);
subDistList = meanDistList(ff);
subLengthList = strandLengthList(ff);
subRadiusList = strandRadiusList(ff);
subTortuosityList = strandTortuosityList(ff);


% subTimeList = timeOfFlightList(ff);
% subTimeList = min(1000,subTimeList);

subTimeList = meanBloodOx(ff)';
subVoltageList = subTimeList;


allDataList = [subVoltageList,subDistList,subLengthList,subRadiusList,subTortuosityList,subTimeList];

sortDataList = sortrows(allDataList,1);
filtSize = 200;
filtDataList = imfilter(sortDataList,ones(filtSize,1),'replicate')./filtSize;


figure(2);p2 = plot(subVoltageList,subDistList,'r.');hold on;
p2b = plot(filtDataList(:,1),filtDataList(:,2),'k-');hold off;
xlabel('Strand Voltage'),ylabel(['Mean separation to ',num2str(numCount),' closest vessels']);
set(p2,'MarkerSize',1);
figure(3);p3 = plot(subVoltageList,subLengthList,'g.');hold on;
p3b = plot(filtDataList(:,1),filtDataList(:,3),'k-');hold off;
xlabel('Strand Voltage'),ylabel('Strand Path Length');
set(p3,'MarkerSize',1);
figure(4);p4 = plot(subVoltageList,subRadiusList,'b.');hold on;
p4b = plot(filtDataList(:,1),filtDataList(:,4),'k-');hold off;
xlabel('Strand Voltage'),ylabel('Strand Radius');
set(p4,'MarkerSize',1);
figure(5);p5 = plot(subVoltageList,subTortuosityList,'m.');hold on;
p5b = plot(filtDataList(:,1),filtDataList(:,5),'k-');hold off;
set(p5,'MarkerSize',1);
xlabel('Strand Voltage'),ylabel('Strand Tortuosity');
figure(6);p6 = plot(subVoltageList,subTimeList,'m.');hold on;
p6b = plot(filtDataList(:,1),filtDataList(:,6),'k-');hold off;
set(p6,'MarkerSize',1);
xlabel('Strand Voltage'),ylabel('Strand Time');


% % figure(22);p5 = plot(subTimeList,subVoltageList,'m.');hold on;
% % p5b = plot(filtDataList(:,6),filtDataList(:,1),'k-');hold off;
% % set(p5,'MarkerSize',1);
% % xlabel('Strand Time'),ylabel('Strand Voltage');
% % 
% % figure(33);p5 = plot(subTimeList,subDistList,'c.');hold on;
% % p5b = plot(filtDataList(:,6),filtDataList(:,2),'k-');hold off;
% % set(p5,'MarkerSize',1);
% % xlabel('Strand Time'),ylabel('Strand Sep');
% % 

%%





