% function DyeTracer_ver01a(vectorProject,startStrandID);




% load('F:\Phil\AOH_VectorProjects\pbDB\VectorProjectFolder\FlowProject000005ADJ_Files\FVFile_2011_04_01-124412.mat')



basicSet = gds.plungingArterioleTipList;
                 


startStrandList = basicSet;                 
minimumFluxFraction = 1/3000;
stopVoltage = 50.5;
divFactor = 3;
%-----
displayFlag = 1;
overlayDisplayFlag = 0;
pauseFlag = 0;
normalizeToStartStrandCurrentFlag = 1; %multiply the flow by the startStrand current


vectorProject.vectorizedStructure.Strands = gds.Strands;
vectorProject.vectorizedStructure.Vertices = gds.Vertices;
vectorProject.maskSize = gds.maskSize;


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = full(Vertices.StrandIndices);
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;
numStrands = numel(Strands);




cutoffRadius = 2.95;
cutoffVoltage = 60;
% % dyeSourceStrandList = TraceToCutoffRadius(vectorProject,startStrandList,cutoffRadius,cutoffVoltage);
fileTag = '_InjectAtBasic'
dyeSourceStrandList = basicSet;



whos dyeSourceStrandList


pathColorStorageList = zeros(size(AllVerts));
maxFlowFractionStorageList = zeros(size(Strands));
associatedStartStorageList = zeros(size(Strands));
%-----               
numStartStrands = numel(dyeSourceStrandList);
myColorSpace = GenerateColorSpace(numStartStrands);
for startStrandIter = 1:numStartStrands;
    startStrandID = dyeSourceStrandList(startStrandIter);
    disp([startStrandIter, startStrandID]);


    startStrand = Strands(startStrandID);
    ssiv = startStrand.InteriorVertices;
    startStrandCoordList = AllVerts(ssiv,:);
    strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
    nodeVoltages = AllVoltages(strandNodes);
    [highVoltage,highVoltagePos] = max(nodeVoltages);
    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
    highNode = strandNodes(highVoltagePos);
    lowNode = strandNodes(strandNodes~=highNode);

    pathActiveFlagList = false(1,100000);
    pathActiveFlagList(1) = 1;
    numActivePath = sum(pathActiveFlagList);
    strandPathList = {};
    nodePathList = {};
    fractionPathList = {};
    strandPathList{1} = startStrandID;
    nodePathList{1} = [highNode lowNode];
    fractionPathList{1} = 1;
    strandFlowList = zeros(numStrands,1);
    strandFlowList(startStrandID) = 1;
    strandVoltageList = zeros(numStrands,1);
    strandVoltageList(1) = mean([highVoltage,lowVoltage]);
    pathCounter = 1;
    keepGoingFlag = 1;
    myCamPos = [0 0 0];
    myCamUp = [-1 0 0];
    myCamVA = 6.6086;

    while (keepGoingFlag == 1),
        myCount = 0;
        for pathIter = find(pathActiveFlagList == 1);
             
            currentPathID = pathIter;
            currentStrandPath = strandPathList{pathIter};
            currentNodePath = nodePathList{pathIter};
            currentFractionPath = fractionPathList{pathIter};
            currentStrandID = currentStrandPath(end);
            currentStrand = Strands(currentStrandID);
            %-----
            strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
            nodeVoltages = AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);
            lowAttachedStrands = StrandIndices(lowNode,:);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
            numDaughterPaths = numel(lowAttachedStrands);
            strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
            stopTracingFlag = 0;
            if numDaughterPaths == 0, stopTracingFlag = 1; end
            if lowVoltage < stopVoltage, stopTracingFlag = 1; end
            if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
            if stopTracingFlag == 1,
                pathActiveFlagList(currentPathID) = 0;
            else%if stopTracingFlag == 1,
                motherCurrent = abs(currentStrand.strandCurrent);
                validDaughterCounter = 0;
                validDaughterStrandList = [];
                validDaughterCurrentList = zeros(1,numDaughterPaths);
                validDaughterPathIndexList = [];
                for daughterIter = 1:numDaughterPaths,
                    %Check to see if the daughter strand leads to a lower voltage
                    candidateDaughterID = lowAttachedStrands(daughterIter);
                    candidateDaughterStrand = Strands(candidateDaughterID);
                    candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                    candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                    candidateDaughterOtherVoltage = AllVoltages(candidateDaughterOtherNode);
                    if candidateDaughterOtherVoltage < lowVoltage,
                        %if so, add the strand to a path
                        myCount = myCount + 1;
                        validDaughterCounter = validDaughterCounter + 1;
                        validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                        validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                        if validDaughterCounter == 1,
                            %if this is the first valid daughter, add to current path
                            strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                            validDaughterPathIndexList(1) = currentPathID;
                        else%if validDaughterCounter == 1,
                            %if not the first daughter, duplicate path up to this point, and
                            %make new path
                            pathCounter = pathCounter + 1;
                            strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                            fractionPathList{pathCounter} = currentFractionPath;
                            pathActiveFlagList(pathCounter) = 1;  
                            validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                        end%if-else validDaughterCounter == 1,
                    end%if candidateDaughterOtherVoltage < lowVoltage,
                end%for daughterIter = 1:numDaughterPaths,
                clear daughterIter
                %-----
                daughterSumCurrent = sum(validDaughterCurrentList);
                fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                for validDaughterIter = 1:validDaughterCounter;
                    validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                    validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                    fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                    strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                end%for validDaughterIter = 1:validDaughterCounter;
            end%if-else stopTracingFlag == 1,
        end%for pathIter = find(pathActiveFlagList == 1);
        if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
        if myCount == 0, keepGoingFlag = 0;end
    end%while (keepGoingFlag == 1),
    %-----
    if displayFlag == 1,
        %Generate a plot
        myColorVector = myColorSpace(startStrandIter,:);
        myR = [0:255]'*myColorVector(1);
        myG = [0:255]'*myColorVector(2);
        myB = [0:255]'*myColorVector(3);
        myColorMap = [myR,myG,myB]./256;
        %-----
        divMaskSize = ceil(maskSize./divFactor);
        activeStrandList = find(strandFlowList>0);
        numActiveStrands = numel(activeStrandList);
        ff = figure(10);
        myCamPos = campos;
        myCamUp = camup;
        myCamVA = camva;
        cameratoolbar
        for strandIter = 1:numActiveStrands 
            thisStrandID = activeStrandList(strandIter);
            thisStrand = Strands(thisStrandID);
            pathIndexList = thisStrand.InteriorVertices;
            pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
            maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
            p3 = plot3(pathCoordList(:,1),pathCoordList(:,2),-1*pathCoordList(:,3),'r.');hold on
            thisStrandFlow = ceil(strandFlowList(thisStrandID)*255);
            thisStrandVoltage = ceil(255*(strandVoltageList(thisStrandID)-49)./51);
            set(p3,'MarkerSize',thisStrandFlow/20);
        %     set(p3,'Color',myColorMap(thisStrandVoltage,:))
            set(p3,'Color',myColorMap(end,:))
        end%for pathIter = 1:numPaths,
        ssccc = ceil(startStrandCoordList./divFactor);
        p4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');
        set(p4,'MarkerSize',7);
        xlabel('Axis 1');
        ylabel('Axis 2');
        zlabel('Axis 3');
        plot3(0,0,0,'b.');
        plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');
        campos(myCamPos)
        camup(myCamUp);
        camva(myCamVA);
        if overlayDisplayFlag ~= 1, hold off; end
        % saveas(ff,['Figure_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);
% %         fp = figure(11);
% %         pp4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');hold on
% %         plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');
        if pauseFlag ==1, pause, else, pause(0.1);end
    end%if displayFlag == 1,
    %-----
    %-----
    %Generate an dominant flow map 
    activeStrandList = find(strandFlowList>0);
    numActiveStrands = numel(activeStrandList);

    for strandIter = 1:numActiveStrands 
        thisStrandID = activeStrandList(strandIter);
        thisStrand = Strands(thisStrandID);
        thisStrandFlow = (strandFlowList(thisStrandID));
        if normalizeToStartStrandCurrentFlag == 1,
            thisStrandFlow = abs(startStrand.strandCurrent) * thisStrandFlow;
        end%if normalizeToStartStrandCurrentFlag == 1,
        storedFlowFraction = maxFlowFractionStorageList(thisStrandID);
        if thisStrandFlow > storedFlowFraction,
            maxFlowFractionStorageList(thisStrandID) = thisStrandFlow;
            associatedStartStorageList(thisStrandID) = startStrandIter;
        end%if thisStrandFlow > storedFlowFraction,
    end%for strandIter = 1:numActiveStrands 
%     disp(numel(find(associatedStartStorageList>0)))
end%for startStrandIter = 1:...


myColorLUT = zeros(numStartStrands,3);
for kk = 1: numStartStrands,
    myColorVector = myColorSpace(kk,:);
    myColorMag = sqrt(sum(myColorVector.^2));
    myColorVector = myColorVector./myColorMag;
    myColorLUT(kk,1:3) = ceil(myColorVector*255);
end%for kk..

divMaskSize = ceil(maskSize./divFactor);
redMask = zeros(divMaskSize,'uint8');
greenMask = zeros(divMaskSize,'uint8');
blueMask = zeros(divMaskSize,'uint8');
bwMask = zeros(divMaskSize,'uint8');

for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = Strands(thisStrandID);
    colorPointer = associatedStartStorageList(thisStrandID);
    thisStrandFlow = maxFlowFractionStorageList(thisStrandID);
    thisStrandCurrent = thisStrand.strandCurrent;
    thisStrandRatio(strandIter) = abs(thisStrandFlow/thisStrandCurrent);
    if mod(strandIter,1000) == 0, disp([thisStrandFlow,thisStrandCurrent]);end
    if colorPointer > 0,
        if thisStrandRatio(strandIter) > 0.5,
            thisColor = myColorLUT(colorPointer,:);
            thisStrandCoords = ceil(AllVerts(thisStrand.StartToEndIndices,:)./divFactor);
            ccc = thisStrandCoords;
            thisStrandIndices = sub2ind(divMaskSize,ccc(:,1),ccc(:,2),ccc(:,3));
            redMask(thisStrandIndices) = thisColor(1);
            greenMask(thisStrandIndices) = thisColor(2);
            blueMask(thisStrandIndices) = thisColor(3);
            bwMask(thisStrandIndices) = colorPointer+50;
        end%if thisStrandRatio >0.5,
    end%if colorPointer > 0,
end




%%
maketiff(bwMask,['bwMask2',fileTag,'.tif']);


fileName = ['DominantFlowRGB2',fileTag,'.tif'];
currentFrame = zeros(size(redMask,1),size(redMask,2),3,'uint8');
currentFrame(:,:,1) = redMask(:,:,1);
currentFrame(:,:,2) = greenMask(:,:,1);
currentFrame(:,:,3) = blueMask(:,:,1);
imwrite(uint8(currentFrame),fileName,'tiff','Compression','none');

for frameIter = 2:size(redMask,3);
    currentFrame(:,:,1) = redMask(:,:,frameIter);
    currentFrame(:,:,2) = greenMask(:,:,frameIter);
    currentFrame(:,:,3) = blueMask(:,:,frameIter);
    imwrite(uint8(currentFrame),fileName,'tiff','WriteMode','append','Compression','none');
end

%%
allPlungingStrandPath = gds.allPlungingArteriolePathList;

for startStrandIter = 1:numStartStrands;
    ccPlunging = AllVerts([Strands(gds.allPlungingArterioleList).StartToEndIndices],:);
    figure(21);hold off
    plot3(ccPlunging(:,1),ccPlunging(:,2),-1*ccPlunging(:,3),'r.');hold on


    
    dominantFlowStrands = find(associatedStartStorageList==startStrandIter);
    ccDom = AllVerts([Strands(dominantFlowStrands).StartToEndIndices],:);
    plot3(ccDom(:,1),ccDom(:,2),-1*ccDom(:,3),'g.');hold on
    
    figure(21);
    plot3(ccPlunging(:,1),ccPlunging(:,2),-1*ccPlunging(:,3),'r.');hold on

    ccStart = AllVerts([Strands([allPlungingStrandPath{startStrandIter}]).StartToEndIndices],:);
    plot3(ccStart(:,1),ccStart(:,2),-1*ccStart(:,3),'b.');hold on
 
    
    pause
    hold on
    
end

    


    








