gridSize = 1200;

smallRadius = 4;
bigRadius = 7;

randRadiusFlag = 0;
randRadiusSmallAmp = 2;
randRadiusBigAmp = 3;

clotFlag = 1;
% clotY = 600; clotX = 560;%artery clot
% clotY = 640; clotX = 630; %vein clot
clotY = 600; clotX = 700; %vein clot



rand('seed',52);

xList1 = [70:140:gridSize];
xList2 = [140:140:gridSize];
yList1 = [80:80:gridSize];
yList2 = [120:80:gridSize];
redList = [];
blueList = [];
myMatrix = zeros(gridSize,gridSize,41);
myFrame = zeros(gridSize,gridSize);

for xIter = 1:numel(xList1),
    for yIter = 1:numel(yList1),
        myFrame(yList1(yIter),xList1(xIter)) = 1;
        blueList = [blueList;[yList1(yIter),xList1(xIter)]];
    end
end
%---

toggleValueInit = 1;
for xIter = 1:numel(xList2),
    toggleValueInit = ~toggleValueInit;
    toggleValue = toggleValueInit;
    for yIter = 1:numel(yList2),
        thisValue = toggleValue+1;
        toggleValue = ~toggleValue;
        myFrame(yList2(yIter),xList2(xIter)) = thisValue;
        if thisValue==2,
            redList = [redList;[yList2(yIter),xList2(xIter)]];
        else
            blueList = [blueList;[yList2(yIter),xList2(xIter)]];
        end%if thisValue==2

    end%for yIter
end%for xIter

jointList = [redList;blueList];

filtFrame = imfilter(myFrame,double(circle2d(21)));
figure(1);imagesc(uint8(filtFrame));



%%
distanceThreshold = 100;
connectFrame = myFrame;


numJoints = size(jointList,1);
for jointIter = 1:numJoints,
    startCoord = jointList(jointIter,:);
    dyList = jointList(:,1)-startCoord(1);
    dxList = jointList(:,2)-startCoord(2);
    ddList = sqrt(dyList.^2 + dxList.^2);
    neighborList = find(ddList < distanceThreshold);
    neighborList = neighborList(neighborList~=jointIter);
    for neighborIter = 1:numel(neighborList)
        stopCoord = jointList(neighborList(neighborIter),:);
        dy = abs(stopCoord(1)-startCoord(1));
        dx = abs(stopCoord(2)-startCoord(2));
        y1 = min(stopCoord(1),startCoord(1));
        y2 = max(stopCoord(1),startCoord(1));
        x1 = min(stopCoord(2),startCoord(2));
        x2 = max(stopCoord(2),startCoord(2));
        
        reverseFlag = 0;
        if y1==startCoord(1) && x1==stopCoord(2), reverseFlag = 1; end
        if y1==stopCoord(1) && x1==startCoord(2), reverseFlag = 1; end
        
        if dy>dx,
            yList = [y1:y2];
            xList = round(linspace(x1,x2,numel(yList)));
        else
            xList = [x1:x2];
            yList = round(linspace(y1,y2,numel(xList)));
        end
        if reverseFlag == 1, yList = fliplr(yList); end
        
        indList = sub2ind([gridSize,gridSize],yList,xList);
        connectFrame (indList) = 1;
    end%for neighborIter...
end%for jointIter...

filtFrame = imfilter(myFrame,double(circle2d(21)));
figure(2);imagesc(uint8(connectFrame)); colormap(hot);       
    
    
    
    
%%



myMatrix(:,:,21) = connectFrame;

indexList = find(myMatrix>0);
radiusList = zeros(size(indexList)) + smallRadius;
labelList = zeros(size(indexList))+111;
if randRadiusFlag == 1,
    radiusList = radiusList + rand(size(radiusList))*randRadiusSmallAmp*2 - randRadiusSmallAmp;
end%if randRadiusFlag == 1,



for pointIter = 1:size(redList,1);
    yy = repmat(redList(pointIter,1),[21,1]);
    xx = repmat(redList(pointIter,2),[21,1]);
    zz = [1:21]';
    addInd = sub2ind(size(myMatrix),yy,xx,zz);
    addRadius = zeros(size(addInd))+ bigRadius;
    addLabel = zeros(size(addInd))+331;
    if randRadiusFlag == 1,
        addRadius = addRadius + rand(size(addRadius))*randRadiusBigAmp*2 - randRadiusBigAmp;
    end%if randRadiusFlag == 1,
    %---
    if clotFlag==1 && redList(pointIter,1) == clotY && redList(pointIter,2)==clotX
        addLabel(:)=111;
        addRadius(:)=smallRadius;
        disp('hi');
    end
    indexList = [indexList;addInd];
    radiusList = [radiusList;addRadius];
    labelList = [labelList;addLabel];

end;
    
for pointIter = 1:size(blueList,1);
    yy = repmat(blueList(pointIter,1),[21,1]);
    xx = repmat(blueList(pointIter,2),[21,1]);
    zz = [21:41]';
    addInd = sub2ind(size(myMatrix),yy,xx,zz);
    addRadius = zeros(size(addInd))+7;
    if randRadiusFlag == 1,
        addRadius = addRadius + rand(size(addRadius))*randRadiusBigAmp*2 - randRadiusBigAmp;
    end%if randRadiusFlag == 1,
    addLabel = zeros(size(addInd))+341;
    if clotFlag==1 && blueList(pointIter,1) == clotY && blueList(pointIter,2)==clotX
        addLabel(:)=111;
        addRadius(:)=smallRadius;
        disp('hiho');
    end
    indexList = [indexList;addInd];
    radiusList = [radiusList;addRadius];
    labelList = [labelList;addLabel];
end;


[cc1,cc2,cc3] = ind2sub(size(myMatrix),indexList);
figure(5);plot3(cc1,cc2,cc3,'r.');


%%    

strandifyParameters.minSegmentLength = 5;
strandifyParameters.maxHairLengthToEvaluateForRemovalInMicrons = 0;
strandifyParameters.maxConnectingStrandLengthToEvaluateForRemovalInMicrons = 0;
strandifyParameters.intensityRatioThresholdForHairRemoval = 3;
strandifyParameters.intensityRatioThresholdForConnectingStrandRemoval = 3;
strandifyParameters.outputTifFilesFlag = 1;

oneList = ones(size(radiusList));

dataStruct.cpMatrix = [cc1,cc2,cc3,oneList,oneList,oneList];
dataStruct.maskSize = size(myMatrix);
dataStruct.allRadii = radiusList;
dataStruct.allLabels = labelList;
dataStruct.allConfidences = radiusList.*0 +1;
dataStruct.origVectorProject = [];
dataStruct.origVectorProject.vectorProjectFolder = 'C:\MATLAB\R2007b\work';
dataStruct.origVectorProject.voxelSizeInMicrons = 1;
dataStruct.origVectorProject.strandifyParameters = strandifyParameters;
dataStruct.origVectorProject.vectorProjectRootName = 'EHexagon';
dataStruct.origVectorProject.maskSize = size(myMatrix);
dataStruct.origVectorProject.volumeFileNames.permutedVascGrayscale = 'none';
dataStruct.origVectorProject.progressFlags = [];
dataStruct.origVectorProject.rootCodeFolder = '';
dataStruct.origVectorProject.note = '';

    vectorProject = RestrandifySE2_barebones(dataStruct);

vectorProject.progressFlags = [];
vectorProject.rootCodeFolder = '';
vectorProject.note = '';
vectorProject.cellCentroidAndLabelList = [];
vectorProject.thresholdRelaxationParameters = [];

save('EHex-vectorProject.mat','vectorProject');
AAA_AnalysisScriptForEHex01

