gridSize = 11;

myMatrix = zeros(gridSize*20+20,gridSize*20+20,40);

toggleY = 1;
toggleX = 1;
for xIter = 1:gridSize,
    if mod(xIter,2)==0, toggleY = ~toggleY; end
    currentXPos = xIter*20+1;
    toggleX = ~toggleX;
    for yIter = 1:gridSize,
        toggleY = ~toggleY;
        currentYPos = yIter*20+1;
        hvFlag = 0;
        if toggleY==1 && toggleX ==1 , hvFlag = 1;end
        if hvFlag == 1,
            %make highvoltage connection
            myMatrix(currentYPos,currentXPos,1:20) = 1;
            %---
            if xIter>1,%make left connections
                myMatrix(currentYPos,currentXPos-20:currentXPos,20) = 1;
            end%if xIter>1
            %---
            if xIter<gridSize,%right connection
                myMatrix(currentYPos,currentXPos:currentXPos+20,20) = 1;
            end%if xIter<gridSize
            %---
            if yIter>1,%up connection
                myMatrix(currentYPos-20:currentYPos,currentXPos,20) = 1;
            end%if yIter>1
            %---
            if yIter<gridSize,%down connection
                myMatrix(currentYPos:currentYPos+20,currentXPos,20) = 1;
            end%if yIter<gridSize,
            %---
            if xIter>1 && yIter>1,%NW connect
                for kk = 0:20,myMatrix(currentYPos-kk,currentXPos-kk,20) = 1;end
            end%if xIter>1 && yIter>1,%NW connect
            %---
            if xIter<gridSize && yIter>1,%NE connect
                for kk = 0:20,myMatrix(currentYPos-kk,currentXPos+kk,20) = 1;end
            end%if xIter<gridSize && yIter>1,
            %---
            if xIter<gridSize && yIter<gridSize,%SE connect
                for kk = 0:20,myMatrix(currentYPos+kk,currentXPos+kk,20) = 1;end
            end%if xIter<gridSize && yIter<gridSize,
            %---
            if xIter>1 && yIter<gridSize,%SW connection
                for kk = 0:20,myMatrix(currentYPos+kk,currentXPos-kk,20) = 1;end
            end%if xIter>1 && yIter<gridSize,
            %---
        else%if hvFlag == 1
            %lowVoltage connection
            myMatrix(currentYPos,currentXPos,20:40) = 1;
            
        end%if-else hvFlag == 1,
    end%for xIter..
end%for yIter...



clotFlag = 1;

clotX = 81;
clotY = 101;

figure(1);imagesc(myMatrix(:,:,20))
indexList = find(myMatrix==1);
[c1,c2,c3]=ind2sub(size(myMatrix),indexList);
figure(2);plot3(c1,c2,c3,'r.');
radiusList = ones(size(indexList));
labelList = zeros(size(indexList))+111;
for pointIter = 1:numel(indexList);
    if c3(pointIter) < 20,
        labelList(pointIter) = 331;
        radiusList(pointIter) = 1.5;
        
        if clotFlag==1 && c1(pointIter) == clotY && c2(pointIter)==clotX
            labelList(pointIter)=111;
            radiusList(pointIter)=1;
            disp('hi');
        end
        
    end%
    %---
    if c3(pointIter) >20,
        labelList(pointIter) = 341;
        radiusList(pointIter) = 1.5;
    end
end
     
labelList(101,81,1:19) = 0;



strandifyParameters.minSegmentLength = 5;
strandifyParameters.maxHairLengthToEvaluateForRemovalInMicrons = 0;
strandifyParameters.maxConnectingStrandLengthToEvaluateForRemovalInMicrons = 0;
strandifyParameters.intensityRatioThresholdForHairRemoval = 3;
strandifyParameters.intensityRatioThresholdForConnectingStrandRemoval = 3;
strandifyParameters.outputTifFilesFlag = 1;

oneList = ones(size(radiusList));

dataStruct.cpMatrix = [c1,c2,c3,oneList,oneList,oneList];
dataStruct.maskSize = size(myMatrix);
dataStruct.allRadii = radiusList;
dataStruct.allLabels = labelList;
dataStruct.allConfidences = radiusList.*0 +1;
dataStruct.origVectorProject = [];
dataStruct.origVectorProject.vectorProjectFolder = 'C:\MATLAB\R2007b\work';
dataStruct.origVectorProject.voxelSizeInMicrons = 1;
dataStruct.origVectorProject.strandifyParameters = strandifyParameters;
dataStruct.origVectorProject.vectorProjectRootName = 'EGrid';
dataStruct.origVectorProject.maskSize = size(myMatrix);
dataStruct.origVectorProject.volumeFileNames.permutedVascGrayscale = 'none';
dataStruct.origVectorProject.progressFlags = [];
dataStruct.origVectorProject.rootCodeFolder = '';
dataStruct.origVectorProject.note = '';

    vectorProject = RestrandifySE2_barebones(dataStruct);

vectorProject.progressFlags = [];
vectorProject.rootCodeFolder = '';
vectorProject.note = '';
vectorProject.cellCentroidAndLabelList = [];
vectorProject.thresholdRelaxationParameters = [];

save('Egrid-vectorProject.mat','vectorProject');
