


vs1 = vectorProject1.vectorizedStructure;
vs2 = vectorProject2.vectorizedStructure;
strands1 = vs1.Strands;
strands2 = vs2.Strands;
vertices1 = vs1.Vertices;
vertices2 = vs2.Vertices;
numVerts = numel(vertices2.AllRadii);
av1 = vertices1.AllVerts;
av2 = vertices2.AllVerts;

si1 = vertices1.StrandIndices;
si2 = vertices2.StrandIndices;

maskSize = vs1.maskSize;
ind1 = sub2ind(maskSize,av1(:,1),av1(:,2),av1(:,3));
ind2 = sub2ind(maskSize,av2(:,1),av2(:,2),av2(:,3));

changeList = [];
for vertIter = 1:numVerts,
    cc = av2(vertIter,:);
    thisInd2 = ind2(vertIter);
    pointer1 = find(ind1==thisInd2);
    if ~isempty(pointer1),
        thisStrandID1 = si1(pointer1(1),1);
        thisStrandID2 = si2(vertIter,1);
        thisStrand1 = strands1(thisStrandID1);
        thisStrand2 = strands2(thisStrandID2);
        current1 = abs(thisStrand1.strandCurrent);
        current2 = abs(thisStrand2.strandCurrent);
        changeList = [changeList;[cc,current2./current1]];
    end
end

%%
ratioFrame = zeros(maskSize(1),maskSize(2));
for changeIter = 1:size(changeList,1);
    thisChange = changeList(changeIter,:);
    ratioFrame(thisChange(1),thisChange(2)) = thisChange(4);
end


ratioFrame = min(ratioFrame,1);
imagesc(ratioFrame);colormap(hot);colorbar


