


vs1 = vectorProject1.vectorizedStructure;
vs2 = vectorProject2.vectorizedStructure;
strands1 = vs1.Strands;
strands2 = vs2.Strands;
vertices1 = vs1.Vertices;
vertices2 = vs2.Vertices;
numVerts = numel(vertices2.AllRadii);
av1 = vertices1.AllVerts;
av2 = vertices2.AllVerts;

si1 = vertices1.StrandIndices;
si2 = vertices2.StrandIndices;

maskSize = vs1.maskSize;
ind1 = sub2ind(maskSize,av1(:,1),av1(:,2),av1(:,3));
ind2 = sub2ind(maskSize,av2(:,1),av2(:,2),av2(:,3));

changeList = [];
for strandIter = 1:numel(strands1);
    thisStrand = strands1(strandIter);
    stei = thisStrand.StartToEndIndices;
    cc = av1(stei,:);
    current1 = abs(thisStrand.strandCurrent);
    logCurrent1 = repmat(log(current1+1),[numel(stei),1]);
    changeList = [changeList;[cc,logCurrent1]];
end
changeList(:,4) = changeList(:,4)./max(changeList(:,4));


%%
ratioFrame = zeros(maskSize(1),maskSize(2));
for changeIter = 1:size(changeList,1);
    thisChange = changeList(changeIter,:);
    ratioFrame(thisChange(1),thisChange(2)) = thisChange(4);
end


ratioFrame = min(ratioFrame,1);
imagesc(ratioFrame);colormap(hot);colorbar


