%Calculate the xy-distance of each downstream branch to its nearest source
%   where source = plunging arteriole offshoot.
%Plot distribution and mean xy-distance at each branchLevel, across all
%   sources



%Open a ...-Flow-VectorProject.



%%
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
flowProject.baseStrandIDList = vectorProject.vectorizedStructure.allPlungingArterioleList;
flowProject.maxBranchSearch = 15;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode

flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);



%%
numStrands = numel(flowProject.Strands);
meanYXZList = zeros(numStrands,3);
for strandIter = 1:numStrands,
    thisStrand = flowProject.Strands(strandIter);
    YXZLimits = thisStrand.YXZLimits;
    meanYXZ = mean(YXZLimits,2);
    meanYXZList(strandIter,:) = meanYXZ';
end
    
    
baseStrandIDList = flowProject.baseStrandIDList;
numBases = numel(baseStrandIDList);
meanDiameterList = [];
for baseIter = 1:numBases,
    thisBaseStrandID = baseStrandIDList(baseIter);
    thisBaseStrand = flowProject.Strands(baseIter);
    baseY = meanYXZList(thisBaseStrandID,1);
    baseX = meanYXZList(thisBaseStrandID,2);
    baseZ = meanYXZList(thisBaseStrandID,3);

    dsbl = flowProject.downstreamBranchList(:,baseIter);
    for branchIter = 1:flowProject.maxBranchSearch,
        f1 = find(dsbl==branchIter);
        f2 = [];
        for kk = 1:numel(f1);
            thisStrandID = f1(kk);
            %Don't count it if it is closer downstream to another baseStrand
            dsbl2 = flowProject.downstreamBranchList(thisStrandID,:);
            if min(dsbl2) == branchIter,
                f2 = [f2,thisStrandID];
            end%if min(dsbl2) == branchIter),
        end%for kk = 1:numel(f1);
        meanY = meanYXZList(f2,1);
        meanX = meanYXZList(f2,2);
        meanZ = meanYXZList(f2,3);
        dr = sqrt((meanY-baseY).^2 + (meanX-baseX).^2);
        
        maxZ = 1000;%Hardcode - only look down to this z-depth
        dr = dr(meanZ<maxZ);
        
        meanDiameterList(baseIter,branchIter) = 2*mean(dr);
        figure(2);plot(repmat(branchIter,size(dr)),dr,'r.');hold on
    end%for branchIter = 1:10,
end%for baseIter = 1:numBases;
hold off        
        
for branchIter = 1:flowProject.maxBranchSearch,
    subList = meanDiameterList(:,branchIter);
    subList2 = subList(~isnan(subList));
    meanD(branchIter) = mean(subList2);
end
figure(1);plot(meanD,'r-');
disp(meanD);

        











