%Load an FV file


%Plunging Arterioles starting points are the points of connection between
%a surface supply strand and a plunging supply strand
%surface supply labels = [330:339]
%plunging supply labels = [430:439]
label1List = [330:339]; %surface arterioles
label2List = [1:329,340:999]; %plunging arterioles
vectorizedStructure.maskSize = gds.maskSize;
vectorizedStructure.Vertices = gds.Vertices;
vectorizedStructure.Strands = gds.Strands;



[foundList1,foundList2] = LocateConnectingStrands(vectorizedStructure,label1List,label2List);

flowProject.plungingArterioleTopStrandList = foundList2;
gds.plungingArterioleTipList = foundList2;

%Plunging Venules starting points are the points of connection between
%a surface draining strand and a plunging draining strand
%surface draining labels = [340:349]
%plunging draining labels = [440:449]
label1List = [340:349]; %surface venules
label2List = [0:339,350:999]; %plunging venules
vectorizedStructure.maskSize = gds.maskSize;
vectorizedStructure.Vertices = gds.Vertices;
vectorizedStructure.Strands = gds.Strands;



[foundList1,foundList2] = LocateConnectingStrands(vectorizedStructure,label1List,label2List);

flowProject.plungingArterioleTopStrandList = foundList2;
gds.plungingVenuleTipList = foundList2;





%%

saveFileName = ['FVFile_',datestr(now,'yyyy_mm_dd-HHMMSS'),'.mat'];
[fileName,pathName] = uiputfile(saveFileName,'Save FV as...');
cd(pathName)
saveFileName = [fileName];
save(saveFileName,'gds');


