% function FlowFromStrand(vectorProject,startStrandID);

% % cd('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001')
% % load('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001\pbDB-LargestSubgraph-VectorProject-fast.mat')

% % vectorProject = CalculateUnperturbedFlow001(vectorProject);
% % vectorProject = FastVectorProject(vectorProject,'nosave');


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;
pathColorStorageList = zeros(size(AllVerts));
maxFlowFractionStorageList = zeros(size(Strands));
associatedStartStorageList = zeros(size(Strands));


divingVesselList = [1054 2208 96 2043 849 24 ...
                     3204 54 1921 2096 1569 244 1010 961 ...
                     946 778 1684 1694 2424 1213 3468 5330 1811 ...
                     2370 3730 ...
                     193 ...
                     1187 ...
                     4587 239]; 

               
maxZForSplit = 500;
minConductanceRatio = 0.1;

                 
                 

numStrands = numel(Strands);
numChanged = 999;

while numChanged > 0,
    newStartStrandList = [];
    numChanged = 0;
    numStartStrands = numel(divingVesselList);
    for startStrandIter = 1:numStartStrands;
        startStrandID = divingVesselList(startStrandIter);
%         disp([startStrandIter, startStrandID]);
        startStrand = Strands(startStrandID);
        ssiv = startStrand.InteriorVertices;
        startStrandCoordList = AllVerts(ssiv,:);
        strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        
        %Look at the low node, and find neighbors
        if lowVoltagePos == 1,
            neighborStrands = startStrand.StartVertexNeighborStrands;
        else%if lowVoltagePos == 1,
            neighborStrands = startStrand.EndVertexNeighborStrands;
        end%if-else lowVoltagePos == 1,
        neighborStrands = neighborStrands(neighborStrands~=startStrandID);
        daughterConductance(1) = Strands(neighborStrands(1)).strandConductance;
        daughterConductance(2) = Strands(neighborStrands(2)).strandConductance;
        conductanceRatio = min(daughterConductance)./max(daughterConductance);
        maxZ = max(startStrandCoordList(:,3));

        if maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
            newStartStrandList = [newStartStrandList,neighborStrands];
        else%if maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
            newStartStrandList = [newStartStrandList,startStrandID];
        end%if-else maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
    end%for startStrandIter = 1:numStartStrands;
divingVesselList = unique(newStartStrandList);
numChanged = numel(divingVesselList)-numStartStrands;
disp(numChanged)
end
    
    