% function FlowFromStrand(vectorProject,startStrandID);

% % cd('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001')
% % load('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001\pbDB-LargestSubgraph-VectorProject-fast.mat')

% % vectorProject = CalculateUnperturbedFlow001(vectorProject);
% % vectorProject = FastVectorProject(vectorProject,'nosave');



%Labels: 100=Unlabeled; 200=Temp ; 300=Surface ; 400=Plunging ; 500=Micro ;
%         10=Unlabeled ; 20=Temp ; 30=Supply ; 40=Draining ;  50=Connecting ;
%Therefore: SurfaceArtery=330; SurfaceVein = 340;



Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;
pathColorStorageList = zeros(size(AllVerts));
maxFlowFractionStorageList = zeros(size(Strands));
associatedStartStorageList = zeros(size(Strands));


% % % divingVesselList = [62 533 877 1199 1599 1181 220 698 ...
% % %  416 1249 896 394 410 10 458 1142 ...
% % %  1175 558 281 622 910 1114 496 1752 ...
% % %  1743 253 304 589 500 779 778 2122 ...
% % %  2023 84 74 1599];

% % divingVesselList = [62 877 1199 1599 1181 220 698 ...
% %  416 1249 896 394 410 10 458 1142 ...
% %  1175 558 281 622 910 1114 496 1752 ...
% %  1743 253 304 589 500 779 778 2122 ...
% %  2023 84 74 1599];

% % % divingVesselList = [533 877 1199 1599 1181 698 ...
% % %  416  1142 ...
% % %  558   ...
% % %  304 589 500 2122 ...
% % %  84 74 1599];
               
divingVesselList = [533 877  887 1287 1288 1199 1599 1181 698 ...
 416  1142 ...
 558   ...
 304 589 500 2122 ...
 84 74 1599];
               


maxZForSplit = 400;
minConductanceRatio = 0.1;

                 
                 

numStrands = numel(Strands);
numChanged = 999;

while numChanged > 0,
    newStartStrandList = [];
    numChanged = 0;
    numStartStrands = numel(divingVesselList);
    for startStrandIter = 1:numStartStrands;
        startStrandID = divingVesselList(startStrandIter);
%         disp([startStrandIter, startStrandID]);
        startStrand = Strands(startStrandID);
        ssiv = startStrand.InteriorVertices;
        startStrandCoordList = AllVerts(ssiv,:);
        strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        
        %Look at the low node, and find neighbors
        if lowVoltagePos == 1,
            neighborStrands = startStrand.StartVertexNeighborStrands;
        else%if lowVoltagePos == 1,
            neighborStrands = startStrand.EndVertexNeighborStrands;
        end%if-else lowVoltagePos == 1,
        neighborStrands = neighborStrands(neighborStrands~=startStrandID);
        daughterConductance(1) = Strands(neighborStrands(1)).strandConductance;
        daughterConductance(2) = Strands(neighborStrands(2)).strandConductance;
        conductanceRatio = min(daughterConductance)./max(daughterConductance);
        maxZ = max(startStrandCoordList(:,3));

        if maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
            newStartStrandList = [newStartStrandList,neighborStrands];
        else%if maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
            newStartStrandList = [newStartStrandList,startStrandID];
        end%if-else maxZ <= maxZForSplit && conductanceRatio > minConductanceRatio,
    end%for startStrandIter = 1:numStartStrands;
divingVesselList = unique(newStartStrandList);
numChanged = numel(divingVesselList)-numStartStrands;
disp(numChanged)
end
    
    