% function FlowFromStrand(vectorProject,startStrandID);


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
AllLabels = Vertices.AllLabels;
maskSize = vectorProject.maskSize;

%Labels: 100=Unlabeled; 200=Temp ; 300=Surface ; 400=Plunging ; 500=Micro ;
%         10=Unlabeled ; 20=Temp ; 30=Supply ; 40=Draining ;  50=Connecting ;
%Therefore: SurfaceArtery=330; SurfaceVein = 340;
searchLabelList = [430:439];
divFactor = 3;
candidatePointList = find(ismember(AllLabels,searchLabelList));
candidateStrandIDList = StrandIndices(candidatePointList);
candidateCoordList = AllVerts(candidatePointList,:);
uniqueCandidateStrandIDList = unique(candidateStrandIDList);
numCandidateStrands = numel(uniqueCandidateStrandIDList);
myMask = zeros(ceil(maskSize./divFactor));
for strandIter = 1:numCandidateStrands,
    thisStrandID = uniqueCandidateStrandIDList(strandIter);
    thisStrand = Strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    ccc = ceil(AllVerts(stei,:)./divFactor);
    myMask(ccc(:,1),ccc(:,2),ccc(:,3)) = thisStrandID;
end

L = bwlabeln(myMask>0);
numClusters = max(L(:));
highestStrandIDList = [];
highestStrandCoordList = [];
for clusterIter = 1:numClusters,
    clusterStrandList = unique(myMask(L==clusterIter));
    minZPosList = [];
    for strandIter = 1:numel(clusterStrandList),
        thisStrandID = clusterStrandList(strandIter);
        thisStrand = Strands(thisStrandID);
        iv = thisStrand.InteriorVertices;
        zPosList = AllVerts(iv,3);
        minZPosList(strandIter) = min(zPosList);
    end
    [minVal,minIndex] = min(minZPosList);
    highestStrandID = clusterStrandList(minIndex);
    highestStrand = Strands(highestStrandID);
    highestStrandIDList(clusterIter) = highestStrandID;
    highestStrandCoordList(clusterIter,:) = AllVerts(highestStrand.InteriorVertices(1),:);
end

disp(highestStrandIDList');
disp(highestStrandCoordList);
       
        
    