
%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];
perturbedProject = vectorProject;
cleanupFlag = 1;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;




%%%Stage 2: Find the offshoots of plunging arterioles
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
flowProject.baseStrandIDList = vectorProject.vectorizedStructure.allPlungingArterioleList;
flowProject.maxBranchSearch = 2;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);

offshootList = find(min(flowProject.downstreamBranchList,[],2)==1);

    offshootList = vectorProject.vectorizedStructure.plungingArterioleTipList;

numOffshoots = numel(offshootList);

%%
%Pick an offshoot: track it down to the first node that is a converging (versus diverging) branch.

myChoice = 30;
purelyDivergentStrandSet = [];
allDownstreamStrandSet = [];

for myChoice = 1:numOffshoots,
    startStrandID = offshootList(myChoice)
    flowProject.baseStrandIDList = startStrandID;
    flowProject.maxBranchSearch = 20;
    flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);

    downstreamPathList = flowProject.downstreamPathList{1};
    numPaths = numel(downstreamPathList);
    purelyDivergentStrandList = [];
    allDownstreamStrandList = [];
    for pathIter = 1:numPaths,
        thisPath = downstreamPathList{pathIter};
        numStrands = numel(thisPath);
        allDownstreamStrandList = [allDownstreamStrandList,thisPath];
        for strandIter = 1:numStrands-1;
            rootStrandID = thisPath(strandIter);
            childStrandID = thisPath(strandIter+1);
            childStrand = strands(childStrandID);
            svns = childStrand.StartVertexNeighborStrands;
            evns = childStrand.EndVertexNeighborStrands;
            neighborList = [];
            if ismember(rootStrandID,svns),neighborList = svns; end
            if ismember(rootStrandID,evns),neighborList = evns; end
            neighborList = neighborList(neighborList~=rootStrandID);
            neighborList = neighborList(neighborList~=childStrandID);
            childVoltage = childStrand.StartVoltage;
            neighborVoltageList = [strands(neighborList).MedianVoltage];
            neighborUpstreamFlagList = neighborVoltageList > childVoltage;
% % % if rootStrandID == 1585, disp('1585!!!');pause;end
            if sum(neighborUpstreamFlagList) == 0,
                %all neighbors are downstream, and this is a purely divergent branch
                convergentBranchFlag = 0;
                purelyDivergentStrandList = [purelyDivergentStrandList,rootStrandID];
            else%if sum(neighborUpstreamFlagList) == 0,
                convergentBranchFlag = 1;
                break
            end%if-else sum(neighborUpstreamFlagList) == 0,
        end%for strandIter...
    end%for pathIter...

    purelyDivergentStrandList = unique(purelyDivergentStrandList);
    allDownstreamStrandList = unique(allDownstreamStrandList);
    purelyDivergentStrandSet{myChoice} = purelyDivergentStrandList;
    allDownstreamStrandSet{myChoice} = allDownstreamStrandList;
    
    
    myRatio = numel(purelyDivergentStrandList) ./ numel(allDownstreamStrandList)
    
    
end%for myChoice ...




%%


myChoice = 9;
rand('seed',27)
for myChoice = 1:numOffshoots
divergentStrandList = purelyDivergentStrandSet{myChoice};


y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

% z1 = 400;z2 = 700;

activeIndices = [vectorProject.vectorizedStructure.Strands(divergentStrandList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(1);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
set(p1,'Color',[rand(1,3)*0.7]);
hold on

end

% % activeStrands = find(currentRatioList>thresholdRatio);
% % activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrands).StartToEndIndices];
% % av = vectorProject.vectorizedStructure.Vertices.AllVerts;
% % av = av(activeIndices,:);
% % activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
% % p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'r.');
% % set(p1,'MarkerSize',1);
% % hold on
% % 
% % 
% % dilationIndices = [vectorProject.vectorizedStructure.Strands(dilationPath).StartToEndIndices];
% % dilationCoords = [vectorProject.vectorizedStructure.Vertices.AllVerts(dilationIndices,:)];
% % p1 = plot3(dilationCoords(:,1),dilationCoords(:,2),-1*dilationCoords(:,3),'g.');
% % set(p1,'MarkerSize',2);
% % hold off


%%
strandSumList = zeros(numel(strands),1);
for myChoice = 1:numOffshoots,
    allDownstreamStrandList = allDownstreamStrandSet{myChoice};
    strandSumList(allDownstreamStrandList) = strandSumList(allDownstreamStrandList) + 1;
end



y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

z1 = 400;z2 = 700;
thisSubsetList = strandSumList ==1 ;
activeIndices = [vectorProject.vectorizedStructure.Strands(thisSubsetList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(2);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
set(p1,'Color',[rand(1,3)*0.7]);
hold on


