
rand('seed',77);

%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];
perturbedProject = vectorProject;
cleanupFlag = 1;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;



%%%Stage 2: Find the offshoots of plunging arterioles
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
startList = vectorProject.vectorizedStructure.plungingArterioleTipList;
flowProject.baseStrandIDList = startList;
flowProject.maxBranchSearch = 20;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
disp('Calculating downstream paths...');
tic
fullFlowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
toc
%%

includedStrandList = [];

for excludeNum = 1:44
    disp(excludeNum);




    downstreamPathList = fullFlowProject.downstreamPathList;
    numPaths = numel(downstreamPathList);
    fullPath = [];
    for pathIter = 1:numPaths,
        if pathIter ~=excludeNum,
            thisPath = downstreamPathList{pathIter};
            thisPath = [thisPath{:}];
            thisPath = unique(thisPath);
            fullPath = [fullPath,thisPath];
        end%if pathIter...
    end%for pathIter..
    fullPath = unique(fullPath);

%-----
startList = vectorProject.vectorizedStructure.plungingArterioleTipList;
flowProject.baseStrandIDList = startList(excludeNum);
flowProject.maxBranchSearch = 20;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);    
%-----    
thisPath = flowProject.downstreamPathList{1};
thisPath = unique([thisPath{:}]);

activeStrandList = zeros(numel(strands),1);
activeStrandList(thisPath) = 1;
activeStrandList(fullPath) = 0;
activeStrandList = find(activeStrandList);
includedStrandList = [includedStrandList;activeStrandList];





y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

% z1 = 400;z2 = 700;

activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrandList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(3);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
myColor = [rand(1,3)*0.7];
set(p1,'Color',myColor);
hold on



z1 = 400;z2 = 600;

activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrandList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(4);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
myColor = [rand(1,3)*0.7];
set(p1,'Color',myColor);
hold on


end%for excludeNum...

%%
includedStrandFlagList = zeros(numel(strands),1);
includedStrandFlagList(includedStrandList) = 1;
unusedStrandList = find(includedStrandFlagList == 0);



y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

activeIndices = [vectorProject.vectorizedStructure.Strands(unusedStrandList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(5);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
myColor = [0 0 0];
set(p1,'Color',myColor);




z1 = 800;z2 = 1200;

activeIndices = [vectorProject.vectorizedStructure.Strands(unusedStrandList).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
figure(6);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
set(p1,'MarkerSize',1);
myColor = [0 0 0];
set(p1,'Color',myColor);






