% % load('F:\Phil\VectorProjects\allProject03c_withVelocity.mat');
% % load('F:\Phil\VectorProjects\tempFlowProjectDB.mat');


vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
velocityListUMs = vectorizedStructure.velocityListMMs'*1000;
strandLengthList = vectorizedStructure.strandLengthList;
strands = vectorizedStructure.Strands;
barrels = vectorProject.barrelBoundaryParameters.barrels;
maskSize = vectorProject.maskSize;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
expandedVerts = [allVerts,[1:size(allVerts,1)]'];
strandIndices = full(vertices.StrandIndices);


%%

barrelIter = 9;

thisBarrel = barrels{barrelIter};
barrelMinZ = min(thisBarrel(:,3));
barrelMaxZ = max(thisBarrel(:,3));
barrelMinY = min(thisBarrel(:,1));
barrelMaxY = max(thisBarrel(:,1));
barrelMinX = min(thisBarrel(:,2));
barrelMaxX = max(thisBarrel(:,2));
flatMask = zeros(maskSize(1),maskSize(2));
for pointIter = 1:size(thisBarrel,1);
    pointCC = thisBarrel(pointIter,:);
    flatMask(pointCC(1),pointCC(2)) = 1;
end
flatMask = imclose(flatMask,circle2d(5));
flatMask = imfill(flatMask>0,'holes');

flag1 = and(allVerts(:,1)>=barrelMinY,allVerts(:,1)<=barrelMaxY);
flag2 = and(allVerts(:,2)>=barrelMinX,allVerts(:,2)<=barrelMaxX);
flag3 = and(allVerts(:,3)>=barrelMinZ,allVerts(:,3)<=barrelMaxZ);
flag4 = and(and(flag1,flag2),flag3);
subVerts = expandedVerts(flag4,:);
subInd = sub2ind(maskSize(1:2),subVerts(:,1),subVerts(:,2));
insideFlag = flatMask(subInd);
insideVerts = subVerts(insideFlag,:);
insideStrands = unique(strandIndices(insideVerts(:,4),1));



figure(1);imagesc(flatMask);


