% function FlowFromStrand(vectorProject,startStrandID);

% % % cd('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001')
% % % load('F:\Phil\AOH_Datasets\pbDB\pbDBVector\VectorProjectFolder\DyeTraceTests\DyeTrace001\pbDB-LargestSubgraph-VectorProject-fast.mat')
% % % 
% % % vectorProject = CalculateUnperturbedFlow001(vectorProject);
% % % vectorProject = FastVectorProject(vectorProject,'nosave');


Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;
pathColorStorageList = zeros(size(AllVerts));
maxFlowFractionStorageList = zeros(size(AllVoltages));
maxFlowFractionStorageList = zeros(size(AllVoltages));

        highV = find(AllVoltages>90);
        AllLabels = Vertices.AllLabels;
        highVLabels = AllLabels(highV);
        sub1 = ismember(highVLabels,[430:439]);
        highV2 = highV(sub1);
        divingVesselList = unique(StrandIndices(highV2));

% % % divingVesselList = [600 244 401 1213 193 24 1684 849 ...
% % %                  96 22 196 93 2255 2424 53 2534 ...
% % %                  3626 3730 240 4675 5330];

             
% % % divingVesselList = [2651 2883 1054 2208 96 2043 849 24 ...
% % %                      3204 54 1921 2096 1569 244 1010 961 ...
% % %                      946 778 1684 1694 2424 1213 3467 1811...
% % %                      2370 3730
% % %                      1438 1437 1811 192 ...
% % %                      1239 1118 402 ...
% % %                      4587 239];
    
% % divingVesselList = [1054 2208 96 2043 849 24 ...
% %                      3204 54 1921 2096 1569 244 1010 961 ...
% %                      946 778 1684 1694 2424 1213 3467 1811 ...
% %                      2370 3730 ...
% %                      193 ...
% %                      1187 ...
% %                      240];           
             
 divingVesselList = [24 54 96 193 239 244 779 849 ...
 899 900 901 905 946 961 1007 1010 ...
 1053 1188 1213 1239 1569 1684 1694 1811 ...
 1921 2045 2097 2208 2370 2424 2462 2669 ...
 2670 3204 3730 4271 4529 4570 4587 4675 ...
 4676 5189 5283 5330 5787 5853 6626 6792];
                 
                 
                 
for startIter = 1:length(divingVesselList);
    startStrandID = divingVesselList(startIter);
    stopVoltage = 50.5;
    minimumFluxFraction = 1/3000;
    divFactor = 3;
    maxVoltage = 100;
    disp([startIter, startStrandID]);


numStrands = numel(Strands);
startStrand = Strands(startStrandID);
ssiv = startStrand.InteriorVertices;
startStrandCoordList = AllVerts(ssiv,:);

strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
nodeVoltages = AllVoltages(strandNodes);
[highVoltage,highVoltagePos] = max(nodeVoltages);
[lowVoltage,lowVoltagePos] = min(nodeVoltages);
highNode = strandNodes(highVoltagePos);
lowNode = strandNodes(strandNodes~=highNode);

pathActiveFlagList = false(1,100000);
pathActiveFlagList(1) = 1;
numActivePath = sum(pathActiveFlagList);
strandPathList = {};
nodePathList = {};
fractionPathList = {};
strandPathList{1} = startStrandID;
nodePathList{1} = [highNode lowNode];
fractionPathList{1} = 1;
strandFlowList = zeros(numStrands,1);
strandFlowList(startStrandID) = 1;
strandVoltageList = zeros(numStrands,1);
strandVoltageList(1) = mean([highVoltage,lowVoltage]);
pathCounter = 1;
keepGoingFlag = 1;
myCamPos = [0 0 0];
myCamUp = [-1 0 0];
myCamVA = 6.6086;

while (keepGoingFlag == 1),
    myCount = 0;
%     keyboard
    for pathIter = find(pathActiveFlagList == 1);
        currentPathID = pathIter;
        currentStrandPath = strandPathList{pathIter};
        currentNodePath = nodePathList{pathIter};
        currentFractionPath = fractionPathList{pathIter};
        currentStrandID = currentStrandPath(end);
        currentStrand = Strands(currentStrandID);
        %-----
        strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);
        lowAttachedStrands = StrandIndices(lowNode,:);
        lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
        lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
        numDaughterPaths = numel(lowAttachedStrands);
        strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
        stopTracingFlag = 0;
        if numDaughterPaths == 0, stopTracingFlag = 1; end
        if lowVoltage < stopVoltage, stopTracingFlag = 1; end
        if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
        if stopTracingFlag == 1,
            pathActiveFlagList(currentPathID) = 0;
        else%if stopTracingFlag == 1,
            motherCurrent = abs(currentStrand.strandCurrent);
            validDaughterCounter = 0;
            validDaughterStrandList = [];
            validDaughterCurrentList = zeros(1,numDaughterPaths);
            validDaughterPathIndexList = [];
            for daughterIter = 1:numDaughterPaths,
                %Check to see if the daughter strand leads to a lower voltage
                candidateDaughterID = lowAttachedStrands(daughterIter);
                candidateDaughterStrand = Strands(candidateDaughterID);
                candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                candidateDaughterOtherVoltage = AllVoltages(candidateDaughterOtherNode);
                if candidateDaughterOtherVoltage < lowVoltage,
                    %if so, add the strand to a path
                    myCount = myCount + 1;
                    validDaughterCounter = validDaughterCounter + 1;
                    validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                    validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                    if validDaughterCounter == 1,
                        %if this is the first valid daughter, add to current path
                        strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                        nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                        validDaughterPathIndexList(1) = currentPathID;
                    else%if validDaughterCounter == 1,
                        %if not the first daughter, duplicate path up to this point, and
                        %make new path
                        pathCounter = pathCounter + 1;
                        strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                        nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                        fractionPathList{pathCounter} = currentFractionPath;
                        pathActiveFlagList(pathCounter) = 1;  
                        validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                    end%if-else validDaughterCounter == 1,
                end%if candidateDaughterOtherVoltage < lowVoltage,
            end%for daughterIter = 1:numDaughterPaths,
            clear daughterIter
            %-----
            daughterSumCurrent = sum(validDaughterCurrentList);
            fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
            for validDaughterIter = 1:validDaughterCounter;
                validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
            end%for validDaughterIter = 1:validDaughterCounter;
        end%if-else stopTracingFlag == 1,
    end%for pathIter = find(pathActiveFlagList == 1);
    if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
    if myCount == 0, keepGoingFlag = 0;end
%     disp([myCount]);
    
end%while (keepGoingFlag == 1),

% clear candidate* current* high* low* keep* valid* *Iter


% % clear qq;for k = 1:numel(fractionPathList);q = fractionPathList{k};q = q(q~=0);qq(k) = q(end);end
% % sum(qq)

% % numPaths = numel(strandPathList);
% % for pathIter = 1:numPaths,
% %     thisStrandPath = strandPathList{pathIter};
% %     thisNodePath = nodePathList{pathIter};
% %     pathCurrentList = abs([Strands(thisStrandPath).strandCurrent]);
% %     pathVoltageList = AllVoltages(thisNodePath);
% %     figure(1);semilogy(pathCurrentList,'b-')
% %     figure(2);plot(pathVoltageList,'r-');
% %     pause(0.1);
% % end

% % % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % % divMaskSize = size(myMask);
% % % numPaths = numel(strandPathList);
% % % for pathIter = 1:numPaths,
% % %     thisStrandPath = strandPathList{pathIter};
% % %     pathIndexList = abs([Strands(thisStrandPath).InteriorVertices]);
% % %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % %     myMask(maskIndexList) = myMask(maskIndexList)+1;
% % % end
% % %     
% % % maketiff(myMask,'testMask.tif');


% % % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % % divMaskSize = size(myMask);
% % % numPaths = numel(strandPathList);
% % % for pathIter = 1:numPaths,
% % %     thisStrandPath = strandPathList{pathIter};
% % %     thisFractionPath = fractionPathList{pathIter};
% % %     numSegments = numel(thisStrandPath);
% % %     for segmentIter = 1:numSegments;
% % %         pathIndexList = Strands(thisStrandPath(segmentIter)).InteriorVertices;
% % %         pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % %         maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % %         myMask(maskIndexList) = max(myMask(maskIndexList),thisFractionPath(segmentIter)*255);
% % %     end%for segmentIter = 1:numSegments;
% % % end%for pathIter = 1:numPaths,
% % % 
% % % 




% % %Generate a flow distribution mask
% % myMask = zeros(ceil(maskSize/divFactor),'uint8');
% % voltageMask = zeros(ceil(maskSize/divFactor),'uint8');
% % divMaskSize = size(myMask);
% % activeStrandList = find(strandFlowList>0);
% % numActiveStrands = numel(activeStrandList);
% % for strandIter = 1:numActiveStrands 
% %     thisStrandID = activeStrandList(strandIter);
% %     thisStrand = Strands(thisStrandID);
% %     pathIndexList = thisStrand.InteriorVertices;
% %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% %     myMask(maskIndexList) = ceil(strandFlowList(thisStrandID)*255);
% %     voltageMask(maskIndexList) = 255*strandVoltageList(thisStrandID)./maxVoltage;
% % end%for pathIter = 1:numPaths,
% % maketiff(myMask,['FlowMask_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);
% % maketiff(voltageMask,['VoltageMask_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);




% % % % %Generate a plot
% % % % myR = zeros(256,1);
% % % % myG = zeros(256,1);
% % % % myB = zeros(256,1);
% % % % myR(257-200:256) = linspace(1,255,200);
% % % % myG(0+1:0+64) = linspace(1,255,64);
% % % % myG(64+1:64+32) = linspace(255,1,32);
% % % % myB(1:64) = linspace(255,1,64);
% % % % myColorMap = [myR,myG,myB]./256;
% % % % %-----
% % % % figure(1);plot(myR,'r-');
% % % % hold on
% % % % figure(1);plot(myG,'g-');
% % % % figure(1);plot(myB,'b-');
% % % % hold off
% % % % %-----
% % % % divMaskSize = size(myMask);
% % % % activeStrandList = find(strandFlowList>0);
% % % % numActiveStrands = numel(activeStrandList);
% % % % ff = figure(10);
% % % % myCamPos = campos;
% % % % myCamUp = camup;
% % % % myCamVA = camva;
% % % % cameratoolbar
% % % % for strandIter = 1:numActiveStrands 
% % % %     thisStrandID = activeStrandList(strandIter);
% % % %     thisStrand = Strands(thisStrandID);
% % % %     pathIndexList = thisStrand.InteriorVertices;
% % % %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % % %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % % %     p3 = plot3(pathCoordList(:,1),pathCoordList(:,2),-1*pathCoordList(:,3),'ro');hold on
% % % %     thisStrandFlow = ceil(strandFlowList(thisStrandID)*255);
% % % %     thisStrandVoltage = ceil(255*(strandVoltageList(thisStrandID)-49)./51);
% % % %     set(p3,'MarkerSize',thisStrandFlow/20);
% % % %     set(p3,'Color',myColorMap(thisStrandVoltage,:))
% % % % end%for pathIter = 1:numPaths,
% % % % ssccc = ceil(startStrandCoordList./divFactor);
% % % % p4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');
% % % % set(p4,'MarkerSize',7);
% % % % xlabel('Axis 1');
% % % % ylabel('Axis 2');
% % % % zlabel('Axis 3');
% % % % plot3(0,0,0,'b.');
% % % % plot3(500,500,-500,'b.');
% % % % campos(myCamPos)
% % % % camup(myCamUp);
% % % % camva(myCamVA);
% % % % hold off
% % % % % saveas(ff,['Figure_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);
% % % % pause



%Generate a plot
myR = zeros(256,1);
myG = zeros(256,1);
myB = zeros(256,1);
myR(257-200:256) = linspace(1,255,200);
myG(0+1:0+64) = linspace(1,255,64);
myG(64+1:64+32) = linspace(255,1,32);
myB(1:64) = linspace(255,1,64);


myColorVector = rand(1,3);
myR = [0:255]'*myColorVector(1);
myG = [0:255]'*myColorVector(2);
myB = [0:255]'*myColorVector(3);

myColorMap = [myR,myG,myB]./256;
%-----
%-----
divMaskSize = ceil(maskSize./divFactor);
activeStrandList = find(strandFlowList>0);
numActiveStrands = numel(activeStrandList);
ff = figure(10);
myCamPos = campos;
myCamUp = camup;
myCamVA = camva;
cameratoolbar
for strandIter = 1:numActiveStrands 
    thisStrandID = activeStrandList(strandIter);
    thisStrand = Strands(thisStrandID);
    pathIndexList = thisStrand.InteriorVertices;
    pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
    maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
    p3 = plot3(pathCoordList(:,1),pathCoordList(:,2),-1*pathCoordList(:,3),'ro');hold on
    thisStrandFlow = ceil(strandFlowList(thisStrandID)*255);
    thisStrandVoltage = ceil(255*(strandVoltageList(thisStrandID)-49)./51);
    set(p3,'MarkerSize',thisStrandFlow/20);
%     set(p3,'Color',myColorMap(thisStrandVoltage,:))
    set(p3,'Color',myColorMap(end,:))
end%for pathIter = 1:numPaths,
ssccc = ceil(startStrandCoordList./divFactor);
p4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');
set(p4,'MarkerSize',7);
xlabel('Axis 1');
ylabel('Axis 2');
zlabel('Axis 3');
plot3(0,0,0,'b.');
plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');
campos(myCamPos)
camup(myCamUp);
camva(myCamVA);
hold off
% saveas(ff,['Figure_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);


fp = figure(11);
pp4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');hold on
plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');


% % % % 
% % % % 
% % % % %Generate an dominant flow map 
% % % % divMaskSize = ceil(maskSize./divFactor);
% % % % activeStrandList = find(strandFlowList>0);
% % % % numActiveStrands = numel(activeStrandList);
% % % % for strandIter = 1:numActiveStrands 
% % % %     thisStrandID = activeStrandList(strandIter);
% % % %     thisStrand = Strands(thisStrandID);
% % % %     pathIndexList = thisStrand.InteriorVertices;
% % % %     pathCoordList = ceil(AllVerts(pathIndexList,:)/divFactor);
% % % %     maskIndexList = sub2ind(divMaskSize,pathCoordList(:,1),pathCoordList(:,2),pathCoordList(:,3));
% % % %     p3 = plot3(pathCoordList(:,1),pathCoordList(:,2),-1*pathCoordList(:,3),'ro');hold on
% % % %     thisStrandVoltage = ceil(255*(strandVoltageList(thisStrandID)-49)./51);
% % % %     thisStrandFlow = ceil(strandFlowList(thisStrandID)*255);
% % % %     thisStrandColor = myColorMap(thisStrandFlow,:);
% % % %     pathColorStorageList(pathIndexList,1) = pathColorStorageList(pathIndexList,1) + thisStrandColor(1);
% % % %     pathColorStorageList(pathIndexList,2) = pathColorStorageList(pathIndexList,2) + thisStrandColor(2);
% % % %     pathColorStorageList(pathIndexList,3) = pathColorStorageList(pathIndexList,3) + thisStrandColor(3);
% % % %     set(p3,'MarkerSize',thisStrandFlow/20);
% % % % %     set(p3,'Color',myColorMap(thisStrandVoltage,:))
% % % %     set(p3,'Color',myColorMap(thisStrandFlow,:))
% % % % end%for pathIter = 1:numPaths,
% % % % pathColorStorageList = min(pathColorStorageList,1);
% % % % ssccc = ceil(startStrandCoordList./divFactor);
% % % % % p4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');
% % % % % set(p4,'MarkerSize',7);
% % % % xlabel('Axis 1');
% % % % ylabel('Axis 2');
% % % % zlabel('Axis 3');
% % % % plot3(0,0,0,'b.');
% % % % plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');
% % % % campos(myCamPos)
% % % % camup(myCamUp);
% % % % camva(myCamVA);
% % % % set(gca,'Color',[0,0,0]);
% % % % hold off
% % % % % saveas(ff,['Figure_StartStrand_',num2str(startStrandID,'%05d'),'.tif']);
% % % % 
% % % % 
% % % % % % fp = figure(11);
% % % % % % pp4 = plot3(ssccc(:,1),ssccc(:,2),-1*ssccc(:,3),'ko');hold on
% % % % % % plot3(ceil(1500/divFactor),ceil(1500/divFactor),ceil(-1300./divFactor),'b.');
% % % % % % 
% % % % 

pause;


end%for startIter = 1:...

% % % 
% % % 
% % % f12 = figure(12);
% % % numVertices = numel(AllVoltages);
% % % for kk = 1:3:numVertices,
% % %     ccc = AllVerts(kk,:);
% % %     thisColor = pathColorStorageList(kk,:);
% % %     pp = plot3(ccc(1),ccc(2),-1*ccc(3),'r.');
% % %     set(pp,'MarkerSize',5);
% % %     set(pp,'Color',thisColor);
% % %     hold on
% % %     if mod(kk,20000)==0,pause;end
% % % end
% % % 
% % % 
