%From each plunging tip, follow the major downstream flow along the branch
%that has the most current stopping when the branch is not mostly vertical
%(with the caveat that it ignores short sideways strands)


%Load an FV file

vertFractionRange = [0 1];
radiusRange = [1 3];
lengthRange = [20 50];

cutoffVerticalFraction = 0.5;
minStrandLength = [2 4];


baseStrandIDList = gds.baseStrandIDList;
numBases = numel(baseStrandIDList);
numStrands = numel(gds.Strands);
majorPathList = [];

%Calculate the high flow path for each base Strand
for baseIter = 1:numBases;
    keepGoingFlag = 1;
        thisPath = [];
        thisStrandID = baseStrandIDList(baseIter);
        thisStrand = gds.Strands(thisStrandID);

    while keepGoingFlag == 1,
        thisPath = [thisPath,thisStrandID];
        startVoltage = gds.Vertices.AllVoltages(thisStrand.StartVertexIndex);
        endVoltage = gds.Vertices.AllVoltages(thisStrand.EndVertexIndex);
        %---
        if startVoltage > endVoltage,
            lowerVoltage = endVoltage;
            lowerNeighbors = thisStrand.EndVertexNeighborStrands;
        else
            lowerVoltage = startVoltage;
            lowerNeighbors = thisStrand.StartVertexNeighborStrands;
        end
        lowerNeighbors = lowerNeighbors(lowerNeighbors~=thisStrandID);
        
        lowerNeighborCurrents = abs([gds.Strands(lowerNeighbors).strandCurrent]);
        highFlowIndex = find(lowerNeighborCurrents == max(lowerNeighborCurrents));
        highFlowNeighbor = lowerNeighbors(highFlowIndex);
        
        %Check - if highFlowNeighbor isn't vertical , try another neighbor
        thisStrandID = highFlowNeighbor;
        thisStrand = gds.Strands(thisStrandID);
        startVoltage = gds.Vertices.AllVoltages(thisStrand.StartVertexIndex);
        endVoltage = gds.Vertices.AllVoltages(thisStrand.EndVertexIndex);
        startZ = gds.Vertices.AllVerts(thisStrand.StartVertexIndex,3);
        endZ = gds.Vertices.AllVerts(thisStrand.EndVertexIndex,3);
        if startVoltage>endVoltage,
            dz = endZ-startZ;
        else
            dz = startZ-endZ;
        end
        strandLength = numel(thisStrand.StartToEndIndices);
        zFraction = dz/strandLength;
        if zFraction < cutoffVerticalFraction && strandLength > minStrandLength,
            lowerNeighbors = lowerNeighbors(lowerNeighbors~=thisStrandID);
            lowerNeighborCurrents = abs([gds.Strands(lowerNeighbors).strandCurrent]);
            highFlowIndex = find(lowerNeighborCurrents == max(lowerNeighborCurrents));
            highFlowNeighbor = lowerNeighbors(highFlowIndex);
            thisStrandID = highFlowNeighbor;
            thisStrand = gds.Strands(thisStrandID);

            startVoltage = gds.Vertices.AllVoltages(thisStrand.StartVertexIndex);
            endVoltage = gds.Vertices.AllVoltages(thisStrand.EndVertexIndex);
            startZ = gds.Vertices.AllVerts(thisStrand.StartVertexIndex,3);
            endZ = gds.Vertices.AllVerts(thisStrand.EndVertexIndex,3);
            if startVoltage>endVoltage,
                dz = endZ-startZ;
            else
                dz = startZ-endZ;
            end
            strandLength = numel(thisStrand.StartToEndIndices);
            zFraction = dz/strandLength;
        end%if zFraction....
        
        %if both neighbors don't qualify, then stop
        if zFraction < cutoffVerticalFraction && strandLength > minStrandLength,    
            keepGoingFlag = 0;
        end%if zFraction...

    end%while keepGoingFlag == 1,
    majorPathList{baseIter} = thisPath;
    
end%for baseIter
    

    

