
%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];
perturbedProject = vectorProject;
cleanupFlag = 1;


%%Stage 2: Find the offshoots of plunging arterioles

pathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;
numPaths = numel(pathList);

rand('seed',sum(clock));
myChoice = ceil(rand(1)*numPaths)



dilationFraction = 1.1;
myChoice = 23;%DB tip Strand 855

myChoice = 18;%27;30;32;34;40;18



dilationPath = pathList{myChoice}
% dilationPath = dilationPath(1:ceil(numel(dilationPath)/2))
origRadiusList = [vectorProject.vectorizedStructure.effectiveStrandRadiusList(dilationPath)]
perturbedProject.vectorizedStructure.effectiveStrandRadiusList(dilationPath) = origRadiusList * dilationFraction;


%Stage 4: Calculate the perturbed flow surface vessel endpoints are held at fixed
%           voltages (100 and 50) using effect Strand Radii & true lengths


perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
disp('Flow Calculation completed');


%%
%Stage 5: compare the two results
origCurrentList = [vectorProject.vectorizedStructure.Strands(:).strandCurrent];
perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
currentRatioList = abs(perturbedCurrentList./origCurrentList);
f1 = figure(2);
set(f1,'DoubleBuffer','on');
clf

thresholdRatio = 1.1;



% % figure(1);p1 = plot3(av(:,1),av(:,2),-1*av(:,3),'y.');hold on
% % set(p1,'MarkerSize',1);

y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

zo = 100; dz = 100; z1 = zo-dz;z2 = zo+dz;

activeStrands = find(currentRatioList<1/thresholdRatio);
activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrands).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
% % p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
% % set(p1,'MarkerSize',1);
hold on

activeStrands = find(currentRatioList>thresholdRatio);
activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrands).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'r.');
set(p1,'MarkerSize',1);
hold on


dilationIndices = [vectorProject.vectorizedStructure.Strands(dilationPath).StartToEndIndices];
dilationCoords = [vectorProject.vectorizedStructure.Vertices.AllVerts(dilationIndices,:)];
p1 = plot3(dilationCoords(:,1),dilationCoords(:,2),-1*dilationCoords(:,3),'g.');
set(p1,'MarkerSize',2);
hold off


%%
%Option 6: tesselate the zone of increased flow
origCurrentList = [vectorProject.vectorizedStructure.Strands(:).strandCurrent];
perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
currentRatioList = abs(perturbedCurrentList./origCurrentList);
f3 = figure(3); colormap(gray);
set(f3,'DoubleBuffer','on');
clf

thresholdRatio = 1.1;


y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

zo = 600; dz = 100; z1 = zo-dz;z2 = zo+dz;

activeStrands = find(currentRatioList>thresholdRatio);
activeIndices = [vectorProject.vectorizedStructure.Strands(activeStrands).StartToEndIndices];
av = vectorProject.vectorizedStructure.Vertices.AllVerts;
av = av(activeIndices,:);
activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);

maskSize = vectorProject.maskSize;
myBlock = zeros(maskSize(1),maskSize(2),2*dz+1);
blockSize = size(myBlock);
blockCoords = activeCoords;
blockCoords(:,3) = activeCoords(:,3) - z1 +1;
blockIndices = sub2ind(blockSize,blockCoords(:,1),blockCoords(:,2),blockCoords(:,3));
myBlock(blockIndices) = 1;

myFrame = max(myBlock,[],3);
figure(3);imagesc(myFrame);

myFilter = double(circle2d(39));%39 = 13*3;
filtFrame = imfilter(myFrame,myFilter);
figure(3);imagesc(filtFrame);

threshFrame = filtFrame>39;
figure(3);imagesc(threshFrame);

closeFrame = imclose(threshFrame,myFilter>0);
figure(3);imagesc(closeFrame);

bwFrame = bwlabeln(closeFrame>0);
myProps = regionprops(bwFrame,'Area','Centroid');
areaList = [myProps.Area];
[maxArea,maxPos] = max(areaList);
singleFrame = bwFrame == maxPos;
myCentroid = round(myProps(maxPos).Centroid);
myRadius = sqrt(maxArea/pi);
figure(3);imagesc(singleFrame);

fillFrame = imfill(singleFrame,'holes');
figure(3);imagesc(fillFrame);

circleFrame = false(size(myFrame));
circleFrame(myCentroid(2),myCentroid(1)) = 1;
circleFrame = bwdist(circleFrame);
circleFrame = circleFrame<myRadius;
figure(4);imagesc(circleFrame);colormap(gray);



