function myColorSpace = GenerateColorSpace(varargin)

displayFlag = 0;

if nargin == 0,
    numDesiredColors = 100;
else%if nargin == 0,
    numDesiredColors = varargin{1};
end%if-else nargin == 0,



myColorMap = [];
myColorMap(1,:) = [1 0 0];
myColorMap(2,:) = [0 1 0];
myColorMap(3,:) = [0 0 1];
counter = 3;

numCycles = 3;
if numDesiredColors>144, numCycles = 4;end
if numDesiredColors>5305, numCycles = 5; end

for myLoop = 1:numCycles,
    numColors = size(myColorMap,1);
    counter = numColors;
    for kk = 1:numColors-1,
        for jj = kk+1:numColors,
            c1 = myColorMap(kk,:);
            c2 = myColorMap(jj,:);
            c3 = c1+c2;
            c3 = c3./sqrt(sum(c3.^2));
            counter = counter+1;
            myColorMap(counter,:) = c3;
        end%for jj
    end%for kk
    myColorMap = uint8(myColorMap*100);
    [junk,ui,uj] = unique(myColorMap,'rows','first');
    uis = sort(ui);
    myColorMap = myColorMap(uis,:);
    myColorMap = double(myColorMap)./100;
    for qq = 1:size(myColorMap,1);
        myColorMap(qq,:) = myColorMap(qq,:)./sqrt(sum(myColorMap(qq,:).^2,2));
    end
end%for myLoop
myColorMap = myColorMap(~isnan(myColorMap(:,1)),:);
numColors = size(myColorMap,1);

sortedColorMap  = zeros(size(myColorMap));
sortedColorMap(1:20,:) = myColorMap(1:20,:);
usedColorList = [1];
%sortColors
mcm = myColorMap;
for kk = 20:numColors-1,
    distMapSum = zeros(numColors,1);
    for jj = max(1,kk-3):kk,
        cc = sortedColorMap(jj,:);
        distMap = sqrt(sum(((mcm - repmat(cc,[numColors,1])).^2),2));
        distMapSum = distMapSum + distMap * (jj+4-kk).^(0); %linear history weighting factor
    end%for jj
    distMapSum(usedColorList) = 0;
    [maxDist,maxPos] = max(distMapSum);
    sortedColorMap(kk+1,:) = mcm(maxPos,:);
    usedColorList = [usedColorList,maxPos];
end
    
if displayFlag == 1,
    for kk = 1:numColors,
        figure(4);p1 = plot(kk,kk,'ro');
        set(p1,'Color',sortedColorMap(kk,:));
        set(p1,'MarkerFaceColor',sortedColorMap(kk,:));
        hold on
    end
    hold off
end
myColorSpace = sortedColorMap(1:numDesiredColors,:);

   