latticeSize = 19;
distributedResistancesFlag = 0;
neighborhoodFlag = 1;

numNodes = latticeSize^3;
GG = zeros(numNodes,numNodes);
myMatrix = false(latticeSize,latticeSize,latticeSize);
matrixSize = size(myMatrix);

onePlane = latticeSize*latticeSize;
oneCol = latticeSize;
oneRow = 1;
fullRow = [-1 0 1];
neighborDiff = [ -onePlane,  -oneCol, +oneCol, -oneRow, +oneRow,  +onePlane];

if distributedResistancesFlag == 1,
    vectorProject = allProject.au;
    vectorizedStructure = vectorProject.vectorizedStructure;
    strands = vectorProject.vectorizedStructure.Strands;
    vertices = vectorProject.vectorizedStructure.Vertices;
    maskSize = vectorProject.maskSize;
    
    y1 = 300;y2 = maskSize(1)-y1;
    x1 = 300;x2 = maskSize(2)-x1;
    midZ = 500; plusMinusZ = 50;

    strandZList = vectorizedStructure.strandMidYXZList(:,3);
    strandYList = vectorizedStructure.strandMidYXZList(:,1);
    strandXList = vectorizedStructure.strandMidYXZList(:,2);
    zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
    yFlagList = and(strandYList>=y1,strandYList<=y2);
    xFlagList = and(strandXList>=x1,strandXList<=x2);
    includedStrandList = find(and(and(zFlagList,yFlagList),xFlagList));
    plungingSurfaceFlag = ismember([strands(includedStrandList).MedianLabel],[300:499]);
    includedStrandList = includedStrandList(~plungingSurfaceFlag);
    includedStrandConductances = [strands(includedStrandList).strandConductance];
    %---
    
    includedStrandList = [1:10000];
    
    includedStrandConductances = rand(10000,1)*3e8+1e8;
    includedResistances = rand(10000,1)*8e-8 + 1e-8;
    includedStrandConductances = 1./includedResistances;

    includedStrandConductances = includedStrandConductances(includedStrandConductances>0.1);
    includedStrandConductances = includedStrandConductances(includedStrandConductances<1e11);

    includedStrandConductances(:) = 1e8

    includedStrandConductances(1:3:end) = 1e9;%high conduct = small resistor = big vessel
    % % includedStrandConductances(2:20:end) = 2e9;%high conduct = small resistor = big vessel
    % % includedStrandConductances(3:20:end) = 3e9;%high conduct = small resistor = big vessel
    % % includedStrandConductances(4:20:end) = 4e9;%high conduct = small resistor = big vessel
    % % includedStrandConductances(5:20:end) = 5e9;%high conduct = small resistor = big vessel
    % % includedStrandConductances = linspace(1e8,1e9,10000);
    % % 

end%if distributedResistancesFlag == 1,
    


% % % for nodeIter = 1:numNodes,
% % %     thisNode = nodeIter;
% % %     neighborList = thisNode + neighborDiff;
% % %     neighborList = neighborList(neighborList>0);
% % %     neighborList = neighborList(neighborList<=numNodes);
% % %     GG(nodeIter,neighborList) = 1;
% % % end

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

for nodeIter = 1:numNodes,
    nn = zeros(6,3);
    thisNode = nodeIter;
    nodeCoord = coordList(thisNode,:);
    nn(1,:) = nodeCoord + [0 0 -1];
    nn(2,:) = nodeCoord + [0 -1 0];
    nn(3,:) = nodeCoord + [0 +1 0];
    nn(4,:) = nodeCoord + [-1 0 0];
    nn(5,:) = nodeCoord + [+1 0 0];
    nn(6,:) = nodeCoord + [0 0 +1];
    nflag1 = nn<1;
    nflag2 = nn>latticeSize;
    nflag1 = max(nflag1,[],2);
    nflag2 = max(nflag2,[],2);
    ff = find(~or(nflag1,nflag2));
    subNeighborDiff = neighborDiff(ff);
    
    neighborList = thisNode + subNeighborDiff;
    neighborList = neighborList(neighborList>0);
    neighborList = neighborList(neighborList<=numNodes);
    GG(nodeIter,neighborList) = 1;
end



if distributedResistancesFlag == 1,
    ff = find(GG==1);
    numEntries = numel(ff);
    %---
    numStrandsIncluded = numel(includedStrandList);
    randIndexList = ceil(rand(numEntries,1)*numStrandsIncluded);
    randomizedStrandConductanceList = includedStrandConductances(randIndexList);
    xxx = [-10:0.001:-7];
    hhh = hist(log10(1./includedStrandConductances),xxx);
    figure(1);plot(xxx,hhh);
    hhh2 = hist(log10(1./randomizedStrandConductanceList),xxx);
    figure(2);plot(xxx,hhh2);
    
    
    
    
    GG(ff) = randomizedStrandConductanceList;
end


for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    GG(rowIter,rowIter) = -1*sum(thisRow);
end
GG = -1*GG;

%%

tic
[eigenVectors,eigenValueMatrix] = eig(GG);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

clear eigenValueMatrix
saveName = ['CubicLattice',num2str(latticeSize,'%02d'),'CalcResults.mat'];
save(saveName,'GG','numNodes','matrixSize','eigenValues','eigenVectors');



%%

GGSize = size(GG);

floatingNode1ID = ceil(numNodes/2);

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

f3 = figure(3);hold off;set(f3,'DoubleBuffer','on');
for floatingNode2ID = 1:1:ceil(GGSize(1)/2);
    % floatingNode2ID = 500
    runSum = 0;
    mSize = size(eigenVectors,1);
    for iIter = 2:mSize;
        eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
        eVectorBeta = eigenVectors(floatingNode2ID,iIter);
        eVal = eigenValues(iIter);
        cutoff = -1;
        if eVal > cutoff,
            runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
        end
    end%for iIter;
    effectiveResistance = runSum;
%     sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
    sep = sum(abs(coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)));%Checkerboard
%      figure(3);plot(sep,log10(effectiveResistance*2),'c.');hold on;pause(0.01);
     figure(3);plot(sep,effectiveResistance,'c.');hold on;pause(0.01);
end%for floatingNode2ID = ...
figure(3);hold off
 xlabel('Checkerboard distance separation');
 ylabel('EffectiveResistance');
 sizeStr = num2str(latticeSize);
 title(['Cubic 3D Lattice - ',sizeStr,' x ',sizeStr]);
 




%%
% % % 
% % % %six possible directions the previous connection arrived from:
% % % %                1 = due north
% % % %northwest = 6          2 = northeast
% % % %southwest = 5          3 = southeast
% % % %                4 = due south
% % % 
% % % goN = [-1,0];
% % % goNE = [-0.5,+0.8776];
% % % goSE = [+0.5,+0.8776];
% % % goS = [+1,0];
% % % goSW = [+0.5,-0.8776];
% % % goNW = [-0.5,-0.8776];
% % % 
% % % moveDirection = [goN;goNE;goSE;goS;goSW;goNW];
% % % 
% % % maxSize =1000;
% % % startCoords = [0,0];
% % % coordList = [0,0];
% % % activeNodeList = [2,3,4];
% % % coordList(2,:) = startCoords + moveDirection(1,:);
% % % coordList(3,:) = startCoords + moveDirection(3,:);
% % % coordList(4,:) = startCoords + moveDirection(5,:);
% % % seedFromList = [0;4;6;2];
% % % GG = zeros(2*maxSize,2*maxSize);
% % % GG(1,2) = 1;GG(2,1) = 1;
% % % GG(1,3) = 1;GG(3,1) = 1;
% % % GG(1,4) = 1;GG(4,1) = 1;
% % % nodeCounter = 4;
% % % 
% % % %%
% % % 
% % % for kk = 1:maxSize,
% % %     disp(kk);
% % % activeNode = activeNodeList(1);
% % % seedFrom = seedFromList(activeNode);
% % % currentCoords = coordList(activeNode,:);
% % % sproutTo = mod([seedFrom+1,seedFrom+3],6)+1;
% % % 
% % % tentativeNodePos1 = currentCoords + moveDirection(sproutTo(1),:);
% % % tentativeSeedDirection1 = mod(sproutTo(1)+2,6)+1;
% % % tentativeNodePos2 = currentCoords + moveDirection(sproutTo(2),:);
% % % tentativeSeedDirection2 = mod(sproutTo(2)+2,6)+1;
% % % 
% % % diffList1 = sqrt(sum((repmat(tentativeNodePos1,[nodeCounter,1]) - coordList).^2,2));    
% % % diffList2 = sqrt(sum((repmat(tentativeNodePos2,[nodeCounter,1]) - coordList).^2,2));    
% % % 
% % % [min1,minPos1] = min(diffList1);
% % % [min2,minPos2] = min(diffList2);
% % % 
% % % if min1 < 0.5,
% % %     %coord already exists, just make connection
% % %     GG(activeNode,minPos1) = 1;
% % %     GG(minPos1,activeNode) = 1;
% % % else%if min1<0.5
% % %     %create node, and make connection
% % %     nodeCounter = nodeCounter + 1;
% % %     activeNodeList = [activeNodeList,nodeCounter];
% % %     coordList(nodeCounter,:) = tentativeNodePos1;
% % %     seedFromList(nodeCounter) = tentativeSeedDirection1;
% % %     GG(activeNode,nodeCounter) = 1;
% % %     GG(nodeCounter,activeNode) = 1;
% % % end%if-else min1<0.5
% % % %---
% % % if min2 < 0.5,
% % %     %coord already exists, just make connection
% % %     GG(activeNode,minPos2) = 1;
% % %     GG(minPos2,activeNode) = 1;
% % % else%if min2<0.5
% % %     %create node, and make connection
% % %     nodeCounter = nodeCounter + 1;
% % %     activeNodeList = [activeNodeList,nodeCounter];
% % %     coordList(nodeCounter,:) = tentativeNodePos2;
% % %     seedFromList(nodeCounter) = tentativeSeedDirection2;
% % %     GG(activeNode,nodeCounter) = 1;
% % %     GG(nodeCounter,activeNode) = 1;
% % % end%if-else min2<0.5
% % % activeNodeList = activeNodeList(2:end);
% % % 
% % % end%for kk
% % % GG = GG(1:nodeCounter,1:nodeCounter);
% % % 
% % % %%
% % % GGSize = size(GG);
% % % GG2 = -1*GG;
% % % for kk = 1:GGSize(1),
% % %     GG2(kk,kk) = -1*sum(GG2(:,kk));
% % % end
% % % 
% % % tic
% % % disp('Finding eigenvectors');pause(0.1);
% % % [eigenVectors,eigenValueMatrix] = eig(GG2);
% % % toc
% % % eigenValues = zeros(length(eigenValueMatrix),1);
% % % for kk = 1:length(eigenValueMatrix);
% % %     eigenValues(kk) = eigenValueMatrix(kk,kk);
% % % end%for kk;
% % % figure(1);p1 = plot(coordList(:,1),coordList(:,2),'r.');
% % % 
% % % %%
% % % floatingNode1ID = 1;
% % % 
% % % figure(2);hold off
% % % for floatingNode2ID = 1:GGSize(1);
% % %     % floatingNode2ID = 500
% % %     runSum = 0;
% % %     mSize = size(eigenVectors,1);
% % %     for iIter = 2:mSize;
% % %         eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
% % %         eVectorBeta = eigenVectors(floatingNode2ID,iIter);
% % %         eVal = eigenValues(iIter);
% % %         cutoff = -1;
% % %         if eVal > cutoff,
% % %             runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
% % %         end
% % %     end%for iIter;
% % %     effectiveResistance = runSum;
% % %     sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
% % %     figure(2);plot(sep,effectiveResistance,'c.');hold on
% % % end%for floatingNode2ID = ...
% % % 
