mypics = loadmovie('bwMask.tif');
mypics = mypics-50;
maxVal = max(mypics(:));

myColorSpace = GenerateColorSpace(maxVal);
myColorLUT = zeros(maxVal,3);
for kk = 1: maxVal,
    myColorVector = myColorSpace(kk,:);
    myColorMag = sqrt(sum(myColorVector.^2));
    myColorVector = myColorVector./myColorMag;
    myColorLUT(kk,1:3) = ceil(myColorVector*255);
end%for kk..


allMask = zeros(size(mypics),'uint8');
redMask = allMask;
greenMask = allMask;
blueMask = allMask;
allMask = allMask>0;


for kk = 1:maxVal-0%108;
    tic
    myMask = mypics == kk;
    [cc1,cc2,cc3] = ind2sub(size(myMask),find(myMask));
    minY = min(cc1); maxY = max(cc1);
    minX = min(cc2); maxX = max(cc2);
    minZ = min(cc3); maxZ = max(cc3);
    yplus = maxY-minY;
    xplus = maxX-minX;
    zplus = maxZ-minZ;
    %---
    subMask = myMask(minY:maxY,minX:maxX,minZ:maxZ);
    %---
    filtMask = imfilter(subMask,ones(2,2,2));
    subMask = filtMask(1:2:end,1:2:end,1:2:end);
    %---
    filtMask = imfilter(subMask,ones(2,2,2));
    subMask = filtMask(1:2:end,1:2:end,1:2:end);
    %---
    filtMask = imfilter(subMask,ones(2,2,2));
    subMask = filtMask(1:2:end,1:2:end,1:2:end);
    %---
    test = imclose(subMask,circle3d(10));
    test = imopen(test,circle3d(5));
    L = bwlabeln(test);
    test = L ==1;
    %---
    f = find(test);
    [c1,c2,c3] = ind2sub(size(subMask),f);
    upMask = false(size(subMask)*2);
    ix = sub2ind(size(upMask),c1*2,c2*2,c3*2);
    upMask(ix) = 1;
    closeMask = imclose(upMask,ones(2,2,2));
    %---
    f = find(closeMask);
    [c1,c2,c3] = ind2sub(size(closeMask),f);
    upMask = false(size(closeMask)*2);
    ix = sub2ind(size(upMask),c1*2,c2*2,c3*2);
    upMask(ix) = 1;
    closeMask = imclose(upMask,ones(2,2,2));
    %---
    f = find(closeMask);
    [c1,c2,c3] = ind2sub(size(closeMask),f);
    upMask = false(size(closeMask)*2);
    ix = sub2ind(size(upMask),c1*2,c2*2,c3*2);
    upMask(ix) = 1;
    closeMask = imclose(upMask,ones(2,2,2));
    closeMask = imclose(upMask,circle3d(7));
    erodeMask = imerode(closeMask,ones(3,3,3));
    shellMask = (closeMask-erodeMask)>0;
     %-----
    myMask(minY:maxY,minX:maxX,minZ:maxZ) = shellMask(1:1+yplus,1:1+xplus,1:1+zplus);
    allMask = max(allMask,myMask);
    thisColor = myColorLUT(kk,:);
    myMask = uint8(erodeMask);
    redMask(minY:maxY,minX:maxX,minZ:maxZ) = redMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*thisColor(1);
    greenMask(minY:maxY,minX:maxX,minZ:maxZ) = greenMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*thisColor(2);
    blueMask(minY:maxY,minX:maxX,minZ:maxZ) = blueMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*thisColor(3);
    myMask = uint8(shellMask);
    redMask(minY:maxY,minX:maxX,minZ:maxZ) = redMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*255;
    greenMask(minY:maxY,minX:maxX,minZ:maxZ) = greenMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*255;
    blueMask(minY:maxY,minX:maxX,minZ:maxZ) = blueMask(minY:maxY,minX:maxX,minZ:maxZ) + myMask(1:1+yplus,1:1+xplus,1:1+zplus)*255;
    toc
%     if mod(kk,10) == 0, maketiff(allMask,'allMask.tif');end
    
        
       
    
    
end%for kk
% maketiff(allMask,'allMask.tif')
    

fileName = ['DominantFlowBlobsRGB.tif'];
currentFrame = zeros(size(redMask,1),size(redMask,2),3,'uint8');
currentFrame(:,:,1) = redMask(:,:,1);
currentFrame(:,:,2) = greenMask(:,:,1);
currentFrame(:,:,3) = blueMask(:,:,1);
imwrite(uint8(currentFrame),fileName,'tiff','Compression','none');

for frameIter = 2:size(redMask,3);
    currentFrame(:,:,1) = redMask(:,:,frameIter);
    currentFrame(:,:,2) = greenMask(:,:,frameIter);
    currentFrame(:,:,3) = blueMask(:,:,frameIter);
    imwrite(uint8(currentFrame),fileName,'tiff','WriteMode','append','Compression','none');
end

        
    