dataSetChoice = 1;


switch dataSetChoice,
    case 1
        flowFolder = 'F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files';
        barrelFile = 'F:\Phil\AOH_VectorProjects\pbDB\BarrelOutlines.mat';
        barrelMaskFile = 'F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files\barrelMaskFlat.mat';
        flowFile = 'F:\Phil\AOH_VectorProjects\pbDB\FlowProject000001_Files\FVFile_2011_06_24-143933.mat';
    case 2
        flowFolder = ('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\FlowProject000001_Files');
        barrelFile = ('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\barrelOutlines.mat');
        barrelMaskFile = ('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\barrelMaskFlat.mat');
        flowFile = ('F:\Phil\AOH_VectorProjects\pbAU\VectorProjectFolder\FlowProject000001_Files\FVFile_2011_06_13-134115.mat');

end%switch dataSetChoice

if ~exist('storedDataSetChoice','var'), storedDataSetChoice = 0;end
if dataSetChoice ~= storedDataSetChoice,
    load(flowFile);
    load(barrelFile);
    load(barrelMaskFile);
    storedDataSetChoice = dataSetChoice;
end

maskSize = gds.maskSize;
apList = gds.plungingArterioleTipList;
vpList = gds.plungingVenuleTipList;
aList = gds.allPlungingArterioleList;
vList = gds.allPlungingVenuleList;

thisList = aList;
numOnList = numel(thisList);
surfYList = [];
surfXList = [];
plungingPointFrame = false(maskSize(1),maskSize(2));
for kk = 1:numOnList,
    thisStrandID = thisList(kk);
    thisStrand = gds.Strands(thisStrandID);
    thisVertList = gds.Vertices.AllVerts(thisStrand.InteriorVertices,:);
    zList = unique(round(thisVertList(:,3)));
    dz = thisVertList(:,3)-median(zList);
    [minVal,minPos] = min(dz.^2);
    yPos = thisVertList(minPos(1),1);
    xPos = thisVertList(minPos(1),2);
    plungingPointFrame(yPos,xPos) = 1;
    surfYList(kk) = yPos;
    surfXList(kk) = xPos;
end

surfTessFrame = bwdist(plungingPointFrame);
surfTessFrame = watershed(surfTessFrame);
surfTessEdgeFrame = (surfTessFrame==0)*128;

test = surfTessEdgeFrame+barrelMaskFrame*128;

%%

zLevel = 450;

thisList = vList;
numOnList = numel(thisList);
surfYList = [];
surfXList = [];
plungingPointFrame = false(maskSize(1),maskSize(2));
for kk = 1:numOnList,
    thisStrandID = thisList(kk);
    thisStrand = gds.Strands(thisStrandID);
    thisVertList = gds.Vertices.AllVerts(thisStrand.InteriorVertices,:);
    zList = unique(round(thisVertList(:,3)));
    if ismember(zLevel,zList),
        dz = thisVertList(:,3)-median(zList);
        [minVal,minPos] = min(dz.^2);
        yPos = thisVertList(minPos(1),1);
        xPos = thisVertList(minPos(1),2);
        plungingPointFrame(yPos,xPos) = 1;
        surfYList(kk) = yPos;
        surfXList(kk) = xPos;
    end%if ismember,
    
end%for kk

surfTessFrame = bwdist(plungingPointFrame);
surfTessFrame = watershed(surfTessFrame);
surfTessEdgeFrame = (surfTessFrame==0)*128;

test = surfTessEdgeFrame+barrelMaskFrame*128;
see(test);




%%
% % % % barrelMask = false(maskSize(1),maskSize(2));
% % % % for kk = 1:numel(barrels);
% % % %     thisBarrel = barrels{kk};
% % % %     indList = sub2ind(size(barrelMask),thisBarrel(:,1),thisBarrel(:,2));
% % % %     barrelMask(indList) = 1;
% % % % end
% % % % 
% % % % barrelMaskOutlineFrame = imclose(barrelMask,ones(5,5));
% % % % barrelMaskFrame = imfill(barrelMaskOutlineFrame,'holes');
% % % % cd(flowFolder);
% % % % save('barrelMaskFlat.mat','barrelMaskFrame','barrelMaskOutlineFrame');

