latticeSize = 13;

runTracePathExperimentFlag = 1;
precautionPauseFlag = 0;

numNodes = latticeSize^3;
GG = zeros(numNodes,numNodes);
myMatrix = false(latticeSize,latticeSize,latticeSize);
matrixSize = size(myMatrix);

onePlane = latticeSize*latticeSize;
oneCol = latticeSize;
oneRow = 1;
fullRow = [-1 0 1];
neighborDiff = [ -onePlane,  -oneCol, -oneRow, +oneRow, +oneCol,  +onePlane];

%Generate a cubic lattice with periodic boundary conditions
for nodeIter = 1:numNodes,
    thisNode = nodeIter;
    neighborList = thisNode + neighborDiff;
    neighborList = neighborList(neighborList>0);
    neighborList = neighborList(neighborList<=numNodes);
    GG(nodeIter,neighborList) = 1;
end%for nodeIter = 1:numNodes,


%Remove the periodic boundary conditions
for nodeIter = 1:numNodes,
    if nodeIter<=numNodes-1 && mod(nodeIter,latticeSize) == 0,
        GG(nodeIter,nodeIter+1) = 0;
        GG(nodeIter+1,nodeIter) = 0;
    end
    %---
    if nodeIter<=numNodes-latticeSize && mod(ceil(nodeIter/latticeSize),latticeSize) == 0,
        GG(nodeIter,nodeIter+latticeSize) = 0;
        GG(nodeIter+latticeSize,nodeIter) = 0;
    end
end
        

%Trim down to three connections per node
removalPattern = [1 2 3 6 5 4];
removalCounter = 0
for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    thisRowActive = find(thisRow);
    thisRowActive = thisRowActive(thisRowActive>rowIter);
    thisRowActiveRep = repmat(thisRowActive,[1,6]);
    numConn = sum(thisRow);
    numRemove = max(0,numConn-3);
    if numRemove>0,
        removalTickers = [1:numRemove]+removalCounter;
        removalPatternInds = mod(removalTickers,6)+1;
        removalInds = removalPattern(removalPatternInds);
        removalPos = thisRowActiveRep(removalInds);
        GG(rowIter,removalPos) = 0;
        GG(removalPos,rowIter) = 0;
        removalCounter = removalCounter + numRemove;
    end%if numRemove>0

end%for rowIter = 1:numNodes,

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];


ggsum = sum(GG>0,2);
n1 = numel(find(ggsum==1))/numNodes;
n2 = numel(find(ggsum==2))/numNodes;
n3 = numel(find(ggsum==3))/numNodes;
n4 = numel(find(ggsum==4))/numNodes;
n5 = numel(find(ggsum==5))/numNodes;
n6 = numel(find(ggsum==6))/numNodes;
disp('Connectivity stats2:');
disp([n1,n2,n3,n4,n5,n6]);


% % % figure(11);hold off
% % % for rowIter = 1:numNodes,
% % %     cc1 = coordList(rowIter,:);
% % %     thisRow = GG(rowIter,:);
% % %     numConn = sum(thisRow);
% % %     thisRowActive = find(thisRow);
% % %     for connIter = 1:numConn,
% % %         cc2 = coordList(thisRowActive(connIter),:);
% % %         figure(11);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
% % % %         pause(0.01)
% % %     end%for connIter...
% % % end%for rowIter;



if distributedResistancesFlag == 1,
    vectorProject = allProject.au;
    vectorizedStructure = vectorProject.vectorizedStructure;
    strands = vectorProject.vectorizedStructure.Strands;
    vertices = vectorProject.vectorizedStructure.Vertices;
    maskSize = vectorProject.maskSize;
    
    y1 = 300;y2 = maskSize(1)-y1;
    x1 = 300;x2 = maskSize(2)-x1;
    midZ = 500; plusMinusZ = 200;

    strandZList = vectorizedStructure.strandMidYXZList(:,3);
    strandYList = vectorizedStructure.strandMidYXZList(:,1);
    strandXList = vectorizedStructure.strandMidYXZList(:,2);
    zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
    yFlagList = and(strandYList>=y1,strandYList<=y2);
    xFlagList = and(strandXList>=x1,strandXList<=x2);
    includedStrandList = find(and(and(zFlagList,yFlagList),xFlagList));
    plungingSurfaceFlag = ismember([strands(includedStrandList).MedianLabel],[300:499]);
    includedStrandList = includedStrandList(~plungingSurfaceFlag);
    includedStrandConductances = [strands(includedStrandList).strandConductance];
    %---
    
% %     includedStrandList = [1:10000];
% %     
% % includedStrandConductances = rand(10000,1)*3e8+1e8;
% % includedResistances = rand(10000,1)*8e-8 + 1e-8;
% % includedStrandConductances = 1./includedResistances;
% % 
% % includedStrandConductances = includedStrandConductances(includedStrandConductances>0.1);
% % includedStrandConductances = includedStrandConductances(includedStrandConductances<1e11);
% % 
% % includedStrandConductances(:) = 1e8

% % includedStrandConductances(1:2:end) = 1e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(2:20:end) = 2e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(3:20:end) = 3e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(4:20:end) = 4e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(5:20:end) = 5e9;%high conduct = small resistor = big vessel
% % includedStrandConductances = linspace(1e8,1e9,10000);
% % 

    ff = find(GG==1);
    numEntries = numel(ff);
    %---
    numStrandsIncluded = numel(includedStrandList);
    randIndexList = ceil(rand(numEntries,1)*numStrandsIncluded);
    randomizedStrandConductanceList = includedStrandConductances(randIndexList);
    xxx = [-10:0.01:-6];
    hhh = hist(log10(1./includedStrandConductances),xxx);
    figure(1);plot(xxx,hhh);
    hhh2 = hist(log10(1./randomizedStrandConductanceList),xxx);
    figure(2);plot(xxx,hhh2);
    
    
    
    
    GG(ff) = randomizedStrandConductanceList;
end



for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    GG(rowIter,rowIter) = -1*sum(thisRow);
end
GG = -1*GG;

%%
if precautionPauseFlag == 1,
    for kk =1:10,
        disp('pausing');
    end
    for kk = 1:3,
        disp('Long Calc. are you sure?- I''ll ask 3 times');
        pause
    end
end%if precautionPauseFlag == 1,
%---
disp('Starting Eigenvalue calculation');pause(0.1);
tic
[eigenVectors,eigenValueMatrix] = eig(GG);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;
clear eigenValueMatrix
saveName = ['TrimmedCubicLattice',num2str(latticeSize,'%02d'),'CalcResults.mat'];
save(saveName,'GG','numNodes','matrixSize','eigenValues','eigenVectors','runTracePathExperimentFlag');


%%

GGSize = size(GG);

floatingNode1ID = ceil(numNodes/2);


[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

figure(13);hold off
for floatingNode2ID = 1:1:GGSize(1);
    % floatingNode2ID = 500
    runSum = 0;
    mSize = size(eigenVectors,1);
    for iIter = 2:mSize;
        eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
        eVectorBeta = eigenVectors(floatingNode2ID,iIter);
        eVal = eigenValues(iIter);
        cutoff = -1;
        if eVal > cutoff,
            runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
        end
    end%for iIter;
    effectiveResistance = runSum;
    sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
    sep = sum(abs(coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)));
%      figure(13);plot(sep,log10(effectiveResistance*0.8),'c.');hold on
     figure(13);plot(sep,(effectiveResistance),'c.');hold on
end%for floatingNode2ID = ...

 xlabel('Checkerboard distance separation');
 ylabel('EffectiveResistance');
 title('TrimmedCubicLattice');

%%
if runTracePathExperimentFlag == 1,
    [c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
    coordList = [c1',c2',c3'];
    allMidPointList = [];
    for rowIter = 1:numNodes,
        cc1 = coordList(rowIter,:);
        thisRow = GG(rowIter,:);
        thisRowActive = find(thisRow);
        thisRowActive = thisRowActive(thisRowActive>rowIter);
        numConn = numel(thisRowActive);
        for connIter = 1:numConn,
            cc2 = coordList(thisRowActive(connIter),:);
%             figure(11);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
            allMidPointList = [allMidPointList;[mean([cc1(1),cc2(1)]),mean([cc1(2),cc2(2)]),mean([cc1(3),cc2(3)])]];
    %         pause(0.01)
        end%for connIter...
    end%for rowIter;


    
    
    
    %Calculate network resistance versus number of nodes actually traveled
    fampl = floor(allMidPointList);
    allLowerCoordList = [fampl(:,1)*100*100 + fampl(:,2)*100 + fampl(:,3)];
    floatingNode1ID = ceil(numNodes/2);
    [c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
    coordList = [c1',c2',c3'];
    % % startCoord = coordList(floatingNode1ID,:);
    % % startMidPoint = find(allLowerCoordList == [startCoord(1)*100*100 + startCoord(2)*100 + startCoord(3)]);
    % % startMidPoint = startMidPoint(1);

    figure(11);hold off
    figure(12);hold off

    %Plot network resistance from a node as you track outward


    numStart = 1;


    for startNum = 1:100;%:skipVal:numStart,
    tempGG = GG<0;
        startNode = floatingNode1ID;

startNode = ceil(floatingNode1ID + 2*rand(1)-50);

        midLat = ceil(latticeSize/2);
        startCC = [midLat,midLat,midLat];
        startCC = startCC + round(4*rand([1,3])-2);
        startNode = sub2ind(matrixSize,startCC(1),startCC(2),startCC(3));

    
        thisRow = tempGG(startNode,:);
        connectsInRow = find(thisRow==1);
        numConnectsAvailable = numel(connectsInRow);
        r = ceil(rand(1)*numConnectsAvailable);
    r = 1;
        nextNode = connectsInRow(r);
        tempGG(startNode,nextNode) = 0;
        tempGG(nextNode,startNode) = 0;
        thisNode = startNode;

        resList = [];
        sepList = [];
            for vIter = 1:100,
                runSum = 0;
                mSize = size(eigenVectors,1);
                for iIter = 2:mSize;
                    eVectorAlpha = eigenVectors(startNode,iIter);
                    eVectorBeta = eigenVectors(nextNode,iIter);
                    eVal = eigenValues(iIter);
                    cutoff = -1;
                    if eVal > cutoff,
                        runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
                    end
                end%for iIter;
                effectiveResistance = runSum;
    %             effectiveResistance = min(effectiveResistance,4e-7);
                if isempty(effectiveResistance),effectiveResistance = inf;end
                resList(vIter) = effectiveResistance;
                sep = coordList(startNode,:) - coordList(nextNode,:);
                sepDist = sqrt(sum(sep.^2));
                sepList(vIter) = sepDist;


                thisNode = nextNode;
                thisRow = tempGG(thisNode,:);
                connectsInRow = find(thisRow==1);
                if ~isempty(connectsInRow),
                    numConnectsAvailable = numel(connectsInRow);
                    r = ceil(rand(1)*numConnectsAvailable);
        r = 1;
                    nextNode = connectsInRow(r);
                    tempGG(thisNode,nextNode) = 0;
                    tempGG(nextNode,thisNode) = 0;
                else%if isempty(connectsInRow),
                    break%for vIter loop
                end%if isempty(connectsInRow),

            end%for vIter...

        figure(11);plot((resList),'r.');hold on
        xlabel('number of branches out'),ylabel('network resistance');
        figure(12);plot(sepList,'g.');hold on
        xlabel('number of branches out'),ylabel('Euclidean distance');

    end%for startNum
end%if runTracePathExperimentFlag == 1,
figure(11);hold off;
figure(12);hold off;


%%
% % % 
% % % %six possible directions the previous connection arrived from:
% % % %                1 = due north
% % % %northwest = 6          2 = northeast
% % % %southwest = 5          3 = southeast
% % % %                4 = due south
% % % 
% % % goN = [-1,0];
% % % goNE = [-0.5,+0.8776];
% % % goSE = [+0.5,+0.8776];
% % % goS = [+1,0];
% % % goSW = [+0.5,-0.8776];
% % % goNW = [-0.5,-0.8776];
% % % 
% % % moveDirection = [goN;goNE;goSE;goS;goSW;goNW];
% % % 
% % % maxSize =1000;
% % % startCoords = [0,0];
% % % coordList = [0,0];
% % % activeNodeList = [2,3,4];
% % % coordList(2,:) = startCoords + moveDirection(1,:);
% % % coordList(3,:) = startCoords + moveDirection(3,:);
% % % coordList(4,:) = startCoords + moveDirection(5,:);
% % % seedFromList = [0;4;6;2];
% % % GG = zeros(2*maxSize,2*maxSize);
% % % GG(1,2) = 1;GG(2,1) = 1;
% % % GG(1,3) = 1;GG(3,1) = 1;
% % % GG(1,4) = 1;GG(4,1) = 1;
% % % nodeCounter = 4;
% % % 
% % % %%
% % % 
% % % for kk = 1:maxSize,
% % %     disp(kk);
% % % activeNode = activeNodeList(1);
% % % seedFrom = seedFromList(activeNode);
% % % currentCoords = coordList(activeNode,:);
% % % sproutTo = mod([seedFrom+1,seedFrom+3],6)+1;
% % % 
% % % tentativeNodePos1 = currentCoords + moveDirection(sproutTo(1),:);
% % % tentativeSeedDirection1 = mod(sproutTo(1)+2,6)+1;
% % % tentativeNodePos2 = currentCoords + moveDirection(sproutTo(2),:);
% % % tentativeSeedDirection2 = mod(sproutTo(2)+2,6)+1;
% % % 
% % % diffList1 = sqrt(sum((repmat(tentativeNodePos1,[nodeCounter,1]) - coordList).^2,2));    
% % % diffList2 = sqrt(sum((repmat(tentativeNodePos2,[nodeCounter,1]) - coordList).^2,2));    
% % % 
% % % [min1,minPos1] = min(diffList1);
% % % [min2,minPos2] = min(diffList2);
% % % 
% % % if min1 < 0.5,
% % %     %coord already exists, just make connection
% % %     GG(activeNode,minPos1) = 1;
% % %     GG(minPos1,activeNode) = 1;
% % % else%if min1<0.5
% % %     %create node, and make connection
% % %     nodeCounter = nodeCounter + 1;
% % %     activeNodeList = [activeNodeList,nodeCounter];
% % %     coordList(nodeCounter,:) = tentativeNodePos1;
% % %     seedFromList(nodeCounter) = tentativeSeedDirection1;
% % %     GG(activeNode,nodeCounter) = 1;
% % %     GG(nodeCounter,activeNode) = 1;
% % % end%if-else min1<0.5
% % % %---
% % % if min2 < 0.5,
% % %     %coord already exists, just make connection
% % %     GG(activeNode,minPos2) = 1;
% % %     GG(minPos2,activeNode) = 1;
% % % else%if min2<0.5
% % %     %create node, and make connection
% % %     nodeCounter = nodeCounter + 1;
% % %     activeNodeList = [activeNodeList,nodeCounter];
% % %     coordList(nodeCounter,:) = tentativeNodePos2;
% % %     seedFromList(nodeCounter) = tentativeSeedDirection2;
% % %     GG(activeNode,nodeCounter) = 1;
% % %     GG(nodeCounter,activeNode) = 1;
% % % end%if-else min2<0.5
% % % activeNodeList = activeNodeList(2:end);
% % % 
% % % end%for kk
% % % GG = GG(1:nodeCounter,1:nodeCounter);
% % % 
% % % %%
% % % GGSize = size(GG);
% % % GG2 = -1*GG;
% % % for kk = 1:GGSize(1),
% % %     GG2(kk,kk) = -1*sum(GG2(:,kk));
% % % end
% % % 
% % % tic
% % % disp('Finding eigenvectors');pause(0.1);
% % % [eigenVectors,eigenValueMatrix] = eig(GG2);
% % % toc
% % % eigenValues = zeros(length(eigenValueMatrix),1);
% % % for kk = 1:length(eigenValueMatrix);
% % %     eigenValues(kk) = eigenValueMatrix(kk,kk);
% % % end%for kk;
% % % figure(1);p1 = plot(coordList(:,1),coordList(:,2),'r.');
% % % 
% % % %%
% % % floatingNode1ID = 1;
% % % 
% % % figure(2);hold off
% % % for floatingNode2ID = 1:GGSize(1);
% % %     % floatingNode2ID = 500
% % %     runSum = 0;
% % %     mSize = size(eigenVectors,1);
% % %     for iIter = 2:mSize;
% % %         eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
% % %         eVectorBeta = eigenVectors(floatingNode2ID,iIter);
% % %         eVal = eigenValues(iIter);
% % %         cutoff = -1;
% % %         if eVal > cutoff,
% % %             runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
% % %         end
% % %     end%for iIter;
% % %     effectiveResistance = runSum;
% % %     sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
% % %     figure(2);plot(sep,effectiveResistance,'c.');hold on
% % % end%for floatingNode2ID = ...
% % % 
