latticeSize = 9;

runTracePathExperimentFlag = 0;
precautionPauseFlag = 0;
saveFlag = 1;
distributedResistancesFlag = 0;
randomizeLatticeFlag = 0 ;
showLatticeFlag = 0;

addHubLineFlag = 0;
numHubLines = 5;

addRandom4sFlag = 0;
allowLongDistRandomFlag = 1;
numMaxStepsLongDist = 7;
numAdd4s = 0.1;

maxRes = 10;
maxSep = 5; 

numNodes = latticeSize^3;
GG = zeros(numNodes,numNodes);
myMatrix = false(latticeSize,latticeSize,latticeSize);
matrixSize = size(myMatrix);

onePlane = latticeSize*latticeSize;
oneCol = latticeSize;
oneRow = 1;
fullRow = [-1 0 1];
neighborDiff = [ -oneRow, -oneCol, -onePlane, +oneRow, +oneCol,  +onePlane];
neighborDiffInd = [-1 -2 -3 1 2 3];

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

% % % fampl = floor(allMidPointList);
% % % campl = fl
% % % allLowerCoordList = [fampl(:,1)*100*100 + fampl(:,2)*100 + fampl(:,3)];
% % %     
upDownCounter = [-1 -1 -1];
dimCounter = 0;
nodeCounter = 0;
breakFrequency = 2;
skipCounter = [0 0 0];
replicateCounter = [0 0 0];

maxAttempts = 100;

for zIter = 1:latticeSize,
    for xIter = 1:latticeSize,
        for yIter = 1:latticeSize;
            nodeCounter = nodeCounter + 1;
            thisCC = [yIter,xIter,zIter];
            thisInd = sub2ind(matrixSize,thisCC(1),thisCC(2),thisCC(3));
            thisRow = GG(thisInd,:);
            numConn = sum(thisRow>0);
            numAddConn = max(0,(3-numConn));
            alreadyConn = find(thisRow>0);
            
            
            connAddCounter = 0;
            attemptCounter = 0;
            while connAddCounter < numAddConn,
                    
            
                validNeighbor = 1;
                trialNeighbor = ceil(rand(1)*numNodes);
                [neighborCC(1),neighborCC(2),neighborCC(3)] = ind2sub(matrixSize,trialNeighbor);
                sep = sqrt(sum((neighborCC-thisCC).^2));
                if sep>maxSep, validNeighbor = 0; end;
                if validNeighbor == 1,
                    stillValidNeighbor = 1;
                    %check neighbor connections
                    neighborRow = GG(trialNeighbor,:);
                    if sum(neighborRow>0)>=3, stillValidNeighbor = 0; end
                    if stillValidNeighbor == 1,
                        GG(thisInd,trialNeighbor) = 1;
                        GG(trialNeighbor,thisInd) = 1;
                        connAddCounter = connAddCounter +1;
                    end%if stillValidNeighbor == 1,
                end%if validNeighbor == 1,
                attemptCounter = attemptCounter +1 ;
                if attemptCounter > maxAttempts, break, end
            end%while...
            

            
        end%for yIter
    end%for xIter
end%for yIter
            
 
            
            
%%
edgeIndList = [];
nonEdgeIndList = [];

for yIter = 1:latticeSize
    for xIter = 1:latticeSize
        for zIter = 1:latticeSize,
            edgeFlag = 0;
            thisInd = sub2ind(matrixSize,yIter,xIter,zIter);
            if zIter == 1 || zIter == latticeSize, edgeFlag = 1; end
            if xIter == 1 || xIter == latticeSize, edgeFlag = 1; end
            if yIter == 1 || yIter == latticeSize, edgeFlag = 1; end
            if edgeFlag == 1,
                edgeIndList = [edgeIndList,thisInd];
            else%if edgeFlag == 1,
                nonEdgeIndList = [nonEdgeIndList,thisInd];
            end%if edgeFlag == 1,
        end
    end
end
                


%%
if addRandom4sFlag ==1 ,
    for addIter = 1:(ceil(numAdd4s*numNodes)),
        midLat = ceil(latticeSize/2);
        startCC = [midLat,midLat,midLat];
        startCC = startCC + round((midLat-2)*2*rand([1,3])-(midLat-2));
        startNode = sub2ind(matrixSize,startCC(1),startCC(2),startCC(3));
        endNode = neighborDiff(ceil(rand(1)*6)) + startNode;
        if allowLongDistRandomFlag == 1,
            sep = inf;
            while sep>numMaxStepsLongDist,
                endCC = [midLat,midLat,midLat];
                endCC = endCC + round((midLat-2)*2*rand([1,3])-(midLat-2));
                endNode = sub2ind(matrixSize,endCC(1),endCC(2),endCC(3));
                sep = sum(abs(endCC-startCC));
            end%while sep>...
            
        end% if allowLongDistRandomFlag == 1
        GG(startNode,endNode) = 1;
        GG(endNode,startNode) = 1;
    end%for addIter...
end%if addRandom4sFlag

if addHubLineFlag == 1,
    for hubIter = 1:numHubLines,
        yHub = ceil(rand(1)*latticeSize);
        xHub = ceil(rand(1)*latticeSize);
        for zIter = 1:latticeSize-1;
            startNode = sub2ind(matrixSize,yHub,xHub,zIter);
            endNode = sub2ind(matrixSize,yHub,xHub,zIter+1);
            GG(startNode,endNode) = 1;
            GG(endNode,startNode) = 1;
        end%for zIter,
    end%for hubIter;
    
    for zIter = 1:1,
    for xIter = 1:latticeSize-1
        for yIter = 1:latticeSize-1
            startNode = sub2ind(matrixSize,yIter,xIter,zIter);
            endNode = sub2ind(matrixSize,yIter,xIter+1,zIter);
            GG(startNode,endNode) = 1;
            GG(endNode,startNode) = 1;
            
            startNode = sub2ind(matrixSize,yIter,xIter,zIter);
            endNode = sub2ind(matrixSize,yIter+1,xIter,zIter);
            GG(startNode,endNode) = 1;
            GG(endNode,startNode) = 1;
        end%for yIter = 1:latticeSize-1
    end%for xIter = 1:latticeSize-1
    end% for zIter = 1:9,
    
end%if addHubLineFlag,

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

ggsum = sum(GG>0,2);
ggsum = ggsum(nonEdgeIndList);
numNodes2 = numel(ggsum);
n1 = numel(find(ggsum==1))/numNodes2;
n2 = numel(find(ggsum==2))/numNodes2;
n3 = numel(find(ggsum==3))/numNodes2;
n4 = numel(find(ggsum==4))/numNodes2;
n5 = numel(find(ggsum==5))/numNodes2;
n6 = numel(find(ggsum==6))/numNodes2;
disp('Connectivity stats2:');
disp([n1,n2,n3,n4,n5,n6]);

%Don't allow zero connections to avoid bad eigenvalues
ff = find(ggsum==0);
GG(ff,ff-1) = 1;
GG(ff-1,ff) = 1;


if showLatticeFlag == 1,
    figure(11);hold off
    for rowIter = 1:numNodes,
        cc1 = coordList(rowIter,:);
        thisRow = GG(rowIter,:);
        numConn = sum(thisRow);
        thisRowActive = find(thisRow);
        for connIter = 1:numConn,
            cc2 = coordList(thisRowActive(connIter),:);
            figure(11);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
    %         pause(0.01)
        end%for connIter...
    end%for rowIter;
end%if showLatticeFlag,


if distributedResistancesFlag == 1,
    vectorProject = allProject.au;
    vectorizedStructure = vectorProject.vectorizedStructure;
    strands = vectorProject.vectorizedStructure.Strands;
    vertices = vectorProject.vectorizedStructure.Vertices;
    maskSize = vectorProject.maskSize;
    
    y1 = 300;y2 = maskSize(1)-y1;
    x1 = 300;x2 = maskSize(2)-x1;
    midZ = 500; plusMinusZ = 200;

    strandZList = vectorizedStructure.strandMidYXZList(:,3);
    strandYList = vectorizedStructure.strandMidYXZList(:,1);
    strandXList = vectorizedStructure.strandMidYXZList(:,2);
    zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
    yFlagList = and(strandYList>=y1,strandYList<=y2);
    xFlagList = and(strandXList>=x1,strandXList<=x2);
    includedStrandList = find(and(and(zFlagList,yFlagList),xFlagList));
    plungingSurfaceFlag = ismember([strands(includedStrandList).MedianLabel],[300:499]);
    includedStrandList = includedStrandList(~plungingSurfaceFlag);
    includedStrandConductances = [strands(includedStrandList).strandConductance];
    %---
    
% %     includedStrandList = [1:10000];
% %     
% % includedStrandConductances = rand(10000,1)*3e8+1e8;
% % includedResistances = rand(10000,1)*8e-8 + 1e-8;
% % includedStrandConductances = 1./includedResistances;
% % 
% % includedStrandConductances = includedStrandConductances(includedStrandConductances>0.1);
% % includedStrandConductances = includedStrandConductances(includedStrandConductances<1e11);
% % 
% % includedStrandConductances(:) = 1e8

% % includedStrandConductances(1:2:end) = 1e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(2:20:end) = 2e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(3:20:end) = 3e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(4:20:end) = 4e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(5:20:end) = 5e9;%high conduct = small resistor = big vessel
% % includedStrandConductances = linspace(1e8,1e9,10000);
% % 

    ff = find(GG==1);
    numEntries = numel(ff);
    %---
    numStrandsIncluded = numel(includedStrandList);
    randIndexList = ceil(rand(numEntries,1)*numStrandsIncluded);
    randomizedStrandConductanceList = includedStrandConductances(randIndexList);
    xxx = [-10:0.01:-6];
    hhh = hist(log10(1./includedStrandConductances),xxx);
    figure(1);plot(xxx,hhh);
    hhh2 = hist(log10(1./randomizedStrandConductanceList),xxx);
    figure(2);plot(xxx,hhh2);
    
    
    
    
    GG(ff) = randomizedStrandConductanceList;
end



for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    GG(rowIter,rowIter) = -1*sum(thisRow);
end
GG = -1*GG;

%%
if precautionPauseFlag == 1,
    for kk =1:10,
        disp('pausing');
    end
    for kk = 1:3,
        disp('Long Calc. are you sure?- I''ll ask 3 times');
        pause
    end
end%if precautionPauseFlag == 1,
%---
disp('Starting Eigenvalue calculation');pause(0.1);
tic
[eigenVectors,eigenValueMatrix] = eig(GG);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;
clear eigenValueMatrix
if saveFlag == 1,
    saveName = ['TrimmedCubicLattice',num2str(latticeSize,'%02d'),'CalcResults3b.mat'];
    save(saveName,'GG','numNodes','matrixSize','eigenValues','eigenVectors','runTracePathExperimentFlag','*Flag','num*');
end%if saveFlag

%%

GGSize = size(GG);

[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];


midLat = ceil(latticeSize/2);
startCC = [midLat,midLat,midLat];
floatingNode1ID = sub2ind(matrixSize,startCC(1),startCC(2),startCC(3));



if runTracePathExperimentFlag == 0,
    
    
    skipSize = 1
    
    figure(33);hold off
    allSepList = [];
    allResList = [];
    for floatingNode2ID = 1:skipSize:ceil(0.5*GGSize(1)+1);
        % floatingNode2ID = 500
        runSum = 0;
        mSize = size(eigenVectors,1);
        for iIter = 2:mSize;
            eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
            eVectorBeta = eigenVectors(floatingNode2ID,iIter);
            eVal = eigenValues(iIter);
            cutoff = -1;
            if eVal > cutoff,
                runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
            end
        end%for iIter;
        effectiveResistance = runSum;
        sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
        sep = sum(abs(coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)));
        allSepList = [allSepList,sep];
        allResList = [allResList,effectiveResistance];
    %      figure(3);plot(sep,log10(effectiveResistance*0.8),'c.');hold on
         figure(33);plot(sep+rand(1)-0.5,(effectiveResistance),'c.');hold on
         xlabel('checkerboard distance');ylabel('network resistance');
    end%for floatingNode2ID = ...
    
    
    %Calc running median
% % %     sortData = sortrows([allSepList',allResList'],1);
% % %     halfAveSize = 10;
% % %     numPoints = size(sortData,1);
% % %     medSepList = [];
% % %     medResList = [];
% % %     for pointIter = halfAveSize+1:numPoints-halfAveSize
% % %         medSepList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
% % %         medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
% % %     end
% % %     figure(12);hold off
% % %     figure(12);p1 = plot(allSepList+rand(size(allSepList))*1-0.5,allResList+rand(size(allResList))*0.02-0.01,'g.');hold on
% % %     figure(12);p2 = plot(medSepList,medResList,'k-');
% % %     xlabel('checkerboard distance');
% % %     ylabel('effective network resistance');
    medResList = [];
    medSepList = [];
    for kk = 1:max(allSepList(:)),
        medSepList(kk) = kk;
        q = find(allSepList==kk);
        qm = median(allResList(q));
        medResList(kk) = qm;
    end
    figure(12);hold off
    figure(12);p1 = plot(allSepList+rand(size(allSepList))*1-0.5,allResList+rand(size(allResList))*0.02-0.01,'g.');hold on
    figure(12);p2 = plot(medSepList,medResList,'k-');
    xlabel('checkerboard distance');
    ylabel('effective network resistance');

    %---
    
    
end% if runTracePathExperimentFlag == 0,




if runTracePathExperimentFlag == 1,
    [c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
    coordList = [c1',c2',c3'];
    allMidPointList = [];
    for rowIter = 1:numNodes,
        cc1 = coordList(rowIter,:);
        thisRow = GG(rowIter,:);
        thisRowActive = find(thisRow);
        thisRowActive = thisRowActive(thisRowActive>rowIter);
        numConn = numel(thisRowActive);
        for connIter = 1:numConn,
            cc2 = coordList(thisRowActive(connIter),:);
%             figure(11);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
            allMidPointList = [allMidPointList;[mean([cc1(1),cc2(1)]),mean([cc1(2),cc2(2)]),mean([cc1(3),cc2(3)])]];
    %         pause(0.01)
        end%for connIter...
    end%for rowIter;


    
    
    
    %Calculate network resistance versus number of nodes actually traveled
    fampl = floor(allMidPointList);
    allLowerCoordList = [fampl(:,1)*100*100 + fampl(:,2)*100 + fampl(:,3)];
    floatingNode1ID = ceil(numNodes/2);
    [c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
    coordList = [c1',c2',c3'];
    % % startCoord = coordList(floatingNode1ID,:);
    % % startMidPoint = find(allLowerCoordList == [startCoord(1)*100*100 + startCoord(2)*100 + startCoord(3)]);
    % % startMidPoint = startMidPoint(1);

    figure(1);hold off
    figure(2);hold off

    %Plot network resistance from a node as you track outward


    numStart = 1;
    startPointFluctuation = 2;

    allResList = [];
    allSepList = [];
    allStepList = [];
    
    for startNum = 1:100;%:skipVal:numStart,
    tempGG = GG<0;
        startNode = floatingNode1ID;


        midLat = ceil(latticeSize/2);
        startCC = [midLat,midLat,midLat];
        startCC = startCC + round(startPointFluctuation*2*rand([1,3])-startPointFluctuation);
        startNode = sub2ind(matrixSize,startCC(1),startCC(2),startCC(3));

    
        thisRow = tempGG(startNode,:);
        connectsInRow = find(thisRow==1);
        numConnectsAvailable = numel(connectsInRow);
        r = ceil(rand(1)*numConnectsAvailable);
    r = 1;
        nextNode = connectsInRow(r);
        tempGG(startNode,nextNode) = 0;
        tempGG(nextNode,startNode) = 0;
        thisNode = startNode;

        resList = [];
        sepList = [];
        stepList = [];
            for vIter = 1:100,
                runSum = 0;
                mSize = size(eigenVectors,1);
                for iIter = 2:mSize;
                    eVectorAlpha = eigenVectors(startNode,iIter);
                    eVectorBeta = eigenVectors(nextNode,iIter);
                    eVal = eigenValues(iIter);
                    cutoff = -1;
                    if eVal > cutoff,
                        runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
                    end
                end%for iIter;
                effectiveResistance = runSum;
    %             effectiveResistance = min(effectiveResistance,4e-7);
                if isempty(effectiveResistance),effectiveResistance = inf;end
                resList(vIter) = effectiveResistance;
                sep = coordList(startNode,:) - coordList(nextNode,:);
                sepDist = sqrt(sum(sep.^2));
                stepList(vIter) = vIter;
                sepList(vIter) = sepDist;


                thisNode = nextNode;
                thisRow = tempGG(thisNode,:);
                connectsInRow = find(thisRow==1);
                if ~isempty(connectsInRow),
                    numConnectsAvailable = numel(connectsInRow);
                    r = ceil(rand(1)*numConnectsAvailable);
        r = 1;
                    nextNode = connectsInRow(r);
                    tempGG(thisNode,nextNode) = 0;
                    tempGG(nextNode,thisNode) = 0;
                else%if isempty(connectsInRow),
                    break%for vIter loop
                end%if isempty(connectsInRow),
                
            end%for vIter...
            
            allResList = [allResList,resList];
            allSepList = [allSepList,sepList];
            allStepList = [allStepList,stepList];

            
            allResList = min(allResList,maxRes);

        figure(1);plot((resList),'r.');hold on
        xlabel('number of branches out'),ylabel('network resistance');
        figure(2);plot(sepList,'g.');hold on
        xlabel('number of branches out'),ylabel('Euclidean distance');

    end%for startNum
    
    
    %Calc running median
    sortData = sortrows([allStepList',allResList'],1);
    halfAveSize = 50;
    numPoints = size(sortData,1);
    medStepList = [];
    medResList = [];
    for pointIter = halfAveSize+1:numPoints-halfAveSize
        medStepList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
        medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
    end
    figure(12);hold off
    figure(12);plot(allStepList,allResList,'g.');hold on
    figure(12);plot(medStepList,medResList,'k-');
    xlabel('path distance along microvessel network');
    ylabel('effective network resistance');
    %---
    

    
end%if runTracePathExperimentFlag == 1,



