latticeSize = 3;
numRep = 3;
numConnectionsToAdd = 1; %inter-neighborhood connections
trimWhileAddingFlag = 0; %each time you add a connection, remove one existing from each node
    %this effectively trades excess 4's for excess 2's
displayFullMatrixFlag = 1;
precautionPauseFlag = 0;
runTracePathExperimentFlag = 0;

skipVal = 1;%>1 = don't plot every point

numNodes = latticeSize^3;
GG = zeros(numNodes,numNodes);
myMatrix = false(latticeSize,latticeSize,latticeSize);
matrixSize = size(myMatrix);

onePlane = latticeSize*latticeSize;
oneCol = latticeSize;
oneRow = 1;
fullRow = [-1 0 1];
neighborDiff = [ -onePlane,  -oneCol, -oneRow, +oneRow, +oneCol,  +onePlane];

%Generate a cubic lattice with periodic boundary conditions
for nodeIter = 1:numNodes,
    thisNode = nodeIter;
    neighborList = thisNode + neighborDiff;
    neighborList = neighborList(neighborList>0);
    neighborList = neighborList(neighborList<=numNodes);
    GG(nodeIter,neighborList) = 1;
end%for nodeIter = 1:numNodes,


%Remove the periodic boundary conditions
for nodeIter = 1:numNodes,
    if nodeIter<=numNodes-1 && mod(nodeIter,latticeSize) == 0,
        GG(nodeIter,nodeIter+1) = 0;
        GG(nodeIter+1,nodeIter) = 0;
    end
    %---
    if nodeIter<=numNodes-latticeSize && mod(ceil(nodeIter/latticeSize),latticeSize) == 0,
        GG(nodeIter,nodeIter+latticeSize) = 0;
        GG(nodeIter+latticeSize,nodeIter) = 0;
    end
end
        

ggsum = sum(GG>0,2);
n1 = numel(find(ggsum==1))/numNodes;
n2 = numel(find(ggsum==2))/numNodes;
n3 = numel(find(ggsum==3))/numNodes;
n4 = numel(find(ggsum==4))/numNodes;
n5 = numel(find(ggsum==5))/numNodes;
n6 = numel(find(ggsum==6))/numNodes;
disp('Connectivity stats1:');
disp([n1,n2,n3,n4,n5,n6]);

%Trim down to three connections per node
removalPattern = [1 2 3 6 5 4];
removalCounter = 0
for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    thisRowActive = find(thisRow);
    thisRowActive = thisRowActive(thisRowActive>rowIter);
    thisRowActiveRep = repmat(thisRowActive,[1,6]);
    numConn = sum(thisRow);
    numRemove = max(0,numConn-3);
    numNeighborConn = [];
    numActive = numel(thisRowActive);
    for checkIter = 1:numActive,
        neighborRow = GG(thisRowActive(checkIter),:);
        numNeighborConn(checkIter) = sum(neighborRow>0);
    end%for checkIter
    [ss,si] = sort(numNeighborConn,'descend');
    thisRowActiveSort = thisRowActive(si);
    above3Flag = ss>3;
    thisRowAbove = thisRowActiveSort(above3Flag);
    numAbove = numel(thisRowAbove);
    thisRowBelow = thisRowActiveSort(~above3Flag);
    if numRemove>0,
        if numRemove<numAbove,
            removalTickers = [1:numRemove]+removalCounter; 
            removalPatternInds = mod(removalTickers,numAbove)+1;
            removalPos = thisRowAbove(removalPatternInds);
        else%if numRemove<numAbove,
            removalPos = thisRowActiveSort(1:numRemove);
        end%if-else numRemove<numAbove,

        GG(rowIter,removalPos) = 0;
        GG(removalPos,rowIter) = 0;
        newRow = GG(rowIter,:);
        newSum = sum(newRow);
        if newSum == 2, keyboard;end
        removalCounter = removalCounter + numRemove;
            
% % %         removalTickers = [1:numRemove]+removalCounter;
% % %         removalPatternInds = mod(removalTickers,6)+1;
% % %         removalInds = removalPattern(removalPatternInds);
% % %         removalPos = thisRowActiveRep(removalInds);
% % %         if numel(unique(removalPos))~=numel(removalPos),
% % %             removalPos = thisRowActive(1:numel(removalPos));
% % %         end%if numel...
    end%if numRemove>0

end%for rowIter = 1:numNodes,


ggsum = sum(GG>0,2);
n1 = numel(find(ggsum==1))/numNodes;
n2 = numel(find(ggsum==2))/numNodes;
n3 = numel(find(ggsum==3))/numNodes;
n4 = numel(find(ggsum==4))/numNodes;
n5 = numel(find(ggsum==5))/numNodes;
n6 = numel(find(ggsum==6))/numNodes;
disp('Connectivity stats2:');
disp([n1,n2,n3,n4,n5,n6]);


[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

midPointList = [];
figure(11);hold off
for rowIter = 1:numNodes,
    cc1 = coordList(rowIter,:);
    thisRow = GG(rowIter,:);
    thisRowActive = find(thisRow);
    thisRowActive = thisRowActive(thisRowActive>rowIter);
    numConn = numel(thisRowActive);
    for connIter = 1:numConn,
        cc2 = coordList(thisRowActive(connIter),:);
        figure(11);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
        midPointList = [midPointList;[mean([cc1(1),cc2(1)]),mean([cc1(2),cc2(2)]),mean([cc1(3),cc2(3)])]];
%         pause(0.01)
    end%for connIter...
end%for rowIter;

baseMidPointList = midPointList;
allMidPointList = [];

%%
%Replicate the neighborhood:

for yIter = 1:numRep,
    addY = latticeSize*(yIter-1);
    for xIter = 1:numRep,
        addX = latticeSize*(xIter-1);
        for zIter = 1:numRep,
            addZ = latticeSize*(zIter-1);
            newMidPointList = baseMidPointList + repmat([addY, addX, addZ],[size(baseMidPointList,1),1]);
            allMidPointList = [allMidPointList;newMidPointList];
        end%for zIter = 1:numRep,
    end%for xIter = 1:numRep,
end%for yIter = 1:numRep,


%%
faceSize = latticeSize.^2;
myLin  = linspace(1,faceSize,numConnectionsToAdd+1);
addInd = mod(round(myLin(1:numConnectionsToAdd) + faceSize/2 - 2),faceSize)+1;

%Add inter-neighborhood connections
counter = 0;
for yIter = 1:numRep,
    addY = latticeSize*(yIter-1);
    for xIter = 1:numRep,
        addX = latticeSize*(xIter-1);
        for zIter = 1:numRep,
            addZ = latticeSize*(zIter-1);
            for faceIter = 1:3,
                otherInd = find([1,2,3]~=faceIter);
                %face1 = increase in y
                block1ID = [yIter,xIter,zIter];
                block2ID = block1ID;
                block2ID(faceIter) = block2ID(faceIter)+1;
                if sum(block2ID>numRep) == 0,
                    [c1,c2] = ind2sub([latticeSize,latticeSize],addInd);
                    for kk = 1:numConnectionsToAdd
                        sc(otherInd(1)) = c1(kk);
                        sc(otherInd(2)) = c2(kk);
                        sc(faceIter) = latticeSize;
                        sc(1) = sc(1) + addY;
                        sc(2) = sc(2) + addX;
                        sc(3) = sc(3) + addZ;
                        newMidPoint = [sc(1),sc(2),sc(3)];
                        newMidPoint(faceIter) = newMidPoint(faceIter)+ 0.5;
%                        pause
                        counter = counter + 1;
                        allMidPointList = [allMidPointList;newMidPoint];
                        %---
                        if trimWhileAddingFlag == 1,
                            fampl = floor(allMidPointList);
                            allLowerCoordList = [fampl(:,1)*100*100 + fampl(:,2)*100 + fampl(:,3)];
                            campl = ceil(allMidPointList);
                            allUpperCoordList = [campl(:,1)*100*100 + campl(:,2)*100 + campl(:,3)];
                            fnmp = floor(newMidPoint);
                            cnmp = ceil(newMidPoint);
                            thisLower = [fnmp(:,1)*100*100 + fnmp(:,2)*100 + fnmp(:,3)];
                            thisUpper = [cnmp(:,1)*100*100 + cnmp(:,2)*100 + cnmp(:,3)];
                            flag1 = allLowerCoordList == thisLower;
                            flag2 = allUpperCoordList == thisLower;
                            ff = find(or(flag1,flag2));
                            allMidPointList = [allMidPointList(1:ff(1)-1,:);allMidPointList(ff(1)+1:end,:)];
                            %---
                            flag1 = allLowerCoordList == thisUpper;
                            flag2 = allUpperCoordList == thisUpper;
                            ff = find(or(flag1,flag2));
                            allMidPointList = [allMidPointList(1:ff(1)-1,:);allMidPointList(ff(1)+1:end,:)];
                        end%if trimWhileAddingFlag == 1,
                            
                    end%for kk
                   
                end%if sum...
%                 disp('next Face');
            end%for faceIter..
        end%for zIter = 1:numRep,
    end%for xIter = 1:numRep,
end%for yIter = 1:numRep,


%%
if displayFullMatrixFlag ==1 ,
    %Show full matrix (neighborhoods conncected)
    numConnects = size(allMidPointList,1);
    figure(12);hold off
    for kk = 1:numConnects,
        thisMidPoint = allMidPointList(kk,:);
        cc1 = ceil(thisMidPoint-0.2);
        cc2 = floor(thisMidPoint+0.2);
        figure(12);plot3([cc1(1),cc2(1)],[cc1(2),cc2(2)],[cc1(3),cc2(3)],'r-');hold on;
    end%for kk
    figure(12);hold off
end%if displayFullMatrixFlag ==1 ,

%%
maxSize = max(allMidPointList(:));
latticeSize = maxSize;
matrixSize = [latticeSize,latticeSize,latticeSize];
numNodes = latticeSize^3;
GG = zeros(numNodes,numNodes);
for kk = 1:length(allMidPointList);
    thisMidPoint = allMidPointList(kk,:);
    cca = floor(thisMidPoint);
    ccb = ceil(thisMidPoint);
    ind1 = sub2ind(matrixSize,cca(1),cca(2),cca(3));
    ind2 = sub2ind(matrixSize,ccb(1),ccb(2),ccb(3));
    GG(ind1,ind2) = 1;
    GG(ind2,ind1) = 1;
end
    
%Matrix stats:
ggsum = sum(GG>0,2);
n1 = numel(find(ggsum==1))/numNodes;
n2 = numel(find(ggsum==2))/numNodes;
n3 = numel(find(ggsum==3))/numNodes;
n4 = numel(find(ggsum==4))/numNodes;
n5 = numel(find(ggsum==5))/numNodes;
disp('Connectivity stats:');
disp([n1,n2,n3,n4,n5]);
%%
distributedResistancesFlag = 0;

if distributedResistancesFlag == 1,
    vectorProject = allProject.au;
    vectorizedStructure = vectorProject.vectorizedStructure;
    strands = vectorProject.vectorizedStructure.Strands;
    vertices = vectorProject.vectorizedStructure.Vertices;
    maskSize = vectorProject.maskSize;
    
    y1 = 300;y2 = maskSize(1)-y1;
    x1 = 300;x2 = maskSize(2)-x1;
    midZ = 500; plusMinusZ = 200;

    strandZList = vectorizedStructure.strandMidYXZList(:,3);
    strandYList = vectorizedStructure.strandMidYXZList(:,1);
    strandXList = vectorizedStructure.strandMidYXZList(:,2);
    zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
    yFlagList = and(strandYList>=y1,strandYList<=y2);
    xFlagList = and(strandXList>=x1,strandXList<=x2);
    includedStrandList = find(and(and(zFlagList,yFlagList),xFlagList));
    plungingSurfaceFlag = ismember([strands(includedStrandList).MedianLabel],[300:499]);
    includedStrandList = includedStrandList(~plungingSurfaceFlag);
    includedStrandConductances = [strands(includedStrandList).strandConductance];
    %---
    
% %     includedStrandList = [1:10000];
% %     
% % includedStrandConductances = rand(10000,1)*3e8+1e8;
% % includedResistances = rand(10000,1)*8e-8 + 1e-8;
% % includedStrandConductances = 1./includedResistances;
% % 
% % includedStrandConductances = includedStrandConductances(includedStrandConductances>0.1);
% % includedStrandConductances = includedStrandConductances(includedStrandConductances<1e11);
% % 
% % includedStrandConductances(:) = 1e8

% % includedStrandConductances(1:2:end) = 1e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(2:20:end) = 2e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(3:20:end) = 3e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(4:20:end) = 4e9;%high conduct = small resistor = big vessel
% % includedStrandConductances(5:20:end) = 5e9;%high conduct = small resistor = big vessel
% % includedStrandConductances = linspace(1e8,1e9,10000);
% % 

    ff = find(GG==1);
    numEntries = numel(ff);
    %---
    numStrandsIncluded = numel(includedStrandList);
    randIndexList = ceil(rand(numEntries,1)*numStrandsIncluded);
    randomizedStrandConductanceList = includedStrandConductances(randIndexList);
    xxx = [-10:0.01:-6];
    hhh = hist(log10(1./includedStrandConductances),xxx);
    figure(1);plot(xxx,hhh);
    hhh2 = hist(log10(1./randomizedStrandConductanceList),xxx);
    figure(2);plot(xxx,hhh2);
    
    
    
    
    GG(ff) = randomizedStrandConductanceList;
end



for rowIter = 1:numNodes,
    thisRow = GG(rowIter,:);
    GG(rowIter,rowIter) = -1*sum(thisRow);
end
GG = -1*GG;

%%
if precautionPauseFlag == 1,
    for kk =1:10,
        disp('pausing');
    end
    for kk = 1:3,
        disp('Long Calc. are you sure?- I''ll ask 3 times');
        pause
    end
end%if precautionPauseFlag == 1,
%---
disp('Starting Eigenvalue calculation');pause(0.1);
tic
[eigenVectors,eigenValueMatrix] = eig(GG);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;



%%

GGSize = size(GG);
floatingNode1ID = ceil(numNodes/2);
[c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
coordList = [c1',c2',c3'];

figure(3);hold off
for floatingNode2ID = 1:skipVal:GGSize(1);
    % floatingNode2ID = 500
    runSum = 0;
    mSize = size(eigenVectors,1);
    for iIter = 2:mSize;
        eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
        eVectorBeta = eigenVectors(floatingNode2ID,iIter);
        eVal = eigenValues(iIter);
        cutoff = -1;
        if eVal > cutoff,
            runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
        end
    end%for iIter;
    effectiveResistance = runSum
    sep = sqrt(sum((coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)).^2,2));
    sep = sum(abs(coordList(floatingNode2ID,:)-coordList(floatingNode1ID,:)));
%      figure(3);plot(sep,log10(effectiveResistance*0.8),'c.');hold on
     figure(3);plot(sep,effectiveResistance,'c.');hold on
end%for floatingNode2ID = ...



%%

if runTracePathExperimentFlag == 1,
    
    %Calculate network resistance versus number of nodes actually traveled
    fampl = floor(allMidPointList);
    allLowerCoordList = [fampl(:,1)*100*100 + fampl(:,2)*100 + fampl(:,3)];
    floatingNode1ID = ceil(numNodes/2);
    [c1,c2,c3] = ind2sub(matrixSize,[1:numNodes]);
    coordList = [c1',c2',c3'];
    % % startCoord = coordList(floatingNode1ID,:);
    % % startMidPoint = find(allLowerCoordList == [startCoord(1)*100*100 + startCoord(2)*100 + startCoord(3)]);
    % % startMidPoint = startMidPoint(1);

    figure(1);hold off
    figure(2);hold off

    %Plot network resistance from a node as you track outward


    numStart = 1;


    for startNum = 1:100;%:skipVal:numStart,
    tempGG = GG>0;
    pause
        startNode = floatingNode1ID;
        thisRow = tempGG(startNode,:);
        connectsInRow = find(thisRow==1);
        numConnectsAvailable = numel(connectsInRow);
        r = ceil(rand(1)*numConnectsAvailable);
        nextNode = connectsInRow(r);
        tempGG(startNode,nextNode) = 0;
        tempGG(nextNode,startNode) = 0;
        thisNode = startNode;

        resList = [];
        sepList = [];
            for vIter = 1:100,
                runSum = 0;
                mSize = size(eigenVectors,1);
                for iIter = 2:mSize;
                    eVectorAlpha = eigenVectors(startNode,iIter);
                    eVectorBeta = eigenVectors(nextNode,iIter);
                    eVal = eigenValues(iIter);
                    cutoff = -1;
                    if eVal > cutoff,
                        runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
                    end
                end%for iIter;
                effectiveResistance = runSum;
    %             effectiveResistance = min(effectiveResistance,4e-7);
                if isempty(effectiveResistance),effectiveResistance = inf;end
                resList(vIter) = effectiveResistance;
                sep = coordList(startNode,:) - coordList(nextNode,:);
                sepDist = sqrt(sum(sep.^2));
                sepList(vIter) = sepDist;


                thisNode = nextNode;
                thisRow = tempGG(thisNode,:);
                connectsInRow = find(thisRow==1);
                if ~isempty(connectsInRow),
                    numConnectsAvailable = numel(connectsInRow);
                    r = ceil(rand(1)*numConnectsAvailable);
                    nextNode = connectsInRow(r);
                    tempGG(thisNode,nextNode) = 0;
                    tempGG(nextNode,thisNode) = 0;
                else%if isempty(connectsInRow),
                    break%for vIter loop
                end%if isempty(connectsInRow),

            end%for vIter...

        figure(1);plot((resList),'r.');hold off
        xlabel('number of branches out'),ylabel('network resistance');
        figure(2);plot(sepList,'g.');hold off
        xlabel('number of branches out'),ylabel('Euclidean distance');

    end%for startNum
end%if runTracePathExperimentFlag == 1,

