
%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];



%%%Stage 2: Find the offshoots of plunging arterioles
flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
startList = vectorProject.vectorizedStructure.allPlungingArterioleList;
flowProject.baseStrandIDList = startList;
flowProject.maxBranchSearch = 3;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
disp('Calculating downstream paths...');
tic
fullFlowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
toc
downstreamBranchList = fullFlowProject.downstreamBranchList;

offshootList = find(min(downstreamBranchList,[],2)==1);
offshootList = offshootList(~ismember(offshootList,startList));

for startIter = 105:numel(offshootList),
    
    flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
    flowProject.Strands = vectorProject.vectorizedStructure.Strands;
    flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
    startList = vectorProject.vectorizedStructure.allPlungingArterioleList;
    flowProject.baseStrandIDList = offshootList(startIter);
    flowProject.maxBranchSearch = 30;
    flowProject.stopVoltage = 50.1;%Hardcode;
    flowProject.minimumFluxFraction = 1/(2^18);%Hardcode
    disp('Calculating downstream paths...');
    tic
    fullFlowProject = CalculateDownstreamPathsFromVectorProject(flowProject);
    toc
    
    downstreamBranchList = fullFlowProject.downstreamBranchList;
    branchOrderList = min(downstreamBranchList,[],2);
    
    subOrderList = branchOrderList(branchOrderList<inf);
    thisStrandSet = find(branchOrderList<inf);
    xRange = [1:30];
    h = hist(subOrderList,xRange);
    figure(44);bar(xRange,h);
    title(num2str(offshootList(startIter)));
    pause
end
