
%Stage 1: Load a -flow-vectorProject
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;

flowAnalysisParameters = [];
cleanupFlag = 1;
%%
%%Stage 2: Run the unperturbed flow analysis:
disp('Starting Unperturbed Calculation');
unperturbedProject1 = vectorProject;
unperturbedProject1.circuitAnalysisParameters.minRadius = 0;
unperturbedProject1 = CalculateUnperturbedFlow003(unperturbedProject1);
disp('UnPerturbed Flow Calculation completed');


%%

myCamva = camva;
myCamup = camup;
myCampos = campos;
myCamtarget = camtarget;


%%
%%Stage 3: Select a vessel segment to occlude
tipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
numTips = numel(tipList);
stallMatrix = [];
stallIDMatrix = [];

%%
% % for firstTipIter = 1:numTips-1,
% %     for secondTipIter = firstTipIter:numTips,
firstTipIter = 44;
secondTipIter = 55;
        
        disp(['TIP ITER ',num2str(firstTipIter),' and ',num2str(secondTipIter)]);
        firstOcclusionStrandID = tipList(firstTipIter);
        secondOcclusionStrandID = tipList(secondTipIter);
        origRadius = vectorProject.vectorizedStructure.effectiveStrandRadiusList(firstOcclusionStrandID);

        disp('Starting Perturbed1 Calculation');
        perturbedProject1 = vectorProject;
        perturbedProject1.circuitAnalysisParameters.minRadius = 0;
        perturbedProject1.vectorizedStructure.effectiveStrandRadiusList(firstOcclusionStrandID) = 0;
        perturbedProject1 = CalculateUnperturbedFlow003(perturbedProject1);
        disp('Perturbed1 Flow Calculation completed');

        disp('Starting Perturbed2 Calculation');
        perturbedProject2 = vectorProject;
        perturbedProject2.circuitAnalysisParameters.minRadius = 0;
        perturbedProject2.vectorizedStructure.effectiveStrandRadiusList(secondOcclusionStrandID) = 0;
        perturbedProject2 = CalculateUnperturbedFlow003(perturbedProject2);
        disp('Perturbed2 Flow Calculation completed');

        disp('Starting Perturbed3 Calculation');
        perturbedProject3 = vectorProject;
        perturbedProject3.circuitAnalysisParameters.minRadius = 0;
        perturbedProject3.vectorizedStructure.effectiveStrandRadiusList(firstOcclusionStrandID) = 0;
        perturbedProject3.vectorizedStructure.effectiveStrandRadiusList(secondOcclusionStrandID) = 0;
        perturbedProject3 = CalculateUnperturbedFlow003(perturbedProject3);
        disp('Perturbed3 Flow Calculation completed');


        %%Stage 7: Occlude stalled vessels
        stopCountingNumStalls = 15000;%Hardcode
        numRepeats = 50;
        stopFlags = [0 0 0];
        stallRatio = 0.5;
        numStalls = zeros(3,numRepeats);
        f1 = figure(1);set(f1,'DoubleBuffer','on');clf
        f2 = figure(2);set(f2,'DoubleBuffer','on');clf
        f3 = figure(3);set(f3,'DoubleBuffer','on');clf
        f4 = figure(4);set(f4,'DoubleBuffer','on');clf
        for repeatIter = 1:numRepeats,
            disp(['REPEAT # ',num2str(repeatIter)]);
            origCurrentList = [unperturbedProject1.vectorizedStructure.Strands(:).strandCurrent];
            perturbedCurrentList1 = [perturbedProject1.vectorizedStructure.Strands(:).strandCurrent];
            perturbedCurrentList2 = [perturbedProject2.vectorizedStructure.Strands(:).strandCurrent];
            perturbedCurrentList3 = [perturbedProject3.vectorizedStructure.Strands(:).strandCurrent];
            currentRatioList1 = abs(perturbedCurrentList1./origCurrentList);
            currentRatioList2 = abs(perturbedCurrentList2./origCurrentList);
            currentRatioList3 = abs(perturbedCurrentList3./origCurrentList);
            stalledVesselList1 = find(currentRatioList1<stallRatio);
            stalledVesselList2 = find(currentRatioList2<stallRatio);
            stalledVesselList3 = find(currentRatioList3<stallRatio);
            %-----
            %-----
            %Display Results
            y1 = 0; y2 = inf; x1 = 0; x2 = inf; z1 = 0; z2 = inf;
            % zo = 700; dz = 100; z1 = zo-dz;z2 = zo+dz;
            av = vertices.AllVerts;
            numVerts = size(av,1);
            subAVFlags = and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2));
            %Plot decreased flow as as shades of blue
            blueRatioList = [0.5 0.3 0.1];
            minRatio = blueRatioList(end);
            ratioRange = blueRatioList(1)-blueRatioList(end)+blueRatioList(end-1)-blueRatioList(end);
            for blueColorRatioIter = 1:numel(blueRatioList),
                thisRatio = blueRatioList(blueColorRatioIter);
                thisColor = [(thisRatio-minRatio)/ratioRange, (thisRatio-minRatio)/ratioRange, 1];
                thisColor = min(1,thisColor);
                %---
                activeStrands1 = find(currentRatioList1<thisRatio);
                numStalls(1,repeatIter) = numel(activeStrands1);
                activeIndices1 = [strands(activeStrands1).StartToEndIndices];
                activeFlags1 = zeros(numVerts,1);
                activeFlags1(activeIndices1) = 1;
                activeCoords1 = [vertices.AllVerts(and(activeFlags1,subAVFlags),:)];
                figure(1);p1 = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'b.');
                if exist('myCamva')
                    camva(myCamva);camup(myCamup);campos(myCampos);camtarget(myCamtarget);
                else
                    myCamva = camva; myCamup = camup; myCampos = campos; myCamtarget = camtarget;
                end
                set(p1,'MarkerSize',1,'Color',thisColor);hold on
                %---
                activeStrands2 = find(currentRatioList2<thisRatio);
                numStalls(2,repeatIter) = numel(activeStrands2);
                activeIndices2 = [strands(activeStrands2).StartToEndIndices];
                activeFlags2 = zeros(numVerts,1);
                activeFlags2(activeIndices2) = 1;
                activeCoords2 = [vertices.AllVerts(and(activeFlags2,subAVFlags),:)];
                figure(2);p2 = plot3(activeCoords2(:,1),activeCoords2(:,2),-1*activeCoords2(:,3),'b.');
                camva(myCamva);camup(myCamup);campos(myCampos);camtarget(myCamtarget);
                set(p2,'MarkerSize',1,'Color',thisColor);hold on
                %---
                activeStrands3 = find(currentRatioList3<thisRatio);
                numStalls(3,repeatIter) = numel(activeStrands3);
                activeIndices3 = [strands(activeStrands3).StartToEndIndices];
                activeFlags3 = zeros(numVerts,1);
                activeFlags3(activeIndices3) = 1;
                activeCoords3 = [vertices.AllVerts(and(activeFlags3,subAVFlags),:)];
                figure(3);p3 = plot3(activeCoords3(:,1),activeCoords3(:,2),-1*activeCoords3(:,3),'b.');
                camva(myCamva);camup(myCamup);campos(myCampos);camtarget(myCamtarget);
                set(p3,'MarkerSize',1,'Color',thisColor);hold on
                %---
                activeStrands4 = find(or(currentRatioList1<thisRatio,currentRatioList2<thisRatio));
                activeIndices4 = [strands(activeStrands4).StartToEndIndices];
                activeFlags4 = zeros(numVerts,1);
                activeFlags4(activeIndices4) = 1;
                activeCoords4 = [vertices.AllVerts(and(activeFlags4,subAVFlags),:)];
                figure(4);p4 = plot3(activeCoords4(:,1),activeCoords4(:,2),-1*activeCoords4(:,3),'b.');
                camva(myCamva);camup(myCamup);campos(myCampos);camtarget(myCamtarget);
                set(p4,'MarkerSize',1,'Color',thisColor);hold on
            end
% % % % %             %Plot increased flow as as shades of red
% % % % %             redRatioList = [1.5 1.75 2];
% % % % %             maxRatio = redRatioList(end);
% % % % %             ratioRange = redRatioList(end)-redRatioList(1)+redRatioList(2)-redRatioList(1);
% % % % %             for redColorRatioIter = 1:numel(redRatioList),
% % % % %                 thisRatio = redRatioList(redColorRatioIter);
% % % % %                 thisColor = [1, (maxRatio-thisRatio)/ratioRange, (maxRatio-thisRatio)/ratioRange];
% % % % %                 thisColor = min(1,thisColor);
% % % % %                 %---
% % % % %                 activeStrands1 = find(currentRatioList1>thisRatio);
% % % % %                 activeIndices1 = [strands(activeStrands1).StartToEndIndices];
% % % % %                 activeFlags1 = zeros(numVerts,1);
% % % % %                 activeFlags1(activeIndices1) = 1;
% % % % %                 activeCoords1 = [vertices.AllVerts(and(activeFlags1,subAVFlags),:)];
% % % % %                 figure(1);p1 = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'r.');
% % % % %                 set(p1,'MarkerSize',1,'Color',thisColor);hold on
% % % % %                 %---
% % % % %                 activeStrands2 = find(currentRatioList2>thisRatio);
% % % % %                 activeIndices2 = [strands(activeStrands2).StartToEndIndices];
% % % % %                 activeFlags2 = zeros(numVerts,1);
% % % % %                 activeFlags2(activeIndices2) = 1;
% % % % %                 activeCoords2 = [vertices.AllVerts(and(activeFlags2,subAVFlags),:)];
% % % % %                 figure(2);p2 = plot3(activeCoords2(:,1),activeCoords2(:,2),-1*activeCoords2(:,3),'r.');
% % % % %                 set(p2,'MarkerSize',1,'Color',thisColor);hold on
% % % % %                 %---
% % % % %                 activeStrands3 = find(currentRatioList3>thisRatio);
% % % % %                 activeIndices3 = [strands(activeStrands3).StartToEndIndices];
% % % % %                 activeFlags3 = zeros(numVerts,1);
% % % % %                 activeFlags3(activeIndices3) = 1;
% % % % %                 activeCoords3 = [vertices.AllVerts(and(activeFlags3,subAVFlags),:)];
% % % % %                 figure(3);p3 = plot3(activeCoords3(:,1),activeCoords3(:,2),-1*activeCoords3(:,3),'r.');
% % % % %                 set(p3,'MarkerSize',1,'Color',thisColor);hold on
% % % % %                 %---
% % % % %                 activeStrands4 = find(or(currentRatioList1>thisRatio,currentRatioList2>thisRatio));
% % % % %                 activeIndices4 = [strands(activeStrands4).StartToEndIndices];
% % % % %                 activeFlags4 = zeros(numVerts,1);
% % % % %                 activeFlags4(activeIndices4) = 1;
% % % % %                 activeCoords4 = [vertices.AllVerts(and(activeFlags4,subAVFlags),:)];
% % % % %                 figure(4);p4 = plot3(activeCoords4(:,1),activeCoords4(:,2),-1*activeCoords4(:,3),'r.');
% % % % %                 set(p4,'MarkerSize',1,'Color',thisColor);hold on
% % % % %                 %---
% % % % %             end%for redColorRatioIter...
            %---
            occulsionIndices1 = [strands(firstOcclusionStrandID).StartToEndIndices];
            activeFlags1 = zeros(numVerts,1);
            activeFlags1(occulsionIndices1) = 1;
            activeCoords1 = [vertices.AllVerts(and(activeFlags1,subAVFlags),:)];
            figure(1);p1 = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'g.');
            set(p1,'MarkerSize',5)
            figure(1);plot3(0,0,0,'w.');plot3(maskSize(1),maskSize(2),-1*maskSize(3),'w.');axis tight;hold off
            %---
            occulsionIndices2 = [strands(secondOcclusionStrandID).StartToEndIndices];
            activeFlags2 = zeros(numVerts,1);
            activeFlags2(occulsionIndices2) = 1;
            activeCoords2 = [vertices.AllVerts(and(activeFlags2,subAVFlags),:)];
            figure(2);p2 = plot3(activeCoords2(:,1),activeCoords2(:,2),-1*activeCoords2(:,3),'g.');
            set(p2,'MarkerSize',5);
            figure(2);plot3(0,0,0,'w.');plot3(maskSize(1),maskSize(2),-1*maskSize(3),'w.');axis tight;hold off
            %---
            figure(3);p3a = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'g.');
            figure(3);p3b = plot3(activeCoords2(:,1),activeCoords2(:,2),-1*activeCoords2(:,3),'g.');
            set(p3a,'MarkerSize',5);
            set(p3b,'MarkerSize',5);
            figure(3);plot3(0,0,0,'w.');plot3(maskSize(1),maskSize(2),-1*maskSize(3),'w.');axis tight;hold off
            %---
            figure(4);p4a = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'g.');
            figure(4);p4b = plot3(activeCoords2(:,1),activeCoords2(:,2),-1*activeCoords2(:,3),'g.');
            set(p4a,'MarkerSize',5);
            set(p4b,'MarkerSize',5);
            figure(4);plot3(0,0,0,'w.');plot3(maskSize(1),maskSize(2),-1*maskSize(3),'w.');axis tight;hold off
            %---
            figure(11);plot(numStalls');
            pause(0.1)
            %-----
            %-----
            if repeatIter > 3,
                if numStalls(1,repeatIter) <= numStalls(1,repeatIter-1), stopFlags(1) = 1; end
                if numStalls(2,repeatIter) <= numStalls(2,repeatIter-1), stopFlags(2) = 1; end
                if numStalls(3,repeatIter) <= numStalls(3,repeatIter-1), stopFlags(3) = 1; end
                if sum(stopFlags) == 3, break, end%break out of repeatIter loop
            end%if repeatIter >3
            
            %Run next iteration of flow calculation with stalls
            if stopFlags(1) == 0,
                disp('STARTING Perturbed1 Flow Calculation');
                perturbedProject1.vectorizedStructure.effectiveStrandRadiusList(stalledVesselList1) = 0;
                perturbedProject1 = CalculateUnperturbedFlow003(perturbedProject1);
            end%if stopFlag(1) == 0,
            %---
            if stopFlags(2) == 0,
                disp('STARTING Perturbed2 Flow Calculation');
                perturbedProject2.vectorizedStructure.effectiveStrandRadiusList(stalledVesselList2) = 0;
                perturbedProject2 = CalculateUnperturbedFlow003(perturbedProject2);
            end%if stopFlag(2) == 0,
            %---
            if stopFlags(3) == 0,
                disp('STARTING Perturbed3 Flow Calculation');
                perturbedProject3.vectorizedStructure.effectiveStrandRadiusList(stalledVesselList1) = 0;
                perturbedProject3.vectorizedStructure.effectiveStrandRadiusList(stalledVesselList2) = 0;
                perturbedProject3 = CalculateUnperturbedFlow003(perturbedProject3);
            end%if stopFlag(3) == 0,
            %-----
            

        end%for repeatIter = ...

% end%for firstTipIter = 
% % % 
% % % myParameters.generatedBy = 'IterateDamageFromSingleOcclusion_Auto.m';
% % % myParameters.circuitAnalysisParameters = unperturbedProject1.circuitAnalysisParameters;
% % % myParameters.stallRatioList = stallRatioList;
% % % myParameters.stopCountingNumStalls = stopCountingNumStalls;
% % % myParameters.numRepeats = numRepeats;
% % % 
% % % save IterateDamageFromSingleOcclusionResults.m myParameters stallMatrix stallIDMatrix


% % % %%
% % % volumePerStrand = prod(maskSize)/numel(strands);
% % % allCystDiameter = zeros(numTips,numStallRatio);
% % % explodeVal = zeros(numTips,1);
% % % for firstTipIter = 2:numTips,
% % %     disp(['Tip # ',num2str(firstTipIter)]);
% % %     stallCurves = stallMatrix{firstTipIter};
% % %     for curveIter = 1:size(stallCurves,1),
% % %         thisRatio = stallRatioList(curveIter);
% % %         figure(77);plot(stallCurves(1:curveIter,:)');
% % %         title(num2str(thisRatio));
% % %         if max(stallCurves(curveIter,:)) >stopCountingNumStalls,
% % %             explodeVal(firstTipIter) = thisRatio;
% % %         end%if max(...)
% % %         maxStalls = max(0,max(stallCurves(curveIter,:)));
% % %         figure(78);plot(explodeVal,'g.');
% % %         figure(79);plot(thisRatio,maxStalls,'r.');hold on
% % %         
% % %         cystVol = maxStalls * volumePerStrand;
% % %         cystDiameter = 2*(cystVol*(0.75/pi))^0.333;
% % %         figure(80);plot(thisRatio,cystDiameter,'m.');hold on
% % %         allCystDiameter(firstTipIter,curveIter) = cystDiameter;
% % % %         pause
% % %         
% % %     end
% % % end
% % % figure(79);hold off
% % %     
% % % 
% % % for stallRatioIter = 1:numStallRatio,
% % %     cystDiameterList = allCystDiameter(:,stallRatioIter);
% % %     nonZeroList = cystDiameterList(cystDiameterList~=0);
% % %     medianCystDiameter(stallRatioIter) = median(nonZeroList);
% % % end
% % % medianCystDiameter(isnan(medianCystDiameter)) = 0;
% % % figure(80);plot(stallRatioList,medianCystDiameter,'r-');
% % % figure(80);hold off
% % % 
