

%Stage 1: Load a -flow-vectorProject
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;

% % % % si = vertices.StrandIndices;
% % % % allVerts = vertices.AllVerts;
% % % % avi = allVerts(:,1)*10000+allVerts(:,2)*100+allVerts(:,3)
% % % % currentRatioList(si(find(avi==713050)))



flowAnalysisParameters = [];
cleanupFlag = 1;
%%
%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);
disp('UnPerturbed Flow Calculation completed');


%%
%%Stage 3: Select a vessel segment to occlude
tipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
numTips = numel(tipList);
rand('seed',sum(clock));
myChoice = ceil(rand(1)*numTips)



% myChoice = 8;%DB Strand 354
% % myChoice = 9;%DB Strand 358
% % myChoice = 10;%DB Strand 855
myChoice = 6;%AU Strand 341
myChoice = 7;%AU Strand 453
myChoice = 8;%AU Strand 526
myChoice = 9;%AU Strand

myChoice = [1,3]

occlusionStrandID = tipList(myChoice)
origRadius = vectorProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID)

%Stage 4: Calculate the perturbed flow surface vessel endpoints are held at fixed
%           voltages (100 and 50) using effect Strand Radii & true lengths

perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList(occlusionStrandID) = 0;


perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
disp('Perturbed Flow Calculation completed');





%%
%Stage 6: compare the two results
origCurrentList = [unperturbedProject.vectorizedStructure.Strands(:).strandCurrent];
perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
currentRatioList = abs(perturbedCurrentList./origCurrentList);
f1 = figure;
set(f1,'DoubleBuffer','on');
clf


y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

% zo = 700; dz = 100; z1 = zo-dz;z2 = zo+dz;

%Plot decreased flow as as shades of blue
ratioList = [0.9 0.7 0.5 0.2 0.1];
colorMultiplier = 2;
for ratioIter = 1:numel(ratioList),
    thisRatio = ratioList(ratioIter);
    thisColor = [thisRatio*colorMultiplier, thisRatio*colorMultiplier, 1];
    thisColor = min(1,thisColor);
    activeStrands = find(currentRatioList<thisRatio);
    activeIndices = [strands(activeStrands).StartToEndIndices];
    av = vertices.AllVerts;
    activeCoords = [vertices.AllVerts(activeIndices,:)];
    av = av(activeIndices,:);
    activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
    p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'bo');
    set(p1,'MarkerSize',1,'Color',thisColor);
    hold on
end

%Plot increased flow as as shades of red
ratioList = [1.1 1.2 1.3 1.4];
colorMultiplier = 0.5;
maxRatio = ratioList(end);
ratioRange = ratioList(end)-ratioList(1);
for ratioIter = 1:numel(ratioList),
    thisRatio = ratioList(ratioIter);
    thisColor = [1, (maxRatio-thisRatio)/ratioRange, (maxRatio-thisRatio)/ratioRange];
    thisColor = min(1,thisColor);
    activeStrands = find(currentRatioList>thisRatio);
    activeIndices = [strands(activeStrands).StartToEndIndices];
    av = vertices.AllVerts;
    activeCoords = [vertices.AllVerts(activeIndices,:)];
    av = av(activeIndices,:);
    activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
    p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'ro');
    set(p1,'MarkerSize',1,'Color',thisColor);
    hold on
end


occulsionIndices = [strands(occlusionStrandID).StartToEndIndices];
occulsionCoords = [vertices.AllVerts(occulsionIndices,:)];
av = vertices.AllVerts;
av = av(occulsionIndices,:);
occulsionCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
p1 = plot3(occulsionCoords(:,1),occulsionCoords(:,2),-1*occulsionCoords(:,3),'g.');
set(p1,'MarkerSize',2);
hold off


%%

%%Stage 7: Occlude stalled vessels
numRepeats = 1;

for repeatIter = 1:numRepeats,
    disp(['REPEAT # ',num2str(repeatIter)]);
    origCurrentList = [unperturbedProject.vectorizedStructure.Strands(:).strandCurrent];
    perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
    currentRatioList = abs(perturbedCurrentList./origCurrentList);

    stallRatio = 0.1;
    stalledVesselList = find(currentRatioList<stallRatio);


    %Stage 4: Calculate the perturbed flow surface vessel endpoints are held at fixed
    %           voltages (100 and 50) using effect Strand Radii & true lengths


    perturbedProject.maskSize = vectorProject.vectorizedStructure.maskSize;
    perturbedProject.Strands = vectorProject.vectorizedStructure.Strands;
    perturbedProject.Vertices = vectorProject.vectorizedStructure.Vertices;
    perturbedProject.baseStrandIDList = vectorProject.vectorizedStructure.plungingArterioleTipList;
    perturbedProject.maxBranchSearch = 2;
    perturbedProject.stopVoltage = 50.1;%Hardcode;
    perturbedProject.minimumFluxFraction = 1/(2^18);%Hardcode
    perturbedProject.vectorizedStructure.effectiveStrandRadiusList(stalledVesselList) = 0;


    perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
    disp('Perturbed Flow Calculation completed');

end

%Stage 7b: compare the two results
origCurrentList = [unperturbedProject.vectorizedStructure.Strands(:).strandCurrent];
perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
currentRatioList = abs(perturbedCurrentList./origCurrentList);
f1 = figure(1);
set(f1,'DoubleBuffer','on');
clf


y1 = 0; y2 = inf;
x1 = 0; x2 = inf;
z1 = 0; z2 = inf;

% zo = 700; dz = 100; z1 = zo-dz;z2 = zo+dz;

av = vertices.AllVerts;
figure(1);p1 = plot3(av(:,1),av(:,2),-1*av(:,3),'yo');hold on
set(p1,'MarkerSize',3)

%Plot decreased flow as as shades of blue
blueRatioList = [0.99 : -0.1 : 0.1];
minRatio = blueRatioList(end);
ratioRange = blueRatioList(1)-blueRatioList(end)+blueRatioList(end-1)-blueRatioList(end);
for blueColorRatioIter = 1:numel(blueRatioList),
    thisRatio = blueRatioList(blueColorRatioIter);
    thisColor = [(thisRatio-minRatio)/ratioRange, (thisRatio-minRatio)/ratioRange, 1];
    thisColor = min(1,thisColor);
    activeStrands = find(currentRatioList<thisRatio);
    activeIndices = [strands(activeStrands).StartToEndIndices];
    av = vertices.AllVerts;
    activeCoords = [vertices.AllVerts(activeIndices,:)];
    av = av(activeIndices,:);
    activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
    p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'bo');
    set(p1,'MarkerSize',3,'Color',thisColor);
    hold on
end

%Plot increased flow as as shades of red
redRatioList = [1.01: 0.01 : 1.2];
maxRatio = redRatioList(end);
ratioRange = redRatioList(end)-redRatioList(1)+redRatioList(2)-redRatioList(1);
for redColorRatioIter = 1:numel(redRatioList),
    thisRatio = redRatioList(redColorRatioIter);
    thisColor = [1, (maxRatio-thisRatio)/ratioRange, (maxRatio-thisRatio)/ratioRange];
    thisColor = min(1,thisColor);
    activeStrands = find(currentRatioList>thisRatio);
    activeIndices = [strands(activeStrands).StartToEndIndices];
    av = vertices.AllVerts;
    activeCoords = [vertices.AllVerts(activeIndices,:)];
    av = av(activeIndices,:);
    activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
    p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'ro');
    set(p1,'MarkerSize',3,'Color',thisColor);
    hold on
end


occulsionIndices = [strands(occlusionStrandID).StartToEndIndices];
occulsionCoords = [vertices.AllVerts(occulsionIndices,:)];
av = vertices.AllVerts;
av = av(occulsionIndices,:);
occulsionCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
p1 = plot3(occulsionCoords(:,1),occulsionCoords(:,2),-1*occulsionCoords(:,3),'go');
set(p1,'MarkerSize',6);
hold off


