
vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);

figure(1);hold off
figure(4);hold off
figure(3);hold off
fallOffList = [];
for strandIter = 6000:1:9000%numStrands%9000%numStrands
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    if thisStrand.strandCurrent <0,
        nextStrandList = thisStrand.StartVertexNeighborStrands;
    else
        nextStrandList = thisStrand.EndVertexNeighborStrands;
    end%if...
    
    allStrandList = [thisStrandID,nextStrandList];
    edgeStrandList = nextStrandList;
    for iterationCounter = 1:20,
        neighborStrands = [];
% % %         for quickIter = 1:numel(edgeStrandList),
% % %             quickStrandID = edgeStrandList(quickIter);
% % %             quickNeighbors = [[strands(quickStrandID).StartVertexNeighborStrands], [strands(quickStrandID).EndVertexNeighborStrands]];
% % %             quickTrueNeighbors = quickNeighbors(quickNeighbors~=quickStrandID);
% % %             neighborStrands = [neighborStrands,quickTrueNeighbors];
% % %         end%for quickIter...
% % % % %         h = hist(neighborStrands,[1:numStrands]);
% % % % %         f = find(h>1)
        
        neighborStrands = [[strands(edgeStrandList).StartVertexNeighborStrands], [strands(edgeStrandList).EndVertexNeighborStrands]];
        uniqueNeighborStrands = unique(neighborStrands);
        edgeStrandList = uniqueNeighborStrands(~ismember(uniqueNeighborStrands,allStrandList));
        allStrandList = unique([allStrandList,uniqueNeighborStrands]);
        allStrandHistory{iterationCounter} = allStrandList;
        numNodes = numel(allStrandList);
        numEdgeStrands = numel(edgeStrandList);
        edgeRatio(iterationCounter) = numEdgeStrands ./ (2^(iterationCounter+1));
        if numEdgeStrands == 0,
            edgeRatio(iterationCounter) = 3;
        end
        % disp([iterationCounter,numNodes,numEdgeStrands]);
    end
    edgeRatio(iterationCounter) = 0;
    xList = linspace(1,20,20)+rand(1,20)-0.5;
    figure(1);plot(xList,edgeRatio,'g.');hold on;hold off
    q = find(edgeRatio<0.37);
    fallOffList(strandIter) = q(1);
    pause(0.01);
    
    if edgeRatio(6)<0.6,
        showStrands = allStrandHistory{2};
        %---
        activeStrandIndices = [thisStrand.StartToEndIndices];
        activeCoords = [vertices.AllVerts(activeStrandIndices,:)];
        figure(4);p4 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'g.');hold on
        %---
        activeStrands = showStrands;
        activeIndices = [strands(activeStrands).StartToEndIndices];
        activeFlags = false(numVerts,1);
        activeFlags(activeIndices) = 1;
        activeCoords = [vertices.AllVerts(activeFlags,:)];
        figure(2);p2 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
        %---
        figure(3);p2 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
        hold on; plot3(0,0,0,'w.');
        plot3(maskSize(1),maskSize(2),-1*maskSize(3),'w.');hold off;hold on;
        if exist('myCamva2')
            camva(myCamva2);camup(myCamup2);campos(myCampos2);camtarget(myCamtarget2);
        else
            myCamva2 = camva; myCamup2 = camup; myCampos2 = campos; myCamtarget2 = camtarget;
        end
        pause(0.1);pause(1)
        myCamva2 = camva; myCamup2 = camup; myCampos2 = campos; myCamtarget2 = camtarget;
    end%if edgeRatio...
    
end%for strandIter...

%%
 %Display Results
y1 = 0; y2 = inf; x1 = 0; x2 = inf; z1 = 0; z2 = inf;
zo = 450; dz = 150; z1 = zo-dz;z2 = zo+dz;

av = vertices.AllVerts;
numVerts = size(av,1);
subAVFlags = and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2));

for fallOffValue = 1:6,
    thisColor = [1 (fallOffValue-1)/8 (fallOffValue-1)/8];
    activeStrands1 = find(fallOffList==fallOffValue);
    activeIndices1 = [strands(activeStrands1).StartToEndIndices];
    activeFlags1 = zeros(numVerts,1);
    activeFlags1(activeIndices1) = 1;
    activeCoords1 = [vertices.AllVerts(and(activeFlags1,subAVFlags),:)];
    figure(1);p1 = plot3(activeCoords1(:,1),activeCoords1(:,2),-1*activeCoords1(:,3),'b.');
    set(p1,'MarkerSize',1,'Color',thisColor);hold on
end
hold off




