% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject004.mat')



vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
barrels = vectorProject.barrelBoundaryParameters.barrels;


%%

allBarrelMask = zeros(maskSize(1),maskSize(2));
barrelDensity = [];
numBarrels = numel(barrels);
minZ1 = inf;
maxZ2 = 0;

for barrelChoice = 1:numBarrels,

    thisBarrel = barrels{barrelChoice};
    flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
    % flatBarrel = thisBarrel(thisBarrel(:,3)==median(thisBarrel(:,3)),:);
    barrelMask = zeros(maskSize(1),maskSize(2));
    flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
    barrelMask(flatBarrelInd) = 1;
    figure(1);imagesc(barrelMask);colormap(gray)
    barrelMask = imclose(barrelMask,circle2d(7));
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelMask = imfill(barrelMask,'holes');
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelCOM = mean(flatBarrel)
    onPixels = find(barrelMask);
    barrelZ1 = min(thisBarrel(:,3));
    barrelZ2 = max(thisBarrel(:,3));
    augVerts = [allVerts,[1:size(allVerts,1)]'];
    subVerts = augVerts(and(allVerts(:,3)>barrelZ1,allVerts(:,3)<=barrelZ2),:);
    subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
    insideBarrelFlagList = ismember(subVertFlatInd,onPixels);
    insideBarrelVerts = subVerts(insideBarrelFlagList,4);
    insideBarrelStrands = unique(strandIndices(insideBarrelVerts,1));
    
    allBarrelMask = max(allBarrelMask,barrelMask);
    numVertsInside = numel(insideBarrelVerts);
    numPointsInside = sum(barrelMask(:)) * (barrelZ2-barrelZ1);
    barrelVesselDensity(barrelChoice) = numVertsInside/numPointsInside;
    minZ1 = min(barrelZ1,minZ1);
    maxZ2 = max(barrelZ1,minZ1);
    
end%for barrelChoice...
%%
figure(1);imagesc(allBarrelMask)
dialtedAllBarrelMask = allBarrelMask;
for dilateIter = 1:60,
    dialtedAllBarrelMask = imdilate(dialtedAllBarrelMask,circle2d(3));
end
dialtedAllBarrelMask =imfill(dialtedAllBarrelMask,'holes');
figure(1);imagesc(dialtedAllBarrelMask)

%%
    onPixels = find(dialtedAllBarrelMask);
    augVerts = [allVerts,[1:size(allVerts,1)]'];
    subVerts = augVerts(and(allVerts(:,3)>minZ1,allVerts(:,3)<=maxZ2),:);
    subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
    insideFieldFlagList = ismember(subVertFlatInd,onPixels);
    insideFieldVerts = subVerts(insideFieldFlagList,4);
    numVertsInside = numel(insideFieldVerts);
    numPointsInside = sum(dialtedAllBarrelMask(:)) * (maxZ2-minZ1);
    fieldVesselDensity = numVertsInside/numPointsInside
   
%%
%%
%%
insideVesselDensity = [];
outsideVesselDensity = [];
numBarrels = numel(barrels);
minZ1 = inf;
maxZ2 = 0;
edgeBuffer = 100;
figure(2);hold off

     
insideDensityMatrix = zeros(numBarrels,100)-1;
outsideDensityMatrix = zeros(numBarrels,100)-1;
for barrelChoice = 1:numBarrels,

% barrelChoice = 2;
    
    thisBarrel = barrels{barrelChoice};
    flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
    % flatBarrel = thisBarrel(thisBarrel(:,3)==median(thisBarrel(:,3)),:);
    barrelMask = zeros(maskSize(1),maskSize(2));
    flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
    barrelMask(flatBarrelInd) = 1;
    figure(1);imagesc(barrelMask);colormap(gray)
    barrelMask = imclose(barrelMask,circle2d(7));
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelMask = imfill(barrelMask,'holes');
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelCOM = mean(flatBarrel)
    %---
    
    barrelZ1 = min(thisBarrel(:,3));
    barrelZ2 = max(thisBarrel(:,3));
    augVerts = [allVerts,[1:size(allVerts,1)]'];
    subVerts = augVerts(and(allVerts(:,3)>barrelZ1,allVerts(:,3)<=barrelZ2),:);
   
    
    keepErodingFlag = 1;
    currentMask = barrelMask;
    erodeCounter = 0;
    insideVesselDensity = [];
    while keepErodingFlag == 1,
        erodeMask = imerode(currentMask,circle2d(3));
        erodeCounter = erodeCounter + 1;
        diffMask = currentMask-erodeMask;
        sum(diffMask(:))
        while sum(diffMask(:))<500, 
            erodeMask = imerode(erodeMask,circle2d(3));
            diffMask = currentMask-erodeMask;
            'go again'
            disp(sum(diffMask(:)));
         end%while sum(diffMask)<500
        figure(1);imagesc(currentMask);pause(0.01)
        currentMask = erodeMask;
        if sum(currentMask(:))<500, keepErodingFlag = 0; end
        
        diffMask(1:edgeBuffer,:) = 0;
        diffMask(end-edgeBuffer:end) = 0;
        diffMask(:,1:edgeBuffer) = 0;
        diffMask(:,end-edgeBuffer:end) = 0;
      
        onPixels = find(diffMask);

        subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
        insideBarrelFlagList = ismember(subVertFlatInd,onPixels);
        insideBarrelVerts = subVerts(insideBarrelFlagList,4);
        numVertsInside = numel(insideBarrelVerts);
        numPointsInside = sum(diffMask(:)) * (barrelZ2-barrelZ1);
        insideVesselDensity(erodeCounter) = numVertsInside/numPointsInside;
        figure(2);plot(-1*erodeCounter,insideVesselDensity(erodeCounter),'r.');hold on
       
    end%while keepErodingFlag,
    
    
    keepDilatingFlag = 1;
    currentMask = barrelMask;
    dilateOtherBarrelMask = allBarrelMask - barrelMask;
    dilateCounter = 0;
    outsideVesselDensity = [];
    while keepDilatingFlag == 1,
        dilateMask = imdilate(currentMask,circle2d(3));
        dilateOtherBarrelMask = imdilate(dilateOtherBarrelMask,circle2d(3));
        dilateCounter = dilateCounter + 1;
        diffMask = dilateMask-currentMask;
        diffMask(dilateOtherBarrelMask>0) = 0;
        sum(diffMask(:))
% %         while sum(diffMask(:))<500, 
% %             dilateMask = imdilate(dilateMask,circle2d(3));
% %             dilateOtherBarrelMask = imdilate(dilateOtherBarrelMask,circle2d(3));
% %             diffMask = dilateMask-currentMask;
% %             diffMask(dilateOtherBarrelMask>0) = 0;
% %             'go again'
% %             disp(sum(diffMask(:))); 
% %             if sum(diffMask(:))<100
% %         end%while sum(diffMask)<500
        
        diffMask(1:edgeBuffer,:) = 0;
        diffMask(end-edgeBuffer:end,:) = 0;
        diffMask(:,1:edgeBuffer) = 0;
        diffMask(:,end-edgeBuffer:end) = 0;

        figure(1);imagesc(currentMask);pause(0.01)
        figure(11);imagesc(diffMask);pause(0.01);
        currentMask = dilateMask;
        if sum(diffMask(:))>2000 || sum(diffMask(:))<500 || dilateCounter > 50, keepDilatingFlag = 0; end
        
        onPixels = find(diffMask);
        subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
        outsideBarrelFlagList = ismember(subVertFlatInd,onPixels);
        outsideBarrelVerts = subVerts(outsideBarrelFlagList,4);
        numVertsInside = numel(outsideBarrelVerts);
        numPointsInside = sum(diffMask(:)) * (barrelZ2-barrelZ1);
        outsideVesselDensity(dilateCounter) = numVertsInside/numPointsInside;
        figure(2);plot(dilateCounter,outsideVesselDensity(dilateCounter),'b.');hold on
       
    end%while keepDilatingFlag,
    
    if isempty(outsideVesselDensity), outsideVesselDensity = -1; dilateCounter = 1; end;
    if isempty(insideVesselDensity), insideVesselDensity = -1; erodeCounter = 1; end;
    
    insideDensityMatrix(barrelChoice,1:erodeCounter) = insideVesselDensity;
    outsideDensityMatrix(barrelChoice,1:dilateCounter) = outsideVesselDensity;
    for kk = 1:100,
        tempLine = insideDensityMatrix(:,kk);
        tempLine = tempLine(tempLine>=0);
        tempInMean(kk) = mean(tempLine);
        tempLine = outsideDensityMatrix(:,kk);
        tempLine = tempLine(tempLine>=0);
        tempOutMean(kk) = mean(tempLine);
    end
    tempInMean(isnan(tempInMean)) = - 0;
    tempOutMean(isnan(tempOutMean)) = - 0;
    figure(12);plot([1:100],tempOutMean,'b-');hold on
    figure(12);plot([-1:-1:-100],tempInMean,'r-');hold off
        
end%for barrelChoice = ..
figure(2);hold off
    
filename = ['VesselBarrelDensityResults_',shortName,'.mat'];
save(filename,'insideDensityMatrix','outsideDensityMatrix');


%%    
q1 = insideDensityMatrix(:);
q1 = q1(q1~=-1);
q1 = q1(~isnan(q1))
q2 = outsideDensityMatrix(:);
q2 = q2(q2~=-1);
q2 = q2(~isnan(q2));
mean(q1)
mean(q2)
    
    
    


%%
validCounter = 0;
ratioList = [];
numBarrels = size(insideDensityMatrix,1);
for barrelIter = 1:numBarrels,
    tempInLine = insideDensityMatrix(barrelIter,:);
    tempOutLine = outsideDensityMatrix(barrelIter,:);
    tempInLine = tempInLine(tempInLine>=0);
    tempInLine = tempInLine(~isnan(tempInLine));
    tempOutLine = tempOutLine(tempOutLine>=0);
    tempOutLine = tempOutLine(~isnan(tempOutLine));
    if numel(tempOutLine)>3 && numel(tempInLine)>3,
        validCounter = validCounter + 1;
        ratioList(validCounter) = mean(tempInLine) ./ mean(tempOutLine);
    end%if..
end%for barrelIter...
numGreater = numel(find(ratioList>1));
numLess = numel(find(ratioList<=1));
disp([numGreater,numLess])



    
    
    

