% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject004.mat')

for setIter = 1:4,
%     
switch setIter
    case 1
        vectorProject = allProject.au;

    case 2
        vectorProject = allProject.av;

    case 3
        vectorProject = allProject.co;

    case 4
        vectorProject = allProject.db;
end%switch

        



vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
barrels = vectorProject.barrelBoundaryParameters.barrels;
allRadii = vertices.AllRadii;
allRadii = allRadii(~isnan(allRadii));
allVerts = allVerts(~isnan(allRadii),:);
sortRadii = sort(allRadii,'ascend');
threshRadius = sortRadii(ceil(numel(allRadii)*0.75));

threshRadius = 0;


%%

allBarrelMask = false(maskSize(1),maskSize(2));
barrelDensity = [];

numBarrels = numel(barrels);
minZ1 = inf;
maxZ2 = 0;

for barrelChoice = 1:numBarrels,

    thisBarrel = barrels{barrelChoice};
% %     flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
% %     % flatBarrel = thisBarrel(thisBarrel(:,3)==median(thisBarrel(:,3)),:);
% %     barrelMask = zeros(maskSize(1),maskSize(2));
% %     flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
% %     barrelMask(flatBarrelInd) = 1;
% %     figure(1);imagesc(barrelMask);colormap(gray)
% %     barrelMask = imclose(barrelMask,circle2d(7));
% %     figure(1);imagesc(barrelMask);colormap(gray);
% %     barrelMask = imfill(barrelMask,'holes');
% %     figure(1);imagesc(barrelMask);colormap(gray);
% %     barrelCOM = mean(flatBarrel);
% %     onPixels = find(barrelMask);
    barrelZ1 = min(thisBarrel(:,3));
    barrelZ2 = max(thisBarrel(:,3));
    minZ1 = min(barrelZ1,minZ1);
    maxZ2 = max(barrelZ2,maxZ2);
    
end%for barrelChoice...


%%
%Make a 3D mask
allBarrelMask = false(maskSize(1),maskSize(2));
numZ = maxZ2-minZ1+1;
fullMask = false([size(allBarrelMask),numZ]);
for barrelChoice = 1:numBarrels,
    thisBarrel = barrels{barrelChoice};
    flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
    barrelMask = false(maskSize(1),maskSize(2));
    flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
    barrelMask(flatBarrelInd) = 1;
    figure(1);imagesc(barrelMask);colormap(gray)
    barrelMask = imclose(barrelMask,circle2d(7));
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelMask = imfill(barrelMask,'holes');
    figure(1);imagesc(barrelMask);colormap(gray);
%     onPixels = find(barrelMask);
    barrelZ1 = min(thisBarrel(:,3));
    barrelZ2 = max(thisBarrel(:,3));
    
    augVerts = [allVerts,[1:size(allVerts,1)]',allRadii];
    subVerts = augVerts(and(allVerts(:,3)>barrelZ1,allVerts(:,3)<=barrelZ2),:);
    subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
    insideBarrelFlagList = ismember(subVertFlatInd,onPixels);
%     insideBarrelVerts = subVerts(insideBarrelFlagList,4);
%     insideBarrelStrands = unique(strandIndices(insideBarrelVerts,1));
%     
    allBarrelMask = max(allBarrelMask,barrelMask);
%     numVertsInside = numel(insideBarrelVerts);
%     numPointsInside = sum(barrelMask(:)) * (barrelZ2-barrelZ1);
%     barrelVesselDensity(barrelChoice) = numVertsInside/numPointsInside;
  
    
    for zIter = barrelZ1:barrelZ2,
        currentZ = zIter;
        adjZ = currentZ-minZ1+1;
        fullMask(:,:,adjZ) = max(fullMask(:,:,adjZ),barrelMask);
    end%for zIter..
end%for barrelChoice...
    
% % %         augVerts = [allVerts,[1:size(allVerts,1)]'];
% % %         subVerts = augVerts(and(allVerts(:,3)>barrelZ1,allVerts(:,3)<=barrelZ2),:);
% % %         subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
% % %         insideBarrelFlagList = ismember(subVertFlatInd,onPixels);
% % %         insideBarrelVerts = subVerts(insideBarrelFlagList,4);
% % %         insideBarrelStrands = unique(strandIndices(insideBarrelVerts,1));
    
        

%%
insideVesselDensity = [];
outsideVesselDensity = [];
numBarrels = numel(barrels);
insideWeightList = []
outsideWeightList = [];
outsideRadiusList = [];
insideRadiusList = [];
edgeBuffer = 100;
figure(2);hold off
figure(3);hold off

     
insideDensityMatrix = zeros(numBarrels,100)-1;
outsideDensityMatrix = zeros(numBarrels,100)-1;




    
% % %     thisBarrel = allBarrelMask;
% % %     flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
% % %     % flatBarrel = thisBarrel(thisBarrel(:,3)==median(thisBarrel(:,3)),:);
    barrelMask = fullMask;
    pixelOffset = maskSize(1)*maskSize(2)*(minZ1-1);
    
% % %     flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
% % %     barrelMask(flatBarrelInd) = 1;
% % %     figure(1);imagesc(barrelMask);colormap(gray)
% % %     barrelMask = imclose(barrelMask,circle2d(7));
% % %     figure(1);imagesc(barrelMask);colormap(gray);
% % %     barrelMask = imfill(barrelMask,'holes');
% % %     figure(1);imagesc(barrelMask);colormap(gray);
% % %     barrelCOM = mean(flatBarrel);
    %---
    
    barrelZ1 = minZ1;%min(thisBarrel(:,3));
    barrelZ2 = maxZ2;%max(thisBarrel(:,3));
    augVerts = [allVerts,[1:size(allVerts,1)]',allRadii];
    subVerts = augVerts(and(and(allVerts(:,3)>=minZ1,allVerts(:,3)<=maxZ2),allRadii>threshRadius),:);
    subVertInd = sub2ind(maskSize,subVerts(:,1),subVerts(:,2),subVerts(:,3));
   
    
    keepErodingFlag = 1;
    currentMask = barrelMask;
    erodeCounter = 0;
    insideVesselDensity = [];
    insideRadiusList = [];
    while keepErodingFlag == 1,
tic  
        erodeMask = currentMask;
        for zIter = 1:numZ;
            thisFrame = currentMask(:,:,zIter);
            if zIter > 1,
                if sum(thisFrame(:)~=previousFrame(:)) == 0,
                    erodeMask(:,:,zIter) = erodeMask(:,:,zIter-1);
                else
                    erodeFrame = imerode(thisFrame,circle2d(3));
                    erodeMask(:,:,zIter) = erodeFrame;
                end%if-else sum(thisFrame....
            else%if zIter>1,
                erodeFrame = imerode(thisFrame,circle2d(3));
                erodeMask(:,:,zIter) = erodeFrame;
            end%if-else zIter>1,
            previousFrame = thisFrame;
        end
        erodeCounter = erodeCounter + 1;
      
%         diffMask = currentMask-erodeMask;
        diffMask = xor(currentMask,erodeMask);

        sum(diffMask(:))

        while sum(diffMask(:))<500, 
            for zIter = 1:numZ;
                thisFrame = currentMask(:,:,zIter);
                erodeFrame = imerode(thisFrame,circle2d(3));
                erodeMask(:,:,zIter) = erodeFrame;
            end
            diffMask = currentMask-erodeMask;
            'go again'
            disp(sum(diffMask(:)));
        end%while sum(diffMask)<500
        
        figure(1);imagesc(currentMask(:,:,ceil(numZ/2)));pause(0.01)
        currentMask = erodeMask;
        if sum(currentMask(:))<500, keepErodingFlag = 0; end
        
        
        diffMask(1:edgeBuffer,:,:) = 0;
        diffMask(end-edgeBuffer:end,:) = 0;
        diffMask(:,1:edgeBuffer,:) = 0;
        diffMask(:,end-edgeBuffer:end,:) = 0;

        onPixels = find(diffMask);
        onPixelsAdj = onPixels + pixelOffset;
        insideBarrelFlagList = ismember(subVertInd,onPixelsAdj);
        insideBarrelVerts = subVerts(insideBarrelFlagList,4);
        insideBarrelRadii = vertices.AllRadii(insideBarrelVerts);
        numVertsInside = numel(insideBarrelVerts);
        numPointsInside = sum(diffMask(:))
        insideVesselDensity(erodeCounter) = numVertsInside/numPointsInside;
        figure(2);plot(-1*erodeCounter,insideVesselDensity(erodeCounter),'r.');hold on
        insideWeightList(erodeCounter) = numPointsInside;
        insideRadiusList(erodeCounter) = mean(insideBarrelRadii);
        figure(3);plot(-1*erodeCounter,insideRadiusList(erodeCounter),'ro');hold on
        

        toc
    end%while keepErodingFlag,
    
%%
    
    keepDilatingFlag = 1;
    currentMask = fullMask;
    dilateCounter = 0;
    outsideVesselDensity = [];
    outsideWeightList = [];
    outsideRadiusList = [];
    
    while keepDilatingFlag == 1,
        
        dilateMask = currentMask;
        tic
        for zIter = 1:numZ;
            thisFrame = currentMask(:,:,zIter);
            if zIter>1,
                if sum(thisFrame(:)~=previousFrame(:)) == 0,
                    dilateMask(:,:,zIter) = dilateMask(:,:,zIter-1);
                else%if sum...
                    dilateFrame = imdilate(thisFrame,circle2d(3));
                    dilateMask(:,:,zIter) = dilateFrame;
                end%if-else sum...
            else%if zIter>1
            dilateFrame = imdilate(thisFrame,circle2d(3));
            dilateMask(:,:,zIter) = dilateFrame;
            end%if-else zIter>1
            previousFrame = thisFrame;
        end
        dilateOtherBarrelMaskFlat = max(currentMask,[],3);
        dilateOtherBarrelMask = repmat(dilateOtherBarrelMaskFlat,[1,1,numZ]);
        dilateCounter = dilateCounter + 1;
        diffMask = xor(dilateMask,dilateOtherBarrelMask);
        diffMask(dilateOtherBarrelMask>0) = 0;
        sum(diffMask(:))
 
        
        diffMask(1:edgeBuffer,:,:) = 0;
        diffMask(end-edgeBuffer:end,:,:) = 0;
        diffMask(:,1:edgeBuffer,:) = 0;
        diffMask(:,end-edgeBuffer:end,:) = 0;

        figure(1);imagesc(currentMask(:,:,ceil(numZ/2)));pause(0.01)
        figure(11);imagesc(diffMask(:,:,ceil(numZ/2)));pause(0.01)
        currentMask = dilateMask;
        if sum(diffMask(:))<500 || dilateCounter >= 60, keepDilatingFlag = 0; end
        
        onPixels = find(diffMask);
        onPixelsAdj = onPixels + pixelOffset;
        insideBarrelFlagList = ismember(subVertInd,onPixelsAdj);
        insideBarrelVerts = subVerts(insideBarrelFlagList,4);
        insideBarrelRadii = vertices.AllRadii(insideBarrelVerts);
        numVertsInside = numel(insideBarrelVerts);
        numPointsInside = sum(diffMask(:))
        outsideVesselDensity(dilateCounter) = numVertsInside/numPointsInside;
        figure(2);plot(dilateCounter,outsideVesselDensity(dilateCounter),'b.');hold on
        outsideWeightList(dilateCounter) = numPointsInside;
        outsideRadiusList(dilateCounter) = mean(insideBarrelRadii);
        figure(3);plot(dilateCounter,outsideRadiusList(dilateCounter),'bo');hold on
        toc
    end%while keepDilatingFlag,
% %     


%%

filename = ['VesselBarrelDensityAllAtOnceResults_',shortName,'.mat'];
save(filename,'insideVesselDensity','outsideVesselDensity','insideWeightList','outsideWeightList','insideRadiusList','outsideRadiusList');

insideWeightedDensity = sum(insideVesselDensity.*insideWeightList)./sum(insideWeightList)
outsideWeightedDensity = sum(outsideVesselDensity.*outsideWeightList)./sum(outsideWeightList)

outsideWeightedDensitySub = sum(outsideVesselDensity(1:50).*outsideWeightList(1:50))./sum(outsideWeightList(1:50))



end %for setIter
