
% load ('Results-VesselBarrelDistribByMeanBloodOx.mat','bloodOxList');
% meanBloodOx = bloodOxList;

vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numVerts = numel(vertices.AllRadii);
numStrands = numel(strands);
allVerts = vertices.AllVerts;
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
strandIndices = vertices.StrandIndices;


arterioleMeanBloodOx = mean(meanBloodOx(allPlungingArterioleList));
venuleMeanBloodOx = mean(meanBloodOx(allPlungingVenuleList));

vertNormMeanBloodOxList = zeros(size(vertices.AllRadii));
normMeanBloodOxList = (meanBloodOx-venuleMeanBloodOx)./(arterioleMeanBloodOx-venuleMeanBloodOx);
for vertIter = 1:numVerts,
    vertNormMeanBloodOxList(vertIter) = normMeanBloodOxList(strandIndices(vertIter,1));
end
save Results-NormMeanBloodOx meanBloodOx normMeanBloodOxList vertNormMeanBloodOxList