
%HARDCODE:
filterSize = 20;
disp(['HardCode: filterSize = ',num2str(filterSize)]);

[fileName,pathName] = uigetfile({'*.tif'},'Select a tif to normalize');
cd(pathName)
[normCurveFileName,pathName] = uigetfile({'*NormCurve.mat'},'Select a normalization file or hit [CANCEL] to self-normalize');
disp('Loading tif file...');
mypics = loadmovie(fileName);
normpics = mypics;
if normCurveFileName == 0;
    %Self-normalize
    disp('Calculating Self Normalization Curve...');
    numFrames = size(mypics,3);
    mymedian = zeros(1,numFrames);
    for frameIter = 1:numFrames,
        myFrame = mypics(:,:,frameIter);
        mymedian(frameIter) = median(myFrame(:));
    end%for frameIter...
    figure(1);plot(mymedian,'r-');hold on
    filtCurve = double(medfilt2(mymedian,[1 filterSize],'symmetric'));
    figure(1);plot(filtCurve,'g-');
    normCurve = filtCurve./max(filtCurve);
    normCurve(find(normCurve==0)) = median(normCurve(normCurve>0));
    figure(1);plot(normCurve.*max(filtCurve),'b-');hold off
    normCurveFileName = [fileName(1:end-4),'NormCurve.mat'];
    save(normCurveFileName,'normCurve');
else%if normCurveFileName == 0;
    disp('Loading External Normalization Curve...');
    load(normCurveFileName,'normCurve');
end%if-else normCurveFileName == 0;
%-----
disp('Normalizing...');
for frameIter = 1:numFrames,
    myFrame = mypics(:,:,frameIter);
    newFrame = myFrame./normCurve(frameIter);
    normpics(:,:,frameIter) = newFrame;
end%for frameIter
%-----
disp('Saving Normalized Tif file...');
normTifFileName =  [fileName(1:end-4),'Norm.tif'];
maketiff(normpics,normTifFileName);
disp('Done.');

