%Find and correct junctions between surface veins and surface arteries
%This fix will be undone if there is a downstream re-vectorization

vectorizedStructure = vectorProject.vectorizedStructure;
vertices = vectorizedStructure.Vertices;
strands = vectorizedStructure.Strands;
allVerts = vertices.AllVerts;
numStrands = numel(strands);
allLabels = vertices.AllLabels;
strandIndices = vertices.StrandIndices;

medianLabelList = zeros(numStrands,1);
for strandIter = 1:numStrands;
    thisStrandID = strandIter;
    thisStrand = strands(thisStrandID);
    stei = thisStrand.StartToEndIndices;
    labelList = allLabels(stei);
    medianLabelList(strandIter) = median(labelList);
end

surfaceArteryList = find(ismember(medianLabelList,[330:339]));
surfaceVeinList = find(ismember(medianLabelList,[340:349]));

badConnectPointList = [];
for arteryIter = 1:numel(surfaceArteryList);
    thisArteryID = surfaceArteryList(arteryIter);
    thisArtery = strands(thisArteryID);
    endVertexNeighbors = thisArtery.EndVertexNeighborStrands;
    endVertexNeighborLabels = medianLabelList(endVertexNeighbors);
    startVertexNeighbors = thisArtery.StartVertexNeighborStrands;
    startVertexNeighborLabels = medianLabelList(startVertexNeighbors);
    badConnect = find(ismember(endVertexNeighborLabels,[340:349]));
    if ~isempty(badConnect),
        badConnectPointList = [badConnectPointList;thisArtery.EndVertexIndex];
    end%if ~isempty(badConnect);
    badConnect = find(ismember(startVertexNeighborLabels,[340:349]));
    if ~isempty(badConnect),
        badConnectPointList = [badConnectPointList;thisArtery.StartVertexIndex];
    end%if ~isempty(badConnect);
end
badConnectPointList = unique(badConnectPointList);
badCoords = allVerts(badConnectPointList,:)

%%

numBadCoords = numel(badConnectPointList)
for badIter = 1:numBadCoords,
    disp(badIter);
    thisVertexID = badConnectPointList(badIter);
    attachedStrandList = strandIndices(thisVertexID,:);
    attachedStrandList = attachedStrandList(attachedStrandList~=0);
    for attachedIter = 1:numel(attachedStrandList);
        thisStrandID = attachedStrandList(attachedIter);
        thisStrand = strands(thisStrandID);
        thisLabel = medianLabelList(thisStrandID);
        wrongLabelList = [];
        if ismember(thisLabel,[330:339,430:439]),
            wrongLabelList = [340:349,440:449];
        end%if ismember(thisLabel,[330:339])
        if ismember(thisLabel,[340:349,440:449]),
            wrongLabelList = [330:339,430:449];
        end%if ismember(thisLabel,[340:349])
        if isempty(wrongLabelList),
            disp('ERROR!')
            pause;pause;pause;
        end%if isempty(wrongLabelList);
        thisStartNeighborList = thisStrand.StartVertexNeighborStrands;
        thisStartNeighborLabelList = medianLabelList(thisStartNeighborList);
        wrongNeighborList = ismember(thisStartNeighborLabelList,wrongLabelList);
        reducedStartNeighborList = thisStartNeighborList(wrongNeighborList==0);
        %---
        thisEndNeighborList = thisStrand.EndVertexNeighborStrands;
        thisEndNeighborLabelList = medianLabelList(thisEndNeighborList);
        wrongNeighborList = ismember(thisEndNeighborLabelList,wrongLabelList);
        reducedEndNeighborList = thisEndNeighborList(wrongNeighborList==0);
        %---
        thisStrand.StartVertexNeighborStrands = reducedStartNeighborList;
        thisStrand.EndVertexNeighborStrands = reducedEndNeighborList;
        strands(thisStrandID) = thisStrand;
    end%for attachedIter...
end%for badIter...
vectorizedStructure.Strands = strands;
vectorProject.vectorizedStructure = vectorizedStructure;

save avRemovedVectorProject.mat vectorProject


        






