

% load('F:\Phil\AOH_VectorProjects\allProject004.mat')

%First set a fraction of the microvessels to very-large resistance.

vectorProject = allProject.au;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;

microVesselMaxRadius = 3;
removeFraction = 0.33;% 1.6 = ~50% removal; 0.2 = ~10%removal; 0.33 = ~15%removal

effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
microVesselList = find(effectiveStrandRadiusList<microVesselMaxRadius);

randomList = ceil(rand(1,ceil(removeFraction*numel(microVesselList)))*numel(microVesselList));
removalStrandList = unique(randomList);
removalRate = numel(removalStrandList)/numel(randomList)
effectiveStrandRadiusList(removalStrandList) = effectiveStrandRadiusList(removalStrandList) ./1000;

plungingStrandList = [vectorProject.vectorizedStructure.allPlungingArterioleList,vectorProject.vectorizedStructure.allPlungingVenuleList];
effectiveStrandRadiusList(plungingStrandList) = effectiveStrandRadiusList(plungingStrandList) ./1000;


perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = effectiveStrandRadiusList;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);

fileName = [shortName,'-removeFraction',num2str(removeFraction,'%0.2f'),'-VectorProject.mat'];
save(fileName,'perturbedProject');


%%
%Next, strip out the plunging vessels by setting their resistance to very-large

vectorProject = perturbedProject;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);


%%Stage 2: Run the unperturbed flow analysis:
unperturbedProject = vectorProject;
unperturbedProject.circuitAnalysisParameters.minRadius = 0;
unperturbedProject.circuitAnalysisParameters.returnBasicConductanceMatrixFlag = 1;
unperturbedProject = CalculateUnperturbedFlow003(unperturbedProject);

L = full(unperturbedProject.basicConductanceMatrix);
tic
[eigenVectors,eigenValueMatrix] = eig(L);
toc
eigenValues = zeros(length(eigenValueMatrix),1);
for kk = 1:length(eigenValueMatrix);
    eigenValues(kk) = eigenValueMatrix(kk,kk);
end%for kk;

save([shortName,'-removeFraction',num2str(removeFraction,'%0.2f'),'Eigen.mat','eigenVectors','eigenValues','-V7.3']);
datestr(now)

