%Calculate Stream Convergence (are branches diverging or converging)

%Load an FV file

yLim1 = 200;
yLim2 = 800;
xLim1 = 200;
xLim2 = 800;
zLim1 = 0;
zLim2 = 1000;


numStrands = numel(gds.Strands);
convergenceValueList = zeros(1,numStrands);
meanYXZ = zeros(numStrands,3);

for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    thisStrand = gds.Strands(thisStrandID);
    startVoltage = gds.Vertices.AllVoltages(thisStrand.StartVertexIndex);
    endVoltage = gds.Vertices.AllVoltages(thisStrand.EndVertexIndex);
    if startVoltage > endVoltage,
        lowerVoltage = endVoltage;
        lowerNeighbors = thisStrand.EndVertexNeighborStrands;
    else
        lowerVoltage = startVoltage;
        lowerNeighbors = thisStrand.StartVertexNeighborStrands;
    end

    lowerNeighbors = lowerNeighbors(lowerNeighbors~=thisStrandID);
    q(strandIter) = numel(lowerNeighbors);
    if numel(lowerNeighbors>0),
        neighborVoltages = [gds.Strands(lowerNeighbors).MedianVoltage];
        convergenceValue = sum(double(neighborVoltages<lowerVoltage)*2-1)-1;
        convergenceValue = max(-1,min(1,convergenceValue));
        convergenceValueList(thisStrandID) = convergenceValue;
        meanYXZ(thisStrandID,1) = mean(thisStrand.YXZLimits(1,:));
        meanYXZ(thisStrandID,2) = mean(thisStrand.YXZLimits(2,:));
        meanYXZ(thisStrandID,3) = mean(thisStrand.YXZLimits(3,:));
    end
    %---
    dbl = gds.downstreamBranchList(thisStrandID,:);
    branchNumber = min(min(dbl),999);
    branchNumberList(thisStrandID) = branchNumber;
end%for strandIter;

maxBranchVal = max(branchNumberList(branchNumberList<999));

fY = and(meanYXZ(:,1)>yLim1,meanYXZ(:,1)<yLim2);
fX = and(meanYXZ(:,1)>zLim1,meanYXZ(:,1)<xLim2);
fZ = and(meanYXZ(:,1)>zLim1,meanYXZ(:,1)<zLim2);
fYXZ = and(and(fY,fX),fZ);
subBranchNumberList = branchNumberList(fYXZ);
subConvergenceValueList = convergenceValueList(fYXZ);
subStrands = [gds.Strands(fYXZ)];





for branchIter = 1:maxBranchVal,
    ff1 = find(subBranchNumberList==branchIter);
    meanConvergenceList(branchIter) = mean(subConvergenceValueList(ff1));
    meanVoltageList(branchIter) = mean([subStrands(ff1).MedianVoltage]);
end

figure(1);plot(meanConvergenceList,'b-');
figure(2);plot(meanVoltageList,'r-');
figure(3);plot(subBranchNumberList+rand(size(subBranchNumberList))-0.5,[subStrands.MedianVoltage],'r.');
figure(4);plot(subBranchNumberList+rand(size(subBranchNumberList))-0.5,subConvergenceValueList+rand(size(subBranchNumberList))-0.5,'b.');

    



