


scriptVersion = 'ShowZDirectionOfFlow.m'


vectorProject = allProject.db;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
allVerts = vertices.AllVerts;

strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;

strandLabelList = [strands(:).MedianLabel];
surfList = find(and(strandLabelList>=300,strandLabelList<=399)); 
zSurf = strandMidYXZList(surfList,3);
medianZSurf = median(zSurf);
minZSurf = min(zSurf);

strandMidYXZList(:,3) = max(strandMidYXZList(:,3)-minZSurf,0);
allPlungingVenulePathList = vectorProject.vectorizedStructure.allPlungingVenulePathList;
allPlungingArteriolePathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;


flowAnalysisParameters = [];
cleanupFlag = 1;


numStrands = numel(strands);
flowZ = zeros(1,numStrands);
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    if thisStrand.StartVoltage>thisStrand.EndVoltage
        %flow is StartToEnd
        dz = allVerts(thisStrand.EndVertexIndex,3) - allVerts(thisStrand.StartVertexIndex,3);
        %dz is negative if flow is up (endZ is less positive than startZ)
    else%if thisStrand.StartVoltage>thisStrand.EndVoltage
        dz = allVerts(thisStrand.StartVertexIndex,3) - allVerts(thisStrand.EndVertexIndex,3);
    end%if-else thisStrand.StartVoltage>thisStrand.EndVoltage
    flowZ(strandIter) = dz;%negative is up
end%for strandIter
flowDirection = sign(flowZ);
upToDownRatio = sum(flowDirection<0)/sum(flowDirection>0)

y1 = 0;y2 = inf;
x1 = 0;x2 = inf;
z1 = 0;z2 = inf;

y1 = 200;y2 = maskSize(1)-y1;
x1 = 200;x2 = maskSize(2)-x1;
z1 = 000;z2 = inf;%au
z1 = 000;z2 = 1400;%av
z1 = 000;z2 = inf;%co


cc = strandMidYXZList;
f1 = and(cc(:,1)>y1,cc(:,1)<y2);
f2 = and(cc(:,2)>x1,cc(:,2)<x2);
f3 = and(cc(:,3)>z1,cc(:,3)<z2);
ff = and(and(f1,f2),f3);

subFlowDirection = flowDirection(ff);
subUpToDownRatio = sum(subFlowDirection<0)/sum(subFlowDirection>0)


%%
y1 = 0;y2 = inf;
x1 = 0;x2 = inf;
z1 = 0;z2 = inf;
y1 = 300;y2 = 400;

figure(1);clf;
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    cc = allVerts(thisStrand.StartToEndIndices,:);
    
    f1 = and(cc(:,1)>y1,cc(:,1)<y2);
    f2 = and(cc(:,2)>x1,cc(:,2)<x2);
    f3 = and(cc(:,3)>z1,cc(:,3)<z2);
    ff = and(and(f1,f2),f3);
    cc = cc(ff,:);
    p1 = plot3(cc(:,1),cc(:,2),-1*cc(:,3),'r.'); hold on;
        
    if flowDirection(strandIter)>0,
        set(p1,'Color','black');%red is down
    else%if flowDirection...
        set(p1,'Color','cyan');%blue is up
    end%if-else flowDir
    set(p1,'MarkerSize',6);
        
end%for strandIter
axis equal
    





