
%Stage 1: Load a -flow-vectorProject

flowAnalysisParameters = [];
cleanupFlag = 1;
%%
%%Stage 2: Find the offshoots of plunging arterioles


flowProject.maskSize = vectorProject.vectorizedStructure.maskSize;
flowProject.Strands = vectorProject.vectorizedStructure.Strands;
flowProject.Vertices = vectorProject.vectorizedStructure.Vertices;
flowProject.baseStrandIDList = vectorProject.vectorizedStructure.plungingArterioleTipList;
flowProject.maxBranchSearch = 2;
flowProject.stopVoltage = 50.1;%Hardcode;
flowProject.minimumFluxFraction = 1/(2^18);%Hardcode

flowProject = CalculateDownstreamPathsFromVectorProject(flowProject);


%%
%%Stage 3: Select a vessel segment to dilate
tipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
numTips = numel(tipList);
rand('seed',sum(clock));
myChoice = ceil(rand(1)*numTips);



dilationFraction = 1.2;
% myChoice = 8;%DB Strand 354
myChoice = 9;%DB Strand 358
myChoice = 10;%DB Strand 855


dilationStrandID = tipList(myChoice)
origRadius = vectorProject.vectorizedStructure.effectiveStrandRadiusList(dilationStrandID)
perturbedProject = vectorProject;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList(dilationStrandID) = origRadius * dilationFraction;


%Stage 4: Calculate the perturbed flow surface vessel endpoints are held at fixed
%           voltages (100 and 50) using effect Strand Radii & true lengths


perturbedProject = CalculateUnperturbedFlow003(perturbedProject);
disp('Flow Calculation completed');


%%
%Stage 5: compare the two results
origCurrentList = [vectorProject.vectorizedStructure.Strands(:).strandCurrent];
perturbedCurrentList = [perturbedProject.vectorizedStructure.Strands(:).strandCurrent];
currentRatioList = abs(perturbedCurrentList./origCurrentList);
f1 = figure(2);
set(f1,'DoubleBuffer','on');
clf

thresholdRatio = 1.05;



% % figure(1);p1 = plot3(av(:,1),av(:,2),-1*av(:,3),'y.');hold on
% % set(p1,'MarkerSize',1);

activeStrands = find(currentRatioList<1/thresholdRatio);
activeIndices = [flowProject.Strands(activeStrands).StartToEndIndices];
av = flowProject.Vertices.AllVerts;
activeCoords = [flowProject.Vertices.AllVerts(activeIndices,:)];
% % p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
% % set(p1,'MarkerSize',1);
hold on

activeStrands = find(currentRatioList>thresholdRatio);
activeIndices = [flowProject.Strands(activeStrands).StartToEndIndices];
av = flowProject.Vertices.AllVerts;
activeCoords = [flowProject.Vertices.AllVerts(activeIndices,:)];
p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'r.');
set(p1,'MarkerSize',1);
hold on


dilationIndices = [flowProject.Strands(dilationStrandID).StartToEndIndices];
dilationCoords = [flowProject.Vertices.AllVerts(dilationIndices,:)];
p1 = plot3(dilationCoords(:,1),dilationCoords(:,2),-1*dilationCoords(:,3),'g.');
set(p1,'MarkerSize',2);
hold off










