
% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject004.mat')


vectorProject = allProject.au;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
numTips = numel(plungingArterioleTipList);

%%
tipCoordList = zeros(numTips,3);
flatMask = false(maskSize(1),maskSize(2));
for tipIter = 1:numTips,
    thisTipID = plungingArterioleTipList(tipIter);
    thisStrand = strands(thisTipID);
    iv = thisStrand.InteriorVertices;
    if thisStrand.strandCurrent < 0,
        iv = fliplr(iv);
    end%%if thisStrand.strandCurrent < 0,
    cc = allVerts(iv,:);
    figure(1);subplot(1,2,1);p1a = plot(cc(:,1),-1*cc(:,3),'r.');axis equal
    figure(1);subplot(1,2,2);p1b = plot(cc(:,2),-1*cc(:,3),'r.');axis equal
    title(['Tip #',num2str(tipIter),',  StrandID #',num2str(thisTipID)]);
%     pause
    vertSep = 20;
    thresholdSlope  = 1;
    numVerts = numel(iv);
    if numVerts>vertSep,
        subCC2 = cc(vertSep+1:end,:);
        subCC1 = cc(1:end-vertSep,:);
        diffCC = subCC2-subCC1;
        drList = sqrt(diffCC(:,1).^2 + diffCC(:,2).^2);
        dzList = diffCC(:,3);
        subSlope = dzList./drList;
        highSlope = find(subSlope>thresholdSlope);
        if isempty(highSlope),
            highInd = numVerts;
        else%if isempty(highSlope),
            highInd = highSlope(1) + ceil(vertSep/2);
        end%if isempty(highSlope),
    else%if numVerts>vertSep,
        highInd = numVerts;
    end%if numVerts>vertSep
    tipCoord = cc(highInd,:);
    tipCoordList(tipIter,:) = tipCoord;
    figure(1);subplot(1,2,1);hold on;p1a = plot(tipCoord(:,1),-1*tipCoord(:,3),'g.');axis equal;hold off
    figure(1);subplot(1,2,2);hold on;p1b = plot(tipCoord(:,2),-1*tipCoord(:,3),'g.');axis equal;hold off
    pause(0.1);
    %---
    flatMask(tipCoord(1),tipCoord(2)) = 1;
end%for tipIter

%%
figure(2);imagesc(imdilate(flatMask,circle2d(7)));colormap(gray)

bw = bwdist(flatMask);
surfaceArteryTess = watershed(bw);
figure(3);imagesc(surfaceArteryTess);






