
% % cd('F:\Phil\AOH_VectorProjects')
% % load('F:\Phil\AOH_VectorProjects\allProject004.mat')


vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
barrels = vectorProject.barrelBoundaryParameters.barrels;
numTips = numel(plungingArterioleTipList);
numBarrels = numel(barrels);



%%

allBarrelMask = false(maskSize(1),maskSize(2));
barrelDensity = [];
numBarrels = numel(barrels);
minZ1 = inf;
maxZ2 = 0;

for barrelChoice = 1:numBarrels,

    thisBarrel = barrels{barrelChoice};
    flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
    barrelMask = zeros(maskSize(1),maskSize(2));
    flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
    barrelMask(flatBarrelInd) = 1;
    figure(1);imagesc(barrelMask);colormap(gray)
    barrelMask = imclose(barrelMask,circle2d(7));
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelMask = imfill(barrelMask,'holes');
    figure(1);imagesc(barrelMask);colormap(gray);
    barrelCOM = mean(flatBarrel);
    allBarrelMask = max(allBarrelMask,barrelMask);
%     barrelZ1 = min(thisBarrel(:,3));
%     barrelZ2 = max(thisBarrel(:,3));
%     minZ1 = min(barrelZ1,minZ1);
%     maxZ2 = max(barrelZ2,maxZ2);
    
end%for barrelChoice...

figure(1);imagesc(allBarrelMask);

%%
tipCoordList = zeros(numTips,3);
flatMask = false(maskSize(1),maskSize(2));
for tipIter = 1:numTips,
    thisTipID = plungingArterioleTipList(tipIter);
    thisStrand = strands(thisTipID);
    iv = thisStrand.InteriorVertices;
    if thisStrand.strandCurrent < 0,
        iv = fliplr(iv);
    end%%if thisStrand.strandCurrent < 0,
    cc = allVerts(iv,:);
    figure(101);subplot(1,2,1);p1a = plot(cc(:,1),-1*cc(:,3),'r.');axis equal
    figure(101);subplot(1,2,2);p1b = plot(cc(:,2),-1*cc(:,3),'r.');axis equal
    title(['Tip #',num2str(tipIter),',  StrandID #',num2str(thisTipID)]);
%     pause
    vertSep = 5;
    thresholdSlope  = 1;
    numVerts = numel(iv);
    if numVerts>vertSep,
        subCC2 = cc(vertSep+1:end,:);
        subCC1 = cc(1:end-vertSep,:);
        diffCC = subCC2-subCC1;
        drList = sqrt(diffCC(:,1).^2 + diffCC(:,2).^2);
        dzList = diffCC(:,3);
        subSlope = abs(dzList./drList);
        highSlope = find(subSlope>thresholdSlope);
        if isempty(highSlope),
            highInd = numVerts;
            disp([tipIter]);
        else%if isempty(highSlope),
            highInd = highSlope(1) + ceil(vertSep/2);
        end%if isempty(highSlope),
    else%if numVerts>vertSep,
        highInd = numVerts;
    end%if numVerts>vertSep
    tipCoord = cc(highInd,:);
    tipCoordList(tipIter,:) = tipCoord;
    figure(101);subplot(1,2,1);hold on;p1a = plot(tipCoord(:,1),-1*tipCoord(:,3),'g.');axis equal;hold off
    set(gca,'XLim',[tipCoord(:,1)-20,tipCoord(:,1)+20],'YLim',-1*[tipCoord(:,3)+100,tipCoord(:,3)-100])
    figure(101);subplot(1,2,2);hold on;p1b = plot(tipCoord(:,2),-1*tipCoord(:,3),'g.');axis equal;hold off
    set(gca,'XLim',[tipCoord(:,2)-20,tipCoord(:,2)+20],'YLim',-1*[tipCoord(:,3)+100,tipCoord(:,3)-100])
   pause(0.1);pause
    %---
    flatMask(tipCoord(1),tipCoord(2)) = 1;
end%for tipIter

%%
figure(2);imagesc(imdilate(flatMask,circle2d(7)));colormap(gray)

bw = bwdist(flatMask);
surfaceArteryTess = watershed(bw);
figure(3);imagesc(surfaceArteryTess);
%%
deepCCList = [];
medBarrelZList = [];
deepMask = false(maskSize(1),maskSize(2));
for barrelIter = 1:numBarrels;
    thisBarrel = barrels{barrelIter};
    medBarrelZList(barrelIter) = median(thisBarrel(:,3));
end
barrelLayerZ = ceil(median(medBarrelZList));
numPlungingStrands = numel(allPlungingArterioleList);
for plungingIter = 1:numPlungingStrands;
    thisStrandID = allPlungingArterioleList(plungingIter);
    thisStrand = strands(thisStrandID);
    iv = thisStrand.InteriorVertices;
    cc = allVerts(iv,:);
    fz = find(cc(:,3)==barrelLayerZ);
    if ~isempty(fz)
        deepCC = cc(fz(1),:);
        deepCCList = [deepCCList;deepCC];
        deepMask(deepCC(1),deepCC(2)) = 1;
    end%if ~isempty(fz)
end%for plungingIter...
figure(4);imagesc(imdilate(deepMask,circle2d(7)));colormap(gray);
bw = bwdist(deepMask);
deepArteryTess = watershed(bw);
figure(5);imagesc(deepArteryTess);


%%
%Make a surface tesselation that only considers those plunging vessels that reach >400 um
allPlungingArteriolePathList = gds.allPlungingArteriolePathList;
tipCoordList = [];
flatMask = false(maskSize(1),maskSize(2));
tipCounter = 0;
for tipIter = 1:numTips,
    thisTipID = plungingArterioleTipList(tipIter);
    thisPlungingStrandList = allPlungingArteriolePathList{tipIter};
    allStrandZ = allVerts([Strands(thisPlungingStrandList).StartToEndIndices],3);
    maxZ = max(allStrandZ);
    if maxZ > 500,
        tipCounter = tipCounter +1;
        thisStrand = strands(thisTipID);
        iv = thisStrand.InteriorVertices;
        if thisStrand.strandCurrent < 0,
            iv = fliplr(iv);
        end%%if thisStrand.strandCurrent < 0,
        cc = allVerts(iv,:);
        figure(101);subplot(1,2,1);p1a = plot(cc(:,1),-1*cc(:,3),'r.');axis equal
        figure(101);subplot(1,2,2);p1b = plot(cc(:,2),-1*cc(:,3),'r.');axis equal
        title(['Tip #',num2str(tipIter),',  StrandID #',num2str(thisTipID)]);
    %     pause
        vertSep = 5;
        thresholdSlope  = 1;
        numVerts = numel(iv);
        if numVerts>vertSep,
            subCC2 = cc(vertSep+1:end,:);
            subCC1 = cc(1:end-vertSep,:);
            diffCC = subCC2-subCC1;
            drList = sqrt(diffCC(:,1).^2 + diffCC(:,2).^2);
            dzList = diffCC(:,3);
            subSlope = abs(dzList./drList);
            highSlope = find(subSlope>thresholdSlope);
            if isempty(highSlope),
                highInd = numVerts;
                disp([tipIter]);
            else%if isempty(highSlope),
                highInd = highSlope(1) + ceil(vertSep/2);
            end%if isempty(highSlope),
        else%if numVerts>vertSep,
            highInd = numVerts;
        end%if numVerts>vertSep
        tipCoord = cc(highInd,:);
        tipCoordList(tipCounter,:) = tipCoord;
        figure(101);subplot(1,2,1);hold on;p1a = plot(tipCoord(:,1),-1*tipCoord(:,3),'g.');axis equal;hold off
        set(gca,'XLim',[tipCoord(:,1)-20,tipCoord(:,1)+20],'YLim',-1*[tipCoord(:,3)+100,tipCoord(:,3)-100])
        figure(101);subplot(1,2,2);hold on;p1b = plot(tipCoord(:,2),-1*tipCoord(:,3),'g.');axis equal;hold off
        set(gca,'XLim',[tipCoord(:,2)-20,tipCoord(:,2)+20],'YLim',-1*[tipCoord(:,3)+100,tipCoord(:,3)-100])
       pause(0.1);%pause
        %---
        flatMask(tipCoord(1),tipCoord(2)) = 1;
    end%if maxZ >...
end%for tipIter

bw = bwdist(flatMask);
deepArteryAtSurfaceTess = watershed(bw);
figure(17);imagesc(deepArteryAtSurfaceTess);


        








