function cutoffStrandList = TraceToCutoffRadius(vectorProject,startStrandList,cutoffRadius,cutoffVoltage);

Strands = vectorProject.vectorizedStructure.Strands;
Vertices = vectorProject.vectorizedStructure.Vertices;
StrandIndices = Vertices.StrandIndices;
AllVoltages = Vertices.AllVoltages;
AllVerts = Vertices.AllVerts;
maskSize = vectorProject.maskSize;
pathColorStorageList = zeros(size(AllVerts));
maxFlowFractionStorageList = zeros(size(Strands));
associatedStartStorageList = zeros(size(Strands));
numStrands = numel(Strands);
AllRadii = Vertices.AllRadii;

% % startStrandList = [1054 2208 96 2043 849 24 ...
% %                      3204 54 1921 2096 1569 244 1010 961 ...
% %                      946 778 1684 1694 2424 1213 3468 5330 1811 ...
% %                      2370 3730 ...
% %                      193 ...
% %                      1187 ...
% %                      4587 239];   
% %                  
% % cutoffRadius = 4;
% % cutoffVoltage = 70;

% % maxZForSplit = 500;
% % minConductanceRatio = 0.1;
numChanged = 999;
belowCutoffStrandList = [];
cycleCounter = 0;
while numChanged > 0,
    cycleCounter = cycleCounter+1;
    newStartStrandList = [];
    numChanged = 0;
    numStartStrands = numel(startStrandList);
    for startStrandIter = 1:numStartStrands;
        startStrandID = startStrandList(startStrandIter);
        
        
% %         if startStrandID == 29, pause; end
        
        
%         disp([startStrandIter, startStrandID]);
        startStrand = Strands(startStrandID);
        ssiv = startStrand.InteriorVertices;
        startStrandCoordList = AllVerts(ssiv,:);
        strandNodes = [startStrand.StartVertexIndex,startStrand.EndVertexIndex];
        nodeVoltages = AllVoltages(strandNodes);
        [highVoltage,highVoltagePos] = max(nodeVoltages);
        [lowVoltage,lowVoltagePos] = min(nodeVoltages);
        highNode = strandNodes(highVoltagePos);
        lowNode = strandNodes(strandNodes~=highNode);

        
        %Look at the low node, and find neighbors
        if lowVoltagePos == 1,
            neighborStrands = startStrand.StartVertexNeighborStrands;
        else%if lowVoltagePos == 1,
            neighborStrands = startStrand.EndVertexNeighborStrands;
        end%if-else lowVoltagePos == 1,
        neighborStrands = neighborStrands(neighborStrands~=startStrandID);
        daughterConductance(1) = Strands(neighborStrands(1)).strandConductance;
        daughterConductance(2) = Strands(neighborStrands(2)).strandConductance;
        conductanceRatio = min(daughterConductance)./max(daughterConductance);
        maxZ = max(startStrandCoordList(:,3));
        
        for neighborIter = 1:numel(neighborStrands);
            thisNeighborID = neighborStrands(neighborIter);
            thisNeighborStrand = Strands(thisNeighborID);
            thisRadius = median(AllRadii(thisNeighborStrand.InteriorVertices));
            thisVoltage = median(AllVoltages(thisNeighborStrand.InteriorVertices));
            neighborNodes = [thisNeighborStrand.StartVertexIndex,thisNeighborStrand.EndVertexIndex];
            neighborNodeVoltages = AllVoltages(neighborNodes);
            sharedNodeVoltagePos = find(ismember(neighborNodeVoltages,nodeVoltages));
            sharedNodeVoltage = neighborNodeVoltages(sharedNodeVoltagePos(1));
            otherNodeVoltage = neighborNodeVoltages(neighborNodeVoltages~=sharedNodeVoltage);
            %---
            failTestFlag = 0;
            if otherNodeVoltage>=sharedNodeVoltage, failTestFlag = 1; end %daughter must be receiving flow from mother strand
            if thisRadius <= cutoffRadius, failTestFlag = 1; end %daughter must be above cutoff radius
            if thisVoltage <= cutoffVoltage, failTestFlag = 1; end %daughter must be above cutoff voltage
            if ismember(thisNeighborID,startStrandList), failTestFlag = 1; end %daughter must not be existing start strand
            
            
%             disp([thisRadius, thisVoltage])
            if failTestFlag == 1,
                belowCutoffStrandList = [belowCutoffStrandList,thisNeighborID];
            else%if failTestFlag == 1,
                newStartStrandList = [newStartStrandList,thisNeighborID];
            end%if failTestFlag == 1,
        end%for neighborIter = 1:numel(neighborStrands);
        
        disp('bcs:'),
        disp(belowCutoffStrandList);
        disp('nssl:');
        disp(newStartStrandList);

        
    end%for startStrandIter = 1:numStartStrands;
startStrandList = unique(newStartStrandList);
% numChanged = numel(startStrandList)-numStartStrands;
if cycleCounter == 1000, keyboard,end
numChanged = numel(startStrandList);
disp(numChanged)
end

cutoffStrandList = belowCutoffStrandList;
    
    