% % load('F:\Phil\VectorProjects\allProject03c_withVelocity.mat');
% % load('F:\Phil\VectorProjects\tempFlowProjectDB.mat');


vectorProject = allProject.db;
vectorizedStructure = vectorProject.vectorizedStructure;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
velocityListUMs = vectorizedStructure.velocityListMMs'*1000;
strandLengthList = vectorizedStructure.strandLengthList;
strands = vectorizedStructure.Strands;
barrels = vectorProject.barrelBoundaryParameters.barrels;
maskSize = vectorProject.maskSize;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
expandedVerts = [allVerts,[1:size(allVerts,1)]'];
strandIndices = full(vertices.StrandIndices);
allFlatMask = [];
allFiltMask = [];


%%
for barrelIter = 1:numel(barrels);

    thisBarrel = barrels{barrelIter};
    barrelMinZ = min(thisBarrel(:,3));
    barrelMaxZ = max(thisBarrel(:,3));
    barrelMinY = min(thisBarrel(:,1));
    barrelMaxY = max(thisBarrel(:,1));
    barrelMinX = min(thisBarrel(:,2));
    barrelMaxX = max(thisBarrel(:,2));
    flatMask = zeros(maskSize(1),maskSize(2));
    for pointIter = 1:size(thisBarrel,1);
        pointCC = thisBarrel(pointIter,:);
        flatMask(pointCC(1),pointCC(2)) = 1;
    end
    flatMask = imclose(flatMask,circle2d(5));
    flatMask = imfill(flatMask>0,'holes');

    flag1 = and(allVerts(:,1)>=barrelMinY,allVerts(:,1)<=barrelMaxY);
    flag2 = and(allVerts(:,2)>=barrelMinX,allVerts(:,2)<=barrelMaxX);
    flag3 = and(allVerts(:,3)>=barrelMinZ,allVerts(:,3)<=barrelMaxZ);
    flag4 = and(and(flag1,flag2),flag3);
    subVerts = expandedVerts(flag4,:);
    subInd = sub2ind(maskSize(1:2),subVerts(:,1),subVerts(:,2));
    insideFlag = flatMask(subInd);
    insideVerts = subVerts(insideFlag,:);
    insideStrands = unique(strandIndices(insideVerts(:,4),1));



    figure(11);imagesc(flatMask);

    barrelInputStrands = [];
    %find those strands with an upstream branch outside the barrel
    for strandIter = 1:numel(insideStrands)
        thisStrandID = insideStrands(strandIter);
        thisStrand = strands(thisStrandID);
        if thisStrand.StartVoltage > thisStrand.EndVoltage,
            upstreamNeighbors = thisStrand.StartVertexNeighborStrands;
        else%if thisStrand.StartVoltage > thisStrand.EndVoltage,
            upstreamNeighbors = thisStrand.EndVertexNeighborStrands;
        end%if-else thisStrand.StartVoltage > thisStrand.EndVoltage,
        if sum(~ismember(upstreamNeighbors,insideStrands))>0,
            barrelInputStrands = [barrelInputStrands;thisStrandID];
        end%if sum(~ismember(upstreamNeighbors;insideStrands))>0,

    end%for strandIter = 1:numel(insideStrands)


    keepFeedingFlag = 1;
    feedEveryNSteps = 50;

    startParticleCount = 1e6;

    activeStrandIDList = [barrelInputStrands];
    frontEdgeFractionList = repmat(0,size(activeStrandIDList));
    particleCountList = repmat(startParticleCount,size(activeStrandIDList));
    timeStep = 0.002;%sec
    minParticleCountFraction = 0.001;
    currentTime = 0;
    stepCounter = 0;
    keepGoingFlag = 1;
    dataArray = [];
    timeList = [];
    historicCoordList = [];
    %---
    displayLimits = [0 1500 0 1400 0 1000];
    timeLimit = 4;

    figure(1);
    myCamPos = campos;
    myCamTarget = camTarget;
    myCamVA = camva;

    figure(2)
    myCamPos2 = campos;
    myCamTarget2 = camTarget;
    myCamVA2 = camva;
    %%
    while keepGoingFlag == 1,

        tempActiveStrandIDList = activeStrandIDList;
        tempFrontEdgeFractionList = frontEdgeFractionList;
        tempParticleCountList = particleCountList;
        numActiveStrands = numel(activeStrandIDList);
        for activeIter = 1:numActiveStrands,
            rootStrandID = activeStrandIDList(activeIter);
            rootStrandParticleCount = particleCountList(activeIter);
            rootStrandFrontEdgeFraction = frontEdgeFractionList(activeIter);
            rootStrand = strands(rootStrandID);
            rootStrandMedianVoltage = rootStrand.MedianVoltage;
            rootStrandVelocity = velocityListUMs(rootStrandID);
            rootStrandLength = strandLengthList(rootStrandID);
            rootStrandStepUM = rootStrandVelocity.*timeStep;
            rootStrandStepFraction = rootStrandStepUM/rootStrandLength;
            rootStrandProgressFraction = rootStrandFrontEdgeFraction + rootStrandStepFraction;

            if rootStrandParticleCount/startParticleCount < minParticleCountFraction,
                tempActiveStrandIDList(activeIter) = 0;
            end%if rootStrandParticleCount/startParticleCount < minParticleCountFraction,

            if rootStrandProgressFraction < 1,
                %simple progress along vessel strand
                tempFrontEdgeFractionList(activeIter) = rootStrandProgressFraction;
            else%if rootStrandProgressFraction < 1,
                %split (or merge) at a juction
                leftOverFraction = rootStrandProgressFraction - 1;
                leftOverTime = (leftOverFraction * rootStrandLength)/rootStrandVelocity; %in seconds
                %---
                if rootStrand.StartVoltage > rootStrand.EndVoltage,
                    nextStrandIDList = rootStrand.EndVertexNeighborStrands;
                    nextStrandConnectVoltage = rootStrand.EndVoltage;
                else%if rootStrand.StartVoltage > rootStrand.EndVoltage,
                    nextStrandIDList = rootStrand.StartVertexNeighborStrands;
                    nextStrandConnectVoltage = rootStrand.StartVoltage;
                end%if rootStrand.StartVoltage > rootStrand.EndVoltage,
                %---
                %find the downstream branches
                numNextStrands = numel(nextStrandIDList);
                nextFlowFlagList = [];
                for nextIter = 1:numNextStrands,
                    tempStrandID = nextStrandIDList(nextIter);
                    tempStrand = strands(tempStrandID);
                    if nextStrandConnectVoltage > tempStrand.MedianVoltage,
                        nextFlowFlagList(nextIter) = +1; %+1 = flows into this strand
                    else%if baseStrandMedianVoltage > tempStrand.MedianVoltage,
                        nextFlowFlagList(nextIter) = -1; %-1 = diluting flow from this strand
                    end%if baseStrandMedianVoltage > tempStrand.MedianVoltage,
                end%for nextIter = 1:numNextStrands,

                downstreamBranchIDList = nextStrandIDList(nextFlowFlagList==+1);

    % %             disp([rootStrandID]);
    % %             disp(downstreamBranchIDList);
    %             keyboard

                allCurrents = [strands(downstreamBranchIDList).strandCurrent];
                sumCurrent = sum(abs(allCurrents));
                %add the downstream branches to the active list
                for downstreamIter = 1:numel(downstreamBranchIDList)
                    thisBranchID = downstreamBranchIDList(downstreamIter);
                    thisBranch = strands(thisBranchID);
                    thisCurrent = abs(thisBranch.strandCurrent);
                    thisStrandLength = strandLengthList(thisBranchID);

                    thisStrandVelocity = velocityListUMs(thisBranchID);
                    currentFraction = thisCurrent./sumCurrent;
                    thisParticleCount = rootStrandParticleCount.*currentFraction;
                    thisStrandStepUM = thisStrandVelocity.*leftOverTime;
                    thisStrandStepFraction = thisStrandStepUM/rootStrandLength;

                    tempNumActive = numel(tempActiveStrandIDList);
                    thisNum = tempNumActive+1;
                    tempActiveStrandIDList(thisNum) = thisBranchID;
                    tempParticleCountList(thisNum) = thisParticleCount;
                    tempFrontEdgeFractionList(thisNum) = thisStrandStepFraction;
                end%for downstreamIter...
                %Clear the rootStrand from the activeList
                tempActiveStrandIDList(activeIter) = 0;
            end%if-else rootStrandProgressFraction < 1,




        end%for activeIter = 1:numActiveStrands,
        stepCounter = stepCounter + 1;
        dataArray{stepCounter} = [activeStrandIDList,particleCountList,frontEdgeFractionList];
        currentTime = currentTime + timeStep;
        timeList(stepCounter) = currentTime;


        nowActiveFlag = find(tempActiveStrandIDList~=0);
        activeStrandIDList = tempActiveStrandIDList(nowActiveFlag);
        particleCountList = tempParticleCountList(nowActiveFlag);
        frontEdgeFractionList = tempFrontEdgeFractionList(nowActiveFlag);

        if keepFeedingFlag == 1 && mod(stepCounter,feedEveryNSteps)==0
            activeStrandIDList = [activeStrandIDList;barrelInputStrands];
            frontEdgeFractionList = [frontEdgeFractionList;[repmat(0,size(barrelInputStrands))]];
            particleCountList = [particleCountList;[repmat(startParticleCount,size(barrelInputStrands))]];

        end%if keepFeedingFlag == 1,

        tempCCList = [];
    %     figure(1);hold on
    %     figure(2);hold on


        for kk = 1:numel(activeStrandIDList),
            thisStrandID = activeStrandIDList(kk);
            thisStrand = strands(thisStrandID);
            thisParticleCount = particleCountList(kk);
            thisFrontEdgeFraction = frontEdgeFractionList(kk);
            startToEndIndices = thisStrand.StartToEndIndices;
            if thisStrand.StartVoltage < thisStrand.EndVoltage,
                startToEndIndices = fliplr(startToEndIndices);
            end%if thisStrand.StartVoltage < thisStrand.EndVoltage,
            numPoints = numel(startToEndIndices);
            roundup = min(numPoints,max(1,ceil(numPoints.*thisFrontEdgeFraction)));
            thisPoint = startToEndIndices(roundup);
            thisCoords = vectorizedStructure.Vertices.AllVerts(thisPoint,:);
            tempCCList = [tempCCList;thisCoords];
    %         figure(1);
            p1 = plot3(thisCoords(1),thisCoords(2),-1*thisCoords(3),'r.');hold on;
            myMarkerSize = max(1,log10(1e7*thisParticleCount/(startParticleCount)));
            set(p1,'MarkerSize',myMarkerSize);
    %         figure(2);
    %         p2 = plot3(thisCoords(1),thisCoords(2),-1*thisCoords(3),'r.');hold on;
    %         myMarkerSize = max(1,log10(1e7*thisParticleCount/(startParticleCount)));
    %         set(p2,'MarkerSize',myMarkerSize);

        end%for kk

        title(['Time: ',num2str(currentTime),' seconds']);


    %     figure(1);
        camva(myCamVA);
        camtarget(myCamTarget);
        campos(myCamPos);


    %     figure(2);
    %     camva(myCamVA2);
    %     camtarget(myCamTarget2);
    %     campos(myCamPos2);

        pause(0.01)
    % pause

        figure(1);hold off
        historicCoordList = [historicCoordList;tempCCList];
        p1 = plot3(historicCoordList(:,1),historicCoordList(:,2),-1*historicCoordList(:,3),'g.');hold on;
        set(p1,'MarkerSize',1);
        set(gca,'YLim',[displayLimits(1),displayLimits(2)]);
        set(gca,'XLim',[displayLimits(3),displayLimits(4)]);
        set(gca,'ZLim',[-1*displayLimits(6),-1*displayLimits(5)]);
        set(gca,'Color',[0,0,0])

    %     figure(2);hold off
    %     p2 = plot3(historicCoordList(:,1),historicCoordList(:,2),-1*historicCoordList(:,3),'g.');hold on;
    %     set(p2,'MarkerSize',1);
    %     set(gca,'YLim',[displayLimits(1),displayLimits(2)]);
    %     set(gca,'XLim',[displayLimits(3),displayLimits(4)]);
    %     set(gca,'ZLim',[-1*displayLimits(6),-1*displayLimits(5)]);
    %     set(gca,'Color',[0,0,0])



    % % %     for kk = 1:numel(activeStrandIDList),
    % % %         thisStrandID = activeStrandIDList(kk);
    % % %         thisStrand = strands(thisStrandID);
    % % %         thisParticleCount = particleCountList(kk);
    % % %         thisFrontEdgeFraction = frontEdgeFractionList(kk);
    % % %         startToEndIndices = thisStrand.StartToEndIndices;
    % % %         if thisStrand.StartVoltage < thisStrand.EndVoltage,
    % % %             startToEndIndices = fliplr(startToEndIndices);
    % % %         end%if thisStrand.StartVoltage < thisStrand.EndVoltage,
    % % %         numPoints = numel(startToEndIndices);
    % % %         roundup = min(numPoints,max(1,ceil(numPoints.*thisFrontEdgeFraction)));
    % % %         thisPoint = startToEndIndices(roundup);
    % % %         thisCoords = vectorizedStructure.Vertices.AllVerts(thisPoint,:);
    % % %         
    % % %         p1 = plot3(thisCoords(1),thisCoords(2),-1*thisCoords(3),'y.');hold on;
    % % %         myMarkerSize = 100*thisParticleCount/(startParticleCount);
    % % %         set(p1,'MarkerSize',myMarkerSize);
    % % %     end%for kk 


    %     disp(activeStrandIDList)


        if isempty(activeStrandIDList), keepGoingFlag = 0; end
        if currentTime>timeLimit, keepGoingFlag = 0; end;



    end%while keepGoingFlag == 1,



    finalData = dataArray{end};
    numPoints = size(finalData,1);
    flowMask = zeros(maskSize(1),maskSize(2));
    vertList = [];
    for pointIter = 1:numPoints,
        thisStrandID = finalData(pointIter,1);
        thisParticleCount = finalData(pointIter,2);
        thisFrontEdgeFraction = min(finalData(pointIter,3),1);
        thisStrand = strands(thisStrandID);
        stei = thisStrand.StartToEndIndices;
        pointIndex = max(1,ceil(numel(stei)*thisFrontEdgeFraction));
        if thisStrand.StartVoltage < thisStrand.EndVoltage,
            stei = fliplr(stei);
        end%if thisStrand....
        thisPoint = stei(pointIndex);
        thisVert = [allVerts(thisPoint,:),thisParticleCount];
        vertList = [vertList;thisVert];
        flowMask(thisVert(1),thisVert(2)) = flowMask(thisVert(1),thisVert(2)) + thisParticleCount;
    end%for pointIter;

    filtMask = imfilter(flowMask,double(gaussian2d(151,41)));
    figure(11);imagesc(flatMask);
    figure(13);logpic(filtMask);
    figure(12);imagesc(filtMask);
    pause(0.1);

    allFlatMask = cat(3,allFlatMask,flatMask);
    allFiltMask = cat(3,allFiltMask,filtMask);

    pause(2);

end%for barrelIter...



figure(91);imagesc(max(allFlatMask,[],3));
figure(92);imagesc(max(allFiltMask,[],3));



