%%

scriptVersion = 'TrackTimeOfFlightOfBolusInjectionScript1x.m'

vectorProject = allProject.av;% au av co db avPlus0p5 coPlus0p4
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
allVerts = vertices.AllVerts;

strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;

strandLabelList = [strands(:).MedianLabel];
surfList = find(and(strandLabelList>=300,strandLabelList<=399)); 
zSurf = strandMidYXZList(surfList,3);
medianZSurf = median(zSurf);
minZSurf = min(zSurf);

strandMidYXZList(:,3) = max(strandMidYXZList(:,3)-minZSurf,0);
plungingArterioleTipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
allPlungingArterioleList = vectorProject.vectorizedStructure.allPlungingArterioleList;
allPlungingArteriolePathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;
plungingVenuleTipList = vectorProject.vectorizedStructure.plungingVenuleTipList;
allPlungingVenuleList = vectorProject.vectorizedStructure.allPlungingVenuleList;
allPlungingVenulePathList = vectorProject.vectorizedStructure.allPlungingVenulePathList;
effectiveStrandRadiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList;
strandLengthList = vectorProject.vectorizedStructure.strandLengthList;



% % % %Eliminate "plunging" vessels that have only one strand
% % % pathLength = [];
% % % for kk = 1:numel(allPlungingVenulePathList);
% % %     pathLength(kk) = numel(allPlungingVenulePathList{kk});
% % % end
% % % ffv = find(pathLength>2);
% % % allPlungingVenulePathList = allPlungingVenulePathList(ffv);
% % % %---
% % % pathLength = [];
% % % for kk = 1:numel(allPlungingArteriolePathList);
% % %     pathLength(kk) = numel(allPlungingArteriolePathList{kk});
% % % end
% % % ffa = find(pathLength>2);
% % % allPlungingArteriolePathList = allPlungingArteriolePathList(ffa);
% % % %---
% % % 


flowAnalysisParameters = [];
cleanupFlag = 1;


numStrands = numel(strands);
numVertices = numel(vertices.AllRadii);
tofStruct = []; %timeOfFlight dataStruct
tofStruct(numStrands).currentList = [];
tofStruct(numStrands).startTimeList = [];

maxBranchSearch = 30;
stopVoltage = 50.1;
minimumFluxFraction = 1/300000;

%%

%%
%Calculate the minimum time of flight from an plungingArterioleTip;
%Time of flight = 

timeMultiplier = 1e6;

meanYXZList = zeros(numStrands,3);
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    YXZLimits = thisStrand.YXZLimits;
    meanYXZ = mean(YXZLimits,2);
    meanYXZList(strandIter,:) = meanYXZ';
end

allStrandTimeList = [];
baseStrandIDList = plungingArterioleTipList;
numBaseStrands = numel(baseStrandIDList);

for baseStrandIter = 1:numBaseStrands;
    disp(baseStrandIter)

% % baseStrandIter = 11

    strandTimeList = zeros(numStrands,2)+inf;
    baseStrandID = baseStrandIDList(baseStrandIter);
    baseStrand = strands(baseStrandID);
    bsiv = baseStrand.InteriorVertices;
    baseStrandCoordList = vertices.AllVerts(bsiv,:);
    strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
    nodeVoltages = vertices.AllVoltages(strandNodes);
    [highVoltage,highVoltagePos] = max(nodeVoltages);
    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
    highNode = strandNodes(highVoltagePos);
    lowNode = strandNodes(strandNodes~=highNode);

    pathActiveFlagList = false(1,100000);
    pathActiveFlagList(1) = 1;
    numActivePath = sum(pathActiveFlagList);
    strandPathList = {};
    strandPathList{100000} = [];
    nodePathList = {};
    nodePathList{100000} = [];
    fractionPathList = {};
    fractionPathList{100000} = [];
    strandPathList{1} = baseStrandID;
    nodePathList{1} = [highNode lowNode];
    fractionPathList{1} = 1;
    strandFlowList = zeros(numStrands,1);
    strandFlowList(baseStrandID) = 1;
    strandVoltageList = zeros(numStrands,1);
    strandVoltageList(1) = mean([highVoltage,lowVoltage]);
    pathCounter = 1;
    keepGoingFlag = 1;
    branchCounter = 0;
    %---
    baseStrandCurrent = abs(baseStrand.strandCurrent);
    strandRadius = effectiveStrandRadiusList(baseStrandID);
    tofStruct(baseStrandID).currentList = baseStrandCurrent;
    tofStruct(baseStrandID).startTimeList = 0;
    strandLength = strandLengthList(baseStrandID);


    velocityMultiplier = 1e-6;
    assumedDensity = 1e-2; %rbc per um3 (assuming 1x7x7 cell, and 50% hematocrit)
    %strand velocity in um/sec (expect ~500 - 1000um/s for small vessels)
    strandVelocity = velocityMultiplier * baseStrandCurrent./((pi*strandRadius^2)*assumedDensity);
    timeOfFlight = strandLength./strandVelocity;
    strandVelocityList(baseStrandID) = strandVelocity;


    transitTimeList(baseStrandID) = timeOfFlight;
    strandTimeList(baseStrandID,:) = [0,timeOfFlight];

    while (keepGoingFlag == 1),
        myCount = 0;
        branchCounter = branchCounter+1;
        disp(['Tracking down ',num2str(branchCounter),' branch orders : ',datestr(now,'mmddyy_HH:MM:SS')]);

        for pathIter = find(pathActiveFlagList == 1);
            currentPathID = pathIter;
            currentStrandPath = strandPathList{pathIter};
            currentNodePath = nodePathList{pathIter};
            currentFractionPath = fractionPathList{pathIter};
            currentStrandID = currentStrandPath(end);
            currentStrand = strands(currentStrandID);
            %-----
            strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
            nodeVoltages = vertices.AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);
            lowAttachedStrands = vertices.StrandIndices(lowNode,:);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
            lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
            numDaughterPaths = numel(lowAttachedStrands);
            strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
            stopTracingFlag = 0;
            if numDaughterPaths == 0, stopTracingFlag = 1; end
            if lowVoltage < stopVoltage, stopTracingFlag = 1; end
            if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
            if stopTracingFlag == 1,
                pathActiveFlagList(currentPathID) = 0;
            else%if stopTracingFlag == 1,
                motherCurrent = abs(currentStrand.strandCurrent);
                validDaughterCounter = 0;
                validDaughterStrandList = [];
                validDaughterCurrentList = zeros(1,numDaughterPaths);
                validDaughterPathIndexList = [];
                for daughterIter = 1:numDaughterPaths,
                    %Check to see if the daughter strand leads to a lower voltage
                    candidateDaughterID = lowAttachedStrands(daughterIter);
                    candidateDaughterStrand = strands(candidateDaughterID);
                    candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                    candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                    candidateDaughterOtherVoltage = vertices.AllVoltages(candidateDaughterOtherNode);
                    if candidateDaughterOtherVoltage < lowVoltage,
                        %if so, add the strand to a path
                        myCount = myCount + 1;
                        validDaughterCounter = validDaughterCounter + 1;
                        validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                        validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                        if validDaughterCounter == 1,
                            %if this is the first valid daughter, add to current path
                            strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                            validDaughterPathIndexList(1) = currentPathID;
                        else%if validDaughterCounter == 1,
                            %if not the first daughter, duplicate path up to this point, and
                            %make new path
                            pathCounter = pathCounter + 1;
                            strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                            nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                            fractionPathList{pathCounter} = currentFractionPath;
                            pathActiveFlagList(pathCounter) = 1;  
                            validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                        end%if-else validDaughterCounter == 1,
                    end%if candidateDaughterOtherVoltage < lowVoltage,
                end%for daughterIter = 1:numDaughterPaths,
                clear daughterIter
                %-----
                daughterSumCurrent = sum(validDaughterCurrentList);
                fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                for validDaughterIter = 1:validDaughterCounter;
                    validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                    validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                    fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                    strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;
                    
                    
                    strandRadius = effectiveStrandRadiusList(validDaughterSegmentID);
                    currentList = [tofStruct(validDaughterSegmentID).currentList, baseStrandCurrent .* validDaughterFraction];
                    tofStruct(validDaughterSegmentID).currentList = currentList;
                    thisDaughterCurrent = abs(strands(validDaughterSegmentID).strandCurrent);
                    thisMotherEndTime = strandTimeList(currentStrandID,2);
                    strandLength = strandLengthList(validDaughterSegmentID);
                    timeOfFlight = strandLength*(strandRadius.^2)/thisDaughterCurrent;

                    
                    velocityMultiplier = 1e-6;
                    assumedDensity = 1e-2; %rbc per um3 (assuming 1x7x7 cell, and 50% hematocrit)
                    %strand velocity in um/sec (expect ~500 - 1000um/s for small vessels)
                    strandVelocity = velocityMultiplier * thisDaughterCurrent./((pi*strandRadius^2)*assumedDensity);
                    timeOfFlight = strandLength./strandVelocity;
                    strandVelocityList(validDaughterSegmentID) = strandVelocity;

                                        
                    thisDaughterEndTime = thisMotherEndTime + timeOfFlight;
                    transitTimeList(validDaughterSegmentID) = timeOfFlight;
                    startTimeList = [tofStruct(validDaughterSegmentID).startTimeList, thisMotherEndTime];
                    tofStruct(validDaughterSegmentID).startTimeList = startTimeList;
                    storedTimes = strandTimeList(validDaughterSegmentID,:);
                    minTimes = min(storedTimes,[thisMotherEndTime,thisDaughterEndTime]);
                    strandTimeList(validDaughterSegmentID,:) = minTimes;
                    

                    
                end%for validDaughterIter = 1:validDaughterCounter;
            end%if-else stopTracingFlag == 1,
        end%for pathIter = find(pathActiveFlagList == 1);
        if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
        if myCount == 0, keepGoingFlag = 0;end
        if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
    end%while (keepGoingFlag == 1),
    allStrandTimeList{baseStrandIter} = strandTimeList;
    disp(baseStrandIter)
    
end%for baseStrandIter = 1:numBaseStrands;
vectorProject.vectorizedStructure.allStrandTimeList = allStrandTimeList


%%
allStrandTimeList = vectorProject.vectorizedStructure.allStrandTimeList;

y1 = 00;y2 = maskSize(1)-y1;
x1 = 00;x2 = maskSize(2)-x1;
z1 = 0;z2 = 1200;
% y1 = 300;y2 = 400;

y3 = min(y2,maskSize(1));
x3 = min(x2,maskSize(2));
z3 = min(z2,maskSize(3));

minStrandTimeList = allStrandTimeList{1};
for baseStrandIter = 1:numBaseStrands,
    minStrandTimeList = min(minStrandTimeList,allStrandTimeList{baseStrandIter});
end
strandTimeList = minStrandTimeList;

allVertTimeList = zeros(numVertices,1)+inf;
subStrandList = find(strandTimeList(:,1)<inf);

for strandIter =1:numel(subStrandList),
    thisStrandID = subStrandList(strandIter);
    thisVertList = strands(thisStrandID).StartToEndIndices;
    thisStrandLength = numel(thisVertList);
    thisStartTime = strandTimeList(thisStrandID,1);
    thisEndTime = strandTimeList(thisStrandID,2);
    thisTimeList = linspace(thisStartTime,thisEndTime,thisStrandLength);
    if strands(thisStrandID).strandCurrent<0, thisTimeList = fliplr(thisTimeList); end
    allVertTimeList(thisVertList) = thisTimeList;
end

strandIndices = vectorProject.vectorizedStructure.Vertices.StrandIndices;
strandCurrentList = abs([strands(:).strandCurrent]);
strandCurrentNormList = ceil(strandCurrentList./1e7)+1;
vertCurrentNormList = strandCurrentNormList(strandIndices(:,1));


f1 = figure(1);
f2 = figure(2);
f3 = figure(3);
set(f1,'DoubleBuffer','on');
set(f2,'DoubleBuffer','on');
set(f3,'DoubleBuffer','on');

zRange = [0:50:1500];
maxBlurSize = 15;
blurSize = 0;
timeVector = [0:0.002:5];
numTimeSteps = numel(timeVector)-maxBlurSize;
for timeIter = 1:numTimeSteps;
    blurSize=min(blurSize+1,maxBlurSize);

   
    
    t1 = timeVector(timeIter);
    t2 = timeVector(timeIter+blurSize);
% % %     activeStrandList = find(and(strandTimeList(:,2)>t1,strandTimeList(:,1)<=t2));
% % %     ft = false(numVertices,1);
% % %     ft([strands(activeStrandList).StartToEndIndices]) = 1;
    ft = and(allVertTimeList>t1,allVertTimeList<=t2);
    f1 = and(allVerts(:,1)>y1,allVerts(:,1)<y2);
    f2 = and(allVerts(:,2)>x1,allVerts(:,2)<x2);
    f3 = and(allVerts(:,3)>z1,allVerts(:,3)<z2);
    ff = and(and(and(f1,f2),f3),ft);
   
    cc = allVerts(ff,:);
    subVertCurrentNormList = vertCurrentNormList(ff);
    
    figure(1);
    p0 = plot3(y1,x1,-z1,'w.');hold on
    p0 = plot3(y3,x3,-z3,'w.');hold on
    p1 = plot3(cc(:,1),cc(:,2),-1*cc(:,3),'r.'); hold off;
    camtarget([559.5000  540.5000 -500.0000]);
    campos([300,-8700,-500]);
    set(p1,'MarkerSize',6);
    axis equal
    title(num2str(t1));
    
    numFlux = sum(subVertCurrentNormList);
    fluxCarrier = zeros(numFlux,1);
    counter = 0;
    for kk = 1:numel(subVertCurrentNormList);
        thisCount = subVertCurrentNormList(kk);
        fluxCarrier(counter+1:counter+thisCount) = cc(kk,3);
        counter = counter+thisCount;
    end
    
    figure(2);
    hz = hist(cc(:,3),zRange);
    bar(zRange,hz);
    
    figure(3);
    hfz = hist(fluxCarrier,zRange);
    bar(zRange,hfz);
    
    
    pause(0.01)
    
    
end%for timeIter
    
disp('SAVE THE VECTORPROJECT BACK TO THE ALLPROJECT AND SAVE');















