%%

scriptVersion = 'TrackTimeOfFlightOfBolusInjectionScript1x.m'

vectorProject = allProject.db;% au av co db avPlus0p5 coPlus0p4
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;

strandMidYXZList = vectorProject.vectorizedStructure.strandMidYXZList;

strandLabelList = [strands(:).MedianLabel];
surfList = find(and(strandLabelList>=300,strandLabelList<=399)); 
zSurf = strandMidYXZList(surfList,3);
medianZSurf = median(zSurf);
minZSurf = min(zSurf);

strandMidYXZList(:,3) = max(strandMidYXZList(:,3)-minZSurf,0);
plungingArterioleTipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
allPlungingArterioleList = vectorProject.vectorizedStructure.allPlungingArterioleList;
allPlungingArteriolePathList = vectorProject.vectorizedStructure.allPlungingArteriolePathList;
plungingVenuleTipList = vectorProject.vectorizedStructure.plungingVenuleTipList;
allPlungingVenuleList = vectorProject.vectorizedStructure.allPlungingVenuleList;
allPlungingVenulePathList = vectorProject.vectorizedStructure.allPlungingVenulePathList;
effectiveStrandRadiusList = vectorProject.vectorizedStructure.effectiveStrandRadiusList;
strandLengthList = vectorProject.vectorizedStructure.strandLengthList;



% % % %Eliminate "plunging" vessels that have only one strand
% % % pathLength = [];
% % % for kk = 1:numel(allPlungingVenulePathList);
% % %     pathLength(kk) = numel(allPlungingVenulePathList{kk});
% % % end
% % % ffv = find(pathLength>2);
% % % allPlungingVenulePathList = allPlungingVenulePathList(ffv);
% % % %---
% % % pathLength = [];
% % % for kk = 1:numel(allPlungingArteriolePathList);
% % %     pathLength(kk) = numel(allPlungingArteriolePathList{kk});
% % % end
% % % ffa = find(pathLength>2);
% % % allPlungingArteriolePathList = allPlungingArteriolePathList(ffa);
% % % %---
% % % 


flowAnalysisParameters = [];
cleanupFlag = 1;


numStrands = numel(strands);
numVertices = numel(vertices.AllRadii);
tofStruct = []; %timeOfFlight dataStruct
tofStruct(numStrands).currentList = [];
tofStruct(numStrands).startTimeList = [];

maxBranchSearch = 30;
stopVoltage = 50.1;
minimumFluxFraction = 1/300000;

timeStep = 0.0001;
maxTimeStep = 0.005;

%%
%Pick a strand(s) to inject bolus
injectionStrandList = plungingArterioleTipList(10);
injectionBallList = repmat([1e3],size(injectionStrandList));


numBalls = sum(injectionBallList);
ballStrandList = zeros(numBalls,1);
ballCounter = 0;
for strandIter = 1:numel(injectionStrandList);
    ballStrandList(ballCounter+1:ballCounter+injectionBallList(strandIter)) =  injectionStrandList(strandIter);
    ballCounter = ballCounter + injectionBallList(strandIter);
end

ballVertList = zeros(size(ballStrandList));
ballVertInStrandList = ones(size(ballStrandList));
keepGoingFlag = 1;
ballIndex = 1;
ballProgressFlag = false(size(ballVertList));
while keepGoingFlag == 1,
    currentBallStrandIndex = find(ballStrandList == ballStrandList(ballIndex));
    thisStrand = strands(ballStrandList(ballIndex));
    ballProgressFlag(currentBallStrandIndex) = 1;
    if thisStrand.StartVoltage > thisStrand.EndVoltage,
        ballVertList(currentBallStrandIndex) = thisStrand.StartVertexIndex;
    else%if thisStrand.StartVoltage > thisStrand.EndVoltage,
        ballVertList(currentBallStrandIndex) = thisStrand.EndVertexIndex;
    end%if-else thisStrand.StartVoltage > thisStrand.EndVoltage,
    keepGoingFlag = sum(ballProgressFlag==0)>0;
    if keepGoingFlag == 1,
        notDoneList = find(ballProgressFlag==0);
        ballIndex = notDoneList(1);
    end%if keepGoingFlag
end%while keepGoingFlag

keepGoingFlag = 1;

f1 = figure(1);
f2 = figure(2);
f3 = figure(3);
set(f1,'DoubleBuffer','on');
set(f2,'DoubleBuffer','on');
set(f3,'DoubleBuffer','on');

%%
while keepGoingFlag == 1,
    ballIndex = 1;
    ballProgressFlag = false(size(ballVertList));
    lastRoundProgress = 0;
    timeStep = min(timeStep+0.00001,maxTimeStep);
    %take one time step for all balls
    keepProcessingBallsFlag = 1;
    while keepProcessingBallsFlag == 1,
        currentBallIndexList = find(ballVertList == ballVertList(ballIndex));
        currentNumBalls = numel(currentBallIndexList);
        %for this (set of) ball(s), calculate the velocity, direction, etc.,
        %   and figure the next vertex (or vertices if a branch is reached) for the next timeStep
            thisVert = ballVertList(currentBallIndexList(1));
            thisBallPos = ballVertInStrandList(currentBallIndexList(1));
            thisStrandID = strandIndices(thisVert,1);
            thisStrand = strands(thisStrandID);
            if thisStrand.StartVoltage>thisStrand.EndVoltage,
                thisInteriorVertList = thisStrand.InteriorVertices;
                thisStartToEndList = thisStrand.StartToEndIndices;
                thisDownstreamNeighborList = thisStrand.EndVertexNeighborStrands;
                thisLowVoltage = thisStrand.EndVoltage;
            else%if thisStrand.StartVoltage>thisStrand.EndVoltage,
                thisInteriorVertList = fliplr(thisStrand.InteriorVertices);
                thisStartToEndList = fliplr(thisStrand.StartToEndIndices);
                thisDownstreamNeighborList = thisStrand.StartVertexNeighborStrands;
                thisLowVoltage = thisStrand.StartVoltage;        
            end%if-else thisStrand.StartVoltage>thisStrand.EndVoltage,
            thisCurrent = abs(thisStrand.strandCurrent);
            thisRadius = effectiveStrandRadiusList(thisStrandID);
            if isempty(thisInteriorVertList),
                thisInteriorVertList = thisStartToEndList;
            end%if isempty(thisInteriorVertList),
            %---
            velocityMultiplier = 1e-6;
            assumedDensity = 1e-2; %rbc per um3 (assuming 1x7x7 cell, and 50% hematocrit)
            %strand velocity in um/sec (expect ~500 - 1000um/s for small vessels)
            strandVelocity = velocityMultiplier * thisCurrent./((pi*thisRadius^2)*assumedDensity);
            ballMovement = strandVelocity*timeStep;
            nextBallPos = thisBallPos + ballMovement;
            %---
            if nextBallPos < numel(thisInteriorVertList),
                ballVertInStrandList(currentBallIndexList) = nextBallPos;
                ballVertList(currentBallIndexList) = thisInteriorVertList(floor(nextBallPos));
                ballProgressFlag(currentBallIndexList) = 1;
            else%if nextBallPos < numel(thisInteriorVertList),
                %find downstream flow strands and distribute balls accordingly
                remainingTimeStep = (nextBallPos - numel(thisInteriorVertList))/strandVelocity;

                thisDownstreamFlowList = thisDownstreamNeighborList([strands(thisDownstreamNeighborList).MedianVoltage] < thisLowVoltage);
                numDaughters = numel(thisDownstreamFlowList);
                daughterCurrentList = [];
                daughterBallPosList = [];
                daughterBallVertList = [];
                if numDaughters == 0,
                    ballVertList(currentBallIndexList) = thisInteriorVertList(end);
                    ballVertInStrandList(currentBallIndexList) = numel(thisInteriorVertList);
                    ballProgressFlag(currentBallIndexList) = 1;
                else%if numDaughters == 0,
                    for daughterIter = 1:numDaughters,
                        thisDaughterID = thisDownstreamFlowList(daughterIter);
                        thisDaughter = strands(thisDaughterID);

                        if thisDaughter.StartVoltage>thisDaughter.EndVoltage,
                            thisDaughterInteriorVertList = thisDaughter.InteriorVertices;
                            thisDaughterStartToEndList = thisDaughter.StartToEndIndices;
                            thisDaughterDownstreamNeighborList = thisDaughter.EndVertexNeighborStrands;
                            thisDaughterLowVoltage = thisDaughter.EndVoltage;
                        else%if thisStrand.StartVoltage>thisStrand.EndVoltage,
                            thisDaughterInteriorVertList = fliplr(thisDaughter.InteriorVertices);
                            thisDaughterStartToEndList = fliplr(thisDaughter.StartToEndIndices);
                            thisDaughterDownstreamNeighborList = thisDaughter.StartVertexNeighborStrands;
                            thisDaughterLowVoltage = thisDaughter.StartVoltage;        
                        end%if-else thisStrand.StartVoltage>thisStrand.EndVoltage,
                        thisDaughterCurrent = abs(thisDaughter.strandCurrent);
                        thisDaughterRadius = effectiveStrandRadiusList(thisDaughterID);
                        thisDaughterVelocity = velocityMultiplier * thisDaughterCurrent./((pi*thisDaughterRadius^2)*assumedDensity);
                        daughterBallMovement = thisDaughterVelocity*remainingTimeStep;
                        daughterBallPos = 1 + daughterBallMovement;
                        if ~isempty(thisDaughterInteriorVertList),
                            daughterBallPos = min(daughterBallPos,numel(thisDaughterInteriorVertList));
                            daughterVert = thisDaughterInteriorVertList(floor(daughterBallPos));
                            daughterCurrentList(daughterIter) = thisDaughterCurrent;
                            daughterBallPosList(daughterIter) = daughterBallPos;
                            daughterBallVertList(daughterIter) = daughterVert;
                        else%if ~isempty(thisDaughterInteriorVertList),
                            daughterBallPos = 2;
                            daughterVert = thisDaughterStartToEndList(floor(daughterBallPos));
                        end%if-else ~isempty(thisDaughterInteriorVertList),
                            daughterCurrentList(daughterIter) = thisDaughterCurrent;
                            daughterBallPosList(daughterIter) = daughterBallPos;
                            daughterBallVertList(daughterIter) = daughterVert;                           
                        
                    end%for daughterIter...
                    daughterCurrentRatio = daughterCurrentList./sum(daughterCurrentList);
                    daughterNumBalls = round(currentNumBalls*daughterCurrentRatio);
                    daughterBallCounter = 0;
                    for daughterIter = 1:numDaughters,
                        if daughterIter == numDaughters,
                            daughterBallList = currentBallIndexList([daughterBallCounter+1:end]);
                        else%if daughterIter == numDaughters,
                           daughterBallList = currentBallIndexList([daughterBallCounter+1:daughterBallCounter+daughterNumBalls(daughterIter)]);
                        end%if-else daughterIter = numDaughters,
                        ballVertInStrandList(daughterBallList) = daughterBallPosList(daughterIter);
                        ballVertList(daughterBallList) = daughterBallVertList(daughterIter);
                        ballProgressFlag(daughterBallList) = 1;
                        daughterBallCounter = daughterBallCounter + daughterNumBalls(daughterIter);
    %                     pause
                    end%for daughterIter...
                end%if-else numDaughters == 0;
            end%if nextBallPos < numel(thisInteriorVertList),
            keepProcessingBallsFlag = sum(ballProgressFlag==0)>0;
            if keepProcessingBallsFlag == 1,
                ballIndex = find(ballProgressFlag==0);
                ballIndex = ballIndex(1);
                thisRoundProgress = sum(ballProgressFlag);
                if thisRoundProgress == lastRoundProgress, disp('no progress'),pause;pause;end
                lastRoundProgress = thisRoundProgress;
            end%if keepProcessingBallsFlag == 1,
    end%while keepProcessingBallsFlag == 1,

    [uniqueBallVerts,bi,bj] = unique(ballVertList);
    cc = allVerts(uniqueBallVerts,:);
    ccAllZ = allVerts(ballVertList,3);
    
    y1 = 00;y2 = maskSize(1)-y1;
    x1 = 00;x2 = maskSize(2)-x1;
    z1 = 0;z2 = 1200;

    
% %     t1 = timeVector(timeIter);
% %     t2 = timeVector(timeIter+blurSize);
% %     ft = and(allVertTimeList>t1,allVertTimeList<=t2);
% %     f1 = and(allVerts(:,1)>y1,allVerts(:,1)<y2);
% %     f2 = and(allVerts(:,2)>x1,allVerts(:,2)<x2);
% %     f3 = and(allVerts(:,3)>z1,allVerts(:,3)<z2);
% %     ff = and(and(and(f1,f2),f3),ft);
   
    
    figure(1);
    p0 = plot3(y1,x1,-z1,'w.');hold on
    p0 = plot3(y2,x2,-z2,'w.');hold on
    p1 = plot3(cc(:,1),cc(:,2),-1*cc(:,3),'r.'); hold off;
    camtarget([559.5000  540.5000 -500.0000]);
    campos([300,-8700,-500]);
    set(p1,'MarkerSize',6);
    axis equal
%     title(num2str(t1));
    
    zRange = [0:50:1500];
    figure(2);
    hz = hist(ccAllZ,zRange);
    bar(zRange,hz);

    zRange = [0:50:1500];
    figure(3);
    hz = hist(ccAllZ,zRange);
    bar(zRange(5:end),hz(5:end));
    
    pause(0.1)

end%while keepGoing












