% cd('F:\Phil\AOH_VectorProjects')
% load('F:\Phil\AOH_VectorProjects\allProject004.mat')



vectorProject = allProject.au;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = vertices.AllVerts;
strandIndices = vertices.StrandIndices;
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
barrels = vectorProject.barrelBoundaryParameters.barrels;


%%
barrelChoice = 1

thisBarrel = barrels{barrelChoice};
flatBarrel = thisBarrel(thisBarrel(:,3)==thisBarrel(end,3),:);
% flatBarrel = thisBarrel(thisBarrel(:,3)==median(thisBarrel(:,3)),:);
barrelMask = zeros(maskSize(1),maskSize(2));
flatBarrelInd = sub2ind(size(barrelMask),flatBarrel(:,1),flatBarrel(:,2));
barrelMask(flatBarrelInd) = 1;
figure(1);imagesc(barrelMask);colormap(gray)
barrelMask = imclose(barrelMask,circle2d(7));
figure(1);imagesc(barrelMask);colormap(gray);
barrelMask = imfill(barrelMask,'holes');
figure(1);imagesc(barrelMask);colormap(gray);
barrelCOM = mean(flatBarrel)
onPixels = find(barrelMask);
barrelZ1 = min(thisBarrel(:,3));
barrelZ2 = max(thisBarrel(:,3));
augVerts = [allVerts,[1:size(allVerts,1)]'];
subVerts = augVerts(and(allVerts(:,3)>barrelZ1,allVerts(:,3)<barrelZ2),:);
subVertFlatInd = sub2ind(size(barrelMask),subVerts(:,1),subVerts(:,2));
insideBarrelFlagList = ismember(subVertFlatInd,onPixels);
insideBarrelVerts = subVerts(insideBarrelFlagList,4);
insideBarrelStrands = unique(strandIndices(insideBarrelVerts,1));

%%
%Now dilate the insideBarrelStrands

dilationFraction = 1.1;

effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
effectiveStrandRadiusList(insideBarrelStrands) = effectiveStrandRadiusList(insideBarrelStrands) * dilationFraction;
perturbedProject = vectorProject;
perturbedProject.circuitAnalysisParameters.minRadius = 0;
perturbedProject.vectorizedStructure.effectiveStrandRadiusList = effectiveStrandRadiusList;
perturbedProject = CalculateUnperturbedFlow003(perturbedProject);

perturbedCurrentList = abs([perturbedProject.vectorizedStructure.Strands(:).strandCurrent]);
origCurrentList = abs([vectorProject.vectorizedStructure.Strands(:).strandCurrent]);
currentRatioList = perturbedCurrentList./origCurrentList;
figure(1);plot(currentRatioList,'r.');


%%


thresholdRatio = 1.03;
    
y1 = 00;y2 = maskSize(1)-y1;
x1 = 00;x2 = maskSize(2)-x1;
z1 = 000;z2 = 1200;

x1 = 400; x2 = 600;


p0 = plot3(y1,x1,-z1,'w.');hold on
p0 = plot3(y2,x2,-z2,'w.');hold on


f1 = and(allVerts(:,1)>y1,allVerts(:,1)<y2);
f2 = and(allVerts(:,2)>x1,allVerts(:,2)<x2);
f3 = and(allVerts(:,3)>z1,allVerts(:,3)<z2);
ff1 = and(and(f1,f2),f3);
av1 = allVerts(ff1,:);

figure(1);hold off
figure(1);p1 = plot3(av1(:,1),av1(:,2),-1*av1(:,3),'g.');hold on;set(p1,'MarkerSize',1);
axis equal
camtarget([559.5000  540.5000 -500.0000]);
campos([300,-8700,-500]);

aboveRatioStrandList = currentRatioList > thresholdRatio;
aboveRatioVertList = [strands(aboveRatioStrandList).InteriorVertices];
fc = false(size(ff1)); fc(aboveRatioVertList) = 1;
ff2 = and(ff1,fc);
av2 = allVerts(ff2,:);
figure(1);p1 = plot3(av2(:,1),av2(:,2),-1*av2(:,3),'r.');hold on;set(p1,'MarkerSize',1);

av3 = allVerts(insideBarrelVerts,:);
figure(1);p1 = plot3(av3(:,1),av3(:,2),-1*av3(:,3),'b.');hold on;set(p1,'MarkerSize',1);

