

strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
numTips = length(stallMatrix);
stallRatioList = myParameters.stallRatioList;
stopCountingNumStalls = myParameters.stopCountingNumStalls;
numStallRatio = length(stallRatioList);

tipChoice =18;
occlusionStrandID = vectorProject.vectorizedStructure.plungingArterioleTipList(tipChoice);

stallRatioChoice = 5;
stallIDList = stallIDMatrix{tipChoice};
stallIDList = stallIDList(stallRatioChoice,:);
numRepeats = numel(stallIDList);
for repeatIter = 1:numRepeats,
    thisStallIDList = stallIDList{repeatIter};
    if isempty(thisStallIDList),
        break%break out of repeatIter loop
    end%if isempty...
    maxStallIDList = stallIDList{repeatIter};
end%for repeatIter..


    

            f1 = figure(1);
            set(f1,'DoubleBuffer','on');
            clf
            y1 = 0; y2 = inf;
            x1 = 0; x2 = inf;
            z1 = 0; z2 = inf;
            % zo = 700; dz = 100; z1 = zo-dz;z2 = zo+dz;
            %Plot decreased flow as as shades of blue
                activeStrands = maxStallIDList;
                activeIndices = [strands(activeStrands).StartToEndIndices];
                av = vertices.AllVerts;
                activeCoords = [vertices.AllVerts(activeIndices,:)];
                av = av(activeIndices,:);
                activeCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
                p1 = plot3(activeCoords(:,1),activeCoords(:,2),-1*activeCoords(:,3),'b.');
                set(p1,'MarkerSize',1,'Color','blue');
                hold on
                
                
                occulsionIndices = [strands(occlusionStrandID).StartToEndIndices];
                occulsionCoords = [vertices.AllVerts(occulsionIndices,:)];
                av = vertices.AllVerts;
                av = av(occulsionIndices,:);
                occulsionCoords = av(and(and(and(av(:,1)>y1,av(:,1)<y2),and(av(:,2)>x1,av(:,2)<x2)),and(av(:,3)>z1,av(:,3)<z2)),:);
                p1 = plot3(occulsionCoords(:,1),occulsionCoords(:,2),-1*occulsionCoords(:,3),'g.');
                set(p1,'MarkerSize',2);
                hold off



    
%%
stepSize = 100;
bigBlock = zeros(ceil(maskSize/stepSize));
halfStep = (stepSize/2);
counter = 0;
stallRatio = zeros(1,10000);
yCenterList = [halfStep:stepSize:maskSize(1)-halfStep];
xCenterList = [halfStep:stepSize:maskSize(2)-halfStep];
zCenterList = [halfStep:stepSize:maskSize(3)-halfStep];
for yIter = 1:numel(yCenterList);
    yCenter = yCenterList(yIter);
    y1 = yCenter - halfStep;
    y2 = yCenter +  halfStep;
    av = vertices.AllVerts;
    f1 = and(av(:,1)>y1,av(:,1)<y2);
    for xIter = 1:numel(xCenterList);
        xCenter = xCenterList(xIter);
        x1 = xCenter - halfStep;
        x2 = xCenter +  halfStep;
        av = vertices.AllVerts;
        f2 = and(av(:,2)>x1,av(:,2)<x2);
        for zIter = 1:numel(zCenterList);
            zCenter = zCenterList(zIter);
            z1 = zCenter - halfStep;
            z2 = zCenter +  halfStep;
            av = vertices.AllVerts;
            f3 = and(av(:,3)>z1,av(:,3)<z2);
            %---
            av = vertices.AllVerts;
            fAll = and(and(f1,f2),f3);
            numActiveCoords = sum(fAll);
            %---
            if numActiveCoords >0,
                activeStrands = maxStallIDList;
                activeIndices = unique([strands(activeStrands).StartToEndIndices]);
                f4 = false(size(vertices.AllRadii));
                f4(activeIndices) = 1;
                fAll = and(and(and(f1,f2),f3),f4);
                numStallCoords = sum(fAll);
                if numStallCoords >0,
                    disp([yCenter,xCenter,zCenter,numStallCoords/numActiveCoords]);
                end%if numStallCoords >0
                counter = counter+1;
                stallRatio(counter) = numStallCoords/numActiveCoords;
                bigBlock(yIter,xIter,zIter) = numStallCoords/numActiveCoords;
            end%if numActiveCoords>0
        end%for zIter
    end%for xIter
end%for yIter
stallRatio = stallRatio(1:counter);


ff = find(bigBlock>0.5);
bigBlockSize = size(bigBlock);
p2 = plot3(0,0,0,'w.');hold on
p2 = plot3(bigBlockSize(1),bigBlockSize(2),-1*bigBlockSize(3),'w.');
[yList,xList,zList] = ind2sub(size(bigBlock),ff);
figure(2);
p2 = plot3(yList,xList,-1*zList,'ro');
set(p2,'MarkerSize',48);
hold off



%%


strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
numTips = length(stallMatrix);
stallRatioList = myParameters.stallRatioList;
stopCountingNumStalls = myParameters.stopCountingNumStalls;
numStallRatio = length(stallRatioList);


arterioleTipList = vectorProject.vectorizedStructure.plungingArterioleTipList;
venuleTipList = vectorProject.vectorizedStructure.plungingVenuleTipList;

arterioleCurrentList = abs([strands(arterioleTipList).strandCurrent]);
venuleCurrentList = abs([strands(venuleTipList).strandCurrent]);

figure(1);plot(arterioleCurrentList,'r.');hold on
figure(1);plot(venuleCurrentList,'b.');hold off


load('IterateDamageFromSingleOcclusionResults.mat')
volumePerStrand = prod(maskSize)/numel(strands);
arterioleCystDiameter = [];
numTips = numel(stallMatrix);
for tipIter = 1:numTips,
    for stallRatioIter = 1:numStallRatio,
        stallCurves = stallMatrix{tipIter};
        thisCurve = stallCurves(stallRatioIter,:);
        maxStalls = max(thisCurve);
        cystVol = maxStalls * volumePerStrand;
        arterioleCystDiameter(tipIter,stallRatioIter) = 2*(cystVol*(0.75/pi))^0.333;
    end
end

load('IterateDamageFromSingleOcclusionVenuleResults.mat')
volumePerStrand = prod(maskSize)/numel(strands);
venuleCystDiameter = [];
numTips = numel(stallMatrix);
for tipIter = 1:numTips,
    for stallRatioIter = 1:numStallRatio,
        stallCurves = stallMatrix{tipIter};
        thisCurve = stallCurves(stallRatioIter,:);
        maxStalls = max(thisCurve);
        cystVol = maxStalls * volumePerStrand;
        venuleCystDiameter(tipIter,stallRatioIter) = 2*(cystVol*(0.75/pi))^0.333;
    end
end



aCyst = arterioleCystDiameter(:,4)';
vCyst = venuleCystDiameter(:,4)';

figure(2);plot(arterioleCurrentList,aCyst,'r.');hold on
figure(2);plot(venuleCurrentList,vCyst,'b.');hold off


     
     





                