% % mypics = loadmovie;

divFactor = 3;

L = bwlabeln(mypics);
numBarrels = max(L(:));
maskSize = size(mypics);


for barrelIter = 1:numBarrels,
    disp(barrelIter);
    thisMask = L==barrelIter;
    [by,bx,bz] = ind2sub(maskSize,find(thisMask));
    minZ = min(bz);
    maxZ = max(bz);
    pointList = [];
    for zIter = minZ:maxZ,
        thisFrame = thisMask(:,:,zIter);
        erodeFrame = imerode(thisFrame,ones(3,3));
        shellFrame = (thisFrame-erodeFrame)>0;
        frameL = bwlabel(shellFrame);
        myprop = regionprops(frameL,'PixelList');
        myPixelList = fliplr(myprop.PixelList);
        pointList = [pointList;[myPixelList,repmat(zIter,[size(myPixelList,1),1])]];
    end
    barrels{barrelIter} = pointList*divFactor;
end
        
save barrelOutlines.mat barrels

    
    
    
