restartFromScratchFlag = 0;

if restartFromScratchFlag == 1,

    cd('F:\Phil\ForFromPeople\Joyce\CX06')
    load('F:\Phil\ForFromPeople\Joyce\CX06\SE2-2012_10_02-14_07_59-Mod-StrandEdit2-CX06_pbEH-LargestSubgraph-Flow.mat')
    load('F:\Phil\ForFromPeople\Joyce\CX06\CX06_barrels.mat')
    oldBarrels = barrels;

    maskSize = globalDataStruct.maskSize;
    frameSize = maskSize(1:2);
    cpMatrix = globalDataStruct.cpMatrix;
    strands = globalDataStruct.strands;
    strandRadiusList = [strands(:).MedianRadius];
    strandIndices = globalDataStruct.strandIndices;


    userTraced = [];
    for barrelIter = 1:numel(oldBarrels)
        userTraced{barrelIter} = oldBarrels(barrelIter).userTraced;
    end


    numBarrels = numel(userTraced);
    for barrelIter = 1:numBarrels,
        barrelPoints = userTraced{barrelIter}.top;
        barrelPoints = [barrelPoints(:,2),barrelPoints(:,1),barrelPoints(:,3)];%flip barrel coords from userTraceds
        diffFlag = sum(abs(diff(barrelPoints)),2)>0;
        barrelPoints = barrelPoints(diffFlag,:);
        barrelPoints(end+1,:) = barrelPoints(1,:);
        barrelCoordList = [];
        for pointIter = 1:size(barrelPoints,1)-1;
            startCoord = barrelPoints(pointIter,:);
            stopCoord = barrelPoints(pointIter+1,:);
            coordDiff = stopCoord-startCoord;
            longestSep = max(abs(coordDiff));
            numInterpPoints = ceil(longestSep)+1;
            cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
            cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
            cc3 = linspace(startCoord(3),stopCoord(3),numInterpPoints);
            lineCoords = round([cc1',cc2',cc3']);
            barrelCoordList = [barrelCoordList;lineCoords];
        end%for pointIter...
        figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
    end%for barrelIter...

    %---

    myFrame = zeros(maskSize(1),maskSize(2));
    barrels = [];
    barrelZMin = inf;
    barrelZMax = 0;

    numBarrels = numel(userTraced);
    for barrelIter = 1:numBarrels,
        barrelPoints = userTraced{barrelIter}.top;
        barrelPoints = [barrelPoints(:,2),barrelPoints(:,1),barrelPoints(:,3)];%flip barrel coords from userTraced
        diffFlag = sum(abs(diff(barrelPoints)),2)>0;
        barrelPoints = barrelPoints(diffFlag,:);
        barrelPoints(end+1,:) = barrelPoints(1,:);
        barrelCoordList = zeros(100000,3);
        barrelZ1 = round(min(barrelPoints(:,3)));
        barrelBottom = userTraced{barrelIter}.bottom;
        barrelZ2 = round(max(barrelBottom(:,3)));
        counter = 0;
        for pointIter = 1:size(barrelPoints,1)-1;
            startCoord = barrelPoints(pointIter,:);
            stopCoord = barrelPoints(pointIter+1,:);
            coordDiff = stopCoord-startCoord;
            longestSep = max(abs(coordDiff));
            numInterpPoints = ceil(longestSep)+1;
            cc1 = linspace(startCoord(1),stopCoord(1),numInterpPoints);
            cc2 = linspace(startCoord(2),stopCoord(2),numInterpPoints);
            numCC = numel(cc1);
            for zIter = barrelZ1:barrelZ2,
                cc3 = zeros(size(cc2))+zIter;
                lineCoords = round([cc1',cc2',cc3']);
                barrelCoordList(counter+1:counter+numCC,:) = lineCoords;
                counter = counter+numCC;
            end%for zIter... 
        end%for pointIter...
        barrelCoordList = barrelCoordList(1:counter,:);
        barrels{barrelIter} = barrelCoordList;
        barrelZMin = min(barrelZMin, min(barrelCoordList(:,3)));
        barrelZMax = max(barrelZMax, max(barrelCoordList(:,3)));
        figure(1);plot(barrelCoordList(:,1),barrelCoordList(:,2),'r.');hold on
        pixelList = sub2ind([maskSize(1),maskSize(2)],barrelCoordList(:,1),barrelCoordList(:,2));
        myFrame(pixelList)=1;
    end%for barrelIter...
    hold off
    figure(2);imagesc(myFrame)
    fillFrame = imfill(myFrame,'holes');
    figure(3);imagesc(fillFrame)
    layer4FrameBarrel = myFrame;



    %%
    fillFrame = imfill(layer4FrameBarrel,'holes');
    openFrame = imopen(fillFrame,ones(3,3));
    barrelInteriorFrame = imerode(openFrame,ones(3,3));
    barrelEdgeFrame = openFrame-barrelInteriorFrame;



    %%
    %Make a mask to trim regions that are far away from any barrel boundary


    dilationSize = 11;
    numIter = 12;
    dilatedFrame = barrelInteriorFrame;
    for kk = 1:numIter,
        dilatedFrame = imdilate(dilatedFrame,circle2d(dilationSize));
    end
    dilatedFrame = imfill(dilatedFrame,'holes');
    figure(1);imagesc(barrelInteriorFrame);
    figure(2);imagesc(dilatedFrame);
    erodedFrame = dilatedFrame;
    erodedFrame(1,:) = 0;
    erodedFrame(end,:) = 0;
    erodedFrame(:,1) = 0;
    erodedFrame(:,end) = 0;

    numIter = 9;
    for kk = 1:numIter,
        erodedFrame = imerode(erodedFrame,circle2d(dilationSize));
    end
    figure(3);imagesc(erodedFrame);

    clear numIter dilationSize




    %%
    %Calculate a normalized distance map inside and outside of the barrels


    figure(11);imagesc(barrelInteriorFrame);
    fullResultFrame = ones(size(barrelInteriorFrame));
    bwFrame = bwdist(barrelInteriorFrame);
    figure(22);imagesc(bwFrame);
    L = watershed(bwFrame);
    L(1:end,1) = 0;
    L(1:end,end) = 0;
    L(1,1:end) = 0;
    L(end,1:end) = 0;

    figure(13);imagesc(L);
    figure(14);imagesc(L==0);
    bwl = bwlabel(barrelInteriorFrame);

    numObjects = max(bwl(:));
    for objIter = 1:numObjects,
        thisObject = bwl==objIter;
        figure(2);imagesc(thisObject);
        thisEdge = thisObject - imerode(thisObject,ones(3,3));
        figure(3);imagesc(thisEdge);
        props = regionprops(bwl,'Centroid','PixelList');
        yc = round(props(objIter).Centroid(2));
        xc = round(props(objIter).Centroid(1));
        allPixelList = props(objIter).PixelList;
        allX = allPixelList(:,1);
        allY = allPixelList(:,2);
        [fullX,fullY] = meshgrid(1-xc:size(thisObject,2)-xc,1-yc:size(thisObject,1)-yc);
        fullR = sqrt(fullX.^2 + fullY.^2);
        allR = fullR(sub2ind(size(thisObject),allY,allX));
        figure(4);imagesc(fullR);
        bwle = bwlabel(thisEdge);
        propsE = regionprops(bwle,'PixelList','PixelIdxList');
        edgePixelList = propsE(1).PixelList;
        edgePixelIDList = propsE(1).PixelIdxList;
        edgeXList = edgePixelList(:,1);
        edgeYList = edgePixelList(:,2);
        dx = edgeXList-xc;
        dy = edgeYList-yc;
        edgeRList = sqrt(dx.^2+dy.^2);
        numPixels = numel(allX);
        numEdge = numel(edgeXList);
        sortedEdgePixelList = flipud(sortrows([edgeYList,edgeXList,edgeRList],3));

        maxEdgeFrame = zeros(size(thisObject));
        maxEdgeFrame(sub2ind(size(thisObject),edgeYList,edgeXList)) = edgeRList;
        for kk = 1:numEdge,
            ey = round(sortedEdgePixelList(kk,1));
            ex = round(sortedEdgePixelList(kk,2));
            er = sortedEdgePixelList(kk,3);
            dy = ey -yc;
            dx = ex -xc;
            if abs(dy)>abs(dx),
                pyList = [yc:sign(dy):ey];
                pxList = round(linspace(xc,ex,numel(pyList)));
            else
                pxList = [xc:sign(dx):ex]; 
                pyList = round(linspace(yc,ey,numel(pxList)));
            end
            maxEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = er;
        end%for kk = 1:numPixels
        figure(5);imagesc(maxEdgeFrame);

        effRadius = fullR.*thisObject./maxEdgeFrame;
        figure(6);imagesc(effRadius);
        numErrors = numel(find(maxEdgeFrame(thisObject)==0))



        wsVal = unique(L(thisObject));
        thisWS = L==wsVal;
        thisWS = thisWS .* dilatedFrame;
        thisWSEdge = thisWS - imerode(thisWS,ones(3,3));

        figure(3);imagesc(thisWSEdge);

        bwWSe = bwlabel(thisWSEdge);
        propsWSE = regionprops(bwWSe,'PixelList','PixelIdxList');
        wsEdgePixelList = propsWSE(1).PixelList;
        wsEdgePixelIDList = propsWSE(1).PixelIdxList;
        wsEdgeXList = wsEdgePixelList(:,1);
        wsEdgeYList = wsEdgePixelList(:,2);
        dx = wsEdgeXList-xc;
        dy = wsEdgeYList-yc;
        wsEdgeRList = sqrt(dx.^2+dy.^2);
        numWSEdge = numel(wsEdgeXList);
        sortedWSEdgePixelList = flipud(sortrows([wsEdgeYList,wsEdgeXList,wsEdgeRList],3));


        q = zeros(kk,1);
        maxWSEdgeFrame = zeros(size(thisObject));
        maxWSEdgeFrame(sub2ind(size(thisObject),wsEdgeYList,wsEdgeXList)) = wsEdgeRList;
        for kk = 1:numWSEdge,
            ey = round(sortedWSEdgePixelList(kk,1));
            ex = round(sortedWSEdgePixelList(kk,2));
            er = sortedWSEdgePixelList(kk,3);
            dy = ey -yc;
            dx = ex -xc;
            if abs(dy)>abs(dx),
                pyList = [yc:sign(dy):ey];
                pxList = round(linspace(xc,ex,numel(pyList)));
            else
                pxList = [xc:sign(dx):ex]; 
                pyList = round(linspace(yc,ey,numel(pxList)));
            end
            %Now, find the point where this vector crosses the barrelEdge
            idList = sub2ind(size(thisObject),pyList,pxList);
            crossFlagList = ismember(idList,edgePixelIDList);
            if sum(crossFlagList)>0,
                crossPoint = find(crossFlagList);
                pyList = pyList(crossPoint(1):end);
                pxList = pxList(crossPoint(1):end);
                normRList = linspace(0,1,numel(pyList));
                maxWSEdgeFrame(sub2ind(size(thisObject),pyList,pxList)) = normRList;
            else
                disp('No Cross');
                keyboard
            end

        end%for kk = 1:numPixels
        figure(5);imagesc(maxWSEdgeFrame);
        fullResultFrame(thisWS>0) = maxWSEdgeFrame(thisWS>0);
        fullResultFrame(thisObject) = effRadius(thisObject)-1;
        figure(9);imagesc(fullResultFrame);
    end%for objIter...


    clear objIter thisObject thisWS maxWSEdgeFrame  thisEdge thisWSEdge
    clear props propsE propsWSE pxList pyList xc yc wsVal wsEdge*
    clear sortedEdgePixelList sortedWSEdgePixelList
    clear normRList idList fullY fullX edgePixelList
    clear edgeRList edgeXList edgeYList edgePixelIDList edgePixelID
    clear dx dy er ex ey fullR kk maxEdgeFrame numErrors numObjects numPixels numWSEdge
    clear crossPoint crossFlagList bwle bwl bwFrame L  aPixelList allR allX allY bwWSe
    clear allPixelList effRadius

    radiusList = globalDataStruct.allRadii;
    
else%if restartFromScratchFlag == 1,    
   load('F:\Phil\ForFromPeople\Joyce\CX06\ShortResult2_AnalyzeVesselsVersusBarrels_CX06.mat')
end%if restartFromScratchFlag == 1,    
%%
%Evaluate the plunging vessels


minRadius = 0;

filtSize = 1;

strandIndexList = strandIndices(:,1);

for kk = 1:numel(strandIndexList),
    radiusList(kk) = strandRadiusList(strandIndexList(kk));
end

z1 = barrelZMin;
z2 = barrelZMax;

midZ = round((z1+z2)/2)+ 00;

z1 = midZ-1;
z2 = midZ+1;

% z1 = barrelZMin-1;
% z2 = barrelZMin+1;



%cpMatrix(:,6) = activeFlag
saPoints = find(and(cpMatrix(:,6)==1,ismember(cpMatrix(:,7),[330:331,333:339])));
svPoints = find(and(cpMatrix(:,6)==1,ismember(cpMatrix(:,7),[340:341,343:349])));
paPoints = find(and(cpMatrix(:,6)==1,ismember(cpMatrix(:,7),[660:669,4320])));
pvPoints = find(and(cpMatrix(:,6)==1,ismember(cpMatrix(:,7),[770:779,4420])));

saCoords = [cpMatrix(saPoints,1:3),radiusList(saPoints)];
svCoords = [cpMatrix(svPoints,1:3),radiusList(svPoints)];
paCoords = [cpMatrix(paPoints,1:3),radiusList(paPoints)];
pvCoords = [cpMatrix(pvPoints,1:3),radiusList(pvPoints)];

layer4FrameArtery = zeros(frameSize);
layer4FrameVein = zeros(frameSize);


layer4paCoords = paCoords(and(and(paCoords(:,3)>z1,paCoords(:,3)<z2),paCoords(:,4)>=minRadius),:);
layer4pvCoords = pvCoords(and(and(pvCoords(:,3)>z1,pvCoords(:,3)<z2),pvCoords(:,4)>=minRadius),:);

layer4FrameArtery(sub2ind(frameSize,layer4paCoords(:,1),layer4paCoords(:,2))) = 1;
layer4FrameVein(sub2ind(frameSize,layer4pvCoords(:,1),layer4pvCoords(:,2))) = 1;


    myFilter = double(circle2d(17));
    layer4FiltFrameBarrel = imfilter(layer4FrameBarrel,myFilter);
    layer4FiltFrameArtery = imfilter(layer4FrameArtery,myFilter);
    layer4FiltFrameVein = imfilter(layer4FrameVein,myFilter);


rFrame = ones(frameSize);
gFrame = ones(frameSize);
bFrame = ones(frameSize);
rFrame(layer4FiltFrameBarrel>0) = 0;
bFrame(layer4FiltFrameBarrel>0) = 0;
gFrame(layer4FiltFrameArtery>0) = 0;
bFrame(layer4FiltFrameArtery>0) = 0;
rFrame(layer4FiltFrameVein>0) = 0;
gFrame(layer4FiltFrameVein>0) = 0;

layer4RGB = zeros([frameSize,3]);
layer4RGB(:,:,1) = rFrame;
layer4RGB(:,:,2) = gFrame;
layer4RGB(:,:,3) = bFrame;

 figure(4);imagesc(layer4RGB)
%% 
figure(5);
plot(saCoords(:,1),saCoords(:,2),'r.');hold on
plot(svCoords(:,1),svCoords(:,2),'b.');
[by,bx] = ind2sub(frameSize,find(barrelEdgeFrame>0));
plot(by,bx,'k.');hold off
axis image

%%
%

%Pick a center point for each plunging vessel.
L = bwlabel(layer4FrameArtery>0);
centroidList = regionprops(L,'Centroid');
aCoordList = [];
for kk = 1:numel(centroidList)
    aCoordList(kk,:) = round(centroidList(kk).Centroid);
end

L = bwlabel(layer4FrameVein>0);
centroidList = regionprops(L,'Centroid');
vCoordList = [];
for kk = 1:numel(centroidList)
    vCoordList(kk,:) = round(centroidList(kk).Centroid);
end
    
%REMEMBER, regionprops Centroid list give XY not YX
arterioleFrame = zeros(frameSize);
for kk = 1:size(aCoordList,1);
    arterioleFrame(aCoordList(kk,2),aCoordList(kk,1)) = 1;
end
venuleFrame = zeros(frameSize);
for kk = 1:size(vCoordList,1);
    venuleFrame(vCoordList(kk,2),vCoordList(kk,1)) = 1;
end



%%
rFrame = ones(frameSize);
gFrame = ones(frameSize);
bFrame = ones(frameSize);
bf = imfilter(barrelEdgeFrame,double(circle2d(filtSize)));
af = imfilter(arterioleFrame,double(circle2d(filtSize)));
vf = imfilter(venuleFrame,double(circle2d(filtSize)));

rFrame(bf>0) = 0;
bFrame(bf>0) = 0;
gFrame(af>0) = 0;
bFrame(af>0) = 0;
rFrame(vf>0) = 0;
gFrame(vf>0) = 0;

layer4RGB = zeros([frameSize,3]);
layer4RGB(:,:,1) = rFrame;
layer4RGB(:,:,2) = gFrame;
layer4RGB(:,:,3) = bFrame;

figure(44);imagesc(layer4RGB)


%%

croppedAFrame = arterioleFrame .* dilatedFrame;
croppedVFrame = venuleFrame .* dilatedFrame;
allValues = fullResultFrame(dilatedFrame>0);
aValues = fullResultFrame(croppedAFrame>0);
vValues = fullResultFrame(croppedVFrame>0);

stepSize = 0.4
hx = [-1:stepSize:1.5];
h1 = histc(allValues,hx);
h1 = h1./sum(h1);
figure(91);plot(hx,h1,'k-');hold on

hA = histc(aValues,hx);
hA = hA./sum(hA);
figure(91);plot(hx,hA,'r-');hold on

hV = histc(vValues,hx);
hV = hV./sum(hV);
figure(91);plot(hx,hV,'b-');hold on


hBoth = histc([aValues;vValues],hx);
hBoth = hBoth./sum(hBoth);
figure(91);plot(hx,hBoth,'g-');hold off

figure(101);plot(hx,hA./h1,'r--');hold on
figure(101);plot(hx,hV./h1,'b--');hold off
figure(102);plot(hx,hBoth./h1,'g--');

csBoth = cumsum(hBoth./h1);
csA = cumsum(hA./h1);
csV = cumsum(hV./h1);
% figure(103);plot(hx,csBoth'./[1:numel(csBoth)],'m');
figure(104);plot(hx,cumsum(hBoth)./cumsum(h1),'go');
figure(105);plot(hx,cumsum(hA)./cumsum(h1),'ro');
figure(106);plot(hx,cumsum(hV)./cumsum(h1),'bo');

figure(202);b1 = bar(hx,hA./h1);set(b1,'FaceColor','red');
figure(203);b2 = bar(hx,hV./h1);set(b2,'FaceColor','blue');



%%

clear L af bf vf arterioleFrame venuleFrame bFrame gFrame rFrame barrelInteriorFrame
clear croppedAFrame croppedVFrame erodedFrame fillFrame layer4FrameArtery layer4FrameVein
clear layer4FrameVein layer4FrameFilt* layer4RGB myFrame openFrame q strands


cd('F:\Phil\ForFromPeople\Joyce\CX06')
save('0plus_AnalyzeVesselsVersusBarrels_CX06b');

% save('ShortResult2_AnalyzeVesselsVersusBarrels_CX06.mat');
