% cd('F:\Phil\VectorProjects')
% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')
 

allClosest1 = [];
allClosest3 = [];
allClosest6 = [];



%%


setIDNum = 4;


switch setIDNum,
    case 1, vectorProject = allProject.au;dataSetName = 'AU';
    case 2, vectorProject = allProject.av;dataSetName = 'AV';
    case 3, vectorProject = allProject.co;dataSetName = 'CO';
    case 4, vectorProject = allProject.db;dataSetName = 'DB';
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
strandLengthList = vectorizedStructure.strandLengthList;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
allPlungingVenuleStrandList = [allPlungingVenulePathList{:}];
allStrandLabelList = [strands(:).MedianLabel];
allSurfaceStrandList = find(ismember(allStrandLabelList,[300:399]));
stopStrandList = [allPlungingVenuleStrandList, allSurfaceStrandList];
numStrands = numel(strands);
strandMidYXZList = vectorizedStructure.strandMidYXZList;


z1 = 400;
z2 = 600;

arterioleCCList = [];
for arterioleIter = 1:numel(allPlungingArteriolePathList);
    thisArterioleList = allPlungingArteriolePathList{arterioleIter};
    thisArterioleCC = mean(strandMidYXZList(thisArterioleList,:),1);
    arterioleCCList(arterioleIter,:) = thisArterioleCC;
end

venuleCCList = [];
for venuleIter = 1:numel(allPlungingVenulePathList);
    thisVenuleList = allPlungingVenulePathList{venuleIter};
    thisVenuleCC = mean(strandMidYXZList(thisVenuleList,:));
    venuleCCList(venuleIter,:) = thisVenuleCC;
end


 
%For each arteriole, find the xy distance to all venules (using median XY positions)
%For each arteriole, find all the outlets within the specified depth range
%Go one outlet at a time, and track out flow-wise until a venule is hit.
numArteriole = numel(allPlungingArteriolePathList)
for arterioleIter = 11:numArteriole
    disp('New Arteriole');
    disp([arterioleIter,numArteriole]);
    
    thisArterioleCC = arterioleCCList(arterioleIter,:);
    sep1 = venuleCCList(:,1) - thisArterioleCC(1);
    sep2 = venuleCCList(:,2) - thisArterioleCC(2);
    avSepList = sqrt(sep1.^2 + sep2.^2);
    
    arteriolePath = allPlungingArteriolePathList{arterioleIter};
    startVertexNeighborList = [strands(arteriolePath).StartVertexNeighborStrands];
    endVertexNeighborList = [strands(arteriolePath).EndVertexNeighborStrands];
    allNeighborList = [startVertexNeighborList,endVertexNeighborList];
    outletStrandList = unique(allNeighborList(~ismember(allNeighborList,[arteriolePath,allSurfaceStrandList])));
    attachedVertexList = [];
    for outletIter = 1:numel(outletStrandList),
        thisOutlet = outletStrandList(outletIter);
        thisOutletStrand = strands(thisOutlet);
        if max(ismember(thisOutletStrand.StartVertexNeighborStrands,arteriolePath))>0,
            attachedVertexList(outletIter) = thisOutletStrand.StartVertexIndex;
        else%if max(ismember....
            attachedVertexList(outletIter) = thisOutletStrand.EndVertexIndex;
        end%if max(ismemember...
    end
    attachedVertexListZ = allVerts(attachedVertexList,3);
    
    zFlagList = and(attachedVertexListZ>=z1,attachedVertexListZ<=z2);
    baseStrandIDList = outletStrandList(zFlagList);
    baseCurrentList = abs([strands(baseStrandIDList).strandCurrent]);
    numBaseStrands = numel(baseStrandIDList);
    
    if numBaseStrands>0,
    
        numVertices = numel(vertices.AllRadii);
        tofStruct = []; %timeOfFlight dataStruct
        tofStruct(numStrands).currentList = [];
        tofStruct(numStrands).startTimeList = [];

        maxBranchSearch = 30;%Hardcode
        stopVoltage = 50.1;%Hardcode;
        minimumFluxFraction = 1/3000;%Hardcode

        downstreamPathList = [];
        downstreamFractionList = [];
        downstreamBranchList = zeros(numStrands,numel(baseStrandIDList)) + Inf;
        transitTimeList = zeros(numStrands,1);



        for baseStrandIter = 1:numBaseStrands;
            disp([baseStrandIter,numBaseStrands]);
            endTimeList = zeros(numStrands,1);
            baseStrandID = baseStrandIDList(baseStrandIter);
            baseStrand = strands(baseStrandID);
            bsiv = baseStrand.InteriorVertices;
            baseStrandCoordList = vertices.AllVerts(bsiv,:);
            strandNodes = [baseStrand.StartVertexIndex,baseStrand.EndVertexIndex];
            nodeVoltages = vertices.AllVoltages(strandNodes);
            [highVoltage,highVoltagePos] = max(nodeVoltages);
            [lowVoltage,lowVoltagePos] = min(nodeVoltages);
            highNode = strandNodes(highVoltagePos);
            lowNode = strandNodes(strandNodes~=highNode);

            pathActiveFlagList = false(1,100000);
            pathActiveFlagList(1) = 1;
            numActivePath = sum(pathActiveFlagList);
            strandPathList = {};
            nodePathList = {};
            fractionPathList = {};
            strandPathList{1} = baseStrandID;
            nodePathList{1} = [highNode lowNode];
            fractionPathList{1} = 1;
            strandFlowList = zeros(numStrands,1);
            strandFlowList(baseStrandID) = 1;
            strandVoltageList = zeros(numStrands,1);
            strandVoltageList(1) = mean([highVoltage,lowVoltage]);
            pathCounter = 1;
            keepGoingFlag = 1;
            branchCounter = 0;
            %---
            baseStrandCurrent = abs(baseStrand.strandCurrent);
            strandRadius = baseStrand.MedianRadius;
            tofStruct(baseStrandID).currentList = baseStrandCurrent;
            tofStruct(baseStrandID).startTimeList = 0;
            strandLength = strandLengthList(baseStrandID);
            timeOfFlight = 1;


            transitTimeList(baseStrandID) = timeOfFlight;
            endTimeList(baseStrandID) = timeOfFlight;

            while (keepGoingFlag == 1),
                myCount = 0;
                branchCounter = branchCounter+1;
                for pathIter = find(pathActiveFlagList == 1);

                    if rand(1)<0.01, disp(sum(pathActiveFlagList));end

                    currentPathID = pathIter;
                    currentStrandPath = strandPathList{pathIter};
                    currentNodePath = nodePathList{pathIter};
                    currentFractionPath = fractionPathList{pathIter};
                    currentStrandID = currentStrandPath(end);
                    currentStrand = strands(currentStrandID);
                    %-----
                    strandNodes = [currentStrand.StartVertexIndex,currentStrand.EndVertexIndex];
                    nodeVoltages = vertices.AllVoltages(strandNodes);
                    [highVoltage,highVoltagePos] = max(nodeVoltages);
                    [lowVoltage,lowVoltagePos] = min(nodeVoltages);
                    highNode = strandNodes(highVoltagePos);
                    lowNode = strandNodes(strandNodes~=highNode);
                    lowAttachedStrands = vertices.StrandIndices(lowNode,:);
                    lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=0);
                    lowAttachedStrands = lowAttachedStrands(lowAttachedStrands~=currentStrandID);
                    numDaughterPaths = numel(lowAttachedStrands);
                    strandVoltageList(currentStrandID) = mean([highVoltage,lowVoltage]);
                    stopTracingFlag = 0;
                    if numDaughterPaths == 0, stopTracingFlag = 1; end
                    if lowVoltage < stopVoltage, stopTracingFlag = 1; end
                    if currentFractionPath(end) < minimumFluxFraction, stopTracingFlag = 1; end
                    if ismember(currentStrandPath(end),stopStrandList), stopTracingFlag = 1; end
                    if stopTracingFlag == 1,
                        pathActiveFlagList(currentPathID) = 0;
                    else%if stopTracingFlag == 1,
                        motherCurrent = abs(currentStrand.strandCurrent);
                        validDaughterCounter = 0;
                        validDaughterStrandList = [];
                        validDaughterCurrentList = zeros(1,numDaughterPaths);
                        validDaughterPathIndexList = [];
                        for daughterIter = 1:numDaughterPaths,
                            %Check to see if the daughter strand leads to a lower voltage
                            candidateDaughterID = lowAttachedStrands(daughterIter);
                            candidateDaughterStrand = strands(candidateDaughterID);
                            candidateDaughterNodes = [candidateDaughterStrand.StartVertexIndex,candidateDaughterStrand.EndVertexIndex];
                            candidateDaughterOtherNode = candidateDaughterNodes(candidateDaughterNodes~=lowNode);
                            candidateDaughterOtherVoltage = vertices.AllVoltages(candidateDaughterOtherNode);
                            if candidateDaughterOtherVoltage < lowVoltage,
                                %if so, add the strand to a path
                                myCount = myCount + 1;
                                validDaughterCounter = validDaughterCounter + 1;
                                validDaughterStrandList(validDaughterCounter) = candidateDaughterID;
                                validDaughterCurrentList(validDaughterCounter) = abs(candidateDaughterStrand.strandCurrent);
                                if validDaughterCounter == 1,
                                    %if this is the first valid daughter, add to current path
                                    strandPathList{currentPathID} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                    nodePathList{currentPathID} = [currentNodePath, candidateDaughterOtherNode];
                                    validDaughterPathIndexList(1) = currentPathID;
                                else%if validDaughterCounter == 1,
                                    %if not the first daughter, duplicate path up to this point, and
                                    %make new path
                                    pathCounter = pathCounter + 1;
                                    strandPathList{pathCounter} = [currentStrandPath, lowAttachedStrands(daughterIter)];
                                    nodePathList{pathCounter} = [currentNodePath, candidateDaughterOtherNode];
                                    fractionPathList{pathCounter} = currentFractionPath;
                                    pathActiveFlagList(pathCounter) = 1;  
                                    validDaughterPathIndexList(validDaughterCounter) = pathCounter;
                                end%if-else validDaughterCounter == 1,
                            end%if candidateDaughterOtherVoltage < lowVoltage,
                        end%for daughterIter = 1:numDaughterPaths,
                        clear daughterIter
                        %-----
                        daughterSumCurrent = sum(validDaughterCurrentList);
                        fractionalDaughterCurrent = validDaughterCurrentList./daughterSumCurrent;
                        for validDaughterIter = 1:validDaughterCounter;
                            validDaughterSegmentID = validDaughterStrandList(validDaughterIter);
                            validDaughterFraction = currentFractionPath(end).*fractionalDaughterCurrent(validDaughterIter);
                            fractionPathList{validDaughterPathIndexList(validDaughterIter)} = [currentFractionPath , validDaughterFraction];
                            strandFlowList(validDaughterSegmentID) = strandFlowList(validDaughterSegmentID) + validDaughterFraction;


                            strandRadius = strands(validDaughterSegmentID).MedianRadius;
                            currentList = [tofStruct(validDaughterSegmentID).currentList, baseStrandCurrent .* validDaughterFraction];
                            tofStruct(validDaughterSegmentID).currentList = currentList;
                            thisDaughterCurrent = abs(strands(validDaughterSegmentID).strandCurrent);
                            thisMotherEndTime = endTimeList(currentStrandID);
                            strandLength = strandLengthList(validDaughterSegmentID);
                            timeOfFlight = 1;


                            thisDaughterEndTime = thisMotherEndTime + timeOfFlight;
                            transitTimeList(validDaughterSegmentID) = timeOfFlight;
                            startTimeList = [tofStruct(validDaughterSegmentID).startTimeList, thisMotherEndTime];
                            tofStruct(validDaughterSegmentID).startTimeList = startTimeList;
                            endTimeList(validDaughterSegmentID) = thisDaughterEndTime;



                        end%for validDaughterIter = 1:validDaughterCounter;
                    end%if-else stopTracingFlag == 1,
                end%for pathIter = find(pathActiveFlagList == 1);
                if sum(pathActiveFlagList) == 0, keepGoingFlag = 0;end
                if myCount == 0, keepGoingFlag = 0;end
                if branchCounter >= maxBranchSearch, keepGoingFlag = 0; end
            end%while (keepGoingFlag == 1),
            downstreamPathList{baseStrandIter} = strandPathList;
            downstreamFractionList{baseStrandIter} = fractionPathList;

        end%for baseStrandIter = 1:numBaseStrands;



        thisArterioleOutletData = [];
        for baseStrandIter = 1:numBaseStrands
            thisBaseCurrent = baseCurrentList(baseStrandIter);
            thisPathSet = downstreamPathList{baseStrandIter};
            thisFractionSet = downstreamFractionList{baseStrandIter};
            numPaths = numel(thisPathSet);
            for pathIter = 1:numPaths;
                thisPath = thisPathSet{pathIter};
                thisFraction = thisFractionSet{pathIter};
                thisPathEnd = thisPath(end);
                thisPathCount = numel(thisPath);
                thisFractionEnd = thisFraction(end);
                thisArterioleOutletData = [thisArterioleOutletData;[thisPathEnd,thisPathCount,thisFractionEnd,thisBaseCurrent]];
            end%for pathIter
        end%for baseStrandIter        



        %find all the endPoints that were plungingVenules
        q1 = thisArterioleOutletData(:,1);
        q2 = thisArterioleOutletData(:,2);
        q3 = thisArterioleOutletData(:,3);
        q4 = thisArterioleOutletData(:,4);

        validEndFlag = ismember(q1,allPlungingVenuleStrandList);

        outletVenuleList = zeros(size(thisArterioleOutletData,1),1);
        outletSepList = zeros(size(thisArterioleOutletData,1),1);
        for venulePathIter = 1:numel(allPlungingVenulePathList),
            thisVenulePath = allPlungingVenulePathList{venulePathIter};
            thisVenuleFlagList = ismember(q1,thisVenulePath);
            outletVenuleList(thisVenuleFlagList) = venulePathIter;
        end
        outletSepList(validEndFlag) = avSepList(outletVenuleList(validEndFlag));
        figure(1);plot(q2(outletSepList>0),'b.');

        conciseOutletList = unique(outletVenuleList(outletVenuleList>0));
        numOutlets = numel(conciseOutletList);

        meanPathToOutletList = [];
        fluxToThisOutletList = [];
        pairSepList = [];
        for outletIter = 1:numOutlets,
            thisOutlet = conciseOutletList(outletIter);
            pairSepList(outletIter) = avSepList(thisOutlet);
            thisOutletFlagList = (outletVenuleList==thisOutlet);
            thisPathCountList = thisArterioleOutletData(thisOutletFlagList,2);
            thisPathFractionList = thisArterioleOutletData(thisOutletFlagList,3);
            thisBaseCurrentList = thisArterioleOutletData(thisOutletFlagList,4);
            thisOutputParticleList = thisPathFractionList.*thisBaseCurrentList;
            normParticleList = thisOutputParticleList./sum(thisOutputParticleList);
            meanPathToThisOutlet = sum(normParticleList.*thisPathCountList)
            meanPathToOutletList(outletIter) = meanPathToThisOutlet;
            fluxToThisOutletList(outletIter) = sum(thisOutputParticleList);
        end

        sortData = [pairSepList',meanPathToOutletList',fluxToThisOutletList'./sum(fluxToThisOutletList)];
        sortData = sortrows(sortData,3)


        closest1 = sortData(end,:);
        delta = min(size(sortData,1)-1,2);
        closest3 = sortData(end-delta:end,:);
        delta = min(size(sortData,1)-1,5);
        closest6 = sortData(end-delta:end,:);


        allClosest1 = [allClosest1;closest1];
        allClosest3 = [allClosest3;closest3];
        allClosest6 = [allClosest6;closest6];


    end%if numBaseStrands>0
    
end%for arterioleIter
    

save tempData_PathDistanceArteryToVein.mat

