% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);

% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')
 
setIDNum = 4;


switch setIDNum,
    case 1, vectorProject = allProject.au;
    case 2, vectorProject = allProject.av;
    case 3, vectorProject = allProject.co;
    case 4, vectorProject = allProject.db;
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;


cutName = shortName(3:end);
cutName = shortName;
eigenSetFileName = ['F:\Phil\VectorProjects\',lower(cutName),'AdjRadiiMinusPlungingEigen.mat']

if exist('eigenValues','var') && numel(eigenValues) == numel(floatingNodeIndexList),
    disp('EigenValues already loaded');
else
    disp('Loading EigenValues and EigenVectors');pause(0.1);
    load(eigenSetFileName);
end

numStrands = numel(strands);
numFloatingNodes = numel(floatingNodeIndexList);




normalizeStrandLengthFlag = 0;

%%

figure(1);hold off
figure(2);hold off
% % figure(7);hold off
% % figure(8);hold off

%Plot network resistance from a node as you track outward
midZ = 500;%
plusMinusZ = 200;%
numStartToUse = 100;%
numRandToUse = 10;
deltaX = 300;
deltaY = 300;
randNeighborChoiceFlag = 0;
furthestNeighborChoiceFlag = 1,
randSeed = 1;
maxPlotResistance = 2e-7;

maxPlotResistance = inf;

numSteps = 20;

allSlope = [];
allUsedStrandList = [];
actualStrandList = [];
allPathDistList = [];
allXYDistList = [];
allResList = [];
% % for midZ = 105:10:1400; disp(midZ);

rand('seed',1);
    
y1 = deltaY;y2 = maskSize(1)-y1;
x1 = deltaX;x2 = maskSize(2)-x1;

strandZList = vectorizedStructure.strandMidYXZList(:,3);
strandYList = vectorizedStructure.strandMidYXZList(:,1);
strandXList = vectorizedStructure.strandMidYXZList(:,2);

zFlagList = and(strandZList>=midZ-plusMinusZ,strandZList<=midZ+plusMinusZ);
yFlagList = and(strandYList>=y1,strandYList<=y2);
xFlagList = and(strandXList>=x1,strandXList<=x2);

thisZStrandList = find(and(and(zFlagList,yFlagList),xFlagList));
numStart = numel(thisZStrandList);

skipVal = ceil(numStart/numStartToUse);

for startNum = 1:skipVal:numStart,

    startingStrand = thisZStrandList(startNum);
    attachedStrandList1 = [strands([vectorizedStructure.allPlungingArterioleList,vectorizedStructure.allPlungingVenuleList]).StartVertexNeighborStrands];
    attachedStrandList2 = [strands([vectorizedStructure.allPlungingArterioleList,vectorizedStructure.allPlungingVenuleList]).EndVertexNeighborStrands];
    usedStrandList = unique([attachedStrandList1,attachedStrandList2,startingStrand]);


    vertex1ID = strands(startingStrand).StartVertexIndex;
    vertex2ID = strands(startingStrand).EndVertexIndex;
    nextNeighborList = strands(startingStrand).EndVertexNeighborStrands;
    nextNeighborList = nextNeighborList(nextNeighborList~=startingStrand);
    nextNeighborID = nextNeighborList(1);
    sep = allVerts(vertex1ID,:) - allVerts(vertex2ID,:);
    sepDist = sqrt(sum(sep.^2));

     
    % for aIter = 1:1,
    % for aIter = 1:numArterioleTips,
    %     myColor = myColorMap(mod(aIter*7,64)+1,:);
    thisStrandID = startingStrand;  
    resList = [];
    xyDistList = [];
     pathDistList = 0;
     oldSepDist = 0;
        for vIter = 1:numSteps,
            floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
            floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
            runSum = 0;
            mSize = size(eigenVectors,1);
            for iIter = 2:mSize;
                eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
                eVectorBeta = eigenVectors(floatingNode2ID,iIter);
                eVal = eigenValues(iIter);
                cutoff = -1;
                if eVal > cutoff,
                    if eVal~=0,
                    runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal))* 2.55e7;;
                    if isnan(runSum),disp('paused');pause;end
                    end%if eval~=0,
                end%if eval>cutoff
            end%for iIter;
            effectiveResistance = runSum;
            if isempty(effectiveResistance),effectiveResistance = inf;end

%             effectiveResistance = min(effectiveResistance,4e-7);
            resList(vIter) = effectiveResistance;
            xyDistList(vIter) = sepDist;
            
            thisPathLength = vectorizedStructure.strandLengthList(thisStrandID);
            if normalizeStrandLengthFlag == 1,
                thisPathLength = 1;
            end%if normalizeStrandLengthFlag == 1,
            pathDistList(vIter) = pathDistList(end) + thisPathLength;

            %----
            %Find next node
            previousStrandID = thisStrandID;
            thisStrandID = nextNeighborID;
            usedStrandList = [usedStrandList,thisStrandID];
            if ismember(previousStrandID,strands(thisStrandID).EndVertexNeighborStrands),
                vertex2ID = strands(thisStrandID).StartVertexIndex;
                nextNeighborList = strands(thisStrandID).StartVertexNeighborStrands;
            else%if ismember(previousStrandID,
                vertex2ID = strands(thisStrandID).EndVertexIndex;
                nextNeighborList = strands(thisStrandID).EndVertexNeighborStrands;
            end%if ismember(previousStrandID,

            nextNeighborList = nextNeighborList(~ismember(nextNeighborList,usedStrandList));
            if isempty(nextNeighborList),break;end
            
            nextNeighborChoice = 1;
            if randNeighborChoiceFlag == 1,
                nextNeighborChoice = round(rand(1)*numel(nextNeighborList)+0.5);
                nextNeighborChoice = min(numel(nextNeighborList),nextNeighborChoice);
            end%if randNeighborChoiceFlag == 1,
            
                       
            numNeighbors = numel(nextNeighborList);
            if furthestNeighborChoiceFlag == 1,
                nSepList = [];
                for kk = 1:numNeighbors,
                    nPoint = vectorizedStructure.strandMidYXZList(nextNeighborList(kk),:);
                    sep = allVerts(vertex1ID,:) - nPoint;
                    sepDist = sqrt(sum(sep.^2));
                    nSepList(kk) = sepDist;
                end
                [maxVal,maxPos] = max(nSepList);
                nextNeighborChoice = maxPos(1);
            end%if furthestNeighborChoiceFlag == 1,
            
            
            nextNeighborID = nextNeighborList(nextNeighborChoice);
            
% % % %             sep = allVerts(vertex1ID,:) - allVerts(vertex2ID,:);
% % % %             sepDist = sqrt(sum(sep.^2));
% % % %             
% % % %             keepGoingFlag = 1;
% % % %             if sepDist < oldSepDist,
% % % %                 nextNeighborChoice = mod(nextNeighborChoice+1,numel(nextNeighborList))+1;
% % % %                 nextNeighborID = nextNeighborList(nextNeighborChoice);
% % % %                 sep = allVerts(vertex1ID,:) - allVerts(vertex2ID,:);
% % % %                 sepDist = sqrt(sum(sep.^2));
% % % %                 if sepDist < oldSepDist,
% % % %                     keepGoingFlag = 0;
% % % %                 end;
% % % %             end
% % % %             oldSepDist = sepDist;
% % % %             
% % % %             if keepGoingFlag == 0, break;end;
            
            actualStrandList = [actualStrandList,thisStrandID];
        end%for vIter...
        
        
        numStrands = numel(strands);
        randSecondPointSkipSize = ceil(numel(floatingNodeIndexList)/numRandToUse);
        %Now supplement with random sampling of points
        startSeed = ceil(rand(1)*randSecondPointSkipSize);
        vertex1ID = strands(startingStrand).StartVertexIndex;
        for vIter = startSeed:randSecondPointSkipSize:numel(floatingNodeIndexList),
            floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
            floatingNode2ID = vIter;
            vertex2ID = floatingNodeIndexList(vIter);
            attachedStrands = strandIndices(vertex2ID,:);
            attachedStrands = attachedStrands(attachedStrands~=0);
            attachedLabels = [strands(attachedStrands).MedianLabel];
            if sum(ismember(attachedLabels,[300;499])) == 0,
            
            otherStrandID = strandIndices(vertex2ID,1);
            actualStrandList = [actualStrandList,otherStrandID];
            runSum = 0;
            mSize = size(eigenVectors,1);
            for iIter = 2:mSize;
                eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
                eVectorBeta = eigenVectors(floatingNode2ID,iIter);
                eVal = eigenValues(iIter);
                cutoff = -1;
                if eVal > cutoff,
                    runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal))* 2.55e7;;
                end
            end%for iIter;
            effectiveResistance = runSum;
            if isempty(effectiveResistance),effectiveResistance = inf;end

            sep = allVerts(vertex1ID,:) - allVerts(vertex2ID,:);
            sepDist = sqrt(sum(sep.^2));
            resList = [resList, effectiveResistance];
            xyDistList = [xyDistList, sepDist];
            pathDistList = [pathDistList, 0];
            
            end%if sum(ismember(attachedLabels,[300;499])) == 0,
       end%for vIter...

        

    resListCut = min(resList,maxPlotResistance);    
    plotString = 'r.';
    switch setIDNum,
        case 1, plotString = 'r.';
        case 2, plotString = 'g.';
        case 3, plotString = 'b.';
        case 4, plotString = 'm.';
    end%switch
    figure(1);plot(xyDistList,(resListCut),plotString);hold on
    xlabel('radial distance [um]'),ylabel('network resistance');
    figure(2);plot(pathDistList,(resListCut),'g.');hold on
    xlabel('pathlength distance [um]'),ylabel('network resistance');
    if normalizeStrandLengthFlag == 1, xlabel('numStrands');end
    allUsedStrandList = unique([allUsedStrandList,usedStrandList]);
    allPathDistList = [allPathDistList,pathDistList];
    allXYDistList = [allXYDistList,xyDistList];
    allResList = [allResList,resList];
    
    
    pause(0.01);
end%for startNum



%%


%Calc running median
sortData = sortrows([allPathDistList',allResList'],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medPathDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medPathDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(12);plot(allPathDistList,allResList,'g.');hold on
% figure(12);plot(medPathDistList,medResList,'k-');
% figure(12);plot([0,30],[modeStrandResistance, modeStrandResistance],'b-');hold off
xlabel('path distance along microvessel network');
if normalizeStrandLengthFlag == 1, xlabel('numStrands');end
ylabel('effective network resistance');
set(gca,'YLim',[0,maxPlotResistance],'XLim',[0,30]);
f1 = find(medPathDistList>=15);
m1 = median(medResList(f1));
figure(12);plot([0,30],[m1,m1],'b-');
myTitle = [shortName,' - blue line @ ',num2str(m1)];
title(myTitle)
for kk = 1:30,
    f1 = find(allPathDistList == kk);
    m2 = median(allResList(f1));
    figure(12);plot(kk,m2,'ko');
end%for kk
figure(12);hold off
%---
sortData = sortrows([allXYDistList',allResList'],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medXYDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medXYDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(11);plot(allXYDistList,allResList,'r.');hold on
figure(11);plot(medXYDistList,medResList,'k-');
set(gca,'YLim',[0,maxPlotResistance],'XLim',[0,700]);
xlabel('radial distance');
ylabel('effective network resistance');
f1 = find(allXYDistList>=350);
m3 = median(allResList(f1));
figure(11);plot([0,700],[m3,m3],'b-');
myTitle = [shortName,' - blue line @ ',num2str(m3)];
title(myTitle)
figure(11);hold off



saveFileName = [shortName,'-AdjRadiiPointToPointResultSource'];
% save(saveFileName,'allPathDistList','allXYDistList','allResList','actualStrandList','skip*','x*','y*','*Z');


sss = [strands(actualStrandList).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'g-');hold on
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---
figure(998);plot(log10([m1,m1]),[0,max(h)./sum(h)],'b-');
%---
sss = [strands(:).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'r-');hold off
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---
%%



if ~exist('multiResistanceList','var'),
    multiSetIDList = [];
    multiResistanceList = [];
    multiPathDistList = [];
    multiSepDistList = [];
    multiNameList = [];
    multiMarkerSize = 5;

end%if ~exist...
multiSetIDList = [multiSetIDList;repmat(setIDNum,size(allResList'))];
multiResistanceList = [multiResistanceList;allResList'];
multiPathDistList = [multiPathDistList;allPathDistList'];
multiSepDistList = [multiSepDistList;allXYDistList'];
multiNameList = [multiNameList,shortName,'-']

%%

%Calc running median
sortData = sortrows([multiPathDistList,multiResistanceList],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medPathDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medPathDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(22);plot(allPathDistList,allResList,'g.');hold on
xlabel('path distance along microvessel network');
if normalizeStrandLengthFlag == 1, xlabel('numStrands');end
ylabel('effective network resistance');
set(gca,'YLim',[0,maxPlotResistance],'XLim',[0,1000]);
f1 = find(medPathDistList>=15);
m1 = median(medResList(f1));
figure(22);plot([0,1000],[m1,m1],'b-');
myTitle = [multiNameList,' - blue line @ ',num2str(m1)];
title(myTitle)
for kk = 1:30,
    f1 = find(allPathDistList == kk);
    m2 = median(allResList(f1));
    figure(22);plot(kk,m2,'ko');
end%for kk
figure(22);hold off
%---
sortData = sortrows([allXYDistList',allResList'],1);
halfAveSize = 50;
numPoints = size(sortData,1);
medXYDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medXYDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(21);plot(allXYDistList,allResList,'r.');hold on
figure(21);plot(medXYDistList,medResList,'k-');
set(gca,'YLim',[0,maxPlotResistance],'XLim',[0,2000]);
xlabel('radial distance');
ylabel('effective network resistance');
f1 = find(allXYDistList>=350);
m3 = median(allResList(f1));
figure(21);plot([0,2000],[m3,m3],'b-');
myTitle = [multiNameList,' - blue line @ ',num2str(m3)];
title(myTitle)
figure(21);hold off



saveFileName = [shortName,'-AdjRadiiPointToPointResultSource'];


sss = [strands(actualStrandList).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'g-');hold on
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---
figure(998);plot(log10([m1,m1]),[0,max(h)./sum(h)],'b-');
%---
sss = [strands(:).strandConductance];
xxx = [-10:0.1:0];
h = hist(log10(1./sss),xxx);
figure(998);plot(xxx,h./sum(h),'r-');hold off
xlabel('log10(strandResistance)')
ylabel('occurences');
meanResistance = 1/mean(sss);
[maxVal,maxPos] = max(h);
modeStrandResistance = 10^(xxx(maxPos));
%---

%%


figData.multiResistanceList = multiResistanceList;
figData.multiSepDistList = multiSepDistList;
figData.multiPathDistList = multiPathDistList;
figData.multiSetIDList = multiSetIDList;
figData.midZ = midZ;
figData.plusMinusZ = plusMinusZ;
figData.numStartToUse = numStartToUse;
figData.numRandToUse = numRandToUse;
figData.deltaX = deltaX;
figData.deltaY = deltaY;
figData.randNeighborChoiceFlag = randNeighborChoiceFlag;
figData.furthestNeighborChoiceFlag = furthestNeighborChoiceFlag;
figData.randSeed = randSeed;
figData.numSteps = numSteps;
figData.maxPlotResistance = maxPlotResistance;


figData.note1 = 'effectiveNetworkResistance from point-to-point with plunging vessels stripped';
figData.note2 = '4 datasets: AU,AV,CO,DB ;';
figData.note3 = 'radii adjusted to Awake histogram with AAA_RenormalizeRadiusHistogramToAwake.m';
figData.note4 = 'Eigenvalues calculated with AAA_CalculateEigenvaluesForPlungingStrippedDatasetAdjRadii.m';
figData.note4 = 'Network resistance calculated with AAA_CalculatePointToPointResistanceScript04_adjustedRadii.m';

multiMarkerSize = 5;
for setIter = 1:4,

    plotString = 'ro';
    switch setIter,
        case 1, plotString = 'ro';
        case 2, plotString = 'go';
        case 3, plotString = 'bo';
        case 4, plotString = 'yo';
    end%switch

    setFlagList = figData.multiSetIDList == setIter;
    effectiveResistanceList = figData.multiResistanceList(setFlagList);
    sepList = figData.multiSepDistList(setFlagList);
    pathDistList  = figData.multiPathDistList(setFlagList);

    figure(103);p3 = plot(sepList,effectiveResistanceList,plotString);hold on
    xlabel('separation [um]'),ylabel('network resistance');
    set(p3,'MarkerSize',multiMarkerSize);
    set(gca,'YLim',[0,figData.maxPlotResistance],'XLim',[0,2000]);
    
    nonZeroList = pathDistList~=0;
    figure(104);p4 = plot(pathDistList(nonZeroList),effectiveResistanceList(nonZeroList),plotString);hold on
    xlabel('pathlength distance [um]'),ylabel('network resistance');
    set(p4,'MarkerSize',multiMarkerSize);
    set(gca,'YLim',[0,figData.maxPlotResistance],'XLim',[0,2000]);
    
    multiMarkerSize = max(1,multiMarkerSize-1);
    
    
end

%Calc running median
sortData = sortrows([figData.multiSepDistList,figData.multiResistanceList],1);
halfAveSize = 100;
numPoints = size(sortData,1);
medSepDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medSepDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(103);p33 = plot(medSepDistList,medResList,'k-');
set(p33,'LineWidth',5);hold off

%---
nonZeroList = figData.multiPathDistList~=0;     
sortData = sortrows([figData.multiPathDistList(nonZeroList),figData.multiResistanceList(nonZeroList)],1);
halfAveSize = 100;
numPoints = size(sortData,1);
medPathDistList = [];
medResList = [];
for pointIter = halfAveSize+1:numPoints-halfAveSize
    medPathDistList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,1));
    medResList(pointIter-halfAveSize) = median(sortData(pointIter-halfAveSize:pointIter+halfAveSize,2));
end
figure(104);p44 = plot(medPathDistList,medResList,'k-');
set(p44,'LineWidth',5);hold off
 


%%
f1 = find(multiSetIDList == 1);
f2 = find(multiSetIDList == 2);
f3 = find(multiSetIDList == 3);
f4 = find(multiSetIDList == 4);

mr1 = multiResistanceList(f1);
ms1 = multiSepDistList(f1);
mr2 = multiResistanceList(f2);
ms2 = multiSepDistList(f2);
mr3 = multiResistanceList(f3);
ms3 = multiSepDistList(f3);
mr4 = multiResistanceList(f4);
ms4 = multiSepDistList(f4);

s1 = 300;
s2 = 800;
rmax = 10;

mr1s = mr1(and(mr1<rmax,and(ms1>s1, ms1<s2)));
ms1s = ms1(and(mr1<rmax,and(ms1>s1, ms1<s2)));
mr2s = mr2(and(mr2<rmax,and(ms2>s1, ms2<s2)));
ms2s = ms2(and(mr2<rmax,and(ms2>s1, ms2<s2)));
mr3s = mr3(and(mr3<rmax,and(ms3>s1, ms3<s2)));
ms3s = ms3(and(mr3<rmax,and(ms3>s1, ms3<s2)));
mr4s = mr4(and(mr4<rmax,and(ms4>s1, ms4<s2)));
ms4s = ms4(and(mr4<rmax,and(ms4>s1, ms4<s2)));

figure(1);hold off;
figure(1);plot(ms1s,mr1s,'r.');hold on
% figure(1);plot(ms2s,mr2s,'g.');
% figure(1);plot(ms3s,mr3s,'b.');
% figure(1);plot(ms4s,mr4s,'m.');hold off;
set(gca,'YLim',[0 10]);


[b,stats] = robustfit(ms4s,mr4s);
disp(' ');
disp(' ');
b(1),b(2),stats.se(1),stats.se(2),%stats.p(1),stats.p(2)


mr1sn = mr1s - mean(mr1s);
mr2sn = mr2s - mean(mr2s);
mr3sn = mr3s - mean(mr3s);
mr4sn = mr4s - mean(mr4s);

figure(2);hold off;
figure(2);plot(ms1s,mr1sn,'r.');hold on
figure(2);plot(ms2s,mr2sn,'g.');
figure(2);plot(ms3s,mr3sn,'b.');
figure(2);plot(ms4s,mr4sn,'m.');hold off;
set(gca,'YLim',[0 10]);

manyR = [mr1sn;mr2sn;mr3sn;mr4sn];
manyS = [ms1s;ms2s;ms3s;ms4s];

[b,stats] = robustfit(manyS,manyR);
disp(' ');
disp(' ');
b(1),b(2),stats.se(1),stats.se(2),%stats.p(1),stats.p(2)

