% % 
% % cd('F:\Phil\VectorProjects')
% % load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')


vectorProject = allProject.av;


%Convert the vectorizedStructure to a segments and nodes structure for the dijkstra algorithm
vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
firstDash = findstr(vectorProjectRootName,'-');
shortName = vectorProjectRootName(1:firstDash(1)-1);

strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allJP = vertices.JunctionPoints;
strandIndices = vertices.StrandIndices;
strandIndices = full(strandIndices);
strandLabelList = [strands(:).MedianLabel];
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
adjustedStrandRadiusList = vectorizedStructure.adjustedStrandRadiusList;
effectiveStrandRadiusList(isnan(effectiveStrandRadiusList)) = 2;

%%
%Propagate out from all plunging arteriole strands (branchID 1)
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
allSurfaceStrandList = find(ismember(strandLabelList,[300:399]));

numStrands = numel(strands);
strandArterioleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];

activeStrandFlagList(allPlungingArterioleList) = 1;
activeStrandFlagList(allSurfaceStrandList) = 2; %notActive, but not usable
activeStrandList = allPlungingArterioleList;
strandArterioleBranchNumList(allPlungingArterioleList) = 1;
arterioleBranchMedianEffectiveRadiusList = [];
arterioleBranchMedianAdjustedRadiusList = [];
arterioleBranchMedianEffectiveRadiusList(1) = median(effectiveStrandRadiusList(activeStrandList));
arterioleBranchMedianAdjustedRadiusList(1) = median(adjustedStrandRadiusList(activeStrandList));


maxBranchSearch = 20;
for branchIter = 2:maxBranchSearch,
    numLeft = numel(find(activeStrandFlagList==0));
%     disp([branchIter,numLeft]);
    %Find all unused connecting strands
    startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
    endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
    neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
    neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
    nextRoundStrandList = neighborStrandList(neighborFlagList);
    activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
    activeStrandFlagList(nextRoundStrandList) = 1;
    strandArterioleBranchNumList(nextRoundStrandList) = branchIter;
    activeStrandList = nextRoundStrandList;
    arterioleBranchMedianEffectiveRadiusList(branchIter) = median(effectiveStrandRadiusList(activeStrandList));
    arterioleBranchMedianAdjustedRadiusList(branchIter) = median(adjustedStrandRadiusList(activeStrandList));
end

figure(1);plot(arterioleBranchMedianEffectiveRadiusList,'r.');



%%

%Propagate out from all plunging arteriole strands (branchID 1)
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
allSurfaceStrandList = find(ismember(strandLabelList,[300:399]));

numStrands = numel(strands);
strandVenuleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];

activeStrandFlagList(allPlungingArterioleList) = 1;
activeStrandFlagList(allSurfaceStrandList) = 2; %notActive, but not usable
activeStrandList = allPlungingVenuleList;
strandArterioleBranchNumList(allPlungingArterioleList) = 1;
venuleBranchMedianEffectiveRadiusList = [];
venuleBranchMedianAdjustedRadiusList = [];
venuleBranchMedianEffectiveRadiusList(1) = median(effectiveStrandRadiusList(activeStrandList));
venuleBranchMedianAdjustedRadiusList(1) = median(adjustedStrandRadiusList(activeStrandList));


maxBranchSearch = 20;
for branchIter = 2:maxBranchSearch,
    numLeft = numel(find(activeStrandFlagList==0));
%     disp([branchIter,numLeft]);
    %Find all unused connecting strands
    startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
    endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
    neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
    neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
    nextRoundStrandList = neighborStrandList(neighborFlagList);
    activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
    activeStrandFlagList(nextRoundStrandList) = 1;
    strandVenuleBranchNumList(nextRoundStrandList) = branchIter;
    activeStrandList = nextRoundStrandList;
    venuleBranchMedianEffectiveRadiusList(branchIter) = median(effectiveStrandRadiusList(activeStrandList));
    venuleBranchMedianAdjustedRadiusList(branchIter) = median(adjustedStrandRadiusList(activeStrandList));
end

figure(2);plot(venuleBranchMedianEffectiveRadiusList,'b.');


%%
