
maxBranchSearch = 20;
multiArterioleBranchList = {[]};
multiVenuleBranchList = {[]};
multiArterioleBranchList{maxBranchSearch} = [];
multiVenuleBranchList{maxBranchSearch} = [];

%%

setIDNum = 1;


switch setIDNum,
    case 1, 
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX06-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX06\SE2-2012_10_02-14_07_59-Mod-StrandEdit2-CX06_pbEH-LargestSubgraph-Flow.mat')
    case 2,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX08-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX08\VectorProjectFolder\SE2-2012_11_16-13_38_43-Mod-StrandEdit2-CX08-PostClickingVectorProject.mat')
    case 3,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX12-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX12\SE2-2012_09_29-01_35_28-Mod-StrandEdit2-CX12-LargestSubgraph-Flow.mat')
    case 4,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX13-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX13\SE2-2012_10_02-00_47_36-Mod-StrandEdit2-CX13-LargestSubgraph-Flow.mat')

end



maskSize = dataStruct.maskSize;
allPlungingArterioleCoordList = dataStruct.paCoords;
allPlungingVenuleCoordList = dataStruct.pvCoords;

strands = globalDataStruct.strands;
allVerts = globalDataStruct.cpMatrix(:,1:3);
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
strandIndices = globalDataStruct.strandIndices;
numStrands = numel(strands);

% % % if isfield(strands(end),'MedianRadius'),
% % %     effectiveStrandRadiusList = [strands(:).MedianRadius];
% % % else% if isfield...
    strandMidYXZList = [];
    for strandIter = 1:numStrands,
        thisStrand = strands(strandIter);
        stei = thisStrand.StartToEndIndices;
        strands(strandIter).MedianRadius = median(allRadii(stei));
        strands(strandIter).MedianLabel = median(allLabels(stei));
        myVerts = allVerts(stei,:);
        myMin = min(myVerts,[],1);
        myMax = max(myVerts,[],1);
        yxzLimits = [myMin',myMax'];
        strands(strandIter).YXZLimits = yxzLimits;
        strandMidYXZList(strandIter,:) = mean(yxzLimits',1);
    end
    effectiveStrandRadiusList = [strands(:).MedianRadius];
% % % end%if isfield...
effectiveStrandRadiusList(isnan(effectiveStrandRadiusList)) = 2;


apacl = allPlungingArterioleCoordList;
allPlungingArterioleIndList = sub2ind(maskSize,apacl(:,1),apacl(:,2),apacl(:,3));
apvcl = allPlungingVenuleCoordList;
allPlungingVenuleIndList = sub2ind(maskSize,apvcl(:,1),apvcl(:,2),apvcl(:,3));
allVertIndList = sub2ind(maskSize,allVerts(:,1),allVerts(:,2),allVerts(:,3));


allPlungingArterioleList = [];
allPlungingVenuleList = [];
allSurfaceStrandList = [];
for strandIter = 1:numStrands,
    if mod(strandIter,10000)==0, disp([strandIter/numStrands]); end
    thisStrand = strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    midPoint = ceil(numel(stei)/2);
    representativePointInd = allVertIndList(stei(midPoint));
    isArterioleFlag = ismember(representativePointInd,allPlungingArterioleIndList);
    isVenuleFlag = ismember(representativePointInd,allPlungingVenuleIndList);
    isSurfaceFlag = ismember(thisStrand.MedianLabel,[300:399]);
    if isArterioleFlag == 1,
        allPlungingArterioleList = [allPlungingArterioleList,strandIter];
    end%if isArterioleFlag == 1,
    if isVenuleFlag == 1,
        allPlungingVenuleList = [allPlungingVenuleList,strandIter];
    end%if isVenuleFlag == 1,
    if isSurfaceFlag == 1,
        allSurfaceStrandList = [allSurfaceStrandList,strandIter];
    end%if isSurfaceFlag == 1,
end%for strandIter
    
    
    




%%

%Propagate out from all plunging arteriole strands (branchID 1)
strandArterioleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];

activeStrandFlagList(allPlungingArterioleList) = 1;
activeStrandFlagList(allSurfaceStrandList) = 2; %notActive, but not usable
activeStrandFlagList(allPlungingVenuleList) = 2; %notActive, but not usable
activeStrandList = allPlungingArterioleList;
strandArterioleBranchNumList(allPlungingArterioleList) = 1;
arterioleBranchMedianEffectiveRadiusList = [];
% arterioleBranchMedianAdjustedRadiusList = [];
arterioleBranchMedianEffectiveRadiusList(1) = mean(effectiveStrandRadiusList(activeStrandList));
% arterioleBranchMedianAdjustedRadiusList(1) = median(adjustedStrandRadiusList(activeStrandList));
thisMultiData = multiArterioleBranchList{1};
thisRadiusList = effectiveStrandRadiusList(activeStrandList);
thisZList = strandMidYXZList(activeStrandList,3);
thisData = [thisRadiusList,thisZList];
thisMultiData = [thisMultiData;thisData];
multiArterioleBranchList{1} = thisMultiData;

for branchIter = 2:maxBranchSearch,
    thisMultiData = multiArterioleBranchList{branchIter};
    numLeft = numel(find(activeStrandFlagList==0));
    %Find all unused connecting strands
    startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
    endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
    neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
    neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
    nextRoundStrandList = neighborStrandList(neighborFlagList);
    activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
    activeStrandFlagList(nextRoundStrandList) = 1;
    strandArterioleBranchNumList(nextRoundStrandList) = branchIter;
    activeStrandList = nextRoundStrandList;
    thisRadiusList = effectiveStrandRadiusList(activeStrandList);
    thisZList = strandMidYXZList(activeStrandList,3);
    arterioleBranchMedianEffectiveRadiusList(branchIter) = mean(thisRadiusList);
%     arterioleBranchMedianAdjustedRadiusList(branchIter) = median(adjustedStrandRadiusList(activeStrandList));
    thisData = [thisRadiusList,thisZList];
    thisMultiData = [thisMultiData;thisData];
    multiArterioleBranchList{branchIter} = thisMultiData;
end

figure(1);plot(arterioleBranchMedianEffectiveRadiusList,'r.');



%-----


%Propagate out from all plunging venule strands (branchID 1)

numStrands = numel(strands);
strandVenuleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];

activeStrandFlagList(allPlungingVenuleList) = 1;
activeStrandFlagList(allSurfaceStrandList) = 2; %notActive, but not usable
activeStrandFlagList(allPlungingArterioleList) = 2; %notActive, but not usable
activeStrandList = allPlungingVenuleList;
strandVenuleBranchNumList(allPlungingVenuleList) = 1;
venuleBranchMedianEffectiveRadiusList = [];
% venuleBranchMedianAdjustedRadiusList = [];
venuleBranchMedianEffectiveRadiusList(1) = mean(effectiveStrandRadiusList(activeStrandList));
% venuleBranchMedianAdjustedRadiusList(1) = median(adjustedStrandRadiusList(activeStrandList));
thisMultiData = multiVenuleBranchList{1};
thisRadiusList = effectiveStrandRadiusList(activeStrandList);
thisZList = strandMidYXZList(activeStrandList,3);
thisData = [thisRadiusList,thisZList];
thisMultiData = [thisMultiData;thisData];
multiVenuleBranchList{1} = thisMultiData;

for branchIter = 2:maxBranchSearch,
    thisMultiData = multiVenuleBranchList{branchIter};
    numLeft = numel(find(activeStrandFlagList==0));
%     disp([branchIter,numLeft]);
    %Find all unused connecting strands
    startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
    endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
    neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
    neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
    nextRoundStrandList = neighborStrandList(neighborFlagList);
    activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
    activeStrandFlagList(nextRoundStrandList) = 1;
    strandVenuleBranchNumList(nextRoundStrandList) = branchIter;
    activeStrandList = nextRoundStrandList;
    thisRadiusList = effectiveStrandRadiusList(activeStrandList);
    thisZList = strandMidYXZList(activeStrandList,3);
    venuleBranchMedianEffectiveRadiusList(branchIter) = mean(thisRadiusList);
%     venuleBranchMedianAdjustedRadiusList(branchIter) = median(adjustedStrandRadiusList(activeStrandList));
    thisData = [thisRadiusList,thisZList];
    thisMultiData = [thisMultiData;thisData];
    multiVenuleBranchList{branchIter} = thisMultiData;
end

figure(2);plot(venuleBranchMedianEffectiveRadiusList,'b.');




%-----

%%


zRange = [0 3000]

meanA= [];
meanV = [];
stdA = [];
stdV = [];
nA = [];
nV = [];

figure(31);hold off;
figure(32);hold off;
for branchIter = 1:maxBranchSearch;
    thisAData = multiArterioleBranchList{branchIter};
    thisVData = multiVenuleBranchList{branchIter};
    aZ = thisAData(:,2);
    vZ = thisVData(:,2);
    aZFlag = and(aZ>zRange(1),aZ<zRange(2));
    vZFlag = and(vZ>zRange(1),vZ<zRange(2));
    thisAData = thisAData(aZFlag,:);
    thisVData = thisVData(vZFlag,:);
    
    
    aX = rand(size(thisAData(:,1)))+branchIter-1;
    vX = rand(size(thisVData(:,1)))+branchIter-1;
    figure(31);plot(aX,thisAData(:,1),'r.');hold on
    figure(32);plot(vX,thisVData(:,1),'b.');hold on
    meanA(branchIter) = mean(thisAData(:,1));
    stdA(branchIter) = std(thisAData(:,1));
    nA(branchIter) = numel(thisAData(:,1));
    meanV(branchIter) = mean(thisVData(:,1));
    stdV(branchIter) = std(thisVData(:,1));
    nV(branchIter) = numel(thisVData(:,1));
end%for branchIter...

figure(41);
plot([0:maxBranchSearch-1],meanA,'ro');hold on
plot([0:maxBranchSearch-1],meanA+stdA,'r^');
plot([0:maxBranchSearch-1],meanA-stdA,'rv');
% plot([0:maxBranchSearch-1],meanA+stdA./sqrt(nA),'r*');
% plot([0:maxBranchSearch-1],meanA-stdA./sqrt(nA),'r*');
hold off
xlabel('Branch away from arteriole');
ylabel('Vessel radius [um]')
title('8 datasets, 1.3 million vessels');

figure(42);
plot([0:maxBranchSearch-1],meanV,'bo');hold on
plot([0:maxBranchSearch-1],meanV+stdV,'b^');
plot([0:maxBranchSearch-1],meanV-stdV,'bv');
% plot([0:maxBranchSearch-1],meanV+stdV./sqrt(nV),'b*');
% plot([0:maxBranchSearch-1],meanV-stdV./sqrt(nV),'b*');
hold off
xlabel('Branch away from venule');
ylabel('Vessel radius [um]')
title('8 datasets, 1.3 million vessels');
    
    

    
    