% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);


setIDNum = 1;


switch setIDNum,
    case 1, vectorProject = allProject.au;
    case 2, vectorProject = allProject.av;
    case 3, vectorProject = allProject.co;
    case 4, vectorProject = allProject.db;
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;


cutName = shortName(3:end);
cutName = shortName;
cutName = 'au'

eigenSetFileName = ['F:\Phil\VectorProjects\',lower(cutName),'MinusSurfaceEigen.mat']

if exist('eigenValues','var') && numel(eigenValues) == numel(floatingNodeIndexList),
    disp('EigenValues already loaded');
else
    disp('Loading EigenValues and EigenVectors');pause(0.1);
    load(eigenSetFileName);
end

numStrands = numel(strands);
numFloatingNodes = numel(floatingNodeIndexList);




normalizeStrandLengthFlag = 0;

%%
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numPlungingVenules = numel(allPlungingVenulePathList);

clear medianResistanceList;
for depthIter = 2:50,
clear effectiveResistance
    
for plungingIter = 1:numPlungingVenules

    thisPlungingVenulePath = allPlungingVenulePathList{plungingIter};
    
    if numel(thisPlungingVenulePath) >=depthIter,

        startPoint = 1;
        endPoint = depthIter;

        startingStrand = thisPlungingVenulePath(startPoint);
        endingStrand = thisPlungingVenulePath(endPoint);
        vertex1ID = strands(startingStrand).StartVertexIndex;
        vertex2ID = strands(endingStrand).StartVertexIndex;
        vertex2Depth = vectorizedStructure.strandMidYXZList(endingStrand,3);
        
        floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
        floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
        runSum = 0;
        mSize = size(eigenVectors,1);
        for iIter = 2:mSize;
            eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
            eVectorBeta = eigenVectors(floatingNode2ID,iIter);
            eVal = eigenValues(iIter);
            cutoff = -1;
            if eVal > cutoff,
                runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
            end
        end%for iIter;
        
        effectiveResistance(plungingIter) = runSum * 2.55e7;
        figure(2);semilogy(vertex2Depth,runSum * 2.55e7,'m.');hold on
    end% if numel(thisPlungingVenulePath) >=depthIter,0
end%for plungingITer
    medianResistanceList(depthIter) = median(effectiveResistance(effectiveResistance>0));
disp(medianResistanceList(depthIter));
figure(1);plot(medianResistanceList,'r.');pause(0.1);
end%for depthIter



