% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);

% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')
 

 
% % multiPairList = [];
% % multiDataSetName = [];


setIDNum = 4;


switch setIDNum,
    case 1, vectorProject = allProject.au;dataSetName = 'AU';
    case 2, vectorProject = allProject.av;dataSetName = 'AV';
    case 3, vectorProject = allProject.co;dataSetName = 'CO';
    case 4, vectorProject = allProject.db;dataSetName = 'DB';
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;


normFactor = 2.55e7; %multiple resistance by this to get true resistance in units of poise/um3

depthResistancePairList = zeros(10000,2);
depthMedResistancePairList = zeros(10000,2);
depthVoltagePairList = zeros(10000,2);
topZList = zeros(10000,1);
numVenules = numel(allPlungingVenulePathList);
strandCounter = 0;
for venuleIter = 1:numVenules,
    venulePath = allPlungingVenulePathList{venuleIter};
    numInPath = numel(venulePath);
    startStrandID = venulePath(1);
    startStrand = strands(startStrandID);
    startStrandPoints = startStrand.StartToEndIndices;
    topZ = min(vertices.AllVerts(startStrandPoints,3));
    runningResistance = 0;
    
    thisPathRR = [];
    thisPathAngle = [];
    thisPathVoltage = [];
    runningResistanceList = [];
    for pathIter = 1:numInPath,
        thisStrandID = venulePath(pathIter);
        thisStrand = strands(thisStrandID);
        thisStrandPoints = thisStrand.StartToEndIndices;
        thisStrandVoltage = thisStrand.MedianVoltage;
        upperZ = min(vertices.AllVerts(thisStrandPoints,3));
        bottomZ = max(vertices.AllVerts(thisStrandPoints,3));
        angle = (bottomZ-upperZ)/numel(thisStrandPoints);
        strandCounter = strandCounter + 1;
        thisResistance = normFactor./(thisStrand.strandConductance);
        thisResistivity = thisResistance./(numel(thisStrandPoints)-1);
        runningResistance = runningResistance + thisResistance;   
        depthResistancePairList(strandCounter,:) = [bottomZ-topZ,runningResistance];
        thisPathRR = [thisPathRR;[bottomZ-upperZ,thisResistivity]];
        thisPathAngle = [thisPathAngle,angle];
        thisPathVoltage = [thisPathVoltage,thisStrandVoltage];
        runningResistanceList = [runningResistanceList;[bottomZ-topZ,runningResistance]];
        medianResitivity = median(thisPathRR(:,2));
        depthMedResistancePairList(strandCounter,:) = [bottomZ-topZ,(bottomZ-topZ)*medianResitivity];            
        depthVoltagePairList(strandCounter,:) = [bottomZ-topZ,thisStrandVoltage];    
        topZList(strandCounter) = topZ;
    end%for pathIter
    figure(3);p1 = plot(runningResistanceList(:,1),runningResistanceList(:,2),'r-');pause(0.01);hold on
    hold off
    figure(44);p2 = plot(runningResistanceList(:,1),thisPathVoltage,'g-');pause(0.01);hold on
    zFraction = max(runningResistanceList(:,1))./1000;
    zFraction = min(zFraction,1);
    myColor = [1 1-zFraction 1-zFraction];
    set(p1,'Color',myColor);
    
    mySlopeList = diff(runningResistanceList(:,2))./diff(runningResistanceList(:,1));
    figure(99);plot(mySlopeList,'m-');
   
    
    medianSlope = median(mySlopeList);
    ff = find(mySlopeList>3*medianSlope);
    if isempty(ff), ff = size(runningResistanceList,1);end
    subRR = runningResistanceList(1:ff(1),:);
    figure(33);p33 = plot(subRR(:,1),subRR(:,2),'r-');pause(0.01);hold off
    
%      pause

     
    
end%for venuleIter
depthResistancePairList = depthResistancePairList(1:strandCounter,:);
depthMedResistancePairList = depthMedResistancePairList(1:strandCounter,:);
depthVoltagePairList = depthVoltagePairList(1:strandCounter,:);
topZList = topZList(1:strandCounter,:);

figure(1);plot(depthResistancePairList(:,1),depthResistancePairList(:,2),'r.');
figure(2);plot(depthMedResistancePairList(:,1),depthMedResistancePairList(:,2),'r.');

%sort by depth
sortPairList = sortrows(depthResistancePairList,1);
medFiltList = medfilt2(sortPairList,[50,1]);
figure(11);plot(medFiltList(:,1),medFiltList(:,2),'b.');
xlabel('depth from pia (micrometers');
ylabel('median resistance to surface in penetrating venule [poise/um3]')
title('Dataset AU');

sortPairList = sortrows(depthMedResistancePairList,1);
medFiltList = medfilt2(sortPairList,[50,1]);
figure(12);plot(medFiltList(:,1),medFiltList(:,2),'b.');


%%
% multiSubResistanceList = [];

barrels = vectorProject.barrelBoundaryParameters.barrels;
barrelMinZ = inf;
barrelMaxZ = 0;
for barrelIter = 1:numel(barrels);
    thisBarrel = barrels{barrelIter};
    barrelMinZ = min(barrelMinZ,min(thisBarrel(:,3)));
    barrelMaxZ = max(barrelMaxZ,max(thisBarrel(:,3)));
end
brainTop = min(allVerts);

disp([barrelMinZ,barrelMaxZ]);

% % barrelMinZ = 400, barrelMaxZ = 558%for AU

barrelMinZ = barrelMinZ-brainTop;
barrelMaxZ = barrelMaxZ-brainTop;


f1 = (depthResistancePairList(:,1)>barrelMinZ);
f2 = (depthResistancePairList(:,1)<barrelMaxZ);
f3 = and(f1,f2);
subResistanceList = depthResistancePairList(f3,2);
multiSubResistanceList = [multiSubResistanceList;subResistanceList];
disp([mean(multiSubResistanceList),std(multiSubResistanceList),median(multiSubResistanceList)]);


%%

hx = [50:1:100];
f1 = find(and(depthVoltagePairList(:,1)>0,depthVoltagePairList(:,1)<=100))
h1 = histc(depthVoltagePairList(f1,2),hx);
figure(101);bar(hx,h1);

f2 = find(and(depthVoltagePairList(:,1)>100,depthVoltagePairList(:,1)<=200))
h2 = histc(depthVoltagePairList(f2,2),hx);
figure(102);bar(hx,h2);

f3 = find(and(depthVoltagePairList(:,1)>200,depthVoltagePairList(:,1)<=300))
h3 = histc(depthVoltagePairList(f3,2),hx);
figure(103);bar(hx,h3);

f4 = find(and(depthVoltagePairList(:,1)>300,depthVoltagePairList(:,1)<=400))
h4 = histc(depthVoltagePairList(f4,2),hx);
figure(104);bar(hx,h4);

f5 = find(and(depthVoltagePairList(:,1)>400,depthVoltagePairList(:,1)<=500))
h5 = histc(depthVoltagePairList(f5,2),hx);
figure(105);bar(hx-50,h5);
ylabel('Count');
xlabel('Pressure (mmHg) in Plunging Venule at 400-500 um depth')

f6 = find(and(depthVoltagePairList(:,1)>500,depthVoltagePairList(:,1)<=600))
h6 = histc(depthVoltagePairList(f6,2),hx);
figure(106);bar(hx,h6);

%%

strandVoltageList = [strands.MedianVoltage];
strandZList = vectorizedStructure.strandMidYXZList(:,3);
figure(201);plot(strandZList,strandVoltageList,'r.');

hold on
plot(depthVoltagePairList(:,1)+topZList,depthVoltagePairList(:,2),'b.');
hold off





multiPairList = [multiPairList;depthResistancePairList];
multiDataSetName = [multiDataSetName,dataSetName];
sortPairList = sortrows(multiPairList,1);


medFiltList = medfilt2(sortPairList,[50,1]);
figure(21);plot(medFiltList(:,1),medFiltList(:,2),'b.');
xlabel('depth from pia (micrometers');
ylabel('median resistance to surface in penetrating arteriole [poise/um3]')
title(['Dataset ',multiDataSetName]);

%%

figure(111);plot(multiPairList(:,1),multiPairList(:,2),'g.');

