% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);

% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')
 

 
% % multiPairList = [];
% % multiDataSetName = [];

setIDNum = 4;


switch setIDNum,
    case 1, 
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX06-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX06\SE2-2012_10_02-14_07_59-Mod-StrandEdit2-CX06_pbEH-LargestSubgraph-Flow.mat')
        dataSetName = 'CX06';
    case 2,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX08-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX08\VectorProjectFolder\SE2-2012_11_16-13_38_43-Mod-StrandEdit2-CX08-PostClickingVectorProject.mat')
        dataSetName = 'CX08';
    case 3,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX12-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX12\SE2-2012_09_29-01_35_28-Mod-StrandEdit2-CX12-LargestSubgraph-Flow.mat')
        dataSetName = 'CX12';
    case 4,
        load('F:\Phil\ForFromPeople\Joyce\dataStructforIOS\CX13-dataStruct.mat');
        load('F:\Phil\ForFromPeople\Joyce\CX13\SE2-2012_10_02-00_47_36-Mod-StrandEdit2-CX13-LargestSubgraph-Flow.mat')
        dataSetName = 'CX13';
end



maskSize = dataStruct.maskSize;
allPlungingArterioleCoordList = dataStruct.paCoords;
allPlungingVenuleCoordList = dataStruct.pvCoords;

strands = globalDataStruct.strands;
allVerts = globalDataStruct.cpMatrix(:,1:3);
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
numStrands = numel(strands);



vertice = [];
vertices.AllVerts = allVerts;



    for strandIter = 1:numStrands,
        thisStrand = strands(strandIter);
        stei = thisStrand.StartToEndIndices;
        strands(strandIter).MedianRadius = median(allRadii(stei));
        strands(strandIter).MedianLabel = median(allLabels(stei));
        myVerts = allVerts(stei,:);
        myMin = min(myVerts,[],1);
        myMax = max(myVerts,[],1);
        yxzLimits = [myMin',myMax'];
        strands(strandIter).YXZLimits = yxzLimits;
    end

%Find plunging arteriole strands that hook up with surface strands;


apacl = allPlungingArterioleCoordList;
allPlungingArterioleIndList = sub2ind(maskSize,apacl(:,1),apacl(:,2),apacl(:,3));
apvcl = allPlungingVenuleCoordList;
allPlungingVenuleIndList = sub2ind(maskSize,apvcl(:,1),apvcl(:,2),apvcl(:,3));
allVertIndList = sub2ind(maskSize,allVerts(:,1),allVerts(:,2),allVerts(:,3));


allPlungingArterioleList = [];
allPlungingVenuleList = [];
allSurfaceStrandList = [];
strandMidZList = zeros(numStrands,1);
for strandIter = 1:numStrands,
    if mod(strandIter,10000)==0, disp([strandIter/numStrands]); end
    thisStrand = strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    midPoint = ceil(numel(stei)/2);
    representativePointInd = allVertIndList(stei(midPoint));
    isArterioleFlag = ismember(representativePointInd,allPlungingArterioleIndList);
    isVenuleFlag = ismember(representativePointInd,allPlungingVenuleIndList);
    isSurfaceFlag = ismember(thisStrand.MedianLabel,[300:399]);
    if isArterioleFlag == 1,
        allPlungingArterioleList = [allPlungingArterioleList,strandIter];
    end%if isArterioleFlag == 1,
    if isVenuleFlag == 1,
        allPlungingVenuleList = [allPlungingVenuleList,strandIter];
    end%if isVenuleFlag == 1,
    if isSurfaceFlag == 1,
        allSurfaceStrandList = [allSurfaceStrandList,strandIter];
    end%if isSurfaceFlag == 1,
    yxzLims = strands(strandIter).YXZLimits;
    strandMidZList(strandIter) = mean(yxzLims(3,:));
end%for strandIter


%%
arterioleTipFlagList = zeros(size(allPlungingArterioleList));
for aIter = 1:numel(allPlungingArterioleList);
    thisStrandID = allPlungingArterioleList(aIter);
    thisStrand = strands(thisStrandID);
    allNeighbors = [thisStrand.EndVertexNeighborStrands,thisStrand.StartVertexNeighborStrands];
    if sum(ismember(allNeighbors,allSurfaceStrandList))>0,
        arterioleTipFlagList(aIter) = 1;
    end% if sum(ismember(allNeighbors,allSurfaceStrandList))>0,
end%for aIter = 1:numel(allPlungingArterioleList);

venuleTipFlagList = zeros(size(allPlungingVenuleList));
for vIter = 1:numel(allPlungingVenuleList);
    thisStrandID = allPlungingVenuleList(vIter);
    thisStrand = strands(thisStrandID);
    allNeighbors = [thisStrand.EndVertexNeighborStrands,thisStrand.StartVertexNeighborStrands];
    if sum(ismember(allNeighbors,allSurfaceStrandList))>0,
        venuleTipFlagList(vIter) = 1;
    end% if sum(ismember(allNeighbors,allSurfaceStrandList))>0,
end%for vIter = 1:numel(allPlungingVenuleList);

    
numArterioles = sum(arterioleTipFlagList);
numVenules = sum(venuleTipFlagList);
arterioleTipList = allPlungingArterioleList(arterioleTipFlagList>0);
venuleTipList = allPlungingVenuleList(venuleTipFlagList>0);

allPlungingArteriolePathList= [];
for aIter = 1:numArterioles,
    thisPath = [arterioleTipList(aIter)];
    keepGoingFlag = 1;
    while keepGoingFlag == 1,
        thisStrandID = thisPath(end);
        thisStrand = strands(thisStrandID);
        thisMidZ = strandMidZList(thisStrandID);
        allNeighbors = [thisStrand.EndVertexNeighborStrands,thisStrand.StartVertexNeighborStrands];
        aFlag = ismember(allNeighbors,allPlungingArterioleList);
        aNeighbors = allNeighbors(aFlag);
        aNeighborZ = strandMidZList(aNeighbors);
        downANeighbors = aNeighbors(aNeighborZ>thisMidZ);
        if isempty(downANeighbors),
            keepGoingFlag = 0;
        else
            thisPath = [thisPath,downANeighbors(1)];
        end%if isempty
    end%while keepGoingFlag == 1
    allPlungingArteriolePathList{aIter} = thisPath;
end%for aIter...

  

allPlungingVenulePathList= [];
for vIter = 1:numVenules,
    thisPath = [venuleTipList(vIter)];
    keepGoingFlag = 1;
    while keepGoingFlag == 1,
        thisStrandID = thisPath(end);
        thisStrand = strands(thisStrandID);
        thisMidZ = strandMidZList(thisStrandID);
        allNeighbors = [thisStrand.EndVertexNeighborStrands,thisStrand.StartVertexNeighborStrands];
        vFlag = ismember(allNeighbors,allPlungingVenuleList);
        vNeighbors = allNeighbors(vFlag);
        vNeighborZ = strandMidZList(vNeighbors);
        downVNeighbors = vNeighbors(vNeighborZ>thisMidZ);
        if isempty(downVNeighbors),
            keepGoingFlag = 0;
        else
            thisPath = [thisPath,downVNeighbors(1)];
        end%if isempty
    end%while keepGoingFlag == 1
    allPlungingVenulePathList{vIter} = thisPath;
end%for aIter...


%%


normFactor = 2.55e7; %multiple resistance by this to get true resistance in units of poise/um3

depthResistancePairList = zeros(10000,2);
depthMedResistancePairList = zeros(10000,2);
depthVoltagePairList = zeros(10000,2);
topZList = zeros(10000,1);
numVenules = numel(allPlungingVenulePathList);
strandCounter = 0;
for venuleIter = 1:numVenules,
    venulePath = allPlungingVenulePathList{venuleIter};
    numInPath = numel(venulePath);
    startStrandID = venulePath(1);
    startStrand = strands(startStrandID);
    startStrandPoints = startStrand.StartToEndIndices;
    topZ = min(vertices.AllVerts(startStrandPoints,3));
    runningResistance = 0;
    
    thisPathRR = [];
    thisPathAngle = [];
    thisPathVoltage = [];
    runningResistanceList = [];
    for pathIter = 1:numInPath,
        thisStrandID = venulePath(pathIter);
        thisStrand = strands(thisStrandID);
        thisStrandPoints = thisStrand.StartToEndIndices;
        thisStrandVoltage = thisStrand.MedianVoltage;
        upperZ = min(vertices.AllVerts(thisStrandPoints,3));
        bottomZ = max(vertices.AllVerts(thisStrandPoints,3));
        angle = (bottomZ-upperZ)/numel(thisStrandPoints);
        strandCounter = strandCounter + 1;
        thisResistance = normFactor./(thisStrand.strandConductance);
        thisResistivity = thisResistance./(numel(thisStrandPoints)-1);
        runningResistance = runningResistance + thisResistance;   
        depthResistancePairList(strandCounter,:) = [bottomZ-topZ,runningResistance];
        thisPathRR = [thisPathRR;[bottomZ-upperZ,thisResistivity]];
        thisPathAngle = [thisPathAngle,angle];
        thisPathVoltage = [thisPathVoltage,thisStrandVoltage];
        runningResistanceList = [runningResistanceList;[bottomZ-topZ,runningResistance]];
        medianResitivity = median(thisPathRR(:,2));
        depthMedResistancePairList(strandCounter,:) = [bottomZ-topZ,(bottomZ-topZ)*medianResitivity];            
        depthVoltagePairList(strandCounter,:) = [bottomZ-topZ,thisStrandVoltage];    
        topZList(strandCounter) = topZ;
    end%for pathIter
    figure(3);p1 = plot(runningResistanceList(:,1),runningResistanceList(:,2),'r-');pause(0.01);hold on
    hold off
    figure(44);p2 = plot(runningResistanceList(:,1),thisPathVoltage,'g-');pause(0.01);hold on
    zFraction = max(runningResistanceList(:,1))./1000;
    zFraction = min(zFraction,1);
    myColor = [1 1-zFraction 1-zFraction];
    set(p1,'Color',myColor);
    
    mySlopeList = diff(runningResistanceList(:,2))./diff(runningResistanceList(:,1));
    figure(99);plot(mySlopeList,'m-');
   
    
    medianSlope = median(mySlopeList);
    ff = find(mySlopeList>3*medianSlope);
    if isempty(ff), ff = size(runningResistanceList,1);end
    subRR = runningResistanceList(1:ff(1),:);
    figure(33);p33 = plot(subRR(:,1),subRR(:,2),'r-');pause(0.01);hold off
    
%      pause

     
    
end%for venuleIter
depthResistancePairList = depthResistancePairList(1:strandCounter,:);
depthMedResistancePairList = depthMedResistancePairList(1:strandCounter,:);
depthVoltagePairList = depthVoltagePairList(1:strandCounter,:);
topZList = topZList(1:strandCounter,:);

figure(1);plot(depthResistancePairList(:,1),depthResistancePairList(:,2),'r.');
figure(2);plot(depthMedResistancePairList(:,1),depthMedResistancePairList(:,2),'r.');

%sort by depth
sortPairList = sortrows(depthResistancePairList,1);
medFiltList = medfilt2(sortPairList,[50,1]);
figure(11);plot(medFiltList(:,1),medFiltList(:,2),'b.');
xlabel('depth from pia (micrometers');
ylabel('median resistance to surface in penetrating venule [poise/um3]')
title(dataSetName);



multiPairList = [multiPairList;depthResistancePairList];
multiDataSetName = [multiDataSetName,dataSetName];
sortPairList = sortrows(multiPairList,1);


medFiltList = medfilt2(sortPairList,[50,1]);
figure(21);plot(medFiltList(:,1),medFiltList(:,2),'b.');
xlabel('depth from pia (micrometers');
ylabel('median resistance to surface in penetrating arteriole [poise/um3]')
title(['Dataset ',multiDataSetName]);



figure(111);plot(multiPairList(:,1),multiPairList(:,2),'g.');




