

% % maxBranchSearch = 16;
% % multiArterioleBranchList = {[]};
% % multiVenuleBranchList = {[]};
% % multiArterioleBranchList{maxBranchSearch} = [];
% % multiVenuleBranchList{maxBranchSearch} = [];
% % 


%%

% % 
% % cd('F:\Phil\VectorProjects')
% % load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')


vectorProject = allProject.db;


%Convert the vectorizedStructure to a segments and nodes structure for the dijkstra algorithm
vectorizedStructure = vectorProject.vectorizedStructure;
vectorProjectRootName = vectorProject.vectorProjectRootName;
firstDash = findstr(vectorProjectRootName,'-');
shortName = vectorProjectRootName(1:firstDash(1)-1);

strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
allVerts = vertices.AllVerts;
allJP = vertices.JunctionPoints;
strandIndices = vertices.StrandIndices;
strandIndices = full(strandIndices);
strandLabelList = [strands(:).MedianLabel];
effectiveStrandRadiusList = vectorizedStructure.effectiveStrandRadiusList;
adjustedStrandRadiusList = vectorizedStructure.adjustedStrandRadiusList;
effectiveStrandRadiusList(isnan(effectiveStrandRadiusList)) = 2;
strandMidYXZList = vectorizedStructure.strandMidYXZList; 

%%

%Propagate out from all plunging arteriole strands (branchID 1)
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
allSurfaceStrandList = find(ismember(strandLabelList,[300:399]));
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numArterioles = numel(allPlungingArteriolePathList);
numVenules = numel(allPlungingVenulePathList);
numArterioleStrands = numel(allPlungingArterioleList);




numStrands = numel(strands);
strandArterioleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];


activeStrandFlagList(allPlungingArterioleList) = 2;
activeStrandFlagList(allSurfaceStrandList) = 3; %notActive, but not usable
activeStrandFlagList(allPlungingVenuleList) = 4; %notActive, but not usable

runningList =zeros(1,maxBranchSearch);

for arterioleIter = 1:numArterioleStrands,
    
    
    activeStrandFlagList = zeros(numStrands,1);
    activeStrandList  = [];


    activeStrandFlagList(allPlungingArterioleList) = 2;
    activeStrandFlagList(allSurfaceStrandList) = 3; %notActive, but not usable
    activeStrandFlagList(allPlungingVenuleList) = 4; %notActive, but not usable

    
    
    radiusList = [];
    thisStrandID = allPlungingArterioleList(arterioleIter)
    thisRadius = effectiveStrandRadiusList(thisStrandID);
    radiusList(1) = thisRadius;
    activeStrandList = thisStrandID;
    activeStrandFlagList(thisStrandID) = 2;
    for branchIter = 2:maxBranchSearch,
        %Find all unused connecting strands
        startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
        endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
        neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
        neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
        nextRoundStrandList = neighborStrandList(neighborFlagList);
        activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
        activeStrandFlagList(nextRoundStrandList) = 1;
        strandArterioleBranchNumList(nextRoundStrandList) = branchIter;
        activeStrandList = nextRoundStrandList;
        thisRadiusList = effectiveStrandRadiusList(activeStrandList);
        thisZList = strandMidYXZList(activeStrandList,3);
        radiusList(branchIter) = mean(thisRadiusList);
    end
    if sum(isnan(radiusList)) == 0,
        runningList = runningList + radiusList;
    end%if sum...
    figure(1);plot([0:numel(radiusList)-1],radiusList,'ro');
    figure(2);plot([0:numel(radiusList)-1],runningList,'go');pause
    
end%for arterioleIter...






%%



%Propagate out from all plunging venule strands (branchID 1)
allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;
allSurfaceStrandList = find(ismember(strandLabelList,[300:399]));

numStrands = numel(strands);
strandVenuleBranchNumList = zeros(numStrands,1);

activeStrandFlagList = zeros(numStrands,1);
activeStrandList  = [];


activeStrandFlagList(allPlungingVenuleList) = 1;
activeStrandFlagList(allSurfaceStrandList) = 2; %notActive, but not usable
activeStrandFlagList(allPlungingArterioleList) = 2; %notActive, but not usable
activeStrandList = allPlungingVenuleList;
strandVenuleBranchNumList(allPlungingVenuleList) = 1;
venuleBranchMedianEffectiveRadiusList = [];
% venuleBranchMedianAdjustedRadiusList = [];
venuleBranchMedianEffectiveRadiusList(1) = mean(effectiveStrandRadiusList(activeStrandList));
% venuleBranchMedianAdjustedRadiusList(1) = median(adjustedStrandRadiusList(activeStrandList));
thisMultiData = multiVenuleBranchList{1};
thisRadiusList = effectiveStrandRadiusList(activeStrandList);
thisZList = strandMidYXZList(activeStrandList,3);
thisData = [thisRadiusList,thisZList];
thisMultiData = [thisMultiData;thisData];
multiVenuleBranchList{1} = thisMultiData;

for branchIter = 2:maxBranchSearch,
    thisMultiData = multiVenuleBranchList{branchIter};
    numLeft = numel(find(activeStrandFlagList==0));
%     disp([branchIter,numLeft]);
    %Find all unused connecting strands
    startNeighborStrandGroup = [strands(activeStrandList).StartVertexNeighborStrands];
    endNeighborStrandGroup = [strands(activeStrandList).EndVertexNeighborStrands];
    neighborStrandList = [startNeighborStrandGroup,endNeighborStrandGroup];
    neighborFlagList = (activeStrandFlagList(neighborStrandList) == 0);
    nextRoundStrandList = neighborStrandList(neighborFlagList);
    activeStrandFlagList(activeStrandList) = 2; %notActive, but not usable
    activeStrandFlagList(nextRoundStrandList) = 1;
    strandVenuleBranchNumList(nextRoundStrandList) = branchIter;
    activeStrandList = nextRoundStrandList;
    thisRadiusList = effectiveStrandRadiusList(activeStrandList);
    thisZList = strandMidYXZList(activeStrandList,3);
    venuleBranchMedianEffectiveRadiusList(branchIter) = mean(thisRadiusList);
%     venuleBranchMedianAdjustedRadiusList(branchIter) = median(adjustedStrandRadiusList(activeStrandList));
    thisData = [thisRadiusList,thisZList];
    thisMultiData = [thisMultiData;thisData];
    multiVenuleBranchList{branchIter} = thisMultiData;
end

figure(2);plot(venuleBranchMedianEffectiveRadiusList,'b.');



%%
%-----

zRange = [0 3000]

meanA= [];
meanV = [];
stdA = [];
stdV = [];
nA = [];
nV = [];

figure(11);hold off;
figure(12);hold off;
for branchIter = 1:maxBranchSearch;
    thisAData = multiArterioleBranchList{branchIter};
    thisVData = multiVenuleBranchList{branchIter};
    aZ = thisAData(:,2);
    vZ = thisVData(:,2);
    aZFlag = and(aZ>zRange(1),aZ<zRange(2));
    vZFlag = and(vZ>zRange(1),vZ<zRange(2));
    thisAData = thisAData(aZFlag,:);
    thisVData = thisVData(vZFlag,:);
    
    
    aX = rand(size(thisAData(:,1)))+branchIter-1;
    vX = rand(size(thisVData(:,1)))+branchIter-1;
    figure(11);plot(aX,thisAData(:,1),'r.');hold on
    figure(12);plot(vX,thisVData(:,1),'b.');hold on
    meanA(branchIter) = mean(thisAData(:,1));
    stdA(branchIter) = std(thisAData(:,1));
    nA(branchIter) = numel(thisAData(:,1));
    meanV(branchIter) = mean(thisVData(:,1));
    stdV(branchIter) = std(thisVData(:,1));
    nV(branchIter) = numel(thisVData(:,1));
end%for branchIter...

figure(21);
plot([0:maxBranchSearch-1],meanA,'ro');hold on
plot([0:maxBranchSearch-1],meanA+stdA,'r^');
plot([0:maxBranchSearch-1],meanA-stdA,'rv');
% plot([0:maxBranchSearch-1],meanA+stdA./sqrt(nA),'r*');
% plot([0:maxBranchSearch-1],meanA-stdA./sqrt(nA),'r*');
hold off
xlabel('Branch away from arteriole');
ylabel('Vessel radius [um]')
title('8 datasets, 1.3 million vessels');

figure(22);
plot([0:maxBranchSearch-1],meanV,'bo');hold on
plot([0:maxBranchSearch-1],meanV+stdV,'b^');
plot([0:maxBranchSearch-1],meanV-stdV,'bv');
% plot([0:maxBranchSearch-1],meanV+stdV./sqrt(nV),'b*');
% plot([0:maxBranchSearch-1],meanV-stdV./sqrt(nV),'b*');
hold off
xlabel('Branch away from venule');
ylabel('Vessel radius [um]')
title('8 datasets, 1.3 million vessels');
    
    




