% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);


setIDNum = 4;
resetFlag = 0;

numSteps = 25;
randFlag = 0;
rand('seed',777);


switch setIDNum,
    case 1, vectorProject = allProject.au;
    case 2, vectorProject = allProject.av;
    case 3, vectorProject = allProject.co;
    case 4, vectorProject = allProject.db;
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
numPlungingArterioles = numel(allPlungingArteriolePathList);
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
allPlungingVenuleStrandIDList = [allPlungingVenulePathList{:}];
strandMidYXZList = vectorizedStructure.strandMidYXZList;

if resetFlag == 1, 
    allStepSepList = [];
end%if resetFlag == 1,

counter = 0;
for tipIter = 1:numPlungingArterioles
%find arteriole outlet
    thisArterioleList = allPlungingArteriolePathList{tipIter};
    numSegments = numel(thisArterioleList);
    
    for segIter = 1:numSegments,

        
        
        
        
        
unchosenPath = [];
        counter = counter+1;
        
% % %         if counter ==52, pause,end
        
% %     for segIter = 1:min(5,numSegments);%:numSegments,
        thisSegmentID = thisArterioleList(segIter);
        startCoord = strandMidYXZList(thisSegmentID,:);
        thisSegment = strands(thisSegmentID);
        thisVoltage = thisSegment.MedianVoltage;
        revFlag = (thisSegment.strandCurrent<0);
        switch revFlag
            case 0
                neighborStrands = thisSegment.EndVertexNeighborStrands;
                startCoord = allVerts(thisSegment.EndVertexIndex,:);
            case 1
                neighborStrands = thisSegment.StartVertexNeighborStrands;
                startCoord = allVerts(thisSegment.StartVertexIndex,:);
        end%switch
        neighborStrands = neighborStrands(neighborStrands~=thisSegmentID);
        neighborStrands = neighborStrands(~ismember(neighborStrands,thisArterioleList));
        neighborStrands = neighborStrands(~ismember(neighborStrands,allPlungingVenuleStrandIDList));
 neighborStrands = neighborStrands(~ismember(neighborStrands,unchosenPath));
        neighborVoltages = [strands(neighborStrands).MedianVoltage];
        downstreamFlags = neighborVoltages < thisVoltage;
        downstreamStrands = neighborStrands(downstreamFlags);
        previousStrandID = thisSegmentID;
        pathList = [thisSegmentID];
        stepSepList = zeros(1,numSteps);
        thisStrandID = thisSegmentID;
        thisStrand = strands(thisStrandID);
        
        
        
        
        
        
        
        for stepIter = 1:numSteps,
            newDSDistList = [];
            numDownstreamStrands = numel(downstreamStrands);
            if numDownstreamStrands == 0,
                downstreamStrands = thisStrand.EndVertexNeighborStrands;
                 numDownstreamStrands = numel(downstreamStrands);
                 disp(['Error ',num2str(stepIter)]);
                 break;
            end%if numDownstreamStrands == 0;
            %---
            for dsIter = 1:numDownstreamStrands,
                thisStrandID = downstreamStrands(dsIter);
                thisStrand = strands(thisStrandID);
                revFlag = 0;
                if ismember(previousStrandID,strands(thisStrandID).EndVertexNeighborStrands),
                    revFlag =1;
                end%if ismember
                %--    
                switch revFlag
                    case 0
                        neighborStrands = thisStrand.EndVertexNeighborStrands;
                        farCoord = allVerts(thisStrand.StartToEndIndices(end),:);
                    case 1
                        neighborStrands = thisStrand.StartVertexNeighborStrands;
                        farCoord = allVerts(thisStrand.StartToEndIndices(1),:);
                end%switch revFlag
                sepDist = sqrt(sum((farCoord(1:2)-startCoord(1:2)).^2));
                newDSDistList(dsIter) = sepDist;
            end%for dsIter
            
            if isempty(newDSDistList), 
                downstreamStrands = thisStrand.EndVertexNeighborStrands;
                newDSDistList = repmat(100,[size(downstreamStrands)]);
                maxVal = stepSepList(end);
                maxPos = 1;
            end%if isempty...
                
            
%     if isempty(newDSDistList), disp('BIG ERROR');break, end;    
            
            [maxVal,maxPos] = max(newDSDistList);
            
            if randFlag == 1,
                maxPos = ceil(rand(1)*numel(newDSDistList));
                maxVal = newDSDistList(maxPos);
            end%if randFlag == 1,
            
            
            nextStrandID = downstreamStrands(maxPos(1));
            stepSepList(stepIter) = maxVal;
            revFlag = 0;
            if ismember(previousStrandID,strands(nextStrandID).EndVertexNeighborStrands),
                revFlag =1;
            end%if ismember
            %--    
            switch revFlag
                case 0
                    neighborStrands = strands(nextStrandID).EndVertexNeighborStrands;
                case 1
                    neighborStrands = strands(nextStrandID).StartVertexNeighborStrands;
            end%switch revFlag
fullNeighborList = [neighborStrands];
            neighborStrands = neighborStrands(neighborStrands~=nextStrandID);
            neighborStrands = neighborStrands(~ismember(neighborStrands,pathList));
            neighborStrands = neighborStrands(~ismember(neighborStrands,thisArterioleList));
            neighborStrands = neighborStrands(~ismember(neighborStrands,allPlungingVenuleStrandIDList));
neighborStrands = neighborStrands(~ismember(neighborStrands,unchosenPath));
            downstreamStrands = neighborStrands;
            previousStrandID = nextStrandID;
            pathList = [pathList,previousStrandID];
            unchosenPath = [unchosenPath,fullNeighborList];
            
            
            
            
            
            
        end%for stepIter    
        allStepSepList = [allStepSepList;stepSepList];
% %         stepSepList
% %         pathList
% %         pause
    end%for segIter...
end%for tipIter

allStepSepList2 = allStepSepList;
stepDiff = diff(allStepSepList,1,2);
for kk = 1:size(allStepSepList,1);
    thisLine = allStepSepList(kk,:);
    thisDiff = [1,stepDiff(kk,:)];
    subLine = thisLine(thisDiff~=0);
    newLine = zeros(1,numSteps);
    newLine(1:numel(subLine)) = subLine;
    allStepSepList2(kk,:) = newLine;
end

myMedian = [];
for kk = 1:numSteps
    myCol = allStepSepList2(:,kk);
    myCol = myCol(myCol~=0);
    myMedian(kk) = median(myCol);
end

    
    


figure(1); plot(allStepSepList2');set(gca,'YLim',[0 1500]);
ylabel('Lateral Euclidean distance from arteriole (micrometers)')
xlabel('Number of strands along most far-reaching path');
if randFlag==1, xlabel('Number of strands along random path'); end


figure(2); plot(myMedian);set(gca,'YLim',[0 1000]);
ylabel('Lateral Euclidean distance from arteriole (micrometers)')
xlabel('Number of strands along most far-reaching path');
if randFlag==1, xlabel('Number of strands along random path'); end



figure(4); hold on;plot(myMedian,'r-');set(gca,'YLim',[0 1000]); hold off
ylabel('Lateral Euclidean distance from arteriole (micrometers)')
xlabel('Number of strands along most far-reaching path');
if randFlag==1, xlabel('Number of strands along random path'); end

