% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);


setIDNum = 1;


switch setIDNum,
    case 1, vectorProject = allProject.au;
    case 2, vectorProject = allProject.av;
    case 3, vectorProject = allProject.co;
    case 4, vectorProject = allProject.db;
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
numPlungingArterioles = numel(allPlungingArteriolePathList);
allPlunginVenulePathList = vectorizedStructure.allPlungingVenulePathList;
allPlungingVenuleStrandIDList = [allPlunginVenulePathList{:}];
strandMidYXZList = vectorizedStructure.strandMidYXZList;

stepSepList = [];
for tipIter = 1:numPlungingArterioles
%find arteriole outlet
    thisArterioleList = allPlungingArteriolePathList{tipIter};
    numSegments = numel(thisArterioleList);
    
    for segIter = 1:numSegments,
% %     for segIter = 1:min(5,numSegments);%:numSegments,
        thisSegmentID = thisArterioleList(segIter);
        startCoord = strandMidYXZList(thisSegmentID,:);
        thisSegment = strands(thisSegmentID);
        thisVoltage = thisSegment.MedianVoltage;
        revFlag = (thisSegment.strandCurrent<0);
        switch revFlag
            case 0
                neighborStrands = thisSegment.EndVertexNeighborStrands;
            case 1
                neighborStrands = thisSegment.StartVertexNeighborStrands;
        end%switch
        neighborStrands = neighborStrands(neighborStrands~=thisSegmentID);
        neighborStrands = neighborStrands(~ismember(neighborStrands,thisArterioleList));
        neighborStrands = neighborStrands(~ismember(neighborStrands,allPlungingVenuleStrandIDList));
        neighborVoltages = [strands(neighborStrands).MedianVoltage];
        downstreamFlags = neighborVoltages < thisVoltage;
        downstreamStrands = neighborStrands(downstreamFlags);
        %---
        for stepIter = 1:12,
            newDSList = [];
            numDownstreamStrands = numel(downstreamStrands);
            for dsIter = 1:numDownstreamStrands,
                thisStrandID = downstreamStrands(dsIter);
                thisStrand = strands(thisStrandID);
                thisVoltage = thisSegment.MedianVoltage;
                revFlag = (thisSegment.strandCurrent<0);
                switch revFlag
                    case 0
                        neighborStrands = thisStrand.EndVertexNeighborStrands;
                        frontCoord = allVerts(thisStrand.StartToEndIndices(1),:);
                    case 1
                        neighborStrands = thisStrand.StartVertexNeighborStrands;
                        frontCoord = allVerts(thisStrand.StartToEndIndices(end),:);
                end%switch
                neighborStrands = neighborStrands(neighborStrands~=thisSegmentID);
                neighborStrands = neighborStrands(~ismember(neighborStrands,thisArterioleList));
                neighborStrands = neighborStrands(~ismember(neighborStrands,allPlungingVenuleStrandIDList));
                neighborVoltages = [strands(neighborStrands).MedianVoltage];
                nextDownstreamFlags = neighborVoltages < thisVoltage;
                nextDownstreamStrands = neighborStrands(nextDownstreamFlags);
                newDSList = [newDSList;nextDownstreamStrands'];
                sepCoords = (startCoord(1:2) - frontCoord(1:2));
                sep = sqrt(sum(sepCoords.^2));
                stepSepList = [stepSepList;[stepIter,sep]];
            end%for dsIter
            downstreamStrands = unique(newDSList);
        end%for stepIter    
    end%for segIter...
end%for tipIter

medianDistanceList = [];
for stepIter = 1:12,
    ff = find(stepSepList(:,1)==stepIter);
    medianDistanceList(stepIter) = median(stepSepList(ff,2));
end

        
figure(1);plot(stepSepList(:,1),stepSepList(:,2),'b.');
figure(2);plot(medianDistanceList,'bo');


