% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);


setIDNum = 3;


switch setIDNum,
    case 1, vectorProject = allProject.au;
    case 2, vectorProject = allProject.av;
    case 3, vectorProject = allProject.co;
    case 4, vectorProject = allProject.db;
end

vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
numPlungingArterioles = numel(allPlungingArteriolePathList);
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numPlungingVenules = numel(allPlungingVenulePathList);
allPlungingVenuleStrandIDList = [allPlungingVenulePathList{:}];
strandMidYXZList = vectorizedStructure.strandMidYXZList;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
plungingVenuleTipList = vectorizedStructure.plungingVenuleTipList;
aYX = allVerts(plungingArterioleTipList,1:2);
vYX = allVerts(plungingVenuleTipList,1:2);

plungingArterioleBottomList = [];
for kk = 1:numPlungingArterioles,
    thisArterioleList = allPlungingArteriolePathList{kk};
    plungingArterioleBottomList(kk) = thisArterioleList(end);
end
%---
plungingVenuleBottomList = [];
for kk = 1:numPlungingVenules,
    thisVenuleList = allPlungingVenulePathList{kk};
    plungingVenuleBottomList(kk) = thisVenuleList(end);
end
aYX = allVerts(plungingArterioleBottomList,1:2);
vYX = allVerts(plungingVenuleBottomList,1:2);

minSepList = [];
mean6SepList = [];
for aIter = 1:numPlungingArterioles
    aCoords = repmat(aYX(aIter,:),[numPlungingVenules,1]);
    sepCoords = aCoords-vYX;
    sepList = sqrt(sum(sepCoords.^2,2));
    sortList = sortrows(sepList);
    minSepList(aIter) = sortList(1);
    mean6SepList(aIter) = mean(sortList(1:6));
end
    
figure(1);plot(minSepList,'r.');
figure(2);plot(mean6SepList,'b.');

% [median(minSepList),median(mean6SepList)]



%%

minSepList = [];
mean6SepList = [];
for aIter = 1:numPlungingArterioles
    aCoords = repmat(aYX(aIter,:),[numPlungingArterioles,1]);
    sepCoords = aCoords-aYX;
    sepList = sqrt(sum(sepCoords.^2,2));
    sortList = sortrows(sepList);
    minSepList(aIter) = sortList(2);
    mean6SepList(aIter) = mean(sortList(2:7));
end
    
figure(1);plot(minSepList,'r.');
figure(2);plot(mean6SepList,'b.');

% [median(minSepList),median(mean6SepList)]



%%

minSepList = [];
mean6SepList = [];
for aIter = 1:numPlungingVenules
    aCoords = repmat(vYX(aIter,:),[numPlungingVenules,1]);
    sepCoords = aCoords-vYX;
    sepList = sqrt(sum(sepCoords.^2,2));
    sortList = sortrows(sepList);
    minSepList(aIter) = sortList(2);
    mean6SepList(aIter) = mean(sortList(2:7));
end
    
figure(1);plot(minSepList,'r.');
figure(2);plot(mean6SepList,'b.');

[median(minSepList),median(mean6SepList)]
