% function effResistance = CalculatePointToPointResistance(vectorProject,vertex1ID,vertex2ID);

% load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')


for setIDNum = 1:4,

    switch setIDNum,
        case 1, vectorProject = allProject.au;
        case 2, vectorProject = allProject.av;
        case 3, vectorProject = allProject.co;
        case 4, vectorProject = allProject.db;
    end
    vectorizedStructure = vectorProject.vectorizedStructure;
    strands = vectorProject.vectorizedStructure.Strands;
    vertices = vectorProject.vectorizedStructure.Vertices;
    maskSize = vectorProject.vectorizedStructure.maskSize;
    rootName = vectorProject.vectorProjectRootName;
    findDash = findstr(rootName,'-');
    shortName = rootName(1:findDash(1)-1);
    circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
    floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
    allVerts = double(vertices.AllVerts);
    strandIndices = vertices.StrandIndices;
    cutName = shortName(3:end);
    cutName = shortName;
    adjustedRadiusList = vectorizedStructure.adjustedStrandRadiusList;
    
    eigenSetFileName = ['F:\Phil\VectorProjects\',lower(cutName),'MinusSurfaceEigenAdjRadii.mat']

    if exist('eigenValues','var') && numel(eigenValues) == numel(floatingNodeIndexList),
        disp('EigenValues already loaded');
    else
        disp('Loading EigenValues and EigenVectors');pause(0.1);
        load(eigenSetFileName);
    end

    numStrands = numel(strands);
    numFloatingNodes = numel(floatingNodeIndexList);

    switch setIDNum,
        case 1, auEigenValues = eigenValues; auEigenVectors = eigenVectors;
            auVS = vectorizedStructure;  auFNIL = floatingNodeIndexList;
        case 2, avEigenValues = eigenValues; avEigenVectors = eigenVectors;
            avVS = vectorizedStructure;  avFNIL = floatingNodeIndexList;
        case 3, coEigenValues = eigenValues; coEigenVectors = eigenVectors;
            coVS = vectorizedStructure;  coFNIL = floatingNodeIndexList;
        case 4, dbEigenValues = eigenValues; dbEigenVectors = eigenVectors;
            dbVS = vectorizedStructure;  dbFNIL = floatingNodeIndexList;
    end
end



normalizeStrandLengthFlag = 0;

%%
figure(1);hold off
for setIDNum = 1:4,

    switch setIDNum,
        case 1, vs = auVS;myMarker = 'r.';
        case 2, vs = avVS;myMarker = 'g.';
        case 3, vs = coVS;myMarker = 'b.';
        case 4, vs = dbVS;myMarker = 'c.';
    end

    allPlungingVenulePathList = vs.allPlungingVenulePathList;
    allPlungingVenuleList = vs.allPlungingVenuleList;
    numPlungingVenules = numel(allPlungingVenulePathList);
    strands = vs.Strands;
    midYXZ = vs.strandMidYXZList;
    adjustedStrandRadiusList = vs.adjustedStrandRadiusList;
    venuleRadii = adjustedStrandRadiusList(allPlungingVenuleList);
    venuleZ = midYXZ(allPlungingVenuleList,3);
    
    figure(1);plot(venuleZ,venuleRadii,myMarker); hold on
    xlabel('Strand Depth [um]');ylabel('Venule Strand Radius(adj) [um]');
    
end%for setID...


%%
figure(2);hold off
figure(3);hold off
for setIDNum = 1:4,

    switch setIDNum,
        case 1, vs = auVS;myMarker = 'r.'; floatingNodeIndexList = auFNIL;
            eigenVectors = auEigenVectors; eigenValues = auEigenValues;
        case 2, vs = avVS;myMarker = 'g.'; floatingNodeIndexList = avFNIL;
            eigenVectors = avEigenVectors; eigenValues = avEigenValues;
        case 3, vs = coVS;myMarker = 'b.'; floatingNodeIndexList = coFNIL;
            eigenVectors = coEigenVectors; eigenValues = coEigenValues;
        case 4, vs = dbVS;myMarker = 'c.'; floatingNodeIndexList = dbFNIL;
            eigenVectors = dbEigenVectors; eigenValues = dbEigenValues;
    end

    allPlungingVenulePathList = vs.allPlungingVenulePathList;
    allPlungingVenuleList = vs.allPlungingVenuleList;
    numPlungingVenules = numel(allPlungingVenulePathList);
    strands = vs.Strands;
    midYXZList = vs.strandMidYXZList;

    medianResistanceList = [];
    for depthIter = 2:50,
    effectiveResistance = [];

    for plungingIter = 1:numPlungingVenules

        thisPlungingVenulePath = allPlungingVenulePathList{plungingIter};

        if numel(thisPlungingVenulePath) >=depthIter,

            startPoint = 1;
            endPoint = depthIter;

            startingStrand = thisPlungingVenulePath(startPoint);
            endingStrand = thisPlungingVenulePath(endPoint);
            vertex1ID = strands(startingStrand).StartVertexIndex;
            vertex2ID = strands(endingStrand).StartVertexIndex;
            vertex2Depth = midYXZList(endingStrand,3);

            floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
            floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
            runSum = 0;
            mSize = size(eigenVectors,1);
            for iIter = 2:mSize;
                eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
                eVectorBeta = eigenVectors(floatingNode2ID,iIter);
                eVal = eigenValues(iIter);
                cutoff = -1;
                if eVal > cutoff,
                    runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
                end
            end%for iIter;

            effectiveResistance(plungingIter) = runSum * 2.55e7;
            figure(2);semilogy(vertex2Depth,runSum * 2.55e7,myMarker);hold on
            xlabel('Strand depth from surface [um]');ylabel('Venule Resistance (to top)[poise/um3]');

        end% if numel(thisPlungingVenulePath) >=depthIter,0
    end%for plungingITer
        medianResistanceList(depthIter) = median(effectiveResistance(effectiveResistance>0));
    disp(medianResistanceList(depthIter));
    figure(3);plot(medianResistanceList,myMarker);pause(0.1);hold on
    xlabel('Strand # from surface [um]');ylabel('Venule Resistance (to top)[poise/um3]');

    end%for depthIter

end%for setIDNum...

%%

allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numPlungingVenules = numel(allPlungingVenulePathList);


clear effectiveResistance
    
for plungingIter = 1:numPlungingVenules

    thisPlungingVenulePath = allPlungingVenulePathList{plungingIter};
    
        startPoint = 1;
        endPoint = numel(thisPlungingVenulePath);

        startingStrand = thisPlungingVenulePath(startPoint);
        endingStrand = thisPlungingVenulePath(endPoint);
        vertex1ID = strands(startingStrand).StartVertexIndex;
        vertex2ID = strands(endingStrand).StartVertexIndex;
        vertex2Depth = vectorizedStructure.strandMidYXZList(endingStrand,3);
        
        floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
        floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
        runSum = 0;
        mSize = size(eigenVectors,1);
        for iIter = 2:mSize;
            eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
            eVectorBeta = eigenVectors(floatingNode2ID,iIter);
            eVal = eigenValues(iIter);
            cutoff = -1;
            if eVal > cutoff,
                runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
            end
        end%for iIter;
        
        effectiveResistance(plungingIter) = runSum * 2.55e7;
      
end%for plungingITer
    medianResistanceList(depthIter) = median(effectiveResistance(effectiveResistance>0));
disp(medianResistanceList(depthIter));
figure(1);plot(medianResistanceList,'r.');pause(0.1);

%%


%%
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numPlungingVenules = numel(allPlungingVenulePathList);

clear medianResistanceList;
for depthIter = 1:50,
clear effectiveResistance
    
for plungingIter = 1:numPlungingVenules

    thisPlungingVenulePath = allPlungingVenulePathList{plungingIter};
    
    if numel(thisPlungingVenulePath) >=depthIter+1,

        startPoint = depthIter;
        endPoint = depthIter+1;

        startingStrand = thisPlungingVenulePath(startPoint);
        endingStrand = thisPlungingVenulePath(endPoint);
        vertex1ID = strands(startingStrand).StartVertexIndex;
        vertex2ID = strands(endingStrand).StartVertexIndex;
        vertex2Depth = vectorizedStructure.strandMidYXZList(endingStrand,3);
        
        floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
        floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
        runSum = 0;
        mSize = size(eigenVectors,1);
        for iIter = 2:mSize;
            eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
            eVectorBeta = eigenVectors(floatingNode2ID,iIter);
            eVal = eigenValues(iIter);
            cutoff = -1;
            if eVal > cutoff,
                runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));
            end
        end%for iIter;
        
        effectiveResistance(plungingIter) = runSum * 2.55e7;
        figure(3);semilogy(vertex2Depth,runSum * 2.55e7,'g.');hold on
    end% if numel(thisPlungingVenulePath) >=depthIter,0
end%for plungingITer
    medianResistanceList(depthIter) = median(effectiveResistance(effectiveResistance>0));
disp(medianResistanceList(depthIter));
figure(1);plot(medianResistanceList,'r.');pause(0.1);
end%for depthIter


%%



%%
figure(2);hold off
figure(3);hold off
for setIDNum = 1:4,

    switch setIDNum,
        case 1, vs = auVS;myMarker = 'r.'; floatingNodeIndexList = auFNIL;
            eigenVectors = auEigenVectors; eigenValues = auEigenValues;
        case 2, vs = avVS;myMarker = 'g.'; floatingNodeIndexList = avFNIL;
            eigenVectors = avEigenVectors; eigenValues = avEigenValues;
        case 3, vs = coVS;myMarker = 'b.'; floatingNodeIndexList = coFNIL;
            eigenVectors = coEigenVectors; eigenValues = coEigenValues;
        case 4, vs = dbVS;myMarker = 'c.'; floatingNodeIndexList = dbFNIL;
            eigenVectors = dbEigenVectors; eigenValues = dbEigenValues;
    end

    allPlungingVenulePathList = vs.allPlungingVenulePathList;
    allPlungingVenuleList = vs.allPlungingVenuleList;
    numPlungingVenules = numel(allPlungingVenulePathList);
    strands = vs.Strands;
    midYXZList = vs.strandMidYXZList;

    medianResistanceList = [];
    for depthIter = 2:50,
    effectiveResistance = [];

    for plungingIter = 1:numPlungingVenules

        thisPlungingVenulePath = allPlungingVenulePathList{plungingIter};

        if numel(thisPlungingVenulePath) >=depthIter,

            startPoint = 1;
            endPoint = depthIter;

            startingStrand = thisPlungingVenulePath(startPoint);
            endingStrand = thisPlungingVenulePath(endPoint);
            vertex1ID = strands(startingStrand).StartVertexIndex;
            vertex2ID = strands(endingStrand).StartVertexIndex;
            vertex2Depth = midYXZList(endingStrand,3);

            floatingNode1ID = find(floatingNodeIndexList==vertex1ID);
            floatingNode2ID = find(floatingNodeIndexList==vertex2ID);
            runSum = 0;
            mSize = size(eigenVectors,1);
            for iIter = 2:mSize;
                eVectorAlpha = eigenVectors(floatingNode1ID,iIter);
                eVectorBeta = eigenVectors(floatingNode2ID,iIter);
                eVal = eigenValues(iIter);
                cutoff = -1;
                if eVal > cutoff,
                    runSum = runSum + (((eVectorAlpha-eVectorBeta).^2)/abs(eVal));disp(runSum);%pause
                end
            end%for iIter;
            if runSum * 2.55e7 > 10, pause;end
            effectiveResistance(plungingIter) = runSum * 2.55e7;
            figure(12);semilogy(vertex2Depth,runSum * 2.55e7,myMarker);hold on
            xlabel('Strand depth from surface [um]');ylabel('Venule Resistance (to top)[poise/um3]');

        end% if numel(thisPlungingVenulePath) >=depthIter,0
    end%for plungingITer
        medianResistanceList(depthIter) = median(effectiveResistance(effectiveResistance>0));
    disp(medianResistanceList(depthIter));
    figure(13);plot(medianResistanceList,myMarker);pause(0.1);hold on
    xlabel('Strand # from surface [um]');ylabel('Venule Resistance (to top)[poise/um3]');

    end%for depthIter

end%for setIDNum...
