function outputParameters = VidaNeunCompile(inputParameters)

%-----
processedDataFolder = inputParameters.processedDataFolder;
cellCentroidList = inputParameters.cellCentroidList;
neunResultsMatFileNameList = inputParameters.neunResultsMatFileNameList;
blockGrid = inputParameters.blockGrid;
%-----

%---
approxNumCells = floor(size(cellCentroidList,1)*1.5); %over-estimate for purpose of pre-allocation with duplicates
%---
overFilledData = ones(approxNumCells,8);
numBlocks = length(blockGrid);
%-----

load(neunResultsMatFileNameList{1},'neunQuantifyResults','blockPos');

    
compiledMaskSize = [];
compiledCellCoords = zeros(0,3);
compiledMeanCell = [];
compiledStdCell = [];
compiledMedianCell = [];
compiledMeanBkg = [];
compiledStdBkg = [];
compiledMedianBkg  = [];
compiledMeanHORDCell  = [];
compiledMeanHORDBkg  = [];



for blockIter = 1:numBlocks
    yStartPos = blockGrid{blockIter}.x1min;
    xStartPos = blockGrid{blockIter}.x2min;
    zStartPos = blockGrid{blockIter}.x3min;
    yo = yStartPos - 1;
    xo = xStartPos - 1;
    zo = zStartPos - 1;

    disp(['COMPILING DATA FROM BLOCK ',num2str(blockIter),' OF ',num2str(numBlocks),' - ', datestr(now,'mm/dd/yy HH:MM:SS')]);
    load(neunResultsMatFileNameList{blockIter},'neunQuantifyResults','blockPos');


    yStartPos = blockPos.x1min;
    xStartPos = blockPos.x2min;
    zStartPos = blockPos.x3min;

    if ~isempty(neunQuantifyResults.cellCoords)        
        cellCoordsInSubBlock = neunQuantifyResults.cellCoords;
        blockPosAdd = [yStartPos,xStartPos,zStartPos]-1;
        blockPosAddMatrix = repmat(blockPosAdd,[size(cellCoordsInSubBlock,1),1]);
        cellCoords = cellCoordsInSubBlock + blockPosAddMatrix;
        maskSize = neunQuantifyResults.maskSize;
        meanCell = neunQuantifyResults.meanCell;
        stdCell = neunQuantifyResults.stdCell;
        medianCell = neunQuantifyResults.medianCell;
        meanBkg = neunQuantifyResults.meanBkg;
        stdBkg = neunQuantifyResults.stdBkg;
        medianBkg = neunQuantifyResults.medianBkg;
        meanHORDCell = neunQuantifyResults.meanHORDCell;
        meanHORDBkg = neunQuantifyResults.meanHORDBkg;

        compiledCellCoords = cat(1,compiledCellCoords,cellCoords);
        compiledMaskSize = cat(1,compiledMaskSize,maskSize);
        compiledMeanCell = cat(1,compiledMeanCell,meanCell);
        compiledStdCell = cat(1,compiledStdCell,stdCell);
        compiledMedianCell = cat(1,compiledMedianCell,medianCell);
        compiledMeanBkg = cat(1,compiledMeanBkg,meanBkg);
        compiledStdBkg = cat(1,compiledStdBkg,stdBkg);
        compiledMedianBkg = cat(1,compiledMedianBkg,medianBkg);
        compiledMeanHORDCell = cat(1,compiledMeanHORDCell,meanHORDCell);
        compiledMeanHORDBkg = cat(1,compiledMeanHORDBkg,meanHORDBkg);
    end%if ~isempty(neunQuantifyResults.cellCoords)  

end%for blockIter = 1:numBlocks


[compiledCellCoords,indI,indJ] = unique(compiledCellCoords,'rows');

compiledMaskSize = compiledMaskSize(indI);
compiledMeanCell = compiledMeanCell(indI);
compiledStdCell = compiledStdCell(indI);
compiledMedianCell = compiledMedianCell(indI);
compiledMeanBkg = compiledMeanBkg(indI);
compiledStdBkg = compiledStdBkg(indI);
compiledMedianBkg = compiledMedianBkg(indI);
compiledMeanHORDCell = compiledMeanHORDCell(indI);
compiledMeanHORDBkg = compiledMeanHORDBkg(indI);



compiledNeunResults.cellCoords = compiledCellCoords;
compiledNeunResults.maskSize = compiledMaskSize;
compiledNeunResults.meanCell = compiledMeanCell;
compiledNeunResults.stdCell = compiledStdCell;
compiledNeunResults.medianCell = compiledMedianCell;
compiledNeunResults.meanBkg = compiledMeanBkg;
compiledNeunResults.stdBkg = compiledStdBkg;
compiledNeunResults.medianBkg = compiledMedianBkg;
compiledNeunResults.meanHORDCell = compiledMeanHORDCell;
compiledNeunResults.meanHORDBkg = compiledMeanHORDBkg;
    


%-----
outputParameters = inputParameters;
outputParameters.compiledNeunResults = compiledNeunResults;

return
