function outExp = VidaNeunQuantify(inExp)
%-----
fileRootName = inExp.globalParameters.fileRootName;
lastRerunStartDateNum = inExp.globalParameters.lastRerunStartDateNum;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
fullStackSize = inExp.globalParameters.fullStackSize;
cellBlockMaskFileNameList = inExp.globalParameters.cellBlockMaskFileNameList;
vascBlockRawMaskFileNameList = inExp.globalParameters.vascBlockRawMaskFileNameList;
cellBlockFileNameList = inExp.globalParameters.cellBlockFileNameList;
neunBlockFileNameList = inExp.globalParameters.neunBlockFileNameList;
blockGrid = inExp.globalParameters.blockGrid;
cellCentroidList = inExp.globalParameters.cellCentroidList;
subVolumeOverlapSize = inExp.globalParameters.subVolumeOverlapSize;
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
%---
neunQuantifyParameters = inExp.neunQuantifyParameters;
%---
vascMaskFilterSizeInMicrons = neunQuantifyParameters.vascMaskFilterSizeInMicrons;
mainCellDilationInMicrons = neunQuantifyParameters.mainCellDilationInMicrons;
bkgShellDilationInMicrons = neunQuantifyParameters.bkgShellDilationInMicrons;
otherCellDilationInMicrons = neunQuantifyParameters.otherCellDilationInMicrons;
%---
minCellAnalysisVolumeInVoxels = neunQuantifyParameters.minCellAnalysisVolumeInVoxels;
minBkgAnalysisVolumeInVoxels = neunQuantifyParameters.minBkgAnalysisVolumeInVoxels;
%---
excludeVascFromCellFlag = neunQuantifyParameters.excludeVascFromCellFlag; %0 = no, 1 = yes
excludeVascFromBkgFlag = neunQuantifyParameters.excludeVascFromBkgFlag; %0 = no, 1 = yes




neunQuantifyFilesFolder = fullfile(processedDataFolder,'NeunQuantifyFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(neunQuantifyFilesFolder);
%-----

%QUANTIFY THE NEUN SUBBLOCKS
disp('Quantifying the NeuN Sub Blocks');
%---
neunQuantifyParameters.fileRootName = fileRootName;
neunQuantifyParameters.lastRerunStartDateNum = lastRerunStartDateNum;
neunQuantifyParameters.processedDataFolder = processedDataFolder;
neunQuantifyParameters.intermediateResultsFolder = intermediateResultsFolder;
neunQuantifyParameters.neunQuantifyFilesFolder = neunQuantifyFilesFolder;
neunQuantifyParameters.cellCentroidList = cellCentroidList;
neunQuantifyParameters.cellBlockMaskFileNameList = cellBlockMaskFileNameList;
neunQuantifyParameters.vascBlockRawMaskFileNameList = vascBlockRawMaskFileNameList;
neunQuantifyParameters.cellBlockFileNameList = cellBlockFileNameList;
neunQuantifyParameters.neunBlockFileNameList = neunBlockFileNameList;
neunQuantifyParameters.blockGrid = blockGrid;
neunQuantifyParameters.subVolumeOverlapSize = subVolumeOverlapSize;
neunQuantifyParameters.fullStackSize = fullStackSize;
neunQuantifyParameters.voxelSizeInMicrons = voxelSizeInMicrons;
    neunQuantifyParameters = VidaQuantifyNeunSubBlocks(neunQuantifyParameters);
%-----



%-----
%COMPILE TOGETHER DATA FROM ALL BLOCKS
disp(['Compling Quantified Neun Data Together : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
%---
neunCompileParameters.fileRootName = fileRootName;
neunCompileParameters.processedDataFolder = processedDataFolder;
neunCompileParameters.intermediateResultsFolder = intermediateResultsFolder;
neunCompileParameters.cellCentroidList = cellCentroidList;
neunCompileParameters.blockGrid = blockGrid;
%---
neunCompileParameters.neunResultsMatFileNameList = neunQuantifyParameters.neunResultsMatFileNameList;
%---
    neunCompileParameters = VidaNeunCompile(neunCompileParameters);
%-----



%----------
%----------
outExp = inExp;
outExp.globalParameters.compiledNeunResults = neunCompileParameters.compiledNeunResults;
%-----
outExp.neunQuantifyParameters.neunQuantifyParameters = neunQuantifyParameters;
outExp.neunQuantifyParameters.neunCompileParameters = neunCompileParameters;
%-----
outExp.completionDates.neunQuantifyCompletionDate = datestr(now);
return