function outputParameters = VidaQuantifyNeunSubBlocks(inputParameters)

%----
fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
processedDataFolder = inputParameters.processedDataFolder;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
neunQuantifyFilesFolder = inputParameters.neunQuantifyFilesFolder;
cellCentroidList = inputParameters.cellCentroidList;
cellBlockMaskFileNameList = inputParameters.cellBlockMaskFileNameList;
vascBlockRawMaskFileNameList = inputParameters.vascBlockRawMaskFileNameList;
cellBlockFileNameList = inputParameters.cellBlockFileNameList;
neunBlockFileNameList = inputParameters.neunBlockFileNameList;
blockGrid = inputParameters.blockGrid;
fullStackSize = inputParameters.fullStackSize;
voxelSizeInMicrons = inputParameters.voxelSizeInMicrons;
%-----
vascMaskFilterSizeInMicrons = inputParameters.vascMaskFilterSizeInMicrons;
mainCellDilationInMicrons = inputParameters.mainCellDilationInMicrons;
bkgShellDilationInMicrons = inputParameters.bkgShellDilationInMicrons;
otherCellDilationInMicrons = inputParameters.otherCellDilationInMicrons;
%---
excludeVascFromCellFlag = inputParameters.excludeVascFromCellFlag; %0 = no, 1 = yes
excludeVascFromBkgFlag = inputParameters.excludeVascFromBkgFlag; %0 = no, 1 = yes
%-----
subVolumeOverlapSize = inputParameters.subVolumeOverlapSize;
minCellAnalysisVolumeInVoxels = inputParameters.minCellAnalysisVolumeInVoxels;
minBkgAnalysisVolumeInVoxels = inputParameters.minBkgAnalysisVolumeInVoxels;
%-----
vascMaskFilterSize = round(vascMaskFilterSizeInMicrons ./ voxelSizeInMicrons);
mainCellDilation = round(mainCellDilationInMicrons ./ voxelSizeInMicrons);
bkgShellDilation = round(bkgShellDilationInMicrons ./ voxelSizeInMicrons);
otherCellDilation = round(otherCellDilationInMicrons ./ voxelSizeInMicrons);
%-----
%-----
neunAnalyzeSubBlockParameters.fileRootName = fileRootName;
neunAnalyzeSubBlockParameters.lastRerunStartDateNum = lastRerunStartDateNum;
neunAnalyzeSubBlockParameters.processedDataFolder = processedDataFolder;
neunAnalyzeSubBlockParameters.intermediateResultsFolder = intermediateResultsFolder;
neunAnalyzeSubBlockParameters.cellCentroidList = cellCentroidList;
neunAnalyzeSubBlockParameters.fullStackSize = fullStackSize;
neunAnalyzeSubBlockParameters.voxelSizeInMicrons = voxelSizeInMicrons;
%---
neunAnalyzeSubBlockParameters.vascMaskFilterSize = vascMaskFilterSize;
neunAnalyzeSubBlockParameters.mainCellDilation = mainCellDilation;
neunAnalyzeSubBlockParameters.bkgShellDilation = bkgShellDilation;
neunAnalyzeSubBlockParameters.otherCellDilation = otherCellDilation;
neunAnalyzeSubBlockParameters.excludeVascFromCellFlag = excludeVascFromCellFlag; %0 = no, 1 = yes
neunAnalyzeSubBlockParameters.excludeVascFromBkgFlag = excludeVascFromBkgFlag; %0 = no, 1 = yes
%-----
neunAnalyzeSubBlockParameters.subVolumeOverlapSize = subVolumeOverlapSize;
neunAnalyzeSubBlockParameters.minCellAnalysisVolumeInVoxels = minCellAnalysisVolumeInVoxels;
neunAnalyzeSubBlockParameters.minBkgAnalysisVolumeInVoxels = minBkgAnalysisVolumeInVoxels;
%-----


numBlocks = length(blockGrid);
neunResultsMatFileNameList = cell(1,numBlocks);
neunAdjCellMaskFileNameList = cell(1,numBlocks);
            
for blockIter = 1:numBlocks,
    neunResultsMatFileNameList{blockIter} = fullfile(neunQuantifyFilesFolder,['NeunEvalResultsBlock',num2str(blockIter),'.mat']);
    neunAdjCellMaskFileNameList{blockIter} = fullfile(neunQuantifyFilesFolder,['NeunAdjCellMask',num2str(blockIter),'.mat']);
    %---
    disp(['STARTING NEUN QUANTIFICATION ON BLOCK ',num2str(blockIter),' OF ',num2str(numBlocks),' - ', datestr(now,'mm/dd/yy HH:MM:SS')]);
    neunAnalyzeSubBlockParameters.blockIter = blockIter;
    neunAnalyzeSubBlockParameters.blockGrid = blockGrid;
    neunAnalyzeSubBlockParameters.neunBlockFileName = neunBlockFileNameList{blockIter};
    neunAnalyzeSubBlockParameters.cellBlockFileName = cellBlockFileNameList{blockIter};
    neunAnalyzeSubBlockParameters.cellBlockMaskFileName = cellBlockMaskFileNameList{blockIter};
    neunAnalyzeSubBlockParameters.vascBlockRawMaskFileName = vascBlockRawMaskFileNameList{blockIter};
    neunAnalyzeSubBlockParameters.neunResultsMatFileName = neunResultsMatFileNameList{blockIter};
    neunAnalyzeSubBlockParameters.neunAdjCellMaskFileName = neunAdjCellMaskFileNameList{blockIter};
   %---
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(neunResultsMatFileNameList{blockIter},'file'),
        fileExistsFlag = 1;
        fileProps = dir(neunResultsMatFileNameList{blockIter});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(neunResultsMatFileNameList{blockIter},'file'),
    %---
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp('...Skipping-Previously calculated');
    else%if and(fileExistsFlag==1,overwriteFlag==0),

        neunAnalyzeSubBlockParameters = VidaNeunAnalyzeSubBlock(neunAnalyzeSubBlockParameters);


    end%if and(fileExistsFlag==1,overwriteFlag==0),
end% for blockIter = 1:numBlocks,
%-----
outputParameters = inputParameters;
outputParameters.neunResultsMatFileNameList = neunResultsMatFileNameList;
outputParameters.neunAdjCellMaskFileNameList = neunAdjCellMaskFileNameList;


