function outExp = VidaNeuronClassify(inExp)

%-----
fileRootName = inExp.globalParameters.fileRootName;
rootDataFolder = inExp.globalParameters.rootDataFolder;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
stackedFileNameList = inExp.globalParameters.stackedFileNameList;
fullStackSize = inExp.globalParameters.fullStackSize;
compiledNeunResults = inExp.globalParameters.compiledNeunResults;
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
%-----
firstRoundParameters = inExp.neuronClassifyParameters.firstRoundParameters;
%---
neuronClassifyFilesFolder = fullfile(processedDataFolder,'NeuronClassifyFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(neuronClassifyFilesFolder);
%-----%Enable or disable flags
saveVisualizationTif = 0;

numConfig = length(compiledNeunResults);
for configIter = 1:numConfig,
    cellCoords = compiledNeunResults(configIter).cellCoords;
    maskSize = compiledNeunResults(configIter).maskSize;
    meanCell = compiledNeunResults(configIter).meanCell;
    stdCell = compiledNeunResults(configIter).stdCell;
    medianCell = compiledNeunResults(configIter).medianCell;
    meanBkg = compiledNeunResults(configIter).meanBkg;
    stdBkg = compiledNeunResults(configIter).stdBkg;
    medianBkg = compiledNeunResults(configIter).medianBkg;
    meanHORDCell = compiledNeunResults(configIter).meanHORDCell;
    meanHORDBkg = compiledNeunResults(configIter).meanHORDBkg;
    evalMetric = (meanCell-medianBkg);


    %USE LOCAL RATIO TO SEGREGATE NEURONS FROM NONNEURONS
    disp(['Config ',num2str(configIter),' Neuron Classification : ',datestr(now,'mm/dd/yy HH:MM:SS')]);

    meanCell = compiledNeunResults(configIter).meanCell;
    medianBkg = compiledNeunResults(configIter).medianBkg;
    evalMetric = (meanCell-medianBkg);

    %---
    firstRoundParameters.processedDataFolder = processedDataFolder;
    firstRoundParameters.neuronClassifyFilesFolder = neuronClassifyFilesFolder;
    firstRoundParameters.intermediateResultsFolder = intermediateResultsFolder;
    firstRoundParameters.compiledNeunResults = compiledNeunResults;
    firstRoundParameters.evalMetric = evalMetric;
    firstRoundParameters.voxelSizeInMicrons = voxelSizeInMicrons;
    %---
        firstRoundParameters = VidaNeuronRatioValueClassify(firstRoundParameters);
    neuronClassifyResults(configIter).firstRoundParameters = firstRoundParameters;
    %-----
end%for configIter = 1:numConfig,








%Just take the first score
cellCentroidAndLabelList(:,1:3) = cellCoords;
neuronScore = neuronClassifyResults(1).firstRoundParameters.neuronScore;
cellCentroidAndLabelList(:,4) = neuronScore>0;





%MAKE VISUALIZATION TIFF
if saveVisualizationTif == 1,
    disp('Generating Visualization Tif');
    neunVisualizationParameters.intermediateResultsFolder = intermediateResultsFolder;
    neunVisualizationParameters.cellCentroidAndLabelList = cellCentroidAndLabelList;
    neunVisualizationParameters.stackedFileNameList = stackedFileNameList;
    neunVisualizationParameters.fullStackSize = fullStackSize;
    neunVisualizationParameters = VidaNeunMakeVisualizationTif(neunVisualizationParameters);
end%if saveVisualizationTif == 1

%----------
%----------
outExp = inExp;
outExp.globalParameters.neuronClassifyResults = neuronClassifyResults;
outExp.globalParameters.cellCentroidAndLabelList = cellCentroidAndLabelList;
outExp.neuronClassifyParameters.firstRoundParameters = firstRoundParameters;
%---
outExp.completionDates.neuronClassifyCompletionDate = datestr(now);
%-----
return



