function VidaConvertParameterFile(varargin)
%last modified 02/08/10 by Phil Tsai

nin = nargin;
abortFlag = 0;
vidaFullFileName = which('VIDA');
[vidaPath,vidaFileName] = fileparts(vidaFullFileName);
parametersFolder = fullfile(vidaPath,'ParameterSetsFolder');
originalFolder = cd;
cd(parametersFolder);
if nin == 1,
    inputParameterMFile = varargin{1};
    [inputPath,inputFileName] = fileparts(inputParameterMFile);
else%if nin == 1,
    windowPrompt = 'Pick a parameters .m file to convert to .mat';
    [inputFileName,inputPath] = uigetfile('*.m',windowPrompt);
    if inputPath == 0,
        abortFlag = 1;
    end%if inputPath == 0
end%if-else nin == 1,
cd(originalFolder)
if abortFlag == 0,
    try
        [junkPath,fnxName] = fileparts(inputFileName);
        myCommand = ['experimentTemplate = ',fnxName,'([]);'];
        eval(myCommand);
        outputFileName = fullfile(inputPath,[fnxName,'.mat']);
        if exist(outputFileName) == 2
            overwriteFlag = questdlg('.mat Parameter file already exists.  Overwrite?','Overwrite Warning','OK','Cancel','OK');
            switch overwriteFlag,
                case {'OK'},
                    save(outputFileName,'experimentTemplate');
                    disp('Parameter .m File Converted to .mat file');
                otherwise
                    disp('PARAMETER FILE CONVERSION ABORTED.');
            end%switch overwriteFlag
        else%if exist(outputFileName) == 2
            save(outputFileName,'experimentTemplate');
            disp('Parameter .m File Converted to .mat file');
        end%if-else exist(outputFileName) == 2
    catch
        disp('Parameter Conversion hit an error');
    end%try-catch
end%if abortFlag == 0,


