myDir = dir('*-VidaProject.mat');
vidaProjectFileName = myDir(1).name;
load(vidaProjectFileName);
%-----
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
vidaProjectRootName = vidaProject.vidaProjectRootName;
%-----
currentFolder = cd;
vidaProject.vidaProjectRootFolder = currentFolder;
vidaProjectRootFolder = cd;
vectorProjectFolder = fullfile(vidaProjectRootFolder,'VectorProjectFolder');
TRFilesFolder = fullfile(vectorProjectFolder,'TRFilesFolder');




permuteSequence = [3 2 1];%Hardcode : switch y and z
xyzPermuteSequence = [1 3 2];%Hardcode : switch y and z (for xyz stored StrandData)



%-----
%-----
%-----
%-----
disp(['Converting VectorProjectFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
VectorProjectFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-VectorProject.mat']);
permutedVectorProjectFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-VectorProject_Permuted.mat']);
load(VectorProjectFileName,'vectorProject');
maskSize = vectorProject.maskSize;
vectorizedStructure = vectorProject.vectorizedStructure;
cellCentroidAndLabelList = vectorProject.cellCentroidAndLabelList;
GapConnectionStruct = vectorProject.GapConnectionStruct;
thresholdRelaxationParameters = vectorProject.thresholdRelaxationParameters;
%---
maskSize = GapConnectionStruct.maskSize;
strandSet = GapConnectionStruct.strandSet;
strandData = strandSet.strandData;
ThreshRelax = GapConnectionStruct.ThreshRelax;
BridgingStrands = ThreshRelax.BridgingStrands;
%Note that maskSize is stored as y-x-z coords sequence in rows 1-2-3
permutedMaskSize(1) = maskSize(permuteSequence(1));
permutedMaskSize(2) = maskSize(permuteSequence(2));
permutedMaskSize(3) = maskSize(permuteSequence(3));
numBridgingStrands = numel(BridgingStrands);
permutedBridgingStrands = BridgingStrands;
%note that bridingStrandCoords are stored as y-x-z coords sequence in rows 1-2-3
for bridgeIter = 1:numBridgingStrands,
    currentBridge = BridgingStrands{bridgeIter};
    if ~isempty(currentBridge);
        permutedBridge = currentBridge;
        permutedBridge(:,1) = currentBridge(:,permuteSequence(1));
        permutedBridge(:,2) = currentBridge(:,permuteSequence(2));
        permutedBridge(:,3) = currentBridge(:,permuteSequence(3));
        permutedBridgingStrands{bridgeIter} = permutedBridge;
    end%if ~isempty(currentBridge);
end%for bridgeIter = 1:numBridgingStrands,
%Note that the StrandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
strandSet.strandData = permutedStrandData;
GapConnectionStruct.strandSet = strandSet;
GapConnectionStruct.maskSize = permutedMaskSize;
GapConnectionStruct.ThreshRelax.BridgingStrands = permutedBridgingStrands;
%---
Vertices = vectorizedStructure.Vertices;
AllVerts = Vertices.AllVerts;
permutedAllVerts = AllVerts;
%Note that AllVerts is stored as y-x-z coords sequence in rows 1-2-3
permutedAllVerts(:,1) = AllVerts(:,permuteSequence(1));
permutedAllVerts(:,2) = AllVerts(:,permuteSequence(2));
permutedAllVerts(:,3) = AllVerts(:,permuteSequence(3));
vectorizedStructure.maskSize = permutedMaskSize;
vectorizedStructure.Vertices.AllVerts = permutedAllVerts;
%---
permutedCellCentroidAndLabelList = cellCentroidAndLabelList;
%Note that AllVerts is stored as y-x-z coords sequence in rows 1-2-3
permutedCellCentroidAndLabelList(:,1) = cellCentroidAndLabelList(:,permuteSequence(1));
permutedCellCentroidAndLabelList(:,2) = cellCentroidAndLabelList(:,permuteSequence(2));
permutedCellCentroidAndLabelList(:,3) = cellCentroidAndLabelList(:,permuteSequence(3));
%---
edgeBoundaryInVoxels = thresholdRelaxationParameters.edgeBoundaryInVoxels;
permutedEdgeBoundary = edgeBoundaryInVoxels;
permutedEdgeBoundary(1,:) = edgeBoundaryInVoxels(permuteSequence(1),:);
permutedEdgeBoundary(2,:) = edgeBoundaryInVoxels(permuteSequence(2),:);
permutedEdgeBoundary(3,:) = edgeBoundaryInVoxels(permuteSequence(3),:);
%---
vectorProject.maskSize = permutedMaskSize;
vectorProject.vectorizedStructure = vectorizedStructure;
vectorProject.cellCentroidAndLabelList = permutedCellCentroidAndLabelList;
vectorProject.GapConnectionStruct = GapConnectionStruct;
save(permutedVectorProjectFileName,'vectorProject');
%-----
%-----
%-----
%-----
disp(['Converting PreAddTRVectorProjectFileName : ',datestr(now,'mmddyy_HH:MM.SS')]);
VectorProjectFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-PreAddTRBridgesVectorProject.mat']);
permutedVectorProjectFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-PreAddTRBridgesVectorProject_Permuted.mat']);
load(VectorProjectFileName,'vectorProject');
maskSize = vectorProject.maskSize;
vectorizedStructure = vectorProject.vectorizedStructure;
cellCentroidAndLabelList = vectorProject.cellCentroidAndLabelList;
GapConnectionStruct = vectorProject.GapConnectionStruct;
thresholdRelaxationParameters = vectorProject.thresholdRelaxationParameters;
%---
maskSize = GapConnectionStruct.maskSize;
strandSet = GapConnectionStruct.strandSet;
strandData = strandSet.strandData;
ThreshRelax = GapConnectionStruct.ThreshRelax;
BridgingStrands = ThreshRelax.BridgingStrands;
%Note that maskSize is stored as y-x-z coords sequence in rows 1-2-3
permutedMaskSize(1) = maskSize(permuteSequence(1));
permutedMaskSize(2) = maskSize(permuteSequence(2));
permutedMaskSize(3) = maskSize(permuteSequence(3));
numBridgingStrands = numel(BridgingStrands);
permutedBridgingStrands = BridgingStrands;
%note that bridingStrandCoords are stored as y-x-z coords sequence in rows 1-2-3
for bridgeIter = 1:numBridgingStrands,
    currentBridge = BridgingStrands{bridgeIter};
    if ~isempty(currentBridge);
        permutedBridge = currentBridge;
        permutedBridge(:,1) = currentBridge(:,permuteSequence(1));
        permutedBridge(:,2) = currentBridge(:,permuteSequence(2));
        permutedBridge(:,3) = currentBridge(:,permuteSequence(3));
        permutedBridgingStrands{bridgeIter} = permutedBridge;
    end%if ~isempty(currentBridge);
end%for bridgeIter = 1:numBridgingStrands,
%Note that the StrandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
strandSet.strandData = permutedStrandData;
GapConnectionStruct.strandSet = strandSet;
GapConnectionStruct.maskSize = permutedMaskSize;
GapConnectionStruct.ThreshRelax.BridgingStrands = permutedBridgingStrands;
%---
Vertices = vectorizedStructure.Vertices;
AllVerts = Vertices.AllVerts;
permutedAllVerts = AllVerts;
%Note that AllVerts is stored as y-x-z coords sequence in rows 1-2-3
permutedAllVerts(:,1) = AllVerts(:,permuteSequence(1));
permutedAllVerts(:,2) = AllVerts(:,permuteSequence(2));
permutedAllVerts(:,3) = AllVerts(:,permuteSequence(3));
vectorizedStructure.maskSize = permutedMaskSize;
vectorizedStructure.Vertices.AllVerts = permutedAllVerts;
%---
permutedCellCentroidAndLabelList = cellCentroidAndLabelList;
%Note that AllVerts is stored as y-x-z coords sequence in rows 1-2-3
permutedCellCentroidAndLabelList(:,1) = cellCentroidAndLabelList(:,permuteSequence(1));
permutedCellCentroidAndLabelList(:,2) = cellCentroidAndLabelList(:,permuteSequence(2));
permutedCellCentroidAndLabelList(:,3) = cellCentroidAndLabelList(:,permuteSequence(3));
%---
edgeBoundaryInVoxels = thresholdRelaxationParameters.edgeBoundaryInVoxels;
permutedEdgeBoundary = edgeBoundaryInVoxels;
permutedEdgeBoundary(1,:) = edgeBoundaryInVoxels(permuteSequence(1),:);
permutedEdgeBoundary(2,:) = edgeBoundaryInVoxels(permuteSequence(2),:);
permutedEdgeBoundary(3,:) = edgeBoundaryInVoxels(permuteSequence(3),:);
%---
vectorProject.maskSize = permutedMaskSize;
vectorProject.vectorizedStructure = vectorizedStructure;
vectorProject.cellCentroidAndLabelList = permutedCellCentroidAndLabelList;
vectorProject.GapConnectionStruct = GapConnectionStruct;
save(permutedVectorProjectFileName,'vectorProject');
%-----
%-----
%-----
%-----
disp(['Converting TRFinalResultsFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
TRFinalResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRFinalResults.mat']);
permutedTRFinalResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRFinalResults_Permuted.mat']);
load(TRFinalResultsFileName,'GapConnectionStruct');
maskSize = GapConnectionStruct.maskSize;
strandSet = GapConnectionStruct.strandSet;
strandData = strandSet.strandData;
ThreshRelax = GapConnectionStruct.ThreshRelax;
BridgingStrands = ThreshRelax.BridgingStrands;
%Note that maskSize is stored as y-x-z coords sequence in rows 1-2-3
permutedMaskSize(1) = maskSize(permuteSequence(1));
permutedMaskSize(2) = maskSize(permuteSequence(2));
permutedMaskSize(3) = maskSize(permuteSequence(3));
numBridgingStrands = numel(BridgingStrands);
permutedBridgingStrands = BridgingStrands;

%note that bridingStrandCoords are stored as y-x-z coords sequence in rows 1-2-3
for bridgeIter = 1:numBridgingStrands,
    currentBridge = BridgingStrands{bridgeIter};
    if ~isempty(currentBridge);
        permutedBridge = currentBridge;
        permutedBridge(:,1) = currentBridge(:,permuteSequence(1));
        permutedBridge(:,2) = currentBridge(:,permuteSequence(2));
        permutedBridge(:,3) = currentBridge(:,permuteSequence(3));
        permutedBridgingStrands{bridgeIter} = permutedBridge;
    end%if ~isempty(currentBridge);
end%for bridgeIter = 1:numBridgingStrands,
%Note that the StrandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
strandSet.strandData = permutedStrandData;
GapConnectionStruct.strandSet = strandSet;
GapConnectionStruct.maskSize = permutedMaskSize;
GapConnectionStruct.ThreshRelax.BridgingStrands = permutedBridgingStrands;
save(permutedTRFinalResultsFileName,'GapConnectionStruct');
%-----
%-----
%-----
%-----
disp(['Converting TRPartialResultsFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
TRPartialResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRPartialResults.mat']);
permutedTRPartialResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRPartialResults_Permuted.mat']);
load(TRPartialResultsFileName,'BridgeStrands','GapConfidences','completedCycles','connectionsbyrelaxation');
numBridgeStrands = numel(BridgeStrands);
permutedBridgeStrands = BridgeStrands;
for bridgeIter = 1:numBridgeStrands,
    currentBridge = BridgeStrands{bridgeIter};
    if ~isempty(currentBridge);
        permutedBridge = currentBridge;
        permutedBridge(:,1) = currentBridge(:,permuteSequence(1));
        permutedBridge(:,2) = currentBridge(:,permuteSequence(2));
        permutedBridge(:,3) = currentBridge(:,permuteSequence(3));
        permutedBridgingStrands{bridgeIter} = permutedBridge;
    end%if ~isempty(currentBridge);
end%for bridgeIter = 1:numBridgingStrands,
BridgeStrands = permutedBridgeStrands;
save(permutedTRPartialResultsFileName,'BridgeStrands','GapConfidences','completedCycles','connectionsbyrelaxation');
%-----
%-----
%-----
%-----
disp(['Converting TRPartialResultsBackupFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
TRPartialResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRPartialResultsBackup.mat']);
permutedTRPartialResultsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-TRPartialResultsBackup_Permuted.mat']);
load(TRPartialResultsFileName,'BridgeStrands','GapConfidences','completedCycles','connectionsbyrelaxation');
numBridgeStrands = numel(BridgeStrands);
permutedBridgeStrands = BridgeStrands;
for bridgeIter = 1:numBridgeStrands,
    currentBridge = BridgeStrands{bridgeIter};
    if ~isempty(currentBridge);
        permutedBridge = currentBridge;
        permutedBridge(:,1) = currentBridge(:,permuteSequence(1));
        permutedBridge(:,2) = currentBridge(:,permuteSequence(2));
        permutedBridge(:,3) = currentBridge(:,permuteSequence(3));
        permutedBridgingStrands{bridgeIter} = permutedBridge;
    end%if ~isempty(currentBridge);
end%for bridgeIter = 1:numBridgingStrands,
BridgeStrands = permutedBridgeStrands;
save(permutedTRPartialResultsFileName,'BridgeStrands','GapConfidences','completedCycles','connectionsbyrelaxation');
%-----
%-----
%-----
%-----
disp(['Converting AugmentedPointsFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
AugmentedPointsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-AugmentedPoints.mat']);
permutedAugmentedPointsFileName = fullfile(vectorProjectFolder,[vidaProjectRootName,'-AugmentedPoints_Permuted.mat']);
load(AugmentedPointsFileName,'augmentedStruct');
maskSize = augmentedStruct.maskSize;
Vertices = augmentedStruct.Vertices;
AllVerts = Vertices.AllVerts;
permutedAllVerts = AllVerts;
%Note that maskSize & All Verts is stored as y-x-z coords sequence in rows 1-2-3
permutedMaskSize(1) = maskSize(permuteSequence(1));
permutedMaskSize(2) = maskSize(permuteSequence(2));
permutedMaskSize(3) = maskSize(permuteSequence(3));
permutedAllVerts(:,1) = AllVerts(:,permuteSequence(1));
permutedAllVerts(:,2) = AllVerts(:,permuteSequence(2));
permutedAllVerts(:,3) = AllVerts(:,permuteSequence(3));
augmentedStruct.maskSize = permutedMaskSize;
augmentedStruct.Vertices.AllVerts = permutedAllVerts;
save(AugmentedPointsFileName,'augmentedStruct');
%-----
%-----
%-----
%-----
disp(['Converting postBuildFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
postBuildFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postBuildAdjacency.mat']);
permutedPostBuildFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postBuildAdjacency_Permuted.mat']);
load(postBuildFileName,'strandSet');
strandData = strandSet.strandData;
%Note that the StrandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
strandSet.strandData = permutedStrandData;
save(permutedPostBuildFileName,'strandSet');
%-----
%-----
%-----
%-----
disp(['Converting postIslandFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
postIslandFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postIsland.mat']);
permutedPostIslandFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postIsland_Permuted.mat']);
load(postIslandFileName,'IslandCenterPoints','augmentedStrandSet','tmpxyz');
strandData = augmentedStrandSet.strandData;
%Note that the strandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
%Note that the IslandCenterPoints are stored as x-y-z coord sequence in rows 1-2-3;
permutedIslandCenterPoints = IslandCenterPoints;
permutedIslandCenterPoints(:,1) = IslandCenterPoints(:,xyzPermuteSequence(1));
permutedIslandCenterPoints(:,2) = IslandCenterPoints(:,xyzPermuteSequence(2));
permutedIslandCenterPoints(:,3) = IslandCenterPoints(:,xyzPermuteSequence(3));
%Note that the tmpxyz are stored as x-y-z coord sequence in rows 1-2-3;
permutedTmpxyz = tmpxyz;
permutedTmpxyz(:,1) = tmpxyz(:,xyzPermuteSequence(1));
permutedTmpxyz(:,2) = tmpxyz(:,xyzPermuteSequence(2));
permutedTmpxyz(:,3) = tmpxyz(:,xyzPermuteSequence(3));
%--
IslandCenterPoints = permutedIslandCenterPoints;
augmentedStrandSet.strandData = permutedStrandData;
tmpxyz = permutedTmpxyz;
save(permutedPostIslandFileName,'IslandCenterPoints','augmentedStrandSet','tmpxyz');
%-----
%-----
%-----
%-----
disp(['Converting postNearestNeighborFile : ',datestr(now,'mmddyy_HH:MM.SS')]);
postNearestNeighborFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postNearestNeighbor.mat']);
permutedPostNearestNeighborFileName = fullfile(TRFilesFolder,[vidaProjectRootName,'-postNearestNeighbor_Permuted.mat']);
load(postNearestNeighborFileName,'connections_jk','connectionsretest_jk','strandSet_jk');
strandData = strandSet_jk.strandData;
%Note that the strandData is stored as x-y-z coord sequence in rows 2-3-4;
permutedStrandData = strandData;
permutedStrandData(:,2) = strandData(:,xyzPermuteSequence(1)+1);
permutedStrandData(:,3) = strandData(:,xyzPermuteSequence(2)+1);
permutedStrandData(:,4) = strandData(:,xyzPermuteSequence(3)+1);
%Note that the connections_jk.coords are stored as x-y-z coord sequence in rows 1-2-3;
numConnections = numel(connections_jk);
permutedConnections_jk = connections_jk;
for connectIter = 1:numConnections,
    currentCoords = connections_jk(connectIter).coords;
    permutedCoords = currentCoords;
    permutedCoords(:,1) = currentCoords(:,xyzPermuteSequence(1));
    permutedCoords(:,2) = currentCoords(:,xyzPermuteSequence(2));
    permutedCoords(:,3) = currentCoords(:,xyzPermuteSequence(3));
    permutedConnections_jk(connectIter).coords = permutedCoords;
end%for connectIter = 1:numConnections,
%--
connections_jk = permutedConnections_jk;
strandSet_jk.strandData = permutedStrandData;
save(permutedPostNearestNeighborFileName,'connections_jk','connectionsretest_jk','strandSet_jk');
%-----
%-----
%-----
%-----
disp(['Converting IslandPointFiles : ',datestr(now,'mmddyy_HH:MM.SS')]);
mydir = dir(fullfile(TRFilesFolder,'islandpts*.mat'));
numFiles = numel(mydir);
for fileIter = 1:numFiles,
    fileName = mydir(fileIter).name;
    pathFileName = fullfile(TRFilesFolder,fileName);
    permutedPathFileName = regexprep(pathFileName,'.mat','_Permuted.mat');
    load(pathFileName,'islandcptmask');
    permutedIslandcptmask = permute(islandcptmask,permuteSequence);
    islandcptmask = permutedIslandcptmask;
    save(permutedPathFileName,'islandcptmask');
end

    


