function outputStructure = QuickTestVascSegVidaVascOnly(varargin)

%if input variable is a string, assume it is the name of the .m setup
%function file to run. - the strings "current" and "default" default to
%using the setup function: SuperVidaParamatersCurrent.m
%if input variable is a structure, assume the call is from the GUI
%and the setup parameters are stored in a .mat file
outputStructure = [];
nin = nargin;
if nin == 0,
    commandVariable = 'current';
else%if nin==0
    commandVariable = varargin{1};
end%if nin==0
%---
% % % if isstruct(commandVariable),
% % %     calledFromGuiFlag = 1;
% % %     setupMatFileName = commandVariable.setupMatFileName; 
% % %     parameterSetupFunctionName = 'current';
% % % else%if isstruct(commandVariable)
% % %     calledFromGuiFlag = 0;
% % %     parameterSetupFunctionName = commandVariable;
% % % end%if-else isstruct(commandVariable)
% % % %---

parameterSetupFunctionName = commandVariable;

switch parameterSetupFunctionName
    case {'default','Default','DEFAULT','def','Def','DEF'};
        parameterSetupFunctionName = 'DefaultVascQuickTestParameters.mat';
    case {'current','CURRENT','Current'}
        parameterSetupFunctionName = 'DefaultVascQuickTestParameters.mat';
    otherwise
        parameterSetupFunctionName = parameterSetupFunctionName;
end%switch parameterSetupFunctionName
%-----------
%Automatically detect rootCodeFolder and add setupFunctions
rootCodeFolder = fileparts(which('VIDA'));
addpath(fullfile(rootCodeFolder,'SetupFunctionsFolder'))
%-----
    outputProject = VidaAutoDectectVidaProjectRootFolder([]);
vidaProjectRootName = outputProject.vidaProjectRootName;
vidaProjectRootFolder = outputProject.vidaProjectRootFolder;
%----------
%SetupParameters
defaultOverwriteFilesStateFlag = 0;
vidaProjectStyleFlag = 1;

useTifStorageFlag = 0; % use variable imageStack in Mat file
skipAutoUpgradeFlag = 0;
debugModeAvoidOverwriteFlag = 1; %set to 1 to avoid overwriting all files experiment file is deleted

deleteAfterCompletedFlags.deleteOffsetTif = 1;
deleteAfterCompletedFlags.deleteSubBlockFiles = 1;
deleteAfterCompletedFlags.deleteVascBlockChannelSubFiles = 1;
deleteAfterCompletedFlags.deleteNeunBlockChannelSubFiles = 1;
deleteAfterCompletedFlags.deleteCellSeg = 1;
deleteAfterCompletedFlags.deleteVascSegFiles = 0;
deleteAfterCompletedFlags.deleteCenterlineFiles = 0;
deleteAfterCompletedFlags.deleteVascRadiiFiles = 0;

createTifFlags.createRawMaskTif = 0;
createTifFlags.createEnhMaskTif = 0;
createTifFlags.createCenterlineMaskTif = 0;

%-----

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp([' ';' ';' ']);
disp(['VIDA Script Started at ',datestr(now)]);
disp([' ';' ';' ']);
%--------------------------------------------------------------------------

%-----


vidaProject.vidaProjectRootName = vidaProjectRootName;
vidaProject.vidaProjectRootFolder = vidaProjectRootFolder;
vidaProject.rootCodeFolder = rootCodeFolder;
%---
vidaProject.progressFlags.initialized = 1;
vidaProject.progressFlags.sortOriginalTifs = 0;
vidaProject.progressFlags.createUniformityFilter = 0;
vidaProject.progressFlags.processImageStacksCompleted = 0;
vidaProject.progressFlags.multiStackProcessingCompleted = 0;


%Initialize the VidaProject file with folder names and setup Parameters
%This step initializes the vidaProject structure, but does NOT save to disk
vidaProject.setupParameters.vidaProjectRootName = vidaProjectRootName;
vidaProject.setupParameters.vidaProjectRootFolder = vidaProjectRootFolder;
vidaProject.setupParameters.parameterSetupFunctionName = parameterSetupFunctionName;
vidaProject.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
vidaProject.setupParameters.useTifStorageFlag = useTifStorageFlag;
vidaProject.setupParameters.skipAutoUpgradeFlag = skipAutoUpgradeFlag;
vidaProject.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
    vidaProject = VidaSetupVidaProjectFile(vidaProject);
revisedCodeFolders = vidaProject.setupParameters.revisedCodeFolders;
vidaProjectFileName = vidaProject.vidaProjectFileName;

%-----
experimentTemplate = vidaProject;
experimentTemplate.deleteAfterCompletedFlags = deleteAfterCompletedFlags;
experimentTemplate.createTifFlags = createTifFlags;
%-----

% experimentTemplate.globalParameters.storePixelListInExperimentFlag = 1;%noteToSelf
%-----
vidaProject.experimentTemplate = experimentTemplate;


%Add all code Folder to Matlab path
codeFolders = experimentTemplate.codeFolders;
codeFolderList = fieldnames(experimentTemplate.codeFolders);
numCodeFolders = size(codeFolderList,1);
for codeFolderIter = 1:numCodeFolders,
    currentField = codeFolderList{codeFolderIter};
    currentCodePath = experimentTemplate.codeFolders.(currentField);
    addpath(currentCodePath)
end
    


%LOAD PARAMETERS
%this step further initializes the vidaProject, but does NOT save to disk
%first, check to see if parameterSetupFunctionName is a .m file or .mat file
continueFlag = 0;
if strcmpi(parameterSetupFunctionName(end-1:end),'.m');
    [junkPath,fileNameOnly] = fileparts(parameterSetupFunctionName);
    loadParamCommand = ['experimentTemplate = ',fileNameOnly,'(experimentTemplate);']
    eval(loadParamCommand)
    disp(['LOADING PARAMETER SET: ',parameterSetupFunctionName]);
    continueFlag = 1;
end%if parameterSetupFunctionName(end-1:end) == '.m',
%---
if strcmpi(parameterSetupFunctionName(end-3:end),'.mat'),
    load(parameterSetupFunctionName,'experimentTemplate');
    continueFlag = 1;
end%if parameterSetupFunctionName(end-3:end) == '.mat',
%---
if continueFlag == 0,
    disp('NOT A VALID PARAMETER SETUP FILE');
    keyboard
end

experimentTemplate.globalParameters = experimentTemplate.basicParameters;
vidaProject.globalParameters = experimentTemplate.basicParameters;
vidaProject.experimentTemplate = experimentTemplate;
%-----
%update:
if ~isfield(experimentTemplate.basicParameters,'delayMultiplier')
    experimentTemplate.basicParameters.delayMultiplier = 1;
end%if ~isfield ...
%-----
vidaProject.experimentTemplate = experimentTemplate;




%Some specifc global-scale parameters may have been overwritten when the generic experiment Template
%was loaded.  Re-write these specific parameters to the experiment_Template
experimentTemplate.vidaProjectRootName = vidaProjectRootName;
experimentTemplate.vidaProjectRootFolder = vidaProjectRootFolder;
experimentTemplate.rootCodeFolder = rootCodeFolder;
experimentTemplate.setupParameters.vidaProjectRootName = vidaProjectRootName;
experimentTemplate.setupParameters.vidaProjectRootFolder = vidaProjectRootFolder;
experimentTemplate.setupParameters.parameterSetupFunctionName = parameterSetupFunctionName;
experimentTemplate.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
experimentTemplate.setupParameters.useTifStorageFlag = useTifStorageFlag;
experimentTemplate.setupParameters.skipAutoUpgradeFlag = skipAutoUpgradeFlag;
experimentTemplate.setupParameters.defaultOverwriteFilesStateFlag = defaultOverwriteFilesStateFlag;
experimentTemplate.setupParameters.revisedCodeFolders = revisedCodeFolders;
experimentTemplate.vidaProjectFileName = vidaProjectFileName;
%---
experimentTemplate.deleteAfterCompletedFlags = deleteAfterCompletedFlags;
experimentTemplate.createTifFlags = createTifFlags;
experimentTemplate.codeFolders = codeFolders;
%-----
%-----



%AutoAdjust the rootfolder in any existing VidaProject file in case folder has moved
%this step saves the changes in the vidaProject file to disk
    vidaProject = VidaAutoAdjustVidaProjectRootFolder(vidaProject);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%DATE STAMP VIDAPROJECT FILE OR LOAD EXISTING VIDAPROJECT FILE
%This step overloads the iniatilzed vidaProject file if one exists on disk
vidaProject.setupParameters.debugModeAvoidOverwriteFlag = debugModeAvoidOverwriteFlag;
    vidaProject = VidaLoadVidaProjectFile(vidaProject);
vidaProject.codeFolders = revisedCodeFolders;
experimentTemplate = vidaProject.experimentTemplate;
experimentTemplate.codeFolders = revisedCodeFolders;
%-----
vidaProject.experimentTemplate = experimentTemplate;
%----------
%Copy the parameters relating to the full Project to the vidaProject structure
if ~isfield(vidaProject,'registrationParameters'),
    vidaProject.registrationParameters = experimentTemplate.registrationParameters;
end%if ~isfield(vidaProject,'registrationParameters'),
%---
if ~isfield(vidaProject,'strandifyParameters'),
    vidaProject.strandifyParameters = experimentTemplate.strandifyParameters;
end%if ~isfield(vidaProject,'strandifyParameters'),
%---
saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vidaProjectFileName,'vidaProject',scs);
preMatRoot = vidaProjectFileName(1:findstr(vidaProjectFileName,'.mat')-1);
save([preMatRoot,'Backup',datestr(now,'mmddyy-HHMM'),'.mat'],'vidaProject',scs);
%--------
% % % %Check for image stack folders.  If none exist, assume data is in one big .tif file
% % % %Break it up into smaller tifs for sorting into individual folders;
% % % myDir = dir(fullfile(vidaProjectRootFolder,'ImageStack*'));
% % % numImageStackDir = size(myDir,1);
% % % if numImageStackDir == 0,
% % %     vidaProject = VidaBreakupVascOnly(vidaProject);
% % % end%if numImageStackDir == 0,




%--------
%STAGE 1 : Determine number of image stacks - allocate each to a folder
%   SORT .TIF FILES INTO INDIVIDUAL FOLDERS IF NECESSARY
% % % disp('Sorting Files');
% % % reverseXBlockNumberingFlag = vidaProject.experimentTemplate.registrationParameters.reverseXBlockNumberingFlag;
% % % reverseYBlockNumberingFlag = vidaProject.experimentTemplate.registrationParameters.reverseYBlockNumberingFlag;
% % % if vidaProject.progressFlags.sortOriginalTifs == 0,
% % %     vidaProject.globalParameters.reverseXBlockNumberingFlag = reverseXBlockNumberingFlag;
% % %     vidaProject.globalParameters.reverseYBlockNumberingFlag = reverseYBlockNumberingFlag;
% % %         vidaProject = VidaSortOriginalTifsVascOnly(vidaProject);
% % %     vidaProject.progressFlags.sortOriginalTifs = 1; 
% % %     saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
% % %     save(vidaProjectFileName,'vidaProject',scs);
% % % end%if vidaProject.progressFlags.sortOriginalTifs == 0,
% % % imageStackFolderNameList = vidaProject.imageStackFolderNameList;
% % % numImageStacks = size(imageStackFolderNameList,2);
vidaProject.imageStackFolderNameList = cd;
vidaProject.setupParameters.currentImageStackFolderName = cd;
numImageStacks = 1;

%-----
%-----
%STAGE 4 : Check out an individual image stack, and run processing.
    fprintf('\nBegin Processing of individual image stacks\n\n');
    vidaProject.multiThreadProgress.imageStackProcessingFlag = 1;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
        vidaProject = QuickTestVascSegImageStackVascOnly(vidaProject);
    vidaProject.multiThreadProgress.imageStackProcessingFlag = 2;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
end%if vidaProject.multiThreadProgress.imageStackProcessingFlag == 2,    


