function [D1,D2,D3]=DG3D(vsz)

% gradient operators for a volume size
Is1=vsz(1);
Is2=vsz(2);
Is3=vsz(3);
nvox=Is1*Is2*Is3;

disp('computing first difference operator, (dim 1)');
% column index primitive
Dx1prim=[[1:Is1-1]',[2:Is1]'];
% slice index primitive
Dx1slice=repmat(Dx1prim,Is2,1)+Is1*kron([0:Is2-1]',ones(size(Dx1prim)));
% volume indices primitive
Di1=repmat(Dx1slice,Is3,1)+Is1*Is2*kron([0:Is3-1]',ones(size(Dx1slice)));
Vi1=repmat([-1 1],size(Di1,1),1);
D1=sparse([Di1(:,1);Di1(:,1)],[Di1(:,1);Di1(:,2)],[Vi1(:,1),Vi1(:,2)],nvox,nvox);

disp('computing first difference operator, (dim 2)');
% slice index primitive
Dx2prim=[[1:Is1*(Is2-1)]',Is1+[1:Is1*(Is2-1)]'];
% volume indices primitive
Di2=repmat(Dx2prim,Is3,1)+Is1*Is2*kron([0:Is3-1]',ones(size(Dx2prim)));
Vi2=repmat([-1 1],size(Di2,1),1);
D2=sparse([Di2(:,1);Di2(:,1)],[Di2(:,1);Di2(:,2)],[Vi2(:,1),Vi2(:,2)],nvox,nvox);

disp('computing first difference operator, (dim 3)');
% volume indices primitive
Di3=[[1:Is1*Is2*(Is3-1)]',Is1*Is2+[1:Is1*Is2*(Is3-1)]'];
Vi3=repmat([-1 1],size(Di3,1),1);
D3=sparse([Di3(:,1);Di3(:,1)],[Di3(:,1);Di3(:,2)],[Vi3(:,1),Vi3(:,2)],nvox,nvox);
