function outputParameters = GetBlockAdjacency(inputParameters)

prmts = inputParameters;

BlockConfig.nblks1 = prmts.nblks1;
BlockConfig.nblks2 = prmts.nblks2;
BlockConfig.nblks3 = prmts.nblks3;
BlockConfig.nblks = [BlockConfig.nblks1,BlockConfig.nblks2,BlockConfig.nblks3];
BlockConfig.BlockArrangement = reshape(1:prod(BlockConfig.nblks),BlockConfig.nblks);
% Make a list of all block pairs
adjacentBlockPairList = GetAllBlockPairs(BlockConfig.BlockArrangement);


outputParameters = inputParameters;
outputParameters.adjacentBlockPairList = adjacentBlockPairList;

%-----------------------------------------------------------------------------------------------------------------------
function all_block_pairs = GetAllBlockPairs(BlockArrangement)

[dim1 dim2 dim3]= size(BlockArrangement); % PB supports only one zpos
[D1,D2,D3] = DG3D([dim1 dim2 dim3]); % PB supports only one zpos
AM = D1'*D1 + D2'*D2 + D3'*D3;
[all_block_pairs1,all_block_pairs2] = find(abs(AM - diag(diag(AM))));
all_block_pairs = [all_block_pairs1,all_block_pairs2];
all_block_pairs = unique(sort(all_block_pairs,2),'rows');



