function outputParameters = VidaRegistrationStackBlocksInto3DVol(inputParameters)
% This function restacks 3D tifs into one large tif after their offset
% computation by "RegBlockViaMetropolis", e.g.


registrationParameters = inputParameters;
RCZList = registrationParameters.RCZList;
blockSize = registrationParameters.fullStackSize;
adjacentBlockPairList = registrationParameters.adjacentBlockPairList;
stitchedFileNameRoot = registrationParameters.stitchedFileNameRoot;
registeredVariableName = registrationParameters.registeredVariableName;
blocks2StitchFullFileNameList = registrationParameters.blocks2StitchFullFileNameList;
nominalBlockStepSizeRC = registrationParameters.nominalBlockStepSizeRC;
nominalBlockStepSizeZ = registrationParameters.nominalBlockStepSizeZ;
overlapfusion = registrationParameters.overlapfusion;
vidaProjectRootFolder = registrationParameters.vidaProjectRootFolder;
%-----
numBlocks = length(blocks2StitchFullFileNameList);
nominalBlockOverlapRCZ(1) = blockSize(1) - nominalBlockStepSizeRC(1);
nominalBlockOverlapRCZ(2) = blockSize(2) - nominalBlockStepSizeRC(1);
nominalBlockOverlapRCZ(3) = blockSize(3) - max(nominalBlockStepSizeZ(:));
%-----

extraOverlapInPixels = 1;


if isempty(adjacentBlockPairList),
    %single block - no concatenation required
% %     outputParameters = inputParameters;
% %     outputParameters.stackedMatFileName = blocks2StitchFullFileNameList{1};
% %     outputParameters.registeredStackSize = blockSize;
    loadedVariables = load(blocks2StitchFullFileNameList{1});
    loadedVariableNames = fieldnames(loadedVariables);
    eval([registeredVariableName,' = loadedVariables.(loadedVariableNames{1});']);
    stackedMatFileName = [stitchedFileNameRoot,'.mat'];
    saveSize = (getfield(whos(registeredVariableName),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(stackedMatFileName,registeredVariableName,scs);
    outputParameters = inputParameters;
    outputParameters.stackedMatFileName = stackedMatFileName;
    outputParameters.registeredStackSize = blockSize;
    
    return%skip rest of function
end%if isempty(adjacentBlockPairList)


%InitializeRegistration
registrationParameters.path2dir = vidaProjectRootFolder;
    registrationParameters = VidaRegistrationInitStackBlocksInto3DVol(registrationParameters);
blockStacking = registrationParameters.blockStacking;
radiusFlag = 0;

if isfield(blockStacking,'overrideVoxeltype'),
    blockStacking.voxeltype = blockStacking.overrideVoxeltype;
end


if strcmp(overlapfusion,'quick'),
    sz1 = blockSize(1);
    sz2 = blockSize(2);
    sz3 = blockSize(3);
    zerobasedoffsets = blockStacking.zerobasedoffsets;
    
    numAdjacentPairs = size(adjacentBlockPairList,1);
    registeredPairOffsetList = zeros(numAdjacentPairs,3);
    blockPairStepOffsetList = zeros(numAdjacentPairs,3);
    for pairIter = 1:numAdjacentPairs,
        block1Index = adjacentBlockPairList(pairIter,1);
        block2Index = adjacentBlockPairList(pairIter,2);
        registeredPairOffsetList(pairIter,:) = zerobasedoffsets(block2Index,:)-zerobasedoffsets(block1Index,:);
        blockPairStepOffsetList(pairIter,:) = RCZList(block2Index,:) - RCZList(block1Index,:) ;
    end  
    
    
    
    % Set up stacked tif filename - repeat this for each channel that needs to be reconstructed.
    blockStacking.stackedsize = [max([blockStacking.latticecoords.x1{:}]),max([blockStacking.latticecoords.x2{:}]),max([blockStacking.latticecoords.x3{:}])];

    if prod(blockStacking.stackedsize)* 2/1024^3 > 4; write2tiffFlag = 0;end
    switch(blockStacking.voxeltype),
        case {'logical'}, myCommand = [registeredVariableName,' = false(blockStacking.stackedsize);'];%disp('logical');
        case {'uint8'}, myCommand = [registeredVariableName,' = zeros(blockStacking.stackedsize,''uint8'');'];%disp('uint8');
        case {'uint16'}, myCommand = [registeredVariableName,' = zeros(blockStacking.stackedsize,''uint16'');'];%disp('uint16');
        case {'single'}, myCommand = [registeredVariableName,' = zeros(blockStacking.stackedsize,''single'');'];%disp('single');
        case {'double'}, myCommand = [registeredVariableName,' = zeros(blockStacking.stackedsize,''double'');'];%disp('double');
    end%switch(blockStacking.voxeltype),    
    eval(myCommand);
    stackedMatFileName = [stitchedFileNameRoot,'.mat'];
    stackedTifFileName = [stitchedFileNameRoot,'.tif'];
    bc = blockStacking.blockconfig;
    [bp1,bp2,bp3] = ndgrid(1:bc(1),1:bc(2),1:bc(3));
    bp1 = bp1(:);
    bp2 = bp2(:);
    bp3 = bp3(:);
    
    
    
    blockTracker = zeros(1,numBlocks);
    for blockIter = 1:numBlocks,
        dispCharCount = fprintf('Stacking: %d %%',round(100*blockIter/numBlocks));
        zbo = zerobasedoffsets(blockIter,:);
        thisBlockFileName = blocks2StitchFullFileNameList{blockIter};
        loadedStruct = load(thisBlockFileName);
        loadedVariables = fieldnames(loadedStruct);
        numVariables = numel(loadedVariables);
        %take the largest (by dimension) variable
        maxSize = 0;
        maxPos = 1;
        for varIter = 1:numVariables,
            varSize = numel(loadedStruct.(loadedVariables{varIter}));
            if varSize>maxSize,
                maxPos = varIter;
                maxSize = varSize;
            end%if varSize>maxSize,
        end%for varIter = 1:numVariables,
        wholeBlock = loadedStruct.(loadedVariables{maxPos});
        if isstruct(wholeBlock),
            tempPixelList = wholeBlock.pixelList;
            tempMaskSize = wholeBlock.maskSize;
            if isfield(wholeBlock,'radiusList'),
                tempRadiusList = wholeBlock.radiusList;
                radiusFlag = 1;
            end%if isfield(wholeBlock,'radiusList')
            wholeBlock = false(tempMaskSize);
            wholeBlock(tempPixelList) = 1;
            if radiusFlag == 1,
                wholeBlock = single(wholeBlock);
                wholeBlock(tempPixelList) = tempRadiusList;
            end%if radiusFlag == 1,
            clear tempPixelList tempMaskSize
        end%if isstruct(blockData),
        
        %find this block in the adjacentBlockPairList
        lowerBlockPairIndex = find(adjacentBlockPairList(:,1) == blockIter);
        higherBlockPairIndex = find(adjacentBlockPairList(:,2) == blockIter);
        %start by setting the default offsets to be the full block
        off1a = 0; off2a = 0; off3a = 0; off1b = 0; off2b = 0; off3b = 0;
        %find neighbor blocks, and increase usage offset by half of the overlap.
        for lowerIter = 1:size(lowerBlockPairIndex,1),
            currentPairIndex = lowerBlockPairIndex(lowerIter);
            currentPairPartner = adjacentBlockPairList(currentPairIndex,2);
            currentPairDimension = find(blockPairStepOffsetList(currentPairIndex,:));
            currentBlockStep = registeredPairOffsetList(currentPairIndex,currentPairDimension);
            currentBlockSize = blockSize(currentPairDimension);
            currentOverlapSize = currentBlockSize - currentBlockStep;
            minimalOffset = ceil(currentOverlapSize/2);
            useOffset = minimalOffset - extraOverlapInPixels;
            switch currentPairDimension
                case 1
                    off1b = useOffset;
                case 2
                    off2b = useOffset;
                case 3
                    off3b = useOffset;
            end%switch
        end%for lowerIter = 1:size(lowerBlockPairIndex,1),
        %-----
        for higherIter = 1:size(higherBlockPairIndex,1),
            currentPairIndex = higherBlockPairIndex(higherIter);
            currentPairPartner = adjacentBlockPairList(currentPairIndex,1);
            currentPairDimension = find(blockPairStepOffsetList(currentPairIndex,:));
            currentBlockStep = registeredPairOffsetList(currentPairIndex,currentPairDimension);
            currentBlockSize = blockSize(currentPairDimension);
            currentOverlapSize = currentBlockSize - currentBlockStep;
            minimalOffset = ceil(currentOverlapSize/2);
            useOffset = minimalOffset - extraOverlapInPixels;
            switch currentPairDimension
                case 1
                    off1a = useOffset;
                case 2
                    off2a = useOffset;
                case 3
                    off3a = useOffset;
            end%switch
        end%for higherIter = 1:size(higherBlockPairIndex,1),
        %-----
        use1 = [1+off1a:sz1-off1b];
        use2 = [1+off2a:sz2-off2b];
        use3 = [1+off3a:sz3-off3b];
        
% % %         imageStack(use1+zbo(1),use2+zbo(2),use3+zbo(3)) = wholeBlock(use1,use2,use3);
        myCommand = [registeredVariableName,'(use1+zbo(1),use2+zbo(2),use3+zbo(3)) = wholeBlock(use1,use2,use3);'];
        eval(myCommand);
        
        
        
        %-----
        %check to see if the partner block has already been placed,
        %if not: spill over in that dimension to the end of the block
        %this avoid holes in the corners.
% % %         allBlockPartners = cat(2,adjacentBlockPairList(lowerBlockPairIndex,2),adjacentBlockPairList(higherBlockPairIndex,1))
        
        
        
        
        
        
        
        
        fprintf(repmat('\b',1,dispCharCount));
    end%for blockIter = 1:numBlocks,

% % %     if write2tiffFlag
% % %         for iSLICE = 1:blockStacking.stackedsize(3);
% % %             tmpslice = imageStack(:,:,iSLICE);
% % %             if or(strcmp(blockStacking.voxeltype,'uint8'),strcmp(blockStacking.voxeltype,'logical'))
% % %                 tmpslice = uint8((2^8-1)*(tmpslice>0));                              % make resulting slice binary
% % %             end%if strcmp(blockStacking.voxeltype,'uint8')
% % %             if iSLICE == 1
% % %          	  imwrite(tmpslice,stackedTifFileName,'tif','writemode','overwrite','compression','none');
% % %             else%if iSLICE == 1
% % %                 imwrite(tmpslice,stackedTifFileName,'tif','writemode','append','compression','none');
% % %             end%if elseiSLICE == 1
% % %         end%for iSLICE = 1:blockStacking.stackedsize(3);
% % %     end%if write2tiffFlag
  
else%if strcmp(overlapfusion,'quick'),
    % Set up stacked tif filename - repeat this for each channel that needs to be reconstructed.
    blockStacking.stackedsize = [max([blockStacking.latticecoords.x1{:}]),max([blockStacking.latticecoords.x2{:}]),max([blockStacking.latticecoords.x3{:}])];
    switch(blockStacking.voxeltype),
        case {'logical'}, imageStack = false(blockStacking.stackedsize);%disp('logical');
        case {'uint8'}, imageStack = zeros(blockStacking.stackedsize,'uint8');%disp('uint8');
        case {'uint16'}, imageStack = zeros(blockStacking.stackedsize,'uint16');%disp('uint16');
        case {'single'}, imageStack = zeros(blockStacking.stackedsize,'single');%disp('single');
        case {'double'}, imageStack = zeros(blockStacking.stackedsize,'double');%disp('double');
    end%switch(blockStacking.voxeltype),    
    if prod(blockStacking.stackedsize)* 2/1024^3 > 4; write2tiffFlag = 0;end
    stackedMatFileName = [stitchedFileNameRoot,'.mat'];
    stackedTifFileName = [stitchedFileNameRoot,'.tif'];    fprintf('\nBuilding slice ');
    
    chosenZ = zeros(1,blockStacking.lastslice);
    
    for iSLICE = 1:blockStacking.lastslice
        nchar = fprintf(' %d/%d ',iSLICE,blockStacking.lastslice);
        % Find all blocks that could contribute:
        contributingblocks = zeros(1,numBlocks);
        for iBLOCK = 1:numBlocks
            contributingblocks(iBLOCK) = ismember(iSLICE,blockStacking.latticecoords.x3{iBLOCK});
        end%for iBLOCK = 1:numBlocks
        cbinds = find(contributingblocks);
        % Get all block contributions and edge distances to iSLICE
        slicecontributions = cell(1,numBlocks);
        slicedistances = cell(1,numBlocks);
        for iBLOCK = 1:numBlocks
            if contributingblocks(iBLOCK)
                localslicenum = find(blockStacking.latticecoords.x3{iBLOCK} == iSLICE);
                thisBlockFileName = blocks2StitchFullFileNameList{iBLOCK};
                loadedStruct = load(thisBlockFileName);
                loadedVariables = fieldnames(loadedStruct);
                wholeBlock = loadedStruct.(loadedVariables{1});
                radiusFlag = 0;
                if isstruct(wholeBlock),
                    tempPixelList = wholeBlock.pixelList;
                    tempMaskSize = wholeBlock.maskSize;
                    if isfield(wholeBlock,'radiusList'),
                        tempRadiusList = wholeBlock.radiusList;
                        radiusFlag = 1;
                    end%if isfield(wholeBlock,'radiusList')
                    wholeBlock = false(tempMaskSize);
                    wholeBlock(tempPixelList) = 1;
                    if radiusFlag == 1,
                        wholeBlock = single(wholeBlock);
                        wholeBlock(tempPixelList) = tempRadiusList;
                    end%if radiusFlag == 1,
                    clear tempPixelList tempMaskSize
                end%if isstruct(blockData),
                %-----
                
                slicecontributions{iBLOCK} = wholeBlock(:,:,localslicenum);

                if strcmp(overlapfusion,'centermost')
                    slicedistances{iBLOCK} = blockStacking.DistanceTransform{blockStacking.distancemappings(iBLOCK)}(:,:,localslicenum);
                end%if strcmp(overlapfusion,'centermost')
                %             slicecontributions{iBLOCK} = imread(fullfile(blockStacking.datadir,blockStacking.tiffilenames{iBLOCK}),'tif',localslicenum);
                slicedistances{iBLOCK} = blockStacking.DistanceTransform{blockStacking.distancemappings(iBLOCK)}(:,:,localslicenum);
            end%if contributingblocks(iBLOCK)
        end%for iBLOCK = 1:numBlocks
        switch overlapfusion
            case {'sum'}% switch overlapfusion
                %% Initialize slice and sum all mask contributions
                disp('SUM CODE NEEDS DEBUGGING');
                keyboard
                tmpslice = single(zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),'uint8'));
                for iBLOCK = 1:numel(cbinds)
                    itmp = cbinds(iBLOCK);
                    tmpx1 = blockStacking.latticecoords.x1{itmp};
                    tmpx2 = blockStacking.latticecoords.x2{itmp};
                    tmpslice(tmpx2,tmpx1) = single(tmpslice(tmpx2,tmpx1)) + single(slicecontributions{itmp});
                end% for iBLOCK = 1:numel(cbinds)
                Stmpslice = tmpslice;

            case {'max'}% switch overlapfusion
                disp('MAX CODE NEEDS DEBUGGING');
                keyboard
                %% Initialize slice and sum all mask contributions
                tmpslice = zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),'uint16');
                for iBLOCK = 1:numel(cbinds)
                    itmp = cbinds(iBLOCK);
                    tmpx1 = blockStacking.latticecoords.x1{itmp};
                    tmpx2 = blockStacking.latticecoords.x2{itmp};
                    tmpslice(tmpx2,tmpx1) = max(uint16(tmpslice(tmpx2,tmpx1)), uint16(slicecontributions{itmp}));
                end%for iBLOCK = 1:numel(cbinds)
                Stmpslice = tmpslice;
            case {'centermost'}% switch overlapfusion
                disp('CENTERMOST CODE NEEDS DEBUGGING');
                keyboard
                %% Initialize slice and only use the mask contributions closest
                % to any block centroid (in city block distance)
                tmpslice = zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),blockStacking.voxeltype);
                oldtmpslice = tmpslice;
                Dslice = zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),'uint8');
                oldDslice = Dslice;
                for iBLOCK = 1:numel(cbinds)
                    itmp = cbinds(iBLOCK);
                    tmpx1 = blockStacking.latticecoords.x1{itmp}(:);
                    tmpx2 = blockStacking.latticecoords.x2{itmp}(:);

                    [x1block,x2block] = ndgrid(tmpx1,tmpx2);
                    x1block = x1block(:);
                    x2block = x2block(:);
                    tmpv = single(slicecontributions{itmp});
                    tmpv = tmpv(:);                                              % get the voxel value for each location
                    tmpD = slicedistances{itmp}+1;                              % Add 1 because edges are 0 otherwise
                    tmpD = tmpD(:);                                              % get the edge distance for each location

                    % if the max of the current block to add is > max of existing locations
                    if max(tmpD(:)) > max(max(Dslice(tmpx2(round(numel(tmpx2)/2)),tmpx1(round(numel(tmpx1)/2)))))
                        for iX = 1:numel(x1block)
                            if tmpD(iX) > Dslice(x2block(iX),x1block(iX))            % if the current voxel is further from the edge than previous
                                tmpslice(x2block(iX),x1block(iX)) = tmpv(iX);        % replace the voxel
                                Dslice(x2block(iX),x1block(iX)) = tmpD(iX);          % update the distances of mapped voxels
                            end%if tmpD(iX) > Dslice(x2block(iX),x1block(iX)) 
                        end%for iX = 1:numel(x1block)
                    end%if max(tmpD(:)) > max...
                end%for iBLOCK = 1:numel(cbinds)
            case {'fixedzlayer'}% switch overlapfusion
                zedgedist = zeros(1,numel(cbinds));
                for iBLOCK = 1:numel(cbinds)
                    zedgedist(iBLOCK) = max(slicedistances{cbinds(iBLOCK)}(:));
                end
                zlayerhits = histc(blockStacking.zlayers(cbinds),1:blockStacking.blockconfig(3));         % mark all layers that may contribute to this zslice
                zlayercandidates = find(zlayerhits == prod(blockStacking.blockconfig(1:2)));              % to be a candidate, zlayer has to represent every block
                if isempty(zlayercandidates)
                    [mzlh,zlayervoted] = max(zlayerhits);                                                 % or have the max # of contributions in a slice
                else%if isempty(zlayercandidates)
                    zvotes = zeros(numel(zlayercandidates),prod(blockStacking.blockconfig(1:2)));             % preallocate max distance votes
                    for iZLC = 1:numel(zlayercandidates)
                        zvotes(iZLC,:) = zedgedist(blockStacking.zlayers(cbinds) == zlayercandidates(iZLC));  % get the max distances per layer
                    end%for iZLC = 1:numel(zlayercandidates)
                    [szv,szvi] = sort(zvotes,'descend');                                                      % sort max distances, furthest z distance first
                    [mf,mfi] = max(histc(szvi(1,:),1:numel(zlayercandidates)));                               % get the candidate index with the most votes for max distance from z edge
                    zlayervoted = zlayercandidates(mfi);                                                      % identify z layer that should contribute to this z slice
                end%if else isempty(zlayercandidates)
                chosenZ(iSLICE) = zlayervoted;
                
                cbinds(~(blockStacking.zlayers(cbinds)==zlayervoted)) = [];                               % throw away all other contributing cbinds
                %% Initialize slice and only use the mask contributions closest
                % to any block centroid (in city block distance)
                if strcmp(blockStacking.voxeltype,'logical'), blockStacking.voxeltype = 'uint8'; end
                tmpslice = zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),blockStacking.voxeltype);
                oldtmpslice = tmpslice;
                Dslice = zeros(blockStacking.stackedsize(2),blockStacking.stackedsize(1),'uint8');
                oldDslice = Dslice;
                for iBLOCK = 1:numel(cbinds)
                    tic;
                    itmp = cbinds(iBLOCK);
                    tmpx1 = blockStacking.latticecoords.x1{itmp}(:);
                    tmpx2 = blockStacking.latticecoords.x2{itmp}(:);
                    [x1block,x2block] = ndgrid(tmpx1,tmpx2);
                    x1block = x1block(:);
                    x2block = x2block(:);
                    tmpv = single(slicecontributions{itmp});
                    tmpv = tmpv(:);                                              % get the voxel value for each location
                    tmpD = slicedistances{itmp}+1;                              % Add 1 because edges are 0 otherwise
                    tmpD = tmpD(:);                                              % get the edge distance for each location
                    for iX = 1:numel(x1block)
                        if tmpD(iX) > Dslice(x2block(iX),x1block(iX))            % if the current voxel is further from the edge than previous
                            tmpslice(x2block(iX),x1block(iX)) = tmpv(iX);        % replace the voxel
                            Dslice(x2block(iX),x1block(iX)) = tmpD(iX);          % update the distances of mapped voxels
                        end%if tmpD(iX) > Dslice(x2block(iX),x1block(iX))
                    end%for iX = 1:numel(x1block)
                end%for iBLOCK = 1:numel(cbinds)
            otherwise% switch overlapfusion
                error('no fusion method specified');
            end% switch overlapfusion
        if strcmp(blockStacking.voxeltype,'uint8')
            tmpslice = uint8((2^8-1)*(tmpslice>0));                              % make resulting slice binary
        end%if strcmp(blockStacking.voxeltype,'uint8')
        tmpslice = tmpslice';
        imageStack(:,:,iSLICE) = tmpslice;
        
% %         if write2tiffFlag
% %             if iSLICE == 1
% %                 imwrite(tmpslice,stackedTifFileName,'tif','writemode','overwrite','compression','none');
% %             else%if iSLICE == 1
% %                 imwrite(tmpslice,stackedTifFileName,'tif','writemode','append','compression','none');
% %             end%if else iSLICE == 1
% %         end%if write2tiffFlag
        
        
        fprintf(repmat('\b',1,nchar));
    end%for iSLICE = 1:blockStacking.lastslice
    registrationParameters.blockStacking.chosenZ = chosenZ;
end%if else strcmp(overlapfusion,'quick'),

myCommand = ['mymax = max(',registeredVariableName,'(:));'];
eval(myCommand);

if or(radiusFlag == 1 , mymax<=1),
    myCommand = ['imageStack = ',registeredVariableName,';'];
    eval(myCommand);
    registeredStackSize = size(imageStack);
    pixelList = find(imageStack);
    maskSize = size(imageStack);
    if radiusFlag == 1, 
        radiusList = imageStack(pixelList);
    end%if radiusFlag == 1, 
    imageStack = [];
    imageStack.pixelList = pixelList;
    imageStack.maskSize = maskSize;
    if radiusFlag == 1,
        imageStack.radiusList = radiusList;
    end%if radiusFlag == 1,
    myCommand = [registeredVariableName,' = imageStack;'];
    eval(myCommand);
else
    myCommand = ['registeredStackSize = size(',registeredVariableName,');'];
    eval(myCommand);
end%if or(radiusFlag == 1 , max(imageStack(:))<=1),



% % % myCommand = [registeredVariableName,' = imageStack;'];
% % % eval(myCommand);
saveSize = (getfield(whos(registeredVariableName),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(stackedMatFileName,registeredVariableName,scs);
fprintf('\n')


%-----
registrationParameters.blockStack = blockStacking;
registrationParameters.registeredStackSize = registeredStackSize;
registrationParameters.stackedMatFileName = stackedMatFileName;
outputParameters = registrationParameters;






    % For debugging purposes and mosaic element decomposition illustration
    % % 1 -> 55
    % % 9 -> 63
    % % ...
    % % 10 -> 46
    % % 18 -> 54
    % tmptmp = reshape(repmat(54:-9:0,9,1),63,1)' + mod(1:63,9)+9*(mod(1:63,9)==0);
    %
    % figure;colormap gray;
    % for iBLOCK = 1:63
    %     subplot(blockStacking.blockconfig(2),blockStacking.blockconfig(1),tmptmp(iBLOCK));
    %     imagesc(slicecontributions{cbinds(iBLOCK)}');axis off;axis image;
    % end
    % figure;colormap gray;
    % for iBLOCK = 64:126
    %     subplot(blockStacking.blockconfig(2),blockStacking.blockconfig(1),tmptmp(iBLOCK-63));
    %     imagesc(slicecontributions{cbinds(iBLOCK)}');axis off;axis image;
    % end
    % figure;colormap gray;
    % for iBLOCK = 1:63
    %     subplot(blockStacking.blockconfig(2),blockStacking.blockconfig(1),tmptmp(iBLOCK));
    %     imagesc((.5*slicecontributions{iBLOCK}')+(.5*slicecontributions{iBLOCK+63}'));axis off;axis image;
    % end
