function outProject = VidaStitchBlocks(inProject)

vidaProject = inProject;
vidaProjectFileName = vidaProject.vidaProjectFileName;
vidaProjectRootName = vidaProject.vidaProjectRootName;
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
globalParameters = vidaProject.globalParameters;
registrationParameters = vidaProject.registrationParameters;
strandifyParameters = vidaProject.strandifyParameters;
imageStackFolderNameList = vidaProject.imageStackFolderNameList;
registeredFilesFolder = globalParameters.registeredFilesFolder;
voxelSizeInMicrons = globalParameters.voxelSizeInMicrons;
stitchedFilesFolder = globalParameters.stitchedFilesFolder;
%-----
stitchVascGrayscaleFlag = registrationParameters.stitchVascGrayscaleFlag;
stitchVascGrayscaleFlag = registrationParameters.stitchCellGrayscaleFlag;
stitchVascGrayscaleFlag = registrationParameters.stitchNeunGrayscaleFlag;
stitchVascGrayscaleFlag = registrationParameters.stitchVascEnhancedGrayscaleFlag;
stitchVascGrayscaleFlag = registrationParameters.stitchVascRawMaskFlag;
stitchVascGrayscaleFlag = registrationParameters.stitchVascEnhancedMaskFlag;
%-----
%-----


if isfield(registrationParameters,'stitchVascGrayscaleFlag') && registrationParameters.stitchVascGrayscaleFlag == 1,
    disp('Stitching Registered Vasc Grayscale');
    if isfield(globalParameters,'registeredVascGrayscaleFileName') && exist(globalParameters.registeredVascGrayscaleFileName,'file')
        disp('registeredVascGrayscaleFileName previously stitched.  Skipping.');
    else%isfield(vidaProject,'registeredMultStackVascGrayscaleFileName') &&...
        registeredVariableName = 'registeredVascGrayscale';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascGrayscaleFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredVascGrayscaleFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if ~isfield(vidaProject,'registeredMultStackVascGrayscaleFileName') && ...
end%if isfield(registrationParameters,'stitchVascGrayscaleFlag') && ...
%-----
if isfield(registrationParameters,'stitchCellGrayscaleFlag') && registrationParameters.stitchCellGrayscaleFlag == 1,
    disp('Stitching Registered Cell Grayscale');
    if isfield(globalParameters,'registeredCellGrayscaleFileName') && exist(globalParameters.registeredCellGrayscaleFileName,'file')
        disp('registeredCellGrayscaleFileName previously stitched.  Skipping.');
    else%isfield(vidaProject,'registeredMultStackCellGrayscaleFileName') &&...
        registeredVariableName = 'registeredCellGrayscale';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.cellGrayscaleFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredCellGrayscaleFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if ~isfield(vidaProject,'registeredMultStackCellGrayscaleFileName') && ...
end%if isfield(registrationParameters,'stitchCellGrayscaleFlag') && ...
%-----
if isfield(registrationParameters,'stitchNeunGrayscaleFlag') && registrationParameters.stitchNeunGrayscaleFlag == 1,
    disp('Stitching Registered Neun Grayscale');
    if isfield(globalParameters,'registeredNeunGrayscaleFileName') && exist(globalParameters.registeredNeunGrayscaleFileName,'file')
        disp('registeredNeunGrayscaleFileName previously stitched.  Skipping.');
    else%isfield(vidaProject,'registeredMultStackNeunGrayscaleFileName') &&...
        registeredVariableName = 'registeredNeunGrayscale';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.neunGrayscaleFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredNeunGrayscaleFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if ~isfield(vidaProject,'registeredMultStackNeunGrayscaleFileName') && ...
end%if isfield(registrationParameters,'stitchNeunGrayscaleFlag') && ...
%-----
if isfield(registrationParameters,'stitchVascEnhancedGrayscaleFlag') && registrationParameters.stitchVascEnhancedGrayscaleFlag == 1,
    disp('Stitching Registered Vasc Enhanced Grayscale');
    if isfield(globalParameters,'registeredVascEnhancedGrayscaleFileName') && exist(globalParameters.registeredVascEnhancedGrayscaleFileName,'file')
        disp('RegisteredVascEnhancedGrayscaleFileName previously stitched.  Skipping.');
    else%isfield(vidaProject,'registeredVascEnhancedGrayscaleFileName') &&...
        registeredVariableName = 'registeredVascEnhancedGrayscale';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascEnhancedGrayscaleFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredVascEnhancedGrayscaleFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if ~isfield(vidaProject,'registeredVascEnhancedGrayscaleFileName') &&...    
end%if isfield(registrationParameters,'stitchVascEnhancedGrayscaleFlag') && ...
%-----
if isfield(registrationParameters,'stitchVascRawMaskFlag') && registrationParameters.stitchVascRawMaskFlag == 1,
    disp('Stitching Registered Vasc Raw Mask');
    if isfield(globalParameters,'registeredVascRawMaskFileName') && exist(globalParameters.registeredVascRawMaskFileName,'file')
        disp('RegisteredVascRawMaskFileName previously stitched.  Skipping.');
    else%if isfield(globalParameters,'registeredVascRawMaskFileName') &&..
        registeredVariableName = 'registeredVascRawMask';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascRawMaskFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredVascRawMaskFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if isfield(globalParameters,'registeredVascRadiusMapFileName') &&.. 
end%if isfield(registrationParameters,'stitchVascRawMaskFlag') && ...
%-----
if isfield(registrationParameters,'stitchVascEnhancedMaskFlag') && registrationParameters.stitchVascEnhancedMaskFlag == 1,
    disp('Stitching Registered Vasc Enhanced Masks');
    if isfield(globalParameters,'registeredVascEnhancedMaskFileName') && exist(globalParameters.registeredVascEnhancedMaskFileName,'file')
        disp('RegisteredVascEnhancedMaskFileName previously stitched.  Skipping.');
    else%isfield(vidaProject,'registeredVascEnhancedMaskFileName') &&...
        registeredVariableName = 'registeredVascEnhancedMask';
        stitchedFileNameRoot = fullfile(stitchedFilesFolder,[vidaProjectRootName,'-',registeredVariableName]);
        registrationParameters.blocks2StitchFullFileNameList = globalParameters.vascEnhancedMaskFileNameList;
        registrationParameters.registeredVariableName = registeredVariableName;
        registrationParameters.stitchedFileNameRoot = stitchedFileNameRoot;
            registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);
        globalParameters.registeredVascEnhancedMaskFileName = registrationParameters.stackedMatFileName;
        vidaProject.registrationParameters = registrationParameters;
        vidaProject.globalParameters = globalParameters;
        vidaProject.globalParameters.registeredStackSize = registrationParameters.registeredStackSize;
        saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vidaProjectFileName,'vidaProject',scs);
    end%if ~isfield(vidaProject,'registeredVascEnhancedMaskFileName') &&...  
end%if isfield(registrationParameters,'stitchVascEnhancedMaskFlag') && ...
%-----


outProject = vidaProject;