%stitch NeuN and DAPI gray scale data - load the vida project and cd to the output directory
%
% last updated - get NEUN demixed channel - 20101209 - Pablo

NeuNStr = 'Stacked-NEUN.mat';
DAPIStr = 'Stacked-HORD.mat';

registrationParameters = vidaProject.registrationParameters;
nBlocks = numel(registrationParameters.blockFileNameList)

registrationParameters.blockStacking.voxeltype = 'uint16';

%apply correction to file location
newLocation = 'O:\AOH\pbCO\VidaSuiteProcessing';
oldLocation = 'L:\Pablo\aoh\pbCO\VidaSuiteProcessing';
registrationParameters.path2dir = newLocation;
replaceFun = @(x) strrep(x,'L:\Pablo\aoh\pbCO\VidaSuiteProcessing','O:\AOH\pbCO\VidaSuiteProcessing');
registrationParameters.blocks2StitchFullFileNameList = ...
    cellfun(replaceFun,registrationParameters.blocks2StitchFullFileNameList,'UniformOutput',false);


%NeuN - get channel demixed 
for iBLK = 1 : nBlocks
    [path2block,blockName]= fileparts(registrationParameters.blocks2StitchFullFileNameList{iBLK});
    path2block = [path2block filesep 'neunBlockChannelSubFiles']; % get channel demixed
    pos=findstr('-',blockName);
    thisBlockName = [blockName(1:pos(end)) NeuNStr];
    registrationParameters.blocks2StitchFullFileNameList{iBLK} = fullfile(path2block,thisBlockName);
end


registrationParameters.stitchedFileNameRoot = [registrationParameters.vidaProjectRootName '-registeredNeunGrayscale'];
registrationParameters.registeredVariableName = 'registeredNeunGrayscale';
registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);



%% DAPI - channel is not spectrally contaminated
registrationParameters = vidaProject.registrationParameters;
%apply correction to file location
newLocation = 'O:\AOH\pbCO\VidaSuiteProcessing';
oldLocation = 'L:\Pablo\aoh\pbCO\VidaSuiteProcessing';
registrationParameters.path2dir = newLocation;
replaceFun = @(x) strrep(x,'L:\Pablo\aoh\pbCO\VidaSuiteProcessing','O:\AOH\pbCO\VidaSuiteProcessing');
registrationParameters.blocks2StitchFullFileNameList = ...
    cellfun(replaceFun,registrationParameters.blocks2StitchFullFileNameList,'UniformOutput',false);

for iBLK = 1 : nBlocks
    [path2block,blockName]= fileparts(registrationParameters.blocks2StitchFullFileNameList{iBLK});
    pos=findstr('-',blockName);
    thisBlockName = [blockName(1:pos(end)) DAPIStr];
    registrationParameters.blocks2StitchFullFileNameList{iBLK} = fullfile(path2block,thisBlockName);
end
registrationParameters.stitchedFileNameRoot = [registrationParameters.vidaProjectRootName '-registeredCellGrayscale'];
registrationParameters.registeredVariableName = 'registeredCellGrayscale';
registrationParameters = VidaRegistrationStackBlocksInto3DVol(registrationParameters);