% % cd('F:\Phil\VectorProjects')
% % load allProject03e_withVelocity

vectorProject = allProject.au;
vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorizedStructure.Strands;
vertices = vectorizedStructure.Vertices;
numStrands = numel(strands);
maskSize = vectorizedStructure.maskSize;
allRadii = vertices.AllRadii;
allVerts = vertices.AllVerts;

allPlungingArterioleList = vectorizedStructure.allPlungingArterioleList;
allPlungingVenuleList = vectorizedStructure.allPlungingVenuleList;

allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
allPlungingVenuleList = allPlungingVenuleList(~ismember(allPlungingVenuleList,allPlungingVenulePathList{13}));
allPlungingVenuleList = allPlungingVenuleList(~ismember(allPlungingVenuleList,allPlungingVenulePathList{9}));
allPlungingVenuleList = allPlungingVenuleList(~ismember(allPlungingVenuleList,allPlungingVenulePathList{16}));
allPlungingVenuleList = allPlungingVenuleList(~ismember(allPlungingVenuleList,allPlungingVenulePathList{31}));
allPlungingVenuleList = allPlungingVenuleList(~ismember(allPlungingVenuleList,[304 4414 5727 6586 ]));


strandMedianLabelList = [strands(:).MedianLabel];
allSurfaceArterioleList = find(ismember(strandMedianLabelList,[330:339]));
allSurfaceVenuleList = find(ismember(strandMedianLabelList,[340:349]));

strandBigVesselList = [allPlungingArterioleList,allPlungingVenuleList,allSurfaceArterioleList,allSurfaceVenuleList];
strandCapList = ~ismember([1:numStrands],[strandBigVesselList]);
allCapList = [strands(strandCapList).StartToEndIndices]; 
allSupplyList = [strands([allPlungingArterioleList,allSurfaceArterioleList]).StartToEndIndices]; 
allDrainList = [strands([allPlungingVenuleList,allSurfaceVenuleList]).StartToEndIndices]; 

allCapFlagList = false(size(allRadii));
allSupplyFlagList = false(size(allRadii));
allDrainFlagList = false(size(allRadii));
allCapFlagList(allCapList) = 1;
allSupplyFlagList(allSupplyList) = 1;
allDrainFlagList(allDrainList) = 1;

medianRadii = allRadii;
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    thisMedianRadius = vectorizedStructure.effectiveStrandRadiusList(strandIter);
    medianRadii(thisStrand.StartToEndIndices) = thisMedianRadius;
end;

divSize = 3;
smallMaskSize = ceil(maskSize/divSize);

capMask = false(smallMaskSize);
supplyMask = false(smallMaskSize);
drainMask = false(smallMaskSize);
smallDiameter = ceil(2*medianRadii/divSize);
smallVerts = ceil(allVerts/divSize);
smallInd = sub2ind(smallMaskSize,smallVerts(:,1),smallVerts(:,2),smallVerts(:,3));
maxDiameter = max(smallDiameter);

    
%%
for diameterIter = maxDiameter:-1:1;
    D = diameterIter

    
    
    thisDiameterFlagList = (smallDiameter == diameterIter);
    thisDiameterCircle = double(circle3d(diameterIter));
    minusRad = floor(diameterIter/2);
    plusRad = -1*minusRad+diameterIter-1;
    
    
    
    %cap Mask
    thisDiameterCapFlagList = and(thisDiameterFlagList,allCapFlagList);
    thisDiameterCapList = find(thisDiameterCapFlagList);
    tic
    
    for vertIter = 1:sum(thisDiameterCapFlagList>0);
        vertInd = thisDiameterCapList(vertIter);
        centerPoint = smallVerts(vertInd,:);
        qa = centerPoint-minusRad;
        qb = centerPoint+plusRad;
        outBoundsFlag = or(sum(qa<1)>0 , sum(qb>smallMaskSize)>0);
% % %         if outBoundsFlag > 0,
% % %             ya = 0;yb = 0;
% % %             if qa(1)<1, ya = 1-qa(1); end
% % %             if qb(1)>smallMaskSize(1), yb = qb-smallMaskSize(1); end
% % %             xa = 0;xb = 0;
% % %             if qa(2)<1, xa = 1-qa(2); end
% % %             if qb(2)>smallMaskSize(2), xb = qb-smallMaskSize(2); end
% % %             za = 0;zb = 0;
% % %             if qa(3)<1, za = 1-qa(3); end
% % %             if qb(3)>smallMaskSize(3), zb = qb-smallMaskSize(3); end
% % %             subField = capMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb);
% % %             cropCircle = thisDiameterCircle(1+ya:D-yb,1+xa:D-xb,1+za:D-zb);
% % %             subField = max(subField,cropCircle);
% % %             capMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb) = subField;
% % %         else
% % %             subField = capMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3));
% % %             subField = max(subField,thisDiameterCircle);
% % %             capMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3)) = subField;
% % %         end%if-else outBoundsFlag,
    capMask(centerPoint(1),centerPoint(2),centerPoint(3)) = 1;

    end%for vertIter;


    
    %supply Mask
    thisDiameterSupplyFlagList = and(thisDiameterFlagList,allSupplyFlagList);
    thisDiameterSupplyList = find(thisDiameterSupplyFlagList);
    for vertIter = 1:sum(thisDiameterSupplyFlagList>0);
        vertInd = thisDiameterSupplyList(vertIter);
        centerPoint = smallVerts(vertInd,:);
        qa = centerPoint-minusRad;
        qb = centerPoint+plusRad;
        outBoundsFlag = or(sum(qa<1)>0 , sum(qb>smallMaskSize)>0);
        if outBoundsFlag > 0,
            ya = 0;yb = 0;
            if qa(1)<1, ya = 1-qa(1); end
            if qb(1)>smallMaskSize(1), yb = qb-smallMaskSize(1); end
            xa = 0;xb = 0;
            if qa(2)<1, xa = 1-qa(2); end
            if qb(2)>smallMaskSize(2), xb = qb-smallMaskSize(2); end
            za = 0;zb = 0;
            if qa(3)<1, za = 1-qa(3); end
            if qb(3)>smallMaskSize(3), zb = qb-smallMaskSize(3); end
            subField = supplyMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb);
            cropCircle = thisDiameterCircle(1+ya:D-yb,1+xa:D-xb,1+za:D-zb);
            subField = max(subField,cropCircle);
            supplyMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb) = subField;
        else
            subField = supplyMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3));
            subField = max(subField,thisDiameterCircle);
            supplyMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3)) = subField;
        end%if-else outBoundsFlag,
    end%for vertIter;


    
    %drain Mask
    thisDiameterDrainFlagList = and(thisDiameterFlagList,allDrainFlagList);
    thisDiameterDrainList = find(thisDiameterDrainFlagList);
    for vertIter = 1:sum(thisDiameterDrainFlagList>0);
        vertInd = thisDiameterDrainList(vertIter);
        centerPoint = smallVerts(vertInd,:);
        qa = centerPoint-minusRad;
        qb = centerPoint+plusRad;
        outBoundsFlag = or(sum(qa<1)>0 , sum(qb>smallMaskSize)>0);
        if outBoundsFlag > 0,
            ya = 0;yb = 0;
            if qa(1)<1, ya = 1-qa(1); end
            if qb(1)>smallMaskSize(1), yb = qb-smallMaskSize(1); end
            xa = 0;xb = 0;
            if qa(2)<1, xa = 1-qa(2); end
            if qb(2)>smallMaskSize(2), xb = qb-smallMaskSize(2); end
            za = 0;zb = 0;
            if qa(3)<1, za = 1-qa(3); end
            if qb(3)>smallMaskSize(3), zb = qb-smallMaskSize(3); end
            subField = drainMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb);
            cropCircle = thisDiameterCircle(1+ya:D-yb,1+xa:D-xb,1+za:D-zb);
            subField = max(subField,cropCircle);
            drainMask(qa(1)+ya:qb(1)-yb,qa(2)+xa:qb(2)-xb,qa(3)+za:qb(3)-zb) = subField;
        else
            subField = drainMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3));
            subField = max(subField,thisDiameterCircle);
            drainMask(qa(1):qb(1),qa(2):qb(2),qa(3):qb(3)) = subField;
        end%if-else outBoundsFlag,
    end%for vertIter;
    
    toc
    
end










