
load('F:\Phil\VectorProjects\allProject03e_withVelocity.mat')



allAASepMin = [];
allAVSepMin = [];
allVASepMin = [];
allVVSepMin = [];
%%

% % thisZ = 400;
bufferSize = 100;
binSize = 25;    

allSubMinDListAOH = [];
for setIDNum = 1:4;


switch setIDNum,
    case 1, vectorProject = allProject.au; thisZ = 575;
    case 2, vectorProject = allProject.av; thisZ = 558;
    case 3, vectorProject = allProject.co; thisZ = 565;
    case 4, vectorProject = allProject.db; thisZ = 585;
end


vectorizedStructure = vectorProject.vectorizedStructure;
strands = vectorProject.vectorizedStructure.Strands;
vertices = vectorProject.vectorizedStructure.Vertices;
maskSize = vectorProject.vectorizedStructure.maskSize;
rootName = vectorProject.vectorProjectRootName;
findDash = findstr(rootName,'-');
shortName = rootName(1:findDash(1)-1);
circuitAnalysisParameters = vectorProject.circuitAnalysisParameters;
floatingNodeIndexList = circuitAnalysisParameters.floatingNodeIndexList;
allVerts = double(vertices.AllVerts);
strandIndices = vertices.StrandIndices;
allPlungingArteriolePathList = vectorizedStructure.allPlungingArteriolePathList;
numPlungingArterioles = numel(allPlungingArteriolePathList);
allPlungingVenulePathList = vectorizedStructure.allPlungingVenulePathList;
numPlungingVenules = numel(allPlungingVenulePathList);
allPlungingVenuleStrandIDList = [allPlungingVenulePathList{:}];
strandMidYXZList = vectorizedStructure.strandMidYXZList;
plungingArterioleTipList = vectorizedStructure.plungingArterioleTipList;
plungingVenuleTipList = vectorizedStructure.plungingVenuleTipList;


minZ = min(allVerts(:,3));



allPlungingArterioleCoordList = [];
for plungingIter = 1:numPlungingArterioles,
    thisArterioleList = allPlungingArteriolePathList{plungingIter};
    thisArterioleIndexList = [strands(thisArterioleList).StartToEndIndices];
    thisArterioleCoordList = allVerts(thisArterioleIndexList,:);
    sortArterioleCoordList = sortrows(thisArterioleCoordList,3);
    sortArterioleCoordList(:,3) = sortArterioleCoordList(:,3) - minZ;
    topList = zeros(sortArterioleCoordList(1,3)-1,3);
    topList(:,1) = sortArterioleCoordList(1,1);
    topList(:,2) = sortArterioleCoordList(1,2);
    topList(:,3) = [1:sortArterioleCoordList(1,3)-1];
    sortArterioleCoordList = [topList;sortArterioleCoordList];
    diffList = diff(sortArterioleCoordList(:,3));
    sortArterioleCoordList = sortArterioleCoordList(diffList==1,:);
    allPlungingArterioleCoordList = [allPlungingArterioleCoordList;sortArterioleCoordList];
end
%---
allPlungingVenuleCoordList = [];
for plungingIter = 1:numPlungingVenules,
    thisVenuleList = allPlungingVenulePathList{plungingIter};
    thisVenuleIndexList = [strands(thisVenuleList).StartToEndIndices];
    thisVenuleCoordList = allVerts(thisVenuleIndexList,:);
    sortVenuleCoordList = sortrows(thisVenuleCoordList,3);
    sortVenuleCoordList(:,3) = sortVenuleCoordList(:,3) - minZ;
    topList = zeros(sortVenuleCoordList(1,3)-1,3);
    topList(:,1) = sortVenuleCoordList(1,1);
    topList(:,2) = sortVenuleCoordList(1,2);
    topList(:,3) = [1:sortVenuleCoordList(1,3)-1];
    sortVenuleCoordList = [topList;sortVenuleCoordList];
    diffList = diff(sortVenuleCoordList(:,3));
    sortVenuleCoordList = sortVenuleCoordList(diffList==1,:);
    allPlungingVenuleCoordList = [allPlungingVenuleCoordList;sortVenuleCoordList];
end


%--
zFlagA = allPlungingArterioleCoordList(:,3)==thisZ;
subArterioleCoordList = allPlungingArterioleCoordList(zFlagA,:);
numSubArterioles = size(subArterioleCoordList,1);
%---
zFlagV = allPlungingVenuleCoordList(:,3)==thisZ;
subVenuleCoordList = allPlungingVenuleCoordList(zFlagV,:);
numSubVenules = size(subVenuleCoordList,1);
%---

maxY = maskSize(1)-bufferSize;
maxX = maskSize(2)-bufferSize;
sA = subArterioleCoordList;
sV = subVenuleCoordList;
insideAFlag = and(and(and(sA(:,1)<maxY,sA(:,1)>bufferSize),sA(:,2)>bufferSize),sA(:,2)<maxX);
insideVFlag = and(and(and(sV(:,1)<maxY,sV(:,1)>bufferSize),sV(:,2)>bufferSize),sV(:,2)<maxX);

insideSubArterioleCoordList = subArterioleCoordList(insideAFlag,:);
numInsideSubArterioles = size(insideSubArterioleCoordList,1);
insideSubVenuleCoordList = subVenuleCoordList(insideVFlag,:);
numInsideSubVenules = size(insideSubVenuleCoordList,1);


minSep = 5;
aaSepMin = [];
avSepMin = [];
for aIter = 1:numInsideSubArterioles
    thisACoord = insideSubArterioleCoordList(aIter,:);
    aaDiff1 = subArterioleCoordList(:,1)-thisACoord(1);
    aaDiff2 = subArterioleCoordList(:,2)-thisACoord(2);
    avDiff1 = subVenuleCoordList(:,1)-thisACoord(1);
    avDiff2 = subVenuleCoordList(:,2)-thisACoord(2);
    aaSep = sqrt(aaDiff1.^2+aaDiff2.^2);
    avSep = sqrt(avDiff1.^2+avDiff2.^2);
    aaSep = aaSep(aaSep>minSep);
    avSep = avSep(avSep>minSep);
    aaSepMin(aIter) = min(aaSep);
    avSepMin(aIter) = min(avSep);
end%for aIter;

vaSepMin = [];
vvSepMin = [];
for vIter = 1:numInsideSubVenules
    thisVCoord = insideSubVenuleCoordList(vIter,:);
    vaDiff1 = subArterioleCoordList(:,1)-thisVCoord(1);
    vaDiff2 = subArterioleCoordList(:,2)-thisVCoord(2);
    vvDiff1 = subVenuleCoordList(:,1)-thisVCoord(1);
    vvDiff2 = subVenuleCoordList(:,2)-thisVCoord(2);
    vaSep = sqrt(vaDiff1.^2+vaDiff2.^2);
    vvSep = sqrt(vvDiff1.^2+vvDiff2.^2);
    vaSep = vaSep(vaSep>minSep);
    vvSep = vvSep(vvSep>minSep);
    vaSepMin(vIter) = min(vaSep);
    vvSepMin(vIter) = min(vvSep);
    
%     if min(vvSep)<10, pause; end
    
end%for aIter;




allAASepMin = [allAASepMin,aaSepMin];
allAVSepMin = [allAVSepMin,avSepMin];
allVASepMin = [allVASepMin,vaSepMin];
allVVSepMin = [allVVSepMin,vvSepMin];



hx = [0:binSize:500];
hAA = histc(allAASepMin,hx);
hAV = histc(allAVSepMin,hx);
hVA = histc(allVASepMin,hx);
hVV = histc(allVVSepMin,hx);

myTitle = ['Analyzed at depth of ',num2str(thisZ),' micrometers'];
figure(1);b1 = bar(hx,hAA);set(b1,'FaceColor','Red');
xlabel('Arteriole Distance to Closest Arteriole'); ylabel('Number of Arterioles'); title(myTitle);
figure(2);b2 = bar(hx,hAV);set(b2,'FaceColor','Magenta');
xlabel('Arteriole Distance to Closest Venule'); ylabel('Number of Arterioles'); title(myTitle);
figure(3);b3 = bar(hx,hVA);set(b3,'FaceColor','Cyan');
xlabel('Venule Distance to Closest Arteriole'); ylabel('Number of Venule'); title(myTitle);
figure(4);b4 = bar(hx,hVV);set(b4,'FaceColor','Blue');
xlabel('Venule Distance to Closest Venule'); ylabel('Number of Venule'); title(myTitle);




blankMask = zeros(maskSize(1),maskSize(2));
for vIter = 1:numSubVenules
    blankMask(subVenuleCoordList(vIter,1),subVenuleCoordList(vIter,2)) = 1;
end

skipSize = 1;
maskArea = prod(size(blankMask));
[yi,xi] = ind2sub(size(blankMask),[1:skipSize:maskArea]);

minDList = [1:skipSize:maskArea]*inf;
for vIter = 1:numSubVenules,
    vy = subVenuleCoordList(vIter,1);
    vx = subVenuleCoordList(vIter,2);
    dd = sqrt((yi-vy).^2 + (xi-vx).^2);
    minDList = min(minDList,dd);
end

dilatedBarrelMask = zeros(size(blankMask));
dilatedBarrelMask(bufferSize:end-bufferSize,bufferSize:end-bufferSize) = 1;


minDMat = reshape(minDList,size(blankMask));
minDMat = minDMat.*dilatedBarrelMask;

subMinDList = minDMat(minDMat(:)>0);
disp(' ');
disp(mean(subMinDList));
disp(sum(dilatedBarrelMask(:)));
disp(' ');


allSubMinDListAOH = [allSubMinDListAOH;subMinDList];




end%for setIDNum


