function outputProject = VidaAutoAdjustVidaProjectRootFolder(inputProject)
    setupParameters = inputProject.setupParameters;
    vidaProjectRootFolder = inputProject.vidaProjectRootFolder;
    vidaProjectRootName = inputProject.vidaProjectRootName;
    rootCodeFolder = inputProject.rootCodeFolder;
    %----------
    %Automatically adjust vidaProjectRootFolder in vidaProject file
    clear vidaProject
    vidaProjectFileName = fullfile(vidaProjectRootFolder,[vidaProjectRootName,'-VidaProject.mat']);
    if exist(vidaProjectFileName,'file'),
        load(vidaProjectFileName,'vidaProject');
        backupVidaProjectFileName = fullfile(vidaProjectRootFolder,[vidaProjectRootName,'-VidaProjectBackup',datestr(now,'mmddyy_HHMMSS'),'.mat']);
        oldPath = vidaProject.vidaProjectRootFolder;
        oldCodeFolder = vidaProject.codeFolders.rootCodeFolder;
        if strcmpi(oldPath,vidaProjectRootFolder)~= 1,
            saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            save(backupVidaProjectFileName,'vidaProject',scs);
            %Update all the field names
            vidaProject = replacefields(vidaProject,oldPath,vidaProjectRootFolder,'no');
            vidaProject = replacefields(vidaProject,oldCodeFolder,rootCodeFolder,'no');
            saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            save(vidaProjectFileName,'vidaProject',scs);
        end%if strcmpi(oldPath,vidaProjectRootFolder)~= 1,
    end%if exist(vidaProjectFileName,'file'),
    %-----
    outputProject = inputProject;
end
