function outputParameters = VidaAutoDectectVidaProjectRootFolder(inputParameters)

disp('Automatically Detecting Data based on current folder');
currentDir = cd;
strPos = findstr(currentDir,'\ProcessedData');
if ~isempty(strPos),
    rootDataFolder = currentDir(1:strPos-1);
    slashPos = findstr(rootDataFolder,'\');
    lastSlash = slashPos(end);
    vidaProjectRootFolder = rootDataFolder(1:lastSlash-1);
    rootDirectoryFlag = 0;
else
    vidaProjectRootFolder = currentDir;
    rootDirectoryFlag = 1;
end

%Automatically detect vidaProjectRootName
if rootDirectoryFlag == 1,
    vidaProjectFiles = dir('*-VidaProject.mat');
    if ~isempty(vidaProjectFiles),
        vidaProjectFile = vidaProjectFiles(1).name;
        strPos = findstr(vidaProjectFile,'-VidaProject.mat');
        vidaProjectRootName = vidaProjectFile(1:strPos-1);
    else%if ~isempty(vidaProjectFiles),
        Ch1Files = dir('*-Ch1.tif');
        if ~isempty(Ch1Files),
            Ch1File = Ch1Files(1).name;
            strPos = findstr(Ch1File,'-');
            vidaProjectRootName = Ch1File(1:strPos(1)-1);
        else%if ~isempty(Ch1Files),
            imageStackFolders = dir('ImageStack-*');
            if ~isempty(imageStackFolders),
                imageStackFolderName = imageStackFolders(1).name;
                strPos = findstr(imageStackFolderName,'-');
                vidaProjectRootName = imageStackFolderName(strPos(1)+1:strPos(2)-1);
            else%if ~isempty(imageStackFolders),
                allTifDir = dir(fullfile(vidaProjectRootFolder,'*.tif'));
                if size(allTifDir,1) > 0,
                    tifFileName = allTifDir(1).name;
                    strPos = findstr(tifFileName,'-');
                    vidaProjectRootName = tifFileName(1:end-4);
                else%if size(allTifDir,1) > 0,
                    vidaProjectRootName = 'temporary';
                end%if-else
            end%if-else ~isempty(imageStackFolders),
        end%if ~isempty(Ch1Files),
    end%if ~isempty(vidaProjectFiles),
else%if rootDirectoryFlag == 1,  
    vidaProjectFiles = dir('*-VidaProject.mat');
    if ~isempty(vidaProjectFiles),
        vidaProjectFile = vidaProjectFiles(1).name;
        strPos = findstr(vidaProjectFile,'-VidaProject.mat');
        vidaProjectRootName = vidaProjectFile(1:strPos-1);
    else%if ~isempty(vidaProjectFiles),
        Ch1Files = dir('*-Ch1.tif');
        if ~isempty(Ch1Files),
            Ch1File = Ch1Files(1).name;
            strPos = findstr(Ch1File,'-');
            vidaProjectRootName = Ch1File(1:strPos(1)-1);
        else%if ~isempty(Ch1File),
            guessFiles = dir('*-*');
            if ~isempty(guessFiles),
                guessFile = guessFiles(1).name;
                strPos = findstr(guessFile,'-');
                vidaProjectRootName = guessFile(1:strPos(1)-1);
            else% if ~isempty(guessFiles),
                guessFiles2 = dir('ProcessedData\*-*');
                guessFile2 = guessFiles2(1).name;
                strPos = findstr(guessFile2,'-');
                vidaProjectRootName = guessFile2(1:strPos(1)-1);
            end% if ~isempty(guessFiles),
        end%if ~isempty(Ch1File),
    end%if ~isempty(vidaProjectFiles),
end%if rootDirectoryFlag == 0,



outputParameters.vidaProjectRootName = vidaProjectRootName;
outputParameters.vidaProjectRootFolder = vidaProjectRootFolder;

    