function outputParameters = VidaLoadExperimentFile(inputParameters)
    vidaProject = inputParameters;
    setupParameters = vidaProject.setupParameters;
    experiment = setupParameters.currentExperiment;
    experimentFileName = setupParameters.currentExperimentFileName;
    defaultOverwriteFilesStateFlag = setupParameters.defaultOverwriteFilesStateFlag;
    debugModeAvoidOverwriteFlag = setupParameters.debugModeAvoidOverwriteFlag;
    %-----
    revisedCodeFolders = vidaProject.codeFolders;
    %-----
    
    %----------
    %INITIALIZE EXPERIMENT FILE OR LOAD EXISTING EXPERIMENT FILE
    if exist(experimentFileName,'file');
        load(experimentFileName,'experiment');
        experiment.codeFolders = revisedCodeFolders;
    else
        experiment.globalParameters.lastRerunStartDateNum = datenum(now);
        if debugModeAvoidOverwriteFlag == 1,
            experiment.globalParameters.lastRerunStartDateNum = datenum(now)-5000;
            %this sets start date to be far in past to avoid overwriting files when
            %   the vidaProject file is deleted or changed for debugging.
        end%if debugModeAvoidOverwriteFlag == 1,
        experiment.progressFlags.overwriteOldFiles = defaultOverwriteFilesStateFlag;
        experiment.completionDates.initializedDate = datestr(now);
    end
    %----------
    %RESET OVERWRITE DATE IF OVERWRITE FLAG HAS BEEN SET TO 1
    %If the experiment.progressFlags.overwriteOldFiles == 1, then overwrite all
    %proress not indicated by other progressFlags.
    if experiment.progressFlags.overwriteOldFiles == 1,
        %Reset the "anything before this gets overwritten" date
        experiment.globalParameters.lastRerunStartDateNum = datenum(now);
        %Reset the overwriteOldFiles flag back to zero so the date doesn't keep
        %getting reset
        experiment.progressFlags.overwriteOldFiles = 0;
    end
    %----------
    outputParameters = inputParameters;
    outputParameters.currentExperiment = experiment;
    
end
