function outputProject = VidaLoadVidaProjectFile(inputProject)
    vidaProject = inputProject;
    setupParameters = inputProject.setupParameters;
    vidaProjectFileName = inputProject.vidaProjectFileName;
    revisedCodeFolders = setupParameters.revisedCodeFolders;
    debugModeAvoidOverwriteFlag = setupParameters.debugModeAvoidOverwriteFlag;
    defaultOverwriteFilesStateFlag = setupParameters.defaultOverwriteFilesStateFlag;
    %----------
    if exist(vidaProjectFileName,'file');
        load(vidaProjectFileName,'vidaProject');
        vidaProject.codeFolders = revisedCodeFolders;
    else
        vidaProject.globalParameters.lastRerunStartDateNum = datenum(now);
        if debugModeAvoidOverwriteFlag == 1,
            vidaProject.globalParameters.lastRerunStartDateNum = datenum(now)-5000;
            %this sets start date to be far in past to avoid overwriting files when
            %   the vidaProject file is deleted or changed for debugging.
        end%if debugModeAvoidOverwriteFlag == 1,
        vidaProject.progressFlags.overwriteOldFiles = defaultOverwriteFilesStateFlag;
        vidaProject.completionDates.initializedDate = datestr(now);
    end
    %--------------------------------------------------------------------------

    %RESET OVERWRITE DATE IF OVERWRITE FLAG HAS BEEN SET TO 1
    %If the vidaProject.progressFlags.overwriteOldFiles == 1, then overwrite all
    %proress not indicated by other progressFlags.
    if vidaProject.progressFlags.overwriteOldFiles == 1,
        %Reset the "anything before this gets overwritten" date
        vidaProject.globalParameters.lastRerunStartDateNum = datenum(now);
        %Reset the overwriteOldFiles flag back to zero so the date doesn't keep
        %getting reset
        vidaProject.progressFlags.overwriteOldFiles = 0;
    end
    %--------------------------------------------------------------------------
    outputProject = vidaProject;
    
end
