%Load a Strand Edit File.

filterRadiusFlag = 0;
partialStrandRadiusOption = 'Median';
wholeStrandRadiusOption = 'MedianOfMedian';

%Grab the current centerline points, radii, and labels
currentCPMatrix = globalDataStruct.cpMatrix;
currentMaskSize = globalDataStruct.maskSize;
ar = globalDataStruct.ar;
si = globalDataStruct.si;
strands = globalDataStruct.strands;
%-----
activeFlags = currentCPMatrix(:,6)==1;
cc1 = currentCPMatrix(activeFlags,1);
cc2 = currentCPMatrix(activeFlags,2);
cc3 = currentCPMatrix(activeFlags,3);
ccr = ar(activeFlags);
%-----
numStrands = size(strands,2);
numStrandsModified = 0;
keepGoingFlag = 1;
while keepGoingFlag == 1, 
    repeatRunFlag = 0;
    for strandIter = 1:numStrands,
        currentStrand = strands(strandIter);
        currentRadiusList = ar(currentStrand.StartToEndIndices);
        if min(currentRadiusList) == 0,
            skipMeFlag = 0;
            if max(currentRadiusList) == 0,
                %If the entire strand is zeroes, look to its neighbors
                %grab list of neighboring strands
                neighborStrandList = [currentStrand.StartVertexNeighborStrands,currentStrand.EndVertexNeighborStrands];
                if isempty(neighborStrandList),
                    skipMeFlag = 1;
                else%if isempty(neighborStrandList),
                    numNeighbors = size(neighborStrandList,2);
                    switch wholeStrandRadiusOption
                        case{'MedianOfMedian'},
                            neighborRadiusList =[];
                            for neighborIter = 1:numNeighbors,
                                currentNeighbor = neighborStrandList(neighborIter);
                                currentNeighborStrand = strands(currentNeighbor);
                                currentNeighborRadiusList = ar(currentNeighborStrand.StartToEndIndices);
                                currentNeighborNonZeroRadiusList = currentNeighborRadiusList(currentNeighborRadiusList~=0);
                                if isempty(currentNeighborNonZeroRadiusList),
                                    repeatRunFlag = 1;
                                    skipMeFlag = 1;
                                    neighborRadiusList = [0];
                                    break%break out of neighborIter for loop
                                end%if isempty(currentNeighborNonZeroRadiusList),
                                currentNeighborRadius = median(currentNeighborNonZeroRadiusList);
                                neighborRadiusList = [neighborRadiusList,currentNeighborRadius];
                            end%for neighborIter = 1:numNeighbors,
                            replacementRadius = median(neighborRadiusList);
                            currentRadiusList(:) = replacementRadius;
                    end%switch wholeStrandRadiusOption
                end%if-else isempty(neighborStrandList),
            end%if max(currentRadiusList) == 0,
            %-----
            if skipMeFlag == 0,
                currentNonZeroRadiusList = currentRadiusList(currentRadiusList~=0);
                switch partialStrandRadiusOption,
                    case{'Median'},
                        replacementValue = median(currentNonZeroRadiusList);
                        currentRadiusList(currentRadiusList==0) = replacementValue;
                        numStrandsModified = numStrandsModified + 1;
                end%switch partialStrandRadiusOption
            end%if skipMeFlag == 0,
        end%if min(currentRadiusList) == 0,
        %-----
        if filterRadiusFlag ~=0 ,
            %insert code to filter the radii along the strand
        end%if filterRadiusFlag ~=0 ,
        ar(currentStrand.StartToEndIndices) = currentRadiusList;
    end%for strandIter = 1:numStrands,
    %---
    if repeatRunFlag == 0,
        keepGoingFlag = 0;
    end
    %---
end%while keepGoingFlag == 1,
%-----
globalDataStruct.ar = ar;
%-----
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE',dateString,'-RadiusModified','-StrandEdit-',fileName,ext]);
save(saveFileName,'globalDataStruct');






    