
if ~exist('variableCleanupFlag','var'), 
    variableCleanupFlag = 0;
end
%---


maskSize = globalDataStruct.maskSize;
cpMatrix = globalDataStruct.cpMatrix;
strands = globalDataStruct.strands;
%---
voltageVector = analysisResults.voltageVector;
nodesConnectedByStrand = analysisResults.nodesConnectedByStrand;
strandConductanceList = analysisResults.strandConductanceList;
nodeCPID = analysisResults.nodeCPID;
groundStrandList = analysisResults.groundStrandList;
voltageStrandList = analysisResults.voltageStrandList;
freeNodeList = analysisResults.freeNodeList;
groundNodeList = analysisResults.groundNodeList;
voltageNodeList = analysisResults.voltageNodeList;



%-----
myMask = zeros(maskSize,'uint8');
cpVoltageList = zeros(size(cpMatrix,1),1);
normCPVoltageList = zeros(size(cpMatrix,1),1);

%Generate a current map from 55 to 255
%(the 55 offset allows a margin around zero to set opacity maps for bkg to 0)

% voltageVector = max(min(voltageVector,400),330);

lowV = 55;
highV = 255;
maxVoltage = max(voltageVector);
minVoltage = min(voltageVector);
sortVoltage = sort(voltageVector);
numVoltage = numel(sortVoltage);
minVoltage = sortVoltage(ceil(numVoltage*0.1))
maxVoltage = sortVoltage(ceil(numVoltage*0.9))
satVoltage = min(maxVoltage,max(minVoltage,voltageVector));
voltageRange = maxVoltage-minVoltage;
normVoltageVector = lowV + (highV-lowV)*(satVoltage-minVoltage)./voltageRange;

numStrands = numel(strands);
for strandIter = 1:numStrands,
    thisStrandID = strandIter;
    strandCompletedFlag = 0;
    voltage1 = -999;
    voltage2 = -999;
    stei = strands(thisStrandID).StartToEndIndices;
    if ismember(thisStrandID,voltageStrandList),
        cpVoltageList(stei) = Ev;
        normCPVoltageList(stei) = highV;
        for pointIter = 1:numel(stei),
            cp = cpMatrix(stei(pointIter),1:3);
            myMask(cp(1),cp(2),cp(3)) = highV;
            strandCompletedFlag = 1;
        end%for pointIter = 1:numel(stei),
    end%if ismember(thisStrandID,voltageStrandList)
    %---
    if ismember(thisStrandID,groundStrandList),
        cpVoltageList(stei) = Eg;
        normCPVoltageList(stei) = lowV;
        for pointIter = 1:numel(stei),
            cp = cpMatrix(stei(pointIter),1:3);
            myMask(cp(1),cp(2),cp(3)) = lowV;
            strandCompletedFlag = 1;
        end%for pointIter = 1:numel(stei),
    end%if ismember(thisStrandID,voltageStrandList)
    %---
    if strandCompletedFlag == 0,
        node1 = nodesConnectedByStrand(thisStrandID,1);
        node2 = nodesConnectedByStrand(thisStrandID,2);
        node1CP = nodeCPID(node1);
        node2CP = nodeCPID(node2);
        if node1CP ~= stei(1),
            stei = fliplr(stei);
        end%if node1CP ~= stei(1),
        %---
        if ismember(node1,voltageNodeList), normVoltage1 = highV; voltage1 = Ev; end
        if ismember(node2,voltageNodeList), normVoltage2 = highV; voltage1 = Ev; end
        if ismember(node1,groundNodeList), normVoltage1 = lowV; voltage1 = Eg; end
        if ismember(node2,groundNodeList), normVoltage2 = lowV; voltage1 = Eg; end
        %---
        if ismember(node1,freeNodeList),
            freeNode1ID = find(freeNodeList==node1);
            voltage1 = voltageVector(freeNode1ID);
            normVoltage1 = normVoltageVector(freeNode1ID);
        end%if ismember(node1,freeNodeList),
        %---
        if ismember(node2,freeNodeList),
            freeNode2ID = find(freeNodeList==node2);
            voltage2 = voltageVector(freeNode2ID);
            normVoltage2 = normVoltageVector(freeNode2ID);
        end%if ismember(node2,freeNodeList),
        %---
        voltageList = linspace(voltage1,voltage2,numel(stei));
        normVoltageList = linspace(normVoltage1,normVoltage2,numel(stei));
        for pointIter = 1:numel(stei),
            cp = cpMatrix(stei(pointIter),1:3);
            normCPVoltageList(stei(pointIter)) = normVoltageList(pointIter);
            cpVoltageList(stei(pointIter)) = voltageList(pointIter);
            myMask(cp(1),cp(2),cp(3)) = uint8(normVoltageList(pointIter));
        end%for pointIter = 1:numel(stei),
        strandCompletedFlag = 1;
    end%if strandCompletedFlag == 0,
end%for strandIter = 1:numStrands,
        
 

analysisResults.cpVoltageList = cpVoltageList;
analysisResults.normCPVoltageList = normCPVoltageList;

if variableCleanupFlag == 1,
    clear cp cpMatrix cpVoltageList thisStrandID freeNode1ID freeNode2ID freeNodeList
    clear highV k lowV maxVoltage minVoltage myFrame newFrame node1 node1CP node2 node2CP
    clear nodeCPID nodesConnectedByStrand normVoltageVector numStrands pointIter
    clear stei strandCompletedFlag strandConductanceList strandIter strands voltage1
    clear voltage2 voltageList voltageNodeList voltageRange voltageVector
end%if variableCleanupFlag == 1







