
        vascBlockCenterlineMask = myMask>0;
        centeringField = myMask;
        blockSize = size(vascBlockCenterlineMask);
        powersOfTwo = pow2(26:-1:0);
        load('ConnectivityLUT.mat','connectivityLUT');
        
        maxFlips = 10;
        
        
        %STEP THREE - RECENTERING BASED ON DILATED ENHANCED MASK        
        
        disp(['Re-centerlining : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
        %Recenter the skeleton pixel by pixel; find the off-neighbor
        %   with a 3D-bwDist value that is maximally greater than the current pixel
        %   Add that pixel, and try to remove the original pixel. If
        %   possible, make the swap; if not retain original config
        
     

        %Re-darken Edges
        vascBlockCenterlineMask(1,:,:) = 0; vascBlockCenterlineMask(end,:,:) = 0;
        vascBlockCenterlineMask(:,1,:) = 0; vascBlockCenterlineMask(:,end,:) = 0;
        vascBlockCenterlineMask(:,:,1) = 0; vascBlockCenterlineMask(:,:,end) = 0;

        %Arrange pixel evaluation order : Y then X then Z
% %         orig = vascBlockCenterlineMask;
        [ySize,xSize,zSize] = size(vascBlockCenterlineMask);
        indexBlock = find(ones(size(vascBlockCenterlineMask)));



        
        centerlineHistory = uint8(vascBlockCenterlineMask);
        centerlineChangedNeighbors = vascBlockCenterlineMask;
        keepGoing = 1;
        cycleCounter = 0;


        while keepGoing == 1,
            starterBlock = vascBlockCenterlineMask;
            cycleCounter = cycleCounter+1;
%             activePixels = and(vascBlockCenterlineMask,centerlineChangedNeighbors)>0;
            safeBlock = vascBlockCenterlineMask;
            safeBlock(2,:,:) = 0; safeBlock(end-1,:,:) = 0;
            safeBlock(:,2,:) = 0; safeBlock(:,end-1,:) = 0;
            safeBlock(:,:,2) = 0; safeBlock(:,:,end-1) = 0;
            activePixels = and(safeBlock,centerlineChangedNeighbors)>0;
            clear safeBlock
            pixelList = indexBlock(activePixels);
            numPixels = numel(pixelList);
            pixelRank = centeringField(pixelList);
            [sortRank,rankOrder] = sort(pixelRank);
            sortedPixelList = pixelList(rankOrder);
            [w1List,w2List,w3List] = ind2sub(blockSize,sortedPixelList);
            %------
            crossBlock = zeros(3,3,3);
            crossBlock(:,2,2) = 1; crossBlock(2,:,2) = 1; crossBlock(2,2,:) = 1;
            centerlineChangedNeighbors(:) = 0;

            for pixelIter = 1:numPixels,
                w1 = round(w1List(pixelIter));
                w2 = round(w2List(pixelIter));
                w3 = round(w3List(pixelIter));
                subBlock = vascBlockCenterlineMask(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1);
                if sum(subBlock(:))>2,


                    %First : can the pixel be removed?
                    subBlockLine = subBlock(:)';
                    decNum = sum(subBlockLine.*powersOfTwo , 2);
                    saveBit = connectivityLUT(decNum);%if saveBit == 0, then the bit is removable
                    if sum(subBlockLine) == 2,saveBit = 1; end %Do not trim endpoints

                        if w1 == 1,saveBit = 1;end
                        if w2 == 1,saveBit = 1;end
                        if w3 == 1,saveBit = 1;end
                        if w1 == ySize,saveBit = 1;end
                        if w2 == xSize,saveBit = 1;end
                        if w3 == zSize,saveBit = 1;end


                    if saveBit == 0 %removable,
                        subBlock(2,2,2) = 0;
                        vascBlockCenterlineMask(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1) = subBlock;
                        centerlineHistory(w1,w2,w3) = centerlineHistory(w1,w2,w3) + 1;
                    else%if saveBit == 0 % (non-removable),
                        %Second : if not, can the pixel be moved?
                        subHistory = centerlineHistory(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1);
                        subBlockDist = centeringField(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1);
                        subBlockGreater = subBlockDist>subBlockDist(2,2,2);
                        subBlockUnused = (subHistory < maxFlips);
                        subBlockAvailable = and(and(~subBlock,subBlockGreater),subBlockUnused)>0;
                        subBlockAvailableVals = subBlockDist(subBlockAvailable);
                        %of the available greater pixels, pick the greatest valued one 
                        %that will allow a move that maintains connectivity
                        numAvailable = numel(subBlockAvailableVals);
                        sortVals = sort(subBlockAvailableVals,'descend');
                        foundMoveFlag = 0;
                        if sum(subBlockLine) > 2, %only search if not an endpoint
                            for moveCheckIter = 1:numAvailable,
                                currentVal = sortVals(moveCheckIter);
                                subBlockAdd = (subBlockDist==currentVal);
                                testBlock = or(subBlock,subBlockAdd);
                                testBlockLine = testBlock(:)';
                                decNum = sum(testBlockLine.*powersOfTwo , 2);
                                keepBit = connectivityLUT(decNum);%if keepBit == 0, then the bit is movable
                                if keepBit == 0,
                                    foundMoveFlag = 1;
                                    replacementBlock = testBlock;
                                    replacementBlock(2,2,2) = 0;
                                    break
                                end%if keepBit == 0,
                            end%for moveCheckIter = 1:numAvailable,
                        end%if sum(subBlockLine) > 2,

                        if foundMoveFlag == 1, %movable



                            %add the new (brighter) pixel, remove the old
                            vascBlockCenterlineMask(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1) = replacementBlock;
                            centerlineHistory(w1,w2,w3) = centerlineHistory(w1,w2,w3) + 1;
                            centerlineChangedNeighbors(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1) = 1;
                        else %if foundMoveFlag == 1, %not movable
                            %Third: if not, add the brightest pixel along one of 3 axes
                            optionBlock = and(and(subBlockAvailable,crossBlock),subBlockUnused)>0;
                            optionBlockVals = subBlockDist(optionBlock);
                            numAddOptions = sum(optionBlock(:));
                            if numAddOptions>0,
                                maxNeighborVal = max(optionBlockVals);
                                addBlock = (subBlockDist==maxNeighborVal);
                                vascBlockCenterlineMask(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1) = or(addBlock,subBlock);
                                centerlineChangedNeighbors(w1-1:w1+1,w2-1:w2+1,w3-1:w3+1) = 1;
                            else%if numAddOptions>0,
                                %do nothing - already at proper centerline
                            end%if numAddOptions>0,
                        end %if foundMoveFlag == 1,
                    end%if saveBit == 0
                end%if sum(subBlock(:))>2,
            end %for pixelIter = 1:numPixels,            

            
            %Re-darken Edges
            vascBlockCenterlineMask(1,:,:) = 0; vascBlockCenterlineMask(end,:,:) = 0;
            vascBlockCenterlineMask(:,1,:) = 0; vascBlockCenterlineMask(:,end,:) = 0;
            vascBlockCenterlineMask(:,:,1) = 0; vascBlockCenterlineMask(:,:,end) = 0;

            
            changedPixels = xor(vascBlockCenterlineMask,starterBlock);
            numChanged = sum(changedPixels(:));
            clear changedPixels
            if numChanged == 0,keepGoing = 0;end
        end%while keepGoing == 1,
        centerlineMask = vascBlockCenterlineMask;
        clear starterBlock indexBlock activePixels centerlineChangedNeighbors
        clear centerlineHistory vascBlockCenterlineMask
 


        