function outExp = RestrandifyAndTransferLabels2(inExp);%Load a Strand Edit File.
% registeredVascGrayscaleFileName = inExp.registeredVascGrayscaleFileName;
strandifyParameters = inExp.strandifyParameters;
centerlineRadiusStructure = inExp.centerlineRadiusStructure;
% % % origLabelList = centerlineRadiusStructure.labelList;
% % % origRadiusList = centerlineRadiusStructure.radiusList;
% % % origConfidenceList = centerlineRadiusStructure.confidenceList;
% % % origNoteList = centerlineRadiusStructure.noteList;
% % % origMaskSize = centerlineRadiusStructure.maskSize;
% % % origPixelList = centerlineRadiusStructure.pixelList; 
% % % %-----
% % % [cc1,cc2,cc3] = ind2sub(origMaskSize,origPixelList);
% % % origCoordList = [cc1,cc2,cc3];
% % % clear cc1 cc2 cc3;
% % % 


%This function takes as input, an experiment file that contains the following:
%   inExp.registeredVascGrayscaleFileName
%   inExp.strandifyParameters
%   inExp.centerlineRadiusStructure : which contains the fields:
%   centerlineRadiusStructure.pixelList = pixelList;
%       maskSize
%       radiusList
%       labelList
%       confidenceList
%       noteList        
%           
%
%the output strandifyExp will contain the new vectorizedStructure




%Label Structure
%100's Labels : Topology   : 100=Unlabeled, 200=Temporary, 300=Surface, 400=Plunging, 500=Connecting
%10's Labels  : Physiology :  10=Unlabeled,  20=Temporary,  30=Supply ,  40=Draining,  50=Microvessel
%1's Labels   : WhenAdded  :   1=Original ,   2=TR Added ,   3=Manual



%Hardcode
bestGuessOffset = [0 0 0];%offset from labeledCP to newCP's : offset = newCoord - labeledCoord (labeled = currentCPMatrix)

%-----
    vectorizedStructure = JustStrandifyCenterlineRadiusStructure2(centerlineRadiusStructure,strandifyParameters);


    
Vertices = vectorizedStructure.Vertices;
Strands = vectorizedStructure.Strands;
AllVerts = Vertices.AllVerts;
AllLabels = Vertices.AllLabels;

 
%-----
%Go strand-by-strand, and make the majority label and confidence of the strand the label for all points
%on that strand.
numStrands = size(Strands,2);
for kk = 1:numStrands,
    currentStrand = Strands(kk);
%     interiorVertices = currentStrand.InteriorVertices;
    interiorVertices = currentStrand.StartToEndIndices(2:end-1);
    interiorLabels = double(Vertices.AllLabels(interiorVertices));
    uniqueLabels = unique(interiorLabels);
    if size(uniqueLabels,1) > 1,
        labelHist = hist(interiorLabels,uniqueLabels);
        [histMax,maxPos] = max(labelHist);
        majorityLabel = uniqueLabels(maxPos(end));
        Vertices.AllLabels(interiorVertices) = majorityLabel;
    end%if size(uniqueLabels,1) > 1,
end%for kk = 1:numStrands,
%-----
vectorizedStructure.Vertices = Vertices;

outExp = inExp;
outExp.vectorizedStructure = vectorizedStructure;
