function outProject = RestrandifySE2(inputDataStruct)

inputDataStruct.cpMatrix = double(inputDataStruct.cpMatrix);


cpMatrix = inputDataStruct.cpMatrix;
maskSize = inputDataStruct.maskSize;
allRadii = inputDataStruct.allRadii;
allLabels = inputDataStruct.allLabels;
allConfidences = inputDataStruct.allConfidences;
origVectorProject = inputDataStruct.origVectorProject;


origVectorProjectFolder = origVectorProject.vectorProjectFolder;
strandifyParameters = origVectorProject.strandifyParameters;
voxelSizeInMicrons = origVectorProject.voxelSizeInMicrons;



%-----
%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label



%Label Structure
%100's Labels : Topology   : 100=Unlabeled, 200=Temporary, 300=Surface, 400=Plunging, 500=Connecting
%10's Labels  : Physiology :  10=Unlabeled,  20=Temporary,  30=Supply ,  40=Draining,  50=Microvessel
%1's Labels   : WhenAdded  :   1=Original ,   2=TR Added ,   3=Manual



centerlineRadiusStructure = [];
activeList = cpMatrix(:,6) == 1;
pixelList = sub2ind(maskSize,cpMatrix(activeList,1),cpMatrix(activeList,2),cpMatrix(activeList,3));
radiusList = allRadii(activeList);
labelList = allLabels(activeList);
confidenceList = allConfidences(activeList);

%-----
centerlineRadiusStructure.pixelList = pixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = radiusList;
centerlineRadiusStructure.labelList = labelList;
centerlineRadiusStructure.confidenceList = confidenceList;
%-----
strandifyParameters.voxelSizeInMicrons = voxelSizeInMicrons;
registeredVascGrayscaleFileOnlyName = origVectorProject.volumeFileNames.permutedVascGrayscale;
strandifyExp.registeredVascGrayscaleFileName = [origVectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
strandifyExp.strandifyParameters = strandifyParameters;
strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;
    strandifyExp = RestrandifyAndTransferLabels2(strandifyExp);
vectorizedStructure = strandifyExp.vectorizedStructure;
%-----
vectorProject.note = origVectorProject.note;
vectorProject.vectorProjectRootName = origVectorProject.vectorProjectRootName;
vectorProject.vectorProjectFolder = origVectorProject.vectorProjectFolder;
vectorProject.rootCodeFolder = origVectorProject.rootCodeFolder;
vectorProject.maskSize = origVectorProject.maskSize;
vectorProject.voxelSizeInMicrons = origVectorProject.voxelSizeInMicrons;
vectorProject.progressFlags = origVectorProject.progressFlags;
    vectorProject.vectorizedStructure = vectorizedStructure;
vectorProject.cellCentroidAndLabelList = origVectorProject.cellCentroidAndLabelList;
vectorProject.thresholdRelaxationParameters = origVectorProject.thresholdRelaxationParameters;
vectorProject.strandifyParameters = origVectorProject.strandifyParameters;
vectorProject.volumeFileNames = origVectorProject.volumeFileNames;
if isfield(origVectorProject,'GapConnectionStruct')
    vectorProject.GapConnectionStruct = origVectorProject.GapConnectionStruct;
else
    vectorProject.GapConnectionStruct = [];
end
    

vectorProject.vectorizedStructure = vectorizedStructure;

%-----
disp([' ';' ';' ']);
disp(['Completed Restrandifying SE2 globalDataStruct : ',datestr(now)]);
disp([' ';' ';' ']);
%----


outProject = vectorProject;
