function varargout = StrandEditor2(varargin)
% StrandEditor2 M-file for StrandEditor2.fig
%      StrandEditor2, by itself, creates a new StrandEditor2 or raises the existing
%      singleton*.
%
%      H = StrandEditor2 returns the handle to a new StrandEditor2 or the handle to
%      the existing singleton*.
%
%      StrandEditor2('CALLBACK',hObject,eventData,handles,...) calls the
%      local
%      function named CALLBACK in StrandEditor2.M with the given input
%      arguments.
%
%      StrandEditor2('Property','Value',...) creates a new StrandEditor2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before StrandEditor2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to StrandEditor2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help StrandEditor2

% Last Modified by GUIDE v2.5 11-Jan-2011 13:05:54

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @StrandEditor2_OpeningFcn, ...
    'gui_OutputFcn',  @StrandEditor2_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before StrandEditor2 is made visible.
function StrandEditor2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to StrandEditor2 (see VARARGIN)

% Choose default command line output for StrandEditor2
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes StrandEditor2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%-----
%-----


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%MY CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
global globalDataStruct
clear global globalDataStruct
global globalDataStruct
strandEditorFigureNum = gcf;

globalDataStruct.colorParameters = [];
globalDataStruct.selectionParameters = [];
fastFlag = 1;%Hardcode
raw3DFlag = 0;%Hardcode
grayFlag = 1;%Hardcode
numargin = numel(varargin);
for nIter = 1:numargin,
    currentArg = varargin{nIter};
    switch(currentArg),
        case{'fast','FAST','Fast'}
            fastFlag = 1;
        case{'nogray','NoGray','NOGRAY','Nogray'}
            grayFlag = 0;
    end%switch(currentArg)
end%for nIter = 1:numargin,



%-----
%KEY NOTES:
%globalDataStruct.selectionParameters.
%   selectStrandFlag, selectPoint1Flag, selectPoint2Flag
%   are mutually exclusive flags that determine what is currently selected.
%   if switching between strand and point - the first point of the strand
%   becomes selected
%globalDataStruct.selectionParameters.
%   selectedCPList: is the row list of cpMatrix that is currently selected
%   affliatedCPList : in pointSelect mode, this lists the rows of cpMatrix
%       that are in the same strand as the selected point.
%cpMatrix:
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7:label

%label1Values: stored in 10^1 position
%   1=Unlabeled 2=Temporary 3=Supply 4=Draining 5=Connecting
%label2Values: stored in 10^2 position
%   1=Unlabeled 2=Temporary 3=Surface 4=Plunging 5=Micro
%-----
[fileName,pathName] = uigetfile({'*.mat'},'Select a vectorProject, StrandEdit2 .mat file');
cd(pathName)
loadFileName = [fileName];
load(loadFileName);
if findstr(fileName,'StrandEdit2')>0,
    %loaded a strandEdit file
    globalDataStruct.loadFileName = loadFileName;
    maskSize = globalDataStruct.maskSize;
    strands = globalDataStruct.strands;
    allVerts = single(globalDataStruct.allVerts);
    allRadii = globalDataStruct.allRadii;
    allLabels = single(globalDataStruct.allLabels);
    allConfidences = globalDataStruct.allConfidences;
    % %     allNotes = globalDataStruct.allNotes;
    % %     strandIndices = globalDataStruct.strandIndices;
    
    cpMatrix = single(globalDataStruct.cpMatrix);
    globalDataStruct.cpMatrix = cpMatrix;
    
    junctionPoints = globalDataStruct.junctionPoints;
    freeEndPoints = globalDataStruct.freeEndPoints;
    if ~isfield(globalDataStruct,'grayThresh')
        globalDataStruct.grayThresh = 100;
    end
    grayThresh = globalDataStruct.grayThresh;
    disp('cpMatrix loaded');
    grayscaleFileName = globalDataStruct.grayscaleFileName;
    fileRootName = loadFileName(findstr(loadFileName,'StrandEdit2-')+11:end);
    globalDataStruct.exitFlag = 0;
else%if findstr(fileName,'StrandEdit2')>0,
    vectorProjectFolder = cd;
    vectorProject.vectorProjectFolder = vectorProjectFolder;
    grayscaleFileNameOnly = vectorProject.volumeFileNames.permutedVascGrayscale;
    grayscaleFileName = fullfile(vectorProjectFolder,fullfile('PermutedFilesFolder',grayscaleFileNameOnly));
    fileRootName = vectorProject.vectorProjectRootName;
    % % %     %assume a vidaProject was loaded - ask for the associated grayscale file
    % % %     [fileName,pathName] = uigetfile({'*.mat'},'Select an associated grayscale file');
    % % %     grayscaleFileName = [pathName,fileName];
    % % %     fileRootName = loadFileName;
end%if-else findstr(fileName,'StrandEdit2')>0,
%---
if grayFlag == 1,
    try
        loadedVariables = load(grayscaleFileName);
    catch
        grayscaleFileName = fullfile(cd,grayscaleFileName(findstr(grayscaleFileName,'Permuted'):end));
        loadedVariables = load(grayscaleFileName);
        globalDataStruct.grayscaleFileName = grayscaleFileName;
    end%try-catch
    variableNames = fieldnames(loadedVariables);
    rawData = loadedVariables.(variableNames{1});
    globalDataStruct.maxIntensity = max(rawData(:));

    % % %
    % % %     coFactor = globalDataStruct.maxIntensity ./256;
    % % % %     rawData = uint8(rawData/coFactor);
    % % %     rawData = uint8(rawData);
    % % %     globalDataStruct.maxIntensity = 255;
    % % %


    clear loadedVariables variableNames
else%if grayFlag == 1,
    rawData = [0 1];
    globalDataStruct.maxIntensity = 1;
end%if grayFlag == 1,

%-----
if exist('vectorProject'),
    maskSize = vectorProject.maskSize;
    strands = vectorProject.vectorizedStructure.Strands;
    allVerts = single(vectorProject.vectorizedStructure.Vertices.AllVerts);
    allRadii = vectorProject.vectorizedStructure.Vertices.AllRadii;
    allLabels = single(vectorProject.vectorizedStructure.Vertices.AllLabels);
    allConfidences = vectorProject.vectorizedStructure.Vertices.AllConfidences;
    % %     allNotes = vectorProject.vectorizedStructure.Vertices.AllNotes;
    strandIndices = full(vectorProject.vectorizedStructure.Vertices.StrandIndices);
    % % % % % %             if iscell(strandIndices),
    % % % % % %                 tempStrandIndices = strandIndices;
    % % % % % %                 strandIndices = sparse(zeros(numel(strandIndices),8));
    % % % % % %                 for pointIter = 1:numel(strandIndices),
    % % % % % %                     thisSet = tempStrandIndices{pointIter};
    % % % % % %                     strandIndices(pointIter,1:numel(thisSet)) = thisSet;
    % % % % % %                 end%for pointIter = 1:numel;
    % % % % % %             end%iscell(strandIndices);
    junctionPointsTemp = vectorProject.vectorizedStructure.Vertices.JunctionPoints;
    freeEndPointsTemp = vectorProject.vectorizedStructure.Vertices.FreeEndPoints;
    cpMatrix = single([allVerts,freeEndPointsTemp,junctionPointsTemp,ones(size(junctionPointsTemp)),allLabels]);
    if raw3DFlag == 1 && grayFlag == 1,
        grayThresh = 0.9 * max(rawData(:)); %threshold for display of raw data
    else%if raw3DFlag == 1 && grayFlag == 1,
        grayThresh = 1;
    end%if raw3DFlag == 1 && grayFlag == 1,
    junctionPoints = allVerts(junctionPointsTemp==1,:);
    freeEndPoints = allVerts(freeEndPointsTemp==1,:);
    clear vidaProject junctionPointsTemp freeEndPointsTemp
    %-----
    % %     globalDataStruct.origVectorProject = vectorProject;
    globalDataStruct.maskSize = maskSize;
    globalDataStruct.fileRootName = fileRootName;
    globalDataStruct.originalFileName = loadFileName;
    globalDataStruct.loadFileName = loadFileName;
    globalDataStruct.grayscaleFileName = grayscaleFileName;
    % %     globalDataStruct.vectorProjectFolder = vectorProjectFolder;
    % %     globalDataStruct.strandifyParameters = strandifyParameters;
    % %     globalDataStruct.voxelSizeInMicrons = voxelSizeInMicrons;
    globalDataStruct.cpMatrix = cpMatrix;
    globalDataStruct.strands = strands;
    globalDataStruct.allVerts = allVerts;
    globalDataStruct.allRadii = allRadii;
    globalDataStruct.allLabels = allLabels;
    globalDataStruct.allConfidences = allConfidences;
    % %     globalDataStruct.allNotes = allNotes;
    globalDataStruct.junctionPoints = junctionPoints;
    globalDataStruct.freeEndPoints = freeEndPoints;
    globalDataStruct.strandIndices = strandIndices;
    cutFrames = [1,maskSize(1);1,maskSize(2);1,maskSize(3)];%cut frames (cutFrames)
    globalDataStruct.cutFrames = cutFrames;
    if raw3DFlag == 1 && grayFlag == 1,
        [rp1,rp2,rp3] = ind2sub(maskSize,find(rawData>grayThresh));%rawPoints = rawData points //PB moved this up
        rawIntensity = zeros(size(rp1));
        for kk = 1:size(rp1,1);
            rawIntensity(kk) = rawData(rp1(kk),rp2(kk),rp3(kk));
        end%for kk...
        rawPoints = [rp1,rp2,rp3,rawIntensity];
        globalDataStruct.rawPoints = rawPoints;
        globalDataStruct.grayThresh = uint16(grayThresh);
        globalDataStruct.maxIntensity = uint16(max(rawData(:)));
    else%if raw3DFlag == 1 && grayFlag == 1,
        globalDataStruct.rawPoints = [];
        globalDataStruct.grayThresh = 1;
        globalDataStruct.maxIntensity = 1;
    end%if-else raw3DFlag == 1 && grayFlag == 1,
    %-----
    InitializeGlobalDataStruct([]);%function call to initialized colors (see below)
    clear vectorProject
    clear strandIndices
    % %     clear strands cpMatrix allVerts allRadii allLabels allConfidences junctionPoints freeEndPoints strandIndices
    %-----
end%if exist('vectorProject')
%---




%-----


%-----
if ~isfield(globalDataStruct,'colorParameters');
    cutFrames = [1,maskSize(1);1,maskSize(2);1,maskSize(3)];%cut frames (cutFrames)
    globalDataStruct.cutFrames = cutFrames;
    if raw3DFlag == 1 && grayFlag == 1,
        [rp1,rp2,rp3] = ind2sub(maskSize,find(rawData>grayThresh));%rawPoints = rawData points //PB moved this up
        rawIntensity = zeros(size(rp1));
        for kk = 1:size(rp1,1);
            rawIntensity(kk) = rawData(rp1(kk),rp2(kk),rp3(kk));
        end%for kk...
        rawPoints = [rp1,rp2,rp3,rawIntensity];
        globalDataStruct.rawPoints = rawPoints;
        globalDataStruct.grayThresh = uint16(grayThresh);
        globalDataStruct.maxIntensity = uint16(max(rawData(:)));
    else%if raw3DFlag == 1 && grayFlag == 1,
        globalDataStruct.rawPoints = [];
        globalDataStruct.grayThresh = 1;
        globalDataStruct.maxIntensity = 1;
    end%if-else raw3DFlag == 1 && grayFlag == 1,
    InitializeGlobalDataStruct([]);
end
colorParameters = globalDataStruct.colorParameters;
selectionParameters = globalDataStruct.selectionParameters;

%-----
allInd = sub2ind(maskSize,allVerts(:,1),allVerts(:,2),allVerts(:,3));
%-----
f9 = figure(9);s1 = subplot(3,1,1);s2 = subplot(3,1,2); s3= subplot(3,1,3);
f2 = figure(2);p1 = plot3(allVerts(:,1),allVerts(:,2),-1*allVerts(:,3),'.');hold on
set(f2,'DoubleBuffer','on');
set(p1,'Color',[0.25,0.25,0.25]);
p2 = plot3(junctionPoints(:,1),junctionPoints(:,2),-1*junctionPoints(:,3),'.');
set(p2,'Color','green');
p3 = plot3(freeEndPoints(:,1),freeEndPoints(:,2),-1*freeEndPoints(:,3),'.');
set(p3,'Color','red');
axis equal
cameratoolbar(f2,'show');
camproj('perspective')
drawnow
currentAxis2 = gca;
globalDataStruct.currentAxis2 = currentAxis2;
datacursormode on
dcmObj = datacursormode(f2);
set(dcmObj,'SnapToDataVertex','on','Enable','on','DisplayStyle','window')
globalDataStruct.dcmObj = dcmObj;
%-----
f7 = figure(7);
set(f7,'visible','off');
% p7 = plot3(rp1,rp2,-1*rp3,'ro');axis equal
set(f7,'DoubleBuffer','on');
currentAxis7 = gca;
globalDataStruct.currentAxis7 = currentAxis7;
%-----
uiwait(handles.figure1,3);
%-----
%Make backwards compatible with older GlobalDataStruct files
if ~isfield(globalDataStruct,'nextDirection'),globalDataStruct.nextDirection = +1;end
if ~isfield(globalDataStruct,'limitBoxSize'),globalDataStruct.limitBoxSize = 50;end
if size(globalDataStruct.limitBoxSize,2) < 3, globalDataStruct.limitBoxSize = [50 50 50]; end
if ~isfield(globalDataStruct,'addPointCoord'),globalDataStruct.addPointCoord = [1 1 1];end
if ~isfield(globalDataStruct,'numBranches'),globalDataStruct.numBranches = 0;end
if ~isfield(globalDataStruct,'branchStruct'),globalDataStruct.branchStruct = [];end
if ~isfield(globalDataStruct.selectionParameters,'selectedRadius'),globalDataStruct.selectionParameters.selectedRadius = 0; end
if ~isfield(globalDataStruct,'radiusMultiplierEdit'),globalDataStruct.radiusMultiplier = 1;end
if ~isfield(globalDataStruct,'logScaleFlag'),globalDataStruct.logScaleFlag = 0;end
if ~isfield(globalDataStruct,'sqrtScaleFlag'),globalDataStruct.sqrtScaleFlag = 1;end
if ~isfield(globalDataStruct,'showCenterlineFlag'),globalDataStruct.showCenterlineFlag = 1;end
if ~isfield(globalDataStruct,'showTargetFlag'),globalDataStruct.showTargetFlag = 1;end
if ~isfield(globalDataStruct,'raw3DFlag'),globalDataStruct.raw3DFlag = 0;end
if ~isfield(globalDataStruct,'grayFlag'),globalDataStruct.grayFlag = 1;end
if ~isfield(globalDataStruct,'projectionExtent'),globalDataStruct.projectionExtent = 100;end
if ~isfield(globalDataStruct,'projectionDepth'),globalDataStruct.projectionDepth = 10;end
if ~isfield(globalDataStruct,'validClick'),globalDataStruct.validClick = 0;end
if ~isfield(globalDataStruct,'autoBoxFlag'),globalDataStruct.autoBoxFlag = 0;end
if ~isfield(globalDataStruct,'autoTrackFlag'),globalDataStruct.autoTrackFlag = 0;end
if ~isfield(globalDataStruct,'markLimitsStruct'),globalDataStruct.markLimitsStruct = [];end
if ~isfield(globalDataStruct,'highlightZeroRadiusFlag'),globalDataStruct.highlightZeroRadiusFlag = 0;end
if ~isfield(globalDataStruct,'strandStatsFlag'),globalDataStruct.strandStatsFlag = 0;end
if ~isfield(globalDataStruct,'hideIslandsFlag'),globalDataStruct.hideIslandsFlag = 0;end
if ~isfield(globalDataStruct,'vectorProjectFolder'),globalDataStruct.vectorProjectFolder = cd;end
if ~isfield(globalDataStruct,'voxelSizeInMicrons'),globalDataStruct.voxelSizeInMicrons = 1;end
globalDataStruct.fastFlag = fastFlag;
globalDataStruct.raw3DFlag = raw3DFlag;
globalDataStruct.grayFlag = grayFlag;
%-----
%Initialize various Gui elements to match GlobalDataStruct
%-----
set(handles.cropStartX1,'String','1');
set(handles.cropStartX2,'String','1');
set(handles.cropStartX3,'String','1');
set(handles.cropStopX1,'String',num2str(maskSize(1)));
set(handles.cropStopX2,'String',num2str(maskSize(2)));
set(handles.cropStopX3,'String',num2str(maskSize(3)));
set(handles.cropStartX1Slider,'Value',0);
set(handles.cropStartX2Slider,'Value',0);
set(handles.cropStartX3Slider,'Value',0);
set(handles.cropStopX1Slider,'Value',1);
set(handles.cropStopX2Slider,'Value',1);
set(handles.cropStopX3Slider,'Value',1);
set(handles.selectStrandCheckbox,'Value',1);
set(handles.selectPoint1Checkbox,'Value',0);
set(handles.selectPoint2Checkbox,'Value',0);
set(handles.connectPointsButton,'Visible','off');
set(handles.deleteStrandButton,'Visible','on');
set(handles.thresholdSlider,'Value',0.9);
set(handles.thresholdEdit,'String',num2str(0.9*max(rawData(:))));
%---
threshRatio = double(globalDataStruct.grayThresh)./double(globalDataStruct.maxIntensity);
set(handles.thresholdSlider,'Value',threshRatio);
set(handles.thresholdEdit,'String',num2str(globalDataStruct.grayThresh));
set(handles.cropStartX1,'String',num2str(globalDataStruct.cutFrames(1,1)));
set(handles.cropStartX2,'String',num2str(globalDataStruct.cutFrames(2,1)));
set(handles.cropStartX3,'String',num2str(globalDataStruct.cutFrames(3,1)));
set(handles.cropStopX1,'String',num2str(globalDataStruct.cutFrames(1,2)));
set(handles.cropStopX2,'String',num2str(globalDataStruct.cutFrames(2,2)));
set(handles.cropStopX3,'String',num2str(globalDataStruct.cutFrames(3,2)));
set(handles.cropStartX1Slider,'Value',globalDataStruct.cutFrames(1,1)./globalDataStruct.maskSize(1));
set(handles.cropStartX2Slider,'Value',globalDataStruct.cutFrames(2,1)./globalDataStruct.maskSize(2));
set(handles.cropStartX3Slider,'Value',globalDataStruct.cutFrames(3,1)./globalDataStruct.maskSize(3));
set(handles.cropStopX1Slider,'Value',globalDataStruct.cutFrames(1,2)./globalDataStruct.maskSize(1));
set(handles.cropStopX2Slider,'Value',globalDataStruct.cutFrames(2,2)./globalDataStruct.maskSize(2));
set(handles.cropStopX3Slider,'Value',globalDataStruct.cutFrames(3,2)./globalDataStruct.maskSize(3));
set(handles.projectionExtentEdit,'String',num2str(globalDataStruct.projectionExtent));
set(handles.projectionDepthEdit,'String',num2str(globalDataStruct.projectionDepth));
set(handles.limitBoxEdit1,'String',num2str(globalDataStruct.limitBoxSize(1)));
set(handles.limitBoxEdit2,'String',num2str(globalDataStruct.limitBoxSize(2)));
set(handles.limitBoxEdit3,'String',num2str(globalDataStruct.limitBoxSize(3)));
set(handles.logScaleToggleButton,'Value',globalDataStruct.logScaleFlag);
set(handles.sqrtScaleToggleButton,'Value',globalDataStruct.sqrtScaleFlag);
set(handles.showCenterlineToggleButton,'Value',globalDataStruct.showCenterlineFlag);
set(handles.showTargetToggleButton,'Value',globalDataStruct.showTargetFlag);
set(handles.autoBoxToggleButton,'Value',globalDataStruct.autoBoxFlag);
set(handles.autoTrackToggleButton,'Value',globalDataStruct.autoTrackFlag);
set(handles.radiusMultiplierEdit,'String',num2str(globalDataStruct.radiusMultiplier));
%-----
%-----
strands = globalDataStruct.strands;
allRadii = globalDataStruct.allRadii;
numStrands = numel(strands);
majorityRadius = zeros(numStrands,1);
majorityZeroRadiusFlagList = zeros(size(cpMatrix,1),1);
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    majRad = median(allRadii(stei));
    majorityRadius(strandIter) = majRad;
    if majRad==0,
        majorityZeroRadiusFlagList(stei) = 1;
    end
end
globalDataStruct.majorityZeroRadiusFlagList = majorityZeroRadiusFlagList;
%-----
%-----
loop = 1;
previousInd = 1;
currentPointer = 1;
figure(2);
currentFigNum = gcf;
globalDataStruct.exitFlag = 0;
globalDataStruct.refreshRawDataDisplayFlag = 1;
globalDataStruct.extraGrayscaleDisplayFlag = 0;
globalDataStruct.selectionParameters.selectedRadius = 0;
fastFlag = globalDataStruct.fastFlag;
globalDataStruct.highlightZeroRadiusFlag = 0;
globalDataStruct.isolatedStrandFlagList = [];
while loop == 1
    figure(currentFigNum);
    globalDataStruct.validClick = 0;
    validClick = globalDataStruct.validClick;
    while validClick == 0,
        myButton = waitforbuttonpress;

        if myButton == 0, %mousePress
            myButtonVals = get(myButton);
            whichFigure = myButtonVals.CurrentFigure;
            %-----
            if globalDataStruct.refreshRawDataDisplayFlag == 1,
                tempCurrentFigNum = gcf;
                globalDataStruct.refreshRawDataDisplayFlag = 0;
                grayThresh = globalDataStruct.grayThresh;
                maxIntensity = globalDataStruct.maxIntensity;
                maxBoxSize = 50;
                maxNumPoints = 5000;
                %----
                currentPosition = double(cpMatrix(currentPointer,1:3));
                i1 = max(currentPosition(1)-maxBoxSize , 1);
                j1 = max(currentPosition(2)-maxBoxSize , 1);
                k1 = max(currentPosition(3)-maxBoxSize , 1);
                i2 = min(currentPosition(1)+maxBoxSize , maskSize(1));
                j2 = min(currentPosition(2)+maxBoxSize , maskSize(2));
                k2 = min(currentPosition(3)+maxBoxSize , maskSize(3));
                %---
                globalDataStruct.currentPosition = currentPosition;
                if raw3DFlag == 1 && grayFlag == 1,
                    subRaw = rawData(i1:i2,j1:j2,k1:k2);
                    rInd = find(subRaw>grayThresh);
                    subSize = size(subRaw);
                    [rp1,rp2,rp3] = ind2sub(subSize,rInd);%rawPoints = rawData points
                    rawIntensity = subRaw(rInd);
                    rawPoints = [rp1+i1-1,rp2+j1-1,rp3+k1-1,rawIntensity];
                    decimateBy = ceil(size(rawPoints,1)/maxNumPoints);
                    rawPoints = rawPoints(1:decimateBy:end,:);
                    myRand = rand(size(rawPoints))-0.5;
                    rawPoints = double(rawPoints) + myRand;
                    globalDataStruct.decimateBy = decimateBy;
                    globalDataStruct.rawPoints = rawPoints;
                    currentAxis7 = gca;
                end%if raw3DFlag == 1 && grayFlag == 1,
                figure(tempCurrentFigNum);
                GenerateDisplay(handles);
            end%if refreshRawDataDisplayFlag == 1,

            %-----
            validClick = globalDataStruct.validClick;
            switch whichFigure,
                case 2,
                    point1 = getCursorInfo(dcmObj);
                    if ~isempty(point1),
                        x1 = point1.Position(1)
                        x2 = point1.Position(2)
                        x3 = -1*point1.Position(3)
                        try
                            pointInd = sub2ind(maskSize,x1,x2,x3);
                            validClick = 1;
                        catch
                            %probably clicked on a boundingBox point - ignore
                        end
                    else
                        validClick = 0;
                    end%if ~isempty(point1)
                case 7,
                    validClick = 0;
                    currentFigNum = gcf;
                case strandEditorFigureNum
                    currentFigNum = gcf;
                    pause(0.25);
                    validClick = globalDataStruct.validClick;
                otherwise,
                    pointInd = previousInd;
                    currentFigNum = gcf;
                    pause(0.25)
                    validClick = 1;
            end%switch whichFigure
            globalDataStruct.validClick = validClick;
        end%if myButton == 0
        validClick = globalDataStruct.validClick;
    end%while validClick == 0,

    cpMatrix = globalDataStruct.cpMatrix;
    showCenterlineFlag = globalDataStruct.showCenterlineFlag;
    showTargetFlag = globalDataStruct.showTargetFlag;
    logScaleFlag = globalDataStruct.logScaleFlag;
    sqrtScaleFlag = globalDataStruct.sqrtScaleFlag;
    raw3DFlag = globalDataStruct.raw3DFlag;

    globalDataStruct.validClick = validClick;



    if pointInd~= previousInd,
        %A new point was selected.  Grab the affiliated points
        previousInd = pointInd;

        if max(min(cpMatrix)) == 0,
            disp('HARDCODE line 522:  Found zero cpMatrix line. Removing.');
            disp('HARDCODE line 522:  Found zero cpMatrix line. Removing.');
            disp('HARDCODE line 522:  Found zero cpMatrix line. Removing.');
            disp('HARDCODE line 522:  Found zero cpMatrix line. Removing.');
            disp('HARDCODE line 522:  Found zero cpMatrix line. Removing.');
            keyboard
            q1 = find(max(cpMatrix,[],2) ~= 0);
            cpMatrix = cpMatrix(q1,:);
            globalDataStruct.cpMatrix = cpMatrix;
        end




        allInd = sub2ind(maskSize,double(cpMatrix(:,1)),double(cpMatrix(:,2)),double(cpMatrix(:,3)));
        currentPointer = find(allInd == pointInd);


        if numel(currentPointer)>1,
            for currentIter = 1:numel(currentPointer);
                if cpMatrix(currentPointer(currentIter),6)==1, break;end
            end%for currentIter = 1:numel(currentPointer);
            currentPointer = currentPointer(currentIter);
        end%if numel(currentPointer)>1,
        currentPosition = double(cpMatrix(currentPointer,1:3));

        %Grab and display affiliated points
        globalDataStruct.currentPosition = currentPosition;
        globalDataStruct.currentPointer = currentPointer;

        GrabAffiliatedPoints(handles,currentPointer)  %function call to embedded function (below)

    end%if pointInd~previousInd,
    if grayFlag == 1,
        if ~isempty(currentPointer),
            %Display cross-sectional projections around selected point
            maskSize = globalDataStruct.maskSize;
            projectionExtent = globalDataStruct.projectionExtent;%plus/minus
            projectionDepth = globalDataStruct.projectionDepth;%plus/minus
            showCenterlineFlag = globalDataStruct.showCenterlineFlag;
            logScaleFlag = globalDataStruct.logScaleFlag;
            %-----
            currentCoords = cpMatrix(currentPointer,1:3);
            %======================================
            %Generate x1 projection
            plim1 = max(currentCoords(1)-projectionDepth , 1);
            plim2 = min(currentCoords(1)+projectionDepth , maskSize(1));
            i1 = max(currentCoords(2)-projectionExtent , 1);
            i2 = min(currentCoords(2)+projectionExtent , maskSize(2));
            j1 = max(currentCoords(3)-projectionExtent , 1);
            j2 = min(currentCoords(3)+projectionExtent , maskSize(3));
            subBlock = rawData(plim1:plim2,:,:);
            subProj = squeeze(sum(subBlock,1));
            subProj = subProj';%Note reversal to generate appropriate front view
            if logScaleFlag == 1,subProj = log(subProj+1); end
            if sqrtScaleFlag == 1, subProj = sqrt(subProj); end
            viewRegion = subProj(j1:j2,i1:i2);%Note reversal to generate appropriate front view
            minValue = min(viewRegion(:));
            maxValue = max(viewRegion(:));
            projRange = maxValue-minValue;
            normProj = (subProj-minValue)./projRange;
            bwProj = normProj;
            %find centerline points in the projection
            subCM = zeros(size(subProj));
            if showCenterlineFlag==1,
                q1 = and(cpMatrix(:,1)>=plim1 , cpMatrix(:,1)<=plim2);
                q2 = and(cpMatrix(:,2)>=i1 , cpMatrix(:,2)<=i2);
                q3 = and(cpMatrix(:,3)>=j1 , cpMatrix(:,3)<=j2);
                q4 = cpMatrix(:,6)==1;
                qq = and(and(and(q1,q2),q3),q4);
                projCPList = cpMatrix(qq,1:3);
                for cmIter = 1:size(projCPList,1);
                    newPosI = projCPList(cmIter,2);
                    newPosJ = projCPList(cmIter,3);
                    subCM(newPosJ,newPosI) = 1;%Note reversal to generate appropriate front view
                end
                normProj(subCM==1)=0;
            end%if showCenterlineFlag==1,
            %---
            crosshair = zeros(size(subProj));
            if showTargetFlag==1,
                normProj(currentCoords(3),:) = 0;
                normProj(:,currentCoords(2)) = 0;
                crosshair(currentCoords(3),:) = 1;
                crosshair(:,currentCoords(2)) = 1;
            end%if showTargetFlag==1,
            RGB1 = zeros(maskSize(3),maskSize(2),3);%Note reversal to generate appropriate front view
            RGB1(:,:,1) = normProj+subCM;
            RGB1(:,:,2) = normProj+crosshair;
            RGB1(:,:,3) = normProj;
            RGB1 = max(min(RGB1,1),0);
            f9 = figure(9);
            s1 = subplot(3,1,1);
            imagesc(RGB1);
            axis equal
            set(s1,'YLim',[currentCoords(3)-projectionExtent,currentCoords(3)+projectionExtent]);
            set(s1,'XLim',[currentCoords(2)-projectionExtent,currentCoords(2)+projectionExtent]);
            xlabel('Axis2')
            ylabel('Axis3');
            title('Front View');
            %-----
            if fastFlag ~=1,
                f10 = figure(10);
                s1 = subplot(3,1,1);
                imagesc(bwProj);
                axis equal
                set(s1,'YLim',[currentCoords(3)-projectionExtent,currentCoords(3)+projectionExtent]);
                set(s1,'XLim',[currentCoords(2)-projectionExtent,currentCoords(2)+projectionExtent]);
                xlabel('Axis2')
                ylabel('Axis3');
                title('Front View');
            end%if fastFlag ~=1,
            %===========================
            %Generate x2 projection
            plim1 = max(currentCoords(2)-projectionDepth , 1);
            plim2 = min(currentCoords(2)+projectionDepth , maskSize(2));
            i1 = max(currentCoords(1)-projectionExtent , 1);
            i2 = min(currentCoords(1)+projectionExtent , maskSize(1));
            j1 = max(currentCoords(3)-projectionExtent , 1);
            j2 = min(currentCoords(3)+projectionExtent , maskSize(3));
            subBlock = rawData(:,plim1:plim2,:);
            subProj = squeeze(sum(subBlock,2));
            subProj = subProj';%Note reversal to generate appropriate left view
            if logScaleFlag == 1,subProj = log(subProj+1); end
            if sqrtScaleFlag == 1, subProj = sqrt(subProj); end
            viewRegion = subProj(j1:j2,i1:i2);%Note reversal to generate appropriate left view
            minValue = min(viewRegion(:));
            maxValue = max(viewRegion(:));
            projRange = maxValue-minValue;
            normProj = (subProj-minValue)./projRange;
            bwProj = normProj;
            %find centerline points in the projection
            subCM = zeros(size(subProj));
            if showCenterlineFlag==1,
                q1 = and(cpMatrix(:,1)>=i1 , cpMatrix(:,1)<=i2);
                q2 = and(cpMatrix(:,2)>=plim1 , cpMatrix(:,2)<=plim2);
                q3 = and(cpMatrix(:,3)>=j1 , cpMatrix(:,3)<=j2);
                q4 = cpMatrix(:,6)==1;
                qq = and(and(and(q1,q2),q3),q4);
                projCPList = cpMatrix(qq,1:3);
                for cmIter = 1:size(projCPList,1);
                    newPosI = projCPList(cmIter,1);
                    newPosJ = projCPList(cmIter,3);
                    subCM(newPosJ,newPosI) = 1;%Note reversal to generate appropriate left view
                end
            end%if showCenterlineFlag==1,
            %---
            crosshair = zeros(size(subProj));
            if showTargetFlag==1,
                normProj(subCM==1)=0;
                normProj(currentCoords(3),:) = 0;
                normProj(:,currentCoords(1)) = 0;
                crosshair(currentCoords(3),:) = 1;
                crosshair(:,currentCoords(1)) = 1;
            end%if showTargetFlag==1,
            RGB2 = zeros(maskSize(3),maskSize(1),3);%Note reversal to generate appropriate left view
            RGB2(:,:,1) = normProj+subCM;
            RGB2(:,:,2) = normProj+crosshair;
            RGB2(:,:,3) = normProj;
            RGB2 = max(min(RGB2,1),0);
            f9 = figure(9);
            s2 = subplot(3,1,2);
            imagesc(RGB2);
            axis equal
            set(s2,'YLim',[currentCoords(3)-projectionExtent,currentCoords(3)+projectionExtent]);
            set(s2,'XLim',[currentCoords(1)-projectionExtent,currentCoords(1)+projectionExtent]);
            ylabel('Axis3')
            xlabel('Axis1');
            title('Left View');
            %-----
            if fastFlag ~=1,
                f10 = figure(10);
                s2 = subplot(3,1,2);
                imagesc(bwProj);
                axis equal
                set(s2,'YLim',[currentCoords(3)-projectionExtent,currentCoords(3)+projectionExtent]);
                set(s2,'XLim',[currentCoords(1)-projectionExtent,currentCoords(1)+projectionExtent]);
                ylabel('Axis3')
                xlabel('Axis1');
                title('Left View');
            end%if fastFlag ~=1,
            %========================================
            %Generate x3 projection
            plim1 = max(currentCoords(3)-projectionDepth , 1);
            plim2 = min(currentCoords(3)+projectionDepth , maskSize(3));
            i1 = max(currentCoords(1)-projectionExtent , 1);
            i2 = min(currentCoords(1)+projectionExtent , maskSize(1));
            j1 = max(currentCoords(2)-projectionExtent , 1);
            j2 = min(currentCoords(2)+projectionExtent , maskSize(2));
            subBlock = rawData(:,:,plim1:plim2);
            subProj = squeeze(sum(subBlock,3));
            if logScaleFlag == 1,subProj = log(subProj+1); end
            if sqrtScaleFlag == 1, subProj = sqrt(subProj); end
            viewRegion = subProj(i1:i2,j1:j2);
            minValue = min(viewRegion(:));
            maxValue = max(viewRegion(:));
            projRange = maxValue-minValue;
            normProj = (subProj-minValue)./projRange;
            bwProj = normProj;
            %find centerline points in the projection
            subCM = zeros(size(subProj));
            if showCenterlineFlag==1,
                q1 = and(cpMatrix(:,1)>=i1 , cpMatrix(:,1)<=i2);
                q2 = and(cpMatrix(:,2)>=j1 , cpMatrix(:,2)<=j2);
                q3 = and(cpMatrix(:,3)>=plim1 , cpMatrix(:,3)<=plim2);
                q4 = cpMatrix(:,6)==1;
                qq = and(and(and(q1,q2),q3),q4);
                projCPList = cpMatrix(qq,1:3);
                for cmIter = 1:size(projCPList,1);
                    newPosI = projCPList(cmIter,1);
                    newPosJ = projCPList(cmIter,2);
                    subCM(newPosI,newPosJ) = 1;
                end
                normProj(subCM==1)=0;
            end%if showCenterlineFlag==1,
            %---
            crosshair = zeros(size(subProj));
            if showTargetFlag==1,
                normProj(currentCoords(1),:) = 0;
                normProj(:,currentCoords(2)) = 0;
                crosshair(currentCoords(1),:) = 1;
                crosshair(:,currentCoords(2)) = 1;
            end%if showTargetFlag==1,
            RGB3 = zeros(maskSize(1),maskSize(2),3);
            RGB3(:,:,1) = normProj+subCM;
            RGB3(:,:,2) = normProj+crosshair;
            RGB3(:,:,3) = normProj;
            RGB3 = max(min(RGB3,1),0);
            f9 = figure(9);
            s3 = subplot(3,1,3);
            imagesc(RGB3);
            axis equal
            set(s3,'YLim',[currentCoords(1)-projectionExtent,currentCoords(1)+projectionExtent]);
            set(s3,'XLim',[currentCoords(2)-projectionExtent,currentCoords(2)+projectionExtent]);
            ylabel('Axis1')
            xlabel('Axis2');
            title('Top View');
            %-----
            if fastFlag ~=1,
                f10 = figure(10);
                s3 = subplot(3,1,3);
                imagesc(bwProj);
                axis equal
                set(s3,'YLim',[currentCoords(1)-projectionExtent,currentCoords(1)+projectionExtent]);
                set(s3,'XLim',[currentCoords(2)-projectionExtent,currentCoords(2)+projectionExtent]);
                ylabel('Axis1')
                xlabel('Axis2');
                title('Top View');
            end%if fastFlag ~=1,
            %===================================
        end%if ~isempty(currentPointer),
    end%if grayFlag == 1,


    %     uiwait(handles.figure1,1);
    %     waitfor(currentAxis,'currentPosition');
    %     figure(handles.figure1);
    globalDataStruct.validClick = validClick;
    pause(0.1);
    % Write exit option
    if globalDataStruct.exitFlag == 1, break; end




end %while loop

if isfield(globalDataStruct,'exitBox');
    if ishandle(globalDataStruct.exitBox),
        close(globalDataStruct.exitBox);
    end%if ishandle(globalDataStruct.exitBox),
end%if isfield(globalDataStruct,'exitBox');

disp('Exited.');
close all;











% --- Outputs from this function are returned to the command line.
function varargout = StrandEditor2_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% % % varargout{1} = handles.output;



% --- Executes on button press in loadButton.
function loadButton_Callback(hObject, eventdata, handles)
% hObject    handle to loadButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%-----


% --- Executes on button press in saveProgressButton.
function saveProgressButton_Callback(hObject, eventdata, handles)
% hObject    handle to saveProgressButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE2-',dateString,'-Mod','-StrandEdit2-',fileName,ext]);
tempDataStruct = globalDataStruct;
globalDataStruct = rmfield(globalDataStruct,'dcmObj');
globalDataStruct = rmfield(globalDataStruct,'currentAxis2');
globalDataStruct = rmfield(globalDataStruct,'currentAxis7');
saveBox = warndlg('Saving Progress - Please Wait');
pause(0.1);
save(saveFileName,'globalDataStruct');
if ishandle(saveBox),
    close(saveBox);
end%if ishandle(saveBox),
globalDataStruct = tempDataStruct;
return




% --- Executes on button press in restrandifyButton.
function restrandifyButton_Callback(hObject, eventdata, handles)
% hObject    handle to restrandifyButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
fileRootName = globalDataStruct.fileRootName;
dateString = datestr(now,'yyyy_mm_dd-HH_MM_SS');
[pathName,fileName,ext] = fileparts(fileRootName);
saveFileName = fullfile(pathName,['SE2-',dateString,'-Mod','-StrandEdit2-',fileName,ext]);
tempDataStruct = globalDataStruct;
globalDataStruct = rmfield(globalDataStruct,'dcmObj');
globalDataStruct = rmfield(globalDataStruct,'currentAxis2');
globalDataStruct = rmfield(globalDataStruct,'currentAxis7');
saveBox = warndlg('Saving Progress - Please Wait');
pause(0.1);
save(saveFileName,'globalDataStruct');
if ishandle(saveBox),
    close(saveBox);
end%if ishandle(saveBox),
globalDataStruct = tempDataStruct;
restrandifyBox =  warndlg('Restrandifying and saving to new vectorProject File - please wait');
pause(0.1);
% % % vectorProject = globalDataStruct.origVectorProject;
% % % backupVectorProjectFileName = ['Backup-VectorProject-',fileName,'-',dateString,'.mat'];
% % % saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
% % % save(backupVectorProjectFileName,'vectorProject',scs);
%-----

vectorProject = RestrandifySE2(globalDataStruct);
vectorProjectFileName = globalDataStruct.originalFileName;
saveSize = (getfield(whos('vectorProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vectorProjectFileName,'vectorProject',scs);
if ishandle(restrandifyBox),
    close(restrandifyBox);
end%if ishandle(saveBox),
exitBox =  warndlg('Exiting. Click on any vertex point to exit program');
pause(0.1);
globalDataStruct.exitBox = exitBox;
globalDataStruct.exitFlag = 1;

return






% --- Executes on button press in allPointsButton.
function allPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to allPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.displayOption = 1;
set(handles.radiusMultiplierEdit,'visible','off');
set(handles.radiusMultiplierIncreaseButton,'visible','off');
set(handles.radiusMultiplierDecreaseButton,'visible','off');
set(handles.radiusMultiplierText,'visible','off');
GenerateDisplay(handles)
return


% --- Executes on button press in junctionPointsButton.
function junctionPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to junctionPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.displayOption = 2;
set(handles.radiusMultiplierEdit,'visible','off');
set(handles.radiusMultiplierIncreaseButton,'visible','off');
set(handles.radiusMultiplierDecreaseButton,'visible','off');
set(handles.radiusMultiplierText,'visible','off');
GenerateDisplay(handles)
return



% --- Executes on button press in endPointsButton.
function endPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to endPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.displayOption = 3;
set(handles.radiusMultiplierEdit,'visible','off');
set(handles.radiusMultiplierIncreaseButton,'visible','off');
set(handles.radiusMultiplierDecreaseButton,'visible','off');
set(handles.radiusMultiplierText,'visible','off');
GenerateDisplay(handles)
return




% --- Executes on button press in radiusViewButton.
function radiusViewButton_Callback(hObject, eventdata, handles)
% hObject    handle to radiusViewButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.displayOption = 4;
set(handles.radiusMultiplierEdit,'visible','on');
set(handles.radiusMultiplierIncreaseButton,'visible','on');
set(handles.radiusMultiplierDecreaseButton,'visible','on');
set(handles.radiusMultiplierText,'visible','on');
GenerateDisplay(handles)
return






function radiusMultiplierEdit_Callback(hObject, eventdata, handles)
% hObject    handle to radiusMultiplierEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of radiusMultiplierEdit as text
%        str2double(get(hObject,'String')) returns contents of radiusMultiplierEdit as a double
global globalDataStruct;
radiusMultiplier = str2num(get(hObject,'String'));
if isempty(radiusMultiplier),
    radiusMultiplier = 1;
end%if isempty(radiusMultiplier),
%-----
radiusMultiplier = min(max(radiusMultiplier,1),99);
globalDataStruct.radiusMultiplier = radiusMultiplier;
GenerateDisplay(handles)
return




% --- Executes on button press in radiusMultiplierIncreaseButton.
function radiusMultiplierIncreaseButton_Callback(hObject, eventdata, handles)
% hObject    handle to radiusMultiplierIncreaseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
radiusMultiplier = globalDataStruct.radiusMultiplier;
radiusMultiplier = radiusMultiplier + 1;
radiusMultiplier = min(max(radiusMultiplier,1),99);
set(handles.radiusMultiplierEdit,'String',num2str(radiusMultiplier));
%-----
globalDataStruct.radiusMultiplier = radiusMultiplier;
GenerateDisplay(handles)



% --- Executes on button press in radiusMultiplierDecreaseButton.
function radiusMultiplierDecreaseButton_Callback(hObject, eventdata, handles)
% hObject    handle to radiusMultiplierDecreaseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
radiusMultiplier = globalDataStruct.radiusMultiplier;
radiusMultiplier = radiusMultiplier - 1;
radiusMultiplier = min(max(radiusMultiplier,1),99);
set(handles.radiusMultiplierEdit,'String',num2str(radiusMultiplier));
%-----
globalDataStruct.radiusMultiplier = radiusMultiplier;
GenerateDisplay(handles)




% --- Executes on button press in colorPanelButton.
function colorPanelButton_Callback(hObject, eventdata, handles)
% hObject    handle to colorPanelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.colorPanelFig = 77;
StrandEditorColorPanel
return



% --- Executes on button press in refreshDisplayButton.
function refreshDisplayButton_Callback(hObject, eventdata, handles)
% hObject    handle to refreshDisplayButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
GenerateDisplay(handles)
currentAxis2 = globalDataStruct.currentAxis2;
currentAxis7 = globalDataStruct.currentAxis7;
raw3DFlag = globalDataStruct.raw3DFlag;
%-----
figure(2);
CameraPosition = get(currentAxis2,'CameraPosition');
CameraTarget = get(currentAxis2,'CameraTarget');
CameraUpVector = get(currentAxis2,'CameraUpVector');
CameraViewAngle = get(currentAxis2,'CameraViewAngle');
%-----
if raw3DFlag == 1,
    figure(7);
    set(gca,'CameraPosition',CameraPosition);
    set(gca,'CameraTarget',CameraTarget);
    set(gca,'CameraUpVector',CameraUpVector);
    set(gca,'CameraViewAngle',CameraViewAngle);
    camproj('perspective')
    drawnow
    pause(1);
end%if raw3DFlag == 1,
globalDataStruct.refreshRawDataDisplayFlag = 1;
return



function thresholdEdit_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdEdit as text
%        str2double(get(hObject,'String')) returns contents of thresholdEdit as a double
global globalDataStruct
maxIntensity = globalDataStruct.maxIntensity;
grayThresh = get(hObject,'String');
if ~isempty(str2num(grayThresh)),
    grayThresh = str2num(grayThresh);
else%if ~isempty(str2num(grayThresh)),
    grayThresh = 1;
end%if-else ~isempty(str2num(grayThresh)),
globalDataStruct.grayThresh = grayThresh;
threshRatio = grayThresh./maxIntensity;
set(handles.thresholdSlider,'Value',threshRatio);
GenerateDisplay(handles)
return


% --- Executes on slider movement.
function thresholdSlider_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
maxIntensity = globalDataStruct.maxIntensity;
threshRatio = get(hObject,'Value');
grayThresh = round(maxIntensity*threshRatio);
set(handles.thresholdEdit,'String',num2str(grayThresh));
globalDataStruct.grayThresh = grayThresh;
GenerateDisplay(handles)
return





% --- Executes on button press in deleteStrandButton.
function deleteStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to deleteStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
cpMatrix = globalDataStruct.cpMatrix;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
%---
%set selected pixels to inactive
cpMatrix(selectedCPList,6) = 0;
%---
globalDataStruct.cpMatrix = cpMatrix;
GenerateDisplay(handles)
globalDataStruct.validClick = 1;
return




% --- Executes on button press in restoreStrandButton.
function restoreStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to restoreStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global globalDataStruct;
cpMatrix = globalDataStruct.cpMatrix;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
affiliatedCPList = globalDataStruct.selectionParameters.affiliatedCPList;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
%---
if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
    cpMatrix(affiliatedCPList,6) = 1;%set affiliated pixels to active
end%if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
%---
if selectStrandFlag == 1,
    cpMatrix(selectedCPList,6) = 1;%set selected pixels to active
end%if selectStrandFlag == 1,
%---
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.validClick = 1;
GenerateDisplay(handles)





% --- Executes on button press in connectPointsButton.
function connectPointsButton_Callback(hObject, eventdata, handles)
% hObject    handle to connectPointsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
cpMatrix = globalDataStruct.cpMatrix;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
strands = globalDataStruct.strands;
strandIndices = globalDataStruct.strandIndices;%strandIndices
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
allConfidences = globalDataStruct.allConfidences;
isolatedStrandFlagList = globalDataStruct.isolatedStrandFlagList;
% % allNotes = globalDataStruct.allNotes;
%-----
if and(selectedPoints12(1)~=0 , selectedPoints12(2)~=0),
    %set the connecting points to junction point (even if they were endpoint)
    cpMatrix(selectedPoints12(1),4) = 0;
    cpMatrix(selectedPoints12(1),5) = 1;
    cpMatrix(selectedPoints12(2),4) = 0;
    cpMatrix(selectedPoints12(2),5) = 1;
    %-----
    %generate a straight line between the two points (m and n)
    %and assign it a new strandID
    pointM = cpMatrix(selectedPoints12(1),1:3);
    pointN = cpMatrix(selectedPoints12(2),1:3);
    sepMN = pointN - pointM;
    maxSep = max(abs(sepMN));
    stepSize = sepMN/maxSep;
    currentPos = pointM;
    currentCPEntry = size(cpMatrix,1);
    newPointerList = [];
    numStrands = size(strands,2);
    newStrandID = numStrands+1;
    cpMatrix(currentCPEntry+maxSep-1,:) = [0 0 0 0 0 0 0];
    allRadii(currentCPEntry+maxSep-1) = 0;
    allLabels(currentCPEntry+maxSep-1) = 0;
    allConfidences(currentCPEntry+maxSep-1) = 0;
    isolatedStrandFlagList(currentCPEntry+maxSep-1) = 0;
    % %     allNotes{currentCPEntry+maxSep-1} = [];
    strandIndices(currentCPEntry+maxSep-1,1:27) = zeros(1,27);%create a hole row of zeros
    for stepIter = 1:maxSep-1,
        currentPos = currentPos + stepSize;
        currentCPEntry = currentCPEntry + 1;
        newPointerList = [newPointerList,currentCPEntry];
        cpMatrix(currentCPEntry,1:3) = round(currentPos);
        cpMatrix(currentCPEntry,4:7) = [0 0 1 113];%113 is the label for "manually-added"
        allRadii(currentCPEntry) = 0; %Set radius of new point to zero
        allLabels(currentCPEntry) = 113;
        allConfidences(currentCPEntry) = 999;%default confidence for manually added points
        % %         allNotes{currentCPEntry} = [];
        strandIndices(currentCPEntry,1) = newStrandID;
    end
    strands(newStrandID).StartToEndIndices = newPointerList;
    globalDataStruct.cpMatrix = cpMatrix;
    globalDataStruct.strands = strands;
    globalDataStruct.allRadii = allRadii;
    globalDataStruct.allLabels = allLabels;
    globalDataStruct.allConfidences = allConfidences;
    globalDataStruct.isolatedStrandFlagList = isolatedStrandFlagList;
    % %     globalDataStruct.allNotes = allNotes;
    globalDataStruct.strandIndices = strandIndices;
    %-----
    RecalculateZeroRadiusList(handles)
    GenerateDisplay(handles)
    globalDataStruct.validClick = 1;
end%if and(selectedPoints12(1)~=0 , selectedPoints12(2)~=0),


return


% --- Executes on button press in deletePointButton.
function deletePointButton_Callback(hObject, eventdata, handles)
% hObject    handle to deletePointButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
cpMatrix = globalDataStruct.cpMatrix;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
strands = globalDataStruct.strands;
strandIndices = globalDataStruct.strandIndices;%strandIndices
%-----
selectedPoint1 = selectedPoints12(1);
cpMatrix(selectedPoint1,6) = 0; %set pixel to inactive;
%for now, nothing is changed in the strand representations.
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.selectedPoints12(1) = 0;
globalDataStruct.validClick = 1;
GenerateDisplay(handles);
return




% --- Executes on button press in deleteBetweenButton.
function deleteBetweenButton_Callback(hObject, eventdata, handles)
% hObject    handle to deleteBetweenButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
cpMatrix = globalDataStruct.cpMatrix;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
strands = globalDataStruct.strands;
strandIndices = globalDataStruct.strandIndices;%strandIndices


if and(selectedPoints12(1)~=0 , selectedPoints12(2)~=0),
    %proceed if point1 and point2 are both selected
    strand1ID = strandIndices(selectedPoints12(1),1);
    strand2ID = strandIndices(selectedPoints12(2),1);
    if strand1ID(1) == strand2ID(1),
        %proceed if both points are on same strand
        currentStrand = strands(strand1ID);
        currentSTEI = currentStrand.StartToEndIndices;
        point1Pointer = find(currentSTEI == selectedPoints12(1));
        point2Pointer = find(currentSTEI == selectedPoints12(2));
        for pointIter = min(point1Pointer,point2Pointer) : max(point1Pointer,point2Pointer),
            currentPoint = currentSTEI(pointIter);
            cpMatrix(currentPoint,6) = 0; %set pixel to inactive;
            %for now, nothing is changed in the strand representations.
        end%for pointIter = min(point1Pointer,point2Pointer) : max(point1Pointer,point2Pointer),
    end%if strand1ID(1) == strand2ID(1),
    globalDataStruct.selectedPoints12 = [0 0];
end%if and(selectedPoints12(1)~=0 , selectedPoints12(2)~=0),
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.validClick = 1;
GenerateDisplay(handles);



% --- Executes on button press in nextPointButton.
function nextPointButton_Callback(hObject, eventdata, handles)
% hObject    handle to nextPointButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%Finds the next point to the current selected point
global globalDataStruct
cpMatrix = globalDataStruct.cpMatrix;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
strands = globalDataStruct.strands;
strandIndices = globalDataStruct.strandIndices;%strandIndices
nextDirection = globalDataStruct.nextDirection;
strandStatsFlag = globalDataStruct.strandStatsFlag;
hideIslandsFlag = globalDataStruct.hideIslandsFlag;
%-----
if sum(selectedPoints12) > 0,
    selectedPoint1 = selectedPoints12(1);
    selectedPoint2 = selectedPoints12(2);
    if selectedPoint1 ~= 0,
        currentPoint = selectedPoint1;
    else%if selectedPoint1 ~= 0,
        currentPoint = selectedPoint2;
    end%if-else selectedPoint1 ~= 0,
    currentStrandIndex = strandIndices(currentPoint,1);
    currentStrand = strands(currentStrandIndex(1));
    stei = currentStrand.StartToEndIndices;
    currentPos = find(stei==selectedPoint1);
    nextPos = currentPos + nextDirection;
    if nextPos > size(stei,2), nextPos = 1; end
    if nextPos < 1, nextPos = size(stei,2); end
    nextPoint = stei(nextPos);
    selectedPoints12(1) = nextPoint;
    globalDataStruct.currentPointer = nextPoint;
end%if sum(selectedPoints12) > 0,

globalDataStruct.selectionParameters.selectedPoints12 = selectedPoints12;
globalDataStruct.validClick = 1;
GenerateDisplay(handles);
if strandStatsFlag == 1,
    DisplayStrandStats(handles,globalDataStruct.currentPointer),
end%if strandStatsFlag == 1,
return


% --- Executes on button press in reverseButton.
function reverseButton_Callback(hObject, eventdata, handles)
% hObject    handle to reverseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.nextDirection = globalDataStruct.nextDirection * -1;




% --- Executes on button press in selectStrandButton.
function selectStrandButton_Callback(hObject, eventdata, handles)
% hObject    handle to selectStrandButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.selectionParameters.selectStrandFlag = 1;
globalDataStruct.selectionParameters.selectPoint1Flag = 0;
globalDataStruct.selectionParameters.selectPoint2Flag = 0;
set(handles.selectStrandCheckbox,'Value',1);
set(handles.selectPoint1Checkbox,'Value',0);
set(handles.selectPoint2Checkbox,'Value',0);
set(handles.connectPointsButton,'Visible','off');
set(handles.deletePointButton,'Visible','off');
set(handles.nextPointButton,'Visible','off');
set(handles.reverseButton,'Visible','off');
set(handles.deleteBetweenButton,'Visible','off');
set(handles.deleteStrandButton,'Visible','on');
set(handles.restoreStrandButton,'Visible','on');
set(handles.radiusEdit,'Visible','on');
set(handles.radiusText,'Visible','on');
set(handles.applyRadiusButton,'Visible','on');
set(handles.highlightZeroRadiusToggleButton,'Visible','on');
GrabAffiliatedPoints(handles,globalDataStruct.currentPointer);

return



% --- Executes on button press in selectPoint1Button.
function selectPoint1Button_Callback(hObject, eventdata, handles)
% hObject    handle to selectPoint1Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.selectionParameters.selectStrandFlag = 0;
globalDataStruct.selectionParameters.selectPoint1Flag = 1;
globalDataStruct.selectionParameters.selectPoint2Flag = 0;
set(handles.selectStrandCheckbox,'Value',0);
set(handles.selectPoint1Checkbox,'Value',1);
set(handles.selectPoint2Checkbox,'Value',0);
set(handles.deleteStrandButton,'Visible','off');
set(handles.restoreStrandButton,'Visible','off');
set(handles.nextPointButton,'Visible','on');
set(handles.reverseButton,'Visible','on');
set(handles.connectPointsButton,'Visible','on');
set(handles.deletePointButton,'Visible','on');
set(handles.deleteBetweenButton,'Visible','on');
set(handles.radiusEdit,'Visible','off');
set(handles.radiusText,'Visible','off');
set(handles.applyRadiusButton,'Visible','off');
set(handles.highlightZeroRadiusToggleButton,'Visible','off');




return


% --- Executes on button press in selectPoint2Button.
function selectPoint2Button_Callback(hObject, eventdata, handles)
% hObject    handle to selectPoint2Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.selectionParameters.selectStrandFlag = 0;
globalDataStruct.selectionParameters.selectPoint1Flag = 0;
globalDataStruct.selectionParameters.selectPoint2Flag = 1;
set(handles.selectStrandCheckbox,'Value',0);
set(handles.selectPoint1Checkbox,'Value',0);
set(handles.selectPoint2Checkbox,'Value',1);
set(handles.deleteStrandButton,'Visible','off');
set(handles.restoreStrandButton,'Visible','off');
set(handles.nextPointButton,'Visible','on');
set(handles.reverseButton,'Visible','on');
set(handles.deletePointButton,'Visible','off');
set(handles.connectPointsButton,'Visible','on');
set(handles.deleteBetweenButton,'Visible','on');
set(handles.radiusEdit,'Visible','off');
set(handles.radiusText,'Visible','off');
set(handles.applyRadiusButton,'Visible','off');
set(handles.highlightZeroRadiusToggleButton,'Visible','off');

return


% --- Executes on button press in selectStrandCheckbox.
function selectStrandCheckbox_Callback(hObject, eventdata, handles)
% hObject    handle to selectStrandCheckbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of selectStrandCheckbox


% --- Executes on button press in selectPoint1Checkbox.
function selectPoint1Checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to selectPoint1Checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of selectPoint1Checkbox



% --- Executes on button press in selectPoint2Checkbox.
function selectPoint2Checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to selectPoint2Checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of selectPoint2Checkbox


% --- Executes on selection change in label1Menu.
function label1Menu_Callback(hObject, eventdata, handles)
% hObject    handle to label1Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns label1Menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from label1Menu


% --- Executes on selection change in label2Menu.
function label2Menu_Callback(hObject, eventdata, handles)
% hObject    handle to label2Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns label2Menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from label2Menu


% --- Executes on button press in applyLabel0Button.
function applyLabel0Button_Callback(hObject, eventdata, handles)
% hObject    handle to applyLabel0Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
cpMatrix = globalDataStruct.cpMatrix;
allLabels = globalDataStruct.allLabels;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
newLabel0Value = get(handles.label1Menu,'Value');
%label0Values: stored in 10^0 position - no effect on display
%   1=OriginalVectorization, 2=ThresholdRelaxationAdded, 3=ManuallyAdded
numSelectedPoints = size(selectedCPList,2);
for pointIter = 1:numSelectedPoints,
    currentPoint = selectedCPList(pointIter);
    currentLabel = allLabels(currentPoint);
    baseLabel = floor(currentLabel/10) * 10;
    newLabel = currentLabel + newLabel0Value;
    cpMatrix(currentPoint,7) = newLabel;
    allLabels(currentPoint) = newLabel;
end
globalDataStruct.cpMatrix = cpMatrix;
allLabels(currentPoint) = newLabel;
GenerateDisplay(handles);
return



% --- Executes on button press in applyLabel1Button.
function applyLabel1Button_Callback(hObject, eventdata, handles)
% hObject    handle to applyLabel1Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
cpMatrix = globalDataStruct.cpMatrix;
allLabels = globalDataStruct.allLabels;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
newLabel1Value = get(handles.label1Menu,'Value');
%label1Values: stored in 10^1 position - affects Color label
%   10=Unlabeled 20=Temporary 30=Supply 40=Draining 50=Connecting 60=Extra1 70=Extra2
numSelectedPoints = size(selectedCPList,2);
for pointIter = 1:numSelectedPoints,
    currentPoint = selectedCPList(pointIter);
    currentLabel = allLabels(currentPoint);
    currentLabel2Value = floor(currentLabel/(10^2));
    modLabel1Value = currentLabel-currentLabel2Value*(10^2);
    currentLabel1Value = floor(modLabel1Value/(10^1));
    newLabel = currentLabel - currentLabel1Value*(10^1) + newLabel1Value*(10^1);
    cpMatrix(currentPoint,7) = newLabel;
    allLabels(currentPoint) = newLabel;
end
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.allLabels = allLabels;
GenerateDisplay(handles);
return



% --- Executes on button press in applyLabel2Button.
function applyLabel2Button_Callback(hObject, eventdata, handles)
% hObject    handle to applyLabel2Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
cpMatrix = globalDataStruct.cpMatrix;
allLabels = globalDataStruct.allLabels;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
newLabel2Value = get(handles.label2Menu,'Value');
%label2Values: stored in 10^2 position - affects symbol label
%   100=Unlabeled 200=Temporary 300=Surface 400=Plunging 500=Micro 600=Extra1 700=Extra2
numSelectedPoints = size(selectedCPList,2);
for pointIter = 1:numSelectedPoints,
    currentPoint = selectedCPList(pointIter);
    currentLabel = allLabels(currentPoint);
    currentLabel2Value = floor(currentLabel/(10^2));
    newLabel = currentLabel - currentLabel2Value*(10^2) + newLabel2Value*(10^2);
    cpMatrix(currentPoint,7) = newLabel;
    allLabels(currentPoint) = newLabel;
end
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.allLabels = allLabels;
GenerateDisplay(handles);
return




% --- Executes on button press in applyAllLabelsButton.
function applyAllLabelsButton_Callback(hObject, eventdata, handles)
% hObject    handle to applyAllLabelsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
cpMatrix = globalDataStruct.cpMatrix;
allLabels = globalDataStruct.allLabels;
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
newLabel0Value = get(handles.label0Menu,'Value');
%label1Values: point type label stored in 10^1 position
%   1=OriginalVectorization 2=ThresholdRelaxtionAdded 3=ManuallyAdded
newLabel1Value = get(handles.label1Menu,'Value');
%label1Values: function label stored in 10^1 position
%   1=Unlabeled 2=Temporary 3=Supply 4=Draining 5=Microvessel
newLabel2Value = get(handles.label2Menu,'Value');
%labe2Values: topolgy label stored in 10^2 position
%   1=Unlabeled 2=Temporary 3=Surface 4=Plunging 5=Connecting
numSelectedPoints = size(selectedCPList,2);
for pointIter = 1:numSelectedPoints,
    currentPoint = selectedCPList(pointIter);
    newLabel = newLabel2Value*(10^2) + newLabel1Value*(10^1) + newLabel0Value;
    cpMatrix(currentPoint,7) = newLabel;
    allLabels(currentPoint) = newLabel;
end
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.allLabels = allLabels;
GenerateDisplay(handles);
return









% --- Executes on selection change in branchMenu.
function branchMenu_Callback(hObject, eventdata, handles)
% hObject    handle to branchMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns branchMenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from branchMenu
global globalDataStruct
branchesToDisplay = get(handles.label1Menu,'Value') - 1;
globalDataStruct.branchesToDisplay = branchesToDisplay;
globalDataStruct.branchStruct = [];
GrabAffiliatedPoints(handles,globalDataStruct.currentPointer);






function GenerateDisplay(handles)
global globalDataStruct
%-----
autoBoxFlag = globalDataStruct.autoBoxFlag;
if autoBoxFlag == 1,
    ApplyLimitBox(handles)
end
%-----
colorParameters = globalDataStruct.colorParameters;
% allVerts = globalDataStruct.allVerts;%allVerts stands for allVertices
% junctionPoints = globalDataStruct.junctionPoints;%junctionPoints stands for junctionPoints
% freeEndPoints = globalDataStruct.freeEndPoints;%freeEndPoints stands for freeEndPoints
cutFrames = globalDataStruct.cutFrames;%cutFrames stands for cutFrames
rawPoints = globalDataStruct.rawPoints;
selectedDots = globalDataStruct.selectedDots;
affiliatedDots = globalDataStruct.affiliatedDots;
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
allConfidences = globalDataStruct.allConfidences;
% % allNotes = globalDataStruct.allNotes;
raw3DFlag = globalDataStruct.raw3DFlag;
grayFlag = globalDataStruct.grayFlag;
displayOption = globalDataStruct.displayOption;
currentAxis2 = globalDataStruct.currentAxis2;
currentAxis7 = globalDataStruct.currentAxis7;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;
maskSize = globalDataStruct.maskSize;
cpMatrix = globalDataStruct.cpMatrix;
strands = globalDataStruct.strands;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
selectedRadius = globalDataStruct.selectionParameters.selectedRadius;
radiusMultiplier = globalDataStruct.radiusMultiplier;
currentPosition = globalDataStruct.currentPosition;
validClick = globalDataStruct.validClick;
autoTrackFlag = globalDataStruct.autoTrackFlag;
highlightZeroRadiusFlag = globalDataStruct.highlightZeroRadiusFlag;
majorityZeroRadiusFlagList = globalDataStruct.majorityZeroRadiusFlagList;
hideIslandsFlag = globalDataStruct.hideIslandsFlag;
isolatedStrandFlagList = globalDataStruct.isolatedStrandFlagList;
%-----
CameraPosition = get(currentAxis2,'CameraPosition');
CameraTarget = get(currentAxis2,'CameraTarget');
CameraUpVector = get(currentAxis2,'CameraUpVector');
CameraViewAngle = get(currentAxis2,'CameraViewAngle');
%-----
if autoTrackFlag == 1 && validClick == 1,
    %Make a smooth transition to new target
    numSteps = 5;



    newTarget = currentPosition.*[1 1 -1];
    oldTarget = CameraTarget;
    deltaTarget = double(newTarget) - double(oldTarget);
    stepSize = double(deltaTarget) / numSteps;
    tempTarget = double(oldTarget);
    for kk = 1:numSteps-1,
        tempTarget = tempTarget + stepSize;
        set(currentAxis2,'CameraTarget',tempTarget);
        drawnow
    end
    set(currentAxis2,'CameraTarget',newTarget);
    CameraTarget = newTarget;
    drawnow
    validClick = 0;
    pause(0.25)
end%if autoCameraFlag == 1 && validClick == 1,
%-----
activePixelList = cpMatrix(:,6)==1;
activeFEPList = and(activePixelList,cpMatrix(:,4)==1);
activeJPList = and(activePixelList,cpMatrix(:,5)==1);
%-----
ad1 = [];ad2 = [];ad3 = [];
sd1 = [];sd2 = [];sd3 = [];
if ~isempty(selectedDots),sd1 = selectedDots(:,1); sd2 = selectedDots(:,2); sd3 = selectedDots(:,3);end
if ~isempty(affiliatedDots),ad1 = affiliatedDots(:,1); ad2 = affiliatedDots(:,2); ad3 = affiliatedDots(:,3);end
cf1a = cutFrames(1,1); cf1b = cutFrames(1,2);
cf2a = cutFrames(2,1); cf2b = cutFrames(2,2);
cf3a = cutFrames(3,1); cf3b = cutFrames(3,2);


%-----
q1 = and(sd1>=cf1a,sd1<=cf1b);
q2 = and(sd2>=cf2a,sd2<=cf2b);
q3 = and(sd3>=cf3a,sd3<=cf3b);
qq = and(and(q1,q2),q3);
sd1 = sd1(qq); sd2 = sd2(qq) ; sd3 = sd3(qq);
%-----
colorCell = {'black','magenta','red','blue','green','cyan','yellow'};
markerString = '.*oxds^';
f2 = figure(2);hold off;
try
    % boundingBox = [cf1a cf2a cf3a ; cf1a cf2a cf3b ; cf1a cf2b cf3b ; cf1a cf2b cf3a ; ...
    %     cf1a cf2a cf3a ; cf1a cf2a cf3b ; cf1b cf2a cf3b ; cf1b cf2a cf3a; ...
    %     cf1a cf2a cf3a ; cf1a cf2b cf3a ; cf1b cf2b cf3a ; cf1b cf2a cf3a; ...
    %     cf1a cf2a cf3a ; cf1a cf2a cf3b ; cf1a cf2b cf3b ; cf1b cf2b cf3b; ...
    %     cf1b cf2b cf3a ; cf1b cf2a cf3a ; cf1b cf2a cf3b ; cf1b cf2b cf3b; ...
    %     cf1b cf2b cf3a ; cf1a cf2b cf3a ; cf1a cf2b cf3b ; cf1b cf2b cf3b; ...
    %     cf1b cf2a cf3b ; cf1a cf2a cf3b ; cf1a cf2b cf3b ; cf1b cf2b cf3b];

    bb1 = [cf1a cf2a cf3b ; cf1a cf2b cf3b ; cf1a cf2b cf3a ; cf1b cf2b cf3a ; cf1b cf2b cf3b; cf1a cf2b cf3b];
    bb2 = [cf1a cf2a cf3b ; cf1b cf2a cf3b ; cf1b cf2a cf3a ; cf1b cf2b cf3a ; cf1b cf2b cf3b; cf1b cf2a cf3b];
    plot3(bb1(:,1),bb1(:,2),-1*bb1(:,3),'m-');hold on
    plot3(bb2(:,1),bb2(:,2),-1*bb2(:,3),'m-');


    %     plot3(boundingBox(:,1),boundingBox(:,2),-1*boundingBox(:,3),'m-');
    hold on
    axis equal
    cameratoolbar(f2,'show');
    camproj(currentAxis2,'perspective')
    set(currentAxis2,'CameraPosition',CameraPosition);
    set(currentAxis2,'CameraTarget',CameraTarget);
    set(currentAxis2,'CameraUpVector',CameraUpVector);
    set(currentAxis2,'CameraViewAngle',CameraViewAngle);
    drawnow
    plot3([cf1a cf1b],[cf2a cf2a],[-1*cf3a, -1*cf3a],'r-');
    plot3([cf1a cf1a],[cf2a cf2b],[-1*cf3a, -1*cf3a],'g-');
    plot3([cf1a cf1a],[cf2a cf2a],[-1*cf3a, -1*cf3b],'b-');
catch
    keyboard
end


if numel(isolatedStrandFlagList)<size(cpMatrix,1),
    isolatedStrandFlagList = [];
end

if hideIslandsFlag == 1 && isempty(isolatedStrandFlagList),
    isolatedStrandFlagList = false(size(activePixelList));
    numStrands = numel(strands);
    for strandIter = 1:numStrands,
        numNeighbors1 = numel(strands(strandIter).StartVertexNeighborStrands);
        numNeighbors2 = numel(strands(strandIter).EndVertexNeighborStrands);
        numNeighbors(strandIter) = numNeighbors1 + numNeighbors2;
    end%for strandIter = 1:numStrands,
    noNeighborStrandsIdx =find(numNeighbors==0);
    for strandIter = 1:numel(noNeighborStrandsIdx),
        currentStrandIdx = noNeighborStrandsIdx(strandIter);
        isolatedStrandFlagList(strands(currentStrandIdx).StartToEndIndices) = true;
    end%for strandIter = 1:numel(noNeighborStrandsIdx),
    globalDataStruct.isolatedStrandFlagList = isolatedStrandFlagList;
end%if hideIslandsFlag == 1 && isempty(isolatedStrandFlagList),



for label1Iter = 1:7,
    for label2Iter = 1:7,
        currentLabelValueList = label1Iter*10^1 + label2Iter*10^2 + [0:9];
        labelPointerList = ismember(allLabels,currentLabelValueList);
        activePixelListSub = find(and(activePixelList,labelPointerList));
        activeFEPListSub = find(and(activeFEPList,labelPointerList));
        activeJPListSub = find(and(activeJPList,labelPointerList));
        nonJPFEPActivePixelListSub = and(and(and(activePixelList,labelPointerList),~activeFEPList),~activeJPList);
        activeMajorityZeroRadiusFlagSub = majorityZeroRadiusFlagList(nonJPFEPActivePixelListSub);
        if ~isempty(activePixelListSub),
            %---
            av1 = cpMatrix(nonJPFEPActivePixelListSub,1);
            av2 = cpMatrix(nonJPFEPActivePixelListSub,2);
            av3 = cpMatrix(nonJPFEPActivePixelListSub,3);
            allRadiiSub = allRadii(nonJPFEPActivePixelListSub);
            %---
            fep1 = cpMatrix(activeFEPListSub,1);
            fep2 = cpMatrix(activeFEPListSub,2);
            fep3 = cpMatrix(activeFEPListSub,3);
            %---
            jp1 = cpMatrix(activeJPListSub,1);
            jp2 = cpMatrix(activeJPListSub,2);
            jp3 = cpMatrix(activeJPListSub,3);
            %-----
            q1 = and(av1>=cf1a,av1<=cf1b);
            q2 = and(av2>=cf2a,av2<=cf2b);
            q3 = and(av3>=cf3a,av3<=cf3b);
            qq = and(and(q1,q2),q3);
            %-----


            if hideIslandsFlag == 1,
                if numel(isolatedStrandFlagList)<numel(nonJPFEPActivePixelListSub),
                    keyboard
                end%if numel...
                isolatedStrandFlagListSub = isolatedStrandFlagList(nonJPFEPActivePixelListSub);
                qq = and(qq,~isolatedStrandFlagListSub);
                %--
                activeFEPListSub = find(and(activeFEPList,and(labelPointerList,~isolatedStrandFlagList)));
                fep1 = cpMatrix(activeFEPListSub,1);
                fep2 = cpMatrix(activeFEPListSub,2);
                fep3 = cpMatrix(activeFEPListSub,3);
            end%if hideIslandsFlag == 1,

            %-----

            av1 = av1(qq); av2 = av2(qq) ; av3 = av3(qq);
            allRadiiSub = allRadiiSub(qq);
            activeMajorityZeroRadiusFlagSub = activeMajorityZeroRadiusFlagSub(qq);
            %---
            q1 = and(fep1>=cf1a,fep1<=cf1b);
            q2 = and(fep2>=cf2a,fep2<=cf2b);
            q3 = and(fep3>=cf3a,fep3<=cf3b);
            qq = and(and(q1,q2),q3);
            fep1 = fep1(qq); fep2 = fep2(qq) ; fep3 = fep3(qq);
            %---
            q1 = and(jp1>=cf1a,jp1<=cf1b);
            q2 = and(jp2>=cf2a,jp2<=cf2b);
            q3 = and(jp3>=cf3a,jp3<=cf3b);
            qq = and(and(q1,q2),q3);
            jp1 = jp1(qq); jp2 = jp2(qq) ; jp3 = jp3(qq);
            %-----
            switch label1Iter
                case {1};colorLabel = 'unlabeledColor';
                case {2};colorLabel = 'tempColor';
                case {3};colorLabel = 'supply';
                case {4};colorLabel = 'draining';
                case {5};colorLabel = 'connecting';
                case {6};colorLabel = 'extraColor1';
                case {7};colorLabel = 'extraColor2';

            end%switch label1Iter
            %----
            switch label2Iter
                case {1};symbolLabel = 'unlabeledSymbol';
                case {2};symbolLabel = 'tempSymbol';
                case {3};symbolLabel = 'surface';
                case {4};symbolLabel = 'plunging';
                case {5};symbolLabel = 'micro';
                case {6};symbolLabel = 'extraSymbol1';
                case {7};symbolLabel = 'extraSymbol2';

            end%switch label2Iter
            %-----
            visibleFlag = min(colorParameters.(colorLabel).visible,colorParameters.(symbolLabel).visible);
            visibleString = 'on';
            if visibleFlag == 0, visibleString = 'off'; end

            %-----

            switch displayOption
                case {1}%all points
                    p1 = plot3(av1,av2,-1*av3,'.');hold on
                    set(p1,'Color',colorCell{colorParameters.(colorLabel).color});
                    set(p1,'Marker',markerString(colorParameters.(symbolLabel).symbol));
                    set(p1,'Visible',visibleString);
                    %                     p2 = plot3(jp1,jp2,-1*jp3,'+');hold on
                    p2 = plot3(jp1,jp2,-1*jp3,'.');hold on
                    set(p2,'Color','green');
                    set(p2,'MarkerSize',10);
                    set(p2,'Visible',visibleString);
                    %                     p3 = plot3(fep1,fep2,-1*fep3,'+');hold on
                    p3 = plot3(fep1,fep2,-1*fep3,'.');hold on
                    set(p3,'Color','red');
                    set(p3,'MarkerSize',10);
                    set(p3,'Visible',visibleString);
                case {2}%junction points
                    p2 = plot3(jp1,jp2,-1*jp3,'+');hold on
                    set(p2,'Color','green');
                    set(p2,'MarkerSize',10);
                    set(p2,'Visible',visibleString);
                case {3}%end points
                    p3 = plot3(fep1,fep2,-1*fep3,'+');hold on
                    set(p3,'Color','red');
                    set(p3,'MarkerSize',10);
                    set(p3,'Visible',visibleString);
                case {4}% radius view
                    %sort by radius,
                    roundRadii = round(allRadiiSub);
                    maxRoundRadii = max(roundRadii);
                    for radiusIter = 1:maxRoundRadii+1;
                        ri = find(and(roundRadii>=radiusIter-1 , roundRadii<radiusIter));%ri means radius index
                        if ~isempty(ri),


                            try
                                p1 = plot3(av1(ri),av2(ri),-1*av3(ri),'.');hold on
                            catch
                                keyboard
                            end


                            set(p1,'Color',colorCell{colorParameters.(colorLabel).color});
                            set(p1,'Marker',markerString(colorParameters.(symbolLabel).symbol));
                            set(p1,'MarkerSize',radiusIter*radiusMultiplier);
                            set(p1,'Visible',visibleString);
                        end%if ~isempty(ri),
                    end%for radiusIter = 1:maxRoundRadii,
                    p2 = plot3(jp1,jp2,-1*jp3,'+');hold on
                    set(p2,'Color','green');
                    set(p2,'MarkerSize',10);
                    set(p2,'Visible',visibleString);
                    p3 = plot3(fep1,fep2,-1*fep3,'+');hold on
                    set(p3,'Color','red');
                    set(p3,'MarkerSize',10);
                    set(p3,'Visible',visibleString);
                case {5}% highlight zero Radius view
                    highlightPredominantZeroStrandsOnlyFlag = 1;
                    if highlightPredominantZeroStrandsOnlyFlag == 1,
                        zeroRadiusIndices = find(activeMajorityZeroRadiusFlagSub);
                    else%if highlightPredominantZeroStrandsOnlyFlag == 1,
                        zeroRadiusIndices = find(allRadiiSub==0);
                    end%if-else highlightPredominantZeroStrandsOnlyFlag == 1,
                    p1 = plot3(av1,av2,-1*av3,'.');hold on
                    set(p1,'Color','black');
                    set(p1,'Marker',markerString(colorParameters.(symbolLabel).symbol));
                    set(p1,'Visible',visibleString);
                    %---
                    zr1 = av1(zeroRadiusIndices);
                    zr2 = av2(zeroRadiusIndices);
                    zr3 = av3(zeroRadiusIndices);
                    p2 = plot3(zr1,zr2,-1*zr3,'.');hold on
                    set(p2,'Color','red');
                    set(p2,'Marker',markerString(colorParameters.(symbolLabel).symbol));
                    set(p2,'Visible',visibleString);

            end%switch displayOption
        end%if ~isempty(activePixelListSub)
        %-----
    end%for label2Iter
end%for label1Iter
xlabel('axis1')
ylabel('axis2')
zlabel('axis3')
radiusTitle = ['Selected Point Radius = ',num2str(selectedRadius(1))];
title(radiusTitle);
set(f2,'Name',radiusTitle);




px = plot3(ad1,ad2,-1*ad3,'o');
set(px,'MarkerSize',10);
set(px,'Color',[0.5 0.5 0.5]);% gray circles for selectedDots
axis equal
%-----
if selectStrandFlag == 1,
    ps = plot3(sd1,sd2,-1*sd3,'o');
    set(ps,'Color',[1 0.5 0]);%orange circles for selectedDots StrandMode
    set(ps,'MarkerSize',10);
end
%-----
if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
    if selectedPoints12(1) ~=0,
        temp1 = cpMatrix(selectedPoints12(1),1);
        temp2 = cpMatrix(selectedPoints12(1),2);
        temp3 = cpMatrix(selectedPoints12(1),3);
        pp1 = plot3(temp1,temp2,-1*temp3,'o');
        set(pp1,'Color',[1 0.6 0]);%thick orange circle for selectedPoint1
        set(pp1,'MarkerSize',12);
        set(pp1,'LineWidth',3);
    end%if selectedPoints12(1) ~=0,
    %---
    if selectedPoints12(2) ~=0,
        temp1 = cpMatrix(selectedPoints12(2),1);
        temp2 = cpMatrix(selectedPoints12(2),2);
        temp3 = cpMatrix(selectedPoints12(2),3);
        pp2 = plot3(temp1,temp2,-1*temp3,'o');
        set(pp2,'Color',[1 0.15 0]);%thick red-orange circle for selectedPoint1
        set(pp2,'MarkerSize',12);
        set(pp2,'LineWidth',3);
    end%if selectedPoints12(2) ~=0,
end%if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
%-----
set(currentAxis2,'CameraPosition',CameraPosition);
set(currentAxis2,'CameraTarget',CameraTarget);
set(currentAxis2,'CameraUpVector',CameraUpVector);
set(currentAxis2,'CameraViewAngle',CameraViewAngle);


%-----
if raw3DFlag == 1 && grayFlag == 1,
    %-----
    rp1 = rawPoints(:,1); rp2 = rawPoints(:,2); rp3 = rawPoints(:,3);ri = rawPoints(:,4);
    q1 = and(rp1>=cf1a,rp1<=cf1b);
    q2 = and(rp2>=cf2a,rp2<=cf2b);
    q3 = and(rp3>=cf3a,rp3<=cf3b);
    qq = and(and(q1,q2),q3);
    rp1 = rp1(qq); rp2 = rp2(qq) ; rp3 = rp3(qq);
    %-----
    figure(7);
    markerDivisor = 500;
    for kk = 1:length(rawPoints);
        pp = plot3(rawPoints(kk,1),rawPoints(kk,2),-1*rawPoints(kk,3),'ro'); hold on
        myIntensity = rawPoints(kk,4)./markerDivisor;
        set(pp,'MarkerSize',myIntensity);
    end%for kk
    minRP = min(rawPoints,[],1);
    maxRP = max(rawPoints,[],1);
    plot3([minRP(1);maxRP(1)],[currentPosition(2);currentPosition(2)],[-1*currentPosition(3);-1*currentPosition(3)],'r-')
    plot3([currentPosition(1);currentPosition(1)],[minRP(2);maxRP(2)],[-1*currentPosition(3);-1*currentPosition(3)],'g-')
    plot3([currentPosition(1);currentPosition(1)],[currentPosition(2);currentPosition(2)],[-1*minRP(3);-1*maxRP(3)],'b-')
    hold off
    xlabel('axis1')
    ylabel('axis2')
    zlabel('axis3')
    title(['Downsampled by factor of ',num2str(globalDataStruct.decimateBy)]);
    currentAxis7 = gca;
    %-----
    set(currentAxis7,'CameraPosition',CameraPosition);
    set(currentAxis7,'CameraTarget',CameraTarget);
    set(currentAxis7,'CameraUpVector',CameraUpVector);
    set(currentAxis7,'CameraViewAngle',CameraViewAngle);
    drawnow
end%if raw3DFlag == 1 && grayFlag == 1,
globalDataStruct.validClick = validClick;
return




function GrabAffiliatedPoints(handles,currentPointer)
global globalDataStruct
strandIndices = globalDataStruct.strandIndices; %strandIndex list
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
allConfidences = globalDataStruct.allConfidences;
% % allNotes = globalDataStruct.allNotes;

strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7 : label
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
affiliatedCPList = globalDataStruct.selectionParameters.affiliatedCPList;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
selectedRadius = globalDataStruct.selectionParameters.selectedRadius;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;
numBranches = globalDataStruct.numBranches;
branchStruct = globalDataStruct.branchStruct;
strandStatsFlag = globalDataStruct.strandStatsFlag;
selectedRadius = allRadii(currentPointer);
%selectStrandFlag, selectPoint1Flag, selectPoint2Flag
if ~isempty(currentPointer),
    if selectStrandFlag == 1,
        selectedCPList = [];
        affiliatedCPList = [];
        selectedPoints12 = [0 0];
        sd1=[];sd2=[];sd3=[];%selectedDots stands for selectedDots
        ad1=[];ad2=[];ad3=[];%affiliatedDots stands for affiliatedDots
        %if currentPointer points to a junction point, do nothing (ambiguous)
        if cpMatrix(currentPointer,5) == 1, %junction Point
            disp('Junction point selected - ambiguous strand selection');
            selectedCPList = [];
        else%if cpMatrix(currentPointer,5) == 1, %junction Point
            try
                if iscell(strandIndices) %% added by Pablo
                    currentStrand = strandIndices{currentPointer}(1);
                else
                    currentStrand = strandIndices(currentPointer,1);
                end
            catch
                keyboard
            end

            stei = strands(currentStrand).StartToEndIndices;
            for pointIter = 1:length(stei)
                %do not include junction points
                thisPoint = stei(pointIter);
                if cpMatrix(thisPoint,5) ~= 1, %not a junction Point
                    sd1 = [sd1;cpMatrix(thisPoint,1)];
                    sd2 = [sd2;cpMatrix(thisPoint,2)];
                    sd3 = [sd3;cpMatrix(thisPoint,3)];
                    selectedCPList = [selectedCPList,thisPoint];
                end%if cpMatrix(thisPoint,5) ~= 1 %not a junction Point
            end%for pointIter = 1:length(stei)
        end%if cpMatrix(currentPointer,5) == 1, %junction Point
    end%if selectStrandFlag == 1
    %------
    if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
        selectedCPList = [];
        affiliatedCPList = [];
        sd1=[];sd2=[];sd3=[];%selectedDots stands for selectedDots
        ad1=[];ad2=[];ad3=[];%affiliatedDots stands for affiliatedDots

        try
            if iscell(strandIndices) %% added by Pablo
                selectedCPList = strandIndices{currentPointer}(1);
            else
                selectedCPList = strandIndices(currentPointer,1);
            end

        catch
            keyboard
        end

        if selectPoint1Flag == 1, selectedPoints12(1) = currentPointer(1); end
        if selectPoint2Flag == 1, selectedPoints12(2) = currentPointer(1); end
        sd1 = cpMatrix(currentPointer,1);
        sd2 = cpMatrix(currentPointer,2);
        sd3 = cpMatrix(currentPointer,3);
        %mark strand(s) containing this point as afilliated

        if iscell(strandIndices) %% added by Pablo
            attachedStrands = strandIndices{currentPointer}(1);
        else
            attachedStrands = strandIndices(currentPointer,1);
        end
        %         attachedStrands = strandIndices(currentPointer,1);
        numStrandsAttached = size(attachedStrands,2);
        for strandIter = 1:numStrandsAttached,
            currentStrand = attachedStrands(strandIter);
            stei = strands(currentStrand).StartToEndIndices;
            for pointIter = 1:length(stei)
                %do not include junction points
                thisPoint = stei(pointIter);
                if cpMatrix(thisPoint,5) ~= 1, %not a junction Point
                    ad1 = [ad1;cpMatrix(thisPoint,1)];
                    ad2 = [ad2;cpMatrix(thisPoint,2)];
                    ad3 = [ad3;cpMatrix(thisPoint,3)];
                    affiliatedCPList = [affiliatedCPList,thisPoint];
                end%if cpMatrix(thisPoint,5) ~= 1 %not a junction Point
            end%for pointIter = 1:length(stei)
        end%for strandIter = 1:numStrandsAttached
    end%if or(selectPoint1Flag == 1, selectPoint2Flag == 1),
    globalDataStruct.selectionParameters.selectedCPList = selectedCPList;
    globalDataStruct.selectionParameters.affiliatedCPList = affiliatedCPList;
    globalDataStruct.selectionParameters.selectedPoints12 = selectedPoints12;
    globalDataStruct.selectionParameters.selectedRadius = selectedRadius;
    globalDataStruct.selectedDots = [sd1,sd2,sd3];
    globalDataStruct.affiliatedDots = [ad1,ad2,ad3];
    GenerateDisplay(handles)
    %---
    if strandStatsFlag == 1,
        DisplayStrandStats(handles,currentPointer),
    end%if strandStatsFlag == 1,
end%if ~isempty(currentPointer)



function DisplayStrandStats(handles,currentPointer),
global globalDataStruct;
strandIndices = globalDataStruct.strandIndices; %strandIndex list
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
allConfidences = globalDataStruct.allConfidences;
% % allNotes = globalDataStruct.allNotes;
strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
%   cols1-3:coords, col4:endPointFlag, col5:junctionFlag, col6:activeFlag
%   col7 : label
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
affiliatedCPList = globalDataStruct.selectionParameters.affiliatedCPList;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
selectedRadius = globalDataStruct.selectionParameters.selectedRadius;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;
numBranches = globalDataStruct.numBranches;
branchStruct = globalDataStruct.branchStruct;
%-----
selectedRadius = allRadii(currentPointer);
currentStrandID = strandIndices(currentPointer,1);
selectedConfidence = allConfidences(currentPointer);
thisLabel = allLabels(currentPointer);
% % selectedNote = allNotes{currentPointer};
%-----
strandStats = '\n';
stat1 = ['Point Radius  :  ', num2str(selectedRadius),'\n'];
strandStats = [strandStats,stat1];
%---
stat1 = ['ID# (cpMatrix ID)  :  ', num2str(currentPointer),'\n'];
strandStats = [strandStats,stat1];
%---
stat1 = ['Coords  :  ', num2str(cpMatrix(currentPointer,1:3)),'\n'];
strandStats = [strandStats,stat1];
%---
% % stat1 = ['Point Notes  :  ', selectedNote,'\n'];
% % strandStats = [strandStats,stat1];
%---
if numel(currentStrandID)>1,
    %this is a node
    stat1 = ['Strands Attached  :  ', num2str(currentStrandID),'\n'];
    strandStats = [strandStats,stat1];
else%if numel(currentStrandID)>1,
    thisStrand = strands(currentStrandID);
    cpIndices = thisStrand.StartToEndIndices;
    strandLength = numel(cpIndices);
    strandRadList = allRadii(cpIndices);
    strandLabelList = allLabels(cpIndices);
    strandConfidenceList = allConfidences(cpIndices);
    % %     strandNoteList = [];
    % %     for k = 1:size(cpIndices,2);
    % %         if ~isempty(allNotes{cpIndices(k)});
    % %             strandNoteList = cat(2,strandNoteList,[num2str(k),' : ',allNotes{cpIndices(k)},'\n']);
    % %         end%if ~isempty(allNotes{cpIndices(k)});
    % %     end%for k = 1:size(cpIndices,2);
    uniqueLabels = unique(strandLabelList);
    majorityLabel = median(strandLabelList);
    majorityConfidence = median(strandConfidenceList);
    minRadius = min(strandRadList);
    minNonZeroRadius = min(strandRadList(strandRadList>0));
    maxRadius = max(strandRadList);
    meanNonZeroRadius = mean(strandRadList(strandRadList>0));
    medianNonZeroRadius = median(strandRadList(strandRadList>0));
    stdRadius = std(strandRadList(strandRadList>0));
    numZeroRadius = numel(find(strandRadList ==0));
    %---
    stat1 = ['Strand ID  :  ', num2str(currentStrandID),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Strand Length  :  ', num2str(strandLength),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Strand Labels  :  ', num2str(uniqueLabels'),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Majority Label  :   ', num2str(majorityLabel),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Majority Confidence  :   ', num2str(majorityConfidence),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Selected Point Confidence  :   ', num2str(selectedConfidence),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Number of Zero Radii  :   ', num2str(numZeroRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Min Strand Radius  :   ', num2str(minRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Min NonZero Strand Radius  :   ', num2str(minNonZeroRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Max Strand Radius  :   ', num2str(maxRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Mean NonZero Strand Radius  :   ', num2str(meanNonZeroRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Median NonZero Strand Radius  :   ', num2str(medianNonZeroRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    stat1 = ['Stdev NonZero Strand Radius  :   ', num2str(stdRadius),'\n'];
    strandStats = [strandStats,stat1];
    %---
    % %     stat1 = ['Strand Notes  :   ', strandNoteList,'\n'];
    % %     strandStats = [strandStats,stat1];
    %---
    autoInsertMedianRadiusFlag = 1;
    if autoInsertMedianRadiusFlag == 1,
        set(handles.radiusEdit,'String',num2str(medianNonZeroRadius,'%0.3f'));
    end%if autoInsertMedianRadiusFlag == 1,

end%if-else numel(currentStrandID)>1,
strandStatString = sprintf(strandStats);
f95 = figure(95);
p1 = plot(0,0,'w.');hold on
p2 = plot(1,1,'w.');hold off
set(p1,'Visible','off');
set(p2,'Visible','off');
set(gca,'XTick',[]);
set(gca,'YTick',[]);
t1 = text(0.5,1,strandStatString);
title('STRAND STATS')
set(t1,'HorizontalAlignment','center');
set(t1,'VerticalAlignment','top');




































function limitBoxEdit1_Callback(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of limitBoxEdit1 as text
%        str2double(get(hObject,'String')) returns contents of limitBoxEdit1 as a double
global globalDataStruct;
newBoxSize = str2num(get(hObject,'String'));
if isempty(newBoxSize),
    newBoxSize = globalDataStruct.limitBoxSize(1);
    set(hObject,'String',num2str(newBoxSize));
end%if isempty(newBoxSize),
globalDataStruct.limitBoxSize(1) = newBoxSize;




function limitBoxEdit2_Callback(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of limitBoxEdit2 as text
%        str2double(get(hObject,'String')) returns contents of limitBoxEdit2 as a double
global globalDataStruct;
newBoxSize = str2num(get(hObject,'String'));
if isempty(newBoxSize),
    newBoxSize = globalDataStruct.limitBoxSize(2);
    set(hObject,'String',num2str(newBoxSize));
end%if isempty(newBoxSize),
globalDataStruct.limitBoxSize(2) = newBoxSize;


function limitBoxEdit3_Callback(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of limitBoxEdit3 as text
%        str2double(get(hObject,'String')) returns contents of limitBoxEdit3 as a double
global globalDataStruct;
newBoxSize = str2num(get(hObject,'String'));
if isempty(newBoxSize),
    newBoxSize = globalDataStruct.limitBoxSize(3);
    set(hObject,'String',num2str(newBoxSize));
end%if isempty(newBoxSize),
globalDataStruct.limitBoxSize(3) = newBoxSize;



% --- Executes on button press in autoBoxToggleButton.
function autoBoxToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to autoBoxToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of autoBoxToggleButton
global globalDataStruct
globalDataStruct.autoBoxFlag = get(hObject,'Value');
GenerateDisplay(handles)



% --- Executes on button press in autoTrackToggleButton.
function autoTrackToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to autoTrackToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of autoTrackToggleButton
global globalDataStruct
globalDataStruct.autoTrackFlag = get(hObject,'Value');
GenerateDisplay(handles)




% --- Executes on button press in applyBoxButton.
function applyBoxButton_Callback(hObject, eventdata, handles)
% hObject    handle to applyBoxButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ApplyLimitBox(handles)
GenerateDisplay(handles)



function ApplyLimitBox(handles)
global globalDataStruct
limitBoxSize = globalDataStruct.limitBoxSize;
cutFrames = globalDataStruct.cutFrames;
selectionParameters = globalDataStruct.selectionParameters;
cpMatrix = globalDataStruct.cpMatrix;
maskSize = globalDataStruct.maskSize;
markLimitsStruct = globalDataStruct.markLimitsStruct;
%---
selectedPoints12 = selectionParameters.selectedPoints12;
currentPoint = round(selectedPoints12(1));
if currentPoint == 0,
    currentPoint = globalDataStruct.currentPointer;
end%if currentPoint == 0,

currentCoords = cpMatrix(currentPoint,1:3);
cc1 = currentCoords(1);
cc2 = currentCoords(2);
cc3 = currentCoords(3);
lim1a = max(cc1 - limitBoxSize(1),1);
lim1b = min(cc1 + limitBoxSize(1), maskSize(1));
lim2a = max(cc2 - limitBoxSize(2),1);
lim2b = min(cc2 + limitBoxSize(2), maskSize(2));
lim3a = max(cc3 - limitBoxSize(3),1);
lim3b = min(cc3 + limitBoxSize(3), maskSize(3));
%---
%If reverting to a saved limit box, do this instead:
if ~isempty(markLimitsStruct) && markLimitsStruct.revertNowFlag == 1,
    markLimitsStruct.revertNowFlag = 0;
    cutFrames = markLimitsStruct.cutFrames;
    lim1a = cutFrames(1,1); lim1b = cutFrames(1,2);
    lim2a = cutFrames(2,1); lim2b = cutFrames(2,2);
    lim3a = cutFrames(3,1); lim3b = cutFrames(3,2);
end%if ~isempty(markLimitsStruct) && markLimitsStruct.revertNowFlag == 1,
%---
set(handles.cropStartX1,'String',num2str(lim1a));
set(handles.cropStopX1,'String',num2str(lim1b));
set(handles.cropStartX2,'String',num2str(lim2a));
set(handles.cropStopX2,'String',num2str(lim2b));
set(handles.cropStartX3,'String',num2str(lim3a));
set(handles.cropStopX3,'String',num2str(lim3b));
%---
set(handles.cropStartX1Slider,'Value',lim1a./maskSize(1));
set(handles.cropStopX1Slider,'Value',lim1b./maskSize(1));
set(handles.cropStartX2Slider,'Value',lim2a./maskSize(2));
set(handles.cropStopX2Slider,'Value',lim2b./maskSize(2));
set(handles.cropStartX3Slider,'Value',lim3a./maskSize(3));
set(handles.cropStopX3Slider,'Value',lim3b./maskSize(3));
%---
cutFrames = [lim1a lim1b ; lim2a lim2b ; lim3a lim3b];
globalDataStruct.cutFrames = cutFrames;
globalDataStruct.markLimitsStruct = markLimitsStruct;








function cropStartX1_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStartX1 as text
%        str2double(get(hObject,'String')) returns contents of cropStartX1 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(1,1);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(1,1) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return

% --- Executes during object creation, after setting all properties.
function cropStartX1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cropStartX2_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStartX2 as text
%        str2double(get(hObject,'String')) returns contents of cropStartX2 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(2,1);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(2,1) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return

% --- Executes during object creation, after setting all properties.
function cropStartX2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cropStartX3_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStartX3 as text
%        str2double(get(hObject,'String')) returns contents of cropStartX3 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(3,1);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(3,1) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return

% --- Executes during object creation, after setting all properties.
function cropStartX3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cropStopX1_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStopX1 as text
%        str2double(get(hObject,'String')) returns contents of cropStopX1 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(1,2);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(1,2) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return

% --- Executes during object creation, after setting all properties.
function cropStopX1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cropStopX2_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStopX2 as text
%        str2double(get(hObject,'String')) returns contents of cropStopX2 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(2,2);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(2,2) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return


% --- Executes during object creation, after setting all properties.
function cropStopX2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cropStopX3_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cropStopX3 as text
%        str2double(get(hObject,'String')) returns contents of cropStopX3 as a double
global globalDataStruct
currentVal = str2num(get(hObject,'String'));
if isempty(currentVal),
    currentVal = globalDataStruct.cutFrames(3,2);
    set(hObject,'String',currentVal);
else%if isempty(currentVal)
    globalDataStruct.cutFrames(3,2) = currentVal;
    GenerateDisplay(handles)
end%if isempty(currentVal)
return

% --- Executes during object creation, after setting all properties.
function cropStopX3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on slider movement.
function cropStartX1Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX1Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(1,1) = round(get(hObject,'Value') * globalDataStruct.maskSize(1));
set(handles.cropStartX1,'String',num2str(globalDataStruct.cutFrames(1,1)));
if globalDataStruct.cutFrames(1,2)<globalDataStruct.cutFrames(1,1),
    globalDataStruct.cutFrames(1,2) = globalDataStruct.cutFrames(1,1);
    set(handles.cropStopX1,'String',num2str(globalDataStruct.cutFrames(1,2)));
    set(handles.cropStopX1Slider,'Value',globalDataStruct.cutFrames(1,2)./globalDataStruct.maskSize(1));
end%if globalDataStruct.cutFrames(1,2)<globalDataStruct.cutFrames(1,1),
GenerateDisplay(handles)

% --- Executes during object creation, after setting all properties.
function cropStartX1Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX1Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function cropStopX1Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX1Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(1,2) = round(get(hObject,'Value') * globalDataStruct.maskSize(1));
set(handles.cropStopX1,'String',num2str(globalDataStruct.cutFrames(1,2)));
if globalDataStruct.cutFrames(1,2)<globalDataStruct.cutFrames(1,1),
    globalDataStruct.cutFrames(1,1) = globalDataStruct.cutFrames(1,2);
    set(handles.cropStartX1,'String',num2str(globalDataStruct.cutFrames(1,1)));
    set(handles.cropStartX1Slider,'Value',globalDataStruct.cutFrames(1,1)./globalDataStruct.maskSize(1));
end%if globalDataStruct.cutFrames(1,2)<globalDataStruct.cutFrames(1,1),
GenerateDisplay(handles)

% --- Executes during object creation, after setting all properties.
function cropStopX1Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX1Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function cropStartX2Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX2Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(2,1) = round(get(hObject,'Value') * globalDataStruct.maskSize(2));
set(handles.cropStartX2,'String',num2str(globalDataStruct.cutFrames(2,1)));
if globalDataStruct.cutFrames(2,2)<globalDataStruct.cutFrames(2,1),
    globalDataStruct.cutFrames(2,2) = globalDataStruct.cutFrames(2,1);
    set(handles.cropStopX2,'String',num2str(globalDataStruct.cutFrames(2,2)));
    set(handles.cropStopX2Slider,'Value',globalDataStruct.cutFrames(2,2)./globalDataStruct.maskSize(2));
end%if globalDataStruct.cutFrames(2,2)<globalDataStruct.cutFrames(2,1),
GenerateDisplay(handles)

% --- Executes during object creation, after setting all properties.
function cropStartX2Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX2Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function cropStopX2Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX2Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(2,2) = round(get(hObject,'Value') * globalDataStruct.maskSize(2));
set(handles.cropStopX2,'String',num2str(globalDataStruct.cutFrames(2,2)));
if globalDataStruct.cutFrames(2,2)<globalDataStruct.cutFrames(2,1),
    globalDataStruct.cutFrames(2,1) = globalDataStruct.cutFrames(2,2);
    set(handles.cropStartX2,'String',num2str(globalDataStruct.cutFrames(3,1)));
    set(handles.cropStartX2Slider,'Value',globalDataStruct.cutFrames(3,1)./globalDataStruct.maskSize(2));
end%if globalDataStruct.cutFrames(2,2)<globalDataStruct.cutFrames(2,1),
GenerateDisplay(handles)

% --- Executes during object creation, after setting all properties.
function cropStopX2Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX2Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function cropStartX3Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStartX3Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(3,1) = round(get(hObject,'Value') * globalDataStruct.maskSize(3));
set(handles.cropStartX3,'String',num2str(globalDataStruct.cutFrames(3,1)));
if globalDataStruct.cutFrames(3,2)<globalDataStruct.cutFrames(3,1),
    globalDataStruct.cutFrames(3,2) = globalDataStruct.cutFrames(3,1);
    set(handles.cropStopX3,'String',num2str(globalDataStruct.cutFrames(3,2)));
    set(handles.cropStopX3Slider,'Value',globalDataStruct.cutFrames(3,2)./globalDataStruct.maskSize(3));
end%if globalDataStruct.cutFrames(3,2)<globalDataStruct.cutFrames(3,1),
GenerateDisplay(handles)

% --- Executes during object creation, after setting all properties.
function cropStartX3Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStartX3Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function cropStopX3Slider_Callback(hObject, eventdata, handles)
% hObject    handle to cropStopX3Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global globalDataStruct
globalDataStruct.cutFrames(3,2) = round(get(hObject,'Value') * globalDataStruct.maskSize(3));
set(handles.cropStopX3,'String',num2str(globalDataStruct.cutFrames(3,2)));
if globalDataStruct.cutFrames(3,2)<globalDataStruct.cutFrames(3,1),
    globalDataStruct.cutFrames(3,1) = globalDataStruct.cutFrames(3,2);
    set(handles.cropStartX3,'String',num2str(globalDataStruct.cutFrames(3,1)));
    set(handles.cropStartX3Slider,'Value',globalDataStruct.cutFrames(3,1)./globalDataStruct.maskSize(3));
end%if globalDataStruct.cutFrames(3,2)<globalDataStruct.cutFrames(3,1),
GenerateDisplay(handles)


% --- Executes during object creation, after setting all properties.
function cropStopX3Slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cropStopX3Slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end







% --- Executes on button press in addPointButton.
function addPointButton_Callback(hObject, eventdata, handles)
% hObject    handle to addPointButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
cpMatrix = globalDataStruct.cpMatrix;
strands = globalDataStruct.strands;
strandIndices = globalDataStruct.strandIndices;%strandIndices
allRadii = globalDataStruct.allRadii;
allLabels = globalDataStruct.allLabels;
allConfidences = globalDataStruct.allConfidences;
% % allNotes = globalDataStruct.allNotes;
%-----
newCPEntry = size(cpMatrix,1)+1;
newStrandID = size(strands,2)+1;
cpMatrix(newCPEntry,1:3) = round(addPointCoord);
cpMatrix(newCPEntry,4:7) = [0 0 1 113];%113 = label for "manually added"
allRadii(newCPEntry) = 0; %Set radius of new point to zero
allLabels(newCPEntry) = 113;
allConfidences(newCPEntry) = 999;%999 = confidence for manually added
% % allNotes{newCPEntry} = [];
strandIndices(newCPEntry,1) = newStrandID;
%---
strands(newStrandID).StartToEndIndices = newCPEntry;
globalDataStruct.cpMatrix = cpMatrix;
globalDataStruct.strands = strands;
globalDataStruct.allRadii = allRadii;
globalDataStruct.allLabels = allLabels;
globalDataStruct.allConfidences = allConfidences;
% % globalDataStruct.allNotes = allNotes;
globalDataStruct.strandIndices = strandIndices;
globalDataStruct.strandIndices = strandIndices;
%-----
globalDataStruct.validClick = 1;
RecalculateZeroRadiusList(handles)
GenerateDisplay(handles)






function addX1Edit_Callback(hObject, eventdata, handles)
% hObject    handle to addX1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of addX1Edit as text
%        str2double(get(hObject,'String')) returns contents of addX1Edit as a double
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
newValue = str2num(get(hObject,'String'));
if isempty(newValue),
    newValue = addPointCoord(1);
end%if isempty(newValue)
newValue = min(max(round(newValue),1),maskSize(1));
set(handles.addX1Edit,'String',num2str(newValue));
addPointCoord(1) = newValue;
globalDataStruct.addPointCoord = addPointCoord;




function addX2Edit_Callback(hObject, eventdata, handles)
% hObject    handle to addX2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of addX2Edit as text
%        str2double(get(hObject,'String')) returns contents of addX2Edit as a double
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
newValue = str2num(get(hObject,'String'));
if isempty(newValue),
    newValue = addPointCoord(2);
end%if isempty(newValue)
newValue = min(max(round(newValue),1),maskSize(2));
set(handles.addX2Edit,'String',num2str(newValue));
addPointCoord(2) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



function addX3Edit_Callback(hObject, eventdata, handles)
% hObject    handle to addX3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of addX3Edit as text
%        str2double(get(hObject,'String')) returns contents of addX3Edit as a double
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
newValue = str2num(get(hObject,'String'));
if isempty(newValue),
    newValue = addPointCoord(3);
end%if isempty(newValue)
newValue = min(max(round(newValue),1),maskSize(3));
set(handles.addX3Edit,'String',num2str(newValue));
addPointCoord(3) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX1PlusButton.
function addX1PlusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX1PlusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(1);
newValue = min(max(round(oldValue+1),1),maskSize(1));
set(handles.addX1Edit,'String',num2str(newValue));
addPointCoord(1) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX1MinusButton.
function addX1MinusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX1MinusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(1);
newValue = min(max(round(oldValue-1),1),maskSize(1));
set(handles.addX1Edit,'String',num2str(newValue));
addPointCoord(1) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX2PlusButton.
function addX2PlusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX2PlusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(2);
newValue = min(max(round(oldValue+1),1),maskSize(2));
set(handles.addX2Edit,'String',num2str(newValue));
addPointCoord(2) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX2MinusButton.
function addX2MinusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX2MinusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(2);
newValue = min(max(round(oldValue-1),1),maskSize(2));
set(handles.addX2Edit,'String',num2str(newValue));
addPointCoord(2) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX3PlusButton.
function addX3PlusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX3PlusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(3);
newValue = min(max(round(oldValue+1),1),maskSize(3));
set(handles.addX3Edit,'String',num2str(newValue));
addPointCoord(3) = newValue;
globalDataStruct.addPointCoord = addPointCoord;



% --- Executes on button press in addX3MinusButton.
function addX3MinusButton_Callback(hObject, eventdata, handles)
% hObject    handle to addX3MinusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
addPointCoord = globalDataStruct.addPointCoord;
maskSize = globalDataStruct.maskSize;
oldValue = addPointCoord(3);
newValue = min(max(round(oldValue-1),1),maskSize(3));
set(handles.addX3Edit,'String',num2str(newValue));
addPointCoord(3) = newValue;
globalDataStruct.addPointCoord = addPointCoord;




function projectionExtentEdit_Callback(hObject, eventdata, handles)
% hObject    handle to projectionExtentEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of projectionExtentEdit as text
%        str2double(get(hObject,'String')) returns contents of projectionExtentEdit as a double
global globalDataStruct
projectionExtent = str2num(get(hObject,'String'));
if isempty(projectionExtent),
    projectionExtent = 100;
end%if isempty(projectionExtent),
projectionExtent = max(5,projectionExtent);
globalDataStruct.projectionExtent = projectionExtent;
globalDataStruct.validClick = 1;
GenerateDisplay(handles)


function projectionDepthEdit_Callback(hObject, eventdata, handles)
% hObject    handle to projectionDepthEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of projectionDepthEdit as text
%        str2double(get(hObject,'String')) returns contents of projectionDepthEdit as a double
global globalDataStruct
projectionDepth = str2num(get(hObject,'String'));
if isempty(projectionDepth),
    projectionDepth = 10;
end%if isempty(projectionDepth),
projectionDepth = max(0,projectionDepth);
globalDataStruct.projectionDepth = projectionDepth;
globalDataStruct.validClick = 1;
GenerateDisplay(handles)


% --- Executes on button press in showCenterlineToggleButton.
function showCenterlineToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to showCenterlineToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showCenterlineToggleButton
global globalDataStruct
globalDataStruct.showCenterlineFlag = get(hObject,'Value');
globalDataStruct.validClick = 1;
GenerateDisplay(handles)


% --- Executes on button press in showTargetToggleButton.
function showTargetToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to showTargetToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of showTargetToggleButton
global globalDataStruct
globalDataStruct.showTargetFlag = get(hObject,'Value');
globalDataStruct.validClick = 1;
GenerateDisplay(handles)


% --- Executes on button press in logScaleToggleButton.
function logScaleToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to logScaleToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of logScaleToggleButton
global globalDataStruct
globalDataStruct.logScaleFlag = get(hObject,'Value');
if globalDataStruct.logScaleFlag == 1,
    globalDataStruct.sqrtScaleFlag = 0;
    set(handles.sqrtScaleToggleButton,'Value',0);
end%if globalDataStruct.logScaleFlag == 1,
globalDataStruct.validClick = 1;
GenerateDisplay(handles)



% --- Executes on button press in sqrtScaleToggleButton.
function sqrtScaleToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to sqrtScaleToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of sqrtScaleToggleButton
global globalDataStruct
globalDataStruct.sqrtScaleFlag = get(hObject,'Value');
if globalDataStruct.sqrtScaleFlag == 1,
    globalDataStruct.logScaleFlag = 0;
    set(handles.logScaleToggleButton,'Value',0);
end%if globalDataStruct.sqrtScaleFlag == 1,
globalDataStruct.validClick = 1;
GenerateDisplay(handles)















% --- Executes during object creation, after setting all properties.
function thresholdEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function thresholdSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes during object creation, after setting all properties.
function label1Menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to label1Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function label2Menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to label2Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function limitBoxEdit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function branchMenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to branchMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function addX1Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to addX1Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function addX2Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to addX2Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function addX3Edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to addX3Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function radiusMultiplierEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to radiusMultiplierEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function projectionExtentEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to projectionExtentEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function projectionDepthEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to projectionDepthEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in strandStatsToggleButton.
function strandStatsToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to strandStatsToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
globalDataStruct.strandStatsFlag = get(hObject,'Value');
if globalDataStruct.strandStatsFlag == 1,
    f95 = figure(95); set(f95,'Visible','on');
    title('STRAND STATS');
else%if globalDataStruct.strandStatsFlag == 1,
    f95 = figure(95); set(f95,'Visible','off');
end%if globalDataStruct.strandStatsFlag == 1,

GenerateDisplay(handles);

% --- Executes on button press in emptyModule2Button.
function emptyModule2Button_Callback(hObject, eventdata, handles)
% hObject    handle to emptyModule2Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in emptyModule3Button.
function emptyModule3Button_Callback(hObject, eventdata, handles)
% hObject    handle to emptyModule3Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in markLimitsButton.
function markLimitsButton_Callback(hObject, eventdata, handles)
% hObject    handle to markLimitsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
markLimitsStruct = globalDataStruct.markLimitsStruct;
currentAxis2 = globalDataStruct.currentAxis2;
cutFrames = globalDataStruct.cutFrames;%cutFrames stands for cutFrames
currentPosition = globalDataStruct.currentPosition;
%-----
%Grab all the information for the current box limits and camera view
markLimitsStruct.CameraPosition = get(currentAxis2,'CameraPosition');
markLimitsStruct.CameraTarget = get(currentAxis2,'CameraTarget');
markLimitsStruct.CameraUpVector = get(currentAxis2,'CameraUpVector');
markLimitsStruct.CameraViewAngle = get(currentAxis2,'CameraViewAngle');
markLimitsStruct.cutFrames = cutFrames;%cutFrames stands for cutFrames;
markLimitsStruct.currentPosition = currentPosition;
markLimitsStruct.revertNowFlag = 1;
%-----
globalDataStruct.markLimitsStruct = markLimitsStruct;



% --- Executes on button press in revertLimitsButton.
function revertLimitsButton_Callback(hObject, eventdata, handles)
% hObject    handle to revertLimitsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct
markLimitsStruct = globalDataStruct.markLimitsStruct;
currentAxis2 = globalDataStruct.currentAxis2;
cutFrames = globalDataStruct.cutFrames;%cutFrames stands for cutFrames
if ~isempty(markLimitsStruct),
    set(currentAxis2,'CameraPosition',markLimitsStruct.CameraPosition);
    set(currentAxis2,'CameraTarget',markLimitsStruct.CameraTarget);
    set(currentAxis2,'CameraUpVector',markLimitsStruct.CameraUpVector);
    set(currentAxis2,'CameraViewAngle',markLimitsStruct.CameraViewAngle);
    cutFrames = markLimitsStruct.cutFrames;
    markLimitsStruct.revertNowFlag = 1;
end
set(handles.cropStartX1,'String',num2str(cutFrames(1,1)));
set(handles.cropStartX2,'String',num2str(cutFrames(2,1)));
set(handles.cropStartX3,'String',num2str(cutFrames(3,1)));
set(handles.cropStopX1,'String',num2str(cutFrames(1,2)));
set(handles.cropStopX2,'String',num2str(cutFrames(2,2)));
set(handles.cropStopX3,'String',num2str(cutFrames(3,2)));
set(handles.cropStartX1Slider,'Value',cutFrames(1,1)./globalDataStruct.maskSize(1));
set(handles.cropStartX2Slider,'Value',cutFrames(2,1)./globalDataStruct.maskSize(2));
set(handles.cropStartX3Slider,'Value',cutFrames(3,1)./globalDataStruct.maskSize(3));
set(handles.cropStopX1Slider,'Value',cutFrames(1,2)./globalDataStruct.maskSize(1));
set(handles.cropStopX2Slider,'Value',cutFrames(2,2)./globalDataStruct.maskSize(2));
set(handles.cropStopX3Slider,'Value',cutFrames(3,2)./globalDataStruct.maskSize(3));
%-----
globalDataStruct.markLimitsStruct = markLimitsStruct;
globalDataStruct.currentPosition = markLimitsStruct.currentPosition;
globalDataStruct.cutFrames = cutFrames;
globalDataStruct.currentAxis2 = currentAxis2;
GenerateDisplay(handles);




% --- Executes during object creation, after setting all properties.
function limitBoxEdit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function limitBoxEdit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to limitBoxEdit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%-----
function InitializeGlobalDataStruct(blank)
global globalDataStruct
%-----
globalDataStruct.displayOption = 1;
globalDataStruct.selectedDots = [0,0,0];
globalDataStruct.affiliatedDots = [0,0,0];
%-----
selectionParameters = blank;
selectionParameters.selectStrandFlag = 1;
selectionParameters.selectPoint1Flag = 0;
selectionParameters.selectPoint2Flag = 0;
selectionParameters.selectedCPList = [1];
selectionParameters.affiliatedCPList = [];
selectionParameters.selectedPoints12 = [0 0];
selectionParameters.selectedRadius = 0;
globalDataStruct.selectionParameters = selectionParameters;
globalDataStruct.currentPointer = 1;
globalDataStruct.refreshRawDataDisplayFlag = 0;
globalDataStruct.loadDataSetFlag = 0;
globalDataStruct.exitFlag = 0;
globalDataStruct.decimateBy = 3;
globalDataStruct.nextDirection = +1;
globalDataStruct.limitBoxSize = [50 50 50];
globalDataStruct.addPointCoord = [1 1 1];
globalDataStruct.numBranches = 0;
globalDataStruct.branchStruct = [];
globalDataStruct.radiusMultiplier = 3;
globalDataStruct.logScaleFlag = 0;
globalDataStruct.sqrtScaleFlag = 1;
globalDataStruct.showCenterlineFlag = 1;
globalDataStruct.showTargetFlag = 1;
globalDataStruct.raw3DFlag = 0;
globalDataStruct.grayFlag = 1;
globalDataStruct.projectionExtent = 100;%plus/minus
globalDataStruct.projectionDepth = 10;%plus/minus
globalDataStruct.validClick = 0;
globalDataStruct.autoBoxFlag = 0;
globalDataStruct.autoTrackFlag = 0;
globalDataStruct.markLimitsStruct = [];
globalDataStruct.highlightZeroRadiusFlag = 0;
globalDataStruct.strandStatsFlag = 0;
globalDataStruct.hideIslandsFlag = 0;
%-----
%Define colorPanels
%ColorPalette =
colorParameters = blank;
colorParameters.colorList = 'kmrbgcy';
colorParameters.symbolList = '.*oxds^';
%---
colorParameters.unlabeledSymbol.color = 0;
colorParameters.unlabeledSymbol.symbol = 1;
colorParameters.unlabeledSymbol.visible = 1;
%---
colorParameters.tempSymbol.color = 0;
colorParameters.tempSymbol.symbol = 2;
colorParameters.tempSymbol.visible = 1;
%---
colorParameters.surface.color = 0;
colorParameters.surface.symbol = 3;
colorParameters.surface.visible = 1;
%---
colorParameters.plunging.color = 0;
colorParameters.plunging.symbol = 4;
colorParameters.plunging.visible = 1;
%---
colorParameters.micro.color = 0;
colorParameters.micro.symbol = 5;
colorParameters.micro.visible = 1;
%---
colorParameters.extraSymbol1.color = 0;
colorParameters.extraSymbol1.symbol = 6;
colorParameters.extraSymbol1.visible = 1;
%---
colorParameters.extraSymbol2.color = 0;
colorParameters.extraSymbol2.symbol = 7;
colorParameters.extraSymbol2.visible = 1;
%---
%---
colorParameters.unlabeledColor.color = 1;
colorParameters.unlabeledColor.symbol = 0;
colorParameters.unlabeledColor.visible = 1;
%---
colorParameters.tempColor.color = 2;
colorParameters.tempColor.symbol = 0;
colorParameters.tempColor.visible = 1;
%---
colorParameters.supply.color = 3;
colorParameters.supply.symbol = 0;
colorParameters.supply.visible = 1;
%---
colorParameters.draining.color = 4;
colorParameters.draining.symbol = 0;
colorParameters.draining.visible = 1;
%---
colorParameters.connecting.color = 5;
colorParameters.connecting.symbol = 0;
colorParameters.connecting.visible = 1;
%---
colorParameters.extraColor1.color = 6;
colorParameters.extraColor1.symbol = 0;
colorParameters.extraColor1.visible = 1;
%---
colorParameters.extraColor2.color = 7;
colorParameters.extraColor2.symbol = 0;
colorParameters.extraColor2.visible = 1;
%-----
globalDataStruct.colorParameters = colorParameters;
globalDataStruct.selectionParameters = selectionParameters;
return



function radiusEdit_Callback(hObject, eventdata, handles)
% hObject    handle to radiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of radiusEdit as text
%        str2double(get(hObject,'String')) returns contents of radiusEdit as a double


% --- Executes during object creation, after setting all properties.
function radiusEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to radiusEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in applyRadiusButton.
function applyRadiusButton_Callback(hObject, eventdata, handles)
% hObject    handle to applyRadiusButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;

applyOnlyToZeroRadiusFlag = 0;%Hardcode

doubleCheck = questdlg('Overwrite Radii: Are you sure?','Yes','Cancel');
switch doubleCheck
    case{'Yes'},
        cpMatrix = globalDataStruct.cpMatrix;
        selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
        allRadii = globalDataStruct.allRadii;
        newRadiusValue = str2num(get(handles.radiusEdit,'String'));
        numSelectedPoints = size(selectedCPList,2);
        for pointIter = 1:numSelectedPoints,
            currentPoint = selectedCPList(pointIter);
            overwriteRadiusFlag = 1;
            if applyOnlyToZeroRadiusFlag == 1 && allRadii(currentPoint)~=0,
                overwriteRadiusFlag = 0;
            end%if applyOnlyToZeroRadiusFlag == 1 && allRadii(currentPoint)~=0,
            %---
            if newRadiusValue == 0, %if the newRadius is 0, go ahead and overwrite
                overwriteRadiusFlag = 1;
            end%if newRadiusValue == 0,
            %---
            if overwriteRadiusFlag == 1,
                allRadii(currentPoint) = newRadiusValue;
            end%if overwriteRadiusFlag == 1,
        end%for pointIter = 1:numSelectedPoints,
        %----
        globalDataStruct.cpMatrix = cpMatrix;
        globalDataStruct.allRadii = allRadii;
        RecalculateZeroRadiusList(handles)
        GenerateDisplay(handles);
end%switch doubleCheck

return

% --- Executes on button press in highlightZeroRadiusToggleButton.
function highlightZeroRadiusToggleButton_Callback(hObject, eventdata, handles)
% hObject    handle to highlightZeroRadiusToggleButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of highlightZeroRadiusToggleButton
global globalDataStruct;
displayOption = globalDataStruct.displayOption;
if isfield(globalDataStruct,'displayOptionMemory'),
    displayOptionMemory = globalDataStruct.displayOptionMemory;
else%if isfield
    displayOptionMemory = 1;
end%if-else isfield
highlightZeroRadiusFlag = get(hObject,'Value');
if highlightZeroRadiusFlag == 1,
    displayOptionMemory = displayOption;
    displayOption = 5;%zero radius highlight view
else%if highlightZeroRadiusFlag == 1,
    displayOption = displayOptionMemory;
end%%if-else highlightZeroRadiusFlag == 1,
globalDataStruct.displayOption = displayOption;
globalDataStruct.displayOptionMemory = displayOptionMemory;
GenerateDisplay(handles);


function RecalculateZeroRadiusList(handles)
global globalDataStruct;
allRadii = globalDataStruct.allRadii;
strands = globalDataStruct.strands;
cpMatrix = globalDataStruct.cpMatrix;
numStrands = numel(strands);
majorityRadius = zeros(numStrands,1);
majorityZeroRadiusFlagList = zeros(size(cpMatrix,1),1);
for strandIter = 1:numStrands,
    thisStrand = strands(strandIter);
    stei = thisStrand.StartToEndIndices;
    majRad = median(allRadii(stei));
    %-----
    %noteToSelf - only highlight if >80% are zeros
    testNum = numel(stei);
    testR = sort(allRadii(stei));
    testPoint = ceil(testNum*0.8);
    majRad = testR(testPoint);


    majorityRadius(strandIter) = majRad;
    if majRad==0,
        majorityZeroRadiusFlagList(stei) = 1;
    end
end
globalDataStruct.majorityZeroRadiusFlagList = majorityZeroRadiusFlagList;
return









% --- Executes on selection change in label0Menu.
function label0Menu_Callback(hObject, eventdata, handles)
% hObject    handle to label0Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns label0Menu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from label0Menu


% --- Executes during object creation, after setting all properties.
function label0Menu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to label0Menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function noteEdit_Callback(hObject, eventdata, handles)
% hObject    handle to noteEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of noteEdit as text
%        str2double(get(hObject,'String')) returns contents of noteEdit as a double


% --- Executes during object creation, after setting all properties.
function noteEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to noteEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in attachNoteButton.
function attachNoteButton_Callback(hObject, eventdata, handles)
% hObject    handle to attachNoteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
% % allNotes = globalDataStruct.allNotes;
allNotes = [];
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;
newNoteString = get(handles.noteEdit,'String');
if selectStrandFlag == 1,
    numSelectedPoints = size(selectedCPList,2);
    for pointIter = 1:numSelectedPoints,
        currentPoint = selectedCPList(pointIter);
        currentNote = allNotes{currentPoint};
        if ~isempty(currentNote), currentNote = [currentNote,'\n']; end
        newNote = [currentNote,newNoteString];
        allNotes{currentPoint} = newNote;
    end%for pointIter = 1:numSelectedPoints,
end%if selectStrandFlag == 1,

if selectPoint1Flag,
    currentPoint = selectedPoints12(1);
    currentNote = allNotes{currentPoint};
    if ~isempty(currentNote), currentNote = [currentNote,'\n']; end
    newNote = [currentNote,newNoteString];
    allNotes{currentPoint} = newNote;
end%if selectPoint1Flag,

if selectPoint2Flag,
    currentPoint = selectedPoints12(2);
    currentNote = allNotes{currentPoint};
    if ~isempty(currentNote), currentNote = [currentNote,'\n']; end
    newNote = [currentNote,newNoteString];
    allNotes{currentPoint} = newNote;
end%if selectPoint1Flag,



% % globalDataStruct.allNotes = allNotes;
GrabAffiliatedPoints(handles,globalDataStruct.currentPointer);
return

% --- Executes on button press in deleteLastButton.
function deleteLastButton_Callback(hObject, eventdata, handles)
% hObject    handle to deleteLastButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalDataStruct;
% % allNotes = globalDataStruct.allNotes;
allNotes = [];
selectedCPList = globalDataStruct.selectionParameters.selectedCPList;
selectedPoints12 = globalDataStruct.selectionParameters.selectedPoints12;
selectStrandFlag = globalDataStruct.selectionParameters.selectStrandFlag;
selectPoint1Flag = globalDataStruct.selectionParameters.selectPoint1Flag;
selectPoint2Flag = globalDataStruct.selectionParameters.selectPoint2Flag;

if selectStrandFlag == 1,
    numSelectedPoints = size(selectedCPList,2);
    for pointIter = 1:numSelectedPoints,
        currentPoint = selectedCPList(pointIter);
        currentNote = allNotes{currentPoint};
        newLinePosList = findstr(currentNote,'\n');
        if isempty(newLinePosList),
            newNote = [];
        else%if isempty(newLinePosList),
            newNote = currentNote(1:newLinePosList(end)-1);
        end%if isempty(newLinePosList),
        allNotes{currentPoint} = newNote;
    end%for pointIter = 1:numSelectedPoints,
end%if selectStrandFlag == 1,

if selectPoint1Flag,
    currentPoint = selectedPoints12(1);
    currentNote = allNotes{currentPoint};
    newLinePosList = findstr(currentNote,'\n');
    if isempty(newLinePosList),
        newNote = [];
    else%if isempty(newLinePosList),
        newNote = currentNote(1:newLinePosList(end)-1);
    end%if isempty(newLinePosList),
    allNotes{currentPoint} = newNote;
end%if selectPoint1Flag,

if selectPoint2Flag,
    currentPoint = selectedPoints12(2);
    currentNote = allNotes{currentPoint};
    newLinePosList = findstr(currentNote,'\n');
    if isempty(newLinePosList),
        newNote = [];
    else%if isempty(newLinePosList),
        newNote = currentNote(1:newLinePosList(end)-1);
    end%if isempty(newLinePosList),
    allNotes{currentPoint} = newNote;
end%if selectPoint1Flag,



% globalDataStruct.allNotes = allNotes;
GrabAffiliatedPoints(handles,globalDataStruct.currentPointer);
return



% --- Executes on button press in hideIsolatedStrandsButton.
function hideIsolatedStrandsButton_Callback(hObject, eventdata, handles)
% hObject    handle to hideIsolatedStrandsButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of hideIsolatedStrandsButton
global globalDataStruct
globalDataStruct.hideIslandsFlag = get(hObject,'Value');


%%
% % % function vectorProject = ConvertToCellStorage(vectorProject)
% % % StrandIndices = full(vectorProject.vectorizedStructure.Vertices.StrandIndices);
% % % numPoints = size(StrandIndices,1);
% % % cellStrandIndices = {};
% % % cellStrandIndices{numPoints} = [];
% % % NotePointerList = vectorProject.vectorizedStructure.Vertices.NotePointers;
% % % NoteList = vectorProject.vectorizedStructure.Vertices.NoteList;
% % % tic
% % % for pointIter = 1:numPoints,
% % %     currentStrandIndices = StrandIndices(pointIter,:);
% % %     nonZeroStrandIndices = currentStrandIndices(currentStrandIndices~=0);
% % %     cellStrandIndices{pointIter} = nonZeroStrandIndices;
% % %     %---
% % % % % %     if NotePointerList(pointIter)==0,
% % % % % %         AllNotes{pointIter} = '';
% % % % % %     else%if NotePointerList(pointIter)==0,
% % % % % %         AllNotes{pointIter} = NoteList{NotePointerList(pointIter)};
% % % % % %     end%if-else NotePointerList(pointIter)==0,
% % % end%for pointIter = 1:numPoints,
% % % AllNotes{numPoints} = '';
% % % toc
% % %
% % %
% % % vectorProject.vectorizedStructure.Vertices.StrandIndices = cellStrandIndices;
% % % vectorProject.vectorizedStructure.Vertices.AllNotes = AllNotes;
% % %

