function FV_GetStrandInfo

global gds
centerOnClickFlag = gds.centerOnClickFlag;
strandData = get(gco,'UserData');
strandID = strandData.strandID;
medianLabel = strandData.medianLabel;
medianRadius = strandData.medianRadius;
medianVoltage = strandData.medianVoltage;
voltageDrop = strandData.voltageDrop;
strandLength = strandData.strandLength;
current = strandData.current;

myColor = get(gco,'MarkerEdgeColor');
set(gco,'MarkerEdgeColor',double(myColor)*0.75);


mytext = ['StrandID: ',num2str(strandID),' ,  '];
mytext = [mytext, 'label: ',num2str(medianLabel),' ,  '];
mytext = [mytext, 'length: ',num2str(strandLength),' ,  '];
mytext = [mytext, 'Rmed: ',num2str(medianRadius,'%0.3f'),' ,  '];
mytext = [mytext, 'Vmed: ',num2str(medianVoltage,'%0.3f'),' ,  '];
mytext = [mytext, 'dV: ',num2str(voltageDrop,'%0.3f'),' ,  '];
mytext = [mytext, 'I: ',num2str(current,'%0.3e')];

title(mytext);



if centerOnClickFlag == 1,
    XData = get(gco,'XData');
    YData = get(gco,'YData');
    ZData = get(gco,'ZData');
    gds.viewCenter = [median(XData),median(YData),-1*median(ZData)];
    camtarget([median(XData),median(YData),median(ZData)]);
end

return