function outputParameters = VidaGenerateStraightLineMasks(inputParameters)
vectorizedStructure = inputParameters.vectorizedStructure;
    Vertices = vectorizedStructure.Vertices;
    Strands = vectorizedStructure.Strands;
    maskSize = vectorizedStructure.maskSize;

%-----
%MAKE STRAING LINE MASKS FOR VISUALIZATION
disp(['Generating Straight Line Mask tiffs : ',datestr(now)]);tic
allVertCoords = Vertices.AllVerts;
numVertices = size(Vertices.AllVerts,1);
junctionFlags = Vertices.JunctionPoints;
allJunctionCoords = allVertCoords(junctionFlags>0,:);
numJunctions = sum(junctionFlags);
freeEndPointFlags = Vertices.FreeEndPoints;
numEndPoints = sum(freeEndPointFlags);
allEndPointCoords = allVertCoords(freeEndPointFlags>0,:);

circle5 = circle3d(5);
%-----
newMask = false(maskSize);
for k = 1:numJunctions,
    cc = allJunctionCoords(k,:);%current coords
    if cc(1)>3 && cc(1)<maskSize(1)-2,
        if cc(2)>3 && cc(2)<maskSize(2)-2,
            if cc(3)>3 && cc(3)<maskSize(3)-2,
                newMask(cc(1)-2:cc(1)+2,cc(2)-2:cc(2)+2,cc(3)-2:cc(3)+2) = circle5;
            end%if cc(3)...
        end%if cc(2)...
    end%if cc(1)...
end%for k..
maketiff(newMask,'junctionBalls.tif');
%-----
newMask = false(maskSize);
for k = 1:numEndPoints,
    cc = allEndPointCoords(k,:);%current coords
    if cc(1)>3 && cc(1)<maskSize(1)-2,
        if cc(2)>3 && cc(2)<maskSize(2)-2,
            if cc(3)>3 && cc(3)<maskSize(3)-2,
                newMask(cc(1)-2:cc(1)+2,cc(2)-2:cc(2)+2,cc(3)-2:cc(3)+2) = circle5;
            end%if cc(3)...
        end%if cc(2)...
    end%if cc(1)...
end
maketiff(newMask,'endPointBalls.tif');
%-----
newMask = false(maskSize);
for k = 1:numVertices,
    newMask(allVertCoords(k,1),allVertCoords(k,2),allVertCoords(k,3)) = 1;
end
maketiff(newMask>0,'centerlineMask.tif');



%---
toc
%----
outputParameters = inputParameters;





