function outputParameters = VidaNodeSegListToVertexStrand2(inputParameters)
nodeSegStructure = inputParameters.nodeSegStructure;
    cpList = nodeSegStructure.cpList;
    radiusList = nodeSegStructure.radiusList;
    labelList = nodeSegStructure.labelList;
    confidenceList = nodeSegStructure.confidenceList;
% %     noteList = nodeSegStructure.noteList;
    segmentList = nodeSegStructure.segmentList;
    nodeList = nodeSegStructure.nodeList;
    maskSize = nodeSegStructure.maskSize;
%-----
%CONVERT TO AGREED NOTATION OF VERTICES AND STRANDS
disp(['Converting to Strand/Vertex Storage Structure : ',datestr(now)]);tic
numCenterLinePoints = size(cpList,1);
numSegments = size(segmentList,2);
endPointList = find(cpList(:,2)==1);
nodePointList = find(cpList(:,2)>2);

[cp1,cp2,cp3] = ind2sub(maskSize,cpList(:,1));
% % Vertices.AllVerts = int16([cp1,cp2,cp3]);
% % Vertices.AllRadii = single(radiusList);
% % Vertices.AllLabels = int16(labelList);
% % Vertices.AllConfidences = single(confidenceList);
% % Vertices.AllNotes = noteList;

Vertices.AllVerts = double([cp1,cp2,cp3]);
Vertices.AllRadii = double(radiusList);
Vertices.AllLabels = double(labelList);
Vertices.AllConfidences = double(confidenceList);


%---
Vertices.AllStrandEndPoints = false(numCenterLinePoints,1);
disp('');
tic
numChar = 0;
strands = struct('field1',zeros(1,5),'field2',zeros(1,7));
% % tempStrand = struct('StartVertexIndex',zeros(1),'EndVertexIndex',zeros(1),...
% %     'InteriorVertices',zeros(1,100),'StartToEndIndices',zeros(1,100),...
% %     'StartVertexNeighborStrands',zeros(1,100),'EndVertexNeighborStrands',zeros(1,100),...
% %     'Active',zeros(1));
tempStrand = struct('StartVertexIndex',zeros(1),'EndVertexIndex',zeros(1),...
    'StartToEndIndices',zeros(1,100),...
    'StartVertexNeighborStrands',zeros(1,100),'EndVertexNeighborStrands',zeros(1,100),...
    'Active',zeros(1));



Strands = repmat(tempStrand,[1,numSegments]);
for segmentIter = 1:numSegments,
% %     if mod(segmentIter,100)==0,
% %         fprintf(repmat('\b',[1,numChar]));
% %         numChar = fprintf(['Converting segment ',num2str(segmentIter),' of ',num2str(numSegments)]);
% %     end
    currentSegment = segmentList{segmentIter};
    firstPoint = currentSegment(1);
    lastPoint = currentSegment(end);
    Vertices.AllStrandEndPoints(firstPoint) = 1;
    Vertices.AllStrandEndPoints(lastPoint) = 1;
    %---
%     tic
    tempStrand.StartVertexIndex = firstPoint;
    tempStrand.EndVertexIndex = lastPoint;
    tempStrand.StartToEndIndices = currentSegment;
    
% %     tempStrand.InteriorVertices = [currentSegment(2:end-1)];

%     if mod(segmentIter,100)==0,toc;end
    %---
    startVertexID = cpList(firstPoint,3);
    if startVertexID > 0,
        tempStrand.StartVertexNeighborStrands = [];
    else%if startVertexID > 0,
        tempStrand.StartVertexNeighborStrands = nodeList{-1*startVertexID};
    end%if-else startVertexID > 0,
    %---
    endVertexID = cpList(lastPoint,3);
    if endVertexID > 0,
        tempStrand.EndVertexNeighborStrands = [];
    else%if endVertexID > 0,
        tempStrand.EndVertexNeighborStrands = nodeList{-1*endVertexID};
    end%if-else endVertexID > 0,
    %---
    tempStrand.Active = 1;
    Strands(segmentIter) = tempStrand;
end%for segmentIter = 1:numSegments,

%---
Vertices.JunctionPoints = false(numCenterLinePoints,1);
Vertices.JunctionPoints(nodePointList) = 1;
%---
Vertices.FreeEndPoints = false(numCenterLinePoints,1);
Vertices.FreeEndPoints(endPointList) = 1;
% % StrandIndices = cell(numCenterLinePoints,1);
StrandIndices = zeros(numCenterLinePoints,26);
%---
numChar = 0;
for cpIter = 1:numCenterLinePoints,
    if mod(cpIter,10000)==0,
        fprintf(repmat('\b',[1,numChar]));
        numChar = fprintf(['Converting segment ',num2str(cpIter),' of ',num2str(numCenterLinePoints)]);
    end
    currentPointID = cpList(cpIter,3);
    if currentPointID>0,
% %         StrandIndices{cpIter} = currentPointID;
        StrandIndices(cpIter,1) = currentPointID;
    else%if currentPointID>0,
        nodeID = -1 * currentPointID;
% %         StrandIndices{cpIter} = nodeList{nodeID};
        StrandIndices(cpIter,1:numel(nodeList{nodeID}))= nodeList{nodeID};
    end%if-else currentPointID>0,
end%for cpIter = 1:numCenterLinePoints,
Vertices.StrandIndices = sparse(StrandIndices);
%-----
fprintf('   Completed. ');toc
%-----
vectorizedStructure.maskSize = maskSize;
vectorizedStructure.Vertices = Vertices;
vectorizedStructure.Strands = Strands;
%---
outputParameters = inputParameters;
outputParameters.vectorizedStructure = vectorizedStructure;

