function outputParameters = VidaReattachStrand(inputParameters)


coord1 = inputParameters.coord1;
coord2 = inputParameters.coord2;
nearbyCoordList = inputParameters.nearbyCoordList;
%-----
%remove coord1 and coord2 from the nearbyCoordList
numNearby = size(nearbyCoordList,1);
f1 = find(sum(abs(repmat(coord1,[numNearby,1])-nearbyCoordList),2)==0);
if ~isempty(f1),
    nearbyCoordList = [nearbyCoordList(1:f1-1,:) ; nearbyCoordList(f1+1:end,:)];
end%if ~isempty(f1)
numNearby = size(nearbyCoordList,1);
f2 = find(sum(abs(repmat(coord2,[numNearby,1])-nearbyCoordList),2)==0);
if ~isempty(f2),
    nearbyCoordList = [nearbyCoordList(1:f2-1,:) ; nearbyCoordList(f2+1:end,:)];
end%if ~isempty(f1)
%-----
numNearby = size(nearbyCoordList,1);
startCoord = coord1;
stopCoord = coord2;
currentCoord = startCoord;

[c1,c2,c3] = ind2sub([3,3,3],[1:27]');
cubeCoords = [c1-2,c2-2,c3-2];
addedCoords = [];
keepGoingFlag = 1;

%circumvent error when no nearby points are found.
if size(nearbyCoordList,1) == 0,
    nearbyCoordList = startCoord + 100;
    numNearby = size(nearbyCoordList,1);
end


while keepGoingFlag == 1,
    deltaCoord = stopCoord - currentCoord;
    currentDistance = sqrt(sum(deltaCoord.^2,2));
    normalizedDelta = deltaCoord./max(abs(deltaCoord));
    directionDiff = repmat(normalizedDelta,[27,1])-cubeCoords;
    directionScore = sum(directionDiff.^2,2);
    [sortedScore,sortedDirection] = sort(directionScore);
    %---
    for directionIter = 1:6,
        trialDirection = sortedDirection(directionIter);
        directionOffsets = cubeCoords(trialDirection,:);
        trialCoord = currentCoord + directionOffsets;
        neighborCoords = repmat(trialCoord,[27,1])+cubeCoords;
        neighborScore = [];
        redLightFlag = 1;
        for neighborIter = 1:27
            nearbyOffsets = nearbyCoordList-repmat(neighborCoords(neighborIter,:),[numNearby,1]);
            neighborMatchList = sum(abs(nearbyOffsets),2);
            
            
            
            try
            neighborScore(neighborIter) = min(neighborMatchList);
            catch
                keyboard
            end
            
            
            
            
        end
        neighborhoodOccupancy = sum(neighborScore==0);
        %we have blanked out the starting point and the end point.
        %we also do not add new points to the "nearby" list.
        %therefore a "good" point should have neighborOccupancy=0.
        %a bad neighbor (>0 occupancy) will create a new node. (bad!) so choose another direction.
        if neighborhoodOccupancy==0, redLightFlag = 0; break; end
    end%for directionIter = 1:6
    %---
    trialDistance = sqrt(sum((stopCoord-trialCoord).^2,2));
    if (trialDistance < currentDistance) && (redLightFlag == 0),
        addedCoords = [addedCoords ; trialCoord];
    else%if (trialDistance < currentDistance) && (redlightFlag == 0),
        %default to the best direction pixel
        trialDirection = sortedDirection(1);
        directionOffsets = cubeCoords(trialDirection,:);
        trialCoord = currentCoord + directionOffsets;
        addedCoords = [addedCoords ; trialCoord];
    end%if-else trialDistance < currentDistance,
    %---
    remainingDisconnect = sqrt(sum((trialCoord - stopCoord).^2,2));
    currentCoord = trialCoord;
    if remainingDisconnect < 1.8,
        keepGoingFlag = 0;
    end%if remainingDisconnect < 1.8,
    %---
end%while keepGoingFlag == 1,


    

outputParameters = inputParameters;
outputParameters.addedCoords = addedCoords;



