function outputParameters = VidaTrimLShapedSegments(inputParameters)
nodeSegStructure = inputParameters.nodeSegStructure;
    cpList = nodeSegStructure.cpList;
    radiusList = nodeSegStructure.radiusList;
    labelList = nodeSegStructure.labelList;
    confidenceList = nodeSegStructure.confidenceList;
% %     noteList = nodeSegStructure.noteList;
    segmentList = nodeSegStructure.segmentList;
    nodeList = nodeSegStructure.nodeList;
    maskSize = nodeSegStructure.maskSize;
%-----  
disp('Correcting 3-long L-shaped segments'); pause(0.1);
numSegments = numel(segmentList);
for segIter = 1:numSegments,
    segmentLength(segIter) = numel(segmentList{segIter});
end

threeSegIDList = find(segmentLength==3);
numThreeSeg = numel(threeSegIDList);

charCount = 0;
pixelKeepFlagList = true(size(radiusList));
for segIter = 1:numThreeSeg,
    fprintf(repmat('\b',[1,charCount]));
    segmentsLeft = numThreeSeg-segIter;
    charCount = fprintf(['Segments remaining: ',num2str(segmentsLeft)]);
    pause(0.001);
 
    thisSegID = threeSegIDList(segIter);
    pointList = segmentList{thisSegID};
    point1 = pointList(1);
    point2 = pointList(2);
    point3 = pointList(3);
    [x1,x2,x3] = ind2sub(maskSize,cpList(point1,1));
    [w1,w2,w3] = ind2sub(maskSize,cpList(point3,1));
    d = abs([x1-w1,x2-w2,x3-w3]);
    if max(d)<2,
        %remove this middle pixel
        pixelKeepFlagList(point2) = 0;
    end
end

centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.labelList = labelList(pixelKeepFlagList);
centerlineRadiusStructure.confidenceList = confidenceList(pixelKeepFlagList);
% % centerlineRadiusStructure.noteList = noteList(pixelKeepFlagList);
centerlineRadiusStructure.pixelList = cpList(pixelKeepFlagList,1);
centerlineRadiusStructure.radiusList = radiusList(pixelKeepFlagList);

inputParameters.centerlineRadiusStructure = centerlineRadiusStructure;
inputParameters.LShapesRemoved = sum(~pixelKeepFlagList);
outputParameters = inputParameters;
    
    