function outputParameters=VidaSegmentationGrid(inputParameters)
%previously called MarchGrid1(EXPERIMENT) and MarchGrid3(EXPERIMENT)
%last modified 08/29/07 by Phil Tsai

%-----
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
subBlockFilesFolder = inputParameters.subBlockFilesFolder;
maskSize = inputParameters.maskSize;
sz3D=inputParameters.sz3D;
overlapsz=inputParameters.overlapsz;
stackedFileName = inputParameters.stackedFileName;
blockVariableName = inputParameters.blockVariableName;
dispon = inputParameters.dispon;
%---
% overlap size dictates how much of each block has to overlap with its 3Dneighbor
if size(sz3D,2)==1,
   nx1blks=ceil(maskSize(1)/sz3D); % number of blocks in x1 dim
   nx2blks=ceil(maskSize(2)/sz3D); % number of blocks in x2 dim
   x1sz=fix(((nx1blks-1)*overlapsz+maskSize(1))/nx1blks)+1;
   x2sz=fix(((nx2blks-1)*overlapsz+maskSize(2))/nx2blks)+1;
   x1x2geomean=sqrt(x1sz*x2sz);
   nx3blks=max(1,ceil((maskSize(3)-overlapsz)/(x1x2geomean-overlapsz))); %number of blocks in x3 diim

   disp('     geometric mean sub-blocking turned off');
   disp('     VidaSegmentationGrid - line 26');
   nx3blks=ceil(maskSize(3)/sz3D); % number of blocks in x2 dim
   
   
else%if size(sz3D,2)==1,
   nx1blks=ceil(maskSize(1)/sz3D(1)); % number of blocks in x1 dim
   nx2blks=ceil(maskSize(2)/sz3D(2)); % number of blocks in x2 dim
   nx3blks=ceil(maskSize(3)/sz3D(3)); % number of blocks in x3 dim;
end%if size(sz3D,2)==1,

[blockGrid]=VidaGridUpBlock(maskSize,overlapsz,nx1blks,nx2blks,nx3blks);

numBlocks = size(blockGrid,2);
if numBlocks > 1,

    % load and write each block in blockGrid for tiff iSec
    disp(['Loading file : ',stackedFileName]);
    pause(0.01)
    loadedStruct = load(stackedFileName);
    loadedVariables = fieldnames(loadedStruct);
    imageStack = loadedStruct.(loadedVariables{1});
    if isstruct(imageStack),
        tempPixelList = imageStack.pixelList;
        tempMaskSize = imageStack.maskSize;
        imageStack = false(tempMaskSize);
        imageStack(tempPixelList) = 1;
        clear tempPixelList tempMaskSize
    end%if isstruct(blockData),
    %-----
    channelSubFactor = zeros(1,length(blockGrid));
    disp(['Writing ',blockVariableName,'s to folder ',subBlockFilesFolder]);
    pause(0.01);
    blockFileNameList = cell(1,numBlocks);

    
    for iBlk=1:length(blockGrid) %---added by Phil 03/02/07
        blockFileNameList{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
        %-----
        overwriteFlag = 0;
        fileExistsFlag = 0;
        if exist(blockFileNameList{iBlk},'file'),
            fileExistsFlag = 1;
            fileProps = dir(blockFileNameList{iBlk});
            fileDateNum = datenum(fileProps.date);
            if fileDateNum < lastRerunStartDateNum,
                overwriteFlag = 1;
            end%if fileDateNum < lastRerunStartDateNum,
        end%if exist(blockFileNameList{iBlk},'file'),
        %---


        if and(fileExistsFlag==1,overwriteFlag==0),
            disp(['skipping block ',num2str(iBlk),' - previously completed...']);
            pause(0.01)
            blockFileNameList{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
        else%if and(fileExistsFlag==1,overwriteFlag==0),
            disp(['block ',num2str(iBlk),' of ',num2str(length(blockGrid)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
            pause(0.01)
            % get indices for each block...
            blkii=blockGrid{iBlk};
            blockFileNameList{iBlk}=fullfile(subBlockFilesFolder,[blockVariableName,'-',num2str(iBlk),'.mat']);
            % subBlock=block from image tif
            subBlock = imageStack(blkii.x1min:blkii.x1max,blkii.x2min:blkii.x2max,blkii.x3min:blkii.x3max);
            % vascblk=rescaleuint8(single(vascblk));
            % write each partially processed vasc block
            if dispon
                for i=1:size(subBlock,3)
                    figure(1);
                    colormap gray;
                    subBlock(1,1,i)=0;
                    subBlock(1,2,i)=vascThresh;
                    imagesc(subBlock(:,:,i));drawnow;%pause(.05);
                end%for i=1:size(subBlock,3)
            end%if dispon
    %         disp(['writing ',blockFileNameList{iBlk},'...']);
            commandString = [blockVariableName,' = uint16(subBlock);'];
            eval(commandString);
            saveSize = (getfield(whos(blockVariableName),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            commandString = ['save(blockFileNameList{iBlk},''',blockVariableName,''',scs);'];
            eval(commandString);
        end%if and(fileExistsFlag==1,overwriteFlag==0),
    end%for iBlk=1:length(blockGrid)
else%if numBlocks>1
    blockFileNameList = {stackedFileName};
end%if numBlocks>1
%-----
outputParameters = inputParameters;
outputParameters.blockFileNameList=blockFileNameList;
outputParameters.blockGrid = blockGrid;
%-----
return


