function outExp = VidaSubBlockReg(inExp)
%last modified 05/08/08 by Phil Tsai

%-----
fileRootName = inExp.globalParameters.fileRootName;
rootDataFolder = inExp.globalParameters.rootDataFolder;
lastRerunStartDateNum = inExp.globalParameters.lastRerunStartDateNum;
processedDataFolder = inExp.globalParameters.processedDataFolder;
intermediateResultsFolder = inExp.globalParameters.intermediateResultsFolder;
numChannels = 1;
stackedFileNameList = inExp.globalParameters.stackedFileNameList;
blockVariableNames = {'registeredVascBlock','registeredVascRawMaskBlock','registeredVascEnhancedMaskBlock'};
voxelSizeInMicrons = inExp.globalParameters.voxelSizeInMicrons;
fullStackSize = inExp.globalParameters.fullStackSize;
%-----
subVolumeSize3DInMicrons = inExp.subBlockParameters.subVolumeSize3DInMicrons;              
subVolumeOverlapSizeInMicrons = inExp.subBlockParameters.subVolumeOverlapSizeInMicrons;    
%-----
%-----
subBlockFilesFolder = fullfile(processedDataFolder,'subBlockFiles');
[mkdirSuccess,mkdirMessage,mkdirId] = mkdir(subBlockFilesFolder);
%-----
displayFlag = 0;
%-----
subVolumeSize3D = round(subVolumeSize3DInMicrons ./ voxelSizeInMicrons);
subVolumeOverlapSize = round(subVolumeOverlapSizeInMicrons ./ voxelSizeInMicrons);
%-----
%DEFINE CHANNEL NAMES
[tempPath,tempFileName,tempExt] = fileparts(stackedFileNameList{1});
dashPos = findstr(tempFileName,'-');
lastDash = dashPos(end);
% channels.regChannelString = tempFileName(lastDash+1:end);


%-----
% Extract subblocks from .tifs, order, and store pointers to .mat files for vasc data
disp(['Starting Reg Grid Subblocking : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
gridParameters.lastRerunStartDateNum = lastRerunStartDateNum;
gridParameters.subBlockFilesFolder = subBlockFilesFolder;
gridParameters.stackedFileName = stackedFileNameList{1};
gridParameters.blockVariableName = blockVariableNames{1};
gridParameters.maskSize = fullStackSize;
gridParameters.sz3D=subVolumeSize3D;
gridParameters.overlapsz = subVolumeOverlapSize;
gridParameters.dispon = displayFlag;
%-----
    gridParameters = VidaSegmentationGrid(gridParameters);      
%-----
vascRawDataBlockGrid = gridParameters.blockGrid;
vascBlockFileNameList = gridParameters.blockFileNameList;

%---------
gridParameters.stackedFileName = stackedFileNameList{2};
gridParameters.blockVariableName = blockVariableNames{2};
gridParameters.maskSize = fullStackSize;
gridParameters.sz3D=subVolumeSize3D;
gridParameters.overlapsz = subVolumeOverlapSize;
gridParameters.dispon = displayFlag;
%-----
    gridParameters = VidaSegmentationGrid(gridParameters);      
%-----
vascRawMaskBlockGrid = gridParameters.blockGrid;
vascBlockRawMaskFileNameList = gridParameters.blockFileNameList;

%---------
%---------
gridParameters.stackedFileName = stackedFileNameList{3};
gridParameters.blockVariableName = blockVariableNames{3};
gridParameters.maskSize = fullStackSize;
gridParameters.sz3D=subVolumeSize3D;
gridParameters.overlapsz = subVolumeOverlapSize;
gridParameters.dispon = displayFlag;
%-----
    gridParameters = VidaSegmentationGrid(gridParameters);      
%-----
vascEnhMaskBlockGrid = gridParameters.blockGrid;
vascBlockEnhancedMaskFileNameList = gridParameters.blockFileNameList;
%---------

outExp = inExp;
% outExp.globalParameters.channels = channels;
%---
outExp.globalParameters.blockGrid = vascEnhMaskBlockGrid;
outExp.globalParameters.subVolumeOverlapSize = subVolumeOverlapSize;
outExp.globalParameters.vascBlockEnhancedMaskFileNameList = vascBlockEnhancedMaskFileNameList;
outExp.globalParameters.vascBlockRawMaskFileNameList = vascBlockEnhancedMaskFileNameList;
outExp.globalParameters.vascBlockFileNameList = vascBlockFileNameList;
outExp.completionDates.subBlockCompletionDate = datestr(now);
%---
%---
return


