function outputParameters=VidaBinaryVascRestitch(inputParameters)

fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascStackFileName = inputParameters.vascStackFileName;
fileSuffix = inputParameters.fileSuffix;
vascBlockMaskFileNameList = inputParameters.vascBlockMaskFileNameList;
fullStackSize = inputParameters.fullStackSize;
blockGrid = inputParameters.blockGrid;
overlapsz = inputParameters.overlapsz;
%------
numPixelsMarginBlank = 0;%noteToSelf
%------
[pname,bname,ext]=fileparts(vascStackFileName);
vascMaskFileName=fullfile(pname,[fileRootName,'-',fileSuffix,'.mat']);
storageVariableName = fileSuffix;
storageVariableName(1) = lower(storageVariableName(1));
%-----
[tempPath,tempName] = fileparts(vascStackFileName);
disp(['Restitching mask for ',tempName]);
vascMask = false(fullStackSize);
subVolumeOverlapSize = overlapsz;
overlapOffset = ceil(subVolumeOverlapSize/2);

minX1 = Inf; minX2 = Inf; minX3 = Inf;
maxX1 = 0; maxX2 = 0; maxX3 = 0;
for gridIter = 1:length(blockGrid);
    blockIterLims=blockGrid{gridIter};
    minX1 = min(minX1,blockIterLims.x1min);
    minX2 = min(minX2,blockIterLims.x2min);
    minX3 = min(minX3,blockIterLims.x3min);
    maxX1 = max(maxX1,blockIterLims.x1max);
    maxX2 = max(maxX2,blockIterLims.x2max);
    maxX3 = max(maxX3,blockIterLims.x3max);
end


for blockIter=1:length(blockGrid)
    blockIterLims=blockGrid{blockIter};
    %-----
    tempLoadVar = load(vascBlockMaskFileNameList{blockIter});
    tempFieldNames = fieldnames(tempLoadVar);
    vascBlockMask = tempLoadVar.(tempFieldNames{1});
    clear tempLoadVar tempFieldNames;
    if isstruct(vascBlockMask),
        tempPixelList = vascBlockMask.pixelList;
        tempMaskSize = vascBlockMask.maskSize;
        vascBlockMask = false(tempMaskSize);
        vascBlockMask(tempPixelList) = 1;
        clear tempPixelList tempMaskSize
    end%if isstruct(vascBlockMask),
    %---
    x1a = blockIterLims.x1min;
    x2a = blockIterLims.x2min;
    x3a = blockIterLims.x3min;
    x1b = blockIterLims.x1max;
    x2b = blockIterLims.x2max;
    x3b = blockIterLims.x3max;
    dW1a = 0; dW2a = 0; dW3a = 0;
    dW1b = 0; dW2b = 0; dW3b = 0;
    if x1a > minX1, x1a=x1a + overlapOffset; dW1a = overlapOffset; end
    if x2a > minX2, x2a=x2a + overlapOffset; dW2a = overlapOffset; end
    if x3a > minX3, x3a=x3a + overlapOffset; dW3a = overlapOffset; end
    if x1b < maxX1, x1b=x1b - overlapOffset; dW1b = overlapOffset; end
    if x2b < maxX2, x2b=x2b - overlapOffset; dW2b = overlapOffset; end
    if x3b < maxX3, x3b=x3b - overlapOffset; dW3b = overlapOffset; end

    x1r=[x1a:x1b];
    x2r=[x2a:x2b];
    x3r=[x3a:x3b];
    vascBlockMask = vascBlockMask(1+dW1a:end-dW1b,1+dW2a:end-dW2b,1+dW3a:end-dW3b);
    vascMask(x1r,x2r,x3r)=max(vascMask(x1r,x2r,x3r),vascBlockMask);
end%for blockIter...
%-----
pixelList = find(vascMask);
maskSize = size(vascMask);
vascMask = [];
vascMask.pixelList = pixelList;
vascMask.maskSize = maskSize;
%-----
myCommand = [storageVariableName,' = vascMask;'];
eval(myCommand)
saveSize = (getfield(whos('storageVariableName'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vascMaskFileName,storageVariableName,scs);

%-----
outputParameters = inputParameters;
outputParameters.vascMaskFileName = vascMaskFileName; 





