function outputParameters=VidaBinaryVascRestitchByIntersect(inputParameters)

fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascStackFileName = inputParameters.vascStackFileName;
fileSuffix = inputParameters.fileSuffix;
vascBlockMaskFileNameList = inputParameters.vascBlockMaskFileNameList;
fullStackSize = inputParameters.fullStackSize;
blockGrid = inputParameters.blockGrid;
overlapsz = inputParameters.overlapsz;
%------
numPixelsMarginBlank = 0;%noteToSelf
%------
[pname,bname,ext]=fileparts(vascStackFileName);
vascMaskFileName=fullfile(pname,[fileRootName,'-',fileSuffix,'.mat']);
storageVariableName = fileSuffix;
storageVariableName(1) = lower(storageVariableName(1));
%-----
[tempPath,tempName] = fileparts(vascStackFileName);
disp(['Restitching mask for ',tempName]);
vascMask = true(fullStackSize);
subVolumeOverlapSize = overlapsz;
overlapOffset = ceil(subVolumeOverlapSize/2);

minX1 = Inf; minX2 = Inf; minX3 = Inf;
maxX1 = 0; maxX2 = 0; maxX3 = 0;
for gridIter = 1:length(blockGrid);
    blockIterLims=blockGrid{gridIter};
    minX1 = min(minX1,blockIterLims.x1min);
    minX2 = min(minX2,blockIterLims.x2min);
    minX3 = min(minX3,blockIterLims.x3min);
    maxX1 = max(maxX1,blockIterLims.x1max);
    maxX2 = max(maxX2,blockIterLims.x2max);
    maxX3 = max(maxX3,blockIterLims.x3max);
end


for blockIter=1:length(blockGrid)
    blockIterLims=blockGrid{blockIter};
    %-----
    tempLoadVar = load(vascBlockMaskFileNameList{blockIter});
    tempFieldNames = fieldnames(tempLoadVar);
    vascBlockMask = tempLoadVar.(tempFieldNames{1});
    clear tempLoadVar tempFieldNames;
    if isstruct(vascBlockMask),
        tempPixelList = vascBlockMask.pixelList;
        tempMaskSize = vascBlockMask.maskSize;
        vascBlockMask = false(tempMaskSize);
        vascBlockMask(tempPixelList) = 1;
        clear tempPixelList tempMaskSize
    end%if isstruct(vascBlockMask),
    %---
    x1a = blockIterLims.x1min;
    x2a = blockIterLims.x2min;
    x3a = blockIterLims.x3min;
    x1b = blockIterLims.x1max;
    x2b = blockIterLims.x2max;
    x3b = blockIterLims.x3max;

    tempVascMask = true(size(vascMask));
    tempVascMask(x1a:x1b,x2a:x2b,x3a:x3b) = vascBlockMask;
    vascMask = and(tempVascMask,vascMask);
end%for blockIter...
%-----
pixelList = find(vascMask);
maskSize = size(vascMask);
vascMask = [];
vascMask.pixelList = pixelList;
vascMask.maskSize = maskSize;
%-----
myCommand = [storageVariableName,' = vascMask;'];
eval(myCommand)
saveSize = (getfield(whos('storageVariableName'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(vascMaskFileName,storageVariableName,scs);



%-----
outputParameters = inputParameters;
outputParameters.vascMaskFileName = vascMaskFileName; 





