function outputParameters=VidaEnhancedVascRestitch(inputParameters)

fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascFileName = inputParameters.vascFileName;
fileSuffix = inputParameters.fileSuffix;
vascBlockGrayscaleFileNameList = inputParameters.vascBlockGrayscaleFileNameList;
fullStackSize = inputParameters.fullStackSize;
blockGrid = inputParameters.blockGrid;
overlapsz = inputParameters.overlapsz;
%------
[pname,bname,ext]=fileparts(vascFileName);
outputStackFileName=fullfile(pname,[fileRootName,fileSuffix,'.mat']);
%-----
numPixelsMarginBlank = 0;%noteToSelf
%-----
[tempPath,tempName] = fileparts(outputStackFileName);
disp(['Restitching mask for ',tempName]);
% These next two lines can be replaced with vsize=EXPERIMENT.SectionSizes
vascEnhancedGrayscale = zeros(fullStackSize,'single');
subVolumeOverlapSize = overlapsz;
overlapOffset = ceil(subVolumeOverlapSize/2);

minX1 = Inf; minX2 = Inf; minX3 = Inf;
maxX1 = 0; maxX2 = 0; maxX3 = 0;
for gridIter = 1:length(blockGrid);
    blockIterLims=blockGrid{gridIter};
    minX1 = min(minX1,blockIterLims.x1min);
    minX2 = min(minX2,blockIterLims.x2min);
    minX3 = min(minX3,blockIterLims.x3min);
    maxX1 = max(maxX1,blockIterLims.x1max);
    maxX2 = max(maxX2,blockIterLims.x2max);
    maxX3 = max(maxX3,blockIterLims.x3max);
end



for blockIter=1:length(blockGrid)
    blockIterLims=blockGrid{blockIter};
    load(vascBlockGrayscaleFileNameList{blockIter},'vascBlockEnhancedGrayscale','-mat');
    x1a = blockIterLims.x1min;
    x2a = blockIterLims.x2min;
    x3a = blockIterLims.x3min;
    x1b = blockIterLims.x1max;
    x2b = blockIterLims.x2max;
    x3b = blockIterLims.x3max;
    dW1a = 0; dW2a = 0; dW3a = 0;
    dW1b = 0; dW2b = 0; dW3b = 0;
    if x1a > minX1, x1a=x1a + overlapOffset; dW1a = overlapOffset; end
    if x2a > minX2, x2a=x2a + overlapOffset; dW2a = overlapOffset; end
    if x3a > minX3, x3a=x3a + overlapOffset; dW3a = overlapOffset; end
    if x1b < maxX1, x1b=x1b - overlapOffset; dW1b = overlapOffset; end
    if x2b < maxX2, x2b=x2b - overlapOffset; dW2b = overlapOffset; end
    if x3b < maxX3, x3b=x3b - overlapOffset; dW3b = overlapOffset; end

    x1r=[x1a:x1b];
    x2r=[x2a:x2b];
    x3r=[x3a:x3b];
    vascBlockEnhancedGrayscale = vascBlockEnhancedGrayscale(1+dW1a:end-dW1b,1+dW2a:end-dW2b,1+dW3a:end-dW3b);
    vascEnhancedGrayscale(x1r,x2r,x3r)=max(vascEnhancedGrayscale(x1r,x2r,x3r),vascBlockEnhancedGrayscale);
end
disp(['Writing mask to ',outputStackFileName]);
saveSize = (getfield(whos('vascEnhancedGrayscale'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
save(outputStackFileName,'vascEnhancedGrayscale',scs);



outputParameters = inputParameters;
outputParameters.outputStackFileName = outputStackFileName;




