function outputParameters=VidaVascBinarizeEnhancedVolume(inputParameters)


%-----      
fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
%---
numBkgStdForMinThresh = inputParameters.numBkgStdForMinThresh;
fractionOfHighIntensityForMaxThresh = inputParameters.fractionOfHighIntensityForMaxThresh;
filtMultiplierForVarThresh = inputParameters.filtMultiplierForVarThresh;
minVolForSmallVolRemoval = inputParameters.minVolForSmallVolRemovalInVoxels;
numCleanupCyclesInMicrons = inputParameters.numCleanupCyclesInMicrons;
minVolForCleanup = inputParameters.minVolForCleanupInVoxels;
gaussianRadiusForFilterInMicrons = inputParameters.gaussianRadiusForFilterInMicrons;
postCleanUpCloseDiameterInMicrons = inputParameters.postCleanUpCloseDiameterInMicrons;
maxDilationCyclesInMicrons = inputParameters.maxDilationCyclesInMicrons;
voxelSizeInMicrons = inputParameters.voxelSizeInMicrons;
smallGaussianSizeFactor = inputParameters.smallGaussianSizeFactor;
%-----
numCleanupCycles = round(numCleanupCyclesInMicrons ./ voxelSizeInMicrons);
gaussianRadiusForFilter = gaussianRadiusForFilterInMicrons ./ voxelSizeInMicrons;
maxDilationCycles = round(maxDilationCyclesInMicrons ./ voxelSizeInMicrons);
postCleanUpCloseDiameter = postCleanUpCloseDiameterInMicrons ./ voxelSizeInMicrons;

useRawMaskOnlyFlag = 0;
if isfield(inputParameters,'useRawMaskOnlyFlag'),
    useRawMaskOnlyFlag = inputParameters.useRawMaskOnlyFlag;
end%if isfield...

surfaceVesselConvexifyFlag = 0;
if isfield(inputParameters,'surfaceVesselConvexifyFlag'),
    surfaceVesselConvexifyFlag = inputParameters.surfaceVesselConvexifyFlag;
end%if isfield...

            surfaceNumCleanupCycles1 = 25;%noteToSelf
            surfaceNumCleanupCycles2 = 25;%Hardcode
            surfaceMinVolForCleanup1 = 4;
            surfaceMinVolForCleanup2 = 14;



%---
vascBlockEnhancedGrayscaleFileNameList=inputParameters.vascBlockEnhancedGrayscaleFileNameList;
vascBlockRawMaskFileNameList = inputParameters.vascBlockRawMaskFileNameList;
vascBlockFileNameList = inputParameters.vascBlockFileNameList;
%-----
numBlocks = length(vascBlockEnhancedGrayscaleFileNameList);
vascBlockEnhancedMaskPixelListFileNameList = cell(1,numBlocks);
vascBlockEnhancedMaskFileNameList = cell(1,numBlocks);
vascBlockEnhancedMaskBinarizeDetailsFileNameList = cell(1,numBlocks);
for i=1:numBlocks,
  [pathName,fileName,ext] = fileparts(vascBlockEnhancedGrayscaleFileNameList{i});
  vascBlockEnhancedMaskPixelListFileNameList{i} = fullfile(vascSegFilesFolder,[fileName,'-EnhancedMaskPixelList.mat']);
  vascBlockEnhancedMaskFileNameList{i} = fullfile(vascSegFilesFolder,[fileName,'-EnhancedMask.mat']);
  vascBlockEnhancedMaskBinarizeDetailsFileNameList{i} = fullfile(vascSegFilesFolder,[fileName,'-EnhancedBinDetails.mat']);
end
%-----
numBlocks = length(vascBlockEnhancedMaskFileNameList);
vethresh = cell(1,numBlocks);
enhancedFraction = cell(1,numBlocks);
%-----
for blockIter=1:numBlocks,
    disp(['Vasc Binarize Enhanced subvolume ',num2str(blockIter),' of ',num2str(length(vascBlockEnhancedGrayscaleFileNameList)),' : ',datestr(now,'mm/dd/yy HH:MM:SS')]);
     %-----
    currentMaskPixelListFileName = vascBlockEnhancedMaskPixelListFileNameList{blockIter};
    currentMaskFileName = vascBlockEnhancedMaskFileNameList{blockIter};
    %-----
    overwriteFlag = 0;
    fileExistsFlag = (exist(currentMaskFileName,'file')==2);
    if fileExistsFlag,
        fileProps = dir(currentMaskFileName);
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if if fileExistsFlag,
    %-----
    if and(fileExistsFlag==1,overwriteFlag==0),
        disp('...Skipping-Previously calculated');
        load(vascBlockEnhancedMaskBinarizeDetailsFileNameList{blockIter},'vethresh','enhancedFraction');
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        load(vascBlockRawMaskFileNameList{blockIter},'vascBlockRawMask','-mat');
        if isstruct(vascBlockRawMask),
            tempPixelList = vascBlockRawMask.pixelList;
            tempMaskSize = vascBlockRawMask.maskSize;
            vascBlockRawMask = false(tempMaskSize);
            vascBlockRawMask(tempPixelList) = 1;
            clear tempPixelList tempMaskSize
        end
        %-----
        if useRawMaskOnlyFlag == 1,
            disp('Substituting Raw Mask for Enhanced Mask');
            vascBlockEnhancedMask = vascBlockRawMask;
        else
            load(vascBlockEnhancedGrayscaleFileNameList{blockIter},'vascBlockEnhancedGrayscale','-mat');
            %-----
            %Generate a preliminary mask of the vessel regions from the raw Mask.
            vascBlockEnhancedMask = vascBlockRawMask;
            clear vascBlockRawMask
            %-----
            %Generate bkg regions by Dilating up the preliminary Mask to exclude all vessel regions        
            vesselRegionMask = vascBlockEnhancedMask;
            nonZeroPixelsCount = sum(vascBlockEnhancedGrayscale(:)>0);
            keepGoing = 1;
            circleDiameter3 = circle3d(3);
            cycleCounter = 0;
            while keepGoing==1,
                cycleCounter=cycleCounter+1;
                previousRoundMask = vesselRegionMask;
                vesselRegionMask = imfilter(previousRoundMask,double(circleDiameter3))>0;
                newFraction = sum(vesselRegionMask(:))./nonZeroPixelsCount;
                if newFraction>0.80, keepGoing = 0; end
                if cycleCounter >maxDilationCycles, keepGoing = 0; disp('==========DILATION LIMIT REACHED');end
            end
            vascBlockEnhancedMask = previousRoundMask;

            nonVesselRegions = vascBlockEnhancedGrayscale(~vascBlockEnhancedMask);
            %-----
            %Calculate a mode and standard deviation of the background regions
    %         modeVal = mode(round(nonVesselRegions(nonVesselRegions>0)));

            
            modeVal = mean(nonVesselRegions(nonVesselRegions>0));       
            stdCutBlock = std(nonVesselRegions(nonVesselRegions>0));

%noteToSelf - Added 08/24/10 - PST
%if the surface bkg is high, the std of the bkg is too high
%therefore, take the std of the lower half of the histogram
%and multiply it by 1.66;  for a symmetric (no long tail) histogram with normal
%distribution this gives equivalent value as just taking the stdev.  for high bkg tail,
%it better approximates the bkg in the bulk

highSurfaceBkgFlag = 1 %Hardcode
if highSurfaceBkgFlag == 1,
    temp1 = sort(nonVesselRegions(nonVesselRegions>0));
    temp1 = temp1(1:ceil(length(temp1)/2));
    stdCutBlock = 1.66*std(temp1);
end

            
lowNoiseFlag = 0 %Hardcode
% lowNoiseFlag = 1


if lowNoiseFlag==1,
    modeVal = 0;
end%if lowNoiseFlag==1,
            
            %-----
            %Set a minimum threshold that is several standard deviations above the background.
            %Set a maximum threshold as a fraction of the brightest rod-filtered pixel intensity.
            maxVal = max(vascBlockEnhancedGrayscale(:));
            minThresh = modeVal+numBkgStdForMinThresh*stdCutBlock;
            maxThresh = maxVal*fractionOfHighIntensityForMaxThresh;
            %------
            %Determine a variable threshold by performing local mean field subtraction.
            %   The local mean field is determined as the minimum of the mean value using a large
            %   and small gaussian filter. 
            [ySize,xSize,zSize] = size(vascBlockEnhancedMask);
            filtBlock = vascBlockEnhancedGrayscale.*0;
            gaussianBlockDiameter = 6*gaussianRadiusForFilter+1;
            gaussianBlockDiameter = min(min(size(vascBlockEnhancedGrayscale))-5,gaussianBlockDiameter);
            largeGaussian = gaussian3d(gaussianBlockDiameter,gaussianRadiusForFilter);
            largeGaussianSum = sum(largeGaussian(:));
            filtBlock1 = VidaConv3DFreq(vascBlockEnhancedGrayscale,largeGaussian)./largeGaussianSum;
            %-----
            smallGaussian = gaussian3d(gaussianBlockDiameter,gaussianRadiusForFilter/smallGaussianSizeFactor);
            smallGaussianSum = sum(smallGaussian(:));
            filtBlock2 = VidaConv3DFreq(vascBlockEnhancedGrayscale,smallGaussian)./smallGaussianSum;
            %-----
            %Set the threshold to a multiplier times the local mean field
            %   subject to the min and max threshold constraints
            threshBlock = min(filtBlock1,filtBlock2)*filtMultiplierForVarThresh;
            threshBlock = min(threshBlock,maxThresh);
            threshBlock = max(threshBlock,minThresh);
            vascBlockEnhancedMask = vascBlockEnhancedGrayscale>threshBlock;
            %-----
            vethresh{blockIter} = minThresh;
            enhFraction{blockIter} = sum(vascBlockEnhancedMask(:))./numel(vascBlockEnhancedMask);
            %----------
            %----------
            %Eliminate contiguous 6-connected regions of size  [minVolForSmallVolRemoval] or less
            L=bwlabeln(vascBlockEnhancedMask,6);
            stmp=regionprops(L,'Area');
            LUT=[0,[stmp.Area]>=minVolForSmallVolRemoval];
            L=LUT(L+1);
            vascBlockEnhancedMask = L>0;
            %-----
            %Run multiple iterations of a convexify-ing routine.
            %   Remove pixels "hairs" that have fewer than [minVol] of 26-connected neighbors.
            %   but also add any pixels that are more than [minVol] of 26-connected neighbors.
            %   
            for cleanIter = 1:numCleanupCycles,
                filtMask = imfilter(double(vascBlockEnhancedMask),ones(3,3,3),'replicate');
                vascBlockEnhancedMask = filtMask>=minVolForCleanup;
            end%for cleanIter = 1:numCleanupCycles,
            vascBlockEnhancedMask = imclose(vascBlockEnhancedMask,circle3d(postCleanUpCloseDiameter));
            %---
        end%if-else useRawMaskOnlyFlag == 0
        %-----
        if surfaceVesselConvexifyFlag == 1,
            %find block edge pixels
            %-----
            surfaceKernel1 = zeros(3,3,3);
            surfaceKernel1(1,1,1) = 1;surfaceKernel1(1,1,3) = 1;surfaceKernel1(1,3,1) = 1;surfaceKernel1(1,3,3) = 1;
            surfaceKernel1(3,1,1) = 1;surfaceKernel1(3,1,3) = 1;surfaceKernel1(3,3,1) = 1;surfaceKernel1(3,3,3) = 1;
            surfaceKernel2 = ones(3,3,3);
            origBlock = vascBlockEnhancedMask;
            disp('Enhancing Surface Vessels - stage 1');
            for cleanIter = 1:surfaceNumCleanupCycles1,
                filtMask = imfilter(uint8(vascBlockEnhancedMask),surfaceKernel1,'replicate');
                vascBlockEnhancedMask = or(vascBlockEnhancedMask,filtMask>=surfaceMinVolForCleanup1);
                %Re-blank edge pixels
                vascBlockEnhancedMask(1,:,:)=0;vascBlockEnhancedMask(:,1,:)=0;vascBlockEnhancedMask(:,:,1)=0;
                vascBlockEnhancedMask(end,:,:)=0;vascBlockEnhancedMask(:,end,:)=0;vascBlockEnhancedMask(:,:,end)=0;
            end%for cleanIter = 1:numCleanupCycles,
            disp('Enhancing Surface Vessels - stage 2');
            for cleanIter = 1:surfaceNumCleanupCycles2,
                filtMask = imfilter(uint8(vascBlockEnhancedMask),surfaceKernel2,'replicate');
                vascBlockEnhancedMask = filtMask>=surfaceMinVolForCleanup2;
                %Re-blank edge pixels
                vascBlockEnhancedMask(1,:,:)=0;vascBlockEnhancedMask(:,1,:)=0;vascBlockEnhancedMask(:,:,1)=0;
                vascBlockEnhancedMask(end,:,:)=0;vascBlockEnhancedMask(:,end,:)=0;vascBlockEnhancedMask(:,:,end)=0;
            end%for cleanIter = 1:numCleanupCycles,
            %-----
            vascBlockEnhancedMask = or(vascBlockEnhancedMask,origBlock);
        end%if surfaceVesselConvexifyFlag == 1,



        %---
        saveSize = (getfield(whos('vethresh'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vascBlockEnhancedMaskBinarizeDetailsFileNameList{blockIter},'vethresh','enhancedFraction',scs);
        pixelList = find(vascBlockEnhancedMask);
        maskSize = size(vascBlockEnhancedMask);
        vascBlockEnhancedMask = [];
        vascBlockEnhancedMask.pixelList = pixelList;
        vascBlockEnhancedMask.maskSize = maskSize;
        %-----
        saveSize = (getfield(whos('vascBlockEnhancedMask'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
        save(vascBlockEnhancedMaskFileNameList{blockIter},'vascBlockEnhancedMask',scs);
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for blockIter=1:length(vascBlockFileNameList)


outputParameters = inputParameters;
outputParameters.vascEnhancedThresh = vethresh;
outputParameters.enhancedFraction = enhancedFraction;
outputParameters.vascBlockEnhancedMaskFileNameList = vascBlockEnhancedMaskFileNameList;


