function outputParameters=VidaVascBlockEnhance2(inputParameters)

fileRootName = inputParameters.fileRootName;
lastRerunStartDateNum = inputParameters.lastRerunStartDateNum;
intermediateResultsFolder = inputParameters.intermediateResultsFolder;
vascSegFilesFolder = inputParameters.vascSegFilesFolder;
rodFilterHalfSizeInMicrons=inputParameters.rodFilterHalfSizeInMicrons; 
nptspu=inputParameters.numPointsRodFilter;
ntriangs=inputParameters.numTrianglesRodFilter; % 1 or 2 (max) should suffice
vascBlockFileNameList = inputParameters.vascBlockFileNameList;
blockGrid = inputParameters.blockGrid;
voxelSizeInMicrons = inputParameters.voxelSizeInMicrons;
%-----
filtsz = round(rodFilterHalfSizeInMicrons ./ voxelSizeInMicrons);
[orientfbnk3D]=VidaCreate3DLinSegFiltBank(filtsz,nptspu,ntriangs);


fbsum=zeros(size(orientfbnk3D{1}));
for i=1:length(orientfbnk3D)
  fbsum=fbsum+orientfbnk3D{i};
end
rsum=sum(sum(fbsum,3));
rsum=rsum/sum(rsum);
% filter indices with less than 1% of total isotropic filter energy are
% trimmed for speed in convolution
trimfilti=find(rsum>0.01);
for i=1:length(orientfbnk3D)
  orientfbnk3D{i}=orientfbnk3D{i}(trimfilti,trimfilti,trimfilti);
  orientfbnk3D{i}=orientfbnk3D{i}/sum(sum(sum(orientfbnk3D{i})));
  % orientfbnk3D{i}=orientfbnk3D{i}-mean(mean(mean(orientfbnk3D{i})));
end

    
% get the blkjth block from volume...
for blkj=1:length(vascBlockFileNameList)
    disp(['Rod filtering block ',num2str(blkj),' of ',num2str(length(vascBlockFileNameList)),': ',datestr(now,'mm/dd/yy HH:MM:SS')]);
    [pname,bname,ext]=fileparts(vascBlockFileNameList{blkj});
    vascenhancedfnames{blkj}=fullfile(vascSegFilesFolder,[bname,'-enhanced',ext]);
    %-----
    overwriteFlag = 0;
    fileExistsFlag = 0;
    if exist(vascenhancedfnames{blkj},'file'),
        fileExistsFlag = 1;
        fileProps = dir(vascenhancedfnames{blkj});
        fileDateNum = datenum(fileProps.date);
        if fileDateNum < lastRerunStartDateNum,
            overwriteFlag = 1;
        end%if fileDateNum < lastRerunStartDateNum,
    end%if exist(vascenhancedfnames{blkj},'file'),
    %---
    if and(fileExistsFlag==1,overwriteFlag==0),
        [tempPath,tempName] = fileparts(vascenhancedfnames{blkj});
        disp(['....skipping. ',tempName,' already exists.']);
    else%if and(fileExistsFlag==1,overwriteFlag==0),
        %-----
        % enhance block
        if rodFilterHalfSizeInMicrons == 0,
            %copy the grayscale block as the enhanced block
            loadedStruct = load(vascBlockFileNameList{blkj},'-mat');
            loadedVariables = fieldnames(loadedStruct);
            vascBlockEnhancedGrayscale = single(loadedStruct.(loadedVariables{1}));
            saveSize = (getfield(whos('vascBlockEnhancedGrayscale'),'bytes')>0.75e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            save(vascenhancedfnames{blkj},'vascBlockEnhancedGrayscale',scs);
        else%if rodFilterHalfSizeInMicrons == 0,
        %enhance block
            [vascBlockEnhancedGrayscale,Oi,minresp,Oli]=VidaRodFiltBank3D(vascBlockFileNameList{blkj},orientfbnk3D);
            saveSize = (getfield(whos('vascBlockEnhancedGrayscale'),'bytes')>0.75e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
            save(vascenhancedfnames{blkj},'vascBlockEnhancedGrayscale','Oi','minresp','Oli','blkj',scs);
        end%if-else rodFilterHalfSizeInMicrons == 0,
    end%if and(fileExistsFlag==1,overwriteFlag==0),
end%for blkj=1:length(vascBlockFileNameList)
%-----
outputParameters = inputParameters;
outputParameters.vascBlockEnhancedGrayscaleFileNameList = vascenhancedfnames;
%-----
return





