function outProject = VidaAddTRBridges(inProject)

vectorProject = inProject;
vectorProjectRootName = vectorProject.vectorProjectRootName;
vectorProjectFolder = vectorProject.vectorProjectFolder;
strandifyParameters = vectorProject.strandifyParameters;
vectorProjectFolder = vectorProject.vectorProjectFolder;
voxelSizeInMicrons = vectorProject.voxelSizeInMicrons;
%-----
minConfidence = vectorProject.thresholdRelaxationParameters.minConfidence;




%Label Structure
%100's Labels : Topology   : 100=Unlabeled, 200=Temporary, 300=Surface, 400=Plunging, 500=Connecting
%10's Labels  : Physiology :  10=Unlabeled,  20=Temporary,  30=Supply ,  40=Draining,  50=Microvessel
%1's Labels   : WhenAdded  :   1=Original ,   2=TR Added ,   3=Manual



%STAGE 9 : Add in TR BridgesRestrandify vascular data
fprintf('\nBegin secound round strandifying of vascular data\n\n');
%Generate new centerlineRadiusStructure from the vectorizedStructure and the new strands from threshold relaxation.
centerlineRadiusStructure = [];
vectorizedStructure = vectorProject.vectorizedStructure;
maskSize = vectorizedStructure.maskSize;
allVerts = vectorizedStructure.Vertices.AllVerts;
origPixelList = sub2ind(maskSize,double(allVerts(:,1)),double(allVerts(:,2)),double(allVerts(:,3)));
origRadiusList = vectorizedStructure.Vertices.AllRadii;
origLabelList = vectorizedStructure.Vertices.AllLabels;
origConfidenceList = vectorizedStructure.Vertices.AllConfidences;
% % origNoteList = vectorizedStructure.Vertices.AllNotes;
BridgingStrands = vectorProject.GapConnectionStruct.ThreshRelax.BridgingStrands;
BridgingConfidences = vectorProject.GapConnectionStruct.ThreshRelax.BridgingConfidences;
numBridgingStrands = size(BridgingStrands,2);
newPixelList = [];
newConfidenceList = [];
medianConfidenceFlag = 0;

%-----
if isfield(vectorProject.GapConnectionStruct.ThreshRelax,'MedianBridgingConfidences'),
    medianConfidenceFlag = 1;
    newMedianConfidenceList = [];
    MedianBridgingConfidences = vectorProject.GapConnectionStruct.ThreshRelax.MedianBridgingConfidences;
end
%-----
for strandIter = 1:numBridgingStrands,
    cs = BridgingStrands{strandIter};
    if ~isempty(cs),
        if BridgingConfidences(strandIter) >= minConfidence,
            currentPixelList = sub2ind(maskSize,double(cs(:,1)),double(cs(:,2)),double(cs(:,3)));
            currentConfidenceList = zeros(size(currentPixelList))+BridgingConfidences(strandIter);
            currentLabelList = zeros(size(currentPixelList))+162;%
            newPixelList = cat(1,newPixelList,currentPixelList);
            newConfidenceList = cat(1,newConfidenceList,currentConfidenceList);
            if medianConfidenceFlag == 1,
                currentMedianBridgingConfidenceList = zeros(size(currentPixelList))+MedianBridgingConfidences(strandIter);
                newMedianConfidenceList = cat(1,newMedianConfidenceList,currentMedianBridgingConfidenceList);
            end%if medianConfidenceFlag == 1,
            
        end%if BridgingConfidences(strandIter) >= minConfidence,
    end%if ~isempty(cs),
end


newRadiusList = zeros(size(newPixelList));
newLabelList = zeros(size(newPixelList))+162;%112 = unlabeled, added by TR
pixelList = cat(1,origPixelList,newPixelList);
radiusList = cat(1,origRadiusList,newRadiusList);
labelList = cat(1,origLabelList,newLabelList);
confidenceList = cat(1,origConfidenceList,newConfidenceList);
medianConfidenceList = cat(1,origConfidenceList,newMedianConfidenceList);
% % noteList = cell(size(radiusList));
% % noteList(1:numel(origNoteList)) = origNoteList;
centerlineRadiusStructure.pixelList = pixelList;
centerlineRadiusStructure.maskSize = maskSize;
centerlineRadiusStructure.radiusList = radiusList;
centerlineRadiusStructure.labelList = labelList;
centerlineRadiusStructure.confidenceList = confidenceList;
centerlineRadiusStructure.medianConfidenceList = medianConfidenceList;
% % centerlineRadiusStructure.noteList = noteList;
%-----
strandifyParameters.voxelSizeInMicrons = voxelSizeInMicrons;
registeredVascGrayscaleFileOnlyName = vectorProject.volumeFileNames.permutedVascGrayscale;
strandifyExp.registeredVascGrayscaleFileName = [vectorProjectFolder,filesep,'PermutedFilesFolder',filesep,registeredVascGrayscaleFileOnlyName];
strandifyExp.strandifyParameters = strandifyParameters;
strandifyExp.centerlineRadiusStructure = centerlineRadiusStructure;


    strandifyExp = RestrandifyAndTransferLabels2(strandifyExp);
vectorizedStructure = strandifyExp.vectorizedStructure;
%-----
vectorProject.vectorizedStructure = vectorizedStructure;

%-----
disp([' ';' ';' ']);
disp(['Completed Adding TR Bridges & Vectorizing : ',datestr(now)]);
disp([' ';' ';' ']);
%----


outProject = vectorProject;
