function outProject = VidaProcessSingleRegSubBlock(inProject)
vidaProject = inProject;
registeredExperiment = vidaProject.registeredExperiment;
setupParameters = vidaProject.setupParameters;
%-----
voxelSizeInMicrons = registeredExperiment.globalParameters.voxelSizeInMicrons;
regCenterlineFilesFolder = registeredExperiment.globalParameters.regCenterlineFilesFolder;
regVascRadiusFilesFolder = registeredExperiment.globalParameters.regVascRadiusFilesFolder;
regCenterlineBlockFilePrefix = registeredExperiment.globalParameters.regCenterlineBlockFilePrefix;
regVascRadiusBlockFilePrefix = registeredExperiment.globalParameters.regVascRadiusBlockFilePrefix;
lastRerunStartDateNum = registeredExperiment.globalParameters.lastRerunStartDateNum;
vascBlockFileNameList = {setupParameters.currentRegVascBlockFileName};
vascBlockRawMaskFileNameList = {setupParameters.currentRegVascBlockRawMaskFileName};
vascBlockEnhancedMaskFileNameList = {setupParameters.currentRegVascBlockEnhancedMaskFileName};
assignmentNumber = vidaProject.setupParameters.assignmentNumber;
%-----
fileRootName = registeredExperiment.globalParameters.fileRootName;
processedDataFolder = registeredExperiment.globalParameters.processedDataFolder;
intermediateResultsFolder = registeredExperiment.globalParameters.intermediateResultsFolder;
%-----
%-----
%Run Centerlining on single subBlock
regCenterlineParameters = registeredExperiment.centerlineEnhancedByConnectivityParameters;
regCenterlineParameters.centerlineFilesFolder = regCenterlineFilesFolder;
regCenterlineParameters.lastRerunStartDateNum = lastRerunStartDateNum;
regCenterlineParameters.centerlineFilesFolder = regCenterlineFilesFolder;
regCenterlineParameters.vascBlockFileNameList = vascBlockFileNameList;
regCenterlineParameters.vascBlockRawMaskFileNameList = vascBlockRawMaskFileNameList;
regCenterlineParameters.vascBlockEnhancedMaskFileNameList = vascBlockEnhancedMaskFileNameList;
regCenterlineParameters.voxelSizeInMicrons = voxelSizeInMicrons;
regCenterlineParameters.overrideFileNumber = assignmentNumber;
regCenterlineParameters.overrideOutputFilePrefix = regCenterlineBlockFilePrefix;
    regCenterlineParameters = VidaCenterlineEnhancedByConnectivity(regCenterlineParameters);
vascBlockCenterlineMaskFileNameList = regCenterlineParameters.vascBlockCenterlineMaskFileNameList;
%-----
%Convert vascBlockCenterlineMaskFileNameList to remote folder
[remotePath,junkName] = fileparts(regCenterlineBlockFilePrefix);
[origPath,fileName,myExt] = fileparts(vascBlockCenterlineMaskFileNameList{1});
vascBlockCenterlineMaskFileNameList{1} = fullfile(remotePath,[fileName,myExt]);
%-----
%Run VascRadii on a single subBlock
regVascRadiusParameters = registeredExperiment.vascRadiiParameters.fractionalIntensityReconstructionParameters;
regVascRadiusParameters.fileRootName = fileRootName;
regVascRadiusParameters.processedDataFolder = processedDataFolder;
regVascRadiusParameters.intermediateResultsFolder = intermediateResultsFolder;
regVascRadiusParameters.lastRerunStartDateNum = lastRerunStartDateNum;
regVascRadiusParameters.vascRadiusFilesFolder = regVascRadiusFilesFolder;
regVascRadiusParameters.vascBlockFileNameList = vascBlockFileNameList;
regVascRadiusParameters.vascBlockRawMaskFileNameList = vascBlockRawMaskFileNameList;
regVascRadiusParameters.vascBlockCenterlineMaskFileNameList = vascBlockCenterlineMaskFileNameList;
regVascRadiusParameters.voxelSizeInMicrons = voxelSizeInMicrons;
regVascRadiusParameters.overrideFileNumber = assignmentNumber;
regVascRadiusParameters.overrideOutputFilePrefix = regVascRadiusBlockFilePrefix;
    regVascRadiusParameters = VidaFractionalIntensityReconstruction(regVascRadiusParameters);
vascBlockRadiusMapFileNameList = regVascRadiusParameters.vascBlockRadiusMapFileNameList;
%-----
%-----
% vidaProject.registeredExperiment.vascBlockCenterlineMaskFileNameList = vascBlockCenterlineMaskFileNameList;
% vidaProject.vascBlockReconstructedMaskFileNameList = vascBlockReconstructedMaskFileNameList;
outProject = vidaProject;





%-----
                