function outProject = VidaRegisteredStrandifyParentSL(inProject)

vidaProject = inProject;
vidaProjectFileName = vidaProject.vidaProjectFileName;
vidaProjectRootName = vidaProject.vidaProjectRootName;
vidaProjectRootFolder = vidaProject.vidaProjectRootFolder;
globalParameters = vidaProject.globalParameters;
registeredExperiment = vidaProject.registeredExperiment;
registeredExperimentFileName = registeredExperiment.globalParameters.registeredExperimentFileName;
registrationParameters = vidaProject.registrationParameters;
strandifyParameters = vidaProject.strandifyParameters;
imageStackFolderNameList = vidaProject.imageStackFolderNameList;
registeredFilesFolder = globalParameters.registeredFilesFolder;
voxelSizeInMicrons = globalParameters.voxelSizeInMicrons;
%-----

%-----
%Create a subFolder for stitched volumes
stitchedFilesFolder = fullfile(registeredFilesFolder,'StitchedFilesFolder');
globalParameters.stitchedFilesFolder = stitchedFilesFolder;
vidaProject.globalParameters = globalParameters;
if ~exist(stitchedFilesFolder,'dir'),
    mkdir(stitchedFilesFolder);
end
    


registeredVascRadiusMapFileName = vidaProject.globalParameters.registeredVascRadiusMapFileName;
    


%Strandify vascular data
if vidaProject.multiThreadProgress.strandifyingFlag == 2,
    fprintf('\nFirst round strandifying previously completed\n\n');
else%if vidaProject.multiThreadProgress.strandifyingFlag == 2,
    fprintf('\nBegin first round strandifying of vascular data\n\n');
    load(registeredVascRadiusMapFileName,'vascRadiusMap');
    centerlineRadiusStructure = vascRadiusMap;
    %-----
    stageParameters.regStrandify.currentStageString = 'RegisteredVascStrandify';
    stageParameters.regStrandify.dataStructureVariableName = 'registeredExperiment';
    stageParameters.regStrandify.dataStructureFileName = registeredExperimentFileName;
    stageParameters.regStrandify.mainFunctionCallString = 'VidaStrandify';
    %----
    registeredExperiment.strandifyParameters = strandifyParameters;
    registeredExperiment.globalParameters.centerlineRadiusStructure = centerlineRadiusStructure;
        [registeredExperiment] = VidaRunSaveOrSkip3(registeredExperiment,stageParameters.regStrandify);
        load(stageParameters.regStrandify.dataStructureFileName,stageParameters.regStrandify.dataStructureVariableName);
    centerlineRadiusStructure = registeredExperiment.globalParameters.centerlineRadiusStructure;
    vectorizedStructure = registeredExperiment.strandifyParameters.vectorizedStructure;
    %-----
%     vidaProject.registeredExperiment = registeredExperiment;
    vidaProject.globalParameters.centerlineRadiusStructure = centerlineRadiusStructure;
    vidaProject.globalParameters.vectorizedStructure = vectorizedStructure;
    %---
    saveSize = (getfield(whos('registeredExperiment'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(registeredExperimentFileName,'registeredExperiment',scs);
    %---
    vectorizedStructureOutputFileName = fullfile(vidaProjectRootFolder,[vidaProjectRootName,'-PreThresholdVectorizedStructure.mat']);
    saveSize = (getfield(whos('vectorizedStructure'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vectorizedStructureOutputFileName,'vectorizedStructure',scs);
    %---
    vidaProject.multiThreadProgress.strandifyingFlag = 2;
    saveSize = (getfield(whos('vidaProject'),'bytes')>1.9e9);switch saveSize, case 0,scs='-v7';case 1,scs='-v7.3';end
    save(vidaProjectFileName,'vidaProject',scs);
    
end%if-else vidaProject.multiThreadProgress.strandifyingFlag == 2,
%-----
% if exist(registeredExperimentFileName),
%     delete(registeredExperimentFileName)
% end%if exist(registeredExperimentFileName),



outProject = vidaProject;
